/*************************************************************************
 *
 *  $RCSfile: sc_autostyl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:45:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include <time.h>
// auto strip #include "autostyl.hxx"

// auto strip #include "docsh.hxx"
// auto strip #include "attrib.hxx"
#include "bf_sc.hrc"
namespace binfilter {

//==================================================================

//STRIP001 struct ScAutoStyleInitData
//STRIP001 {
//STRIP001 	ScRange	aRange;
//STRIP001 	String	aStyle1;
//STRIP001 	ULONG	nTimeout;
//STRIP001 	String	aStyle2;
//STRIP001 
//STRIP001 	ScAutoStyleInitData( const ScRange& rR, const String& rSt1, ULONG nT, const String& rSt2 ) :
//STRIP001 		aRange(rR), aStyle1(rSt1), nTimeout(nT), aStyle2(rSt2) {}
//STRIP001 };

//STRIP001 struct ScAutoStyleData
//STRIP001 {
//STRIP001 	ULONG	nTimeout;
//STRIP001 	ScRange	aRange;
//STRIP001 	String	aStyle;
//STRIP001 
//STRIP001 	ScAutoStyleData( ULONG nT, const ScRange& rR, const String& rT ) :
//STRIP001 		nTimeout(nT), aRange(rR), aStyle(rT) {}
//STRIP001 };

//==================================================================

//STRIP001 inline ULONG TimeNow()			// Sekunden
//STRIP001 {
//STRIP001 	return (ULONG) time(0);
//STRIP001 }

//==================================================================

//STRIP001 ScAutoStyleList::ScAutoStyleList(ScDocShell* pShell) :
//STRIP001 	pDocSh( pShell )
//STRIP001 {
//STRIP001 	aTimer.SetTimeoutHdl( LINK( this, ScAutoStyleList, TimerHdl ) );
//STRIP001 	aInitTimer.SetTimeoutHdl( LINK( this, ScAutoStyleList, InitHdl ) );
//STRIP001 	aInitTimer.SetTimeout( 0 );
//STRIP001 }

//STRIP001 ScAutoStyleList::~ScAutoStyleList()
//STRIP001 {
//STRIP001 	ULONG i;
//STRIP001 	ULONG nCount = aEntries.Count();
//STRIP001 	for (i=0; i<nCount; i++)
//STRIP001 		delete (ScAutoStyleData*) aEntries.GetObject(i);
//STRIP001 	nCount = aInitials.Count();
//STRIP001 	for (i=0; i<nCount; i++)
//STRIP001 		delete (ScAutoStyleInitData*) aInitials.GetObject(i);
//STRIP001 }

//==================================================================

//	initial short delay (asynchronous call)

//STRIP001 void ScAutoStyleList::AddInitial( const ScRange& rRange, const String& rStyle1,
//STRIP001 									ULONG nTimeout, const String& rStyle2 )
//STRIP001 {
//STRIP001 	ScAutoStyleInitData* pNew =
//STRIP001 		new ScAutoStyleInitData( rRange, rStyle1, nTimeout, rStyle2 );
//STRIP001 	aInitials.Insert( pNew, aInitials.Count() );
//STRIP001 	aInitTimer.Start();
//STRIP001 }

//STRIP001 IMPL_LINK( ScAutoStyleList, InitHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	DBG_ASSERT( pTimer == &aInitTimer, "wrong timer" );
//STRIP001 
//STRIP001 	ULONG nCount = aInitials.Count();
//STRIP001 	for (ULONG i=0; i<nCount; i++)
//STRIP001 	{
//STRIP001 		ScAutoStyleInitData* pData = (ScAutoStyleInitData*) aInitials.GetObject(i);
//STRIP001 
//STRIP001 		//	apply first style immediately
//STRIP001 		pDocSh->DoAutoStyle( pData->aRange, pData->aStyle1 );
//STRIP001 
//STRIP001 		//	add second style to list
//STRIP001 		if ( pData->nTimeout )
//STRIP001 			AddEntry( pData->nTimeout, pData->aRange, pData->aStyle2 );
//STRIP001 
//STRIP001 		delete pData;
//STRIP001 	}
//STRIP001 	aInitials.Clear();
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

//==================================================================

//STRIP001 void ScAutoStyleList::AddEntry( ULONG nTimeout, const ScRange& rRange, const String& rStyle )
//STRIP001 {
//STRIP001 	aTimer.Stop();
//STRIP001 	ULONG nNow = TimeNow();
//STRIP001 
//STRIP001 	//	alten Eintrag loeschen
//STRIP001 
//STRIP001 	ULONG nCount = aEntries.Count();
//STRIP001 	ULONG i;
//STRIP001 	for (i=0; i<nCount; i++)
//STRIP001 	{
//STRIP001 		ScAutoStyleData* pData = (ScAutoStyleData*) aEntries.GetObject(i);
//STRIP001 		if (pData->aRange == rRange)
//STRIP001 		{
//STRIP001 			delete pData;
//STRIP001 			aEntries.Remove(i);
//STRIP001 			--nCount;
//STRIP001 			break;						// nicht weitersuchen - es kann nur einen geben
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	//	Timeouts von allen Eintraegen anpassen
//STRIP001 
//STRIP001 	if (nCount && nNow != nTimerStart)
//STRIP001 	{
//STRIP001 		DBG_ASSERT(nNow>nTimerStart, "Zeit laeuft rueckwaerts?");
//STRIP001 		AdjustEntries((nNow-nTimerStart)*1000);
//STRIP001 	}
//STRIP001 
//STRIP001 	//	Einfuege-Position suchen
//STRIP001 
//STRIP001 	ULONG nPos = LIST_APPEND;
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 	for (i=0; i<nCount && nPos == LIST_APPEND; i++)
//STRIP001 		if (nTimeout <= ((ScAutoStyleData*) aEntries.GetObject(i))->nTimeout)
//STRIP001 			nPos = i;
//STRIP001 
//STRIP001 	ScAutoStyleData* pNew = new ScAutoStyleData( nTimeout, rRange, rStyle );
//STRIP001 	aEntries.Insert( pNew, nPos );
//STRIP001 
//STRIP001 	//	abgelaufene ausfuehren, Timer neu starten
//STRIP001 
//STRIP001 	ExecuteEntries();
//STRIP001 	StartTimer(nNow);
//STRIP001 }

//STRIP001 void ScAutoStyleList::AdjustEntries( ULONG nDiff )	// Millisekunden
//STRIP001 {
//STRIP001 	ULONG nCount = aEntries.Count();
//STRIP001 	for (ULONG i=0; i<nCount; i++)
//STRIP001 	{
//STRIP001 		ScAutoStyleData* pData = (ScAutoStyleData*) aEntries.GetObject(i);
//STRIP001 		if ( pData->nTimeout <= nDiff )
//STRIP001 			pData->nTimeout = 0;					// abgelaufen
//STRIP001 		else
//STRIP001 			pData->nTimeout -= nDiff;				// weiterzaehlen
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScAutoStyleList::ExecuteEntries()
//STRIP001 {
//STRIP001 	ScAutoStyleData* pData;
//STRIP001 	while ((pData = (ScAutoStyleData*) aEntries.GetObject(0)) && pData->nTimeout == 0)
//STRIP001 	{
//STRIP001 		pDocSh->DoAutoStyle( pData->aRange, pData->aStyle );	//! oder Request ???
//STRIP001 
//STRIP001 		delete pData;
//STRIP001 		aEntries.Remove((ULONG)0);
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScAutoStyleList::ExecuteAllNow()
//STRIP001 {
//STRIP001 	aTimer.Stop();
//STRIP001 
//STRIP001 	ULONG nCount = aEntries.Count();
//STRIP001 	for (ULONG i=0; i<nCount; i++)
//STRIP001 	{
//STRIP001 		ScAutoStyleData* pData = (ScAutoStyleData*) aEntries.GetObject(i);
//STRIP001 
//STRIP001 		pDocSh->DoAutoStyle( pData->aRange, pData->aStyle );	//! oder Request ???
//STRIP001 
//STRIP001 		delete pData;
//STRIP001 	}
//STRIP001 	aEntries.Clear();
//STRIP001 }

//STRIP001 void ScAutoStyleList::StartTimer( ULONG nNow )		// Sekunden
//STRIP001 {
//STRIP001 	// ersten Eintrag mit Timeout != 0 suchen
//STRIP001 
//STRIP001 	ULONG nPos = 0;
//STRIP001 	ScAutoStyleData* pData;
//STRIP001 	while ( (pData = (ScAutoStyleData*) aEntries.GetObject(nPos)) && pData->nTimeout == 0 )
//STRIP001 		++nPos;
//STRIP001 
//STRIP001 	if (pData)
//STRIP001 	{
//STRIP001 		aTimer.SetTimeout( pData->nTimeout );
//STRIP001 		aTimer.Start();
//STRIP001 	}
//STRIP001 	nTimerStart = nNow;
//STRIP001 }

//STRIP001 IMPL_LINK( ScAutoStyleList, TimerHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	DBG_ASSERT( pTimer == &aTimer, "falscher Timer" );
//STRIP001 
//STRIP001 	ULONG nNow = TimeNow();
//STRIP001 	AdjustEntries(aTimer.GetTimeout());				// eingestellte Wartezeit
//STRIP001 	ExecuteEntries();
//STRIP001 	StartTimer(nNow);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }




}
