/*************************************************************************
 *
 *  $RCSfile: sc_fuconstr.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:52:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------------

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX


//SV
//#define _CLIP_HXX
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX
//#define _TOOLBOX_HXX
//#define _STATUS_HXX
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX

//svtools
#define _SCRWIN_HXX
#define _RULER_HXX
//#define _TABBAR_HXX
//#define _VALUESET_HXX
#define _STDMENU_HXX
//#define _STDCTRL_HXX
//#define _CTRLBOX_HXX
#define _CTRLTOOL_HXX
#define _EXTATTR_HXX
#define _FRM3D_HXX
#define _EXTATTR_HXX

//SVTOOLS
//#define _SVTREELIST_HXX ***
#define _FILTER_HXX
//#define _SVLBOXITM_HXX ***
//#define _SVTREEBOX_HXX ***
#define _SVICNVW_HXX
#define _SVTABBX_HXX

//sfxcore.hxx
//#define _SFXINIMGR_HXX ***
//#define _SFXCFGITEM_HXX
//#define _SFX_PRINTER_HXX
#define _SFXGENLINK_HXX
#define _SFXHINTPOST_HXX
//#define _SFXDOCINF_HXX ***
#define _SFXLINKHDL_HXX
//#define _SFX_PROGRESS_HXX

//sfxsh.hxx
//#define _SFX_SHELL_HXX
//#define _SFXAPP_HXX
//#define _SFXDISPATCH_HXX
//#define _SFXMSG_HXX ***
//#define _SFXOBJFACE_HXX ***
//#define _SFXREQUEST_HXX
#define _SFXMACRO_HXX

// SFX
//#define _SFXAPPWIN_HXX ***
#define _SFX_SAVEOPT_HXX
//#define _SFX_CHILDWIN_HXX
//#define _SFXCTRLITEM_HXX
#define _SFXPRNMON_HXX
#define _INTRO_HXX
#define _SFXMSGDESCR_HXX
#define _SFXMSGPOOL_HXX
#define _SFXFILEDLG_HXX
#define _PASSWD_HXX
#define _SFXTBXCTRL_HXX
#define _SFXSTBITEM_HXX
#define _SFXMNUITEM_HXX
#define _SFXIMGMGR_HXX
#define _SFXTBXMGR_HXX
#define _SFXSTBMGR_HXX
#define _SFX_MINFITEM_HXX
#define _SFXEVENT_HXX

//------------------------------------------------------------------------

// auto strip #include <bf_svx/outliner.hxx>
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #include <bf_svx/svdouno.hxx>
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>

// auto strip #include "fuconstr.hxx"
// auto strip #include "fudraw.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "futext.hxx"
#include "bf_sc.hrc"
namespace binfilter {

//	Maximal erlaubte Mausbewegung um noch Drag&Drop zu starten
//!	fusel,fuconstr,futext - zusammenfassen!
#define SC_MAXDRAGMOVE	3

//------------------------------------------------------------------------

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 FuConstruct::FuConstruct(ScTabViewShell* pViewSh, Window* pWin, SdrView* pView,
//STRIP001 				   SdrModel* pDoc, SfxRequest& rReq) :
//STRIP001 	FuDraw(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 FuConstruct::~FuConstruct()
//STRIP001 {
//STRIP001 }

//STRIP001 BYTE FuConstruct::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	//	special code for non-VCL OS2/UNX removed
//STRIP001 
//STRIP001 	return FuDraw::Command( rCEvt );
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstruct::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	BOOL bReturn = FuDraw::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	if ( pView->IsAction() )
//STRIP001 	{
//STRIP001 		if ( rMEvt.IsRight() )
//STRIP001 			pView->BckAction();
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	aDragTimer.Start();
//STRIP001 
//STRIP001 	aMDPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
//STRIP001 
//STRIP001 	if ( rMEvt.IsLeft() )
//STRIP001 	{
//STRIP001 		pWindow->CaptureMouse();
//STRIP001 
//STRIP001 		SdrHdl* pHdl = pView->HitHandle(aMDPos, *pWindow);
//STRIP001 
//STRIP001 		if ( pHdl != NULL || pView->IsMarkedHit(aMDPos) )
//STRIP001 		{
//STRIP001 			pView->BegDragObj(aMDPos, (OutputDevice*) NULL, pHdl, 1);
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 		else if ( pView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			pView->UnmarkAll();
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	bIsInDragMode = FALSE;
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstruct::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	FuDraw::MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001 		Point aOldPixel = pWindow->LogicToPixel( aMDPos );
//STRIP001 		Point aNewPixel = rMEvt.GetPosPixel();
//STRIP001 		if ( Abs( aOldPixel.X() - aNewPixel.X() ) > SC_MAXDRAGMOVE ||
//STRIP001 			 Abs( aOldPixel.Y() - aNewPixel.Y() ) > SC_MAXDRAGMOVE )
//STRIP001 			aDragTimer.Stop();
//STRIP001 	}
//STRIP001 
//STRIP001 	Point aPix(rMEvt.GetPosPixel());
//STRIP001 	Point aPnt( pWindow->PixelToLogic(aPix) );
//STRIP001 
//STRIP001 	if ( pView->IsAction() )
//STRIP001 	{
//STRIP001 		ForceScroll(aPix);
//STRIP001 		pView->MovAction(aPnt);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SdrHdl* pHdl=pView->HitHandle(aPnt, *pWindow);
//STRIP001 
//STRIP001 		if ( pHdl != NULL )
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer(pHdl->GetPointer());
//STRIP001 		}
//STRIP001 		else if ( pView->IsMarkedHit(aPnt) )
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer(Pointer(POINTER_MOVE));
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer( aNewPointer );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstruct::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	BOOL bReturn = SimpleMouseButtonUp( rMEvt );
//STRIP001 
//STRIP001 	//		Doppelklick auf Textobjekt? (->fusel)
//STRIP001 
//STRIP001 	USHORT nClicks = rMEvt.GetClicks();
//STRIP001 	if ( nClicks == 2 && rMEvt.IsLeft() )
//STRIP001 	{
//STRIP001 		if ( pView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 			if (rMarkList.GetMarkCount() == 1)
//STRIP001 			{
//STRIP001 				SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 				SdrObject* pObj = pMark->GetObj();
//STRIP001 
//STRIP001 				//	#49458# bei Uno-Controls nicht in Textmodus
//STRIP001 				if ( pObj->ISA(SdrTextObj) && !pObj->ISA(SdrUnoObj) )
//STRIP001 				{
//STRIP001 					OutlinerParaObject* pOPO = pObj->GetOutlinerParaObject();
//STRIP001 					BOOL bVertical = ( pOPO && pOPO->IsVertical() );
//STRIP001 					USHORT nTextSlotId = bVertical ? SID_DRAW_TEXT_VERTICAL : SID_DRAW_TEXT;
//STRIP001 
//STRIP001 					pViewShell->GetViewData()->GetDispatcher().
//STRIP001 						Execute(nTextSlotId, SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 
//STRIP001 					// jetzt den erzeugten FuText holen und in den EditModus setzen
//STRIP001 					FuPoor* pPoor = pViewShell->GetViewData()->GetView()->GetDrawFuncPtr();
//STRIP001 					if ( pPoor && pPoor->GetSlotID() == nTextSlotId )	 //	hat keine RTTI
//STRIP001 					{
//STRIP001 						FuText* pText = (FuText*)pPoor;
//STRIP001 						Point aMousePixel = rMEvt.GetPosPixel();
//STRIP001 						pText->SetInEditMode( pObj, &aMousePixel );
//STRIP001 					}
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	FuDraw::MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

//		SimpleMouseButtonUp - ohne Test auf Doppelklick

//STRIP001 BOOL FuConstruct::SimpleMouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL	bReturn = TRUE;
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001 		aDragTimer.Stop();
//STRIP001 	}
//STRIP001 
//STRIP001 	Point	aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 	if ( pView->IsDragObj() )
//STRIP001 		 pView->EndDragObj( rMEvt.IsMod1() );
//STRIP001 
//STRIP001 	else if ( pView->IsMarkObj() )
//STRIP001 		pView->EndMarkObj();
//STRIP001 
//STRIP001 	else bReturn = FALSE;
//STRIP001 
//STRIP001 	if ( !pView->IsAction() )
//STRIP001 	{
//STRIP001 		pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 		if ( !pView->HasMarkedObj() && rMEvt.GetClicks() < 2 )
//STRIP001 		{
//STRIP001 			pView->MarkObj(aPnt, -2, FALSE, rMEvt.IsMod1());
//STRIP001 
//STRIP001 			SfxDispatcher& rDisp = pViewShell->GetViewData()->GetDispatcher();
//STRIP001 			if ( pView->HasMarkedObj() )
//STRIP001 				rDisp.Execute(SID_OBJECT_SELECT, SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 			else
//STRIP001 				rDisp.Execute(aSfxRequest.GetSlot(), SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstruct::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	switch ( rKEvt.GetKeyCode().GetCode() )
//STRIP001 	{
//STRIP001 		case KEY_ESCAPE:
//STRIP001 			if ( pView->IsAction() )
//STRIP001 			{
//STRIP001 				pView->BrkAction();
//STRIP001 				pWindow->ReleaseMouse();
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 			else							// Zeichenmodus beenden
//STRIP001 			{
//STRIP001 				pViewShell->GetViewData()->GetDispatcher().
//STRIP001 					Execute(aSfxRequest.GetSlot(), SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case KEY_DELETE:
//STRIP001 			pView->DeleteMarked();
//STRIP001 			bReturn = TRUE;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !bReturn )
//STRIP001 	{
//STRIP001 		bReturn = FuDraw::KeyInput(rKEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }

/*************************************************************************
|*
|* Function aktivieren
|*
\************************************************************************/

//STRIP001 void FuConstruct::Activate()
//STRIP001 {
//STRIP001 	FuDraw::Activate();
//STRIP001 }

/*************************************************************************
|*
|* Function deaktivieren
|*
\************************************************************************/

//STRIP001 void FuConstruct::Deactivate()
//STRIP001 {
//STRIP001 	FuDraw::Deactivate();
//STRIP001 }




}
