/*************************************************************************
 *
 *  $RCSfile: sc_fumark.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:53:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include <bf_svx/svdview.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>

// auto strip #include "fumark.hxx"
#include "bf_sc.hrc"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "scmod.hxx"
// auto strip #include "reffact.hxx"
// auto strip #include "document.hxx"
// auto strip #include "scresid.hxx"
namespace binfilter {

//------------------------------------------------------------------

/*************************************************************************
|*
|* Funktion zum Aufziehen eines Rechtecks
|*
\************************************************************************/

//STRIP001 FuMarkRect::FuMarkRect(ScTabViewShell* pViewSh, Window* pWin, SdrView* pView,
//STRIP001 			   SdrModel* pDoc, SfxRequest& rReq) :
//STRIP001 	FuPoor(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	bVisible(FALSE),
//STRIP001 	bStartDrag(FALSE)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 FuMarkRect::~FuMarkRect()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

//STRIP001 BOOL FuMarkRect::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	pWindow->CaptureMouse();
//STRIP001 	pView->UnmarkAll();			// der Einheitlichkeit halber und wegen #50558#
//STRIP001 	bStartDrag = TRUE;
//STRIP001 
//STRIP001 	aBeginPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
//STRIP001 	aZoomRect = Rectangle( aBeginPos, Size() );
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

//STRIP001 BOOL FuMarkRect::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	if ( bStartDrag )
//STRIP001 	{
//STRIP001 		if ( bVisible )
//STRIP001 			pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		Point aPixPos= rMEvt.GetPosPixel();
//STRIP001 		ForceScroll(aPixPos);
//STRIP001 
//STRIP001 		Point aEndPos = pWindow->PixelToLogic(aPixPos);
//STRIP001 		Rectangle aRect(aBeginPos, aEndPos);
//STRIP001 		aZoomRect = aRect;
//STRIP001 		aZoomRect.Justify();
//STRIP001 		pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		bVisible = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 
//STRIP001 	return bStartDrag;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

//STRIP001 BOOL FuMarkRect::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	if ( bVisible )
//STRIP001 	{
//STRIP001 		// Hide ZoomRect
//STRIP001 		pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		bVisible = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	Size aZoomSizePixel = pWindow->LogicToPixel(aZoomRect).GetSize();
//STRIP001 
//STRIP001 	USHORT nMinMove = pView->GetMinMoveDistancePixel();
//STRIP001 	if ( aZoomSizePixel.Width() < nMinMove || aZoomSizePixel.Height() < nMinMove )
//STRIP001 	{
//STRIP001 		// Klick auf der Stelle
//STRIP001 
//STRIP001 		aZoomRect.SetSize(Size());		// dann ganz leer
//STRIP001 	}
//STRIP001 
//STRIP001 	bStartDrag = FALSE;
//STRIP001 	pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 	pViewShell->GetViewData()->GetDispatcher().
//STRIP001 		Execute(aSfxRequest.GetSlot(), SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 
//STRIP001 		//	Daten an der View merken
//STRIP001 
//STRIP001 	pViewShell->SetChartArea( aSourceRange, aZoomRect );
//STRIP001 
//STRIP001 		//	Chart-Dialog starten:
//STRIP001 
//STRIP001 	USHORT nId  = ScChartDlgWrapper::GetChildWindowId();
//STRIP001 	SfxChildWindow* pWnd = pViewShell->GetViewFrame()->GetChildWindow( nId );
//STRIP001 	SC_MOD()->SetRefDialog( nId, pWnd ? FALSE : TRUE );
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
|*
|* Command-event
|*
\************************************************************************/

//STRIP001 BYTE FuMarkRect::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	if ( COMMAND_STARTDRAG == rCEvt.GetCommand() )
//STRIP001 	{
//STRIP001 		//	#29877# nicht anfangen, auf der Tabelle rumzudraggen,
//STRIP001 		//	aber Maus-Status nicht zuruecksetzen
//STRIP001 		return SC_CMD_IGNORE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return FuPoor::Command(rCEvt);
//STRIP001 }

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

//STRIP001 BOOL FuMarkRect::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	switch ( rKEvt.GetKeyCode().GetCode() )
//STRIP001 	{
//STRIP001 		case KEY_ESCAPE:
//STRIP001 			//	beenden
//STRIP001 			pViewShell->GetViewData()->GetDispatcher().
//STRIP001 				Execute(aSfxRequest.GetSlot(), SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 			bReturn = TRUE;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		bReturn = FuPoor::KeyInput(rKEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }

/*************************************************************************
|*
|* Vor dem Scrollen Selektionsdarstellung ausblenden
|*
\************************************************************************/

//STRIP001 void FuMarkRect::ScrollStart()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Nach dem Scrollen Selektionsdarstellung wieder anzeigen
|*
\************************************************************************/

//STRIP001 void FuMarkRect::ScrollEnd()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Function aktivieren
|*
\************************************************************************/

//STRIP001 void FuMarkRect::Activate()
//STRIP001 {
//STRIP001 	FuPoor::Activate();
//STRIP001 
//STRIP001 		//	Markierung merken, bevor evtl. Tabelle umgeschaltet wird
//STRIP001 
//STRIP001 	ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001 	ScMarkData& rMark = pViewData->GetMarkData();
//STRIP001 
//STRIP001 	if ( !rMark.IsMultiMarked() && !rMark.IsMarked() )
//STRIP001 		pViewShell->MarkDataArea( TRUE );
//STRIP001 
//STRIP001 	pViewData->GetMultiArea( aSourceRange );		// Mehrfachselektion erlaubt
//STRIP001 
//STRIP001 //	pViewShell->Unmark();
//STRIP001 
//STRIP001 	ForcePointer(NULL);
//STRIP001 }

/*************************************************************************
|*
|* Function deaktivieren
|*
\************************************************************************/

//STRIP001 void FuMarkRect::Deactivate()
//STRIP001 {
//STRIP001 	FuPoor::Deactivate();
//STRIP001 
//STRIP001 	if (bVisible)
//STRIP001 	{
//STRIP001 		// Hide ZoomRect
//STRIP001 		pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		bVisible = FALSE;
//STRIP001 		bStartDrag = FALSE;
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Maus-Pointer umschalten
|*
\************************************************************************/

//STRIP001 void FuMarkRect::ForcePointer(const MouseEvent* pMEvt)
//STRIP001 {
//STRIP001 	pViewShell->SetActivePointer( Pointer( POINTER_CHART ) );
//STRIP001 }




}
