/*************************************************************************
 *
 *  $RCSfile: areasave.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:29:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_AREASAVE_HXX
#define SC_AREASAVE_HXX

#ifndef SC_COLLECT_HXX
#include "collect.hxx"
#endif

#ifndef SC_SCGLOB_HXX
#include "global.hxx"
#endif
namespace binfilter {

//STRIP001 class ScDocument;
//STRIP001 class ScAreaLink;


//STRIP001 class ScAreaLinkSaver : public DataObject
//STRIP001 {
//STRIP001 private:
//STRIP001 	String		aFileName;
//STRIP001 	String		aFilterName;
//STRIP001 	String		aOptions;
//STRIP001 	String		aSourceArea;
//STRIP001 	ScRange		aDestArea;
//STRIP001 
//STRIP001 public:
//STRIP001 				ScAreaLinkSaver( const ScAreaLink& rSource );
//STRIP001 				ScAreaLinkSaver( const ScAreaLinkSaver& rCopy );
//STRIP001 	virtual		~ScAreaLinkSaver();
//STRIP001 
//STRIP001 	virtual	DataObject*	Clone() const;
//STRIP001 
//STRIP001 	BOOL		IsEqual( const ScAreaLink& rCompare ) const;
//STRIP001 	BOOL		IsEqualSource( const ScAreaLink& rCompare ) const;
//STRIP001 
//STRIP001 	void		WriteToLink( ScAreaLink& rLink ) const;
//STRIP001 };


//STRIP001 class ScAreaLinkSaveCollection : public Collection
//STRIP001 {
//STRIP001 public:
//STRIP001 				ScAreaLinkSaveCollection();
//STRIP001 				ScAreaLinkSaveCollection( const ScAreaLinkSaveCollection& rCopy );
//STRIP001 	virtual		~ScAreaLinkSaveCollection();
//STRIP001 
//STRIP001 	virtual	DataObject*	Clone() const;
//STRIP001 
//STRIP001 	ScAreaLinkSaver*	operator[](USHORT nIndex) const {return (ScAreaLinkSaver*)At(nIndex);}
//STRIP001 
//STRIP001 	BOOL		IsEqual( const ScDocument* pDoc ) const;
//STRIP001 	void		Restore( ScDocument* pDoc ) const;
//STRIP001 
//STRIP001 	// returns NULL if empty
//STRIP001 	static ScAreaLinkSaveCollection* CreateFromDoc( const ScDocument* pDoc );
//STRIP001 };


} //namespace binfilter
#endif

