/*************************************************************************
 *
 *  $RCSfile: preview.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:03:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_PREVIEW_HXX
#define SC_PREVIEW_HXX


#ifndef _WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif
// auto strip #include "printfun.hxx"		// ScPrintState
namespace binfilter {

//STRIP001 class ScDocShell;
//STRIP001 class ScPreviewShell;
//STRIP001 class FmFormView;
//STRIP001 
//STRIP001 class ScPreview : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 										// eingestellt:
//STRIP001 	long			nPageNo;			// Seite im Dokument
//STRIP001 	USHORT			nZoom;				// eingestellter Zoom
//STRIP001 	Point			aOffset;			// positiv
//STRIP001 
//STRIP001 										// berechnet:
//STRIP001 	BOOL			bValid;				// folgende Werte gueltig
//STRIP001 	USHORT			nTabCount;
//STRIP001 	USHORT			nTabsTested;		// fuer wieviele Tabellen ist nPages gueltig?
//STRIP001 	long			nPages[MAXTAB+1];
//STRIP001 	long			nFirstAttr[MAXTAB+1];
//STRIP001 	USHORT			nTab;				// Tabelle
//STRIP001 	long			nTabPage;			// Seite von Tabelle
//STRIP001 	long			nTabStart;			// erste Seite der Tabelle (wirklich)
//STRIP001 	long			nDisplayStart;		// dito, relativ zum Anfang der Zaehlung
//STRIP001 	Date			aDate;
//STRIP001 	Time			aTime;
//STRIP001 	long			nTotalPages;
//STRIP001 	Size			aPageSize;			// fuer GetOptimalZoom
//STRIP001 	BOOL			bStateValid;
//STRIP001 	BOOL			bLocationValid;
//STRIP001 	ScPrintState	aState;
//STRIP001 	ScPreviewLocationData* pLocationData;	// stores table layout for accessibility API
//STRIP001 	FmFormView*		pDrawView;
//STRIP001 
//STRIP001 										// intern:
//STRIP001 	BOOL			bInPaint;
//STRIP001 	BOOL			bInGetState;
//STRIP001 	ScDocShell*		pDocShell;
//STRIP001 	ScPreviewShell*	pViewShell;
//STRIP001 
//STRIP001 
//STRIP001 	void	TestLastPage();
//STRIP001 	void	CalcPages( USHORT nToWhichTab );
//STRIP001 	void	RecalcPages();
//STRIP001 	void	UpdateDrawView();
//STRIP001 	void	DoPrint( ScPreviewLocationData* pFillLocation );
//STRIP001 
//STRIP001 	void	InvalidateLocationData( ULONG nId );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Paint( const Rectangle& rRect );
//STRIP001 	virtual void	Command( const CommandEvent& rCEvt );
//STRIP001 	virtual void	KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001     virtual void    GetFocus();
//STRIP001     virtual void    LoseFocus();
//STRIP001 
//STRIP001 	virtual ::com::sun::star::uno::Reference< ::com::sun::star::accessibility::XAccessible > CreateAccessible();
//STRIP001 
//STRIP001 public:
//STRIP001 			ScPreview( Window* pParent, ScDocShell* pDocSh, ScPreviewShell* pViewSh );
//STRIP001 			~ScPreview();
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 	void	DataChanged(BOOL bNewTime = FALSE);				// statt Invalidate rufen
//STRIP001 	void	DoInvalidate();
//STRIP001 
//STRIP001 	void	SetXOffset( long nX );
//STRIP001 	void	SetYOffset( long nY );
//STRIP001 	void	SetZoom(USHORT nNewZoom);
//STRIP001 	void	SetPageNo( long nPage );
//STRIP001 
//STRIP001 	const ScPreviewLocationData& GetLocationData();
//STRIP001 
//STRIP001 	String	GetPosString();
//STRIP001 
//STRIP001 	long	GetPageNo() const	{ return nPageNo; }
//STRIP001 	USHORT	GetZoom() const		{ return nZoom; }
//STRIP001 	Point	GetOffset() const	{ return aOffset; }
//STRIP001 
//STRIP001 	USHORT	GetTab()			{ if (!bValid) { CalcPages(0); RecalcPages(); } return nTab; }
//STRIP001 	long	GetTotalPages()		{ if (!bValid) { CalcPages(0); RecalcPages(); } return nTotalPages; }
//STRIP001 
//STRIP001 	BOOL	AllTested() const	{ return bValid && nTabsTested >= nTabCount; }
//STRIP001 
//STRIP001 	USHORT	GetOptimalZoom(BOOL bWidthOnly);
//STRIP001 	long	GetFirstPage(USHORT nTab);
//STRIP001 
//STRIP001 	void	CalcAll()			{ CalcPages(MAXTAB); }
//STRIP001 	void	SetInGetState(BOOL bSet) { bInGetState = bSet; }
//STRIP001 
//STRIP001 	DECL_STATIC_LINK( ScPreview, InvalidateHdl, void* );
//STRIP001 	static void StaticInvalidate();
//STRIP001 
//STRIP001     FmFormView* GetDrawView() { return pDrawView; }
//STRIP001 };



} //namespace binfilter
#endif
