/*************************************************************************
 *
 *  $RCSfile: prevwsh.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:39:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_PREVWSH_HXX
#define SC_PREVWSH_HXX

class ScrollBar;

#ifndef _VIEWFAC_HXX //autogen
#include <bf_sfx2/viewfac.hxx>
#endif
#ifndef _SFXVIEWSH_HXX //autogen
#include <bf_sfx2/viewsh.hxx>
#endif
#ifndef _SVX_ZOOMITEM_HXX //autogen
#include <bf_svx/zoomitem.hxx>
#endif

#include "shellids.hxx"
namespace binfilter {

class ScDocument;
class ScDocShell;
class ScPreview;
struct ScHeaderFieldData;
class ScPreviewLocationData;
class CommandEvent;

//==================================================================


class ScPreviewShell: public SfxViewShell
{
//STRIP001 	ScDocShell*		pDocShell;
//STRIP001 
//STRIP001 	ScPreview*		pPreview;				// Ausgabe-Fenster
//STRIP001 	ScrollBar*		pHorScroll;
//STRIP001 	ScrollBar*		pVerScroll;
//STRIP001 	Window*			pCorner;
//STRIP001 
//STRIP001 	String			aSourceData;			// ViewData
//STRIP001 	BYTE			nSourceDesignMode;		// form design mode from TabView
//STRIP001 	SvxZoomType		eZoom;
//STRIP001 
//STRIP001 	SfxBroadcaster*	pAccessibilityBroadcaster;
//STRIP001 
//STRIP001 private:
//STRIP001 	void			Construct( Window* pParent );
//STRIP001 	DECL_LINK(ScrollHandler, ScrollBar* );
//STRIP001 	void			DoScroll( USHORT nMode );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Activate(BOOL bMDI);
//STRIP001 	virtual void	Deactivate(BOOL bMDI);
//STRIP001 
//STRIP001 	virtual void	AdjustPosSizePixel( const Point &rPos, const Size &rSize );
//STRIP001 
//STRIP001 	virtual void	InnerResizePixel( const Point &rOfs, const Size &rSize );
//STRIP001 	virtual void	OuterResizePixel( const Point &rOfs, const Size &rSize );
//STRIP001 
//STRIP001 	virtual Size	GetOptimalSizePixel() const;
//STRIP001 
//STRIP001 	virtual String  GetDescription() const;
//STRIP001 
//STRIP001 	virtual void	WriteUserData(String &, BOOL bBrowse = FALSE);
//STRIP001 	virtual void	ReadUserData(const String &, BOOL bBrowse = FALSE);
//STRIP001 
//STRIP001     virtual void    WriteUserDataSequence (::com::sun::star::uno::Sequence < ::com::sun::star::beans::PropertyValue >&, sal_Bool bBrowse = sal_False );
//STRIP001     virtual void    ReadUserDataSequence (const ::com::sun::star::uno::Sequence < ::com::sun::star::beans::PropertyValue >&, sal_Bool bBrowse = sal_False );

public:
//STRIP001 					TYPEINFO();

					SFX_DECL_INTERFACE(SCID_PREVIEW_SHELL);
					SFX_DECL_VIEWFACTORY(ScPreviewShell);

//STRIP001 					ScPreviewShell( SfxViewFrame*			pViewFrame,
//STRIP001 									const ScPreviewShell&	rWin );
//STRIP001 					ScPreviewShell( SfxViewFrame*			pViewFrame,
//STRIP001 									Window*					pParent);
					ScPreviewShell( SfxViewFrame*			pViewFrame,
									SfxViewShell*			pOldSh ):SfxViewShell( pViewFrame, SFX_VIEW_MAXIMIZE_FIRST | SFX_VIEW_CAN_PRINT | SFX_VIEW_HAS_PRINTOPTIONS ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 SfxViewShell*			pOldSh );

//STRIP001 	virtual			~ScPreviewShell();
//STRIP001 
//STRIP001 	void			InitStartTable(USHORT nTab);
//STRIP001 
//STRIP001 	void			UpdateScrollBars();
//STRIP001 	BOOL			ScrollCommand( const CommandEvent& rCEvt );

	void			Execute( SfxRequest& rReq ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 void			Execute( SfxRequest& rReq );
	void			GetState( SfxItemSet& rSet ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 void			GetState( SfxItemSet& rSet );

//STRIP001 	void			FillFieldData( ScHeaderFieldData& rData );
//STRIP001 
//STRIP001 	const String& 	GetSourceData() const	{ return aSourceData; }
//STRIP001 	BYTE			GetSourceDesignMode() const	{ return nSourceDesignMode; }
//STRIP001 
//STRIP001 	virtual void SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
//STRIP001 						 const SfxHint& rHint, const TypeId& rHintType );
//STRIP001 
//STRIP001 	virtual SfxPrinter*		GetPrinter( BOOL bCreate = FALSE );
//STRIP001 	virtual USHORT			SetPrinter( SfxPrinter*	pNewPrinter, USHORT nDiffFlags = SFX_PRINTER_ALL );
//STRIP001 	virtual PrintDialog*	CreatePrintDialog( Window* pParent );
//STRIP001 	virtual SfxTabPage*     CreatePrintOptionsPage( Window *pParent, const SfxItemSet &rOptions );
//STRIP001 	virtual void			PreparePrint( PrintDialog* pPrintDialog = NULL );
//STRIP001 	virtual USHORT			Print( SfxProgress& rProgress, PrintDialog* pPrintDialog = NULL );
//STRIP001 
//STRIP001 	void	AddAccessibilityObject( SfxListener& rObject );
//STRIP001 	void	RemoveAccessibilityObject( SfxListener& rObject );
//STRIP001 	void	BroadcastAccessibility( const SfxHint &rHint );
//STRIP001 	BOOL	HasAccessibilityObjects();
//STRIP001 
//STRIP001 	const ScPreviewLocationData& GetLocationData();
//STRIP001 	ScDocument*		GetDocument();
//STRIP001     ScPreview*		GetPreview() { return pPreview; }
};



} //namespace binfilter
#endif
