/*************************************************************************
 *
 *  $RCSfile: sch_tpdefcol.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
// header for GetAppData
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#include "tpappopt.hxx"
#include "tpappopt.hrc"

#include "schdll.hxx"
#include "schresid.hxx"
#include "strings.hrc"
#include "schmod.hxx"
namespace binfilter {


// ====================
// class ChartColorLB
// ====================
//STRIP001 void ChartColorLB::Fill( const SchColorTable* pTab )
//STRIP001 {
//STRIP001 	long nCount = pTab->Count();
//STRIP001 	XColorEntry* pEntry;
//STRIP001 	SetUpdateMode( FALSE );
//STRIP001 
//STRIP001 	for( long i = 0; i < nCount; i++ )
//STRIP001 	{
//STRIP001 		pEntry = pTab->Get( i );
//STRIP001 		if( pEntry )
//STRIP001 		{
//STRIP001 			Append( pEntry );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SetUpdateMode( TRUE );	
//STRIP001 }


// ====================
// class SchDefaultColorOptPage
// ====================
//STRIP001 SchDefaultColorOptPage::SchDefaultColorOptPage( Window* pParent, const SfxItemSet& rInAttrs ) :
//STRIP001 		SfxTabPage( pParent, SchResId( TP_DEF_COLOR ), rInAttrs ),
//STRIP001 		aGbChartColors( this, SchResId( GB_CHART_COLOR_LIST ) ),
//STRIP001 		aLbChartColors( this, SchResId( LB_CHART_COLOR_LIST ) ),
//STRIP001 		aGbColorBox( this, SchResId( GB_COLOR_BOX ) ),
//STRIP001 		aValSetColorBox( this, SchResId( CT_COLOR_BOX ) ),
//STRIP001 		aPBDefault( this, SchResId( PB_RESET_TO_DEFAULT ) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aPBDefault.SetClickHdl( LINK( this, SchDefaultColorOptPage, ResetToDefaults ) );
//STRIP001 	aLbChartColors.SetSelectHdl( LINK( this, SchDefaultColorOptPage, ListClickedHdl ) );
//STRIP001 	aValSetColorBox.SetSelectHdl( LINK( this, SchDefaultColorOptPage, BoxClickedHdl ) );
//STRIP001 
//STRIP001 	aValSetColorBox.SetStyle( aValSetColorBox.GetStyle()
//STRIP001 									| WB_VSCROLL | WB_ITEMBORDER | WB_NAMEFIELD );
//STRIP001 	aValSetColorBox.SetColCount( 8 );
//STRIP001 	aValSetColorBox.SetLineCount( 12 );
//STRIP001 	aValSetColorBox.SetExtraSpacing( 0 );
//STRIP001 	aValSetColorBox.Show();
//STRIP001 
//STRIP001 	pColorTab = new XColorTable( SvtPathOptions().GetPalettePath());
//STRIP001 
//STRIP001 	const SfxPoolItem* pItem = NULL;
//STRIP001 	if( rInAttrs.GetItemState( CHATTR_DEFCOLORS, FALSE, &pItem ) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		pColorConfig = SAL_STATIC_CAST( SchColorTableItem*, pItem->Clone() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SchColorTable aTable;
//STRIP001 		aTable.UseDefault();
//STRIP001 		pColorConfig = new SchColorTableItem( CHATTR_DEFCOLORS, aTable );
//STRIP001 		pColorConfig->SetOptions( SCH_MOD1()->GetSchOptions() );
//STRIP001 	}
//STRIP001 
//STRIP001 	Construct();
//STRIP001 }

//STRIP001 SchDefaultColorOptPage::~SchDefaultColorOptPage()
//STRIP001 {
//STRIP001 	delete pColorConfig;
//STRIP001 	delete pColorTab;
//STRIP001 }

//STRIP001 void SchDefaultColorOptPage::Construct()
//STRIP001 {
//STRIP001 	if( pColorConfig )
//STRIP001 		aLbChartColors.Fill( SAL_STATIC_CAST( SchColorTable*, pColorConfig ) );
//STRIP001 
//STRIP001 	FillColorBox();
//STRIP001 
//STRIP001 	aLbChartColors.SelectEntryPos( 0 );
//STRIP001 	ListClickedHdl( &aLbChartColors );
//STRIP001 }


//STRIP001 SfxTabPage* __EXPORT SchDefaultColorOptPage::Create( Window* pParent, const SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	return new SchDefaultColorOptPage( pParent, rAttrs );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL __EXPORT SchDefaultColorOptPage::FillItemSet( SfxItemSet& rOutAttrs )
//STRIP001 {
//STRIP001 	if( pColorConfig )
//STRIP001 		rOutAttrs.Put( *SAL_STATIC_CAST( SfxPoolItem*, pColorConfig ));
//STRIP001 	
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 void __EXPORT SchDefaultColorOptPage::Reset( const SfxItemSet& rInAttrs )
//STRIP001 {
//STRIP001 	aLbChartColors.SelectEntryPos( 0 );
//STRIP001 	ListClickedHdl( &aLbChartColors );
//STRIP001 }
//STRIP001 
//STRIP001 void SchDefaultColorOptPage::FillColorBox()
//STRIP001 {
//STRIP001 	if( !pColorTab ) return;
//STRIP001 	
//STRIP001 	long nCount = pColorTab->Count();
//STRIP001 	XColorEntry* pColorEntry;
//STRIP001 
//STRIP001 	for( long i = 0; i < nCount; i++ )
//STRIP001 	{
//STRIP001 		pColorEntry = pColorTab->Get( i );
//STRIP001 		aValSetColorBox.InsertItem( (USHORT) i + 1, pColorEntry->GetColor(), pColorEntry->GetName() );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 long SchDefaultColorOptPage::GetColorIndex( const Color& rCol )
//STRIP001 {
//STRIP001 	if( pColorTab )
//STRIP001 	{
//STRIP001 		long nCount = pColorTab->Count();
//STRIP001 		XColorEntry* pColorEntry;
//STRIP001 
//STRIP001 		for( long i = nCount - 1; i >= 0; i-- )			// default chart colors are at the end of the table
//STRIP001 		{
//STRIP001 			pColorEntry = pColorTab->Get( i );
//STRIP001 			if( pColorEntry && pColorEntry->GetColor() == rCol )
//STRIP001 				return SAL_STATIC_CAST( XPropertyTable*, pColorTab )->Get( pColorEntry->GetName() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return -1L;
//STRIP001 }



// --------------------
// event handlers
// --------------------

// ResetToDefaults
// ---------------

//STRIP001 IMPL_LINK( SchDefaultColorOptPage, ResetToDefaults, void *, EMPTYARG )
//STRIP001 {
//STRIP001   	SAL_STATIC_CAST( SchColorTable*, pColorConfig )->UseDefault();
//STRIP001 
//STRIP001 	aLbChartColors.Clear();
//STRIP001 	aLbChartColors.Fill( SAL_STATIC_CAST( SchColorTable*, pColorConfig ) );
//STRIP001 
//STRIP001 	aLbChartColors.GetFocus();
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }

// ListClickedHdl
// --------------

//STRIP001 IMPL_LINK( SchDefaultColorOptPage, ListClickedHdl, ChartColorLB*,  pColorList )
//STRIP001 {
//STRIP001 	Color aCol = pColorList->GetSelectEntryColor();
//STRIP001 
//STRIP001 	long nIndex = GetColorIndex( aCol );
//STRIP001 
//STRIP001 	if( nIndex == -1 )		// not found
//STRIP001 	{
//STRIP001 		aValSetColorBox.SetNoSelection();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aValSetColorBox.SelectItem( (USHORT)nIndex + 1 );		// ValueSet is 1-based
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }

// BoxClickedHdl
// -------------

//STRIP001 IMPL_LINK( SchDefaultColorOptPage, BoxClickedHdl, ValueSet*, pColorBox )
//STRIP001 {
//STRIP001 	USHORT nIdx = aLbChartColors.GetSelectEntryPos();
//STRIP001 	if( nIdx != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001 		XColorEntry* pEntry = new XColorEntry( aValSetColorBox.GetItemColor( aValSetColorBox.GetSelectItemId() ),
//STRIP001 											   aLbChartColors.GetSelectEntry() );
//STRIP001 
//STRIP001 		aLbChartColors.Modify( pEntry, nIdx );
//STRIP001 		pColorConfig->ReplaceAndDestroy( nIdx, pEntry );
//STRIP001 							   
//STRIP001 		aLbChartColors.SelectEntryPos( nIdx );	// reselect entry
//STRIP001 	}
//STRIP001 	
//STRIP001 	return 0L;
//STRIP001 }

}
