/*************************************************************************
 *
 *  $RCSfile: sch_undatrow.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//svdraw.hxx
//#define _SVDRAW_HXX
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV

// auto strip #ifndef _SFX_OBJSH_HXX //autogen
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #endif




#pragma hdrstop
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif

// auto strip #include "schdll.hxx"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #include "schview.hxx"
// auto strip #include "datarow.hxx"
// auto strip #include "undatrow.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchUndoDataRow, SchUndoAttr);


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDataRow::Undo()
//STRIP001 {
//STRIP001 	const SfxPoolItem* pPoolItem=NULL;
//STRIP001 	if(pOldAttr->GetItemState(CHATTR_DIAGRAM_GAPWIDTH, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetGap((long)((const SfxInt32Item*)pPoolItem)->GetValue(),nRow);
//STRIP001 	if(pOldAttr->GetItemState(CHATTR_DIAGRAM_OVERLAP, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetOverlap((long)((const SfxInt32Item*)pPoolItem)->GetValue(),nRow);
//STRIP001 	if(pOldAttr->GetItemState(CHATTR_BARCONNECT, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetBarConnectors(((const SfxBoolItem*)pPoolItem)->GetValue(),nRow);
//STRIP001 
//STRIP001 	rDoc.ChangeDataRowAttr(*pOldAttr, nRow, FALSE);//#54870# nRow statt pObj
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDataRow::Redo()
//STRIP001 {
//STRIP001 	const SfxPoolItem* pPoolItem=NULL;
//STRIP001 	if(pNewAttr->GetItemState(CHATTR_DIAGRAM_GAPWIDTH, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetGap((long)((const SfxInt32Item*)pPoolItem)->GetValue(),nRow);
//STRIP001 	if(pNewAttr->GetItemState(CHATTR_DIAGRAM_OVERLAP, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetOverlap((long)((const SfxInt32Item*)pPoolItem)->GetValue(),nRow);
//STRIP001 	if(pNewAttr->GetItemState(CHATTR_BARCONNECT, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		rDoc.SetBarConnectors(((const SfxBoolItem*)pPoolItem)->GetValue(),nRow);
//STRIP001 
//STRIP001 	rDoc.ChangeDataRowAttr(*pNewAttr, nRow);//#54870# nRow statt pObj
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDataRow::Repeat(SfxRepeatTarget& rView)
//STRIP001 {
//STRIP001 	if (((SchView&)rView).HasMarkedObj())
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 			SchDataRow* pDataRow = GetDataRow(*pObj);
//STRIP001 
//STRIP001 			if (pDataRow)
//STRIP001 			{
//STRIP001 				short nRow = pDataRow->GetRow();
//STRIP001 
//STRIP001 				SfxItemSet aOldAttr(rDoc.GetDataRowAttr(nRow));
//STRIP001 
//STRIP001 				if (rDoc.ChangeDataRowAttr(*pNewAttr, nRow))//#54870# nRow statt pObj
//STRIP001 				{
//STRIP001 					SchUndoDataRow* pUndo =
//STRIP001 						new SchUndoDataRow(rDoc, nRow, aOldAttr, *pNewAttr);
//STRIP001 					pUndo->SetComment(String(SchResId(STR_UNDO_DATA_ROW)));
//STRIP001 
//STRIP001 					rDoc.GetObjectShell()->
//STRIP001 						GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 BOOL SchUndoDataRow::CanRepeat(SfxRepeatTarget& rView) const
//STRIP001 {
//STRIP001 	if (((SchView&)rView).HasMarkedObj())
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1 &&
//STRIP001 			GetDataRow(*rMarkList.GetMark(0)->GetObj()))
//STRIP001 			return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }



}
