/*************************************************************************
 *
 *  $RCSfile: sd_dlgolbul.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:36:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <bf_sfx2/objsh.hxx>
#endif
#define ITEMID_COLOR_TABLE      SID_COLOR_TABLE
// auto strip #ifndef _SVX_DRAWITEM_HXX //autogen
// auto strip #include <bf_svx/drawitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BULITEM_HXX
// auto strip #include <bf_svx/bulitem.hxx>
// auto strip #endif
// auto strip #ifndef _EEITEM_HXX
// auto strip #include <bf_svx/eeitem.hxx>
// auto strip #endif

// auto strip #include <bf_svx/numpages.hxx>
// auto strip #include <bf_svx/numitem.hxx>

#include <bf_svx/dialogs.hrc>
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVDMARK_HXX //autogen
// auto strip #include <bf_svx/svdmark.hxx>
// auto strip #endif

// auto strip #ifndef _SD_SDVIEW_HXX
// auto strip #include "sdview.hxx"
// auto strip #endif

// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif

// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif

// auto strip #ifndef _DRAWDOC_HXX
// auto strip #include <drawdoc.hxx>
// auto strip #endif

// auto strip #ifndef _SD_SDRESID_HXX
// auto strip #include "sdresid.hxx"
// auto strip #endif

#include "glob.hrc"
// auto strip #include "dlgolbul.hxx"
#include "dlgolbul.hrc"
//#include "enumdlg.hxx"
// auto strip #include "bulmaper.hxx"
// auto strip #include "docshell.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

//STRIP001 SdOutlineBulletDlg::SdOutlineBulletDlg( Window* pParent, const SfxItemSet* pAttr, SdView* pView ) :
//STRIP001 		SfxTabDialog	( pParent, SdResId(TAB_OUTLINEBULLET) ),
//STRIP001 		aInputSet		( *pAttr ),
//STRIP001 		bTitle			( FALSE ),
//STRIP001 		pSdView			( pView )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aInputSet.MergeRange( SID_PARAM_NUM_PRESET, SID_PARAM_CUR_NUM_LEVEL );
//STRIP001 	aInputSet.Put( *pAttr );
//STRIP001 
//STRIP001 	pOutputSet = new SfxItemSet( *pAttr );
//STRIP001 	pOutputSet->ClearItem();
//STRIP001 
//STRIP001 	BOOL bOutliner = FALSE;
//STRIP001 
//STRIP001 	// Sonderbehandlung wenn eine Title Objekt selektiert wurde
//STRIP001 	if( pView )
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 		const ULONG nCount = rMarkList.GetMarkCount();
//STRIP001 		for(ULONG nNum = 0; nNum < nCount; nNum++)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(nNum)->GetObj();
//STRIP001 			if( pObj->GetObjInventor() == SdrInventor )
//STRIP001 			{
//STRIP001 
//STRIP001 				switch(pObj->GetObjIdentifier())
//STRIP001 				{
//STRIP001 				case OBJ_TITLETEXT:
//STRIP001 					bTitle = TRUE;
//STRIP001 					break;
//STRIP001 				case OBJ_OUTLINETEXT:
//STRIP001 					bOutliner = TRUE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( SFX_ITEM_SET != aInputSet.GetItemState(EE_PARA_NUMBULLET))
//STRIP001 	{
//STRIP001 		const SvxNumBulletItem *pItem = NULL;
//STRIP001 		if(bOutliner)
//STRIP001 		{
//STRIP001 			SfxStyleSheetBasePool* pSSPool = pView->GetDocSh()->GetStyleSheetPool();
//STRIP001 			String aStyleName((SdResId(STR_LAYOUT_OUTLINE)));
//STRIP001 			aStyleName.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " 1" ) );
//STRIP001 			SfxStyleSheetBase* pFirstStyleSheet = pSSPool->Find( aStyleName, SFX_STYLE_FAMILY_PSEUDO);
//STRIP001 			if( pFirstStyleSheet )
//STRIP001 				pFirstStyleSheet->GetItemSet().GetItemState(EE_PARA_NUMBULLET, FALSE, (const SfxPoolItem**)&pItem);
//STRIP001 		}
//STRIP001 
//STRIP001 		if( pItem == NULL )
//STRIP001 			pItem = (SvxNumBulletItem*) aInputSet.GetPool()->GetSecondaryPool()->GetPoolDefaultItem(EE_PARA_NUMBULLET);
//STRIP001 
//STRIP001 		DBG_ASSERT( pItem, "Kein EE_PARA_NUMBULLET im Pool! [CL]" );
//STRIP001 
//STRIP001 		aInputSet.Put(*pItem, EE_PARA_NUMBULLET);
//STRIP001 	}
//STRIP001 
//STRIP001 	/* debug
//STRIP001 	if( SFX_ITEM_SET == aInputSet.GetItemState(EE_PARA_NUMBULLET, FALSE, &pItem ))
//STRIP001 	{
//STRIP001 		SvxNumRule& rItem = *((SvxNumBulletItem*)pItem)->GetNumRule();
//STRIP001 		for( int i = 0; i < 9; i++ )
//STRIP001 		{
//STRIP001 			SvxNumberFormat aNumberFormat = rItem.GetLevel(i);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	*/
//STRIP001 
//STRIP001 	if(bTitle && aInputSet.GetItemState(EE_PARA_NUMBULLET,TRUE) == SFX_ITEM_ON )
//STRIP001 	{
//STRIP001 		SvxNumBulletItem* pItem = (SvxNumBulletItem*)aInputSet.GetItem(EE_PARA_NUMBULLET,TRUE);
//STRIP001 		SvxNumRule* pRule = pItem->GetNumRule();
//STRIP001 		if(pRule)
//STRIP001 		{
//STRIP001 			SvxNumRule aNewRule( *pRule );
//STRIP001 			aNewRule.SetFeatureFlag( NUM_NO_NUMBERS, TRUE );
//STRIP001 
//STRIP001 			SvxNumBulletItem aNewItem( aNewRule, EE_PARA_NUMBULLET );
//STRIP001 			aInputSet.Put(aNewItem);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SdBulletMapper::PreMapNumBulletForDialog( aInputSet );
//STRIP001 
//STRIP001 	SetInputSet( &aInputSet );
//STRIP001 
//STRIP001 	if(!bTitle)
//STRIP001 		AddTabPage(RID_SVXPAGE_PICK_SINGLE_NUM, &SvxSingleNumPickTabPage::Create, 0);
//STRIP001 	else
//STRIP001 		RemoveTabPage( RID_SVXPAGE_PICK_SINGLE_NUM );
//STRIP001 
//STRIP001 	AddTabPage(RID_SVXPAGE_PICK_BULLET    , &SvxBulletPickTabPage::Create, 0);
//STRIP001 	AddTabPage(RID_SVXPAGE_PICK_BMP 	  , &SvxBitmapPickTabPage::Create, 0);
//STRIP001 	AddTabPage(RID_SVXPAGE_NUM_OPTIONS 	  , &SvxNumOptionsTabPage::Create, 0);
//STRIP001 	AddTabPage(RID_SVXPAGE_NUM_POSITION	  , &SvxNumPositionTabPage::Create, 0);
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 SdOutlineBulletDlg::~SdOutlineBulletDlg()
//STRIP001 {
//STRIP001 	delete pOutputSet;
//STRIP001 }
//STRIP001 
//STRIP001 void SdOutlineBulletDlg::PageCreated( USHORT nId, SfxTabPage &rPage )
//STRIP001 {
//STRIP001 	switch ( nId )
//STRIP001 	{
//STRIP001 		case RID_SVXPAGE_NUM_OPTIONS:
//STRIP001 		{
//STRIP001 			if( pSdView )
//STRIP001 			{
//STRIP001 				FieldUnit eMetric = pSdView->GetDoc()->GetUIUnit();
//STRIP001 				((SvxNumOptionsTabPage&)rPage).SetMetric(eMetric);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case RID_SVXPAGE_NUM_POSITION:
//STRIP001 		{
//STRIP001 			if( pSdView )
//STRIP001 			{
//STRIP001 				FieldUnit eMetric = pSdView->GetDoc()->GetUIUnit();
//STRIP001 				((SvxNumPositionTabPage&)rPage).SetMetric(eMetric);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 const SfxItemSet* SdOutlineBulletDlg::GetOutputItemSet()
//STRIP001 {
//STRIP001 	SfxItemSet aSet( *SfxTabDialog::GetOutputItemSet() );
//STRIP001 	pOutputSet->Put( aSet );
//STRIP001 
//STRIP001 	const SfxPoolItem *pItem = NULL;
//STRIP001 	if( SFX_ITEM_SET == pOutputSet->GetItemState(pOutputSet->GetPool()->GetWhich(SID_ATTR_NUMBERING_RULE), FALSE, &pItem ))
//STRIP001 	{
//STRIP001 		SdBulletMapper::MapFontsInNumRule( *((SvxNumBulletItem*)pItem)->GetNumRule(), *pOutputSet );
//STRIP001 
//STRIP001 		SfxUInt16Item aBulletState( EE_PARA_BULLETSTATE, 1 );
//STRIP001 		pOutputSet->Put(aBulletState);
//STRIP001 	}
//STRIP001 
//STRIP001 	SdBulletMapper::PostMapNumBulletForDialog( *pOutputSet );
//STRIP001 
//STRIP001 	if(bTitle && pOutputSet->GetItemState(EE_PARA_NUMBULLET,TRUE) == SFX_ITEM_ON )
//STRIP001 	{
//STRIP001 		SvxNumBulletItem* pItem = (SvxNumBulletItem*)pOutputSet->GetItem(EE_PARA_NUMBULLET,TRUE);
//STRIP001 		SvxNumRule* pRule = pItem->GetNumRule();
//STRIP001 		if(pRule)
//STRIP001 			pRule->SetFeatureFlag( NUM_NO_NUMBERS, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pOutputSet;
//STRIP001 }




}
