/*************************************************************************
 *
 *  $RCSfile: sd_dlgpage.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:37:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_GRADIENT_LIST	SID_GRADIENT_LIST
#define ITEMID_HATCH_LIST		SID_HATCH_LIST
#define ITEMID_BITMAP_LIST		SID_BITMAP_LIST

// auto strip #ifndef _SVX_PAGE_HXX
// auto strip #include <bf_svx/page.hxx>
// auto strip #endif
#ifndef _SVX_DIALOGS_HRC
#include <bf_svx/dialogs.hrc>
#endif
#ifndef _SVX_TAB_AREA_HXX
#include <bf_svx/tabarea.hxx>
#endif
// auto strip #ifndef _SVX_DRAWITEM_HXX
// auto strip #include <bf_svx/drawitem.hxx>
// auto strip #endif

// auto strip #ifndef _SD_SDRESID_HXX
// auto strip #include "sdresid.hxx"
// auto strip #endif
// auto strip #include "dlgpage.hxx"

// auto strip #include "docshell.hxx"
namespace binfilter {


/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

//STRIP001 SdPageDlg::SdPageDlg( SfxObjectShell* pDocSh, Window* pParent, const SfxItemSet* pAttr, BOOL bAreaPage ) :
//STRIP001 		SfxTabDialog ( pParent, SdResId( TAB_PAGE ), pAttr ),
//STRIP001 		rOutAttrs			( *pAttr ),
//STRIP001 		pDocShell			( pDocSh )
//STRIP001 {
//STRIP001 	SvxColorTableItem aColorTableItem(*( (const SvxColorTableItem*)
//STRIP001 		( pDocShell->GetItem( SID_COLOR_TABLE ) ) ) );
//STRIP001 	SvxGradientListItem aGradientListItem(*( (const SvxGradientListItem*)
//STRIP001 		( pDocShell->GetItem( SID_GRADIENT_LIST ) ) ) );
//STRIP001 	SvxBitmapListItem aBitmapListItem(*( (const SvxBitmapListItem*)
//STRIP001 		( pDocShell->GetItem( SID_BITMAP_LIST ) ) ) );
//STRIP001 	SvxHatchListItem aHatchListItem(*( (const SvxHatchListItem*)
//STRIP001 		( pDocShell->GetItem( SID_HATCH_LIST ) ) ) );
//STRIP001 
//STRIP001 	pColorTab = aColorTableItem.GetColorTable();
//STRIP001 	pGradientList = aGradientListItem.GetGradientList();
//STRIP001 	pHatchingList = aHatchListItem.GetHatchList();
//STRIP001 	pBitmapList = aBitmapListItem.GetBitmapList();
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	AddTabPage( RID_SVXPAGE_PAGE, SvxPageDescPage::Create, 0);
//STRIP001 	AddTabPage( RID_SVXPAGE_AREA, SvxAreaTabPage::Create, 0 );
//STRIP001 
//STRIP001 	nDlgType = 1; // Vorlagen-Dialog
//STRIP001 	nPageType = 0;
//STRIP001 	nPos = 0;
//STRIP001 
//STRIP001 	nColorTableState = CT_NONE;
//STRIP001 	nBitmapListState = CT_NONE;
//STRIP001 	nGradientListState = CT_NONE;
//STRIP001 	nHatchingListState = CT_NONE;
//STRIP001 
//STRIP001 	if(!bAreaPage)  // I have to add the page before I remove it !
//STRIP001 		RemoveTabPage( RID_SVXPAGE_AREA );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Seite wird erzeugt
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageDlg::PageCreated(USHORT nId, SfxTabPage& rPage)
//STRIP001 {
//STRIP001 	switch(nId)
//STRIP001 	{
//STRIP001 	case RID_SVXPAGE_PAGE:
//STRIP001 		( (SvxPageDescPage&) rPage).SetMode(SVX_PAGE_MODE_PRESENTATION);
//STRIP001 		( (SvxPageDescPage&) rPage).SetPaperFormatRanges( SVX_PAPER_A0, SVX_PAPER_E );
//STRIP001 		break;
//STRIP001 	case RID_SVXPAGE_AREA:
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetGradientList( pGradientList );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetHatchingList( pHatchingList );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetBitmapList( pBitmapList );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetPos( &nPos );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetGrdChgd( &nGradientListState );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetHtchChgd( &nHatchingListState );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetBmpChgd( &nBitmapListState );
//STRIP001 		( (SvxAreaTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 		( (SvxAreaTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }



}
