/*************************************************************************
 *
 *  $RCSfile: sd_tlborder.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:42:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include <tools/urlobj.hxx>
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #ifndef _SVDITER_HXX //autogen
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #endif

// auto strip #ifndef _SFX_BINDINGS_HXX
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif

// auto strip #ifndef _SFXDISPATCH_HXX
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

// auto strip #include "tlborder.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
#include "sdview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "anminfo.hxx"
// auto strip #include "unoaprms.hxx"                 // Undo-Action
// auto strip #include "sdundogr.hxx"                 // Undo Gruppe

// fuer Preview-Window
// auto strip #include "preview.hxx"
// auto strip #include "prevchld.hxx"

#include "strings.hrc"
#include "res_bmp.hrc"
namespace binfilter {


/*************************************************************************
|*
|* Ctor1 SdOrderTLB
|*
\************************************************************************/

//STRIP001 SdOrderTLB::SdOrderTLB(  Window* pParentWin, const SdResId& rSdResId, SfxBindings* pInBindings ) :
//STRIP001 	SvTreeListBox   ( pParentWin, rSdResId ),
//STRIP001 	pBindings       ( pInBindings ),
//STRIP001 	pParent 		( pParentWin ),
//STRIP001 	bUpdate			( FALSE ),
//STRIP001 	bExtSelect		( FALSE )
//STRIP001 {
//STRIP001 	// Tree-ListBox mit Linien versehen
//STRIP001 	SetWindowBits( WinBits( WB_TABSTOP |
//STRIP001 							WB_BORDER |
//STRIP001 							WB_HASLINES |
//STRIP001 							WB_HASBUTTONS |
//STRIP001 							WB_HASLINESATROOT |
//STRIP001 							//WB_HSCROLL |
//STRIP001 							WB_HASBUTTONSATROOT ) );
//STRIP001 
//STRIP001 	// internes Drag&Drop zulassen
//STRIP001 	SetDragDropMode( SV_DRAGDROP_CTRL_MOVE );
//STRIP001 
//STRIP001 	pTable = new Table();
//STRIP001 
//STRIP001 	// Tabelle und ListBox aufbauen
//STRIP001 	FillTable( pTable );
//STRIP001 	Fill();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Dtor SdOrderTLB
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdOrderTLB::~SdOrderTLB()
//STRIP001 {
//STRIP001 	delete pTable;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ueberladen, um Flag zu setzen, dass von Aussen die TLB bedient wird
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	bExtSelect = TRUE;
//STRIP001 
//STRIP001 	SvTreeListBox::MouseButtonDown( rMEvt );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ueberladen, um Flag zu setzen, dass von Aussen die TLB bedient wird
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001 	bExtSelect = TRUE;
//STRIP001 
//STRIP001 	USHORT nKCode = rKEvt.GetKeyCode().GetFullCode();
//STRIP001 	if( nKCode != KEY_BACKSPACE && nKCode != KEY_DELETE )
//STRIP001 		SvTreeListBox::KeyInput( rKEvt );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* In TreeLB Eintrag selektieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdOrderTLB::SelectEntry( const SdrObject* pObj )
//STRIP001 {
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 
//STRIP001 	if( pObj )
//STRIP001 	{
//STRIP001 		SvLBoxEntry* pEntry = NULL;
//STRIP001 		SdrObject*	 pTmpObj;
//STRIP001 
//STRIP001 		for( pEntry = First(); pEntry && !bFound; pEntry = Next( pEntry ) )
//STRIP001 		{
//STRIP001 			pTmpObj = (SdrObject*)pEntry->GetUserData();
//STRIP001 			if( pObj == pTmpObj )
//STRIP001 			{
//STRIP001 				bFound = TRUE;
//STRIP001 				SetCurEntry( pEntry );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return( bFound );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Selectierten String zurueckgeben
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 String SdOrderTLB::GetSelectEntry()
//STRIP001 {
//STRIP001 	return( GetEntryText( GetCurEntry() ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Select-Hdl
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 //void SdOrderTLB::SelectHdl()
//STRIP001 BOOL SdOrderTLB::Select( SvLBoxEntry* pEntry, BOOL bSelect )
//STRIP001 {
//STRIP001 	BOOL bReturn = SvTreeListBox::Select( pEntry, bSelect );
//STRIP001 
//STRIP001 	if( bReturn && bSelect )
//STRIP001 	{
//STRIP001 		if( bExtSelect )
//STRIP001 		{
//STRIP001 			bExtSelect = FALSE;
//STRIP001 
//STRIP001 			if( bUpdate )
//STRIP001 			{
//STRIP001 				//SvLBoxEntry* pEntry = FirstSelected();
//STRIP001 				if( pEntry )
//STRIP001 				{
//STRIP001 					SdrObject* pObj = (SdrObject*)pEntry->GetUserData();
//STRIP001 					if( pObj )
//STRIP001 					{
//STRIP001 						SdViewShell*	pViewShell= ( SdViewShell* ) pBindings->GetDispatcher()->GetFrame()->GetViewShell();
//STRIP001 						SdrView*		pView	  = pViewShell->GetDrawView();
//STRIP001 						SdrPageView*	pPageView = pView->GetPageViewPvNum( 0 );
//STRIP001 
//STRIP001 						pView->UnmarkAll();
//STRIP001 						pView->MarkObj( pObj, pPageView, FALSE );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return( bReturn );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* TreeLB mit Seiten und Objekten fuellen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::Fill()
//STRIP001 {
//STRIP001 	Color aColor( COL_WHITE );
//STRIP001 	Bitmap aBmpObject( SdResId( BMP_OBJECTS ) );
//STRIP001 	Image aImgObject( aBmpObject, aColor );
//STRIP001 	Bitmap aBmpGroup( SdResId( BMP_GROUP ) );
//STRIP001 	Image aImgGroup( aBmpGroup, aColor );
//STRIP001 	Bitmap aBmpObjectH( SdResId( BMP_OBJECTS_H ) );
//STRIP001 	Image aImgObjectH( aBmpObjectH, Color( COL_BLACK ) );
//STRIP001 	Bitmap aBmpGroupH( SdResId( BMP_GROUP_H ) );
//STRIP001 	Image aImgGroupH( aBmpGroupH, Color( COL_BLACK ) );
//STRIP001 
//STRIP001 	SdDrawDocShell* pDocSh = ( SdDrawDocShell* ) pBindings->GetDispatcher()->GetFrame()->GetObjectShell();
//STRIP001 	SdDrawDocument*	pDoc      = pDocSh->GetDoc();
//STRIP001 	SdrObject*	 	pObj 	  = NULL;
//STRIP001 	SvLBoxEntry*	pEntry	  = NULL;
//STRIP001 
//STRIP001 	for( pObj = (SdrObject*)pTable->First();
//STRIP001 		 pObj;
//STRIP001 		 pObj = (SdrObject*)pTable->Next() )
//STRIP001 	{
//STRIP001 		SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pObj );
//STRIP001 		if( pInfo && pInfo->bActive )
//STRIP001 		{
//STRIP001 			String aStr( pObj->GetName() );
//STRIP001 			if( aStr.Len() == 0 )
//STRIP001 			{
//STRIP001 				aStr = String( SdResId( STR_EFFECTDLG_OBJECT ) );
//STRIP001 				aStr.Append( sal_Unicode(' ') );
//STRIP001 				aStr.Append( UniString::CreateFromInt32( pObj->GetOrdNum() + 1 ) );
//STRIP001 			}
//STRIP001 			String aObjStr;
//STRIP001 			pObj->TakeObjNameSingul( aObjStr );
//STRIP001 			aStr.AppendAscii( " (" );
//STRIP001 			aStr.Append( aObjStr );
//STRIP001 			aStr.Append( sal_Unicode(')') );
//STRIP001 
//STRIP001 			// Reihenfolge
//STRIP001 			ULONG nPos = pInfo->nPresOrder;
//STRIP001 
//STRIP001 			if( pObj->GetObjInventor() == SdrInventor && pObj->GetObjIdentifier() == OBJ_GRUP )
//STRIP001 			{
//STRIP001 				pEntry = InsertEntry( aStr, aImgGroup, aImgGroup, 0, FALSE, nPos );
//STRIP001 				SetExpandedEntryBmp( pEntry, aImgGroupH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 				SetCollapsedEntryBmp( pEntry, aImgGroupH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pEntry = InsertEntry( aStr, aImgObject, aImgObject, 0, FALSE, nPos );
//STRIP001 				SetExpandedEntryBmp( pEntry, aImgObjectH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 				SetCollapsedEntryBmp( pEntry, aImgObjectH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 			}
//STRIP001 
//STRIP001 			pEntry->SetUserData( pObj );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Inhalt Ueberprufen und ggfs. die TLB neu aufbauen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::Update()
//STRIP001 {
//STRIP001 	BOOL bDifferent = FALSE;
//STRIP001 	SdDrawDocShell* pDocSh = ( SdDrawDocShell* ) pBindings->GetDispatcher()->GetFrame()->GetObjectShell();
//STRIP001 	SdDrawDocument*	pDoc      = pDocSh->GetDoc();
//STRIP001 	SdrObject*	 	pObj 	  = NULL;
//STRIP001 	SdrObject*	 	pObj2 	  = NULL;
//STRIP001 
//STRIP001 	// Tabelle aufbauen
//STRIP001 	Table* pNewTab = new Table();
//STRIP001 	FillTable( pNewTab );
//STRIP001 
//STRIP001 	// Anzahl
//STRIP001 	ULONG nCount = pNewTab->Count();
//STRIP001 	if( nCount != GetEntryCount() )
//STRIP001 		bDifferent = TRUE;
//STRIP001 
//STRIP001 	for( pObj = (SdrObject*)pTable->First(), pObj2 = (SdrObject*)pNewTab->First();
//STRIP001 		 pObj && pObj2 && !bDifferent;
//STRIP001 		 pObj = (SdrObject*)pTable->Next(), pObj2 = (SdrObject*)pNewTab->Next() )
//STRIP001 	{
//STRIP001 		if( pObj != pObj2 )
//STRIP001 			bDifferent = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bDifferent )
//STRIP001 	{
//STRIP001 		delete pTable;
//STRIP001 		pTable = pNewTab;
//STRIP001 
//STRIP001 		Clear();
//STRIP001 		Fill();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		delete pNewTab;
//STRIP001 
//STRIP001 	// Eintrag selektieren
//STRIP001 	if( bUpdate )
//STRIP001 	{
//STRIP001 		SdViewShell* pViewShell= ( SdViewShell* ) pBindings->GetDispatcher()->GetFrame()->GetViewShell();
//STRIP001 		SdrView* pView = pViewShell->GetDrawView();
//STRIP001 		SdrMarkList aMarkList = pView->GetMarkList();
//STRIP001 		ULONG nMarkCount = aMarkList.GetMarkCount();
//STRIP001 		if( nMarkCount == 1 )
//STRIP001 		{
//STRIP001 			pObj = aMarkList.GetMark( 0 )->GetObj();
//STRIP001 			if( !SelectEntry( pObj ) )
//STRIP001 				SelectAll( FALSE );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			SelectAll( FALSE );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tabelle aufbauen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::FillTable( Table* pTab )
//STRIP001 {
//STRIP001 	SdDrawDocShell* pDocSh = ( SdDrawDocShell* ) pBindings->GetDispatcher()->GetFrame()->GetObjectShell();
//STRIP001 	SdDrawDocument*	pDoc      = pDocSh->GetDoc();
//STRIP001 	SdViewShell*	pViewShell= pDocSh->GetViewShell();
//STRIP001 	SdPage* 	 	pPage 	  = pViewShell->GetActualPage();
//STRIP001 	SdrObject*	 	pObj 	  = NULL;
//STRIP001 	SdrObjListIter	aIter( *pPage, IM_FLAT );
//STRIP001 
//STRIP001 	ULONG i = 0;
//STRIP001 	while( aIter.IsMore() )
//STRIP001 	{
//STRIP001 		pObj = aIter.Next();
//STRIP001 		SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pObj );
//STRIP001 		SdrObjKind eKind	   = (SdrObjKind)pObj->GetObjIdentifier();
//STRIP001 
//STRIP001 		if( pInfo && pInfo->bActive )
//STRIP001 		{
//STRIP001 			// Wenn es sich um das Pfad-Objekt bei dem Effekt "An Kurve entlang"
//STRIP001 			// handelt, soll es nicht in der Tabelle aufgenommen werden
//STRIP001 			// "bInvisibleInPresentation" ist der einzige Hinweis darauf, ob
//STRIP001 			// es sich um das Pfad-Objekt handelt
//STRIP001 			if( !( pInfo->bInvisibleInPresentation &&
//STRIP001 				   pObj->GetObjInventor() == SdrInventor &&
//STRIP001 				   ( (eKind == OBJ_LINE) ||        // 2-Punkt-Linie
//STRIP001 					 (eKind == OBJ_PLIN) ||        // Polygon
//STRIP001 					 (eKind == OBJ_PATHLINE) ) ) ) // Bezier-Kurve
//STRIP001 			{
//STRIP001 				ULONG nPos = pInfo->nPresOrder;
//STRIP001 				// eindeutiger Key wird generiert
//STRIP001 				if( nPos == LIST_APPEND )
//STRIP001 					nPos /= 1024;
//STRIP001 				else
//STRIP001 					nPos *= 1024;
//STRIP001 				nPos += ++i;
//STRIP001 				BOOL bOK = pTab->Insert( nPos, pObj );
//STRIP001 				DBG_ASSERT( bOK, "Table::Insert fehlgeschlagen (Key schon vorhanden)" );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Reihenfolge an der Page zuweisen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOrderTLB::Assign()
//STRIP001 {
//STRIP001 	SdDrawDocShell* pDocSh = ( SdDrawDocShell* ) pBindings->GetDispatcher()->GetFrame()->GetObjectShell();
//STRIP001 	SdDrawDocument*	pDoc      = pDocSh->GetDoc();
//STRIP001 	SdrObject*		pObj 	  = NULL;
//STRIP001 	SvLBoxEntry*	pEntry 	  = NULL;
//STRIP001 
//STRIP001 	// Undo...
//STRIP001 	SfxUndoManager*				pUndoMgr = pDocSh->GetUndoManager();
//STRIP001 	SdAnimationPrmsUndoAction*	pAction = NULL;
//STRIP001 	SdUndoGroup*				pUndoGroup = NULL;
//STRIP001 	String	aComment( SdResId( STR_UNDO_ANIMATION_ORDER ) );
//STRIP001 
//STRIP001 
//STRIP001 	ULONG i = 0;
//STRIP001 	for( pEntry = First(); pEntry; pEntry = Next( pEntry ), i++ )
//STRIP001 	{
//STRIP001 		pObj = (SdrObject*)pEntry->GetUserData();
//STRIP001 		if( pObj )
//STRIP001 		{
//STRIP001 			SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pObj );
//STRIP001 			if( pInfo && pInfo->bActive )
//STRIP001 			{
//STRIP001 				if( pInfo->nPresOrder != i )
//STRIP001 				{
//STRIP001 					if( !pAction )
//STRIP001 					{
//STRIP001 						// Undo klammern
//STRIP001 						pUndoMgr->EnterListAction( aComment, aComment );
//STRIP001 
//STRIP001 						// Undo Gruppe erzeugen
//STRIP001 						pUndoGroup = new SdUndoGroup( pDoc );
//STRIP001 						pUndoGroup->SetComment( aComment );
//STRIP001 					}
//STRIP001 
//STRIP001 					// die eigentliche Undo-Action...
//STRIP001 					pAction = new SdAnimationPrmsUndoAction( pDoc, pObj );
//STRIP001 					pAction->SetPresOrder( pInfo->nPresOrder, i );
//STRIP001 					pUndoGroup->AddAction( pAction );
//STRIP001 					//pUndoMgr->AddUndoAction( pAction );
//STRIP001 
//STRIP001 					// Dies ist die eigentlich Animations-Reihenfolge
//STRIP001 					pInfo->nPresOrder = i;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pAction ) // Aenderungen wurden gemacht
//STRIP001 	{
//STRIP001 		// Undo Gruppe dem Undo Manager uebergeben
//STRIP001 		pUndoMgr->AddUndoAction( pUndoGroup );
//STRIP001 		pUndoMgr->LeaveListAction();
//STRIP001 
//STRIP001 		// Tabelle auf den neuesten Stand bringen (insb. fuer Undo/Redo)
//STRIP001 		pTable->Clear();
//STRIP001 		FillTable( pTable );
//STRIP001 
//STRIP001 		// Dokument ist geaendert worden
//STRIP001 		pDoc->SetChanged();
//STRIP001 
//STRIP001 		// ggfs. in Preview anzeigen
//STRIP001 		SfxChildWindow* pPreviewChildWindow =
//STRIP001 			pBindings->GetDispatcher()->GetFrame()->GetChildWindow( SdPreviewChildWindow::GetChildWindowId() );
//STRIP001 		if( pPreviewChildWindow )
//STRIP001 		{
//STRIP001 			SdPreviewWin* pPreviewWin = (SdPreviewWin*)pPreviewChildWindow->GetWindow();
//STRIP001 			if( pPreviewWin )
//STRIP001 				pPreviewWin->AnimatePage();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
