/*************************************************************************
 *
 *  $RCSfile: sd_fuconstr.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:47:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <bf_svx/svxids.hrc>
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _XDEF_HXX //autogen
// auto strip #include <bf_svx/xdef.hxx>
// auto strip #endif
// auto strip #ifndef SVX_XFILLIT0_HXX //autogen
// auto strip #include <bf_svx/xfillit0.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#include "app.hrc"
#include "glob.hrc"
// auto strip #include "fudraw.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuconstr.hxx"
// auto strip #include "frmview.hxx"
#include "sdpage.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "stlpool.hxx"
// auto strip #include <bf_svx/globl3d.hxx>
namespace binfilter {

//STRIP001 TYPEINIT1( FuConstruct, FuDraw );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstruct::FuConstruct(SdViewShell*		pViewSh,
//STRIP001 						 SdWindow*			pWin,
//STRIP001 						 SdView*			pView,
//STRIP001 						 SdDrawDocument*	pDoc,
//STRIP001 						 SfxRequest&		rReq) :
//STRIP001 	FuDraw(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	bSelectionChanged(FALSE)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstruct::~FuConstruct()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstruct::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuDraw::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	bMBDown = TRUE;
//STRIP001 	bSelectionChanged = FALSE;
//STRIP001 
//STRIP001 	if ( pView->IsAction() )
//STRIP001 	{
//STRIP001 		// #90235# this extra triggering is an error and leads to
//STRIP001 		// erasing the last two points when creating a polygon.
//STRIP001 		// if ( rMEvt.IsRight() )
//STRIP001 		//	pView->BckAction();
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	bFirstMouseMove = TRUE;
//STRIP001 	aDragTimer.Start();
//STRIP001 
//STRIP001 	aMDPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
//STRIP001 	USHORT nHitLog = USHORT (pWindow->PixelToLogic(Size(HITPIX,0)).Width());
//STRIP001 
//STRIP001 	if (rMEvt.IsLeft() && pView->IsExtendedMouseEventDispatcherEnabled())
//STRIP001 	{
//STRIP001 		pWindow->CaptureMouse();
//STRIP001 
//STRIP001 		SdrHdl* pHdl = pView->HitHandle(aMDPos, *pWindow);
//STRIP001 
//STRIP001 		if ( pHdl != NULL || pView->IsMarkedHit(aMDPos, nHitLog) )
//STRIP001 		{
//STRIP001 			USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 			pView->BegDragObj(aMDPos, (OutputDevice*) NULL, pHdl, nDrgLog);
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 		else if ( pView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			pView->UnmarkAll();
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstruct::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	FuDraw::MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001 		if( bFirstMouseMove )
//STRIP001 			bFirstMouseMove = FALSE;
//STRIP001 		else
//STRIP001 			aDragTimer.Stop();
//STRIP001 	}
//STRIP001 
//STRIP001 	Point aPix(rMEvt.GetPosPixel());
//STRIP001 	Point aPnt( pWindow->PixelToLogic(aPix) );
//STRIP001 
//STRIP001 	if ( pView->IsAction() )
//STRIP001 	{
//STRIP001 		ForceScroll(aPix);
//STRIP001 		pView->MovAction(aPnt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstruct::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = TRUE;
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001 		aDragTimer.Stop();
//STRIP001 		bIsInDragMode = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	FuDraw::MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 	if ( pView->IsDragObj() )
//STRIP001 	{
//STRIP001 		FrameView* pFrameView = pViewShell->GetFrameView();
//STRIP001 		BOOL bDragWithCopy = (rMEvt.IsMod1() && pFrameView->IsDragWithCopy());
//STRIP001 
//STRIP001 		if (bDragWithCopy)
//STRIP001 		{
//STRIP001 			bDragWithCopy = !pView->IsPresObjSelected(FALSE, TRUE);
//STRIP001 		}
//STRIP001 
//STRIP001 		pView->SetDragWithCopy(bDragWithCopy);
//STRIP001 		pView->EndDragObj( pView->IsDragWithCopy() );
//STRIP001 	}
//STRIP001 	else if ( pView->IsMarkObj() )
//STRIP001 	{
//STRIP001 		pView->EndMarkObj();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bReturn = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !pView->IsAction() )
//STRIP001 	{
//STRIP001 		pWindow->ReleaseMouse();
//STRIP001 		USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 		SdrHdl* pHdl = pView->HitHandle(aPnt, *pWindow);
//STRIP001 
//STRIP001 		if ( !pView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			SdrObject* pObj;
//STRIP001 			SdrPageView* pPV;
//STRIP001 			USHORT nHitLog = USHORT ( pWindow->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 
//STRIP001 			if (!pView->PickObj(aPnt, pObj, pPV))
//STRIP001 			{
//STRIP001 				pView->MarkObj(aPnt, nHitLog);
//STRIP001 			}
//STRIP001 
//STRIP001 			pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_OBJECT_SELECT, SFX_CALLMODE_ASYNCHRON);
//STRIP001 		}
//STRIP001 		else if (rMEvt.IsLeft() && !rMEvt.IsShift() && !rMEvt.IsMod1() && !rMEvt.IsMod2() &&
//STRIP001 				 !bSelectionChanged                   &&
//STRIP001 				 Abs(aPnt.X() - aMDPos.X()) < nDrgLog &&
//STRIP001 				 Abs(aPnt.Y() - aMDPos.Y()) < nDrgLog)
//STRIP001 		{
//STRIP001 			/**************************************************************
//STRIP001 			* Toggle zw. Selektion und Rotation
//STRIP001 			**************************************************************/
//STRIP001 			SdrObject* pSingleObj = NULL;
//STRIP001 			ULONG nMarkCount = pView->GetMarkList().GetMarkCount();
//STRIP001 
//STRIP001 			if (nMarkCount==1)
//STRIP001 			{
//STRIP001 				pSingleObj = pView->GetMarkList().GetMark(0)->GetObj();
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pView->GetDragMode() == SDRDRAG_MOVE && pView->IsRotateAllowed() &&
//STRIP001 				(pViewShell->GetFrameView()->IsClickChangeRotation() ||
//STRIP001 				 (pSingleObj && pSingleObj->GetObjInventor()==E3dInventor)))
//STRIP001 			{
//STRIP001 				pView->SetDragMode(SDRDRAG_ROTATE);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pView->SetDragMode(SDRDRAG_MOVE);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nClicks = rMEvt.GetClicks();
//STRIP001 
//STRIP001 	if (nClicks == 2 && rMEvt.IsLeft() && bMBDown &&
//STRIP001 		!rMEvt.IsMod1() && !rMEvt.IsMod2() && !rMEvt.IsShift() )
//STRIP001 	{
//STRIP001 		DoubleClick(rMEvt);
//STRIP001 	}
//STRIP001 	bMBDown = FALSE;
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstruct::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if ( !bReturn )
//STRIP001 		bReturn = FuDraw::KeyInput(rKEvt);
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstruct::Activate()
//STRIP001 {
//STRIP001 	pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 	FuDraw::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstruct::Deactivate()
//STRIP001 {
//STRIP001 	FuDraw::Deactivate();
//STRIP001 	pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* StyleSheet fuer das zu erzeugende Objekt setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstruct::SetStyleSheet(SfxItemSet& rAttr, SdrObject* pObj)
//STRIP001 {
//STRIP001 	SdPage* pPage = (SdPage*) pView->GetPageViewPvNum(0)->GetPage();
//STRIP001 
//STRIP001 	if ( pPage->IsMasterPage() && pPage->GetPageKind() == PK_STANDARD &&
//STRIP001 	     pDoc->GetDocumentType() == DOCUMENT_TYPE_IMPRESS )
//STRIP001 	{
//STRIP001 		/******************************************************************
//STRIP001 		* Objekt wurde auf Hintergrund erzeugt
//STRIP001 		******************************************************************/
//STRIP001 		String aName( pPage->GetLayoutName() );
//STRIP001 		String aSep = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( SD_LT_SEPARATOR ) );
//STRIP001 		USHORT n = aName.Search(aSep);
//STRIP001 		n += aSep.Len();
//STRIP001 		aName.Erase(n);
//STRIP001 		aName.Append( String ( SdResId( STR_LAYOUT_BACKGROUNDOBJECTS ) ) );
//STRIP001 		SfxStyleSheet* pSheet = (SfxStyleSheet*)pPage->GetModel()->
//STRIP001 												GetStyleSheetPool()->
//STRIP001 												Find(aName, SD_LT_FAMILY);
//STRIP001 		DBG_ASSERT(pSheet, "Objektvorlage nicht gefunden");
//STRIP001 
//STRIP001 		if (pSheet)
//STRIP001 		{
//STRIP001 			// Vorlage fuer Hintergrundobjekte zuweisen
//STRIP001 			pObj->SetStyleSheet(pSheet, FALSE);
//STRIP001 
//STRIP001 			SfxItemSet& rSet = pSheet->GetItemSet();
//STRIP001 			const XFillStyleItem& rFillStyle = (const XFillStyleItem&)
//STRIP001 											   rSet.Get(XATTR_FILLSTYLE);
//STRIP001 
//STRIP001 			if (nSlotId == SID_DRAW_RECT         || // Rechteck
//STRIP001 				nSlotId == SID_DRAW_RECT_ROUND   || // Rechteck, rund
//STRIP001 				nSlotId == SID_DRAW_SQUARE       || // Quadrat
//STRIP001 				nSlotId == SID_DRAW_SQUARE_ROUND || // Quadrat, rund
//STRIP001 				nSlotId == SID_DRAW_ELLIPSE      || // Ellipse
//STRIP001 				nSlotId == SID_DRAW_PIE          || // Ellipsensegment
//STRIP001 				nSlotId == SID_DRAW_ELLIPSECUT   || // Ellipsenabschnitt
//STRIP001 				nSlotId == SID_DRAW_CIRCLE       || // Kreis
//STRIP001 				nSlotId == SID_DRAW_CIRCLEPIE    || // Kreissegment
//STRIP001 				nSlotId == SID_DRAW_CIRCLECUT    || // Ellipsenabschnitt
//STRIP001 				nSlotId == SID_DRAW_POLYGON      || // Polygon
//STRIP001 				nSlotId == SID_DRAW_XPOLYGON     || // 45-Polygon
//STRIP001 				nSlotId == SID_DRAW_FREELINE     || // Freihandlinie
//STRIP001 				nSlotId == SID_DRAW_BEZIER_FILL)    // Bezier
//STRIP001 			{
//STRIP001 				/**********************************************************
//STRIP001 				* Gefuellte Objekte
//STRIP001 				**********************************************************/
//STRIP001 				if (rFillStyle.GetValue() == XFILL_NONE)
//STRIP001 				{
//STRIP001 					// Vorlage hat keine Fuellung, daher hart attributieren:
//STRIP001 					// Fuellung setzen
//STRIP001 					rAttr.Put(XFillStyleItem(XFILL_SOLID));
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else if (nSlotId == SID_DRAW_RECT_NOFILL         || // Rechteck
//STRIP001 					 nSlotId == SID_DRAW_RECT_ROUND_NOFILL   || // Rechteck, rund
//STRIP001 					 nSlotId == SID_DRAW_SQUARE_NOFILL       || // Quadrat
//STRIP001 					 nSlotId == SID_DRAW_SQUARE_ROUND_NOFILL || // Quadrat, rund
//STRIP001 					 nSlotId == SID_DRAW_ELLIPSE_NOFILL      || // Ellipse
//STRIP001 					 nSlotId == SID_DRAW_PIE_NOFILL          || // Ellipsensegment
//STRIP001 					 nSlotId == SID_DRAW_ELLIPSECUT_NOFILL   || // Ellipsenabschnitt
//STRIP001 					 nSlotId == SID_DRAW_CIRCLE_NOFILL       || // Kreis
//STRIP001 					 nSlotId == SID_DRAW_CIRCLEPIE_NOFILL    || // Kreissegment
//STRIP001 					 nSlotId == SID_DRAW_CIRCLECUT_NOFILL    || // Ellipsenabschnitt
//STRIP001 					 nSlotId == SID_DRAW_POLYGON_NOFILL      || // Polygon
//STRIP001 					 nSlotId == SID_DRAW_XPOLYGON_NOFILL     || // 45-Polygon
//STRIP001 					 nSlotId == SID_DRAW_FREELINE_NOFILL     || // Freihandlinie
//STRIP001 					 nSlotId == SID_DRAW_BEZIER_NOFILL)         // Bezier
//STRIP001 			{
//STRIP001 				/**********************************************************
//STRIP001 				* Ungefuellte Objekte
//STRIP001 				**********************************************************/
//STRIP001 				if (rFillStyle.GetValue() != XFILL_NONE)
//STRIP001 				{
//STRIP001 					// Vorlage hat eine Fuellung, daher hart attributieren:
//STRIP001 					// Keine Fuellung setzen
//STRIP001 					rAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		/******************************************************************
//STRIP001 		* Objekt wurde auf Seite  erzeugt
//STRIP001 		******************************************************************/
//STRIP001 		if (nSlotId == SID_DRAW_RECT_NOFILL         || // Rechteck
//STRIP001 			nSlotId == SID_DRAW_RECT_ROUND_NOFILL   || // Rechteck, rund
//STRIP001 			nSlotId == SID_DRAW_SQUARE_NOFILL       || // Quadrat
//STRIP001 			nSlotId == SID_DRAW_SQUARE_ROUND_NOFILL || // Quadrat, rund
//STRIP001 			nSlotId == SID_DRAW_ELLIPSE_NOFILL      || // Ellipse
//STRIP001 			nSlotId == SID_DRAW_PIE_NOFILL          || // Ellipsensegment
//STRIP001 			nSlotId == SID_DRAW_ELLIPSECUT_NOFILL   || // Ellipsenabschnitt
//STRIP001 			nSlotId == SID_DRAW_CIRCLE_NOFILL       || // Kreis
//STRIP001 			nSlotId == SID_DRAW_CIRCLEPIE_NOFILL    || // Kreissegment
//STRIP001 			nSlotId == SID_DRAW_CIRCLECUT_NOFILL    || // Ellipsenabschnitt
//STRIP001 			nSlotId == SID_DRAW_POLYGON_NOFILL      || // Polygon
//STRIP001 			nSlotId == SID_DRAW_XPOLYGON_NOFILL     || // 45-Polygon
//STRIP001 			nSlotId == SID_DRAW_FREELINE_NOFILL     || // Freihandlinie
//STRIP001 			nSlotId == SID_DRAW_BEZIER_NOFILL)         // Bezier
//STRIP001 		{
//STRIP001 			/**************************************************************
//STRIP001 			* Ungefuellte Objekte:
//STRIP001 			* Vorlage fuer ungefuellte Objekte zuweisen
//STRIP001 			**************************************************************/
//STRIP001 			String aName(SdResId(STR_POOLSHEET_OBJWITHOUTFILL));
//STRIP001 			SfxStyleSheet* pSheet = (SfxStyleSheet*)pPage->GetModel()->
//STRIP001 										 GetStyleSheetPool()->
//STRIP001 										 Find(aName, SFX_STYLE_FAMILY_PARA);
//STRIP001 			DBG_ASSERT(pSheet, "Objektvorlage nicht gefunden");
//STRIP001 
//STRIP001 			if (pSheet)
//STRIP001 			{
//STRIP001 				pObj->SetStyleSheet(pSheet, FALSE);
//STRIP001 
//STRIP001 				// Default-Attr. und Fuellung aus Vorlage zuweisen
//STRIP001 				SfxItemSet aAttr(*pView->GetDefaultAttr().Clone());
//STRIP001 				aAttr.Put(pSheet->GetItemSet().Get(XATTR_FILLSTYLE));
//STRIP001 
//STRIP001 //-/				pObj->NbcSetAttributes(aAttr, FALSE);
//STRIP001 				pObj->SetItemSet(aAttr);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// Default-Attr. und "Leere-Fuellung" zuweisen
//STRIP001 				SfxItemSet aAttr(*pView->GetDefaultAttr().Clone());
//STRIP001 				rAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 
//STRIP001 //-/				pObj->NbcSetAttributes(aAttr, FALSE);
//STRIP001 				pObj->SetItemSet(aAttr);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }




}
