/*************************************************************************
 *
 *  $RCSfile: sd_fuoltext.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:50:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _OUTLINER_HXX
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #endif
#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #ifndef _PSTM_HXX
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#ifndef _SVX_ITEMDATA_HXX
#include <bf_svx/itemdata.hxx>
#endif

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif

#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif

#define ITEMID_FIELD    EE_FEATURE_FIELD
// auto strip #ifndef _SVX_FLDITEM_HXX //autogen
// auto strip #include <bf_svx/flditem.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

#include <bf_svx/svxids.hrc>
#include "app.hrc"
// auto strip #include "fuoltext.hxx"
// auto strip #include "outlview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "viewshel.hxx"

#include <stdio.h>          // Fuer SlotFilter-Listing
namespace binfilter {

static USHORT SidArray[] = {
				SID_STYLE_FAMILY2,
				SID_STYLE_FAMILY5,
				SID_STYLE_UPDATE_BY_EXAMPLE,
				SID_CUT,
				SID_COPY,
				SID_PASTE,
				SID_SELECTALL,
				SID_ATTR_CHAR_FONT,
				SID_ATTR_CHAR_POSTURE,
				SID_ATTR_CHAR_WEIGHT,
				SID_ATTR_CHAR_UNDERLINE,
				SID_ATTR_CHAR_FONTHEIGHT,
				SID_ATTR_CHAR_COLOR,
				SID_OUTLINE_UP,
				SID_OUTLINE_DOWN,
				SID_OUTLINE_LEFT,
				SID_OUTLINE_RIGHT,
				//SID_OUTLINE_FORMAT,
				SID_OUTLINE_COLLAPSE_ALL,
				//SID_OUTLINE_BULLET,
				SID_OUTLINE_COLLAPSE,
				SID_OUTLINE_EXPAND_ALL,
				SID_OUTLINE_EXPAND,
				SID_SET_SUPER_SCRIPT,
				SID_SET_SUB_SCRIPT,
				SID_HYPERLINK_GETLINK,
				SID_PRESENTATION_TEMPLATES,
				SID_STATUS_PAGE,
				SID_STATUS_LAYOUT,
				SID_EXPAND_PAGE,
				SID_SUMMARY_PAGE,
				SID_PARASPACE_INCREASE,
				SID_PARASPACE_DECREASE,
				0 };

//STRIP001 TYPEINIT1( FuOutlineText, FuOutline );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuOutlineText::FuOutlineText(SdViewShell* pViewShell, SdWindow* pWindow,
//STRIP001 							 SdView* pView, SdDrawDocument* pDoc,
//STRIP001 							 SfxRequest& rReq)
//STRIP001 	   : FuOutline(pViewShell, pWindow, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 //    ERSTELLT SLOTFILTER-LISTING
//STRIP001 //    FILE* pFile = fopen("menu.dat", "w");
//STRIP001 //    fprintf(pFile, "SID_STYLE_FAMILY2,               %6d\n", SID_STYLE_FAMILY2);
//STRIP001 //    fprintf(pFile, "SID_STYLE_FAMILY5,               %6d\n", SID_STYLE_FAMILY5);
//STRIP001 //    fprintf(pFile, "SID_STYLE_UPDATE_BY_EXAMPLE,     %6d\n", SID_STYLE_UPDATE_BY_EXAMPLE);
//STRIP001 //    fprintf(pFile, "SID_CUT,                            %6d\n", SID_CUT);
//STRIP001 //    fprintf(pFile, "SID_COPY,                           %6d\n", SID_COPY);
//STRIP001 //    fprintf(pFile, "SID_PASTE,                          %6d\n", SID_PASTE);
//STRIP001 //    fprintf(pFile, "SID_SELECTALL,                      %6d\n", SID_SELECTALL);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_FONT,                 %6d\n", SID_ATTR_CHAR_FONT);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_POSTURE,              %6d\n", SID_ATTR_CHAR_POSTURE);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_WEIGHT,               %6d\n", SID_ATTR_CHAR_WEIGHT);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_UNDERLINE,            %6d\n", SID_ATTR_CHAR_UNDERLINE);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_FONTHEIGHT,           %6d\n", SID_ATTR_CHAR_FONTHEIGHT);
//STRIP001 //    fprintf(pFile, "SID_ATTR_CHAR_COLOR,                %6d\n", SID_ATTR_CHAR_COLOR);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_UP,                     %6d\n", SID_OUTLINE_UP);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_DOWN,                   %6d\n", SID_OUTLINE_DOWN);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_LEFT,                   %6d\n", SID_OUTLINE_LEFT);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_RIGHT,                  %6d\n", SID_OUTLINE_RIGHT);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_COLLAPSE_ALL,           %6d\n", SID_OUTLINE_COLLAPSE_ALL);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_COLLAPSE,               %6d\n", SID_OUTLINE_COLLAPSE);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_EXPAND_ALL,             %6d\n", SID_OUTLINE_EXPAND_ALL);
//STRIP001 //    fprintf(pFile, "SID_OUTLINE_EXPAND,                 %6d\n", SID_OUTLINE_EXPAND);
//STRIP001 //    fprintf(pFile, "SID_SET_SUPER_SCRIPT,               %6d\n", SID_SET_SUPER_SCRIPT);
//STRIP001 //    fprintf(pFile, "SID_SET_SUB_SCRIPT,                 %6d\n", SID_SET_SUB_SCRIPT);
//STRIP001 //    fprintf(pFile, "SID_PRESENTATION_TEMPLATES,         %6d\n", SID_PRESENTATION_TEMPLATES);
//STRIP001 //    fprintf(pFile, "SID_STATUS_PAGE,                    %6d\n", SID_STATUS_PAGE);
//STRIP001 //    fprintf(pFile, "SID_STATUS_LAYOUT,                  %6d\n", SID_STATUS_LAYOUT);
//STRIP001 //    fprintf(pFile, "SID_HYPERLINK_GETLINK,              %6d\n", SID_HYPERLINK_GETLINK);
//STRIP001 //    fclose(pFile);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuOutlineText::~FuOutlineText()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuOutlineText::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	pWindow->GrabFocus();
//STRIP001 
//STRIP001 	bReturn = pOutlineView->GetViewByWindow(pWindow)->MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	if (bReturn)
//STRIP001 	{
//STRIP001 		// Attributierung der akt. Textstelle kann jetzt anders sein
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bReturn = FuOutline::MouseButtonDown(rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuOutlineText::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	bReturn = pOutlineView->GetViewByWindow(pWindow)->MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		bReturn = FuOutline::MouseMove(rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001     // MT 07/2002: Done in OutlinerView::MouseMove
//STRIP001     /*
//STRIP001 	const SvxFieldItem* pFieldItem = pOutlineView->GetViewByWindow( pWindow )->
//STRIP001 										GetFieldUnderMousePointer();
//STRIP001 	const SvxFieldData* pField = NULL;
//STRIP001 	if( pFieldItem )
//STRIP001 		pField = pFieldItem->GetField();
//STRIP001 
//STRIP001 	if( pField && pField->ISA( SvxURLField ) )
//STRIP001 	{
//STRIP001 	   pWindow->SetPointer( Pointer( POINTER_REFHAND ) );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	   pWindow->SetPointer( Pointer( POINTER_TEXT ) );
//STRIP001     */
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuOutlineText::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	bReturn = pOutlineView->GetViewByWindow(pWindow)->MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	if (bReturn)
//STRIP001 	{
//STRIP001 		// Attributierung der akt. Textstelle kann jetzt anders sein
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		const SvxFieldItem* pFieldItem = pOutlineView->GetViewByWindow( pWindow )->GetFieldUnderMousePointer();
//STRIP001 		if( pFieldItem )
//STRIP001 		{
//STRIP001 			const SvxFieldData* pField = pFieldItem->GetField();
//STRIP001 
//STRIP001 			if( pField && pField->ISA( SvxURLField ) )
//STRIP001 			{
//STRIP001 				bReturn = TRUE;
//STRIP001 	            pWindow->ReleaseMouse();
//STRIP001                 SfxStringItem aStrItem( SID_FILE_NAME, ( (SvxURLField*) pField)->GetURL() );
//STRIP001                 SfxStringItem aReferer( SID_REFERER, pDocSh->GetMedium()->GetName() );
//STRIP001                 SfxBoolItem aBrowseItem( SID_BROWSE, TRUE );
//STRIP001                 SfxViewFrame* pFrame = pViewShell->GetViewFrame();
//STRIP001 
//STRIP001 				if ( rMEvt.IsMod1() )
//STRIP001 				{
//STRIP001 					// Im neuen Frame oeffnen
//STRIP001                 	pFrame->GetDispatcher()->Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
//STRIP001                     		    &aStrItem, &aBrowseItem, &aReferer, 0L);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					// Im aktuellen Frame oeffnen
//STRIP001 					SfxFrameItem aFrameItem( SID_DOCFRAME, pFrame );
//STRIP001                 	pFrame->GetDispatcher()->Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
//STRIP001                     		    &aStrItem, &aFrameItem, &aBrowseItem, &aReferer, 0L);
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bReturn )
//STRIP001 		bReturn = FuOutline::MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuOutlineText::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if( !pDocSh->IsReadOnly() ||
//STRIP001 		rKEvt.GetKeyCode().GetGroup() == KEYGROUP_CURSOR )
//STRIP001 	{
//STRIP001 		pWindow->GrabFocus();
//STRIP001 
//STRIP001 		bReturn = pOutlineView->GetViewByWindow(pWindow)->PostKeyEvent(rKEvt);
//STRIP001 
//STRIP001 		if (bReturn)
//STRIP001 		{
//STRIP001 			// Attributierung der akt. Textstelle kann jetzt anders sein
//STRIP001 			pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			bReturn = FuOutline::KeyInput(rKEvt);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuOutlineText::Activate()
//STRIP001 {
//STRIP001 	FuOutline::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuOutlineText::Deactivate()
//STRIP001 {
//STRIP001 	FuOutline::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Cut object to clipboard
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuOutlineText::DoCut()
//STRIP001 {
//STRIP001 	pOutlineView->GetViewByWindow(pWindow)->Cut();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Copy object to clipboard
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuOutlineText::DoCopy()
//STRIP001 {
//STRIP001 	pOutlineView->GetViewByWindow(pWindow)->Copy();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Paste object from clipboard
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuOutlineText::DoPaste()
//STRIP001 {
//STRIP001 	pOutlineView->GetViewByWindow(pWindow)->PasteSpecial();
//STRIP001 }




}
