/*************************************************************************
 *
 *  $RCSfile: sd_fuprlout.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:35:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//STRIP008 #pragma hdrstop

//STRIP008 #ifndef _SV_WRKWIN_HXX
//STRIP008 #include <vcl/wrkwin.hxx>
//STRIP008 #endif
//STRIP008 #ifndef _SFXDISPATCH_HXX //autogen
//STRIP008 #include <bf_sfx2/dispatch.hxx>
//STRIP008 #endif
//STRIP008 #ifndef _SFXSMPLHINT_HXX //autogen
//STRIP001 #include <svtools/smplhint.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXITEMPOOL_HXX //autogen
//STRIP001 #include <svtools/itempool.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVSTOR_HXX //autogen
//STRIP001 #include <so3/svstor.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVDUNDO_HXX //autogen
//STRIP001 #include <bf_svx/svdundo.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "fuprlout.hxx"
//STRIP001 #include "drawdoc.hxx"
//STRIP001 #include "sdpage.hxx"
//STRIP001 #include "pres.hxx"
//STRIP001 #include "drviewsh.hxx"
//STRIP001 #include "frmview.hxx"
//STRIP001 #include "stlpool.hxx"
//STRIP001 #include "sdview.hxx"
//STRIP001 #include "glob.hrc"
//STRIP001 #include "glob.hxx"
//STRIP001 #include "strings.hrc"
//STRIP001 #include "strmname.h"
//STRIP001 #include "app.hrc"
//STRIP001 #include "docshell.hxx"
//STRIP001 #include "unprlout.hxx"
//STRIP001 #include "unchss.hxx"
//STRIP001 #include "unmovss.hxx"
//STRIP001 #include "sdattr.hxx"
//STRIP001 #include "sdresid.hxx"
//STRIP001 #include "sdpreslt.hxx"
//STRIP001 #include "drawview.hxx"
//STRIP001 #include "eetext.hxx"
//STRIP001 #include <bf_svx/editdata.hxx>

//STRIP001 #ifndef SO2_DECL_SVSTORAGE_DEFINED
//STRIP001 #define SO2_DECL_SVSTORAGE_DEFINED
//STRIP001 SO2_DECL_REF(SvStorage)
//STRIP001 #endif
//STRIP001 
//STRIP001 TYPEINIT1( FuPresentationLayout, FuPoor );
//STRIP001 
//STRIP001 #define POOL_BUFFER_SIZE		(USHORT)32768
//STRIP001 #define DOCUMENT_BUFFER_SIZE	(USHORT)32768
//STRIP001 #define DOCUMENT_TOKEN (sal_Unicode('#'))
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuPresentationLayout::FuPresentationLayout(SdViewShell* pViewSh,
//STRIP001 										   SdWindow* pWin, SdView* pView,
//STRIP001 										   SdDrawDocument* pDoc,
//STRIP001 										   SfxRequest& rReq)
//STRIP001 	 : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 
//STRIP001 {
//STRIP001 	// damit nicht Objekte, die gerade editiert werden oder selektiert
//STRIP001 	// sind , verschwinden
//STRIP001 	pView->EndTextEdit();
//STRIP001 
//STRIP001 	USHORT nPgViewCount = pView->GetPageViewCount();
//STRIP001 	for (USHORT nPgView = 0; nPgView < nPgViewCount; nPgView++)
//STRIP001 	{
//STRIP001 		pView->UnmarkAll();
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bError = FALSE;
//STRIP001 
//STRIP001 	// die aktive Seite ermitteln
//STRIP001 	USHORT nSelectedPage = SDRPAGE_NOTFOUND;
//STRIP001 	for (USHORT nPage = 0; nPage < pDoc->GetSdPageCount(PK_STANDARD); nPage++)
//STRIP001 	{
//STRIP001 		if (pDoc->GetSdPage(nPage, PK_STANDARD)->IsSelected())
//STRIP001 		{
//STRIP001 			nSelectedPage = nPage;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	DBG_ASSERT(nSelectedPage != SDRPAGE_NOTFOUND, "keine selektierte Seite");
//STRIP001 	SdPage* pSelectedPage = pDoc->GetSdPage(nSelectedPage, PK_STANDARD);
//STRIP001 	String aOldPageLayoutName(pSelectedPage->GetLayoutName());
//STRIP001 	String aOldLayoutName(aOldPageLayoutName);
//STRIP001 	aOldLayoutName.Erase(aOldLayoutName.SearchAscii(SD_LT_SEPARATOR));
//STRIP001 
//STRIP001 	// wenn wir auf einer Masterpage sind, gelten die Aenderungen fuer alle
//STRIP001 	// Seiten und Notizseiten, die das betreffende Layout benutzen
//STRIP001 	BOOL bOnMaster = FALSE;
//STRIP001 	if (pViewSh->ISA(SdDrawViewShell))
//STRIP001 	{
//STRIP001 		EditMode eEditMode = ((SdDrawViewShell*)pViewSh)->GetEditMode();
//STRIP001 		if (eEditMode == EM_MASTERPAGE)
//STRIP001 			bOnMaster = TRUE;
//STRIP001 	}
//STRIP001 	BOOL bMasterPage = bOnMaster;
//STRIP001 	BOOL bCheckMasters = FALSE;
//STRIP001 
//STRIP001 	// Dialog aufrufen
//STRIP001 	BOOL   bLoad = FALSE;			// tauchen neue Masterpages auf?
//STRIP001 	String aFile;
//STRIP001 	SfxItemSet aSet(pDoc->GetPool(), ATTR_PRESLAYOUT_START, ATTR_PRESLAYOUT_END);
//STRIP001 
//STRIP001 	aSet.Put( SfxBoolItem( ATTR_PRESLAYOUT_LOAD, bLoad));
//STRIP001 	aSet.Put( SfxBoolItem( ATTR_PRESLAYOUT_MASTER_PAGE, bMasterPage ) );
//STRIP001 	aSet.Put( SfxBoolItem( ATTR_PRESLAYOUT_CHECK_MASTERS, bCheckMasters ) );
//STRIP001 	aSet.Put( SfxStringItem( ATTR_PRESLAYOUT_NAME, aOldLayoutName));
//STRIP001 
//STRIP001 	SdPresLayoutDlg* pDlg = new SdPresLayoutDlg( pDocSh, pViewSh, NULL, aSet);
//STRIP001 	USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 	switch (nResult)
//STRIP001 	{
//STRIP001 		case RET_OK:
//STRIP001 		{
//STRIP001 			pDlg->GetAttr(aSet);
//STRIP001 			if (aSet.GetItemState(ATTR_PRESLAYOUT_LOAD) == SFX_ITEM_SET)
//STRIP001 				bLoad = ((SfxBoolItem&)aSet.Get(ATTR_PRESLAYOUT_LOAD)).GetValue();
//STRIP001 			if( aSet.GetItemState( ATTR_PRESLAYOUT_MASTER_PAGE ) == SFX_ITEM_SET )
//STRIP001 				bMasterPage = ( (SfxBoolItem&) aSet.Get( ATTR_PRESLAYOUT_MASTER_PAGE ) ).GetValue();
//STRIP001 			if( aSet.GetItemState( ATTR_PRESLAYOUT_CHECK_MASTERS ) == SFX_ITEM_SET )
//STRIP001 				bCheckMasters = ( (SfxBoolItem&) aSet.Get( ATTR_PRESLAYOUT_CHECK_MASTERS ) ).GetValue();
//STRIP001 			if (aSet.GetItemState(ATTR_PRESLAYOUT_NAME) == SFX_ITEM_SET)
//STRIP001 				aFile = ((SfxStringItem&)aSet.Get(ATTR_PRESLAYOUT_NAME)).GetValue();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			bError = TRUE;
//STRIP001 	}
//STRIP001 	delete pDlg;
//STRIP001 
//STRIP001 	if (!bError)
//STRIP001 	{
//STRIP001 		pDocSh->SetWaitCursor( TRUE );
//STRIP001 
//STRIP001 		// Hier werden nur Masterpages ausgewechselt, d.h. die aktuelle Seite
//STRIP001 		// bleibt aktuell. Damit beim Ein- und Ausfuegen der Masterpages nicht
//STRIP001 		// dauernd via PageOrderChangedHint die Methode ResetActualPage gerufen
//STRIP001 		// wird, wird jetzt blockiert.
//STRIP001 		// That isn't quitely right. If the masterpageview is active and you are
//STRIP001 		// removing a masterpage, it's possible that you are removing the
//STRIP001 		// current masterpage. So you have to call ResetActualPage !
//STRIP001 		if( pViewShell->ISA(SdDrawViewShell) && !bCheckMasters )
//STRIP001 			((SdDrawView*)pView)->BlockPageOrderChangedHint(TRUE);
//STRIP001 
//STRIP001 		if (bLoad)
//STRIP001 		{
//STRIP001 			String aFileName = aFile.GetToken( 0, DOCUMENT_TOKEN );
//STRIP001 			SdDrawDocument* pTempDoc = pDoc->OpenBookmarkDoc( aFileName );
//STRIP001 
//STRIP001 			// #69581: If I chosed the standard-template I got no filename and so I get no
//STRIP001 			//         SdDrawDocument-Pointer. But the method SetMasterPage is able to handle
//STRIP001 			//         a NULL-pointer as a Standard-template ( look at SdDrawDocument::SetMasterPage )
//STRIP001 			String aLayoutName;
//STRIP001 			if( pTempDoc )
//STRIP001 				aLayoutName = aFile.GetToken( 1, DOCUMENT_TOKEN );
//STRIP001 
//STRIP001 			pDoc->SetMasterPage(nSelectedPage, aLayoutName, pTempDoc, bMasterPage, bCheckMasters);
//STRIP001 			pDoc->CloseBookmarkDoc();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// MasterPage mit dem LayoutNamen aFile aus aktuellem Doc verwenden
//STRIP001 			pDoc->SetMasterPage(nSelectedPage, aFile, pDoc, bMasterPage, bCheckMasters);
//STRIP001 		}
//STRIP001 
//STRIP001 		// Blockade wieder aufheben
//STRIP001 		if (pViewShell->ISA(SdDrawViewShell) && !bCheckMasters )
//STRIP001 			((SdDrawView*)pView)->BlockPageOrderChangedHint(FALSE);
//STRIP001 
//STRIP001 		/*************************************************************************
//STRIP001 		|* Falls dargestellte Masterpage sichtbar war, neu darstellen
//STRIP001 		\************************************************************************/
//STRIP001 		if (!bError && nSelectedPage != SDRPAGE_NOTFOUND)
//STRIP001 		{
//STRIP001 			if (bOnMaster)
//STRIP001 			{
//STRIP001 				if (pViewShell->ISA(SdDrawViewShell))
//STRIP001 				{
//STRIP001 					SdView* pView = ((SdDrawViewShell*)pViewShell)->GetView();
//STRIP001 					USHORT nPgNum = pSelectedPage->GetMasterPage(0)->GetPageNum();
//STRIP001 
//STRIP001 					if (((SdDrawViewShell*)pViewShell)->GetPageKind() == PK_NOTES)
//STRIP001 						nPgNum++;
//STRIP001 
//STRIP001 					pView->HideAllPages();
//STRIP001 					pView->ShowMasterPagePgNum(nPgNum, Point());
//STRIP001 				}
//STRIP001 
//STRIP001 				// damit TabBar aktualisiert wird
//STRIP001 				pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_MASTERPAGE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pSelectedPage->SetAutoLayout(pSelectedPage->GetAutoLayout());
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		// fake a mode change to repaint the page tab bar
//STRIP001 		if( pViewShell && pViewShell->ISA( SdDrawViewShell ) )
//STRIP001 		{
//STRIP001 			SdDrawViewShell* pDrawViewSh = (SdDrawViewShell*)pViewShell;
//STRIP001 			EditMode eMode = pDrawViewSh->GetEditMode();
//STRIP001 			BOOL bLayer = pDrawViewSh->GetLayerMode();
//STRIP001 			pDrawViewSh->ChangeEditMode( eMode, !bLayer );
//STRIP001 			pDrawViewSh->ChangeEditMode( eMode, bLayer );
//STRIP001 		}
//STRIP001 
//STRIP001 		pDocSh->SetWaitCursor( FALSE );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuPresentationLayout::~FuPresentationLayout()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Layoutvorlage von einem StyleSheetPool in einen anderen uebertragen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuPresentationLayout::TransferLayoutTemplate(String aFromName,
//STRIP001 												  String aToName,
//STRIP001 												  SfxStyleSheetBasePool* pFrom,
//STRIP001 												  SfxStyleSheetBasePool* pTo)
//STRIP001 {
//STRIP001 	SfxStyleSheetBase* pHis = pFrom->Find(aFromName,SD_LT_FAMILY);
//STRIP001 	SfxStyleSheetBase* pMy	= pTo->Find(aToName, SD_LT_FAMILY);
//STRIP001 
//STRIP001 	DBG_ASSERT(pHis, "neue Layoutvorlage nicht gefunden");
//STRIP001 
//STRIP001 	// gibt's noch nicht: neu anlegen
//STRIP001 	if (!pMy)
//STRIP001 	{
//STRIP001 		pMy = &(pTo->Make(aToName, SD_LT_FAMILY));
//STRIP001 	}
//STRIP001 
//STRIP001 	// Inhalte neu setzen
//STRIP001 	if (pHis)
//STRIP001 		pMy->GetItemSet().Set(pHis->GetItemSet());
//STRIP001 }


