/*************************************************************************
 *
 *  $RCSfile: sd_unslprms.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:00:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "unslprms.hxx"
// auto strip #include "sdpage.hxx"
#include "slidvish.hxx"
namespace binfilter {

using namespace ::com::sun::star;

//STRIP001 TYPEINIT1(SlideParametersUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SlideParametersUndoAction::Undo()
//STRIP001 {
//STRIP001 	pPage->SetFadeSpeed(eOldFadeSpeed);
//STRIP001 	pPage->SetFadeEffect(eOldFadeEffect);
//STRIP001 	pPage->SetPresChange(eOldChange);
//STRIP001 	pPage->SetTime(nOldTime);
//STRIP001 	pPage->SetSound(bOldSoundOn);
//STRIP001 	pPage->SetSoundFile(aOldSoundFile);
//STRIP001 
//STRIP001 	SfxViewShell* pViewShell = SfxViewShell::Current();
//STRIP001 
//STRIP001 	if (((eOldFadeEffect != presentation::FadeEffect_NONE &&
//STRIP001 		  eNewFadeEffect == presentation::FadeEffect_NONE)	 ||
//STRIP001 		 (eOldFadeEffect == presentation::FadeEffect_NONE &&
//STRIP001 		  eNewFadeEffect != presentation::FadeEffect_NONE))	 &&
//STRIP001 		pViewShell->ISA(SdSlideViewShell))
//STRIP001 	{
//STRIP001 		// PK_STANDARD Seite berechnen
//STRIP001 		USHORT		 nPageNo = (pPage->GetPageNum() - 1) / 2;
//STRIP001 		SdSlideView* pView	 = (SdSlideView*) ((SdSlideViewShell*)pViewShell)
//STRIP001 											  ->GetView();
//STRIP001 		Rectangle	 aRect	 = pView->GetFadeIconArea(nPageNo);
//STRIP001 		pView->InvalidateAllWin(aRect);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SlideParametersUndoAction::Redo()
//STRIP001 {
//STRIP001 	pPage->SetFadeSpeed(eNewFadeSpeed);
//STRIP001 	pPage->SetFadeEffect(eNewFadeEffect);
//STRIP001 	pPage->SetPresChange(eNewChange);
//STRIP001 	pPage->SetTime(nNewTime);
//STRIP001 	pPage->SetSound(bNewSoundOn);
//STRIP001 	pPage->SetSoundFile(aNewSoundFile);
//STRIP001 
//STRIP001 	SfxViewShell* pViewShell = SfxViewShell::Current();
//STRIP001 
//STRIP001 	if (((eOldFadeEffect != presentation::FadeEffect_NONE &&
//STRIP001 		  eNewFadeEffect == presentation::FadeEffect_NONE)	 ||
//STRIP001 		 (eOldFadeEffect == presentation::FadeEffect_NONE &&
//STRIP001 		  eNewFadeEffect != presentation::FadeEffect_NONE))	 &&
//STRIP001 		pViewShell->ISA(SdSlideViewShell))
//STRIP001 	{
//STRIP001 		// PK_STANDARD Seite berechnen
//STRIP001 		USHORT		 nPageNo = (pPage->GetPageNum() - 1) / 2;
//STRIP001 		SdSlideView* pView	 = (SdSlideView*) ((SdSlideViewShell*)pViewShell)
//STRIP001 											  ->GetView();
//STRIP001 		Rectangle	 aRect	 = pView->GetFadeIconArea(nPageNo);
//STRIP001 		pView->InvalidateAllWin(aRect);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SlideParametersUndoAction::Repeat()
//STRIP001 {
//STRIP001 	pPage->SetFadeSpeed(eNewFadeSpeed);
//STRIP001 	pPage->SetFadeEffect(eNewFadeEffect);
//STRIP001 	pPage->SetPresChange(eNewChange);
//STRIP001 	pPage->SetTime(nNewTime);
//STRIP001 	pPage->SetSound(bNewSoundOn);
//STRIP001 	pPage->SetSoundFile(aNewSoundFile);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SlideParametersUndoAction::~SlideParametersUndoAction()
//STRIP001 {
//STRIP001 }



}
