/*************************************************************************
 *
 *  $RCSfile: diactrl.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:36:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_DIACTRL_HXX
#define _SD_DIACTRL_HXX

#pragma hdrstop

#ifndef SD_DLGCTRLS_HXX
#include "dlgctrls.hxx"
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX
#include <bf_sfx2/bindings.hxx>
#endif
#ifndef _SVX_ITEMWIN_HXX //autogen
#include <bf_svx/itemwin.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SV_TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif

#ifndef _SFXTBXCTRL_HXX //autogen
#include <bf_sfx2/tbxctrl.hxx>
#endif
namespace binfilter {


/*************************************************************************
|*
|* Controls (Windows) fuer Diaeffekte
|*
\************************************************************************/

//========================================================================
// DiaTimeControl:

//STRIP001 class DiaTimeControl : public TimeField
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Up();
//STRIP001 	virtual void	Down();
//STRIP001 
//STRIP001 public:
//STRIP001 				DiaTimeControl( Window* pParent, SfxBindings& rBindings, WinBits nStyle = 0 );
//STRIP001 				DiaTimeControl( Window* pParent, SfxBindings& rBindings, ResId nRId );
//STRIP001 				~DiaTimeControl();
//STRIP001 
//STRIP001 	DECL_LINK( ModifyDiaTimeHdl, void * );
//STRIP001 	DECL_LINK( GetFocusHdl, void * );
//STRIP001 };
//STRIP001 
#ifdef _SD_DIACTRL_CXX
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // DiaEffectControl:
//STRIP001 
//STRIP001 class DiaEffectControl : public Window
//STRIP001 {
//STRIP001 public:
//STRIP001 	FadeEffectLB	aLbEffect;
//STRIP001 
//STRIP001 public:
//STRIP001 				DiaEffectControl( Window* pParent, SfxBindings& rBindings, WinBits nStyle = 0 );
//STRIP001 				~DiaEffectControl();
//STRIP001 
//STRIP001 	DECL_LINK( SelectDiaEffectHdl, void * );
//STRIP001 
//STRIP001 protected:
//STRIP001     /** This method is called when the window gets the focus.  It grabs the
//STRIP001         focus to this control so that it can be controlled with the
//STRIP001         keyboard. 
//STRIP001     */
//STRIP001     virtual void GetFocus (void);
//STRIP001 
//STRIP001 private:
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 	FixedText		aFtDescr;
//STRIP001 };
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // DiaSpeedControl:
//STRIP001 
//STRIP001 class DiaSpeedControl : public Window
//STRIP001 {
//STRIP001 public:
//STRIP001 	ListBox			aLbSpeed;
//STRIP001 
//STRIP001 public:
//STRIP001 				DiaSpeedControl( Window* pParent, SfxBindings& rBindings, WinBits nStyle = 0 );
//STRIP001 				~DiaSpeedControl();
//STRIP001 
//STRIP001 	DECL_LINK( SelectDiaSpeedHdl, void * );
//STRIP001 
//STRIP001 protected:
//STRIP001     /** This method is called when the window gets the focus.  It grabs the
//STRIP001         focus to this control so that it can be controlled with the
//STRIP001         keyboard. 
//STRIP001     */
//STRIP001     virtual void GetFocus (void);
//STRIP001 
//STRIP001 private:
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 };
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // DiaAutoControl:
//STRIP001 
//STRIP001 class DiaAutoControl : public Window
//STRIP001 {
//STRIP001 public:
//STRIP001 	ListBox			aLbAuto;
//STRIP001 
//STRIP001 public:
//STRIP001 				DiaAutoControl( Window* pParent, SfxBindings& rBindings, WinBits nStyle = 0 );
//STRIP001 				~DiaAutoControl();
//STRIP001 
//STRIP001 	DECL_LINK( SelectDiaAutoHdl, void * );
//STRIP001 
//STRIP001 protected:
//STRIP001     /** This method is called when the window gets the focus.  It grabs the
//STRIP001         focus to this control so that it can be controlled with the
//STRIP001         keyboard. 
//STRIP001     */
//STRIP001     virtual void GetFocus (void);
//STRIP001 
//STRIP001 private:
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 	FixedText		aFtDescr;
//STRIP001 };
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // SdPagesField:
//STRIP001 
//STRIP001 class SdPagesField : public SvxMetricField
//STRIP001 {
//STRIP001 private:
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 protected:
//STRIP001 	virtual void 	Modify();
//STRIP001 
//STRIP001 public:
//STRIP001 					SdPagesField( Window* pParent, SfxBindings& rBindings,
//STRIP001 						WinBits nBits = WB_BORDER | WB_SPIN | WB_REPEAT );
//STRIP001 					~SdPagesField();
//STRIP001 
//STRIP001 	void			Update( const SfxUInt16Item* pItem );
//STRIP001 };


/*************************************************************************
|*
|* Toolbox-Controller fuer Diaeffekte
|*
\************************************************************************/

class SdTbxCtlDiaEffect: public SfxToolBoxControl
{
public:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 	virtual Window*		CreateItemWindow( Window *pParent );
//STRIP001 
			SFX_DECL_TOOLBOX_CONTROL();
//STRIP001 
			SdTbxCtlDiaEffect( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );
//STRIP001 			~SdTbxCtlDiaEffect() {}
};

class SdTbxCtlDiaSpeed: public SfxToolBoxControl
{
public:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 	virtual Window*		CreateItemWindow( Window *pParent );
//STRIP001 
			SFX_DECL_TOOLBOX_CONTROL();
//STRIP001 
			SdTbxCtlDiaSpeed( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );
//STRIP001 			~SdTbxCtlDiaSpeed() {}
};

class SdTbxCtlDiaAuto: public SfxToolBoxControl
{
public: 
//STRIP001     virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 	virtual Window*		CreateItemWindow( Window *pParent );
//STRIP001 
			SFX_DECL_TOOLBOX_CONTROL();

			SdTbxCtlDiaAuto( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );
//STRIP001 			~SdTbxCtlDiaAuto() {}
};

class SdTbxCtlDiaTime: public SfxToolBoxControl
{
public:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 	virtual Window*		CreateItemWindow( Window *pParent );
//STRIP001 
			SFX_DECL_TOOLBOX_CONTROL();

			SdTbxCtlDiaTime( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );
//STRIP001 			~SdTbxCtlDiaTime() {}
};

//========================================================================
// SdTbxCtlDiaPages:
//========================================================================

class SdTbxCtlDiaPages : public SfxToolBoxControl
{
//STRIP001 protected:
//STRIP001 	SfxBindings& 		rBindings;
//STRIP001 
public:
//STRIP001 	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 									  const SfxPoolItem* pState );
//STRIP001 	virtual Window*		CreateItemWindow( Window *pParent );

	SFX_DECL_TOOLBOX_CONTROL();

	SdTbxCtlDiaPages( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
//STRIP001 	~SdTbxCtlDiaPages();
};

#endif // _SD_DIACTRL_CXX

} //namespace binfilter
#endif // _SD_TBXCTRLS_HXX



