/*************************************************************************
 *
 *  $RCSfile: fuslsel.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//STRIP001 #ifndef _SD_FUSLSEL_HXX
//STRIP001 #define _SD_FUSLSEL_HXX

//STRIP001 #ifndef _SD_FUSLID_HXX
//STRIP001 #include "fuslid.hxx"
//STRIP001 #endif

//STRIP001 class SdSlideViewShell;
//STRIP001 class SdWindow;
//STRIP001 class SdSlideView;
//STRIP001 class SdDrawDocument;
//STRIP001 class Sound;
//STRIP001 
//STRIP001 struct FSS_IsShowingEffectInfo
//STRIP001 {
//STRIP001 	BOOL bIsShowingEffect;			// TRUE while we show a fade effect one the slide view
//STRIP001 	BOOL bDisposed;					// TRUE if the FuSlideSelection was deleted during fade effect
//STRIP001 };
//STRIP001 
//STRIP001 class FuSlideSelection : public FuSlide
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	BOOL		                bSubstShown;
//STRIP001 	BOOL		                bPageHit;
//STRIP001 	List		                aSubstList;		  // Liste mit Ertsatzdarstellungen
//STRIP001 	Point		                aDragPos;			  // hier wird die Seite angefasst
//STRIP001 	BOOL		                bDragSelection;
//STRIP001 	Point		                aDragSelRectAnchor;  // fester Punkt des Selektionsrechtecks
//STRIP001 	Rectangle	                aDragSelRect;
//STRIP001 	Point		                aPosOfInsertMarker;
//STRIP001     Sound*		                pSound;
//STRIP001 	FSS_IsShowingEffectInfo*	pIsShowingEffectInfo;
//STRIP001 
//STRIP001 	void                        DrawInsertMarker(BOOL bShow);
//STRIP001 	Point                       CalcPosOfInsertMarker(const Point& rPoint);
//STRIP001 
//STRIP001 	USHORT                      GetTargetPage(const Point& rPoint) const;
//STRIP001 
//STRIP001 	void                        CreateSubst();
//STRIP001 	void                        DeleteSubst();
//STRIP001 	void                        DrawSubst() const;
//STRIP001 	void                        ChangeSubstPos(const Point& rVector);
//STRIP001 	void                        DrawDragSelectionRect() const;
//STRIP001 	void                        ShowEffect(USHORT nPageNo);
//STRIP001 
//STRIP001 	                            DECL_LINK( DragSlideHdl, Timer* );
//STRIP001 
//STRIP001 public:
//STRIP001 	                            
//STRIP001                                 TYPEINFO();
//STRIP001 
//STRIP001 	                            FuSlideSelection( SdSlideViewShell* pViewSh, SdWindow* pWin,
//STRIP001 					                              SdSlideView* pView, SdDrawDocument* pDoc,
//STRIP001 					                              SfxRequest& rReq );
//STRIP001                                 
//STRIP001 	virtual                     ~FuSlideSelection();
//STRIP001 					            				   // Mouse- & Key-Events
//STRIP001 	virtual BOOL                KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual BOOL                MouseMove(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL                MouseButtonUp(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL                MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 	virtual void                Paint(const Rectangle& rRect, SdWindow* pWin);
//STRIP001                                 
//STRIP001 	virtual void                Activate();		   // Function aktivieren
//STRIP001 	virtual void                Deactivate();		   // Function deaktivieren
//STRIP001                                 
//STRIP001 	virtual void                ScrollStart();
//STRIP001 	virtual void                ScrollEnd();
//STRIP001                                 
//STRIP001 	BOOL                        IsShowingEffect() const { return pIsShowingEffectInfo && pIsShowingEffectInfo->bIsShowingEffect; }
//STRIP001 
//STRIP001 	/** is called when the currenct function should be aborted. <p>
//STRIP001 		This is used when a function gets a KEY_ESCAPE but can also
//STRIP001 		be called directly.
//STRIP001 
//STRIP001 		@returns true if a active function was aborted
//STRIP001 	*/
//STRIP001 	virtual bool cancel();
//STRIP001 };



//STRIP001 #endif		// _SD_FUSLSEL_HXX

