/*************************************************************************
 *
 *  $RCSfile: sdxfer.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:40:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_SDXFER_HXX
#define _SD_SDXFER_HXX

#ifndef _TRANSFER_HXX
#include <svtools/transfer.hxx>
#endif
#ifndef _EMBOBJ_HXX //autogen
#include <so3/embobj.hxx>
#endif
#ifndef _SV_GRAPH_HXX //autogen
#include <vcl/graph.hxx>
#endif
class ImageMap;
class VirtualDevice;
namespace binfilter {

// ------------------
// - SdTransferable -
// ------------------

class SdView;
class SdDrawDocument;
class INetBookmark;
class SdDrawDocShell;

class SdTransferable : public TransferableHelper
{
//STRIP001 private:

//STRIP001 	SvEmbeddedObjectRef				aDocShellRef;
//STRIP001     SdDrawDocShell*                 pPageDocShell;
//STRIP001     List                            aPageBookmarks;
//STRIP001 	TransferableDataHelper*			pOLEDataHelper;
//STRIP001 	TransferableObjectDescriptor*	pObjDesc;
//STRIP001 	const SdView* 					pSdView;
//STRIP001 	SdView* 						pSdViewIntern;
//STRIP001 	SdDrawDocument* 				pSdDrawDocument;
//STRIP001 	SdDrawDocument* 				pSdDrawDocumentIntern;
//STRIP001 	SdDrawDocument* 				pSourceDoc;
//STRIP001 	VirtualDevice*					pVDev;
//STRIP001 	INetBookmark*	  				pBookmark;
//STRIP001 	Graphic*						pGraphic;
//STRIP001 	ImageMap*						pImageMap;
//STRIP001 	Rectangle						aVisArea;
//STRIP001 	Point							aStartPos;
//STRIP001 	BOOL							bInternalMove               : 1;
//STRIP001 	BOOL							bOwnDocument                : 1;
//STRIP001 	BOOL							bOwnView                    : 1;
//STRIP001 	BOOL							bLateInit                   : 1;
//STRIP001     BOOL                            bPageTransferable           : 1;
//STRIP001     BOOL                            bPageTransferablePersistent : 1;
//STRIP001 	bool							mbIsUnoObj					: 1;
//STRIP001 
//STRIP001 									// not available
//STRIP001 									SdTransferable();
//STRIP001 									SdTransferable( const SdTransferable& );
//STRIP001 	SdTransferable&					operator=( const SdTransferable& );
//STRIP001 									
//STRIP001 	void							CreateObjectReplacement( SdrObject* pObj );
//STRIP001 	void							CreateData();
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void					AddSupportedFormats();
//STRIP001 	virtual sal_Bool				GetData( const ::com::sun::star::datatransfer::DataFlavor& rFlavor );
//STRIP001 	virtual sal_Bool				WriteObject( SotStorageStreamRef& rxOStm, void* pUserObject, sal_uInt32 nUserObjectId, const ::com::sun::star::datatransfer::DataFlavor& rFlavor );
//STRIP001 	virtual void					DragFinished( sal_Int8 nDropAction );
//STRIP001 	virtual void					ObjectReleased();
//STRIP001 
//STRIP001     virtual sal_Int64 SAL_CALL      getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& rId ) throw( ::com::sun::star::uno::RuntimeException );
									
public:								
									
//STRIP001 									SdTransferable( SdDrawDocument* pSrcDoc, SdView* pWorkView, BOOL bInitOnGetData );
//STRIP001 									~SdTransferable();
//STRIP001 
//STRIP001 	void							SetDocShell( const SvEmbeddedObjectRef& rRef ) { aDocShellRef = rRef; }
//STRIP001 	const SvEmbeddedObjectRef&		GetDocShell() const { return aDocShellRef; }
//STRIP001 									
//STRIP001 	void							SetWorkDocument( const SdDrawDocument* pWorkDoc ) { pSdDrawDocument = pSdDrawDocumentIntern = (SdDrawDocument*) pWorkDoc; }
//STRIP001 	const SdDrawDocument*			GetWorkDocument() const { return pSdDrawDocument; }
//STRIP001 									
//STRIP001 	void							SetView( const SdView* pView ) { pSdView = pView; }
	const SdView*					GetView() const {DBG_BF_ASSERT(0, "STRIP");return NULL; } //STRIP001 const SdView*					GetView() const { return pSdView; }
									
//STRIP001 	void							SetObjectDescriptor( const TransferableObjectDescriptor& rObjDesc );
									
//STRIP001 	void							SetStartPos( const Point& rStartPos ) { aStartPos = rStartPos; }
//STRIP001 	const Point&					GetStartPos() const { return aStartPos; }
									
//STRIP001 	void							SetInternalMove( BOOL bSet ) { bInternalMove = bSet; }
//STRIP001 	BOOL							IsInternalMove() const { return bInternalMove; }
									
//STRIP001 	BOOL							HasSourceDoc( const SdDrawDocument* pDoc ) const { return( pSourceDoc == pDoc ); }

//STRIP001 	void							SetPageBookmarks( const List& rPageBookmarks, BOOL bPersistent );
//STRIP001     BOOL                            IsPageTransferable() const { return bPageTransferable; }
//STRIP001     BOOL                            HasPageBookmarks() const { return( pPageDocShell && ( aPageBookmarks.Count() > 0 ) ); }
//STRIP001     const List&                     GetPageBookmarks() const { return aPageBookmarks; }
//STRIP001 	SdDrawDocShell*         		GetPageDocShell() const { return pPageDocShell; }

//STRIP001 public:

//STRIP001 	static const ::com::sun::star::uno::Sequence< sal_Int8 >& getUnoTunnelId();
//STRIP001     static SdTransferable*          getImplementation( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& rxData ) throw();
};

} //namespace binfilter
#endif // _SD_SDXFER_HXX
