/*************************************************************************
 *
 *  $RCSfile: sd_sdview4.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:19:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _UNOTOOLS_LOCALFILEHELPER_HXX
// auto strip #include <unotools/localfilehelper.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_DOCFILT_HACK_HXX //autogen
// auto strip #include <bf_sfx2/docfilt.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_FCONTNR_HXX //autogen
// auto strip #include <bf_sfx2/fcontnr.hxx>
// auto strip #endif

#ifndef _XDEF_HXX
#include <bf_svx/xdef.hxx>
#endif

// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SV_SOUND_HXX //autogen
// auto strip #include <vcl/sound.hxx>
// auto strip #endif
// auto strip #ifndef _URLBMK_HXX //autogen
// auto strip #include <svtools/urlbmk.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FILLITEM_HXX //autogen
// auto strip #include <bf_svx/xfillit.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _XOUTBMP_HXX //autogen
// auto strip #include <bf_svx/xoutbmp.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOOLE2_HXX
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif
// auto strip #ifndef _IMPGRF_HXX
// auto strip #include <bf_svx/impgrf.hxx>
// auto strip #endif
// auto strip #ifndef _SVSTOR_HXX //autogen
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif

#include "app.hrc"
// auto strip #include "sdwindow.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "graphpro.hxx"
// auto strip #include "fuinsfil.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdresid.hxx"
#include "strings.hrc"
// auto strip #include "imapinfo.hxx"
// auto strip #include "sdpage.hxx"
#include "sdview.hxx"
// auto strip #include "slidview.hxx"
namespace binfilter {

#ifdef WNT
#pragma optimize ( "", off )
#endif

/*************************************************************************
|*
|* Graphik einfuegen
|* Wird ein leeres Graphikobjekt uebergeben, so wird dieses gefuellt.
|* Andernfalls wird ein an der gegebenen Position vorhandenes Objekt
|* gefuellt. Ist an der Position kein Objekt vorhanden, so wird ein neues
|* Objekt erzeugt und ein Pointer auf dieses Objekt zurueckgegeben.
|*
\************************************************************************/

//STRIP001 SdrGrafObj* SdView::InsertGraphic( const Graphic& rGraphic, sal_Int8& rAction,
//STRIP001 								   const Point& rPos, SdrObject* pObj, ImageMap* pImageMap )
//STRIP001 {
//STRIP001 	EndTextEdit();
//STRIP001 	nAction = rAction;
//STRIP001 
//STRIP001 	// Liegt ein Objekt an der Position rPos?
//STRIP001 	SdrGrafObj*		pNewGrafObj = NULL;
//STRIP001 	SdrPageView*	pPV = GetPageViewPvNum(0);
//STRIP001 	SdrObject*		pPickObj = pObj;
//STRIP001 
//STRIP001 	if( this->ISA( SdSlideView ) )
//STRIP001 		pPV = HitPage( rPos );
//STRIP001 
//STRIP001 	if( !pPickObj && pPV )
//STRIP001 	{
//STRIP001 		SdrPageView* pPageView = pPV;
//STRIP001 		PickObj(rPos, pPickObj, pPageView);
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nAction == DND_ACTION_LINK && pPickObj && pPV )
//STRIP001 	{
//STRIP001 		if( pPickObj->ISA( SdrGrafObj ) )
//STRIP001 		{
//STRIP001 			// Das Objekt wird mit der Bitmap gefuellt
//STRIP001 			pNewGrafObj = (SdrGrafObj*) pPickObj->Clone();
//STRIP001 			pNewGrafObj->SetGraphic(rGraphic);
//STRIP001 
//STRIP001 			if ( pNewGrafObj->IsEmptyPresObj() )
//STRIP001 			{
//STRIP001 				Rectangle aRect( pNewGrafObj->GetLogicRect() );
//STRIP001 				pNewGrafObj->AdjustToMaxRect( aRect, FALSE );
//STRIP001 				pNewGrafObj->SetOutlinerParaObject(NULL);
//STRIP001 				pNewGrafObj->SetEmptyPresObj(FALSE);
//STRIP001 			}
//STRIP001 
//STRIP001 			SdPage* pPage = (SdPage*) pPickObj->GetPage();
//STRIP001 
//STRIP001 			if (pPage && pPage->GetPresObjKind(pPickObj) == PRESOBJ_GRAPHIC)
//STRIP001 			{
//STRIP001 				// Neues PresObj in die Liste eintragen
//STRIP001 				pNewGrafObj->SetUserCall(pPickObj->GetUserCall());
//STRIP001 				pPage->GetPresObjList()->Remove(pPickObj);
//STRIP001 				pPage->GetPresObjList()->Insert(pNewGrafObj, LIST_APPEND);
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pImageMap)
//STRIP001 				pNewGrafObj->InsertUserData(new SdIMapInfo(*pImageMap));
//STRIP001 
//STRIP001 			BegUndo(String(SdResId(STR_UNDO_DRAGDROP)));
//STRIP001 			ReplaceObject(pPickObj, *pPV, pNewGrafObj);
//STRIP001 			EndUndo();
//STRIP001 		}
//STRIP001 		else if (pPickObj->IsClosedObj() && !pPickObj->ISA(SdrOle2Obj))
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Das Objekt wird mit der Graphik gefuellt
//STRIP001 			******************************************************************/
//STRIP001 			BegUndo(String(SdResId(STR_UNDO_DRAGDROP)));
//STRIP001 			AddUndo(new SdrUndoAttrObj(*pPickObj));
//STRIP001 			EndUndo();
//STRIP001 
//STRIP001 			XOBitmap aXOBitmap( rGraphic.GetBitmap() );
//STRIP001 			SfxItemSet aSet(pDocSh->GetPool(), XATTR_FILLSTYLE, XATTR_FILLBITMAP);
//STRIP001 			aSet.Put(XFillStyleItem(XFILL_BITMAP));
//STRIP001 			aSet.Put(XFillBitmapItem(&pDocSh->GetPool(), aXOBitmap));
//STRIP001 			pPickObj->SetItemSetAndBroadcast(aSet);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( pPV )
//STRIP001 	{
//STRIP001 		// create  new object
//STRIP001 		Size aSize;
//STRIP001 		
//STRIP001 		if ( rGraphic.GetPrefMapMode().GetMapUnit() == MAP_PIXEL )
//STRIP001 			aSize = pViewSh->GetActiveWindow()->PixelToLogic( rGraphic.GetPrefSize(), MAP_100TH_MM );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aSize = OutputDevice::LogicToLogic( rGraphic.GetPrefSize(),
//STRIP001 											    rGraphic.GetPrefMapMode(),
//STRIP001 											    MapMode( MAP_100TH_MM ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		pNewGrafObj = new SdrGrafObj( rGraphic, Rectangle( rPos, aSize ) );
//STRIP001 		SdrPage* pPage = pPV->GetPage();
//STRIP001 		Size aPageSize( pPage->GetSize() );
//STRIP001 		aPageSize.Width()  -= pPage->GetLftBorder() + pPage->GetRgtBorder();
//STRIP001 		aPageSize.Height() -= pPage->GetUppBorder() + pPage->GetLwrBorder();
//STRIP001 		pNewGrafObj->AdjustToMaxRect( Rectangle( pPV->GetOffset(), aPageSize ), TRUE );
//STRIP001 
//STRIP001 		ULONG	nOptions = SDRINSERT_SETDEFLAYER;
//STRIP001 		BOOL	bIsPresTarget = FALSE;
//STRIP001 		
//STRIP001 		if ((pViewSh && pViewSh->GetIPClient() && pViewSh->GetIPClient()->IsInPlaceActive()) || this->ISA(SdSlideView))
//STRIP001 			nOptions |= SDRINSERT_DONTMARK;
//STRIP001 
//STRIP001 		if( ( nAction & DND_ACTION_MOVE ) && pPickObj && (pPickObj->IsEmptyPresObj() || pPickObj->GetUserCall()) )
//STRIP001 		{
//STRIP001 			SdPage* pPage = (SdPage*) pPickObj->GetPage();
//STRIP001 		
//STRIP001 			if ( pPage && pPage->IsMasterPage() )
//STRIP001 				bIsPresTarget = pPage->GetPresObjList()->GetPos(pPickObj) != LIST_ENTRY_NOTFOUND;
//STRIP001 		}
//STRIP001 
//STRIP001 		if( ( nAction & DND_ACTION_MOVE ) && pPickObj && !bIsPresTarget )
//STRIP001 		{
//STRIP001 			// replace object
//STRIP001 			if (pImageMap)
//STRIP001 				pNewGrafObj->InsertUserData(new SdIMapInfo(*pImageMap));
//STRIP001 
//STRIP001 			Rectangle aPickObjRect(pPickObj->GetBoundRect());
//STRIP001 			Size aPickObjSize(aPickObjRect.GetSize());
//STRIP001 			Rectangle aObjRect(pNewGrafObj->GetBoundRect());
//STRIP001 			Size aObjSize(aObjRect.GetSize());
//STRIP001 
//STRIP001 			Fraction aScaleWidth(aPickObjSize.Width(), aObjSize.Width());
//STRIP001 			Fraction aScaleHeight(aPickObjSize.Height(), aObjSize.Height());
//STRIP001 			pNewGrafObj->NbcResize(aObjRect.TopLeft(), aScaleWidth, aScaleHeight);
//STRIP001 
//STRIP001 			Point aVec = aPickObjRect.TopLeft() - aObjRect.TopLeft();
//STRIP001 			pNewGrafObj->NbcMove(Size(aVec.X(), aVec.Y()));
//STRIP001 
//STRIP001 			BegUndo(String(SdResId(STR_UNDO_DRAGDROP)));
//STRIP001 			pNewGrafObj->NbcSetLayer(pPickObj->GetLayer());
//STRIP001 			SdrPage* pPage = pPV->GetPage();
//STRIP001 			pPage->InsertObject(pNewGrafObj);
//STRIP001 			AddUndo(new SdrUndoNewObj(*pNewGrafObj));
//STRIP001 			AddUndo(new SdrUndoDelObj(*pPickObj));
//STRIP001 			pPage->RemoveObject(pPickObj->GetOrdNum());
//STRIP001 			EndUndo();
//STRIP001 			nAction = DND_ACTION_COPY;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			InsertObject(pNewGrafObj, *pPV, nOptions);
//STRIP001 
//STRIP001 			if( pImageMap )
//STRIP001 				pNewGrafObj->InsertUserData(new SdIMapInfo(*pImageMap));
//STRIP001 		}
//STRIP001 	}
//STRIP001 	
//STRIP001 	rAction = nAction;
//STRIP001 	
//STRIP001 	return pNewGrafObj;
//STRIP001 }

/*************************************************************************
|*
|* Timer-Handler fuer InsertFile beim Drop()
|*
\************************************************************************/

IMPL_LINK( SdView, DropInsertFileHdl, Timer*, pTimer )
{
    DBG_BF_ASSERT(0, "STRIP"); //STRIP001 ::std::vector< String >::const_iterator aIter( aDropFileVector.begin() );
//STRIP001 
//STRIP001     while( aIter != aDropFileVector.end() )
//STRIP001     {
//STRIP001 	    String          aCurrentDropFile( *aIter );
//STRIP001         INetURLObject   aURL( aCurrentDropFile );
//STRIP001 	    BOOL		    bOK = FALSE;
//STRIP001 
//STRIP001 	    if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
//STRIP001 	    {
//STRIP001 		    String aURLStr;
//STRIP001 		    ::utl::LocalFileHelper::ConvertPhysicalNameToURL( aCurrentDropFile, aURLStr );
//STRIP001 		    aURL = INetURLObject( aURLStr );
//STRIP001 	    }
//STRIP001 	    
//STRIP001         GraphicFilter*  pGraphicFilter = GetGrfFilter();
//STRIP001 	    Graphic			aGraphic;
//STRIP001 
//STRIP001         aCurrentDropFile = aURL.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 	    
//STRIP001 		if( !Sound::IsSoundFile( aCurrentDropFile ) )
//STRIP001 		{
//STRIP001 		    FilterProgress* pFilterProgress = new FilterProgress( pGraphicFilter, pViewSh->GetDocSh() );
//STRIP001 
//STRIP001 			if( !pGraphicFilter->ImportGraphic( aGraphic, aURL ) )
//STRIP001 			{
//STRIP001 				sal_Int8    nTempAction = ( aIter == aDropFileVector.begin() ) ? nAction : 0;
//STRIP001 				SdrGrafObj* pGrafObj = InsertGraphic( aGraphic, nTempAction, aDropPos, NULL, NULL );
//STRIP001 
//STRIP001 				if( pGrafObj )
//STRIP001 					pGrafObj->SetGraphicLink( aCurrentDropFile, String() );
//STRIP001 
//STRIP001 				// return action from first inserted graphic
//STRIP001 				if( aIter == aDropFileVector.begin() )
//STRIP001 					nAction = nTempAction;
//STRIP001 
//STRIP001 				bOK = TRUE;
//STRIP001 			}
//STRIP001 
//STRIP001 			delete pFilterProgress;
//STRIP001 
//STRIP001 			if( !bOK )
//STRIP001 			{
//STRIP001     			const SfxFilter*        pFoundFilter = NULL;
//STRIP001 				SfxMedium	            aSfxMedium( aCurrentDropFile, STREAM_READ | STREAM_SHARE_DENYNONE, FALSE );
//STRIP001 				ErrCode		            nErr = SFX_APP()->GetFilterMatcher().GuessFilter(  aSfxMedium, &pFoundFilter, SFX_FILTER_IMPORT, SFX_FILTER_NOTINSTALLED | SFX_FILTER_EXECUTABLE );
//STRIP001 
//STRIP001 				if( pFoundFilter && !nErr )
//STRIP001 				{
//STRIP001 					::std::vector< String > aFilterVector;
//STRIP001 					const String	        aFilterName( pFoundFilter->GetFilterName() );
//STRIP001 					const String	        aLowerAsciiFileName( aCurrentDropFile.ToLowerAscii() );
//STRIP001 
//STRIP001 					FuInsertFile::GetSupportedFilterVector( aFilterVector );
//STRIP001 
//STRIP001 					if( ( ::std::find( aFilterVector.begin(), aFilterVector.end(), pFoundFilter->GetMimeType() ) != aFilterVector.end() ) ||
//STRIP001 						aFilterName.SearchAscii( "Text" ) != STRING_NOTFOUND ||
//STRIP001 						aFilterName.SearchAscii( "Rich" ) != STRING_NOTFOUND ||
//STRIP001 						aFilterName.SearchAscii( "RTF" ) != STRING_NOTFOUND ||
//STRIP001 						aFilterName.SearchAscii( "HTML" ) != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".sdd") != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".sda") != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".sxd") != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".sxi") != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".std") != STRING_NOTFOUND ||
//STRIP001 						aLowerAsciiFileName.SearchAscii(".sti") != STRING_NOTFOUND )
//STRIP001 					{
//STRIP001 						SdWindow*       pWin = pViewSh->GetActiveWindow();
//STRIP001 						SfxRequest      aReq(SID_INSERTFILE, 0, pDoc->GetItemPool());
//STRIP001 						SfxStringItem   aItem1( ID_VAL_DUMMY0, aCurrentDropFile ), aItem2( ID_VAL_DUMMY1, pFoundFilter->GetFilterName() );
//STRIP001 						
//STRIP001 						aReq.AppendItem( aItem1 );
//STRIP001 						aReq.AppendItem( aItem2 );
//STRIP001 						delete( new FuInsertFile( pViewSh, pWin, this, pDoc, aReq ) );
//STRIP001 						bOK = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 	    if( !bOK )
//STRIP001 	    {
//STRIP001 		    if( Sound::IsSoundFile( aCurrentDropFile ) || ( nAction & DND_ACTION_LINK ) )
//STRIP001 			    static_cast< SdDrawViewShell* >( pViewSh )->InsertURLButton( aCurrentDropFile, aCurrentDropFile, String(), &aDropPos );
//STRIP001 		    else
//STRIP001 		    {
//STRIP001 			    if( pViewSh )
//STRIP001 			    {
//STRIP001 			        String              aName;
//STRIP001 			        SvStorageRef        aStor( new SvStorage( String(), STREAM_STD_READWRITE ) );
//STRIP001 			        SvInPlaceObjectRef  aIPObj( &static_cast< SvFactory* >( SvInPlaceObject::ClassFactory() )->CreateAndInit( aCurrentDropFile, aStor ) );
//STRIP001 
//STRIP001 				    if( aIPObj.Is() )
//STRIP001 				    {
//STRIP001 					    Size        aSize( aIPObj->GetVisArea( ASPECT_CONTENT ).GetSize() );
//STRIP001 					    Rectangle   aRect;
//STRIP001 
//STRIP001 					    if (!aSize.Width() || !aSize.Height())
//STRIP001 					    {
//STRIP001 						    aSize.Width()   = 1410;
//STRIP001 						    aSize.Height()  = 1000;
//STRIP001 					    }
//STRIP001     
//STRIP001     				    aRect = Rectangle( aDropPos, aSize );
//STRIP001     				    aName = pDocSh->InsertObject( aIPObj, String() )->GetObjName();
//STRIP001 
//STRIP001 					    SdrOle2Obj* pOleObj = new SdrOle2Obj( aIPObj, aName, aRect );
//STRIP001 					    ULONG       nOptions = SDRINSERT_SETDEFLAYER;
//STRIP001 
//STRIP001 					    if (pViewSh && pViewSh->GetIPClient() && pViewSh->GetIPClient()->IsInPlaceActive())
//STRIP001 						    nOptions |= SDRINSERT_DONTMARK;
//STRIP001 
//STRIP001 					    InsertObject( pOleObj, *GetPageViewPvNum(0), nOptions );
//STRIP001 					    pOleObj->SetLogicRect( aRect );
//STRIP001 					    aIPObj->SetVisAreaSize( aRect.GetSize() );
//STRIP001 				    }
//STRIP001 			    }
//STRIP001 		    }
//STRIP001 	    }
//STRIP001 
//STRIP001         ++aIter;
//STRIP001     }
//STRIP001 
	return 0;
}

/*************************************************************************
|*
|* Timer-Handler fuer Errorhandling beim Drop()
|*
\************************************************************************/

IMPL_LINK( SdView, DropErrorHdl, Timer*, pTimer )
{
	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 InfoBox( pViewSh->GetActiveWindow(), String(SdResId(STR_ACTION_NOTPOSSIBLE) ) ).Execute();
	return 0;
}

#ifdef WNT
#pragma optimize ( "", on )
#endif

/*************************************************************************
|*
|* Redraw sperren oder erlauben
|*
\************************************************************************/

//STRIP001 void SdView::LockRedraw(BOOL bLock)
//STRIP001 {
//STRIP001 	if (bLock)
//STRIP001 	{
//STRIP001 		nLockRedrawSmph++;
//STRIP001 		DBG_ASSERT(nLockRedrawSmph, "Ueberlauf im LockRedraw");
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		DBG_ASSERT(nLockRedrawSmph, "Unterlauf im LockRedraw");
//STRIP001 		nLockRedrawSmph--;
//STRIP001 
//STRIP001 		// alle gespeicherten Redraws ausfuehren
//STRIP001 		if (!nLockRedrawSmph)
//STRIP001 		{
//STRIP001 			while (pLockedRedraws && pLockedRedraws->Count())
//STRIP001 			{
//STRIP001 				SdViewRedrawRec* pRec = (SdViewRedrawRec*)pLockedRedraws->First();
//STRIP001 				OutputDevice* pCurrentOut = pRec->pOut;
//STRIP001 				Rectangle aBoundRect(pRec->aRect);
//STRIP001 				pLockedRedraws->Remove(pRec);
//STRIP001 				delete pRec;
//STRIP001 
//STRIP001 				pRec = (SdViewRedrawRec*)pLockedRedraws->First();
//STRIP001 				while (pRec)
//STRIP001 				{
//STRIP001 					if (pRec->pOut == pCurrentOut)
//STRIP001 					{
//STRIP001 						aBoundRect.Union(pRec->aRect);
//STRIP001 						pLockedRedraws->Remove(pRec);
//STRIP001 						delete pRec;
//STRIP001 						pRec = (SdViewRedrawRec*)pLockedRedraws->GetCurObject();
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						pRec = (SdViewRedrawRec*)pLockedRedraws->Next();
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				InitRedraw(pCurrentOut, Region(aBoundRect));
//STRIP001 			}
//STRIP001 			delete pLockedRedraws;
//STRIP001 			pLockedRedraws = NULL;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* StyleSheet aus der Sleketion besorgen
|*
\************************************************************************/

//STRIP001 SfxStyleSheet* SdView::GetStyleSheet() const
//STRIP001 {
//STRIP001 	return SdrView::GetStyleSheet();
//STRIP001 }
}
