/*************************************************************************
 *
 *  $RCSfile: sd_showview.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:20:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SVDMODEL_HXX //autogen
// auto strip #include <bf_svx/svdmodel.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FMVIEW_HXX
// auto strip #include <bf_svx/fmview.hxx>
// auto strip #endif

#pragma hdrstop

// auto strip #include "showview.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "frmview.hxx"
namespace binfilter {


//STRIP001 #ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
//STRIP001 #define SO2_DECL_SVINPLACEOBJECT_DEFINED
//STRIP001 SO2_DECL_REF(SvInPlaceObject)
//STRIP001 #endif
//STRIP001 #ifndef SO2_DECL_SVINPLACECLIENT_DEFINED
//STRIP001 #define SO2_DECL_SVINPLACECLIENT_DEFINED
//STRIP001 SO2_DECL_REF(SvInPlaceClient)
//STRIP001 #endif
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* der Konstruktor setzt den MapMode und arrangiert die einzelnen Seiten
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 ShowView::ShowView(SdDrawDocument* pDoc, OutputDevice* pOut,
//STRIP001 				   SdViewShell* pViewShell, Window* pWin)
//STRIP001 		: FmFormView(pDoc, pOut),
//STRIP001 		  pDrDoc(pDoc),
//STRIP001 		  pViewSh(pViewShell),
//STRIP001 		  pWindowForPlugIns(pWin),
//STRIP001 		  nAllowInvalidateSmph(0),
//STRIP001 		  bAllowMasterPageCaching(TRUE)
//STRIP001 {
//STRIP001 	EnableExtendedKeyInputDispatcher(FALSE);
//STRIP001 	EnableExtendedMouseEventDispatcher(FALSE);
//STRIP001 	EnableExtendedCommandEventDispatcher(FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 ShowView::~ShowView()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Zaehler fuer Invalidierungserlaubnis hoch- oder runter zaehlen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ShowView::SetAllowInvalidate(BOOL bFlag)
//STRIP001 {
//STRIP001 	if (!bFlag)
//STRIP001 	{
//STRIP001 		nAllowInvalidateSmph++;
//STRIP001 	}
//STRIP001 	else if (nAllowInvalidateSmph > 0)
//STRIP001 	{
//STRIP001 		nAllowInvalidateSmph--;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ermittelt, ob invalidiert werden darf
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL ShowView::IsInvalidateAllowed() const
//STRIP001 {
//STRIP001 	return (nAllowInvalidateSmph == 0);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Invalidate abfangen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ShowView::InvalidateOneWin(Window& rWin)
//STRIP001 {
//STRIP001 	if (IsInvalidateAllowed())
//STRIP001 	{
//STRIP001 		FmFormView::InvalidateOneWin(rWin);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Invalidate abfangen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ShowView::InvalidateOneWin(Window& rWin, const Rectangle& rRect)
//STRIP001 {
//STRIP001 	if (IsInvalidateAllowed())
//STRIP001 	{
//STRIP001 		FmFormView::InvalidateOneWin(rWin, rRect);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Paint-Methode: das Ereignis wird an die View weitergeleitet
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ShowView::InitRedraw(OutputDevice* pOutDev, const Region& rReg)
//STRIP001 {
//STRIP001 	BOOL bMPCache = FALSE;
//STRIP001 
//STRIP001 	if (bAllowMasterPageCaching && pViewSh &&
//STRIP001 		pViewSh == (SdViewShell*) SfxViewShell::Current() &&
//STRIP001 		pViewSh->GetFrameView()->IsMasterPagePaintCaching() &&
//STRIP001 		pOutDev->GetOutDevType() != OUTDEV_PRINTER)
//STRIP001 	{
//STRIP001 		// Aktive ViewShell: Caching einschalten
//STRIP001 		bMPCache = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bMPCache)
//STRIP001 	{
//STRIP001 		if (!IsMasterPagePaintCaching())
//STRIP001 		{
//STRIP001 			SetMasterPagePaintCaching(TRUE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if (IsMasterPagePaintCaching())
//STRIP001 		{
//STRIP001 			ReleaseMasterPagePaintCache();
//STRIP001 			SetMasterPagePaintCaching(FALSE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	FmFormView::InitRedraw(pOutDev, rReg, SDRPAINTMODE_ANILIKEPRN);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* DoConnect
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ShowView::DoConnect(SdrOle2Obj* pOleObj)
//STRIP001 {
//STRIP001 	// connected wird jetzt in FuSlideShow::ShowPlugIns()
//STRIP001 }





}
