/*************************************************************************
 *
 *  $RCSfile: sfx2_objsys.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:53:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef WNT

#define UINT64 USE_WIN_UINT64
#define INT64 USE_WIN_INT64
#define UINT32 USE_WIN_UINT32
#define INT32 USE_WIN_INT32

#include <tools/presys.h>
#include <windows.h>
#include <tools/postsys.h>

#undef UINT64
#undef INT64
#undef UINT32
#undef INT32

#endif

// auto strip #ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
// auto strip #include <com/sun/star/uno/Exception.hpp>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_DATATRANSFER_XTRANSFERABLE_HPP_
// auto strip #include <com/sun/star/datatransfer/XTransferable.hpp>
// auto strip #endif

#ifndef _OSL_THREAD_H_
#include <osl/thread.h>
#endif
// auto strip #ifndef _SV_GDIMTF_HXX
// auto strip #include <vcl/gdimtf.hxx>
// auto strip #endif
// auto strip #ifndef _SV_GRAPH_HXX
// auto strip #include <vcl/graph.hxx>
// auto strip #endif
// auto strip #ifndef _SV_CVTGRF_HXX
// auto strip #include <vcl/cvtgrf.hxx>
// auto strip #endif
// auto strip #ifndef _SV_OUTDEV_HXX
// auto strip #include <vcl/outdev.hxx>
// auto strip #endif
// auto strip #ifndef _STREAM_HXX
// auto strip #include <tools/stream.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_TEMPFILE_HXX
// auto strip #include <unotools/tempfile.hxx>
// auto strip #endif
#ifndef _UNTOOLS_UCBSTREAMHELPER_HXX
#include <unotools/ucbstreamhelper.hxx>
#endif
namespace binfilter {

using namespace ::com::sun::star;

//STRIP001 SvMemoryStream* getMetaMemStrFromGDI_Impl( const GDIMetaFile* pGDIMeta, sal_uInt32 nFormat )
//STRIP001 {
//STRIP001 	SvMemoryStream* pResult = NULL;
//STRIP001 	if ( pGDIMeta )
//STRIP001 	{
//STRIP001 		SvMemoryStream* pStream = new SvMemoryStream( 65535, 65535 );
//STRIP001 		if ( pStream )
//STRIP001 		{
//STRIP001 			Graphic aGraph( *pGDIMeta );
//STRIP001 			if ( GraphicConverter::Export( *pStream, aGraph, nFormat ) == 0 )
//STRIP001 				pResult = pStream;
//STRIP001 			else
//STRIP001 				delete pStream;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 void* getEnhMetaFileFromGDI_Impl( const GDIMetaFile* pGDIMeta )
//STRIP001 {
//STRIP001 	void* pResult = NULL;
//STRIP001 
//STRIP001 #ifdef WNT
//STRIP001 	if ( pGDIMeta )
//STRIP001 	{
//STRIP001 		String aStr = ::rtl::OUString::createFromAscii( ".emf" );
//STRIP001 		::utl::TempFile aTempFile( ::rtl::OUString(),
//STRIP001 								   &aStr,
//STRIP001 								   NULL,
//STRIP001 								   sal_False );
//STRIP001 
//STRIP001 		::rtl::OUString aMetaFile = aTempFile.GetFileName();
//STRIP001 		::rtl::OUString aMetaURL = aTempFile.GetURL();
//STRIP001 		::rtl::OString aWinFile = ::rtl::OUStringToOString( aMetaFile, osl_getThreadTextEncoding() );
//STRIP001 
//STRIP001 		SvStream* pStream = ::utl::UcbStreamHelper::CreateStream( aMetaURL, STREAM_STD_READWRITE );
//STRIP001 		if ( pStream )
//STRIP001 		{
//STRIP001 			Graphic aGraph( *pGDIMeta );
//STRIP001 			sal_Bool bFailed = (sal_Bool)GraphicConverter::Export( *pStream, aGraph, CVT_EMF );
//STRIP001 			pStream->Flush();
//STRIP001 			delete pStream;
//STRIP001 			
//STRIP001 			if ( !bFailed )
//STRIP001 				pResult = GetEnhMetaFileA( aWinFile.getStr() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 void* getWinMetaFileFromGDI_Impl( const GDIMetaFile* pGDIMeta, const Size& aMetaSize )
//STRIP001 {
//STRIP001 	void* pResult = NULL;
//STRIP001 
//STRIP001 #ifdef WNT
//STRIP001 	if ( pGDIMeta )
//STRIP001 	{
//STRIP001 		SvMemoryStream* pStream = new SvMemoryStream( 65535, 65535 );
//STRIP001 		if ( pStream )
//STRIP001 		{
//STRIP001 			Graphic aGraph( *pGDIMeta );
//STRIP001 			sal_Bool bFailed = (sal_Bool)GraphicConverter::Export( *pStream, aGraph, CVT_WMF );
//STRIP001 			pStream->Flush();
//STRIP001 			if ( !bFailed )
//STRIP001 			{
//STRIP001 				sal_Int32 nLength = pStream->Seek( STREAM_SEEK_TO_END );
//STRIP001 				if ( nLength > 22 )
//STRIP001 				{
//STRIP001 					HMETAFILE hMeta = SetMetaFileBitsEx( nLength - 22, 
//STRIP001 									( reinterpret_cast< const sal_uChar*>( pStream->GetData() ) ) + 22 );
//STRIP001 
//STRIP001 					if ( hMeta )
//STRIP001 					{
//STRIP001 						HGLOBAL hMemory = GlobalAlloc( GMEM_DDESHARE | GMEM_MOVEABLE, sizeof( METAFILEPICT ) );
//STRIP001 				
//STRIP001 						if ( hMemory )
//STRIP001 						{
//STRIP001    							METAFILEPICT* pMF = (METAFILEPICT*)GlobalLock( hMemory );
//STRIP001 
//STRIP001    							pMF->hMF = hMeta;
//STRIP001    							pMF->mm = MM_ANISOTROPIC;
//STRIP001 
//STRIP001 							MapMode aMetaMode = pGDIMeta->GetPrefMapMode();
//STRIP001 							MapMode aWinMode( MAP_100TH_MM );
//STRIP001 
//STRIP001 							if ( aWinMode == pGDIMeta->GetPrefMapMode() )
//STRIP001 							{
//STRIP001 								pMF->xExt = aMetaSize.Width();
//STRIP001 								pMF->yExt = aMetaSize.Height();
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								Size aWinSize = OutputDevice::LogicToLogic( Size( aMetaSize.Width(), aMetaSize.Height() ), 
//STRIP001 																			aWinMode, 
//STRIP001 																			pGDIMeta->GetPrefMapMode() );
//STRIP001 								pMF->xExt = aWinSize.Width();
//STRIP001 								pMF->yExt = aWinSize.Height();
//STRIP001 							}
//STRIP001 
//STRIP001 							GlobalUnlock( hMemory );
//STRIP001 							pResult = (void*)hMemory;
//STRIP001 						}
//STRIP001 						else
//STRIP001    							DeleteMetaFile( hMeta );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			delete pStream;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool supportsMetaFileHandle_Impl()
//STRIP001 {
//STRIP001 #ifdef WNT
//STRIP001 	return sal_True;
//STRIP001 #else
//STRIP001 	return sal_False;
//STRIP001 #endif
//STRIP001 }

}
