/*************************************************************************
 *
 *  $RCSfile: sfx2_ipenv.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:07:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <so3/iface.hxx>
// auto strip #ifndef _IPMENU_HXX //autogen
// auto strip #include <so3/ipmenu.hxx>
// auto strip #endif
#ifndef _IPWIN_HXX //autogen
#include <so3/ipwin.hxx>
#endif
// auto strip #include <svtools/menuoptions.hxx>
#pragma hdrstop

// auto strip #include "virtmenu.hxx"
// auto strip #include "dispatch.hxx"
// auto strip #include "ipfrm.hxx"
// auto strip #include "viewsh.hxx"
// auto strip #include "accmgr.hxx"
// auto strip #include "mnumgr.hxx"
// auto strip #include "cfgmgr.hxx"
// auto strip #include "interno.hxx"
// auto strip #include "docfac.hxx"
// auto strip #include "ipenv.hxx"

// SFX_INIMANAGER()
#if SUPD<613//MUSTINI
// auto strip #include "inimgr.hxx"
#endif
namespace binfilter {

//=========================================================================

//STRIP001 #define SVIPWINDOW(p) ((SvInPlaceWindow&)p->GetWindow())

//--------------------------------------------------------------------

//STRIP001 SfxInPlaceEnv_Impl::~SfxInPlaceEnv_Impl()
//STRIP001 {
//STRIP001 	DeleteWindows();
//STRIP001 	delete pMenuBar;
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 MenuBar* SfxInPlaceEnv_Impl::QueryMenu( USHORT * nCount0, USHORT * nCount1,
//STRIP001 										USHORT * nCount2 )
//STRIP001 {
//STRIP001 	SfxObjectFactory &rObjFactory = pFrame->GetObjectShell()->GetFactory();
//STRIP001 
//STRIP001 	if( !pMenuBar )
//STRIP001 	{
//STRIP001         SfxMenuBarManager* pMenuMgr = pFrame->GetViewShell()->GetMenuBar_Impl();
//STRIP001 		pFrame->GetDispatcher()->UpdateObjectMenus_Impl(pMenuMgr);
//STRIP001 
//STRIP001 		SfxVirtualMenu *pAppMenu = pMenuMgr->GetMenu();
//STRIP001 		MenuBar *pAppBar = (MenuBar*) pAppMenu->GetSVMenu();
//STRIP001 
//STRIP001 		// Bereich 1: hinter dem Datei-Menue und vor dem 2.Containermenue;
//STRIP001 		// da wir dieses nicht haben: vor dem Fenstermenue
//STRIP001 		USHORT nPos = pAppBar->GetItemPos(SID_MDIWINDOWLIST);
//STRIP001 
//STRIP001 		// Die Menue-Konfiguration mu\s sicherstellen, da\s vor dem Dateimenue
//STRIP001 		// nichts steht und da\s Datei - und Fenstermenue nicht wegkonfiguriert
//STRIP001 		// werden k"onnen !
//STRIP001 		DBG_ASSERT( nPos != MENU_ITEM_NOTFOUND, "Wer hat das MDI-Menue geklaut ?!");
//STRIP001 
//STRIP001 		USHORT nStart1 = 1, nCount1 = nPos - 1;
//STRIP001 
//STRIP001 		// Bereich 2: hinter dem 2.Containermenue
//STRIP001 		USHORT nStart2 = 0, nCount2 = 0;
//STRIP001 
//STRIP001 		// Bereich 3: hinter dem Fenster-Menue; das ist in der Regel nur das
//STRIP001 		// Hilfe-Menue
//STRIP001 		USHORT 	nStart3 = nPos + 1,
//STRIP001 				nCount3 = pAppBar->GetItemCount() - nStart3;
//STRIP001 		pMenuBar = new SvInPlaceMenuBar( pAppBar,
//STRIP001 										 nStart1, nCount1,
//STRIP001 										 nStart2, nCount2,
//STRIP001 										 nStart3, nCount3 );
//STRIP001 #if SUPD<613//MUSTINI
//STRIP001 		if ( !SFX_INIMANAGER()->IsDontHideDisabledEntries() )
//STRIP001 #else
//STRIP001 		if( SvtMenuOptions().IsEntryHidingEnabled() == sal_False )
//STRIP001 #endif
//STRIP001 			pMenuBar->SetMenuFlags( pMenuBar->GetMenuFlags() | MENU_FLAG_HIDEDISABLEDENTRIES );
//STRIP001 
//STRIP001 		// Die einschl"agigen Menu-Handler m"ussen gesetzt werden, damit ein
//STRIP001 		// TRUE returniert werdenn kann, um SV daran zu hindern, an das AppMenue
//STRIP001 		// zu gehen und dort seinen Aufruf loszuwerden, was InPlace garantiert
//STRIP001 		// nicht richtig sein kann!
//STRIP001 		Link aLink = LINK( this, SfxInPlaceEnv_Impl, DummyMenuHdl );
//STRIP001 		pMenuBar->SetHighlightHdl( aLink );
//STRIP001 		pMenuBar->SetActivateHdl( aLink );
//STRIP001 		pMenuBar->SetDeactivateHdl( aLink );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pMenuBar->GetBlocks( nCount0, nCount1, nCount2 );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 SfxInPlaceEnv_Impl::SfxInPlaceEnv_Impl
//STRIP001 (
//STRIP001 	SfxInPlaceObject*	pObj,
//STRIP001 	SfxInPlaceFrame*	pIPFrame
//STRIP001 )
//STRIP001 :	SvInPlaceEnvironment( pObj->GetIPClient()->GetEnv(), pObj ),
//STRIP001 	pFrame( pIPFrame ),
//STRIP001     pMenuBar( 0 )
//STRIP001 {
//STRIP001 	SfxObjectShell *pObjShell = pFrame->GetObjectShell();
//STRIP001 
//STRIP001     pIPFrame->GetFrame()->SetWorkWindow_Impl(  new SfxIPWorkWin_Impl( GetContainerEnv()->GetTopWin(),
//STRIP001                             pFrame->GetBindings(), this ) );
//STRIP001 	MakeWindows();
//STRIP001 
//STRIP001 	// StatusUpdates gehen erst los, wenn UITools angezeigt werden
//STRIP001 	pFrame->GetBindings().ENTERREGISTRATIONS();
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::TopWinResize()
//STRIP001 {
//STRIP001 	if ( IsShowUITools())
//STRIP001 	{
//STRIP001 		// TopWinResize kann auch kommen, wenn die Tools nicht angezeigt
//STRIP001 		// werden, weil das Dokumentfenster nicht aktiv ist.
//STRIP001         SfxWorkWindow* pWorkWin = pFrame->GetFrame()->GetWorkWindow_Impl();
//STRIP001 		pWorkWin->ArrangeChilds_Impl();
//STRIP001 		pWorkWin->ShowChilds_Impl();
//STRIP001 	}
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::RectsChangedPixel( const Rectangle & rObjRect,
//STRIP001 											const Rectangle & rClipRect )
//STRIP001 {
//STRIP001 	DBG_ASSERT( pFrame, "no pFrame in RectsChangedPixel" );
//STRIP001 
//STRIP001 	SvInPlaceEnvironment::RectsChangedPixel( rObjRect, rClipRect );
//STRIP001 
//STRIP001 	// View skalieren
//STRIP001 	SfxInPlaceObject* pObj = (SfxInPlaceObject*) GetIPObj();
//STRIP001 	if ( !pObj->IsViewScalingDisabled() )
//STRIP001 		MakeScale( GetIPObj()->GetVisArea().GetSize(),
//STRIP001 				   GetIPObj()->GetMapUnit(), rObjRect.GetSize() );
//STRIP001 
//STRIP001 	// View resizen
//STRIP001 	Size aHatch( GetBorderWin()->GetHatchBorderPixel() );
//STRIP001 	Point aPos( aHatch.Width(), aHatch.Height() );
//STRIP001 	pFrame->DoAdjustPosSizePixel( pFrame->GetViewShell(),
//STRIP001 					aPos, rObjRect.GetSize() ); //! +/-1 Problem
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 BOOL SfxInPlaceEnv_Impl::DispatchAccel(const KeyCode &rKeyCode)
//STRIP001 {
//STRIP001 	if (!pFrame->GetViewShell()->GetWindow()->HasFocus())
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	return pFrame->GetViewShell()->KeyInput( KeyEvent(0, rKeyCode) );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::TopWinActivate( BOOL bActivate )
//STRIP001 {
//STRIP001 /*
//STRIP001 	if( bActivate )
//STRIP001 	{
//STRIP001 		ActivateConfig();
//STRIP001 	}
//STRIP001  */
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::UIActivate( BOOL bActivate )
//STRIP001 {
//STRIP001     SfxWorkWindow* pWorkWin = pFrame->GetFrame()->GetWorkWindow_Impl();
//STRIP001 	if ( bActivate )
//STRIP001 	{
//STRIP001 		pFrame->GetViewShell()->GetWindow()->GrabFocus();
//STRIP001 		pWorkWin->ArrangeChilds_Impl();
//STRIP001 		pWorkWin->ShowChilds_Impl();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pWorkWin->ResetObjectBars_Impl();
//STRIP001 		pWorkWin->UpdateObjectBars_Impl();
//STRIP001 		pWorkWin->Close_Impl();
//STRIP001 	}
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::DocWinActivate( BOOL bActivate )
//STRIP001 {
//STRIP001 	if( bActivate )
//STRIP001 	{
//STRIP001 //        ActivateConfig();
//STRIP001 
//STRIP001 		// Da bei internem Inplace die Objekte und der Container einen Teil
//STRIP001 		// des Environments gemeinsam haben, m"ussen "Anderungen upgedatet
//STRIP001 		// werden, wenn von einem zum anderen gewechselt wird (z.B. der Status
//STRIP001 		// der Objektleiste u.a.).
//STRIP001 		if ( GetContainerEnv()->GetIPClient()->Owner() )
//STRIP001 			pFrame->GetBindings().InvalidateAll( FALSE );
//STRIP001 	}
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::ShowUITools( BOOL bShow )
//STRIP001 {
//STRIP001     SfxWorkWindow* pWorkWin = pFrame->GetFrame()->GetWorkWindow_Impl();
//STRIP001 	if ( bShow )
//STRIP001 	{
//STRIP001 		// Wenn nach letztem ShowUITools(FALSE) TopWin-Groesse veraendert
//STRIP001 		// wurde, muss neu arrangiert werden
//STRIP001 		pFrame->GetBindings().LEAVEREGISTRATIONS();
//STRIP001         pWorkWin->ArrangeChilds_Impl();
//STRIP001         pWorkWin->ShowChilds_Impl();
//STRIP001 		pFrame->GetBindings().HidePopups(FALSE);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         pWorkWin->HideChilds_Impl();
//STRIP001 		pFrame->GetBindings().HidePopups(TRUE);
//STRIP001 		pFrame->GetBindings().ENTERREGISTRATIONS();
//STRIP001 	}
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 void SfxInPlaceEnv_Impl::QueryObjAreaPixel( Rectangle& rRect ) const
//STRIP001 {
//STRIP001 	pFrame->GetViewShell()->QueryObjAreaPixel(rRect);
//STRIP001 }


//--------------------------------------------------------------------
/*
void SfxInPlaceEnv_Impl::ActivateConfig()
{
	SfxConfigManager *pMgr = pFrame->GetObjectShell()->GetConfigManager();
	if ( pMgr )
		SFX_APP()->SetConfigManager_Impl( pMgr );
	else
		SFX_APP()->SetConfigManager_Impl( pCfgMgr);
}
*/
//--------------------------------------------------------------------

//STRIP001 IMPL_LINK( SfxInPlaceEnv_Impl, DummyMenuHdl, Menu *, pMenu )
//STRIP001 {
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL SfxInPlaceEnv_Impl::IsInternalInPlace() const
//STRIP001 {
//STRIP001 	return TRUE;
//STRIP001 }


}
