/*************************************************************************
 *
 *  $RCSfile: svx_dstribut.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _BASEDLGS_HXX
#include <bf_sfx2/basedlgs.hxx>
#endif

#include "dialogs.hrc"
#include "dstribut.hxx"
#include "dstribut.hrc"

#include "svddef.hxx"
#include "dialmgr.hxx"

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
namespace binfilter {

//STRIP001 static USHORT pRanges[] =
//STRIP001 {
//STRIP001 	SDRATTR_MEASURE_FIRST,
//STRIP001 	SDRATTR_MEASURE_LAST,
//STRIP001 	0
//STRIP001 };

/*************************************************************************
|*
|* Dialog
|*
\************************************************************************/

//STRIP001 SvxDistributeDialog::SvxDistributeDialog(
//STRIP001 	Window* pParent,
//STRIP001 	const SfxItemSet& rInAttrs,
//STRIP001 	SvxDistributeHorizontal eHor,
//STRIP001 	SvxDistributeVertical eVer)
//STRIP001 :	SfxSingleTabDialog(pParent, rInAttrs, RID_SVXPAGE_DISTRIBUTE ),
//STRIP001 	mpPage(0L)
//STRIP001 {
//STRIP001 	mpPage = new SvxDistributePage(this, rInAttrs, eHor, eVer);
//STRIP001 	SetTabPage(mpPage);
//STRIP001 	SetText(mpPage->GetText());
//STRIP001 }

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

//STRIP001 SvxDistributeDialog::~SvxDistributeDialog()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Tabpage
|*
\************************************************************************/

//STRIP001 SvxDistributePage::SvxDistributePage(
//STRIP001 	Window* pWindow,
//STRIP001 	const SfxItemSet& rInAttrs,
//STRIP001 	SvxDistributeHorizontal eHor,
//STRIP001 	SvxDistributeVertical eVer)
//STRIP001 :	SvxTabPage(pWindow, ResId(RID_SVXPAGE_DISTRIBUTE, DIALOG_MGR()), rInAttrs),
//STRIP001 	meDistributeHor(eHor),
//STRIP001 	meDistributeVer(eVer),
//STRIP001 	maFlHorizontal		(this, ResId(FL_HORIZONTAL		)),
//STRIP001 	maBtnHorNone		(this, ResId(BTN_HOR_NONE		)),
//STRIP001 	maBtnHorLeft		(this, ResId(BTN_HOR_LEFT		)),
//STRIP001 	maBtnHorCenter		(this, ResId(BTN_HOR_CENTER		)),
//STRIP001 	maBtnHorDistance	(this, ResId(BTN_HOR_DISTANCE	)),
//STRIP001 	maBtnHorRight		(this, ResId(BTN_HOR_RIGHT		)),
//STRIP001 	maHorLow			(this, ResId(IMG_HOR_LOW		)),
//STRIP001 	maHorCenter			(this, ResId(IMG_HOR_CENTER		)),
//STRIP001 	maHorDistance		(this, ResId(IMG_HOR_DISTANCE	)),
//STRIP001 	maHorHigh			(this, ResId(IMG_HOR_HIGH		)),
//STRIP001 	maFlVertical		(this, ResId(FL_VERTICAL		)),
//STRIP001 	maBtnVerNone		(this, ResId(BTN_VER_NONE		)),
//STRIP001 	maBtnVerTop			(this, ResId(BTN_VER_TOP		)),
//STRIP001 	maBtnVerCenter		(this, ResId(BTN_VER_CENTER		)),
//STRIP001 	maBtnVerDistance	(this, ResId(BTN_VER_DISTANCE	)),
//STRIP001 	maBtnVerBottom		(this, ResId(BTN_VER_BOTTOM		)),
//STRIP001 	maVerDistance		(this, ResId(IMG_VER_DISTANCE	)),
//STRIP001 	maVerLow			(this, ResId(IMG_VER_LOW		)),
//STRIP001 	maVerCenter			(this, ResId(IMG_VER_CENTER		)),
//STRIP001     maVerHigh           (this, ResId(IMG_VER_HIGH       ))
//STRIP001 {
//STRIP001 	maHorLow.SetModeImage( Image( ResId( IMG_HOR_LOW_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maHorCenter.SetModeImage( Image( ResId( IMG_HOR_CENTER_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maHorDistance.SetModeImage( Image( ResId( IMG_HOR_DISTANCE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maHorHigh.SetModeImage( Image( ResId( IMG_HOR_HIGH_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maVerDistance.SetModeImage( Image( ResId( IMG_VER_DISTANCE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maVerLow.SetModeImage( Image( ResId( IMG_VER_LOW_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maVerCenter.SetModeImage( Image( ResId( IMG_VER_CENTER_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	maVerHigh.SetModeImage( Image( ResId( IMG_VER_HIGH_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 }

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

//STRIP001 SvxDistributePage::~SvxDistributePage()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* create the tabpage
|*
\************************************************************************/

//STRIP001 SfxTabPage* SvxDistributePage::Create(Window* pWindow, const SfxItemSet& rAttrs,
//STRIP001 	SvxDistributeHorizontal eHor, SvxDistributeVertical eVer)
//STRIP001 {
//STRIP001 	return(new SvxDistributePage(pWindow, rAttrs, eHor, eVer));
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 UINT16*	SvxDistributePage::GetRanges()
//STRIP001 {
//STRIP001 	return(pRanges);
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SvxDistributePage::PointChanged(Window* pWindow, RECT_POINT eRP)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* read the delivered Item-Set
|*
\************************************************************************/

//STRIP001 void __EXPORT SvxDistributePage::Reset(const SfxItemSet& rAttrs)
//STRIP001 {
//STRIP001 	maBtnHorNone.SetState(FALSE);
//STRIP001 	maBtnHorLeft.SetState(FALSE);
//STRIP001 	maBtnHorCenter.SetState(FALSE);
//STRIP001 	maBtnHorDistance.SetState(FALSE);
//STRIP001 	maBtnHorRight.SetState(FALSE);
//STRIP001 
//STRIP001 	switch(meDistributeHor)
//STRIP001 	{
//STRIP001 		case SvxDistributeHorizontalNone : maBtnHorNone.SetState(TRUE); break;
//STRIP001 		case SvxDistributeHorizontalLeft : maBtnHorLeft.SetState(TRUE); break;
//STRIP001 		case SvxDistributeHorizontalCenter : maBtnHorCenter.SetState(TRUE); break;
//STRIP001 		case SvxDistributeHorizontalDistance : maBtnHorDistance.SetState(TRUE); break;
//STRIP001 		case SvxDistributeHorizontalRight : maBtnHorRight.SetState(TRUE); break;
//STRIP001 	}
//STRIP001 
//STRIP001 	maBtnVerNone.SetState(FALSE);
//STRIP001 	maBtnVerTop.SetState(FALSE);
//STRIP001 	maBtnVerCenter.SetState(FALSE);
//STRIP001 	maBtnVerDistance.SetState(FALSE);
//STRIP001 	maBtnVerBottom.SetState(FALSE);
//STRIP001 
//STRIP001 	switch(meDistributeVer)
//STRIP001 	{
//STRIP001 		case SvxDistributeVerticalNone : maBtnVerNone.SetState(TRUE); break;
//STRIP001 		case SvxDistributeVerticalTop : maBtnVerTop.SetState(TRUE); break;
//STRIP001 		case SvxDistributeVerticalCenter : maBtnVerCenter.SetState(TRUE); break;
//STRIP001 		case SvxDistributeVerticalDistance : maBtnVerDistance.SetState(TRUE); break;
//STRIP001 		case SvxDistributeVerticalBottom : maBtnVerBottom.SetState(TRUE); break;
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Fill the delivered Item-Set with dialogbox-attributes
|*
\************************************************************************/

//STRIP001 BOOL SvxDistributePage::FillItemSet( SfxItemSet& rAttrs)
//STRIP001 {
//STRIP001 	SvxDistributeHorizontal eDistributeHor(SvxDistributeHorizontalNone);
//STRIP001 	SvxDistributeVertical eDistributeVer(SvxDistributeVerticalNone);
//STRIP001 
//STRIP001 	if(maBtnHorLeft.IsChecked())
//STRIP001 		eDistributeHor = SvxDistributeHorizontalLeft;
//STRIP001 	else if(maBtnHorCenter.IsChecked())
//STRIP001 		eDistributeHor = SvxDistributeHorizontalCenter;
//STRIP001 	else if(maBtnHorDistance.IsChecked())
//STRIP001 		eDistributeHor = SvxDistributeHorizontalDistance;
//STRIP001 	else if(maBtnHorRight.IsChecked())
//STRIP001 		eDistributeHor = SvxDistributeHorizontalRight;
//STRIP001 
//STRIP001 	if(maBtnVerTop.IsChecked())
//STRIP001 		eDistributeVer = SvxDistributeVerticalTop;
//STRIP001 	else if(maBtnVerCenter.IsChecked())
//STRIP001 		eDistributeVer = SvxDistributeVerticalCenter;
//STRIP001 	else if(maBtnVerDistance.IsChecked())
//STRIP001 		eDistributeVer = SvxDistributeVerticalDistance;
//STRIP001 	else if(maBtnVerBottom.IsChecked())
//STRIP001 		eDistributeVer = SvxDistributeVerticalBottom;
//STRIP001 
//STRIP001 	if(eDistributeHor != meDistributeHor || eDistributeVer != meDistributeVer)
//STRIP001 	{
//STRIP001 		meDistributeHor = eDistributeHor;
//STRIP001 		meDistributeVer = eDistributeVer;
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }


}
