/*************************************************************************
 *
 *  $RCSfile: svx_langtab.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// include ---------------------------------------------------------------

#include "dialogs.hrc" // -> RID_SVXSTR_LANGUAGE_TABLE
#include "dialmgr.hxx"
#include "langtab.hxx"

#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
namespace binfilter {

//------------------------------------------------------------------------

//STRIP001 SvxLanguageTable::SvxLanguageTable() :
//STRIP001 
//STRIP001 	ResStringArray( SVX_RES( RID_SVXSTR_LANGUAGE_TABLE ) )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxLanguageTable::~SvxLanguageTable()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 const String& SvxLanguageTable::GetString( const LanguageType eType ) const
//STRIP001 {
//STRIP001     // no_NO is an alias for nb_NO
//STRIP001     LanguageType eLang = (eType == LANGUAGE_NORWEGIAN ?
//STRIP001             LANGUAGE_NORWEGIAN_BOKMAL : eType);
//STRIP001 	USHORT nPos = FindIndex( (long)eLang );
//STRIP001 
//STRIP001 	if ( RESARRAY_INDEX_NOTFOUND != nPos && nPos < Count() )
//STRIP001 		return ResStringArray::GetString( nPos );
//STRIP001 	else
//STRIP001 	{
//STRIP001         // If we knew what a simple "en" should alias to (en_US?) we could
//STRIP001         // generally raise an error.
//STRIP001         if ( LANGUAGE_ENGLISH != eLang )
//STRIP001             DBG_ERROR( "language entry not found in resource" );
//STRIP001         
//STRIP001         nPos = FindIndex( (long)LANGUAGE_DONTKNOW );
//STRIP001 
//STRIP001 		if ( RESARRAY_INDEX_NOTFOUND != nPos && nPos < Count() )
//STRIP001 			return ResStringArray::GetString( nPos );
//STRIP001 	}
//STRIP001 	return String();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 LanguageType SvxLanguageTable::GetType( const String& rStr ) const
//STRIP001 {
//STRIP001 	LanguageType eType = LANGUAGE_DONTKNOW;
//STRIP001 	USHORT nCount = Count();
//STRIP001 
//STRIP001 	for ( USHORT i = 0; i < nCount; ++i )
//STRIP001 		if ( rStr == ResStringArray::GetString( i ) )
//STRIP001 		{
//STRIP001 			eType = LanguageType( GetValue( i ) );
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	return eType;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SvxLanguageTable::GetEntryCount() const
//STRIP001 {
//STRIP001 	return Count();
//STRIP001 }
//STRIP001 	
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 LanguageType SvxLanguageTable::GetTypeAtIndex( USHORT nIndex ) const
//STRIP001 {
//STRIP001 	LanguageType nType = LANGUAGE_DONTKNOW;
//STRIP001 	if (nIndex < Count())
//STRIP001 		nType = LanguageType( GetValue( nIndex ) );
//STRIP001 	return nType;
//STRIP001 }

//------------------------------------------------------------------------

}
