/*************************************************************************
 *
 *  $RCSfile: svx_SvXMLAutoCorrectImport.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:33:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Martin Gallwey (gallwey@sun.com)
 *
 *
 ************************************************************************/
// auto strip #ifndef _SV_XMLAUTOCORRECTIMPORT_HXX
// auto strip #include <SvXMLAutoCorrectImport.hxx>
// auto strip #endif
#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#define _SVSTDARR_STRINGSISORTDTOR
#define _SVSTDARR_STRINGSDTOR
// auto strip #include <svtools/svstdarr.hxx>
#ifndef _XMLOFF_XMLTOKEN_HXX
#include <bf_xmloff/xmltoken.hxx>
#endif
namespace binfilter {

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star;
using namespace ::binfilter::xmloff::token;
using namespace ::rtl;

//STRIP001 static OUString sBlockList ( RTL_CONSTASCII_USTRINGPARAM ( "_block-list" ) );

// #110680#
//STRIP001 SvXMLAutoCorrectImport::SvXMLAutoCorrectImport( 
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 	SvxAutocorrWordList *pNewAutocorr_List, 
//STRIP001 	SvxAutoCorrect &rNewAutoCorrect, 
//STRIP001 	SvStorageRef &rNewStorage)
//STRIP001 :	SvXMLImport( xServiceFactory ),
//STRIP001 	pAutocorr_List (pNewAutocorr_List), 
//STRIP001 	rAutoCorrect ( rNewAutoCorrect ), 
//STRIP001 	rStorage ( rNewStorage )
//STRIP001 {
//STRIP001 	GetNamespaceMap().Add( 
//STRIP001 			sBlockList,
//STRIP001 			GetXMLToken ( XML_N_BLOCK_LIST), 
//STRIP001 			XML_NAMESPACE_BLOCKLIST );
//STRIP001 }

//STRIP001 SvXMLAutoCorrectImport::~SvXMLAutoCorrectImport ( void ) throw ()
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SvXMLAutoCorrectImport::CreateContext(
//STRIP001 		sal_uInt16 nPrefix,
//STRIP001 		const OUString& rLocalName,
//STRIP001 		const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 
//STRIP001 	if( XML_NAMESPACE_BLOCKLIST == nPrefix &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BLOCK_LIST ) )
//STRIP001 		pContext = new SvXMLWordListContext( *this, nPrefix, rLocalName, xAttrList );
//STRIP001 	else
//STRIP001 		pContext = SvXMLImport::CreateContext( nPrefix, rLocalName, xAttrList );
//STRIP001 	return pContext;
//STRIP001 }

//STRIP001 SvXMLWordListContext::SvXMLWordListContext(
//STRIP001    SvXMLAutoCorrectImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001    rLocalRef(rImport),
//STRIP001    SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SvXMLWordListContext::CreateChildContext(
//STRIP001 	sal_uInt16 nPrefix,
//STRIP001 	const OUString& rLocalName,
//STRIP001 	const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 
//STRIP001 	if (nPrefix == XML_NAMESPACE_BLOCKLIST &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BLOCK ) )
//STRIP001 		pContext = new SvXMLWordContext (rLocalRef, nPrefix, rLocalName, xAttrList);
//STRIP001 	else
//STRIP001 		pContext = new SvXMLImportContext( rLocalRef, nPrefix, rLocalName);
//STRIP001 	return pContext;
//STRIP001 }
//STRIP001 SvXMLWordListContext::~SvXMLWordListContext ( void )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLWordContext::SvXMLWordContext(
//STRIP001    SvXMLAutoCorrectImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001    rLocalRef(rImport),
//STRIP001    SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 	String sRight, sWrong;
//STRIP001 	sal_Int16 nAttrCount = xAttrList.is() ? xAttrList->getLength() : 0;
//STRIP001 
//STRIP001 	for (sal_Int16 i=0; i < nAttrCount; i++)
//STRIP001 	{
//STRIP001 		const OUString& rAttrName = xAttrList->getNameByIndex( i );
//STRIP001 		OUString aLocalName;
//STRIP001 		sal_uInt16 nPrefix = rImport.GetNamespaceMap().GetKeyByAttrName( rAttrName, &aLocalName);
//STRIP001 		const OUString& rAttrValue = xAttrList->getValueByIndex( i );
//STRIP001 		if (XML_NAMESPACE_BLOCKLIST == nPrefix)
//STRIP001 		{
//STRIP001 			if ( IsXMLToken ( aLocalName, XML_ABBREVIATED_NAME ) )
//STRIP001 			{
//STRIP001 				sWrong = rAttrValue;
//STRIP001 			}
//STRIP001 			else if ( IsXMLToken ( aLocalName, XML_NAME ) )
//STRIP001 			{
//STRIP001 				sRight = rAttrValue;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (!sWrong.Len() || !sRight.Len() )
//STRIP001 		return;
//STRIP001 
//STRIP001 //	const International& rInter = Application::GetAppInternational();
//STRIP001 //	BOOL bOnlyTxt = COMPARE_EQUAL != rInter.Compare( sRight, sWrong, INTN_COMPARE_IGNORECASE );
//STRIP001 	BOOL bOnlyTxt = sRight != sWrong;
//STRIP001 	if( !bOnlyTxt )
//STRIP001 	{
//STRIP001 		String sLongSave( sRight );
//STRIP001 		if( !rLocalRef.rAutoCorrect.GetLongText( rLocalRef.rStorage, sWrong, sRight ) &&
//STRIP001 			sLongSave.Len() )
//STRIP001 		{
//STRIP001 			sRight = sLongSave;
//STRIP001 			bOnlyTxt = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SvxAutocorrWordPtr pNew = new SvxAutocorrWord( sWrong, sRight, bOnlyTxt );
//STRIP001 
//STRIP001 	if( !rLocalRef.pAutocorr_List->Insert( pNew ) )
//STRIP001 		delete pNew;
//STRIP001 }

//STRIP001 SvXMLWordContext::~SvXMLWordContext ( void )
//STRIP001 {
//STRIP001 }
// #110680#
//STRIP001 SvXMLExceptionListImport::SvXMLExceptionListImport( 
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 	SvStringsISortDtor & rNewList )
//STRIP001 :	SvXMLImport( xServiceFactory ),
//STRIP001 	rList (rNewList)
//STRIP001 {
//STRIP001 	GetNamespaceMap().Add( 
//STRIP001 			sBlockList,
//STRIP001 			GetXMLToken ( XML_N_BLOCK_LIST), 
//STRIP001 			XML_NAMESPACE_BLOCKLIST );
//STRIP001 }

//STRIP001 SvXMLExceptionListImport::~SvXMLExceptionListImport ( void ) throw ()
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SvXMLExceptionListImport::CreateContext(
//STRIP001 		sal_uInt16 nPrefix,
//STRIP001 		const OUString& rLocalName,
//STRIP001 		const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 
//STRIP001 	if( XML_NAMESPACE_BLOCKLIST==nPrefix &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BLOCK_LIST ) )
//STRIP001 		pContext = new SvXMLExceptionListContext( *this, nPrefix, rLocalName, xAttrList );
//STRIP001 	else
//STRIP001 		pContext = SvXMLImport::CreateContext( nPrefix, rLocalName, xAttrList );
//STRIP001 	return pContext;
//STRIP001 }

//STRIP001 SvXMLExceptionListContext::SvXMLExceptionListContext(
//STRIP001    SvXMLExceptionListImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001    rLocalRef(rImport),
//STRIP001    SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SvXMLExceptionListContext::CreateChildContext(
//STRIP001 	sal_uInt16 nPrefix,
//STRIP001 	const OUString& rLocalName,
//STRIP001 	const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 
//STRIP001 	if (nPrefix == XML_NAMESPACE_BLOCKLIST &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BLOCK ) )
//STRIP001 		pContext = new SvXMLExceptionContext (rLocalRef, nPrefix, rLocalName, xAttrList);
//STRIP001 	else
//STRIP001 		pContext = new SvXMLImportContext( rLocalRef, nPrefix, rLocalName);
//STRIP001 	return pContext;
//STRIP001 }
//STRIP001 SvXMLExceptionListContext::~SvXMLExceptionListContext ( void )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLExceptionContext::SvXMLExceptionContext(
//STRIP001    SvXMLExceptionListImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001    rLocalRef(rImport),
//STRIP001    SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 	String sWord;
//STRIP001 	sal_Int16 nAttrCount = xAttrList.is() ? xAttrList->getLength() : 0;
//STRIP001 
//STRIP001 	for (sal_Int16 i=0; i < nAttrCount; i++)
//STRIP001 	{
//STRIP001 		const OUString& rAttrName = xAttrList->getNameByIndex( i );
//STRIP001 		OUString aLocalName;
//STRIP001 		sal_uInt16 nPrefix = rImport.GetNamespaceMap().GetKeyByAttrName( rAttrName, &aLocalName);
//STRIP001 		const OUString& rAttrValue = xAttrList->getValueByIndex( i );
//STRIP001 		if (XML_NAMESPACE_BLOCKLIST == nPrefix)
//STRIP001 		{
//STRIP001 			if ( IsXMLToken ( aLocalName, XML_ABBREVIATED_NAME ) )
//STRIP001 			{
//STRIP001 				sWord = rAttrValue;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (!sWord.Len() )
//STRIP001 		return;
//STRIP001 
//STRIP001 	String * pNew = new String( sWord );
//STRIP001 
//STRIP001 	if( !rLocalRef.rList.Insert( pNew ) )
//STRIP001 		delete pNew;
//STRIP001 }

//STRIP001 SvXMLExceptionContext::~SvXMLExceptionContext ( void )
//STRIP001 {
//STRIP001 }
}
