/*************************************************************************
 *
 *  $RCSfile: svx_edtspell.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:35:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <eeng_pch.hxx>

#pragma hdrstop

// auto strip #ifndef _SV_OUTDEV_HXX
// auto strip #include <vcl/outdev.hxx>
// auto strip #endif

// auto strip #ifndef _VCL_POINTR_HXX
// auto strip #include <vcl/pointr.hxx>
// auto strip #endif

#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif

#include <impedit.hxx>
// auto strip #include <editview.hxx>
// auto strip #include <editeng.hxx>
// auto strip #include <edtspell.hxx>

// auto strip #ifndef _PSTM_HXX //autogen
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

// auto strip #ifndef _SFXPOOLITEM_HXX //autogen
// auto strip #include <svtools/poolitem.hxx>
// auto strip #endif

#ifndef _SVX_ITEMDATA_HXX
#include "itemdata.hxx"
#endif

// auto strip #ifndef _DATE_HXX //autogen
// auto strip #include <tools/date.hxx>
// auto strip #endif

// auto strip #ifndef _TIME_HXX //autogen
// auto strip #include <tools/time.hxx>
// auto strip #endif

// auto strip #include <flditem.hxx>
// auto strip #include <fontitem.hxx>
// auto strip #include <svtools/intitem.hxx>

// auto strip #ifndef _UNO_LINGU_HXX
// auto strip #include <unolingu.hxx>
// auto strip #endif
// auto strip #ifndef _LINGUISTIC_LNGPROPS_HHX_
// auto strip #include <bf_linguistic/lngprops.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
// auto strip #include <com/sun/star/beans/XPropertySet.hpp>
// auto strip #endif
namespace binfilter {

using namespace rtl;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::linguistic2;


//STRIP001 EditSpellWrapper::EditSpellWrapper( Window* pWin,
//STRIP001 		Reference< XSpellChecker1 >  &xChecker,
//STRIP001 		sal_Bool bIsStart, sal_Bool bIsAllRight, EditView* pView ) :
//STRIP001 	SvxSpellWrapper( pWin, xChecker, bIsStart, bIsAllRight )
//STRIP001 {
//STRIP001 	DBG_ASSERT( pView, "Es muss eine View uebergeben werden!" );
//STRIP001 	// IgnoreList behalten, ReplaceList loeschen...
//STRIP001 	if (SvxGetChangeAllList().is())
//STRIP001 		SvxGetChangeAllList()->clear();
//STRIP001 	pEditView = pView;
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::SpellStart( SvxSpellArea eArea )
//STRIP001 {
//STRIP001 	ImpEditEngine* pImpEE = pEditView->GetImpEditEngine();
//STRIP001 	SpellInfo* pSpellInfo = pImpEE->GetSpellInfo();
//STRIP001 	sal_Bool bForward = !IsSpellReverse();
//STRIP001 
//STRIP001 	if ( eArea == SVX_SPELL_BODY_START )
//STRIP001 	{
//STRIP001 		// Wird gerufen, wenn
//STRIP001 		// a) Spell-Forwad ist am Ende angekomment und soll von vorne beginnen
//STRIP001 		// b) Spell-Backward wird gestartet
//STRIP001 		// IsEndDone() liefert auch sal_True, wenn Rueckwaerts-Spelling am Ende gestartet wird!
//STRIP001 		if ( IsEndDone() && bForward )
//STRIP001 		{
//STRIP001 			pSpellInfo->bSpellToEnd = sal_False;
//STRIP001 			pSpellInfo->aSpellTo = pSpellInfo->aSpellStart;
//STRIP001 			pEditView->GetImpEditView()->SetEditSelection(
//STRIP001 					pImpEE->GetEditDoc().GetStartPaM() );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pSpellInfo->bSpellToEnd = sal_True;
//STRIP001 			pSpellInfo->aSpellTo = pImpEE->CreateEPaM(
//STRIP001 					pImpEE->GetEditDoc().GetStartPaM() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( eArea == SVX_SPELL_BODY_END )
//STRIP001 	{
//STRIP001 		// Wird gerufen, wenn
//STRIP001 		// a) Spell-Forwad wird gestartet
//STRIP001 		// b) Spell-Backward ist am Anfang angekomment und soll von hinten beginnen
//STRIP001 		// IsStartDone() liefert auch sal_True, wenn Vorwaerts-Spelling am Anfang gestartet wird!
//STRIP001 		if ( !IsStartDone() || bForward )
//STRIP001 		{
//STRIP001 			pSpellInfo->bSpellToEnd = sal_True;
//STRIP001 			pSpellInfo->aSpellTo = pImpEE->CreateEPaM(
//STRIP001 					pImpEE->GetEditDoc().GetEndPaM() );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pSpellInfo->bSpellToEnd = sal_False;
//STRIP001 			pSpellInfo->aSpellTo = pSpellInfo->aSpellStart;
//STRIP001 			pEditView->GetImpEditView()->SetEditSelection(
//STRIP001 					pImpEE->GetEditDoc().GetEndPaM() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( eArea == SVX_SPELL_BODY )
//STRIP001 	{
//STRIP001 		;	// Wird ueber SpellNextDocument von App gehandelt
//STRIP001 
//STRIP001 		// pSpellInfo->bSpellToEnd = sal_True;
//STRIP001 		// pSpellInfo->aSpellTo = pImpEE->CreateEPaM( pImpEE->GetEditDoc().GetEndPaM() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		DBG_ERROR( "SpellStart: Unknown Area!" );
//STRIP001 	}
//STRIP001 }

//STRIP001 sal_Bool EditSpellWrapper::SpellContinue()
//STRIP001 {
//STRIP001 	SetLast( pEditView->GetImpEditEngine()->ImpSpell( pEditView ) );
//STRIP001 	return GetLast().is();
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::SpellEnd()
//STRIP001 {
//STRIP001 	// Keine weitere Aktion noetig...
//STRIP001 }

//STRIP001 sal_Bool __EXPORT EditSpellWrapper::HasOtherCnt()
//STRIP001 {
//STRIP001 	return sal_False;
//STRIP001 }

//STRIP001 sal_Bool __EXPORT EditSpellWrapper::SpellMore()
//STRIP001 {
//STRIP001 	ImpEditEngine* pImpEE = pEditView->GetImpEditEngine();
//STRIP001 	SpellInfo* pSpellInfo = pImpEE->GetSpellInfo();
//STRIP001 	sal_Bool bMore = sal_False;
//STRIP001 	if ( pSpellInfo->bMultipleDoc )
//STRIP001 	{
//STRIP001 		bMore = pImpEE->GetEditEnginePtr()->SpellNextDocument();
//STRIP001 		if ( bMore )
//STRIP001 		{
//STRIP001 			// Der Text wurde in diese Engine getreten, bei Rueckwaerts
//STRIP001 			// muss die Selektion hinten sein.
//STRIP001 			Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
//STRIP001 			sal_Bool bIsWrapReverse = IsSpellReverse();
//STRIP001 			if ( bIsWrapReverse )
//STRIP001 				pEditView->GetImpEditView()->SetEditSelection(
//STRIP001 						pImpEE->GetEditDoc().GetEndPaM() );
//STRIP001 			else
//STRIP001 				pEditView->GetImpEditView()->SetEditSelection(
//STRIP001 						pImpEE->GetEditDoc().GetStartPaM() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bMore;
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::ScrollArea()
//STRIP001 {
//STRIP001 	// Keine weitere Aktion noetig...
//STRIP001 	// Es sei denn, der Bereich soll in die Mitte gescrollt werden,
//STRIP001 	// und nicht irgendwo stehen.
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::ReplaceAll( const String &rNewText,
//STRIP001 			sal_Int16 nLanguage )
//STRIP001 {
//STRIP001 	// Wird gerufen, wenn Wort in ReplaceList des SpellCheckers
//STRIP001 	pEditView->InsertText( rNewText );
//STRIP001 	CheckSpellTo();
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::ChangeWord( const String& rNewWord,
//STRIP001 			const sal_uInt16 nLang )
//STRIP001 {
//STRIP001 	// Wird gerufen, wenn Wort Button Change
//STRIP001 	// bzw. intern von mir bei ChangeAll
//STRIP001 
//STRIP001 	// Wenn Punkt hinterm Wort, wird dieser nicht mitgegeben.
//STRIP001 	// Falls '"' => PreStripped.
//STRIP001 	String aNewWord( rNewWord );
//STRIP001 	pEditView->InsertText( aNewWord );
//STRIP001 	CheckSpellTo();
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::ChangeThesWord( const String& rNewWord )
//STRIP001 {
//STRIP001 	pEditView->InsertText( rNewWord );
//STRIP001 	CheckSpellTo();
//STRIP001 }

//STRIP001 void __EXPORT EditSpellWrapper::AutoCorrect( const String& rOldWord,
//STRIP001 			const String& rNewWord )
//STRIP001 {
//STRIP001 }

//STRIP001 void EditSpellWrapper::CheckSpellTo()
//STRIP001 {
//STRIP001 	ImpEditEngine* pImpEE = pEditView->GetImpEditEngine();
//STRIP001 	SpellInfo* pSpellInfo = pImpEE->GetSpellInfo();
//STRIP001 	EditPaM aPaM( pEditView->GetImpEditView()->GetEditSelection().Max() );
//STRIP001 	EPaM aEPaM = pImpEE->CreateEPaM( aPaM );
//STRIP001 	if ( aEPaM.nPara == pSpellInfo->aSpellTo.nPara )
//STRIP001 	{
//STRIP001 		// prueffen, ob SpellToEnd noch gueltiger Index, falls in dem Absatz
//STRIP001 		// ersetzt wurde.
//STRIP001 		if ( pSpellInfo->aSpellTo.nIndex > aPaM.GetNode()->Len() )
//STRIP001 			pSpellInfo->aSpellTo.nIndex = aPaM.GetNode()->Len();
//STRIP001 	}
//STRIP001 }

//STRIP001 BOOL EditSpellWrapper::IsSpellReverse()
//STRIP001 {
//STRIP001 	Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
//STRIP001 	sal_Bool bIsWrapReverse = sal_False;
//STRIP001 	if ( xProp.is() )
//STRIP001 	{
//STRIP001 		Any aVal = xProp->getPropertyValue( OUString(
//STRIP001 				RTL_CONSTASCII_USTRINGPARAM( UPN_IS_WRAP_REVERSE ) ) );
//STRIP001 		aVal >>= bIsWrapReverse;
//STRIP001 	}
//STRIP001 	return bIsWrapReverse;
//STRIP001 }

/*N*/ SV_IMPL_VARARR( WrongRanges, WrongRange );

/*N*/ WrongList::WrongList()
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 /*?*/ 	nInvalidStart = 0;
//STRIP001 /*?*/ 	nInvalidEnd = 0xFFFF;
/*N*/ }

/*N*/ WrongList::~WrongList()
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//STRIP001 void WrongList::TextInserted( sal_uInt16 nPos, sal_uInt16 nNew, sal_Bool bPosIsSep )
//STRIP001 {
//STRIP001 	if ( !IsInvalid() )
//STRIP001 	{
//STRIP001 		nInvalidStart = nPos;
//STRIP001 		nInvalidEnd = nPos+nNew;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( nInvalidStart > nPos )
//STRIP001 			nInvalidStart = nPos;
//STRIP001 		if ( nInvalidEnd >= nPos )
//STRIP001 			nInvalidEnd += nNew;
//STRIP001 		else
//STRIP001 			nInvalidEnd = nPos+nNew;
//STRIP001 	}
//STRIP001 
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		sal_Bool bRefIsValid = sal_True;
//STRIP001 		if ( rWrong.nEnd >= nPos )
//STRIP001 		{
//STRIP001 			// Alle Wrongs hinter der Einfuegeposition verschieben...
//STRIP001 			if ( rWrong.nStart > nPos )
//STRIP001 			{
//STRIP001 				rWrong.nStart += nNew;
//STRIP001 				rWrong.nEnd += nNew;
//STRIP001 			}
//STRIP001 			// 1: Startet davor, geht bis nPos...
//STRIP001 			else if ( rWrong.nEnd == nPos )
//STRIP001 			{
//STRIP001 				// Sollte bei einem Blank unterbunden werden!
//STRIP001 				if ( !bPosIsSep )
//STRIP001 					rWrong.nEnd += nNew;
//STRIP001 			}
//STRIP001 			// 2: Startet davor, geht hinter Pos...
//STRIP001 			else if ( ( rWrong.nStart < nPos ) && ( rWrong.nEnd > nPos ) )
//STRIP001 			{
//STRIP001 				rWrong.nEnd += nNew;
//STRIP001 				// Bei einem Trenner das Wrong entfernen und neu pruefen
//STRIP001 				if ( bPosIsSep )
//STRIP001 				{
//STRIP001 					// Wrong aufteilen...
//STRIP001 					WrongRange aNewWrong( rWrong.nStart, nPos );
//STRIP001 					rWrong.nStart = nPos+1;
//STRIP001 					Insert( aNewWrong, n );
//STRIP001 					bRefIsValid = sal_False;	// Referenz nach Insert nicht mehr gueltig, der andere wurde davor an dessen Position eingefuegt
//STRIP001 					n++; // Diesen nicht nochmal...
//STRIP001 				}
//STRIP001 			}
//STRIP001 			// 3: Attribut startet auf Pos...
//STRIP001 			else if ( rWrong.nStart == nPos )
//STRIP001 			{
//STRIP001 				rWrong.nEnd += nNew;
//STRIP001 				if ( bPosIsSep )
//STRIP001 					rWrong.nStart++;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		DBG_ASSERT( !bRefIsValid || ( rWrong.nStart < rWrong.nEnd ),
//STRIP001 				"TextInserted, WrongRange: Start >= End?!" );
//STRIP001 	}
//STRIP001 
//STRIP001 	DBG_ASSERT( !DbgIsBuggy(), "InsertWrong: WrongList kaputt!" );
//STRIP001 }

//STRIP001 void WrongList::TextDeleted( sal_uInt16 nPos, sal_uInt16 nDeleted )
//STRIP001 {
//STRIP001 	sal_uInt16 nEndChanges = nPos+nDeleted;
//STRIP001 	if ( !IsInvalid() )
//STRIP001 	{
//STRIP001 		nInvalidStart = nPos;
//STRIP001 		nInvalidEnd = nPos+1;	// Nicht nDeleted, weil da ja wegfaellt.
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( nInvalidStart > nPos )
//STRIP001 			nInvalidStart = nPos;
//STRIP001 		if ( nInvalidEnd > nPos )
//STRIP001 		{
//STRIP001 			if ( nInvalidEnd > nEndChanges )
//STRIP001 				nInvalidEnd -=nDeleted;
//STRIP001 			else
//STRIP001 				nInvalidEnd = nPos+1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		sal_Bool bDelWrong = sal_False;
//STRIP001 		if ( rWrong.nEnd >= nPos )
//STRIP001 		{
//STRIP001 			// Alles Wrongs hinter der Einfuegeposition verschieben...
//STRIP001 			if ( rWrong.nStart >= nEndChanges )
//STRIP001 			{
//STRIP001 				rWrong.nStart -= nDeleted;
//STRIP001 				rWrong.nEnd -= nDeleted;
//STRIP001 			}
//STRIP001 			// 1. Innenliegende Wrongs loeschen...
//STRIP001 			else if ( ( rWrong.nStart >= nPos ) && ( rWrong.nEnd <= nEndChanges ) )
//STRIP001 			{
//STRIP001 				bDelWrong = sal_True;
//STRIP001 			}
//STRIP001 			// 2. Wrong beginnt davor, endet drinnen oder dahinter...
//STRIP001 			else if ( ( rWrong.nStart <= nPos ) && ( rWrong.nEnd > nPos ) )
//STRIP001 			{
//STRIP001 				if ( rWrong.nEnd <= nEndChanges )	// endet drinnen
//STRIP001 					rWrong.nEnd = nPos;
//STRIP001 				else
//STRIP001 					rWrong.nEnd -= nDeleted;		// endet dahinter
//STRIP001 			}
//STRIP001 			// 3. Wrong beginnt drinnen, endet dahinter...
//STRIP001 			else if ( ( rWrong.nStart >= nPos ) && ( rWrong.nEnd > nEndChanges ) )
//STRIP001 			{
//STRIP001 				rWrong.nStart = nEndChanges;
//STRIP001 				rWrong.nStart -= nDeleted;
//STRIP001 				rWrong.nEnd -= nDeleted;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		DBG_ASSERT( rWrong.nStart < rWrong.nEnd,
//STRIP001 				"TextInserted, WrongRange: Start >= End?!" );
//STRIP001 		if ( bDelWrong )
//STRIP001 		{
//STRIP001 			Remove( n, 1 );
//STRIP001 			n--;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	DBG_ASSERT( !DbgIsBuggy(), "InsertWrong: WrongList kaputt!" );
//STRIP001 }

//STRIP001 sal_Bool WrongList::NextWrong( sal_uInt16& rnStart, sal_uInt16& rnEnd ) const
//STRIP001 {
//STRIP001 	/*
//STRIP001 		rnStart enthaelt die Startposition, wird ggf. auf Wrong-Start korrigiert
//STRIP001 		rnEnd braucht nicht inizialisiert sein.
//STRIP001 	*/
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		if ( rWrong.nEnd > rnStart )
//STRIP001 		{
//STRIP001 			rnStart = rWrong.nStart;
//STRIP001 			rnEnd = rWrong.nEnd;
//STRIP001 			return sal_True;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return sal_False;
//STRIP001 }

//STRIP001 sal_Bool WrongList::HasWrong( sal_uInt16 nStart, sal_uInt16 nEnd ) const
//STRIP001 {
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		if ( ( rWrong.nStart == nStart ) && ( rWrong.nEnd == nEnd ) )
//STRIP001 			return sal_True;
//STRIP001 		else if ( rWrong.nStart >= nStart )
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	return sal_False;
//STRIP001 }

//STRIP001 sal_Bool WrongList::HasAnyWrong( sal_uInt16 nStart, sal_uInt16 nEnd ) const
//STRIP001 {
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		if ( ( rWrong.nEnd >= nStart ) && ( rWrong.nStart < nEnd ) )
//STRIP001 			return sal_True;
//STRIP001 		else if ( rWrong.nStart >= nEnd )
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	return sal_False;
//STRIP001 }

//STRIP001 void WrongList::ClearWrongs( sal_uInt16 nStart, sal_uInt16 nEnd,
//STRIP001 			const ContentNode* pNode )
//STRIP001 {
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		if ( ( rWrong.nEnd > nStart ) && ( rWrong.nStart < nEnd ) )
//STRIP001 		{
//STRIP001 			if ( rWrong.nEnd > nEnd )	// // Laeuft raus
//STRIP001 			{
//STRIP001 				rWrong.nStart = nEnd;
//STRIP001 				// Blanks?
//STRIP001 				while ( ( rWrong.nStart < pNode->Len() ) &&
//STRIP001 							( ( pNode->GetChar( rWrong.nStart ) == ' ' ) ||
//STRIP001 							  ( pNode->IsFeature( rWrong.nStart ) ) ) )
//STRIP001 				{
//STRIP001 					rWrong.nStart++;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				Remove( n, 1 );
//STRIP001 				n--;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	DBG_ASSERT( !DbgIsBuggy(), "InsertWrong: WrongList kaputt!" );
//STRIP001 }

//STRIP001 void WrongList::InsertWrong( sal_uInt16 nStart, sal_uInt16 nEnd,
//STRIP001 			sal_Bool bClearRange )
//STRIP001 {
//STRIP001 	sal_uInt16 nPos = Count();
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		if ( rWrong.nStart >= nStart )
//STRIP001 		{
//STRIP001 			nPos = n;
//STRIP001 			if ( bClearRange )
//STRIP001 			{
//STRIP001 				// Es kann eigentlich nur Passieren, dass der Wrong genau
//STRIP001 				// hier beginnt und weiter rauslauft, aber nicht, dass hier
//STRIP001 				// mehrere im Bereich liegen...
//STRIP001 				// Genau im Bereich darf keiner liegen, sonst darf diese Methode
//STRIP001 				// garnicht erst gerufen werden!
//STRIP001 				DBG_ASSERT( ( ( rWrong.nStart == nStart ) && ( rWrong.nEnd > nEnd ) )
//STRIP001 								|| ( rWrong.nStart > nEnd ), "InsertWrong: RangeMismatch!" );
//STRIP001 				if ( ( rWrong.nStart == nStart ) && ( rWrong.nEnd > nEnd ) )
//STRIP001 					rWrong.nStart = nEnd+1;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	Insert( WrongRange( nStart, nEnd ), nPos );
//STRIP001 
//STRIP001 	DBG_ASSERT( !DbgIsBuggy(), "InsertWrong: WrongList kaputt!" );
//STRIP001 }

//STRIP001 void WrongList::MarkWrongsInvalid()
//STRIP001 {
//STRIP001 	if ( Count() )
//STRIP001 		MarkInvalid( GetObject( 0 ).nStart, GetObject( Count()-1 ).nEnd );
//STRIP001 }

//STRIP001 WrongList*	WrongList::Clone() const
//STRIP001 {
//STRIP001 	WrongList* pNew = new WrongList;
//STRIP001 	for ( sal_uInt16 n = 0; n < Count(); n++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( n );
//STRIP001 		pNew->Insert( rWrong, pNew->Count() );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pNew;
//STRIP001 }


#ifdef DBG_UTIL
//STRIP001 sal_Bool WrongList::DbgIsBuggy() const
//STRIP001 {
//STRIP001 	// Pruefen, ob sich Bereiche ueberlappen
//STRIP001 	sal_Bool bError = sal_False;
//STRIP001 	for ( sal_uInt16 nA = 0; !bError && ( nA < Count() ); nA++ )
//STRIP001 	{
//STRIP001 		WrongRange& rWrong = GetObject( nA );
//STRIP001 		for ( sal_uInt16 nB = nA+1; !bError && ( nB < Count() ); nB++ )
//STRIP001 		{
//STRIP001 			WrongRange& rNextWrong = GetObject( nB );
//STRIP001 			// 1) Start davor, End hinterm anderen Start
//STRIP001 			if (   ( rWrong.nStart <= rNextWrong.nStart )
//STRIP001 				&& ( rWrong.nEnd >= rNextWrong.nStart ) )
//STRIP001 				bError = sal_True;
//STRIP001 			// 2) Start hinter anderen Start, aber noch vorm anderen End
//STRIP001 			else if (   ( rWrong.nStart >= rNextWrong.nStart)
//STRIP001 					 && ( rWrong.nStart <= rNextWrong.nEnd ) )
//STRIP001 				bError = sal_True;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bError;
//STRIP001 }
#endif


//STRIP001 EdtAutoCorrDoc::EdtAutoCorrDoc( ImpEditEngine* pE, ContentNode* pN,
//STRIP001 			sal_uInt16 nCrsr, xub_Unicode cIns )
//STRIP001 {
//STRIP001 	pImpEE = pE;
//STRIP001 	pCurNode = pN;
//STRIP001 	nCursor = nCrsr;
//STRIP001 
//STRIP001 	bUndoAction = sal_False;
//STRIP001 	bAllowUndoAction = cIns ? sal_True : sal_False;
//STRIP001 }

//STRIP001 EdtAutoCorrDoc::~EdtAutoCorrDoc()
//STRIP001 {
//STRIP001 	if ( bUndoAction )
//STRIP001 		pImpEE->UndoActionEnd( EDITUNDO_INSERT );
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::Delete( sal_uInt16 nStt, sal_uInt16 nEnd )
//STRIP001 {
//STRIP001 	EditSelection aSel( EditPaM( pCurNode, nStt ), EditPaM( pCurNode, nEnd ) );
//STRIP001 	pImpEE->ImpDeleteSelection( aSel );
//STRIP001 	DBG_ASSERT( nCursor >= nEnd, "Cursor mitten im Geschehen ?!" );
//STRIP001 	nCursor -= ( nEnd-nStt );
//STRIP001 	bAllowUndoAction = sal_False;
//STRIP001 	return sal_True;
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::Insert( sal_uInt16 nPos, const String& rTxt )
//STRIP001 {
//STRIP001 	EditSelection aSel = EditPaM( pCurNode, nPos );
//STRIP001 	pImpEE->ImpInsertText( aSel, rTxt );
//STRIP001 	DBG_ASSERT( nCursor >= nPos, "Cursor mitten im Geschehen ?!" );
//STRIP001 	nCursor += rTxt.Len();
//STRIP001 
//STRIP001 	if ( bAllowUndoAction && ( rTxt.Len() == 1 ) )
//STRIP001 		ImplStartUndoAction();
//STRIP001 	bAllowUndoAction = sal_False;
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::Replace( sal_uInt16 nPos, const String& rTxt )
//STRIP001 {
//STRIP001 	// Eigentlich ein Replace einfuehren => Entspr. UNDO
//STRIP001 	sal_uInt16 nEnd = nPos+rTxt.Len();
//STRIP001 	if ( nEnd > pCurNode->Len() )
//STRIP001 		nEnd = pCurNode->Len();
//STRIP001 
//STRIP001     // #i5925# First insert new text behind to be deleted text, for keeping attributes.
//STRIP001 	pImpEE->ImpInsertText( EditSelection( EditPaM( pCurNode, nEnd ) ), rTxt );
//STRIP001 	pImpEE->ImpDeleteSelection( EditSelection( EditPaM( pCurNode, nPos ), EditPaM( pCurNode, nEnd ) ) );
//STRIP001 
//STRIP001     if ( nPos == nCursor )
//STRIP001 		nCursor += rTxt.Len();
//STRIP001 
//STRIP001 	if ( bAllowUndoAction && ( rTxt.Len() == 1 ) )
//STRIP001 		ImplStartUndoAction();
//STRIP001 
//STRIP001     bAllowUndoAction = sal_False;
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::SetAttr( sal_uInt16 nStt, sal_uInt16 nEnd,
//STRIP001 			sal_uInt16 nSlotId, SfxPoolItem& rItem )
//STRIP001 {
//STRIP001 	SfxItemPool* pPool = &pImpEE->GetEditDoc().GetItemPool();
//STRIP001 	while ( pPool->GetSecondaryPool() &&
//STRIP001 			pPool->GetName().EqualsAscii( "EditEngineItemPool" ) )
//STRIP001 	{
//STRIP001 		pPool = pPool->GetSecondaryPool();
//STRIP001 
//STRIP001 	}
//STRIP001 	sal_uInt16 nWhich = pPool->GetWhich( nSlotId );
//STRIP001 	if ( nWhich )
//STRIP001 	{
//STRIP001 		rItem.SetWhich( nWhich );
//STRIP001 
//STRIP001 		SfxItemSet aSet( pImpEE->GetEmptyItemSet() );
//STRIP001 		aSet.Put( rItem );
//STRIP001 
//STRIP001 		EditSelection aSel( EditPaM( pCurNode, nStt ), EditPaM( pCurNode, nEnd ) );
//STRIP001 		aSel.Max().SetIndex( nEnd );	// ???
//STRIP001 		pImpEE->SetAttribs( aSel, aSet, ATTRSPECIAL_EDGE );
//STRIP001 		bAllowUndoAction = sal_False;
//STRIP001 	}
//STRIP001 	return sal_True;
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::SetINetAttr( sal_uInt16 nStt, sal_uInt16 nEnd,
//STRIP001 			const String& rURL )
//STRIP001 {
//STRIP001 	// Aus dem Text ein Feldbefehl machen...
//STRIP001 	EditSelection aSel( EditPaM( pCurNode, nStt ), EditPaM( pCurNode, nEnd ) );
//STRIP001 	String aText = pImpEE->GetSelected( aSel );
//STRIP001 	aSel = pImpEE->ImpDeleteSelection( aSel );
//STRIP001 	DBG_ASSERT( nCursor >= nEnd, "Cursor mitten im Geschehen ?!" );
//STRIP001 	nCursor -= ( nEnd-nStt );
//STRIP001 	SvxFieldItem aField( SvxURLField( rURL, aText, SVXURLFORMAT_REPR ),
//STRIP001 									  EE_FEATURE_FIELD  );
//STRIP001 	pImpEE->InsertField( aSel, aField );
//STRIP001 	nCursor++;
//STRIP001 	pImpEE->UpdateFields();
//STRIP001 	bAllowUndoAction = sal_False;
//STRIP001 	return sal_True;
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::HasSymbolChars( sal_uInt16 nStt, sal_uInt16 nEnd )
//STRIP001 {
//STRIP001 	USHORT nScriptType = pImpEE->GetScriptType( EditPaM( pCurNode, nStt ) );
//STRIP001 	USHORT nScriptFontInfoItemId = GetScriptItemId( EE_CHAR_FONTINFO, nScriptType );
//STRIP001 
//STRIP001 	CharAttribArray& rAttribs = pCurNode->GetCharAttribs().GetAttribs();
//STRIP001 	sal_uInt16 nAttrs = rAttribs.Count();
//STRIP001 	for ( sal_uInt16 n = 0; n < nAttrs; n++ )
//STRIP001 	{
//STRIP001 		EditCharAttrib* pAttr = rAttribs.GetObject( n );
//STRIP001 		if ( pAttr->GetStart() >= nEnd )
//STRIP001 			return sal_False;
//STRIP001 
//STRIP001 		if ( ( pAttr->Which() == nScriptFontInfoItemId ) &&
//STRIP001 				( ((SvxFontItem*)pAttr->GetItem())->GetCharSet() == RTL_TEXTENCODING_SYMBOL ) )
//STRIP001 		{
//STRIP001 			// Pruefen, ob das Attribt im Bereich liegt...
//STRIP001 			if ( pAttr->GetEnd() >= nStt )
//STRIP001 				return sal_True;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return sal_False;
//STRIP001 }

//STRIP001 const String* EdtAutoCorrDoc::GetPrevPara( sal_Bool bAtNormalPos )
//STRIP001 {
//STRIP001 	// Vorherigen Absatz zurueck geben, damit ermittel werden kann,
//STRIP001 	// ob es sich beim aktuellen Wort um einen Satzanfang handelt.
//STRIP001 
//STRIP001 	bAllowUndoAction = sal_False;	// Jetzt nicht mehr...
//STRIP001 
//STRIP001 	ContentList& rNodes = pImpEE->GetEditDoc();
//STRIP001 	sal_uInt16 nPos = rNodes.GetPos( pCurNode );
//STRIP001 
//STRIP001 	// Sonderbehandlung: Bullet => Absatzanfang => einfach NULL returnen...
//STRIP001 	const SfxUInt16Item& rBulletState = (const SfxUInt16Item&)
//STRIP001 			pImpEE->GetParaAttrib( nPos, EE_PARA_BULLETSTATE );
//STRIP001 	sal_Bool bBullet = rBulletState.GetValue() ? sal_True : sal_False;
//STRIP001 	if ( !bBullet && ( pImpEE->aStatus.GetControlWord() & EE_CNTRL_OUTLINER ) )
//STRIP001 	{
//STRIP001 		// Der Outliner hat im Gliederungsmodus auf Ebene 0 immer ein Bullet.
//STRIP001 		const SfxUInt16Item& rLevel = (const SfxUInt16Item&)
//STRIP001 				pImpEE->GetParaAttrib( nPos, EE_PARA_OUTLLEVEL );
//STRIP001 		if ( rLevel.GetValue() == 0 )
//STRIP001 			bBullet = sal_True;
//STRIP001 	}
//STRIP001 	if ( bBullet )
//STRIP001 		return NULL;
//STRIP001 
//STRIP001 	for ( sal_uInt16 n = nPos; n; )
//STRIP001 	{
//STRIP001 		n--;
//STRIP001 		ContentNode* pNode = rNodes[n];
//STRIP001 		if ( pNode->Len() )
//STRIP001 			return pNode;
//STRIP001 	}
//STRIP001 	return NULL;
//STRIP001 
//STRIP001 }

//STRIP001 sal_Bool EdtAutoCorrDoc::ChgAutoCorrWord( sal_uInt16& rSttPos,
//STRIP001 			sal_uInt16 nEndPos, SvxAutoCorrect& rACorrect, 
//STRIP001 			const String** ppPara )
//STRIP001 {
//STRIP001 	// Absatz-Anfang oder ein Blank gefunden, suche nach dem Wort
//STRIP001 	// Kuerzel im Auto
//STRIP001 	
//STRIP001 	bAllowUndoAction = sal_False;	// Jetzt nicht mehr...
//STRIP001 	
//STRIP001 	String aShort( pCurNode->Copy( rSttPos, nEndPos - rSttPos ) );
//STRIP001 	sal_Bool bRet = sal_False;
//STRIP001 
//STRIP001 	if( !aShort.Len() )
//STRIP001 		return bRet;
//STRIP001 
//STRIP001 	LanguageType eLang = pImpEE->GetLanguage( EditPaM( pCurNode, rSttPos+1 ) );
//STRIP001 	const SvxAutocorrWord* pFnd = rACorrect.SearchWordsInList( *pCurNode, rSttPos, nEndPos, *this, eLang );
//STRIP001 	if( pFnd && pFnd->IsTextOnly() )
//STRIP001 	{
//STRIP001 		// dann mal ersetzen
//STRIP001 		EditSelection aSel( EditPaM( pCurNode, rSttPos ), 
//STRIP001 							EditPaM( pCurNode, nEndPos ) );
//STRIP001 		aSel = pImpEE->ImpDeleteSelection( aSel );
//STRIP001 		DBG_ASSERT( nCursor >= nEndPos, "Cursor mitten im Geschehen ?!" );
//STRIP001 		nCursor -= ( nEndPos-rSttPos );
//STRIP001 		pImpEE->ImpInsertText( aSel, pFnd->GetLong() );
//STRIP001 		nCursor += pFnd->GetLong().Len();
//STRIP001 		if( ppPara )
//STRIP001 			*ppPara = pCurNode;
//STRIP001 		bRet = sal_True;
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 LanguageType EdtAutoCorrDoc::GetLanguage( sal_uInt16 nPos, sal_Bool bPrevPara ) const
//STRIP001 {
//STRIP001 	return pImpEE->GetLanguage( EditPaM( pCurNode, nPos+1 ) );
//STRIP001 }

//STRIP001 void EdtAutoCorrDoc::ImplStartUndoAction()
//STRIP001 {
//STRIP001 	sal_uInt16 nPara = pImpEE->GetEditDoc().GetPos( pCurNode );
//STRIP001 	ESelection aSel( nPara, nCursor, nPara, nCursor );
//STRIP001 	pImpEE->UndoActionStart( EDITUNDO_INSERT, aSel );
//STRIP001 	bUndoAction = sal_True;
//STRIP001 	bAllowUndoAction = sal_False;
//STRIP001 }

}
