/*************************************************************************
 *
 *  $RCSfile: svx_galbrws.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:53:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <vcl/split.hxx>
// auto strip #include <vcl/ctrl.hxx>
// auto strip #include <svtools/pathoptions.hxx>
#include <bf_sfx2/app.hxx>
#include <bf_sfx2/sfxsids.hrc>
#include "gallery.hrc"
// auto strip #include "galmisc.hxx"
// auto strip #include "gallery1.hxx"
// auto strip #include "galbrws1.hxx"
// auto strip #include "galbrws2.hxx"
#include "galbrws.hxx"
namespace binfilter {

// -------------------
// - GallerySplitter -
// -------------------

//STRIP001 class GallerySplitter : public Splitter
//STRIP001 {
//STRIP001 protected:
//STRIP001 
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001     
//STRIP001 public:
//STRIP001 
//STRIP001                     GallerySplitter( Window* pParent, const ResId& rResId );
//STRIP001     virtual         ~GallerySplitter();
//STRIP001 };
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 GallerySplitter::GallerySplitter( Window* pParent, const ResId& rResId ) :
//STRIP001     Splitter( pParent, rResId )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 GallerySplitter::~GallerySplitter()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GallerySplitter::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001     Splitter::DataChanged( rDCEvt );
//STRIP001     static_cast< GalleryBrowser* >( GetParent() )->InitSettings();
//STRIP001 }
//STRIP001 
//STRIP001 // -------------------------
//STRIP001 // - SvxGalleryChildWindow -
//STRIP001 // -------------------------
//STRIP001 
/*?*/ GalleryChildWindow::GalleryChildWindow( Window* pParent, USHORT nId, SfxBindings* pBindings, SfxChildWinInfo* pInfo ) :
/*?*/ 	SfxChildWindow( pParent, nId )
/*?*/ {
/*?*/ DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	pWindow = new GalleryBrowser( pBindings, this, pParent, GAL_RESID( RID_SVXDLG_GALLERYBROWSER ) );
//STRIP001 	eChildAlignment = SFX_ALIGN_TOP;
//STRIP001 	( (GalleryBrowser*) pWindow )->Initialize( pInfo );
/*?*/ };

//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 GalleryChildWindow::~GalleryChildWindow()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------------

/*N*/ SFX_IMPL_DOCKINGWINDOW( GalleryChildWindow, SID_GALLERY )

// ------------------
// - GalleryBrowser -
// ------------------

//STRIP001 GalleryBrowser::GalleryBrowser( SfxBindings* pBindings, SfxChildWindow* pCW,
//STRIP001 								Window* pParent, const ResId& rResId ) :
//STRIP001 	SfxDockingWindow( pBindings, pCW, pParent, rResId )
//STRIP001 {
//STRIP001 	mpGallery = Gallery::AcquireGallery( SvtPathOptions().GetGalleryPath() );
//STRIP001 	mpBrowser1 = new GalleryBrowser1( this, GAL_RESID( GALLERY_BROWSER1 ), mpGallery );
//STRIP001 	mpSplitter = new GallerySplitter( this, GAL_RESID( GALLERY_SPLITTER ) );
//STRIP001 	mpBrowser2 = new GalleryBrowser2( this, GAL_RESID( GALLERY_BROWSER2 ), mpGallery );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 	SetMinOutputSizePixel( maLastSize = GetOutputSizePixel() );
//STRIP001 	
//STRIP001 	mpBrowser1->SelectTheme( 0 );
//STRIP001 	mpBrowser1->Show( TRUE );
//STRIP001 	mpBrowser2->Show( TRUE );
//STRIP001 
//STRIP001 	mpSplitter->SetSplitHdl( LINK( this, GalleryBrowser, SplitHdl ) );
//STRIP001 	mpSplitter->Show( TRUE );
//STRIP001 
//STRIP001     InitSettings();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 	
//STRIP001 GalleryBrowser::~GalleryBrowser()
//STRIP001 {
//STRIP001 	delete mpBrowser2;
//STRIP001 	delete mpSplitter;
//STRIP001 	delete mpBrowser1;
//STRIP001 	Gallery::ReleaseGallery( mpGallery );
//STRIP001 	GrabFocusToDocument();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryBrowser::InitSettings()
//STRIP001 {
//STRIP001 	SetBackground( Wallpaper( GALLERY_DLG_COLOR ) );
//STRIP001 	SetControlBackground( GALLERY_DLG_COLOR );
//STRIP001 	SetControlForeground( GALLERY_DLG_COLOR );
//STRIP001 
//STRIP001 	mpSplitter->SetBackground( Wallpaper( GALLERY_DLG_COLOR ) );
//STRIP001 	mpSplitter->SetControlBackground( GALLERY_DLG_COLOR );
//STRIP001 	mpSplitter->SetControlForeground( GALLERY_DLG_COLOR );
//STRIP001 
//STRIP001 	mpBrowser1->SetBackground( Wallpaper( GALLERY_DLG_COLOR ) );
//STRIP001 	mpBrowser1->SetControlBackground( GALLERY_DLG_COLOR );
//STRIP001 	mpBrowser1->SetControlForeground( GALLERY_DLG_COLOR );
//STRIP001 
//STRIP001 	mpBrowser2->SetBackground( Wallpaper( GALLERY_DLG_COLOR ) );
//STRIP001 	mpBrowser2->SetControlBackground( GALLERY_DLG_COLOR );
//STRIP001 	mpBrowser2->SetControlForeground( GALLERY_DLG_COLOR );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryBrowser::Resize()
//STRIP001 {
//STRIP001 	SfxDockingWindow::Resize();
//STRIP001 
//STRIP001 	const long	nFrameWidth = LogicToPixel( Size( 3, 0 ), MAP_APPFONT ).Width();
//STRIP001 	const long	nFrameWidth2 = nFrameWidth << 1;
//STRIP001 	Size		aMinSize( GetMinOutputSizePixel() );
//STRIP001 	Size		aNewSize( GetOutputSizePixel() );
//STRIP001 	Point		aSplitPos( mpSplitter->GetPosPixel() );
//STRIP001 	const Size	aSplitSize( mpSplitter->GetOutputSizePixel() );
//STRIP001 
//STRIP001 	mpBrowser1->SetPosSizePixel( Point( nFrameWidth, nFrameWidth ), 
//STRIP001 								 Size( aSplitPos.X() - nFrameWidth, aNewSize.Height() - nFrameWidth2 ) );
//STRIP001 	
//STRIP001 	mpSplitter->SetPosSizePixel( aSplitPos, Size( aSplitSize.Width(), aNewSize.Height() ) );
//STRIP001 	mpSplitter->SetDragRectPixel( Rectangle( Point( nFrameWidth2, 0 ), Size( aNewSize.Width() - ( nFrameWidth2 << 1 ) - aSplitSize.Width(), aNewSize.Height() ) ) );
//STRIP001 	
//STRIP001 	mpBrowser2->SetPosSizePixel( Point( aSplitPos.X() + aSplitSize.Width(), nFrameWidth ),
//STRIP001 								 Size( aNewSize.Width() - aSplitSize.Width() - aSplitPos.X() - nFrameWidth, aNewSize.Height() - nFrameWidth2 ) );
//STRIP001 
//STRIP001 	maLastSize = aNewSize;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL GalleryBrowser::KeyInput( const KeyEvent& rKEvt, Window* pWindow )
//STRIP001 {
//STRIP001     const USHORT    nCode = rKEvt.GetKeyCode().GetCode();
//STRIP001     BOOL            bForward = FALSE;
//STRIP001     BOOL            bRet = ( !rKEvt.GetKeyCode().IsMod1() &&
//STRIP001                            ( ( KEY_TAB == nCode ) || ( KEY_F6 == nCode && rKEvt.GetKeyCode().IsMod2() ) ) );
//STRIP001 
//STRIP001     if( bRet )
//STRIP001     {
//STRIP001         if( !rKEvt.GetKeyCode().IsShift() )
//STRIP001         {
//STRIP001             if( mpBrowser1->mpThemes->HasChildPathFocus( TRUE ) )
//STRIP001                 mpBrowser2->GetViewWindow()->GrabFocus();
//STRIP001             else if( mpBrowser2->GetViewWindow()->HasFocus() )
//STRIP001                 mpBrowser2->maViewBox.GrabFocus();
//STRIP001             else if( mpBrowser2->maViewBox.HasFocus() )
//STRIP001                 mpBrowser1->maNewTheme.GrabFocus();
//STRIP001             else
//STRIP001                 mpBrowser1->mpThemes->GrabFocus();
//STRIP001         }
//STRIP001         else 
//STRIP001         {
//STRIP001             if( mpBrowser1->mpThemes->HasChildPathFocus( TRUE ) )
//STRIP001                 mpBrowser1->maNewTheme.GrabFocus();
//STRIP001             else if( mpBrowser1->maNewTheme.HasFocus() )
//STRIP001                 mpBrowser2->maViewBox.GrabFocus();
//STRIP001             else if( mpBrowser2->maViewBox.HasFocus() )
//STRIP001                 mpBrowser2->GetViewWindow()->GrabFocus();
//STRIP001             else
//STRIP001                 mpBrowser1->mpThemes->GrabFocus();
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001     return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL GalleryBrowser::Close()
//STRIP001 {
//STRIP001 	return SfxDockingWindow::Close();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryBrowser::GetFocus()
//STRIP001 {
//STRIP001 	SfxDockingWindow::GetFocus();
//STRIP001 	mpBrowser1->GrabFocus();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryBrowser::ThemeSelectionHasChanged()
//STRIP001 {
//STRIP001 	mpBrowser2->SelectTheme( mpBrowser1->GetSelectedTheme() );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 INetURLObject GalleryBrowser::GetURL() const
//STRIP001 {
//STRIP001 	return mpBrowser2->GetURL();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 String GalleryBrowser::GetFilterName() const
//STRIP001 {
//STRIP001 	return mpBrowser2->GetFilterName();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 Graphic GalleryBrowser::GetGraphic() const
//STRIP001 {
//STRIP001 	return mpBrowser2->GetGraphic();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL GalleryBrowser::GetVCDrawModel( FmFormModel& rModel ) const
//STRIP001 {
//STRIP001 	return mpBrowser2->GetVCDrawModel( rModel );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL GalleryBrowser::IsLinkage() const
//STRIP001 {
//STRIP001 	return mpBrowser2->IsLinkage();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( GalleryBrowser, SplitHdl, void*, p )
//STRIP001 {
//STRIP001 	mpSplitter->SetPosPixel( Point( mpSplitter->GetSplitPosPixel(), mpSplitter->GetPosPixel().Y() ) );
//STRIP001 	Resize();
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }
}
