/*************************************************************************
 *
 *  $RCSfile: svddrgm1.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:16:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDDRGM1_HXX
#define _SVDDRGM1_HXX

// auto strip #ifndef _XPOLY_HXX
// auto strip #include "xpoly.hxx"
// auto strip #endif

// auto strip #ifndef _SVDHDL_HXX
// auto strip #include "svdhdl.hxx"
// auto strip #endif

// auto strip #ifndef _SVDDRGV_HXX
// auto strip #include "svddrgv.hxx"
// auto strip #endif

// auto strip #ifndef _SVDDRGMT_HXX
// auto strip #include "svddrgmt.hxx"
// auto strip #endif
namespace binfilter {

//************************************************************
//   Vorausdeklarationen
//************************************************************

class SdrDragView;
class SdrDragStat;

//************************************************************
//   SdrDragMovHdl
//************************************************************

//STRIP001 class SdrDragMovHdl : public SdrDragMethod
//STRIP001 {
//STRIP001 	FASTBOOL					bMirrObjShown;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragMovHdl(SdrDragView& rNewView): SdrDragMethod(rNewView), bMirrObjShown(FALSE) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual void Brk();
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 	virtual void Show();
//STRIP001 	virtual void Hide();
//STRIP001 };

//************************************************************
//   SdrDragObjOwn
//************************************************************

//STRIP001 class SdrDragObjOwn : public SdrDragMethod
//STRIP001 {
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragObjOwn(SdrDragView& rNewView): SdrDragMethod(rNewView) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 	virtual void DrawXor(ExtOutputDevice& rXOut, FASTBOOL bFull) const;
//STRIP001 };

//************************************************************
//   SdrDragMove
//************************************************************

//STRIP001 class SdrDragMove : public SdrDragMethod
//STRIP001 {
//STRIP001 	long						nBestXSnap;
//STRIP001 	long						nBestYSnap;
//STRIP001 	FASTBOOL					bXSnapped;
//STRIP001 	FASTBOOL					bYSnapped;
//STRIP001 
//STRIP001 private:
//STRIP001 	void ImpCheckSnap(const Point& rPt);
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragMove(SdrDragView& rNewView): SdrDragMethod(rNewView) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovAllPoints();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual FASTBOOL IsMoveOnly() const;
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 };

//************************************************************
//   SdrDragResize
//************************************************************

//STRIP001 class SdrDragResize : public SdrDragMethod
//STRIP001 {
//STRIP001 protected:
//STRIP001 	Fraction					aXFact;
//STRIP001 	Fraction					aYFact;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragResize(SdrDragView& rNewView): SdrDragMethod(rNewView), aXFact(1,1), aYFact(1,1) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 };

//************************************************************
//   SdrDragRotate
//************************************************************

//STRIP001 class SdrDragRotate : public SdrDragMethod
//STRIP001 {
//STRIP001 protected:
//STRIP001 	double						nSin;
//STRIP001 	double						nCos;
//STRIP001 	long						nWink0;
//STRIP001 	long						nWink;
//STRIP001 	FASTBOOL					bRight;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragRotate(SdrDragView& rNewView): SdrDragMethod(rNewView),nWink0(0),nWink(0),nSin(0.0),nCos(1.0),bRight(FALSE) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 };

//************************************************************
//   SdrDragShear
//************************************************************

//STRIP001 class SdrDragShear : public SdrDragMethod
//STRIP001 {
//STRIP001 	Fraction					aFact;
//STRIP001 	long						nWink0;
//STRIP001 	long						nWink;
//STRIP001 	double						nTan;
//STRIP001 	FASTBOOL					bVertical;   // Vertikales verzerren
//STRIP001 	FASTBOOL					bResize;     // Shear mit Resize
//STRIP001 	FASTBOOL					bUpSideDown; // Beim Shear/Slant gespiegelt
//STRIP001 	FASTBOOL					bSlant;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragShear(SdrDragView& rNewView,FASTBOOL bSlant1): SdrDragMethod(rNewView),
//STRIP001 		bSlant(bSlant1),aFact(1,1),
//STRIP001 		nWink0(0),nWink(0),nTan(0.0),
//STRIP001 		bVertical(FALSE),bResize(FALSE),bUpSideDown(FALSE) { }
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 };

//************************************************************
//   SdrDragMirror
//************************************************************

//STRIP001 class SdrDragMirror : public SdrDragMethod
//STRIP001 {
//STRIP001 	Point						aDif;
//STRIP001 	long						nWink;
//STRIP001 	FASTBOOL					bMirrored;
//STRIP001 	FASTBOOL					bSide0;
//STRIP001 
//STRIP001 private:
//STRIP001 	FASTBOOL ImpCheckSide(const Point& rPnt) const;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragMirror(SdrDragView& rNewView): SdrDragMethod(rNewView),nWink(0),bMirrored(FALSE),bSide0(FALSE) { }
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 };

//************************************************************
//   SdrDragGradient
//************************************************************

//STRIP001 class SdrDragGradient : public SdrDragMethod
//STRIP001 {
//STRIP001 	// Handles to work on
//STRIP001 	SdrHdlGradient*				pIAOHandle;
//STRIP001 
//STRIP001 	// is this for gradient (or for transparence) ?
//STRIP001 	unsigned					bIsGradient : 1;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragGradient(SdrDragView& rNewView, BOOL bGrad = TRUE);
//STRIP001 
//STRIP001 	BOOL IsGradient() const { return bIsGradient; }
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 	virtual void Brk();
//STRIP001 };

//************************************************************
//   SdrDragCrook
//************************************************************

//STRIP001 class SdrDragCrook : public SdrDragMethod
//STRIP001 {
//STRIP001 	Rectangle					aMarkRect;
//STRIP001 	Point						aMarkCenter;
//STRIP001 	Point						aCenter;
//STRIP001 	Point						aStart;
//STRIP001 	Fraction					aFact;
//STRIP001 	Point						aRad;
//STRIP001 	FASTBOOL					bContortionAllowed;
//STRIP001 	FASTBOOL					bNoContortionAllowed;
//STRIP001 	FASTBOOL					bContortion;
//STRIP001 	FASTBOOL					bResizeAllowed;
//STRIP001 	FASTBOOL					bResize;
//STRIP001 	FASTBOOL					bRotateAllowed;
//STRIP001 	FASTBOOL					bRotate;
//STRIP001 	FASTBOOL					bVertical;
//STRIP001 	FASTBOOL					bValid;
//STRIP001 	FASTBOOL					bLft;
//STRIP001 	FASTBOOL					bRgt;
//STRIP001 	FASTBOOL					bUpr;
//STRIP001 	FASTBOOL					bLwr;
//STRIP001 	FASTBOOL					bAtCenter;
//STRIP001 	long						nWink;
//STRIP001 	long						nMarkSize;
//STRIP001 	SdrCrookMode				eMode;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragCrook(SdrDragView& rNewView): SdrDragMethod(rNewView),aFact(1,1),
//STRIP001 		bContortionAllowed(FALSE),bNoContortionAllowed(FALSE),bContortion(FALSE),
//STRIP001 		bResizeAllowed(FALSE),bResize(FALSE),bRotateAllowed(FALSE),bRotate(FALSE),
//STRIP001 		bVertical(FALSE),bValid(FALSE),bLft(FALSE),bRgt(FALSE),bUpr(FALSE),bLwr(FALSE),bAtCenter(FALSE),
//STRIP001 		nWink(0),nMarkSize(0),eMode(SDRCROOK_ROTATE) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovAllPoints();
//STRIP001 	void MovPoint(Point& rPnt, const Point& rPvOfs, Point* pC1, Point* pC2);
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 	virtual void DrawXor(ExtOutputDevice& rXOut, FASTBOOL bFull) const;
//STRIP001 };

//************************************************************
//   SdrDragDistort
//************************************************************

//STRIP001 class SdrDragDistort : public SdrDragMethod
//STRIP001 {
//STRIP001 	Rectangle					aMarkRect;
//STRIP001 	XPolygon					aDistortedRect;
//STRIP001 	USHORT						nPolyPt;
//STRIP001 	FASTBOOL					bContortionAllowed;
//STRIP001 	FASTBOOL					bNoContortionAllowed;
//STRIP001 	FASTBOOL					bContortion;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragDistort(SdrDragView& rNewView): SdrDragMethod(rNewView),nPolyPt(0),
//STRIP001 		bContortionAllowed(FALSE),bNoContortionAllowed(FALSE),bContortion(FALSE) {}
//STRIP001 
//STRIP001 	virtual void TakeComment(String& rStr) const;
//STRIP001 
//STRIP001 	virtual FASTBOOL Beg();
//STRIP001 	virtual void MovAllPoints();
//STRIP001 	virtual void Mov(const Point& rPnt);
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy);
//STRIP001 	virtual Pointer GetPointer() const;
//STRIP001 	virtual void DrawXor(ExtOutputDevice& rXOut, FASTBOOL bFull) const;
//STRIP001 };

////////////////////////////////////////////////////////////////////////////////////////////////////

}//end of namespace binfilter
#endif //_SVDDRGM1_HXX

