/*************************************************************************
 *
 *  $RCSfile: svx_xexch.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:47:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

// include ---------------------------------------------------------------

//STRIP001 #include <sot/formats.hxx>
//STRIP001 #include <tools/vcompat.hxx>
//STRIP001 
//STRIP001 #ifndef _SVX_XFLASIT_HXX
//STRIP001 #include <xflasit.hxx>
//STRIP001 #endif
//STRIP001 #ifndef SVX_XFILLIT0_HXX
//STRIP001 #include <xfillit0.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXIPOOL_HXX
//STRIP001 #include <svtools/itempool.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_WHITER_HXX
//STRIP001 #include <svtools/whiter.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXIPOOL_HXX
//STRIP001 #include <svtools/itempool.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXITEMSET_HXX
//STRIP001 #include <svtools/itemset.hxx>
//STRIP001 #endif
//STRIP001 #include "xdef.hxx"
//STRIP001 #include "xexch.hxx"
//STRIP001 
//STRIP001 
//STRIP001 TYPEINIT1_AUTOFACTORY( XFillExchangeData, SvDataCopyStream );
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Default-Ctor (Fuer Assign())
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 XFillExchangeData::XFillExchangeData() :
//STRIP001 	pPool( NULL ),
//STRIP001 	pXFillAttrSetItem( NULL )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ctor
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 XFillExchangeData::XFillExchangeData( const XFillAttrSetItem rXFillAttrSetItem ) :
//STRIP001 	pPool( rXFillAttrSetItem.GetItemSet().GetPool() ),
//STRIP001 	pXFillAttrSetItem( (XFillAttrSetItem*) rXFillAttrSetItem.Clone( rXFillAttrSetItem.GetItemSet().GetPool() ) )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Dtor
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 XFillExchangeData::~XFillExchangeData()
//STRIP001 {
//STRIP001 	delete pXFillAttrSetItem;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 ULONG XFillExchangeData::RegisterClipboardFormatName()
//STRIP001 {
//STRIP001 	return( SOT_FORMATSTR_ID_XFA );
//STRIP001 }
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*  Binaer-Export (z.Z. ohne Versionsverwaltung, da nicht persistent!)
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 SvStream& operator<<( SvStream& rOStm, const XFillExchangeData& rData )
//STRIP001 {
//STRIP001 	if( rData.pXFillAttrSetItem )
//STRIP001 	{
//STRIP001 		USHORT nItemVersion = rData.pXFillAttrSetItem->GetVersion( (USHORT) rOStm.GetVersion() );
//STRIP001 
//STRIP001 		SfxWhichIter		aIter( rData.pXFillAttrSetItem->GetItemSet() );
//STRIP001 		USHORT				nWhich = aIter.FirstWhich();
//STRIP001 		const SfxPoolItem*	pItem;
//STRIP001 		ULONG				nItemCount = 0, nFirstPos = rOStm.Tell();
//STRIP001 
//STRIP001 		rOStm << nItemCount;
//STRIP001 		
//STRIP001 		while( nWhich )
//STRIP001 		{
//STRIP001 			if( SFX_ITEM_SET == rData.pXFillAttrSetItem->GetItemSet().GetItemState( nWhich, FALSE, &pItem ) )
//STRIP001 			{
//STRIP001 				VersionCompat	aCompat( rOStm, STREAM_WRITE );
//STRIP001 				const USHORT	nItemVersion = pItem->GetVersion( (USHORT) rOStm.GetVersion() );
//STRIP001 
//STRIP001 				rOStm << nWhich << nItemVersion;
//STRIP001 				pItem->Store( rOStm, nItemVersion );
//STRIP001 				
//STRIP001 				nItemCount++;
//STRIP001 			}
//STRIP001 			
//STRIP001 			nWhich = aIter.NextWhich();
//STRIP001 		}
//STRIP001 
//STRIP001 		const ULONG nLastPos = rOStm.Tell();
//STRIP001 		rOStm.Seek( nFirstPos );
//STRIP001 		rOStm << nItemCount;
//STRIP001 		rOStm.Seek( nLastPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	return rOStm;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*  Binaer-Import (z.Z. ohne Versionsverwaltung, da nicht persistent!)
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 SvStream& operator>>( SvStream& rIStm, XFillExchangeData& rData )
//STRIP001 {
//STRIP001 	DBG_ASSERT( rData.pPool, "XFillExchangeData has no pool" );
//STRIP001 
//STRIP001 	SfxItemSet*		pSet = new SfxItemSet ( *rData.pPool, XATTR_FILL_FIRST, XATTR_FILL_LAST );
//STRIP001 	SfxPoolItem*	pNewItem;
//STRIP001 	ULONG			nItemCount = 0;
//STRIP001 	USHORT			nWhich, nItemVersion;
//STRIP001 
//STRIP001 	rIStm >> nItemCount;
//STRIP001 
//STRIP001 	if( nItemCount > ( XATTR_FILL_LAST - XATTR_FILL_FIRST + 1 ) )
//STRIP001 		nItemCount = ( XATTR_FILL_LAST - XATTR_FILL_FIRST + 1 );
//STRIP001 
//STRIP001 	for( ULONG i = 0; i < nItemCount; i++ )
//STRIP001 	{
//STRIP001 		VersionCompat aCompat( rIStm, STREAM_READ );
//STRIP001 
//STRIP001 		rIStm >> nWhich >> nItemVersion;
//STRIP001 		
//STRIP001 		if( nWhich )
//STRIP001 		{
//STRIP001 			pNewItem = rData.pPool->GetDefaultItem( nWhich ).Create( rIStm, nItemVersion );
//STRIP001 
//STRIP001 			if( pNewItem )
//STRIP001 			{
//STRIP001 				pSet->Put( *pNewItem );
//STRIP001 				delete pNewItem;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	
//STRIP001 	delete rData.pXFillAttrSetItem; 
//STRIP001 	rData.pXFillAttrSetItem = new XFillAttrSetItem( pSet );
//STRIP001 	rData.pPool = rData.pXFillAttrSetItem->GetItemSet().GetPool();
//STRIP001 
//STRIP001 	return rIStm;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	  XBitmap& XBitmap::operator=( const XBitmap& rXBmp )
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 
//STRIP001 XFillExchangeData& XFillExchangeData::operator=( const XFillExchangeData& rData )
//STRIP001 {
//STRIP001 	delete pXFillAttrSetItem;
//STRIP001 
//STRIP001 	if( rData.pXFillAttrSetItem )
//STRIP001 		pXFillAttrSetItem = (XFillAttrSetItem*) rData.pXFillAttrSetItem->Clone( pPool = rData.pXFillAttrSetItem->GetItemSet().GetPool() );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pPool = NULL;
//STRIP001 		pXFillAttrSetItem = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	return( *this );
//STRIP001 }
}
