/*************************************************************************
 *
 *  $RCSfile: sw_trvlcol.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:02:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "crsrsh.hxx"
// auto strip #include "doc.hxx"
// auto strip #include "layfrm.hxx"
#include "cntfrm.hxx"
// auto strip #include "swcrsr.hxx"
// auto strip #include "viscrs.hxx"
// auto strip #include "callnk.hxx"
namespace binfilter {



//STRIP001 SwLayoutFrm* GetCurrColumn( const SwLayoutFrm* pLayFrm )
//STRIP001 {
//STRIP001 	while( pLayFrm && !pLayFrm->IsColumnFrm() )
//STRIP001 		pLayFrm = pLayFrm->GetUpper();
//STRIP001 	return (SwLayoutFrm*)pLayFrm;
//STRIP001 }


//STRIP001 SwLayoutFrm* GetNextColumn( const SwLayoutFrm* pLayFrm )
//STRIP001 {
//STRIP001 	SwLayoutFrm* pActCol = GetCurrColumn( pLayFrm );
//STRIP001 	return pActCol ? (SwLayoutFrm*)pActCol->GetNext() : 0;
//STRIP001 }


//STRIP001 SwLayoutFrm* GetPrevColumn( const SwLayoutFrm* pLayFrm )
//STRIP001 {
//STRIP001 	SwLayoutFrm* pActCol = GetCurrColumn( pLayFrm );
//STRIP001 	return pActCol ? (SwLayoutFrm*)pActCol->GetPrev() : 0;
//STRIP001 }


//STRIP001 SwCntntFrm* GetColumnStt( const SwLayoutFrm* pColFrm )
//STRIP001 {
//STRIP001 	return pColFrm ? (SwCntntFrm*)pColFrm->ContainsCntnt() : 0;
//STRIP001 }


//STRIP001 SwCntntFrm* GetColumnEnd( const SwLayoutFrm* pColFrm )
//STRIP001 {
//STRIP001 	SwCntntFrm *pRet = GetColumnStt( pColFrm );
//STRIP001 	if( !pRet )
//STRIP001 		return 0;
//STRIP001 
//STRIP001 	SwCntntFrm *pNxt = pRet->GetNextCntntFrm();
//STRIP001 	while( pNxt && pColFrm->IsAnLower( pNxt ) )
//STRIP001 	{
//STRIP001 		pRet = pNxt;
//STRIP001 		pNxt = pNxt->GetNextCntntFrm();
//STRIP001 	}
//STRIP001 	return pRet;
//STRIP001 }


//STRIP001 SwWhichColumn fnColumnPrev = &GetPrevColumn;
//STRIP001 SwWhichColumn fnColumnCurr = &GetCurrColumn;
//STRIP001 SwWhichColumn fnColumnNext = &GetNextColumn;
//STRIP001 SwPosColumn fnColumnStart = &GetColumnStt;
//STRIP001 SwPosColumn fnColumnEnd = &GetColumnEnd;


//STRIP001 FASTBOOL SwCrsrShell::MoveColumn( SwWhichColumn fnWhichCol, SwPosColumn fnPosCol )
//STRIP001 {
//STRIP001 	FASTBOOL bRet = FALSE;
//STRIP001 	if( !pTblCrsr )
//STRIP001 	{
//STRIP001 		SwLayoutFrm* pLayFrm = GetCurrFrm()->GetUpper();
//STRIP001 		if( pLayFrm && 0 != ( pLayFrm = (*fnWhichCol)( pLayFrm )) )
//STRIP001 		{
//STRIP001 			SwCntntFrm* pCnt = (*fnPosCol)( pLayFrm );
//STRIP001 			if( pCnt )
//STRIP001 			{
//STRIP001 				SET_CURR_SHELL( this );
//STRIP001 				SwCallLink aLk( *this );        // Crsr-Moves ueberwachen, evt. Link callen
//STRIP001 				SwCrsrSaveState aSaveState( *pCurCrsr );
//STRIP001 
//STRIP001 				pCnt->Calc();					// ???
//STRIP001 
//STRIP001 				Point aPt( pCnt->Frm().Pos() + pCnt->Prt().Pos() );
//STRIP001 				if( fnPosCol == GetColumnEnd )
//STRIP001 				{
//STRIP001 					aPt.X() += pCnt->Prt().Width();
//STRIP001 					aPt.Y() += pCnt->Prt().Height();
//STRIP001 				}
//STRIP001 
//STRIP001 				pCnt->GetCrsrOfst( pCurCrsr->GetPoint(), aPt );
//STRIP001 
//STRIP001 				if( !pCurCrsr->IsInProtectTable( TRUE ) &&
//STRIP001 					!pCurCrsr->IsSelOvr() )
//STRIP001 				{
//STRIP001 					UpdateCrsr();
//STRIP001 					bRet = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }



}
