/*************************************************************************
 *
 *  $RCSfile: sw_eddel.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:20:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _EDITSH_HXX
// auto strip #include <editsh.hxx>
// auto strip #endif
#ifndef _CNTFRM_HXX
#include <cntfrm.hxx>
#endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>		// fuer die UndoIds
// auto strip #endif
// auto strip #ifndef _EDIMP_HXX
// auto strip #include <edimp.hxx>
// auto strip #endif
// auto strip #ifndef _BOOKMRK_HXX
// auto strip #include <bookmrk.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
namespace binfilter {


/************************************************************
 * Loeschen
 ************************************************************/

//STRIP001 void SwEditShell::DeleteSel( SwPaM& rPam, BOOL* pUndo )
//STRIP001 {
//STRIP001 	// nur bei Selektion
//STRIP001 	if( !rPam.HasMark() || *rPam.GetPoint() == *rPam.GetMark())
//STRIP001 		return;
//STRIP001 
//STRIP001 	// besteht eine Selection in einer Tabelle ?
//STRIP001 	// dann nur den Inhalt der selektierten Boxen loeschen
//STRIP001 	// jetzt gibt es 2 Faelle die beachtet werden muessen:
//STRIP001 	//	1. Point und Mark stehen in einer Box, Selection normal loeschen
//STRIP001 	//	2. Point und Mark stehen in unterschiedlichen Boxen, alle
//STRIP001 	// selektierten Boxen suchen in den Inhalt loeschen
//STRIP001 	if( rPam.GetNode()->FindTableNode() &&
//STRIP001 		rPam.GetNode()->StartOfSectionNode() !=
//STRIP001 		rPam.GetNode(FALSE)->StartOfSectionNode() )
//STRIP001 	{
//STRIP001 		// in Tabellen das Undo gruppieren
//STRIP001 		if( pUndo && !*pUndo )
//STRIP001 		{
//STRIP001 			GetDoc()->StartUndo( UNDO_START );
//STRIP001 			*pUndo = TRUE;
//STRIP001 		}
//STRIP001 		SwPaM aDelPam( *rPam.Start() );
//STRIP001 		const SwPosition* pEndSelPos = rPam.End();
//STRIP001 		do {
//STRIP001 			aDelPam.SetMark();
//STRIP001 			SwNode* pNd = aDelPam.GetNode();
//STRIP001 			const SwNode& rEndNd = *pNd->EndOfSectionNode();
//STRIP001 			if( pEndSelPos->nNode.GetIndex() <= rEndNd.GetIndex() )
//STRIP001 			{
//STRIP001 				*aDelPam.GetPoint() = *pEndSelPos;
//STRIP001 				pEndSelPos = 0;		// Pointer als Flag missbrauchen
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// dann ans Ende der Section
//STRIP001 				aDelPam.GetPoint()->nNode = rEndNd;
//STRIP001 				aDelPam.Move( fnMoveBackward, fnGoCntnt );
//STRIP001 			}
//STRIP001 				// geschuetze Boxen ueberspringen !
//STRIP001 			if( !pNd->IsCntntNode() ||
//STRIP001 				!((SwCntntNode*)pNd)->GetFrm()->IsProtected() )
//STRIP001 			{
//STRIP001 				// alles loeschen
//STRIP001 				GetDoc()->DeleteAndJoin( aDelPam );
//STRIP001 				SaveTblBoxCntnt( aDelPam.GetPoint() );
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !pEndSelPos )				// am Ende der Selection
//STRIP001 				break;
//STRIP001 			aDelPam.DeleteMark();
//STRIP001 			aDelPam.Move( fnMoveForward, fnGoCntnt );	// naechste Box
//STRIP001 		} while( pEndSelPos );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 			// alles loeschen
//STRIP001 		GetDoc()->DeleteAndJoin( rPam );
//STRIP001 		SaveTblBoxCntnt( rPam.GetPoint() );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Selection wird nicht mehr benoetigt.
//STRIP001 	rPam.DeleteMark();
//STRIP001 }


//STRIP001 long SwEditShell::Delete()
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	long nRet = 0;
//STRIP001 	if( !HasReadonlySel() )
//STRIP001 	{
//STRIP001 		StartAllAction();
//STRIP001 
//STRIP001 		BOOL bUndo = GetCrsr()->GetNext() != GetCrsr();
//STRIP001 		if( bUndo )     // mehr als eine Selection ?
//STRIP001 			GetDoc()->StartUndo( UNDO_START );
//STRIP001 
//STRIP001 		FOREACHPAM_START(this)
//STRIP001 			DeleteSel( *PCURCRSR, &bUndo );
//STRIP001 		FOREACHPAM_END()
//STRIP001 
//STRIP001 		// falls eine Undo-Klammerung, dann hier beenden
//STRIP001 		if( bUndo )
//STRIP001 			GetDoc()->EndUndo( UNDO_END );
//STRIP001 		EndAllAction();
//STRIP001 		nRet = 1;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }



//STRIP001 long SwEditShell::Move()
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 
//STRIP001 	long nRet = 0;
//STRIP001 	if( !HasReadonlySel() )
//STRIP001 	{
//STRIP001 		StartAllAction();
//STRIP001 		SwPosition * pPos = 0;
//STRIP001 		BOOL bFirstMove = TRUE;
//STRIP001 
//STRIP001 		String sBookmark( String::CreateFromAscii("Move") );
//STRIP001 		GetDoc()->MakeUniqueBookmarkName( sBookmark );
//STRIP001 
//STRIP001 		BOOL bUndo = GetDoc()->DoesUndo();
//STRIP001 
//STRIP001 		GetDoc()->StartUndo( UNDO_START );
//STRIP001 
//STRIP001 		FOREACHPAM_START(this)
//STRIP001 
//STRIP001 			if( !pPos )
//STRIP001 			{
//STRIP001 				// der 1.Cursor ist die Position, wohin verschoben wird !!
//STRIP001 				PCURCRSR->DeleteMark();
//STRIP001 				pPos = (SwPosition*)PCURCRSR->GetPoint();
//STRIP001 			}
//STRIP001 			// nur bei Selektion (nicht Textnodes haben Selection,
//STRIP001 			// aber Point/GetMark sind gleich
//STRIP001 			else if( PCURCRSR->HasMark() &&
//STRIP001 					*PCURCRSR->GetPoint() != *PCURCRSR->GetMark() &&
//STRIP001 					GetDoc()->MoveAndJoin( *PCURCRSR, *pPos ))
//STRIP001 			{
//STRIP001 				nRet = 1;
//STRIP001 				if( bFirstMove )
//STRIP001 				{
//STRIP001 					// Anfangs-Position vom neuen Bereich merken
//STRIP001 					bFirstMove = FALSE;
//STRIP001 					GetDoc()->DoUndo( FALSE );
//STRIP001 					GetDoc()->MakeBookmark( *PCURCRSR, KeyCode(), sBookmark,
//STRIP001 											aEmptyStr, MARK );
//STRIP001 					GetDoc()->DoUndo( bUndo );
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 		FOREACHPAM_END()
//STRIP001 
//STRIP001 		KillPams();
//STRIP001 
//STRIP001 		// wurde ueberhaupt etwas verschoben ?
//STRIP001 		if( !bFirstMove )
//STRIP001 		{
//STRIP001 			USHORT nFndPos = GetDoc()->FindBookmark( sBookmark );
//STRIP001 			const SwBookmark& rBkmk = *GetDoc()->GetBookmarks()[ nFndPos ];
//STRIP001 
//STRIP001 			SwPaM* pCrsr = GetCrsr();
//STRIP001 			pCrsr->SetMark();
//STRIP001 			*pCrsr->GetMark() = rBkmk.GetPos();
//STRIP001 
//STRIP001 			GetDoc()->DoUndo( FALSE );
//STRIP001 			GetDoc()->DelBookmark( nFndPos );
//STRIP001 			GetDoc()->DoUndo( bUndo );
//STRIP001 		}
//STRIP001 
//STRIP001 #if OSL_DEBUG_LEVEL > 1
//STRIP001 // pruefe ob die Indizies auch in den richtigen Nodes angemeldet sind
//STRIP001 {
//STRIP001 	SwPaM* pCmp = GetCrsr();        // sicher den Pointer auf Cursor
//STRIP001 	do {
//STRIP001 		ASSERT( pCmp->GetPoint()->nContent.GetIdxReg()
//STRIP001 					== pCmp->GetCntntNode(), "Point im falschen Node" );
//STRIP001 		ASSERT( pCmp->GetMark()->nContent.GetIdxReg()
//STRIP001 					== pCmp->GetCntntNode(FALSE), "Mark im falschen Node" );
//STRIP001 		BOOL bTst = *pCmp->GetPoint() == *pCmp->GetMark();
//STRIP001 	} while( GetCrsr() != ( pCmp = (SwPaM*)pCmp->GetNext() ) );
//STRIP001 }
//STRIP001 #endif
//STRIP001 
//STRIP001 		// Undo-Klammerung hier beenden
//STRIP001 		GetDoc()->EndUndo( UNDO_END );
//STRIP001 		EndAllAction();
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 	// falls eine Bitmap nicht verschoben werden konnte so melde das an
//STRIP001 	// die SwWriterShell weiter
//STRIP001 }



//STRIP001 long SwEditShell::Copy( SwEditShell* pDestShell )
//STRIP001 {
//STRIP001 	if( !pDestShell )
//STRIP001 		pDestShell = this;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( pDestShell );
//STRIP001 
//STRIP001 	// ueberpruefe ob Selectionen in sich selbst kopiert werden
//STRIP001 	if( pDestShell->GetDoc() == GetDoc() )
//STRIP001 	{
//STRIP001 		SwPosition * pPos = 0;
//STRIP001 		FOREACHPAM_START(this)
//STRIP001 
//STRIP001 			if( !pPos )
//STRIP001 			{
//STRIP001 				if( pDestShell == this )
//STRIP001 				{
//STRIP001 					// der 1.Cursor ist die Position, wohin verschoben wird !!
//STRIP001 					PCURCRSR->DeleteMark();
//STRIP001 					pPos = (SwPosition*)PCURCRSR->GetPoint();
//STRIP001 					continue;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					pPos = pDestShell->GetCrsr()->GetPoint();
//STRIP001 			}
//STRIP001 			if( *PCURCRSR->Start() <= *pPos && *pPos < *PCURCRSR->End() )
//STRIP001 				return FALSE;		// Position im Bereich einer Selection
//STRIP001 									// --> Kopieren in sich selbst
//STRIP001 		FOREACHPAM_END()
//STRIP001 	}
//STRIP001 
//STRIP001 	pDestShell->StartAllAction();
//STRIP001 	SwPosition * pPos = 0;
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	BOOL bFirstMove = TRUE;
//STRIP001 	SwNodeIndex aSttNdIdx( pDestShell->GetDoc()->GetNodes() );
//STRIP001 	xub_StrLen nSttCntIdx = 0;
//STRIP001 
//STRIP001 	pDestShell->GetDoc()->StartUndo( UNDO_START );
//STRIP001 	FOREACHPAM_START(this)
//STRIP001 
//STRIP001 		if( !pPos )
//STRIP001 		{
//STRIP001 			if( pDestShell == this )
//STRIP001 			{
//STRIP001 				// der 1.Cursor ist die Position, wohin verschoben wird !!
//STRIP001 				PCURCRSR->DeleteMark();
//STRIP001 				pPos = (SwPosition*)PCURCRSR->GetPoint();
//STRIP001 				continue;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pPos = pDestShell->GetCrsr()->GetPoint();
//STRIP001 		}
//STRIP001 
//STRIP001 		// nur bei Selektion (nicht Textnodes haben Selection,
//STRIP001 		// aber Point/GetMark sind gleich
//STRIP001 		if( !PCURCRSR->HasMark() || *PCURCRSR->GetPoint() == *PCURCRSR->GetMark())
//STRIP001 			continue;
//STRIP001 
//STRIP001 		if( bFirstMove )
//STRIP001 		{
//STRIP001 			// Anfangs-Position vom neuen Bereich merken
//STRIP001 			aSttNdIdx = pPos->nNode.GetIndex()-1;
//STRIP001 			nSttCntIdx = pPos->nContent.GetIndex();
//STRIP001 			bFirstMove = FALSE;
//STRIP001 		}
//STRIP001 
//STRIP001 		if( !GetDoc()->Copy( *PCURCRSR, *pPos ))
//STRIP001 			continue;
//STRIP001 
//STRIP001 		bRet = TRUE;
//STRIP001 	FOREACHPAM_END()
//STRIP001 
//STRIP001 
//STRIP001 	// wurde ueberhaupt etwas verschoben ?
//STRIP001 	if( !bFirstMove )
//STRIP001 	{
//STRIP001 		SwPaM* pCrsr = pDestShell->GetCrsr();
//STRIP001 		pCrsr->SetMark();
//STRIP001 		pCrsr->GetPoint()->nNode = aSttNdIdx.GetIndex()+1;
//STRIP001 		pCrsr->GetPoint()->nContent.Assign( pCrsr->GetCntntNode(),nSttCntIdx);
//STRIP001 		pCrsr->Exchange();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// falls beim Move der Cursor "gewandert" ist, so setze hier auch
//STRIP001 		// seinen GetMark um, damit dieser nie in den Wald zeigt.
//STRIP001 		pDestShell->GetCrsr()->SetMark();
//STRIP001 		pDestShell->GetCrsr()->DeleteMark();
//STRIP001 	}
//STRIP001 #if OSL_DEBUG_LEVEL > 1
//STRIP001 // pruefe ob die Indizies auch in den richtigen Nodes angemeldet sind
//STRIP001 {
//STRIP001 	SwPaM* pCmp = (SwPaM*)pDestShell->GetCrsr();        // sicher den Pointer auf Cursor
//STRIP001 	do {
//STRIP001 		ASSERT( pCmp->GetPoint()->nContent.GetIdxReg()
//STRIP001 					== pCmp->GetCntntNode(), "Point im falschen Node" );
//STRIP001 		ASSERT( pCmp->GetMark()->nContent.GetIdxReg()
//STRIP001 					== pCmp->GetCntntNode(FALSE), "Mark im falschen Node" );
//STRIP001 		BOOL bTst = *pCmp->GetPoint() == *pCmp->GetMark();
//STRIP001 	} while( pDestShell->GetCrsr() != ( pCmp = (SwPaM*)pCmp->GetNext() ) );
//STRIP001 }
//STRIP001 #endif
//STRIP001 
//STRIP001 	// Undo-Klammerung hier beenden
//STRIP001 	pDestShell->GetDoc()->EndUndo( UNDO_END );
//STRIP001 	pDestShell->EndAllAction();
//STRIP001 
//STRIP001 	pDestShell->SaveTblBoxCntnt( pDestShell->GetCrsr()->GetPoint() );
//STRIP001 
//STRIP001 	return (long)bRet;
//STRIP001 }


	// Ersetz einen selektierten Bereich in einem TextNode mit dem
	// String. Ist fuers Suchen&Ersetzen gedacht.
	// bRegExpRplc - ersetze Tabs (\\t) und setze den gefundenen String
	//				 ein ( nicht \& )
	// 				z.B.: Fnd: "zzz", Repl: "xx\t\\t..&..\&"
	//						--> "xx\t<Tab>..zzz..&"
//STRIP001 BOOL SwEditShell::Replace( const String& rNewStr, BOOL bRegExpRplc )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	if( !HasReadonlySel() )
//STRIP001 	{
//STRIP001 		StartAllAction();
//STRIP001 		GetDoc()->StartUndo( UNDO_END );
//STRIP001 
//STRIP001 		FOREACHPAM_START(this)
//STRIP001 
//STRIP001 //JP 02.12.97: muss das noch sein??
//STRIP001 			// sollten mehrere Node selektiert sein, dann loesche diese
//STRIP001 			// erst, fuege ein Zeichen ein und ersetze dann dieses
//STRIP001 			if( PCURCRSR->GetPoint()->nNode != PCURCRSR->GetMark()->nNode )
//STRIP001 			{
//STRIP001 				BOOL bForward = PCURCRSR->GetPoint()->nNode.GetIndex() >
//STRIP001 								PCURCRSR->GetMark()->nNode.GetIndex();
//STRIP001 				DeleteSel( *PCURCRSR );
//STRIP001 				pDoc->Insert( *PCURCRSR, ' ' );
//STRIP001 				PCURCRSR->SetMark();
//STRIP001 				if( bForward )
//STRIP001 					PCURCRSR->GetMark()->nContent--;
//STRIP001 				else
//STRIP001 					PCURCRSR->GetPoint()->nContent--;
//STRIP001 			}
//STRIP001 //JP 02.12.97: muss das noch sein??
//STRIP001 
//STRIP001 			if( PCURCRSR->HasMark() && *PCURCRSR->GetMark() != *PCURCRSR->GetPoint() )
//STRIP001 			{
//STRIP001 				bRet |= GetDoc()->Replace( *PCURCRSR, rNewStr, bRegExpRplc );
//STRIP001 				SaveTblBoxCntnt( PCURCRSR->GetPoint() );
//STRIP001 			}
//STRIP001 		FOREACHPAM_END()
//STRIP001 
//STRIP001 		// Undo-Klammerung hier beenden
//STRIP001 		GetDoc()->EndUndo( UNDO_END );
//STRIP001 		EndAllAction();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }


	// Special-Methode fuer JOE's- Wizzards
//STRIP001 BOOL SwEditShell::DelFullPara()
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	if( !IsTableMode() )
//STRIP001 	{
//STRIP001 		SwPaM* pCrsr = GetCrsr();
//STRIP001 		// keine Mehrfach-Selection
//STRIP001 		if( pCrsr->GetNext() == pCrsr && !HasReadonlySel() )
//STRIP001 		{
//STRIP001 			SET_CURR_SHELL( this );
//STRIP001 			StartAllAction();
//STRIP001 			bRet = GetDoc()->DelFullPara( *pCrsr );
//STRIP001 			EndAllAction();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }



}
