/*************************************************************************
 *
 *  $RCSfile: sw_fldlst.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/04 15:40:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "editsh.hxx"
// auto strip #include "doc.hxx"

// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _FMTFLD_HXX //autogen
// auto strip #include <fmtfld.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFLD_HXX //autogen
// auto strip #include <txtfld.hxx>
// auto strip #endif
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif
#ifndef _VISCRS_HXX
#include <viscrs.hxx>
#endif
#include "edimp.hxx"
// auto strip #include "expfld.hxx"
// auto strip #include "pam.hxx"
// auto strip #include "docfld.hxx"
// auto strip #include "ndtxt.hxx"
namespace binfilter {


/*--------------------------------------------------------------------
	Beschreibung: Sortieren der Input-Eintraege
 --------------------------------------------------------------------*/

//STRIP001 SwInputFieldList::SwInputFieldList( SwEditShell* pShell, FASTBOOL bBuildTmpLst )
//STRIP001 	: pSh(pShell)
//STRIP001 {
//STRIP001 	// Hier die Liste aller Eingabefelder sortiert erstellen
//STRIP001 	pSrtLst = new _SetGetExpFlds();
//STRIP001 
//STRIP001 	SwNodes* pNds = &pSh->GetDoc()->GetNodes();
//STRIP001 	const SwFldTypes& rFldTypes = *pSh->GetDoc()->GetFldTypes();
//STRIP001 	const USHORT nSize = rFldTypes.Count();
//STRIP001 
//STRIP001 	// Alle Typen abklappern
//STRIP001 
//STRIP001 	for(USHORT i=0; i < nSize; ++i)
//STRIP001 	{
//STRIP001 		SwFieldType* pFldType = (SwFieldType*)rFldTypes[ i ];
//STRIP001 		USHORT nType = pFldType->Which();
//STRIP001 
//STRIP001      if( RES_SETEXPFLD == nType || RES_INPUTFLD == nType || RES_DROPDOWN == nType )
//STRIP001 		{
//STRIP001 			SwClientIter aIter( *pFldType );
//STRIP001 			for( SwFmtFld* pFld = (SwFmtFld*)aIter.First( TYPE(SwFmtFld) );
//STRIP001 					pFld; pFld = (SwFmtFld*)aIter.Next() )
//STRIP001 
//STRIP001 			{
//STRIP001 				const SwTxtFld* pTxtFld = pFld->GetTxtFld();
//STRIP001 
//STRIP001 				//	nur InputFields und interaktive SetExpFlds bearbeiten
//STRIP001                 //  and DropDown fields
//STRIP001 				if( !pTxtFld || ( RES_SETEXPFLD == nType &&
//STRIP001 					!((SwSetExpField*)pFld->GetFld())->GetInputFlag()))
//STRIP001 					continue;
//STRIP001 
//STRIP001 				const SwTxtNode& rTxtNode = pTxtFld->GetTxtNode();
//STRIP001 				if( rTxtNode.GetNodes().IsDocNodes() )
//STRIP001 				{
//STRIP001 					if( bBuildTmpLst )
//STRIP001 					{
//STRIP001 						VoidPtr pTmp = (VoidPtr)pTxtFld;
//STRIP001 						aTmpLst.Insert( pTmp, aTmpLst.Count() );
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						SwNodeIndex aIdx( rTxtNode );
//STRIP001 						_SetGetExpFld* pNew = new _SetGetExpFld(aIdx, pTxtFld );
//STRIP001 						pSrtLst->Insert( pNew );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

//STRIP001 SwInputFieldList::~SwInputFieldList()
//STRIP001 {
//STRIP001 	delete pSrtLst;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Felder aus der Liste in sortierter Reihenfolge
 --------------------------------------------------------------------*/

//STRIP001 USHORT SwInputFieldList::Count() const
//STRIP001 {
//STRIP001 	return pSrtLst->Count();
//STRIP001 }


//STRIP001 SwField* SwInputFieldList::GetField(USHORT nId)
//STRIP001 {
//STRIP001 	const SwTxtFld* pTxtFld = (*pSrtLst)[ nId ]->GetFld();
//STRIP001 	ASSERT( pTxtFld, "kein TextFld" );
//STRIP001 	return (SwField*)pTxtFld->GetFld().GetFld();
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Cursor sichern
 --------------------------------------------------------------------*/

//STRIP001 void SwInputFieldList::PushCrsr()
//STRIP001 {
//STRIP001 	pSh->Push();
//STRIP001 	pSh->ClearMark();
//STRIP001 }

//STRIP001 void SwInputFieldList::PopCrsr()
//STRIP001 {
//STRIP001 	pSh->Pop(FALSE);
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Position eines Feldes ansteuern
 --------------------------------------------------------------------*/

//STRIP001 void SwInputFieldList::GotoFieldPos(USHORT nId)
//STRIP001 {
//STRIP001 	pSh->StartAllAction();
//STRIP001 	(*pSrtLst)[ nId ]->GetPosOfContent( *pSh->GetCrsr()->GetPoint() );
//STRIP001 	pSh->EndAllAction();
//STRIP001 }

	// vergleiche TmpLst mit akt Feldern. Alle neue kommen in die SortLst
	// damit sie geupdatet werden koennen. Returnt die Anzahl.
	// (Fuer Textbausteine: nur seine Input-Felder aktualisieren)
//STRIP001 USHORT SwInputFieldList::BuildSortLst()
//STRIP001 {
//STRIP001 	SwNodes* pNds = &pSh->GetDoc()->GetNodes();
//STRIP001 	const SwFldTypes& rFldTypes = *pSh->GetDoc()->GetFldTypes();
//STRIP001 	USHORT nSize = rFldTypes.Count();
//STRIP001 
//STRIP001 	// Alle Typen abklappern
//STRIP001 
//STRIP001 	for( USHORT i = 0; i < nSize; ++i )
//STRIP001 	{
//STRIP001 		SwFieldType* pFldType = (SwFieldType*)rFldTypes[ i ];
//STRIP001 		USHORT nType = pFldType->Which();
//STRIP001 
//STRIP001 		if( RES_SETEXPFLD == nType || RES_INPUTFLD == nType )
//STRIP001 		{
//STRIP001 			SwClientIter aIter( *pFldType );
//STRIP001 			for( SwFmtFld* pFld = (SwFmtFld*)aIter.First( TYPE(SwFmtFld) );
//STRIP001 					pFld; pFld = (SwFmtFld*)aIter.Next() )
//STRIP001 			{
//STRIP001 				const SwTxtFld* pTxtFld = pFld->GetTxtFld();
//STRIP001 
//STRIP001 				//	nur InputFields und interaktive SetExpFlds bearbeiten
//STRIP001 				if( !pTxtFld || ( RES_SETEXPFLD == nType &&
//STRIP001 					!((SwSetExpField*)pFld->GetFld())->GetInputFlag()))
//STRIP001 					continue;
//STRIP001 
//STRIP001 				const SwTxtNode& rTxtNode = pTxtFld->GetTxtNode();
//STRIP001 				if( rTxtNode.GetNodes().IsDocNodes() )
//STRIP001 				{
//STRIP001 					VoidPtr pTmp = (VoidPtr)pTxtFld;
//STRIP001 					// nicht in der TempListe vorhanden, also in die SortListe
//STRIP001 					// aufnehemen
//STRIP001 					USHORT nFndPos = aTmpLst.GetPos( pTmp );
//STRIP001 					if( USHRT_MAX == nFndPos )
//STRIP001 					{
//STRIP001 						SwNodeIndex aIdx( rTxtNode );
//STRIP001 						_SetGetExpFld* pNew = new _SetGetExpFld(aIdx, pTxtFld );
//STRIP001 						pSrtLst->Insert( pNew );
//STRIP001 					}
//STRIP001 					else
//STRIP001 						aTmpLst.Remove( nFndPos );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// die Pointer werden nicht mehr gebraucht
//STRIP001 	aTmpLst.Remove( 0, aTmpLst.Count() );
//STRIP001 	return pSrtLst->Count();
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Alle Felder auerhalb von Selektionen aus Liste entfernen
 --------------------------------------------------------------------*/

//STRIP001 void SwInputFieldList::RemoveUnselectedFlds()
//STRIP001 {
//STRIP001 	_SetGetExpFlds*	pNewLst = new _SetGetExpFlds();
//STRIP001 
//STRIP001 	FOREACHPAM_START(pSh)
//STRIP001 	{
//STRIP001 		for (USHORT i = 0; i < Count();)
//STRIP001 		{
//STRIP001 			_SetGetExpFld* pFld = (*pSrtLst)[i];
//STRIP001 			SwPosition aPos(*PCURCRSR->GetPoint());
//STRIP001 
//STRIP001 			pFld->GetPos( aPos );
//STRIP001 
//STRIP001 			if (aPos >= *PCURCRSR->Start() && aPos < *PCURCRSR->End())
//STRIP001 			{
//STRIP001 				// Feld innerhalb der Selektion
//STRIP001 				pNewLst->Insert( (*pSrtLst)[i] );
//STRIP001 				pSrtLst->Remove(i, 1);
//STRIP001 			}
//STRIP001 			else
//STRIP001 				i++;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	FOREACHPAM_END()
//STRIP001 
//STRIP001 	delete pSrtLst;
//STRIP001 	pSrtLst = pNewLst;
//STRIP001 }


}
