/*************************************************************************
 *
 *  $RCSfile: sw_SwXMLBlockListContext.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: aw $ $Date: 2003/12/05 15:10:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Martin Gallwey (gallwey@sun.com)
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SW_XMLBLOCKLISTCONTEXT_HXX
//STRIP001 #include <SwXMLBlockListContext.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SW_XMLBLOCKIMPORT_HXX
//STRIP001 #include <SwXMLBlockImport.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SW_XMLTEXTBLOCKS_HXX
//STRIP001 #include <SwXMLTextBlocks.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _XMLOFF_XMLIMP_HXX
//STRIP001 #include <bf_xmloff/xmlimp.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_NMSPMAP_HXX
//STRIP001 #include <bf_xmloff/nmspmap.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLNMSPE_HXX
//STRIP001 #include <bf_xmloff/xmlnmspe.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOTOOLS_CHARCLASS_HXX
//STRIP001 #include <unotools/charclass.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLTOKEN_HXX
//STRIP001 #include <bf_xmloff/xmltoken.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001                       
//STRIP001 
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 using namespace ::com::sun::star;
//STRIP001 using namespace ::binfilter::xmloff::token;
//STRIP001 using namespace ::rtl;

//STRIP001 SwXMLBlockListContext::SwXMLBlockListContext(
//STRIP001    SwXMLBlockListImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001 	rLocalRef (rImport),
//STRIP001 	SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 	sal_Int16 nAttrCount = xAttrList.is() ? xAttrList->getLength() : 0;
//STRIP001 	for (sal_Int16 i=0; i < nAttrCount; i++)
//STRIP001 	{
//STRIP001 		const OUString& rAttrName = xAttrList->getNameByIndex( i );
//STRIP001 		OUString aLocalName;
//STRIP001 		sal_uInt16 nPrefix = rImport.GetNamespaceMap().GetKeyByAttrName( rAttrName, &aLocalName);
//STRIP001 		const OUString& rAttrValue = xAttrList->getValueByIndex( i );
//STRIP001 		if ( XML_NAMESPACE_BLOCKLIST == nPrefix )
//STRIP001 		{
//STRIP001 			if ( IsXMLToken ( aLocalName, XML_LIST_NAME ) )
//STRIP001 			{
//STRIP001 				rImport.getBlockList().SetName(rAttrValue);
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

//STRIP001 SwXMLBlockListContext::~SwXMLBlockListContext ( void )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SwXMLBlockListContext::CreateChildContext(
//STRIP001 	sal_uInt16 nPrefix,
//STRIP001 	const OUString& rLocalName,
//STRIP001 	const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 	if (nPrefix == XML_NAMESPACE_BLOCKLIST &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BLOCK ) )
//STRIP001 		pContext = new SwXMLBlockContext (rLocalRef, nPrefix, rLocalName, xAttrList);
//STRIP001 	else
//STRIP001 		pContext = new SvXMLImportContext( rLocalRef, nPrefix, rLocalName);
//STRIP001 	return pContext;
//STRIP001 }

//STRIP001 SwXMLBlockContext::SwXMLBlockContext(
//STRIP001    SwXMLBlockListImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001 	rLocalRef(rImport),
//STRIP001 	SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 	static const CharClass & rCC = GetAppCharClass();
//STRIP001 	String aShort, aLong, aPackageName;
//STRIP001 	BOOL bTextOnly = FALSE;
//STRIP001 
//STRIP001 	sal_Int16 nAttrCount = xAttrList.is() ? xAttrList->getLength() : 0;
//STRIP001 	for (sal_Int16 i=0; i < nAttrCount; i++)
//STRIP001 	{
//STRIP001 		const OUString& rAttrName = xAttrList->getNameByIndex( i );
//STRIP001 		OUString aLocalName;
//STRIP001 		sal_uInt16 nPrefix = rImport.GetNamespaceMap().GetKeyByAttrName( rAttrName, &aLocalName);
//STRIP001 		const OUString& rAttrValue = xAttrList->getValueByIndex( i );
//STRIP001 		if (XML_NAMESPACE_BLOCKLIST == nPrefix)
//STRIP001 		{
//STRIP001 			if ( IsXMLToken ( aLocalName, XML_ABBREVIATED_NAME ) )
//STRIP001 			{
//STRIP001 				aShort = rCC.upper(rAttrValue);
//STRIP001 			}
//STRIP001 			else if ( IsXMLToken ( aLocalName, XML_NAME ) )
//STRIP001 			{
//STRIP001 				aLong = rAttrValue;
//STRIP001 			}
//STRIP001 			else if ( IsXMLToken ( aLocalName, XML_PACKAGE_NAME ) )
//STRIP001 			{
//STRIP001 				aPackageName = rAttrValue;
//STRIP001 			}
//STRIP001 			else if ( IsXMLToken ( aLocalName, XML_UNFORMATTED_TEXT ) )
//STRIP001 			{
//STRIP001 				if ( IsXMLToken ( rAttrValue, XML_TRUE ) )
//STRIP001 					bTextOnly = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (!aShort.Len() || !aLong.Len() || !aPackageName.Len())
//STRIP001 		return;
//STRIP001 	rImport.getBlockList().AddName( aShort, aLong, aPackageName, bTextOnly);
//STRIP001 }

//STRIP001 SwXMLBlockContext::~SwXMLBlockContext ( void )
//STRIP001 {
//STRIP001 }

//STRIP001 SwXMLTextBlockDocumentContext::SwXMLTextBlockDocumentContext(
//STRIP001    SwXMLTextBlockImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001 	rLocalRef(rImport),
//STRIP001 	SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SwXMLTextBlockDocumentContext::CreateChildContext(
//STRIP001 	sal_uInt16 nPrefix,
//STRIP001 	const OUString& rLocalName,
//STRIP001 	const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 	if (nPrefix == XML_NAMESPACE_OFFICE &&
//STRIP001 		IsXMLToken ( rLocalName, XML_BODY ) )
//STRIP001 		pContext = new SwXMLTextBlockBodyContext (rLocalRef, nPrefix, rLocalName, xAttrList);
//STRIP001 	else
//STRIP001 		pContext = new SvXMLImportContext( rLocalRef, nPrefix, rLocalName);
//STRIP001 	return pContext;
//STRIP001 }
//STRIP001 SwXMLTextBlockDocumentContext::~SwXMLTextBlockDocumentContext ( void )
//STRIP001 {
//STRIP001 }
//STRIP001 SwXMLTextBlockBodyContext::SwXMLTextBlockBodyContext(
//STRIP001    SwXMLTextBlockImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001 	rLocalRef(rImport),
//STRIP001 	SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SwXMLTextBlockBodyContext::CreateChildContext(
//STRIP001 	sal_uInt16 nPrefix,
//STRIP001 	const OUString& rLocalName,
//STRIP001 	const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 	if (nPrefix == XML_NAMESPACE_TEXT &&
//STRIP001 		IsXMLToken ( rLocalName, XML_P ) )
//STRIP001 		pContext = new SwXMLTextBlockParContext (rLocalRef, nPrefix, rLocalName, xAttrList);
//STRIP001 	else
//STRIP001 		pContext = new SvXMLImportContext( rLocalRef, nPrefix, rLocalName);
//STRIP001 	return pContext;
//STRIP001 }
//STRIP001 SwXMLTextBlockBodyContext::~SwXMLTextBlockBodyContext ( void )
//STRIP001 {
//STRIP001 }
//STRIP001 SwXMLTextBlockParContext::SwXMLTextBlockParContext(
//STRIP001    SwXMLTextBlockImport& rImport,
//STRIP001    sal_uInt16 nPrefix,
//STRIP001    const OUString& rLocalName,
//STRIP001    const ::com::sun::star::uno::Reference<
//STRIP001    ::com::sun::star::xml::sax::XAttributeList > & xAttrList ) :
//STRIP001 	rLocalRef(rImport),
//STRIP001 	SvXMLImportContext ( rImport, nPrefix, rLocalName )
//STRIP001 {
//STRIP001 }

//STRIP001 void SwXMLTextBlockParContext::Characters( const ::rtl::OUString& rChars )
//STRIP001 {
//STRIP001 	rLocalRef.m_rText.Append ( rChars.getStr());
//STRIP001 }
//STRIP001 SwXMLTextBlockParContext::~SwXMLTextBlockParContext ( void )
//STRIP001 {
//STRIP001 	if (rLocalRef.bTextOnly)
//STRIP001 		rLocalRef.m_rText.AppendAscii( "\015" );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if (rLocalRef.m_rText.GetChar ( rLocalRef.m_rText.Len()) != ' ' )
//STRIP001 			rLocalRef.m_rText.AppendAscii( " " );
//STRIP001 	}
//STRIP001 }
}
