/*************************************************************************
 *
 *  $RCSfile: sw_macassgn.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include "hintids.hxx"
//STRIP001 
//STRIP001 #define _SVSTDARR_STRINGSDTOR
//STRIP001 #include <svtools/svstdarr.hxx>
//STRIP001 
//STRIP001 #ifndef _SVX_HTMLMODE_HXX
//STRIP001 #include <bf_svx/htmlmode.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_SVXIDS_HRC //autogen
//STRIP001 #include <bf_svx/svxids.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _SFXAPP_HXX //autogen
//STRIP001 #include <bf_sfx2/app.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "swtypes.hxx"
//STRIP001 #include "wrtsh.hxx"
//STRIP001 #include "viewopt.hxx"
//STRIP001 #include "macassgn.hxx"
//STRIP001 #include "swevent.hxx"
//STRIP001 #include "docsh.hxx"
//STRIP001 #include "globals.hrc"


//STRIP001 SvStringsDtor* __EXPORT _GetRangeHdl( _SfxMacroTabPage*, const String& );


//STRIP001 SwMacroAssignDlg::SwMacroAssignDlg( Window* pParent, SfxItemSet& rSet,
//STRIP001 										DlgEventType eType )
//STRIP001 	: SfxMacroAssignDlg( pParent, rSet )
//STRIP001 {
//STRIP001 	 // TabPage holen
//STRIP001 	SwMacroAssignDlg::AddEvents( *(SfxMacroTabPage*) GetTabPage(), eType );
//STRIP001 }


//STRIP001 SwMacroAssignDlg::~SwMacroAssignDlg()
//STRIP001 {
//STRIP001 }


//STRIP001 void SwMacroAssignDlg::AddEvents( SfxMacroTabPage& rPg, DlgEventType eType )
//STRIP001 {
//STRIP001 	const SfxItemSet& rSet = rPg.GetItemSet();
//STRIP001 
//STRIP001 	BOOL bHtmlMode = FALSE;
//STRIP001 	USHORT nHtmlMode = ::binfilter::GetHtmlMode((const SwDocShell*)SfxObjectShell::Current());
//STRIP001 	bHtmlMode = nHtmlMode & HTMLMODE_ON ? TRUE : FALSE;
//STRIP001 
//STRIP001 	switch( eType )
//STRIP001 	{
//STRIP001 	case MACASSGN_TEXTBAUST:			// Textbausteine
//STRIP001 		rPg.SetGetRangeLink( &_GetRangeHdl );
//STRIP001 		rPg.AddEvent( String( SW_RES(STR_EVENT_START_INS_GLOSSARY) ),
//STRIP001 							SW_EVENT_START_INS_GLOSSARY );
//STRIP001 		rPg.AddEvent( String( SW_RES(STR_EVENT_END_INS_GLOSSARY) ),
//STRIP001 							SW_EVENT_END_INS_GLOSSARY);
//STRIP001 		// damit der neue Handler aktiv wird!
//STRIP001 		rPg.Reset( rSet );
//STRIP001 		break;
//STRIP001 	case MACASSGN_ALLFRM:
//STRIP001 	case MACASSGN_GRAPHIC:			// Grafiken
//STRIP001 		{
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_IMAGE_ERROR) ),
//STRIP001 								SVX_EVENT_IMAGE_ERROR);
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_IMAGE_ABORT) ),
//STRIP001 								SVX_EVENT_IMAGE_ABORT);
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_IMAGE_LOAD) ),
//STRIP001 								SVX_EVENT_IMAGE_LOAD);
//STRIP001 		}
//STRIP001 		// kein break;
//STRIP001 	case MACASSGN_FRMURL:			// Frm - URL-Attribute
//STRIP001 		{
//STRIP001 			if( !bHtmlMode &&
//STRIP001 				(MACASSGN_FRMURL == eType || MACASSGN_ALLFRM == eType))
//STRIP001 			{
//STRIP001 				rPg.AddEvent( String( SW_RES( STR_EVENT_FRM_KEYINPUT_A ) ),
//STRIP001 								SW_EVENT_FRM_KEYINPUT_ALPHA );
//STRIP001 				rPg.AddEvent( String( SW_RES( STR_EVENT_FRM_KEYINPUT_NOA ) ),
//STRIP001 								SW_EVENT_FRM_KEYINPUT_NOALPHA );
//STRIP001 				rPg.AddEvent( String( SW_RES( STR_EVENT_FRM_RESIZE ) ),
//STRIP001 								SW_EVENT_FRM_RESIZE );
//STRIP001 				rPg.AddEvent( String( SW_RES( STR_EVENT_FRM_MOVE ) ),
//STRIP001 								SW_EVENT_FRM_MOVE );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		// kein break;
//STRIP001 	case MACASSGN_OLE:				// OLE
//STRIP001 		{
//STRIP001 			if( !bHtmlMode )
//STRIP001 				rPg.AddEvent( String( SW_RES(STR_EVENT_OBJECT_SELECT) ),
//STRIP001 								SW_EVENT_OBJECT_SELECT );
//STRIP001 		}
//STRIP001 		// kein break;
//STRIP001 	case MACASSGN_INETFMT:			// INetFmt-Attribute
//STRIP001 		{
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_MOUSEOVER_OBJECT) ),
//STRIP001 								SFX_EVENT_MOUSEOVER_OBJECT );
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_MOUSECLICK_OBJECT) ),
//STRIP001 								SFX_EVENT_MOUSECLICK_OBJECT);
//STRIP001 			rPg.AddEvent( String( SW_RES(STR_EVENT_MOUSEOUT_OBJECT) ),
//STRIP001 								SFX_EVENT_MOUSEOUT_OBJECT);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }


//STRIP001 BOOL SwMacroAssignDlg::INetFmtDlg( Window* pParent, SwWrtShell& rSh,
//STRIP001 									SvxMacroItem*& rpINetItem )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	SfxItemSet aSet( rSh.GetAttrPool(), RES_FRMMACRO, RES_FRMMACRO );
//STRIP001 	SvxMacroItem aItem;
//STRIP001 	if( !rpINetItem )
//STRIP001 		rpINetItem = new SvxMacroItem;
//STRIP001 	else
//STRIP001 		aItem.SetMacroTable( rpINetItem->GetMacroTable() );
//STRIP001 
//STRIP001 	aSet.Put( aItem );
//STRIP001 
//STRIP001 	SwMacroAssignDlg aMacDlg( pParent, aSet, MACASSGN_INETFMT );
//STRIP001 	if( aMacDlg.Execute() == RET_OK )
//STRIP001 	{
//STRIP001 		const SfxItemSet* pOutSet = aMacDlg.GetOutputItemSet();
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		if( SFX_ITEM_SET == pOutSet->GetItemState( RES_FRMMACRO, FALSE, &pItem ))
//STRIP001 		{
//STRIP001 			rpINetItem->SetMacroTable( ((SvxMacroItem*)pItem)->GetMacroTable() );
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }


//STRIP001 SvStringsDtor* __EXPORT _GetRangeHdl( _SfxMacroTabPage* pTbPg, const String& rLanguage )
//STRIP001 {
//STRIP001 	SvStringsDtor* pNew = new SvStringsDtor;
//STRIP001 
//STRIP001 	SfxApplication* pSfxApp = SFX_APP();
//STRIP001 	if ( !rLanguage.EqualsAscii(SVX_MACRO_LANGUAGE_JAVASCRIPT) )
//STRIP001 	{
//STRIP001 		pSfxApp->EnterBasicCall();
//STRIP001 
//STRIP001 		String* pNewEntry = new String( pSfxApp->GetName() );
//STRIP001 		pNew->Insert( pNewEntry, pNew->Count() );
//STRIP001 
//STRIP001 		TypeId aType( TYPE( SwDocShell ));
//STRIP001 		SfxObjectShell* pDoc = SfxObjectShell::GetFirst( &aType );
//STRIP001 		while( pDoc )
//STRIP001 		{
//STRIP001 			pNewEntry = new String( pDoc->GetTitle() );
//STRIP001 			pNew->Insert( pNewEntry, pNew->Count() );
//STRIP001 			pDoc = SfxObjectShell::GetNext( *pDoc, &aType );
//STRIP001 		}
//STRIP001 		pSfxApp->LeaveBasicCall();
//STRIP001 	}
//STRIP001 
//STRIP001 	return pNew;
//STRIP001 }


}
