/*************************************************************************
 *
 *  $RCSfile: sw_flddb.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:48:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>
// auto strip #endif
#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif
// auto strip #ifndef _DBFLD_HXX
// auto strip #include <dbfld.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _FLDTDLG_HXX
// auto strip #include <fldtdlg.hxx>
// auto strip #endif
// auto strip #ifndef _NUMRULE_HXX
// auto strip #include <numrule.hxx>
// auto strip #endif

#ifndef _FLDTDLG_HRC
#include <fldtdlg.hrc>
#endif
#ifndef _FLDUI_HRC
#include <fldui.hrc>
#endif
// auto strip #ifndef _FLDDB_HXX
// auto strip #include <flddb.hxx>
// auto strip #endif
// auto strip #ifndef _DBCONFIG_HXX
// auto strip #include <dbconfig.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 #define USER_DATA_VERSION_1 	"1"
//STRIP001 #define USER_DATA_VERSION USER_DATA_VERSION_1
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SwFldDBPage::SwFldDBPage(Window* pParent, const SfxItemSet& rCoreSet ) :
//STRIP001 	SwFldPage( pParent, SW_RES( TP_FLD_DB ), rCoreSet ),
//STRIP001 	aTypeFT		(this, SW_RES(FT_DBTYPE)),
//STRIP001 	aTypeLB		(this, SW_RES(LB_DBTYPE)),
//STRIP001 	aSelectionFT(this, SW_RES(FT_DBSELECTION)),
//STRIP001     aDatabaseTLB(this, SW_RES(TLB_DBLIST), ::GetActiveView()->GetWrtShell(),aEmptyStr, FALSE),
//STRIP001 	aConditionFT(this, SW_RES(FT_DBCONDITION)),
//STRIP001 	aConditionED(this, SW_RES(ED_DBCONDITION)),
//STRIP001 	aValueFT	(this, SW_RES(FT_DBSETNUMBER)),
//STRIP001 	aValueED	(this, SW_RES(ED_DBSETNUMBER)),
//STRIP001 	aDBFormatRB	(this, SW_RES(RB_DBOWNFORMAT)),
//STRIP001 	aNewFormatRB(this, SW_RES(RB_DBFORMAT)),
//STRIP001 	aNumFormatLB(this, SW_RES(LB_DBNUMFORMAT)),
//STRIP001 	aFormatLB	(this, SW_RES(LB_DBFORMAT)),
//STRIP001     aFormatFL   (this, SW_RES(FL_DBFORMAT)),
//STRIP001     aFormatVertFL   (this, SW_RES(FL_DBFORMAT_VERT))
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aOldNumSelectHdl = aNumFormatLB.GetSelectHdl();
//STRIP001 
//STRIP001 	aNumFormatLB.SetSelectHdl(LINK(this, SwFldDBPage, NumSelectHdl));
//STRIP001 	aDatabaseTLB.SetSelectHdl(LINK(this, SwFldDBPage, TreeSelectHdl));
//STRIP001 	aDatabaseTLB.SetDoubleClickHdl(LINK(this, SwFldDBPage, InsertHdl));
//STRIP001 
//STRIP001 	aValueED.SetModifyHdl(LINK(this, SwFldDBPage, ModifyHdl));
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 __EXPORT SwFldDBPage::~SwFldDBPage()
//STRIP001 {
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: TabPage initialisieren
 --------------------------------------------------------------------*/

//STRIP001 void __EXPORT SwFldDBPage::Reset(const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	Init();	// Allgemeine initialisierung
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(FALSE);
//STRIP001 	USHORT nOldPos = aTypeLB.GetSelectEntryPos();
//STRIP001 	sOldDBName = aDatabaseTLB.GetDBName(sOldTableName, sOldColumnName);
//STRIP001 
//STRIP001 	aTypeLB.Clear();
//STRIP001 
//STRIP001 	USHORT nPos, nTypeId, i;
//STRIP001 
//STRIP001 	if (!IsFldEdit())
//STRIP001 	{
//STRIP001 		// TypeListBox initialisieren
//STRIP001 		const SwFldGroupRgn& rRg = GetFldMgr().GetGroupRange(IsFldDlgHtmlMode(), GetGroup());
//STRIP001 
//STRIP001 		for(i = rRg.nStart; i < rRg.nEnd; ++i)
//STRIP001 		{
//STRIP001 			nTypeId = GetFldMgr().GetTypeId(i);
//STRIP001 			nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(i));
//STRIP001 			aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nTypeId = GetCurField()->GetTypeId();
//STRIP001 		nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(GetFldMgr().GetPos(nTypeId)));
//STRIP001 		aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001 	}
//STRIP001 
//STRIP001 	// alte Pos selektieren
//STRIP001 	if (GetTypeSel() != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		aTypeLB.SelectEntryPos(GetTypeSel());
//STRIP001 
//STRIP001 	aFormatLB.Clear();
//STRIP001 
//STRIP001 	USHORT nSize = GetFldMgr().GetFormatCount(TYP_DBSETNUMBERFLD, FALSE, IsFldDlgHtmlMode());
//STRIP001 	for( i = 0; i < nSize; ++i )
//STRIP001 	{
//STRIP001 		USHORT nPos = aFormatLB.InsertEntry(GetFldMgr().GetFormatStr(TYP_DBSETNUMBERFLD, i));
//STRIP001 		USHORT nFmtId = GetFldMgr().GetFormatId( TYP_DBSETNUMBERFLD, i );
//STRIP001 		aFormatLB.SetEntryData( nPos, (void*)nFmtId );
//STRIP001 		if( SVX_NUM_ARABIC == nFmtId )
//STRIP001 			aFormatLB.SelectEntryPos( nPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!IsFldEdit())
//STRIP001 	{
//STRIP001 		if (nOldPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 			aTypeLB.SelectEntryPos(nOldPos);
//STRIP001 
//STRIP001 		if (sOldDBName.Len())
//STRIP001 		{
//STRIP001 			aDatabaseTLB.Select(sOldDBName, sOldTableName, sOldColumnName);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SwWrtShell *pSh = ::GetActiveView()->GetWrtShellPtr();
//STRIP001 			SwDBData aTmp(pSh->GetDBData());
//STRIP001 
//STRIP001 			aDatabaseTLB.Select(aTmp.sDataSource, aTmp.sCommand, aEmptyStr);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !IsRefresh() )
//STRIP001 	{
//STRIP001 		String sUserData = GetUserData();
//STRIP001 		if(sUserData.GetToken(0, ';').EqualsIgnoreCaseAscii(USER_DATA_VERSION_1))
//STRIP001 		{
//STRIP001 			String sVal = sUserData.GetToken(1, ';');
//STRIP001 			USHORT nVal = (USHORT)sVal.ToInt32();
//STRIP001 			if(nVal != USHRT_MAX)
//STRIP001 			{
//STRIP001 				for(USHORT i = 0; i < aTypeLB.GetEntryCount(); i++)
//STRIP001 					if(nVal == (USHORT)(ULONG)aTypeLB.GetEntryData(i))
//STRIP001 					{
//STRIP001 						aTypeLB.SelectEntryPos(i);
//STRIP001 						break;
//STRIP001 					}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	TypeHdl(0);
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(TRUE);
//STRIP001 	aTypeLB.SetSelectHdl(LINK(this, SwFldDBPage, TypeHdl));
//STRIP001 	aTypeLB.SetDoubleClickHdl(LINK(this, SwFldDBPage, InsertHdl));
//STRIP001 
//STRIP001 	if (IsFldEdit())
//STRIP001 	{
//STRIP001 		aConditionED.SaveValue();
//STRIP001 		aValueED.SaveValue();
//STRIP001 		sOldDBName = aDatabaseTLB.GetDBName(sOldTableName, sOldColumnName);
//STRIP001 		nOldFormat = GetCurField()->GetFormat();
//STRIP001 		nOldSubType = GetCurField()->GetSubType();
//STRIP001 	}
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 BOOL __EXPORT SwFldDBPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	String sTableName, sColumnName;
//STRIP001 	SwDBData aData;
//STRIP001     sal_Bool bIsTable;
//STRIP001 	aData.sDataSource = aDatabaseTLB.GetDBName(sTableName, sColumnName, &bIsTable);
//STRIP001 	aData.sCommand = sTableName;
//STRIP001     aData.nCommandType = bIsTable ? 0 : 1;
//STRIP001 	SwWrtShell *pSh = ::GetActiveView()->GetWrtShellPtr();
//STRIP001 
//STRIP001 	if (!aData.sDataSource.getLength())
//STRIP001 		aData = pSh->GetDBData();
//STRIP001 	else
//STRIP001 		pSh->ChgDBData(aData);
//STRIP001 
//STRIP001 	if(aData.sDataSource.getLength())		// Ohne Datenbank kein neuer Feldbefehl
//STRIP001 	{
//STRIP001 		USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 		String aVal(aValueED.GetText());
//STRIP001 		String aName(aConditionED.GetText());
//STRIP001 		ULONG nFormat = 0;
//STRIP001 		USHORT nSubType = 0;
//STRIP001 
//STRIP001 		String sDBName = aData.sDataSource;
//STRIP001 		sDBName += DB_DELIM;
//STRIP001 		sDBName += (String)aData.sCommand;
//STRIP001 		sDBName += DB_DELIM;
//STRIP001         sDBName += String::CreateFromInt32(aData.nCommandType);
//STRIP001 		sDBName += DB_DELIM;
//STRIP001         if(sColumnName.Len())
//STRIP001 		{
//STRIP001 			sDBName += sColumnName;
//STRIP001 			sDBName += DB_DELIM;
//STRIP001 		}
//STRIP001 		aName.Insert(sDBName, 0);
//STRIP001 
//STRIP001 		switch (nTypeId)
//STRIP001 		{
//STRIP001 		case TYP_DBFLD:
//STRIP001 			nFormat = aNumFormatLB.GetFormat();
//STRIP001 			if (aNewFormatRB.IsEnabled() && aNewFormatRB.IsChecked())
//STRIP001 				nSubType = SUB_OWN_FMT;
//STRIP001 			aName = sDBName;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_DBSETNUMBERFLD:
//STRIP001 			nFormat = (USHORT)(ULONG)aFormatLB.GetEntryData(
//STRIP001 								aFormatLB.GetSelectEntryPos() );
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 		String sTempDBName, sTempTableName, sTempColumnName;
//STRIP001 		sTempDBName = aDatabaseTLB.GetDBName(sTempTableName, sTempColumnName);
//STRIP001 		BOOL bDBListBoxChanged = sOldDBName != sTempDBName ||
//STRIP001 			sOldTableName != sTempTableName || sOldColumnName != sTempColumnName;
//STRIP001 		if (!IsFldEdit() ||
//STRIP001 			aConditionED.GetSavedValue() != aConditionED.GetText() ||
//STRIP001 			 aValueED.GetSavedValue() != aValueED.GetText() ||
//STRIP001 			 bDBListBoxChanged ||
//STRIP001 			 nOldFormat != nFormat || nOldSubType != nSubType)
//STRIP001 		{
//STRIP001 			InsertFld( nTypeId, nSubType, aName, aVal, nFormat);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SfxTabPage* __EXPORT SwFldDBPage::Create( 	Window* pParent,
//STRIP001 						const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return ( new SwFldDBPage( pParent, rAttrSet ) );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 USHORT SwFldDBPage::GetGroup()
//STRIP001 {
//STRIP001 	return GRP_DB;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 IMPL_LINK( SwFldDBPage, TypeHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	// Alte ListBoxPos sichern
//STRIP001 	const USHORT nOld = GetTypeSel();
//STRIP001 
//STRIP001 	// Aktuelle ListBoxPos
//STRIP001 	SetTypeSel(aTypeLB.GetSelectEntryPos());
//STRIP001 
//STRIP001 	if(GetTypeSel() == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 	{
//STRIP001 		SetTypeSel(0);
//STRIP001 		aTypeLB.SelectEntryPos(0);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nOld != GetTypeSel())
//STRIP001 	{
//STRIP001 		SwWrtShell *pSh = ::GetActiveView()->GetWrtShellPtr();
//STRIP001 		BOOL bCond = FALSE, bSetNo = FALSE, bFormat = FALSE, bDBFormat = FALSE;
//STRIP001 		USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 		aDatabaseTLB.ShowColumns(nTypeId == TYP_DBFLD);
//STRIP001 
//STRIP001 		if (IsFldEdit())
//STRIP001 		{
//STRIP001 			SwDBData aData;
//STRIP001 			String sColumnName;
//STRIP001 			if (nTypeId == TYP_DBFLD)
//STRIP001 			{
//STRIP001 				aData = ((SwDBField*)GetCurField())->GetDBData();
//STRIP001 				sColumnName = ((SwDBFieldType*)GetCurField()->GetTyp())->GetColumnName();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				aData = ((SwDBNameInfField*)GetCurField())->GetDBData(pSh->GetDoc());
//STRIP001 			}
//STRIP001 			aDatabaseTLB.Select(aData.sDataSource, aData.sCommand, sColumnName);
//STRIP001 		}
//STRIP001 
//STRIP001 		switch (nTypeId)
//STRIP001 		{
//STRIP001 			case TYP_DBFLD:
//STRIP001 				bFormat = TRUE;
//STRIP001 				bDBFormat = TRUE;
//STRIP001 				aNumFormatLB.Show();
//STRIP001 				aFormatLB.Hide();
//STRIP001 
//STRIP001 				if (pBox)	// Typ wurde vom User geaendert
//STRIP001 					aDBFormatRB.Check();
//STRIP001 
//STRIP001 				if (IsFldEdit())
//STRIP001 				{
//STRIP001 					if (GetCurField()->GetFormat() != 0 && GetCurField()->GetFormat() != ULONG_MAX)
//STRIP001 						aNumFormatLB.SetDefFormat(GetCurField()->GetFormat());
//STRIP001 
//STRIP001 					if (GetCurField()->GetSubType() & SUB_OWN_FMT)
//STRIP001 						aNewFormatRB.Check();
//STRIP001 					else
//STRIP001 						aDBFormatRB.Check();
//STRIP001 				}
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_DBNUMSETFLD:
//STRIP001 				bSetNo = TRUE;
//STRIP001 				// kein break!
//STRIP001 			case TYP_DBNEXTSETFLD:
//STRIP001 				bCond = TRUE;
//STRIP001 				if (IsFldEdit())
//STRIP001 				{
//STRIP001 					aConditionED.SetText(GetCurField()->GetPar1());
//STRIP001 					aValueED.SetText(GetCurField()->GetPar2());
//STRIP001 				}
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_DBNAMEFLD:
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_DBSETNUMBERFLD:
//STRIP001 				bFormat = TRUE;
//STRIP001 				aNewFormatRB.Check();
//STRIP001 				aNumFormatLB.Hide();
//STRIP001 				aFormatLB.Show();
//STRIP001 				if( IsFldEdit() )
//STRIP001 				{
//STRIP001 					for( USHORT nI = aFormatLB.GetEntryCount(); nI; )
//STRIP001 						if( GetCurField()->GetFormat() == (USHORT)(ULONG)
//STRIP001 							aFormatLB.GetEntryData( --nI ))
//STRIP001 						{
//STRIP001 							aFormatLB.SelectEntryPos( nI );
//STRIP001 							break;
//STRIP001 						}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 		}
//STRIP001 
//STRIP001 		aConditionFT.Enable(bCond);
//STRIP001 		aConditionED.Enable(bCond);
//STRIP001 		aValueFT.Enable(bSetNo);
//STRIP001 		aValueED.Enable(bSetNo);
//STRIP001 		if (nTypeId != TYP_DBFLD)
//STRIP001 		{
//STRIP001 			aDBFormatRB.Enable(bDBFormat);
//STRIP001 			aNewFormatRB.Enable(bDBFormat|bFormat);
//STRIP001 			aNumFormatLB.Enable(bDBFormat);
//STRIP001 			aFormatLB.Enable(bFormat);
//STRIP001 		}
//STRIP001         aFormatFL.Enable(bDBFormat|bFormat);
//STRIP001 
//STRIP001 		if (!IsFldEdit())
//STRIP001 		{
//STRIP001 			aValueED.SetText(aEmptyStr);
//STRIP001 			if (bCond)
//STRIP001 				aConditionED.SetText( String::CreateFromAscii(
//STRIP001 						RTL_CONSTASCII_STRINGPARAM( "TRUE" )));
//STRIP001 			else
//STRIP001 				aConditionED.SetText(aEmptyStr);
//STRIP001 		}
//STRIP001 
//STRIP001 		CheckInsert();
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 IMPL_LINK( SwFldDBPage, NumSelectHdl, NumFormatListBox *, pLB )
//STRIP001 {
//STRIP001 	aNewFormatRB.Check();
//STRIP001 	aOldNumSelectHdl.Call(pLB);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

/*---------------------------------------------------------------------
	Beschreibung:
---------------------------------------------------------------------*/

//STRIP001 void SwFldDBPage::CheckInsert()
//STRIP001 {
//STRIP001 	BOOL bInsert = TRUE;
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	SvLBoxEntry* pEntry = aDatabaseTLB.GetCurEntry();
//STRIP001 
//STRIP001 	if (pEntry)
//STRIP001 	{
//STRIP001 		pEntry = aDatabaseTLB.GetParent(pEntry);
//STRIP001 
//STRIP001 		if (nTypeId == TYP_DBFLD && pEntry)
//STRIP001 			pEntry = aDatabaseTLB.GetParent(pEntry);
//STRIP001 
//STRIP001 		bInsert &= pEntry != 0;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		bInsert = FALSE;
//STRIP001 
//STRIP001 	if (nTypeId == TYP_DBNUMSETFLD)
//STRIP001 	{
//STRIP001 		BOOL bHasValue = aValueED.GetText().Len() != 0;
//STRIP001 
//STRIP001 		bInsert &= bHasValue;
//STRIP001 	}
//STRIP001 
//STRIP001 	EnableInsert(bInsert);
//STRIP001 }

/*---------------------------------------------------------------------
	Beschreibung:
---------------------------------------------------------------------*/

//STRIP001 IMPL_LINK( SwFldDBPage, TreeSelectHdl, SvTreeListBox *, pBox )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pColEntry;
//STRIP001 	SvLBoxEntry* pEntry = pColEntry = pBox->GetCurEntry();
//STRIP001 	if (pEntry)
//STRIP001 	{
//STRIP001 		USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 		pEntry = aDatabaseTLB.GetParent(pEntry);
//STRIP001 
//STRIP001 		if (nTypeId == TYP_DBFLD && pEntry)
//STRIP001 			pEntry = aDatabaseTLB.GetParent(pEntry);
//STRIP001 
//STRIP001 		CheckInsert();
//STRIP001 
//STRIP001 		if (nTypeId == TYP_DBFLD)
//STRIP001 		{
//STRIP001 			BOOL bNumFormat = FALSE;
//STRIP001 
//STRIP001 			if (pEntry != 0)
//STRIP001 			{
//STRIP001 				String sTableName;
//STRIP001 				String sColumnName;
//STRIP001 				BOOL bIsTable;
//STRIP001 				String sDBName = aDatabaseTLB.GetDBName(sTableName, sColumnName, &bIsTable);
//STRIP001 				bNumFormat = GetFldMgr().IsDBNumeric(sDBName,
//STRIP001 							sTableName,
//STRIP001 							bIsTable,
//STRIP001 							sColumnName);
//STRIP001 				if (!IsFldEdit())
//STRIP001 					aDBFormatRB.Check();
//STRIP001 			}
//STRIP001 
//STRIP001 			aDBFormatRB.Enable(bNumFormat);
//STRIP001 			aNewFormatRB.Enable(bNumFormat);
//STRIP001 			aNumFormatLB.Enable(bNumFormat);
//STRIP001             aFormatFL.Enable(bNumFormat);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Modify
 --------------------------------------------------------------------*/

//STRIP001 IMPL_LINK( SwFldDBPage, ModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	CheckInsert();
//STRIP001 	return 0;
//STRIP001 }

/* -----------------12.01.99 11:21-------------------
 *
 * --------------------------------------------------*/
//STRIP001 void	SwFldDBPage::FillUserData()
//STRIP001 {
//STRIP001 	String sData( String::CreateFromAscii(
//STRIP001 						RTL_CONSTASCII_STRINGPARAM( USER_DATA_VERSION )));
//STRIP001 	sData += ';';
//STRIP001 	USHORT nTypeSel = aTypeLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 	if( LISTBOX_ENTRY_NOTFOUND == nTypeSel )
//STRIP001 		nTypeSel = USHRT_MAX;
//STRIP001 	else
//STRIP001 		nTypeSel = (USHORT)(ULONG)aTypeLB.GetEntryData( nTypeSel );
//STRIP001 	sData += String::CreateFromInt32( nTypeSel );
//STRIP001 	SetUserData(sData);
//STRIP001 }
/* -----------------12.12.2002 11:33-----------------
 * 
 * --------------------------------------------------*/
//STRIP001 void SwFldDBPage::ActivateMailMergeAddress()
//STRIP001 {
//STRIP001     ULONG nData = TYP_DBFLD;
//STRIP001     aTypeLB.SelectEntryPos(aTypeLB.GetEntryPos( (const void*) nData ));
//STRIP001     aTypeLB.GetSelectHdl().Call(&aTypeLB);
//STRIP001     const SwDBData& rData = SW_MOD()->GetDBConfig()->GetAddressSource();
//STRIP001 	aDatabaseTLB.Select(rData.sDataSource, rData.sCommand, aEmptyStr);
//STRIP001 }            

}
