/*************************************************************************
 *
 *  $RCSfile: outline.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:55:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OUTLINE_HXX
#define _OUTLINE_HXX


#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif


#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#include "swtypes.hxx"		//fuer MAXLEVEL
#ifndef _NUMPREVW_HXX
#include <numprevw.hxx>
#endif
#ifndef _NUMBERINGTYPELISTBOX_HXX
#include <numberingtypelistbox.hxx>
#endif
namespace binfilter {

class SwWrtShell;
class SwTxtFmtColl;
class SwNumRule;
class SwChapterNumRules;

/* -----------------07.07.98 13:38-------------------
 *
 * --------------------------------------------------*/
//STRIP001 class SwOutlineTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 	String				aNullStr;
//STRIP001 	String				aCollNames[MAXLEVEL];
//STRIP001 	PopupMenu			aFormMenu;
//STRIP001 
//STRIP001 	SwWrtShell&			rWrtSh;
//STRIP001 	SwNumRule*			pNumRule;
//STRIP001 	SwChapterNumRules*	pChapterNumRules;
//STRIP001 
//STRIP001 	USHORT 				nNumLevel;
//STRIP001 	BOOL 				bModified : 1;
//STRIP001 
//STRIP001 	protected:
//STRIP001 	DECL_LINK( CancelHdl, Button * );
//STRIP001 	DECL_LINK( FormHdl, Button * );
//STRIP001 	DECL_LINK( MenuSelectHdl, Menu * );
//STRIP001 
//STRIP001 		virtual void 	PageCreated(USHORT nPageId, SfxTabPage& rPage);
//STRIP001 		virtual short	Ok();
//STRIP001 
//STRIP001 	public:
//STRIP001 		SwOutlineTabDialog(Window* pParent,
//STRIP001 					const SfxItemSet* pSwItemSet,
//STRIP001 					SwWrtShell &);
//STRIP001 		~SwOutlineTabDialog();
//STRIP001 
//STRIP001 	SwNumRule*			GetNumRule() {return pNumRule;}
//STRIP001 	USHORT 				GetLevel(const String &rFmtName) const;
//STRIP001 	String*				GetCollNames() {return aCollNames;}
//STRIP001 	USHORT 				GetActNumLevel() {return nNumLevel;}
//STRIP001 	void				SetActNumLevel(USHORT nSet) {nNumLevel = nSet;}
//STRIP001 };
/* -----------------07.07.98 13:47-------------------
 *
 * --------------------------------------------------*/
//STRIP001 class SwOutlineSettingsTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 	ListBox			aLevelLB;
//STRIP001     FixedLine       aLevelFL;
//STRIP001 
//STRIP001 	FixedText		aCollLbl;
//STRIP001 	ListBox 		aCollBox;
//STRIP001 	FixedText		aNumberLbl;
//STRIP001 	SwNumberingTypeListBox	aNumberBox;
//STRIP001 	FixedText		aCharFmtFT;
//STRIP001 	ListBox			aCharFmtLB;
//STRIP001 	FixedText       aAllLevelFT;
//STRIP001 	NumericField	aAllLevelNF;
//STRIP001 	FixedText		aDelim;
//STRIP001 	FixedText		aPrefixFT;
//STRIP001 	Edit			aPrefixED;
//STRIP001 	FixedText		aSuffixFT;
//STRIP001 	Edit			aSuffixED;
//STRIP001 	FixedText		aStartLbl;
//STRIP001 	NumericField 	aStartEdit;
//STRIP001     FixedLine        aNumberFL;
//STRIP001 	NumberingPreview aPreviewWIN;
//STRIP001 
//STRIP001 	String				aNoFmtName;
//STRIP001 	String				aSaveCollNames[MAXLEVEL];
//STRIP001 	SwWrtShell*			pSh;
//STRIP001 	SwNumRule*			pNumRule;
//STRIP001 	String*				pCollNames;
//STRIP001 	USHORT 				nActLevel;
//STRIP001 
//STRIP001 	DECL_LINK( LevelHdl, ListBox * );
//STRIP001 	DECL_LINK( ToggleComplete, NumericField * );
//STRIP001 	DECL_LINK( CollSelect, ListBox * );
//STRIP001 	DECL_LINK( CollSelectGetFocus, ListBox * );
//STRIP001 	DECL_LINK( NumberSelect, SwNumberingTypeListBox * );
//STRIP001 	DECL_LINK( DelimModify, Edit * );
//STRIP001 	DECL_LINK( StartModified, NumericField * );
//STRIP001 	DECL_LINK( CharFmtHdl, ListBox * );
//STRIP001 
//STRIP001 	void   	Update();
//STRIP001 
//STRIP001 	void	SetModified(){aPreviewWIN.Invalidate();}
//STRIP001     void    CheckForStartValue_Impl(sal_uInt16 nNumberingType);
//STRIP001 
//STRIP001 public:
//STRIP001 	SwOutlineSettingsTabPage(Window* pParent, const SfxItemSet& rSet);
//STRIP001 	~SwOutlineSettingsTabPage();
//STRIP001 
//STRIP001 	void SetWrtShell(SwWrtShell* pShell);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 };
} //namespace binfilter
#endif
