/*************************************************************************
 *
 *  $RCSfile: tabledlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:55:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _TABLEDLG_HXX
#define _TABLEDLG_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#include "swtypes.hxx"
namespace binfilter {

//STRIP001 class SwWrtShell;
//STRIP001 class SwTabCols;
//STRIP001 struct TColumn;

//STRIP001 void lcl_ItemSetToTableParam( const SfxItemSet&, SwWrtShell& );
//STRIP001 extern const USHORT __FAR_DATA aUITableAttrRange[];

/*-------------------------------------------------------
 Tabellendialog
--------------------------------------------------------- */
//STRIP001 class SwTableTabDlg : public SfxTabDialog
//STRIP001 {
//STRIP001 	SwWrtShell* pShell;
//STRIP001 	USHORT 		nHtmlMode;
//STRIP001 
//STRIP001 	virtual void  		PageCreated(USHORT nId, SfxTabPage& rPage);
//STRIP001 public:
//STRIP001 	 SwTableTabDlg( Window* pParent, SfxItemPool& Pool,
//STRIP001 					const SfxItemSet* pItemSet, SwWrtShell* pSh );
//STRIP001 };

//STRIP001 class SwTableRep
//STRIP001 {
//STRIP001 	TColumn* 	pTColumns;
//STRIP001 
//STRIP001 	SwTwips		nTblWidth;
//STRIP001 	SwTwips		nSpace;
//STRIP001 	SwTwips		nLeftSpace;
//STRIP001 	SwTwips 	nRightSpace;
//STRIP001 	USHORT 		nAlign;
//STRIP001 	USHORT		nColCount;
//STRIP001 	USHORT		nAllCols;
//STRIP001 	USHORT 		nWidthPercent;
//STRIP001 	BOOL 		bComplex : 1;
//STRIP001 	BOOL 		bLineSelected : 1;
//STRIP001 	BOOL		bWidthChanged : 1;
//STRIP001 	BOOL		bColsChanged : 1;
//STRIP001 
//STRIP001 public:
//STRIP001 	SwTableRep( const SwTabCols& rTabCol, BOOL bComplex );
//STRIP001 	~SwTableRep();
//STRIP001 
//STRIP001 	BOOL		FillTabCols( SwTabCols& rTabCol ) const;
//STRIP001 
//STRIP001 	SwTwips 	GetLeftSpace() const			{return nLeftSpace;}
//STRIP001 	void 		SetLeftSpace(SwTwips nSet) 		{nLeftSpace = nSet;}
//STRIP001 
//STRIP001 	SwTwips		GetRightSpace() const			{return nRightSpace;}
//STRIP001 	void 		SetRightSpace(SwTwips nSet) 	{nRightSpace = nSet;}
//STRIP001 
//STRIP001 	SwTwips		GetWidth() const				{return nTblWidth;}
//STRIP001 	void 		SetWidth(SwTwips nSet) 			{nTblWidth = nSet;}
//STRIP001 
//STRIP001 	USHORT		GetWidthPercent() const			{return nWidthPercent;}
//STRIP001 	void 		SetWidthPercent(USHORT nSet) 	{nWidthPercent = nSet;}
//STRIP001 
//STRIP001 	USHORT		GetAlign() const				{return nAlign;}
//STRIP001 	void 		SetAlign(USHORT nSet) 			{nAlign = nSet;}
//STRIP001 
//STRIP001 	BOOL		IsComplex() const 				{return bComplex;}
//STRIP001 	USHORT 		GetColCount() const 			{return nColCount;}
//STRIP001 	USHORT 		GetAllColCount() const 			{return nAllCols;}
//STRIP001 
//STRIP001 	BOOL		HasColsChanged() const 			{return bColsChanged;}
//STRIP001 	void		SetColsChanged() 				{bColsChanged = TRUE;}
//STRIP001 
//STRIP001 	BOOL		HasWidthChanged() const 		{return bWidthChanged;}
//STRIP001 	void 		SetWidthChanged() 				{bWidthChanged  = TRUE;}
//STRIP001 
//STRIP001 	BOOL 		IsLineSelected() const			{return bLineSelected;}
//STRIP001 	void		SetLineSelected(BOOL bSet) 		{bLineSelected = bSet;}
//STRIP001 
//STRIP001 	SwTwips		GetSpace() const				{ return nSpace;}
//STRIP001 	void 		SetSpace(SwTwips nSet) 			{nSpace = nSet;}
//STRIP001 
//STRIP001 	TColumn* 	GetColumns() const				{return pTColumns;}
//STRIP001 };

} //namespace binfilter
#endif
