/*************************************************************************
 *
 *  $RCSfile: sw_hdftctrl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:12:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif

// auto strip #ifndef _SV_MENU_HXX //autogen
// auto strip #include <vcl/menu.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
#ifndef _SFX_OBJITEM_HXX //autogen
#include <bf_sfx2/objitem.hxx>
#endif
// auto strip #ifndef _SFX_BINDINGS_HXX
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ULSPITEM_HXX //autogen
// auto strip #include <bf_svx/ulspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_DIALMGR_HXX //autogen
// auto strip #include <bf_svx/dialmgr.hxx>
// auto strip #endif
#ifndef _SVX_DIALOGS_HRC //autogen
#include <bf_svx/dialogs.hrc>
#endif
// auto strip #ifndef _SFXSTRITEM_HXX
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _FMTHDFT_HXX //autogen
// auto strip #include <fmthdft.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
#ifndef _HDFTCTRL_HXX
#include <hdftctrl.hxx>
#endif
// auto strip #ifndef _WDOCSH_HXX
// auto strip #include <wdocsh.hxx>
// auto strip #endif
// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEDESC_HXX
// auto strip #include <pagedesc.hxx>
// auto strip #endif
// auto strip #ifndef _SHELLRES_HXX
// auto strip #include <shellres.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _MISC_HRC
#include <misc.hrc>
#endif
namespace binfilter {

#define _ALL_STYLES_MENU_ENTRY 100

/*N*/ SFX_IMPL_MENU_CONTROL( SwHeadFootMenuControl, SfxObjectItem );

//STRIP001 SwHeadFootMenuControl::SwHeadFootMenuControl( USHORT nPos, Menu& rMenu,
//STRIP001 											SfxBindings& rBindings )
//STRIP001 	: SfxMenuControl( nPos, rBindings ), pParent( &rMenu ), nInsPos( nPos ),
//STRIP001     pDynMenu( 0 ), pShell( 0 ),
//STRIP001     aStyleNames(10)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SwHeadFootMenuControl::~SwHeadFootMenuControl()
//STRIP001 {
//STRIP001 	if( pDynMenu )
//STRIP001 	{
//STRIP001 		pParent->SetPopupMenu( nInsPos, 0 );
//STRIP001 		delete pDynMenu;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SwHeadFootMenuControl::StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 										  const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if( pDynMenu )
//STRIP001 	{
//STRIP001 		if ( pParent )
//STRIP001 			pParent->SetPopupMenu( nInsPos, 0 );
//STRIP001 		delete pDynMenu, pDynMenu = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxObjectItem* pItem = PTR_CAST( SfxObjectItem, pState );
//STRIP001 	pShell = pItem ? PTR_CAST( SwDocShell, pItem->GetShell() ) : 0;
//STRIP001 	if( pShell && pShell->GetWrtShell() )
//STRIP001 	{
//STRIP001 		SwWrtShell& rSh = *pShell->GetWrtShell();
//STRIP001 
//STRIP001 		// Seitenvorlagen besorgen
//STRIP001 		USHORT n, nCnt = rSh.GetPageDescCnt();
//STRIP001         aStyleNames.DeleteAndDestroy( 0, aStyleNames.Count() );
//STRIP001 		SvBools aCheckArr( (BYTE)nCnt );
//STRIP001 		BOOL bAllOneState = TRUE, bLastCheck;
//STRIP001 
//STRIP001 		for( n = 0; n < nCnt; ++n )
//STRIP001 		{
//STRIP001 			const SwPageDesc& rDesc = rSh.GetPageDesc( n );
//STRIP001             StringPtr pNm = new String(rDesc.GetName());
//STRIP001 			USHORT nIPos;
//STRIP001             aStyleNames.Insert( pNm, nIPos );
//STRIP001 
//STRIP001 			BOOL bCheck = FN_INSERT_PAGEHEADER == nSID
//STRIP001 							? rDesc.GetMaster().GetHeader().IsActive()
//STRIP001 							: rDesc.GetMaster().GetFooter().IsActive();
//STRIP001 			aCheckArr.Insert( bCheck, nIPos );
//STRIP001 			if( bAllOneState && n && bCheck != bLastCheck )
//STRIP001 				bAllOneState = FALSE;
//STRIP001 			bLastCheck = bCheck;
//STRIP001 		}
//STRIP001 
//STRIP001 		// sollte keine "gueltige" Seitenvorlage existieren?
//STRIP001 		// (sprich: haben schon alle Kopf/Fusszeilen?)
//STRIP001         nCnt = aStyleNames.Count();
//STRIP001 		if( nCnt )
//STRIP001 		{
//STRIP001 			pDynMenu = new PopupMenu;
//STRIP001 			for( n = 0; n < nCnt; ++n )
//STRIP001 			{
//STRIP001                 pDynMenu->InsertItem( _ALL_STYLES_MENU_ENTRY + 1 + n, *aStyleNames[ n ], MIB_CHECKABLE );
//STRIP001                 pDynMenu->CheckItem( _ALL_STYLES_MENU_ENTRY + 1 + n, aCheckArr[ n ] );
//STRIP001 			}
//STRIP001 
//STRIP001 			// wenn mehrere Eintraege mit dem gleichen "CheckStatus"
//STRIP001 			// existieren, dann auch den Menupunkt "Alle" anbieten
//STRIP001 			if( 1 < nCnt && bAllOneState )
//STRIP001 			{
//STRIP001                 pDynMenu->InsertItem( _ALL_STYLES_MENU_ENTRY,  ViewShell::GetShellRes()->
//STRIP001 									aStrAllPageHeadFoot, 0, 0 );
//STRIP001 				pDynMenu->InsertSeparator( 1 );
//STRIP001 			}
//STRIP001 
//STRIP001 			pDynMenu->SetSelectHdl( LINK( this, SwHeadFootMenuControl, DynMenuPageSelect ));
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pShell = 0;
//STRIP001 
//STRIP001 	pParent->SetPopupMenu( nInsPos, pDynMenu );
//STRIP001 
//STRIP001 	SfxMenuControl::StateChanged( nSID, eState, pState );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 PopupMenu* SwHeadFootMenuControl::GetPopup() const
//STRIP001 {
//STRIP001 	return pDynMenu;
//STRIP001 }


//STRIP001 IMPL_LINK( SwHeadFootMenuControl, DynMenuPageSelect, Menu*, pMenu )
//STRIP001 {
//STRIP001     USHORT nCurId = pMenu->GetCurItemId();
//STRIP001     String sSrchNm;
//STRIP001     BOOL bChecked;
//STRIP001     if( _ALL_STYLES_MENU_ENTRY == nCurId )
//STRIP001         bChecked = pMenu->IsItemChecked( 101 );
//STRIP001     else
//STRIP001     {
//STRIP001         sSrchNm = *aStyleNames[nCurId - _ALL_STYLES_MENU_ENTRY - 1 ];
//STRIP001         bChecked = pMenu->IsItemChecked( nCurId );
//STRIP001     }
//STRIP001 
//STRIP001     const SfxPoolItem* aItems[3];
//STRIP001     SfxStringItem aStyleName(GetId(), sSrchNm);
//STRIP001     SfxBoolItem aOn(FN_PARAM_1, !bChecked);
//STRIP001     aItems[0] = &aStyleName;
//STRIP001     aItems[1] = &aOn;
//STRIP001     aItems[2] = NULL;
//STRIP001     GetBindings().ExecuteSynchron(GetId(), aItems, 0L);
//STRIP001 	return 0;
//STRIP001 }



}
