/*************************************************************************
 *
 *  $RCSfile: sw_drformsh.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:57:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #include <hintids.hxx>
// auto strip #ifndef _SVX_HLNKITEM_HXX //autogen
// auto strip #include <bf_svx/hlnkitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDVIEW_HXX //autogen
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _SFXOBJFACE_HXX //autogen
#include <bf_sfx2/objface.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
// auto strip #ifndef _SVX_SRCHITEM_HXX
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FMGLOB_HXX
// auto strip #include <bf_svx/fmglob.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOUNO_HXX //autogen
// auto strip #include <bf_svx/svdouno.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FORM_FORMBUTTONTYPE_HPP_
// auto strip #include <com/sun/star/form/FormButtonType.hpp>
// auto strip #endif
// auto strip #ifndef _SVX_HTMLMODE_HXX
// auto strip #include <bf_svx/htmlmode.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif

// auto strip #include "viewopt.hxx"
// auto strip #include "swmodule.hxx"

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "wrtsh.hxx"
#include "cmdid.h"
#include "globals.hrc"
#include "helpid.h"
#include "popup.hrc"
#include "shells.hrc"
// auto strip #include "drwbassh.hxx"
#include "drformsh.hxx"
#include "view.hxx"

#define SwDrawFormShell
#include "itemdef.hxx"

#include "so3/staticbaseurl.hxx"
namespace binfilter {
#include "swslots.hxx"
#define C2U(cChar) OUString::createFromAscii(cChar)

using namespace ::com::sun::star;
using namespace ::rtl;

/*N*/ SFX_IMPL_INTERFACE(SwDrawFormShell, SwDrawBaseShell, SW_RES(STR_SHELLNAME_DRAWFORM))
/*N*/ {
//STRIP001 /*N*/ 	SFX_POPUPMENU_REGISTRATION(SW_RES(MN_DRAWFORM_POPUPMENU));
//STRIP001 /*N*/ 	SFX_OBJECTBAR_REGISTRATION(SFX_OBJECTBAR_OBJECT, SW_RES(RID_DRAWFORM_TOOLBOX));
/*N*/ 	SFX_OBJECTMENU_REGISTRATION(SID_OBJECTMENU0, SW_RES(MN_OBJECTMENU_DRAWFORM));
/*N*/ }


//STRIP001 TYPEINIT1(SwDrawFormShell, SwDrawBaseShell)


//STRIP001 void SwDrawFormShell::Execute(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	switch ( rReq.GetSlot() )
//STRIP001 	{
//STRIP001 		case SID_HYPERLINK_SETLINK:
//STRIP001 		{
//STRIP001 		if(pArgs)
//STRIP001 			pArgs->GetItemState(SID_HYPERLINK_SETLINK, sal_False, &pItem);
//STRIP001 		if(pItem)
//STRIP001 		{
//STRIP001 			SdrView *pSdrView = rSh.GetDrawView();
//STRIP001 			const SvxHyperlinkItem& rHLinkItem = *(const SvxHyperlinkItem *)pItem;
//STRIP001 			const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001 			if (rMarkList.GetMark(0))
//STRIP001 			{
//STRIP001 				SdrUnoObj* pUnoCtrl = PTR_CAST(SdrUnoObj, rMarkList.GetMark(0)->GetObj());
//STRIP001 				if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
//STRIP001 				{
//STRIP001 					uno::Reference< awt::XControlModel >  xControlModel = pUnoCtrl->GetUnoControlModel();
//STRIP001 
//STRIP001 					ASSERT( xControlModel.is(), "UNO-Control ohne Model" );
//STRIP001 					if( !xControlModel.is() )
//STRIP001 						return;
//STRIP001 
//STRIP001 					uno::Reference< beans::XPropertySet >  xPropSet(xControlModel, uno::UNO_QUERY);
//STRIP001 
//STRIP001 					// Darf man eine URL an dem Objekt setzen?
//STRIP001 					OUString sTargetURL( C2U( "TargetURL" ));
//STRIP001 					uno::Reference< beans::XPropertySetInfo >  xPropInfoSet = xPropSet->getPropertySetInfo();
//STRIP001 					if( xPropInfoSet->hasPropertyByName( sTargetURL ))
//STRIP001 					{
//STRIP001 						beans::Property aProp = xPropInfoSet->getPropertyByName( sTargetURL );
//STRIP001 						if( aProp.Name.getLength() )
//STRIP001 						{
//STRIP001 							uno::Any aTmp;
//STRIP001 							// Ja!
//STRIP001 							aTmp <<= OUString(rHLinkItem.GetName());
//STRIP001 							xPropSet->setPropertyValue(C2U("Label"), aTmp );
//STRIP001 
//STRIP001 							aTmp <<=  OUString(so3::StaticBaseUrl::RelToAbs(rHLinkItem.GetURL()));
//STRIP001 							xPropSet->setPropertyValue( sTargetURL, aTmp );
//STRIP001 
//STRIP001 							if( rHLinkItem.GetTargetFrame().Len() )
//STRIP001 							{
//STRIP001 								aTmp <<=  OUString(rHLinkItem.GetTargetFrame());
//STRIP001 								xPropSet->setPropertyValue( C2U("TargetFrame"), aTmp );
//STRIP001 							}
//STRIP001 
//STRIP001 
//STRIP001 					 		form::FormButtonType eButtonType = form::FormButtonType_URL;
//STRIP001 							aTmp.setValue( &eButtonType, ::getCppuType((const form::FormButtonType*)0));
//STRIP001 							xPropSet->setPropertyValue( C2U("ButtonType"), aTmp );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ASSERT(!this, "falscher Dispatcher");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 }

//STRIP001 void SwDrawFormShell::GetState(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	SfxWhichIter aIter( rSet );
//STRIP001 	sal_uInt16 nWhich = aIter.FirstWhich();
//STRIP001 
//STRIP001 	while( nWhich )
//STRIP001 	{
//STRIP001 		switch( nWhich )
//STRIP001 		{
//STRIP001 			case SID_HYPERLINK_GETLINK:
//STRIP001 			{
//STRIP001 				SdrView* pSdrView = rSh.GetDrawViewWithValidMarkList();
//STRIP001 				const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001 				SvxHyperlinkItem aHLinkItem;
//STRIP001 				if (rMarkList.GetMark(0))
//STRIP001 				{
//STRIP001 					SdrUnoObj* pUnoCtrl = PTR_CAST(SdrUnoObj, rMarkList.GetMark(0)->GetObj());
//STRIP001 					if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
//STRIP001 					{
//STRIP001 						uno::Reference< awt::XControlModel >  xControlModel = pUnoCtrl->GetUnoControlModel();
//STRIP001 
//STRIP001 						ASSERT( xControlModel.is(), "UNO-Control ohne Model" );
//STRIP001 						if( !xControlModel.is() )
//STRIP001 							return;
//STRIP001 
//STRIP001 						uno::Reference< beans::XPropertySet >  xPropSet(xControlModel, uno::UNO_QUERY);
//STRIP001 
//STRIP001 						uno::Any aTmp;
//STRIP001 						uno::Reference< beans::XPropertySetInfo >  xInfo = xPropSet->getPropertySetInfo();
//STRIP001 						if(xInfo->hasPropertyByName(C2U("ButtonType" )))
//STRIP001 						{
//STRIP001 						 	form::FormButtonType eButtonType = form::FormButtonType_URL;
//STRIP001 							aTmp = xPropSet->getPropertyValue( C2U("ButtonType") );
//STRIP001                             if( aTmp >>= eButtonType )
//STRIP001 							{
//STRIP001 								// Label
//STRIP001 								if(xInfo->hasPropertyByName( C2U("Label") ))
//STRIP001 								{
//STRIP001 									aTmp = xPropSet->getPropertyValue( C2U("Label") );
//STRIP001                                     OUString sTmp;
//STRIP001                                     if( (aTmp >>= sTmp) && sTmp.getLength())
//STRIP001 									{
//STRIP001                                         aHLinkItem.SetName(sTmp);
//STRIP001 									}
//STRIP001 								}
//STRIP001 
//STRIP001 								// URL
//STRIP001 								if(xInfo->hasPropertyByName( C2U("TargetURL" )))
//STRIP001 								{
//STRIP001 									aTmp = xPropSet->getPropertyValue( C2U("TargetURL") );
//STRIP001                                     OUString sTmp;
//STRIP001                                     if( (aTmp >>= sTmp) && sTmp.getLength())
//STRIP001 									{
//STRIP001                                         aHLinkItem.SetURL(sTmp);
//STRIP001 									}
//STRIP001 								}
//STRIP001 
//STRIP001 								// Target
//STRIP001 								if(xInfo->hasPropertyByName( C2U("TargetFrame") ))
//STRIP001 								{
//STRIP001 									aTmp = xPropSet->getPropertyValue( C2U("TargetFrame") );
//STRIP001                                     OUString sTmp;
//STRIP001                                     if( (aTmp >>= sTmp) && sTmp.getLength())
//STRIP001 									{
//STRIP001                                         aHLinkItem.SetTargetFrame(sTmp);
//STRIP001 									}
//STRIP001 								}
//STRIP001 								aHLinkItem.SetInsertMode(HLINK_BUTTON);
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				sal_uInt16 nHtmlMode = ::binfilter::GetHtmlMode(GetView().GetDocShell());
//STRIP001 				aHLinkItem.SetInsertMode((SvxLinkInsertMode)(aHLinkItem.GetInsertMode() |
//STRIP001 					((nHtmlMode & HTMLMODE_ON) != 0 ? HLINK_HTMLMODE : 0)));
//STRIP001 
//STRIP001 				rSet.Put(aHLinkItem);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 SwDrawFormShell::SwDrawFormShell(SwView &rView) :
//STRIP001 	SwDrawBaseShell(rView)
//STRIP001 {
//STRIP001 	SetHelpId(SW_DRAWFORMSHELL);
//STRIP001 	GetShell().NoEdit(sal_True);
//STRIP001 	SetName(String::CreateFromAscii("DrawForm"));
//STRIP001 }
//STRIP001 
//STRIP001 SwDrawFormShell::~SwDrawFormShell()
//STRIP001 {
//STRIP001 }



}
