/*************************************************************************
 *
 *  $RCSfile: sw_drwbassh.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:18:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif
#include <helpid.h>
// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>
// auto strip #endif
#ifndef _SFXOBJFACE_HXX //autogen
#include <bf_sfx2/objface.hxx>
#endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _SFX_BINDINGS_HXX //autogen
#include <bf_sfx2/bindings.hxx>
#endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDVIEW_HXX //autogen
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SRCHITEM_HXX //autogen
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_TRANSFRM_HXX //autogen
// auto strip #include <bf_svx/transfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_LABDLG_HXX //autogen
// auto strip #include <bf_svx/labdlg.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ANCHORID_HXX //autogen
// auto strip #include <bf_svx/anchorid.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_HTMLMODE_HXX //autogen
// auto strip #include <bf_svx/htmlmode.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #ifndef _UITOOL_HXX
// auto strip #include <uitool.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _FMTORNT_HXX
// auto strip #include <fmtornt.hxx>
// auto strip #endif
#ifndef _CMDID_H
#include <cmdid.h>
#endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
#ifndef _WVIEW_HXX
#include <wview.hxx>
#endif
// auto strip #ifndef _EDTWIN_HXX
// auto strip #include <edtwin.hxx>
// auto strip #endif
// auto strip #ifndef _VIEWOPT_HXX
// auto strip #include <viewopt.hxx>
// auto strip #endif
// auto strip #ifndef _DCONTACT_HXX
// auto strip #include <dcontact.hxx>
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX
// auto strip #include <frmfmt.hxx>
// auto strip #endif
// auto strip #ifndef _WRAP_HXX
// auto strip #include <wrap.hxx>
// auto strip #endif
// auto strip #ifndef _DRAWBASE_HXX
// auto strip #include <drawbase.hxx>
// auto strip #endif
#ifndef _DRWBASSH_HXX
#include <drwbassh.hxx>
#endif
// auto strip #ifndef _SWDTFLVR_HXX
// auto strip #include <swdtflvr.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_DLG_NAME_HXX
// auto strip #include <bf_svx/dlgname.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif

// auto strip #include <doc.hxx>
#include <shells.hrc>
#define SwDrawBaseShell
#ifndef _ITEMDEF_HXX
#include <itemdef.hxx>
#endif

namespace binfilter {
#ifndef _SWSLOTS_HXX
#include <swslots.hxx>
#endif
/*N*/ SFX_IMPL_INTERFACE(SwDrawBaseShell, SwBaseShell, SW_RES(0))
/*N*/ {
/*N*/ }

//STRIP001 TYPEINIT1(SwDrawBaseShell,SwBaseShell)

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 SwDrawBaseShell::SwDrawBaseShell(SwView &rView):
//STRIP001 	SwBaseShell( rView )
//STRIP001 {
//STRIP001 	GetShell().NoEdit(TRUE);
//STRIP001 
//STRIP001 	SwEditWin& rWin = GetView().GetEditWin();
//STRIP001 
//STRIP001 	rWin.SetBezierMode(SID_BEZIER_MOVE);
//STRIP001 
//STRIP001 	if ( !rView.GetDrawFuncPtr() )
//STRIP001 		rView.GetEditWin().StdDrawMode(SID_OBJECT_SELECT);
//STRIP001 
//STRIP001 	SwTransferable::CreateSelection( GetShell() );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 SwDrawBaseShell::~SwDrawBaseShell()
//STRIP001 {
//STRIP001 	GetView().ExitDraw();
//STRIP001 	GetShell().Edit();
//STRIP001 	SwTransferable::ClearSelection( GetShell() );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 void SwDrawBaseShell::Execute(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	SwWrtShell *pSh = &GetShell();
//STRIP001 	SdrView*	pSdrView = pSh->GetDrawView();
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 	USHORT		nSlotId = rReq.GetSlot();
//STRIP001 	BOOL		bChanged = pSdrView->GetModel()->IsChanged();
//STRIP001 	pSdrView->GetModel()->SetChanged(FALSE);
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 	if(pArgs)
//STRIP001 		pArgs->GetItemState(nSlotId, FALSE, &pItem);
//STRIP001 
//STRIP001 	//Sonderfall Align per Menue
//STRIP001 	if(pItem && nSlotId == SID_OBJECT_ALIGN)
//STRIP001 	{
//STRIP001 		DBG_ASSERT(PTR_CAST(SfxEnumItem, pItem),"SfxEnumItem erwartet")
//STRIP001 		nSlotId += ((const SfxEnumItem*)pItem)->GetValue();
//STRIP001 		nSlotId++;
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bAlignPossible = pSh->IsAlignPossible();
//STRIP001 
//STRIP001 	BOOL bTopParam = TRUE, bBottomParam = TRUE;
//STRIP001 	BOOL bNotify = FALSE;
//STRIP001 	BOOL bDone = FALSE;
//STRIP001 	SfxBindings& rBind = GetView().GetViewFrame()->GetBindings();
//STRIP001 
//STRIP001 	switch (nSlotId)
//STRIP001 	{
//STRIP001 		case FN_DRAW_WRAP_DLG:
//STRIP001 		{
//STRIP001 			if(pSdrView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 				if(!pArgs)
//STRIP001 				{
//STRIP001 					const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001 					if( rMarkList.GetMark(0) != 0 )
//STRIP001 					{
//STRIP001 						SfxItemSet aSet(GetPool(),	RES_SURROUND, RES_SURROUND,
//STRIP001 													RES_ANCHOR, RES_ANCHOR,
//STRIP001 													RES_LR_SPACE, RES_UL_SPACE,
//STRIP001 													SID_HTML_MODE, SID_HTML_MODE,
//STRIP001 													FN_DRAW_WRAP_DLG, FN_DRAW_WRAP_DLG,
//STRIP001 													0);
//STRIP001 
//STRIP001 						const SwViewOption* pVOpt = pSh->GetViewOptions();
//STRIP001 						aSet.Put(SfxBoolItem(SID_HTML_MODE,
//STRIP001 							0 != ::binfilter::GetHtmlMode(pSh->GetView().GetDocShell())));
//STRIP001 
//STRIP001 						aSet.Put(SfxInt16Item(FN_DRAW_WRAP_DLG, pSh->GetLayerId()));
//STRIP001 
//STRIP001 						pSh->GetObjAttr(aSet);
//STRIP001 						SwWrapDlg aDlg(GetView().GetWindow(), aSet, pSh, TRUE);
//STRIP001 
//STRIP001 						if (aDlg.Execute() == RET_OK)
//STRIP001 						{
//STRIP001 							const SfxPoolItem* pItem;
//STRIP001 							const SfxItemSet* pOutSet = aDlg.GetOutputItemSet();
//STRIP001 							if(SFX_ITEM_SET == pOutSet->GetItemState(FN_DRAW_WRAP_DLG, FALSE, &pItem))
//STRIP001 							{
//STRIP001 								short nLayer = ((const SfxInt16Item*)pItem)->GetValue();
//STRIP001 								if (nLayer == 1)
//STRIP001 									pSh->SelectionToHeaven();
//STRIP001 								else
//STRIP001 									pSh->SelectionToHell();
//STRIP001 							}
//STRIP001 
//STRIP001 							pSh->SetObjAttr(*pOutSet);
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_ATTR_TRANSFORM:
//STRIP001 		{
//STRIP001 			if(pSdrView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 				if(!pArgs)
//STRIP001 				{
//STRIP001 					const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001 					if( rMarkList.GetMark(0) != 0 )
//STRIP001 					{
//STRIP001 						SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 						SfxTabDialog *pDlg;
//STRIP001 						BOOL bCaption = FALSE;
//STRIP001 
//STRIP001 						// Erlaubte Verankerungen:
//STRIP001 						USHORT nAnchor = pSh->GetAnchorId();
//STRIP001 						USHORT nAllowedAnchors = SVX_OBJ_AT_CNTNT|SVX_OBJ_IN_CNTNT;
//STRIP001 						USHORT nHtmlMode = ::binfilter::GetHtmlMode(pSh->GetView().GetDocShell());
//STRIP001 						if( !((HTMLMODE_ON & nHtmlMode) && (0 == (nHtmlMode & HTMLMODE_SOME_ABS_POS))) )
//STRIP001 							nAllowedAnchors |= SVX_OBJ_PAGE;
//STRIP001 						if ( pSh->IsFlyInFly() )
//STRIP001 							nAllowedAnchors |= SVX_OBJ_AT_FLY;
//STRIP001 
//STRIP001 						if (pObj->GetObjIdentifier() == OBJ_CAPTION )
//STRIP001 							bCaption = TRUE;
//STRIP001 
//STRIP001 						if (bCaption)
//STRIP001 							pDlg = new SvxCaptionTabDialog(NULL, pSdrView, nAllowedAnchors);
//STRIP001 						else
//STRIP001 							pDlg = new SvxTransformTabDialog(NULL, NULL, pSdrView, nAllowedAnchors);
//STRIP001 
//STRIP001 						SfxItemSet aNewAttr(pSdrView->GetGeoAttrFromMarked());
//STRIP001 
//STRIP001 						const USHORT* pRange = pDlg->GetInputRanges( *aNewAttr.GetPool() );
//STRIP001 						SfxItemSet aSet( *aNewAttr.GetPool(), pRange );
//STRIP001 						SwView& rView = GetView();
//STRIP001 						FieldUnit eMetric = ::GetDfltMetric(0 != PTR_CAST(SwWebView, &rView));
//STRIP001 						SW_MOD()->PutItem(SfxUInt16Item(SID_ATTR_METRIC, eMetric));
//STRIP001 
//STRIP001 						aSet.Put( aNewAttr, FALSE );
//STRIP001 
//STRIP001 						if (bCaption)
//STRIP001 							pSdrView->GetAttributes( aSet );
//STRIP001 
//STRIP001 						aSet.Put(SfxUInt16Item(SID_ATTR_TRANSFORM_ANCHOR, nAnchor));
//STRIP001 
//STRIP001 						SwFrmFmt* pFrmFmt = FindFrmFmt( pObj );
//STRIP001 						SwFmtVertOrient aVOrient((SwFmtVertOrient&)pFrmFmt->GetAttr(RES_VERT_ORIENT));
//STRIP001 						USHORT nOrient = aVOrient.GetVertOrient();
//STRIP001 						aSet.Put(SfxUInt16Item(SID_ATTR_TRANSFORM_VERT_ORIENT, nOrient));
//STRIP001 
//STRIP001 						pDlg->SetInputSet( &aSet );
//STRIP001 
//STRIP001 						if (pDlg->Execute() == RET_OK)
//STRIP001 						{
//STRIP001 							const SfxItemSet* pOutSet = pDlg->GetOutputItemSet();
//STRIP001 							pSh->StartAllAction();
//STRIP001 							pSdrView->SetGeoAttrToMarked(*pOutSet);
//STRIP001 
//STRIP001 							if (bCaption)
//STRIP001 								pSdrView->SetAttributes(*pOutSet);
//STRIP001 
//STRIP001 							BOOL bPosCorr =
//STRIP001 								SFX_ITEM_SET != pOutSet->GetItemState(
//STRIP001 									SID_ATTR_TRANSFORM_POS_X, FALSE ) &&
//STRIP001 								SFX_ITEM_SET != pOutSet->GetItemState(
//STRIP001 									SID_ATTR_TRANSFORM_POS_Y, FALSE );
//STRIP001 
//STRIP001 							const SfxPoolItem* pItem;
//STRIP001 							if(SFX_ITEM_SET == pOutSet->GetItemState(
//STRIP001 								SID_ATTR_TRANSFORM_ANCHOR, FALSE, &pItem))
//STRIP001 								pSh->ChgAnchor(((const SfxUInt16Item*)pItem)
//STRIP001 									->GetValue(), FALSE, bPosCorr );
//STRIP001 
//STRIP001 							if( SFX_ITEM_SET == pOutSet->GetItemState(
//STRIP001 								SID_ATTR_TRANSFORM_VERT_ORIENT, FALSE, &pItem))
//STRIP001 							{
//STRIP001 								aVOrient.SetVertOrient( (SwVertOrient)
//STRIP001 									((const SfxUInt16Item*)pItem)->GetValue());
//STRIP001 								pFrmFmt->SetAttr( aVOrient );
//STRIP001 							}
//STRIP001 
//STRIP001 							rBind.InvalidateAll(FALSE);
//STRIP001 							pSh->EndAllAction();
//STRIP001 						}
//STRIP001 						delete pDlg;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DELETE:
//STRIP001 		case FN_BACKSPACE:
//STRIP001 			if (pSh->IsObjSelected() && !pSdrView->IsTextEdit())
//STRIP001 			{
//STRIP001 				bDone = TRUE;
//STRIP001 
//STRIP001 				if( GetView().IsDrawRotate() )
//STRIP001 				{
//STRIP001 					pSh->SetDragMode( SDRDRAG_MOVE );
//STRIP001 					GetView().FlipDrawRotate();
//STRIP001 				}
//STRIP001 
//STRIP001 				pSh->SetModified();
//STRIP001 				pSh->DelSelectedObj();
//STRIP001 
//STRIP001                 if (rReq.IsAPI() ||
//STRIP001                     SID_OBJECT_SELECT == GetView().GetEditWin().GetDrawMode() )
//STRIP001 				{
//STRIP001                     // Wenn Basic-Aufruf, dann zurueck in die Textshell, da das
//STRIP001                     // Basic sonst keine Rueckkehrmoeglichkeit hat.
//STRIP001 					if (GetView().GetDrawFuncPtr())
//STRIP001 					{
//STRIP001 						GetView().GetDrawFuncPtr()->Deactivate();
//STRIP001 						GetView().SetDrawFuncPtr(NULL);
//STRIP001 					}
//STRIP001 					GetView().LeaveDrawCreate();	// In Selektionsmode wechseln
//STRIP001 				}
//STRIP001 
//STRIP001 				if (pSh->IsSelFrmMode())
//STRIP001 				{
//STRIP001 					pSh->LeaveSelFrmMode();
//STRIP001                     // #105852# FME
//STRIP001 //                   pSh->NoEdit();
//STRIP001 				}
//STRIP001 				bNotify = TRUE;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_GROUP:
//STRIP001 			if (pSh->IsObjSelected() > 1 && pSh->IsGroupAllowed())
//STRIP001 			{
//STRIP001 				pSh->GroupSelection();	// Objekt gruppieren
//STRIP001 				rBind.Invalidate(SID_UNGROUP);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_UNGROUP:
//STRIP001 			if (pSh->IsGroupSelected())
//STRIP001 			{
//STRIP001 				pSh->UnGroupSelection();	// Objektgruppierung aufheben
//STRIP001 				rBind.Invalidate(SID_GROUP);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ENTER_GROUP:
//STRIP001 			if (pSh->IsGroupSelected())
//STRIP001 			{
//STRIP001 				pSdrView->EnterMarkedGroup();
//STRIP001 				rBind.InvalidateAll(FALSE);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_LEAVE_GROUP:
//STRIP001 			if (pSdrView->IsGroupEntered())
//STRIP001 			{
//STRIP001 				pSdrView->LeaveOneGroup();
//STRIP001 				rBind.Invalidate(SID_ENTER_GROUP);
//STRIP001 				rBind.Invalidate(SID_UNGROUP);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_OBJECT_ALIGN_LEFT:
//STRIP001 		case SID_OBJECT_ALIGN_CENTER:
//STRIP001 		case SID_OBJECT_ALIGN_RIGHT:
//STRIP001 		case SID_OBJECT_ALIGN_UP:
//STRIP001 		case SID_OBJECT_ALIGN_MIDDLE:
//STRIP001 		case SID_OBJECT_ALIGN_DOWN:
//STRIP001 		{
//STRIP001 			if ( bAlignPossible )
//STRIP001 			{
//STRIP001 				const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001 				if( rMarkList.GetMarkCount() == 1 && bAlignPossible )
//STRIP001 				{	// Objekte nicht aneinander ausrichten
//STRIP001 
//STRIP001 					USHORT nAnchor = pSh->GetAnchorId();
//STRIP001 					if (nAnchor == FLY_IN_CNTNT)
//STRIP001 					{
//STRIP001 						int nVertOrient = -1;
//STRIP001 
//STRIP001 						switch (nSlotId)
//STRIP001 						{
//STRIP001 							case SID_OBJECT_ALIGN_UP:
//STRIP001 								nVertOrient = SVX_VERT_TOP;
//STRIP001 								break;
//STRIP001 							case SID_OBJECT_ALIGN_MIDDLE:
//STRIP001 								nVertOrient = SVX_VERT_CENTER;
//STRIP001 								break;
//STRIP001 							case SID_OBJECT_ALIGN_DOWN:
//STRIP001 								nVertOrient = SVX_VERT_BOTTOM;
//STRIP001 								break;
//STRIP001 							default:
//STRIP001 								break;
//STRIP001 						}
//STRIP001 						if (nVertOrient != -1)
//STRIP001 						{
//STRIP001 							pSh->StartAction();
//STRIP001 							SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 							SwFrmFmt* pFrmFmt = FindFrmFmt( pObj );
//STRIP001 							SwFmtVertOrient aVOrient((SwFmtVertOrient&)pFrmFmt->GetAttr(RES_VERT_ORIENT));
//STRIP001 							aVOrient.SetVertOrient((SwVertOrient)nVertOrient);
//STRIP001 							pFrmFmt->SetAttr(aVOrient);
//STRIP001 							pSh->EndAction();
//STRIP001 						}
//STRIP001 						break;
//STRIP001 					}
//STRIP001 					if (nAnchor == FLY_AT_CNTNT)
//STRIP001 						break;	// Absatzverankerte Rahmen nicht ausrichten
//STRIP001 				}
//STRIP001 
//STRIP001 				pSh->StartAction();
//STRIP001 				switch (nSlotId)
//STRIP001 				{
//STRIP001 					case SID_OBJECT_ALIGN_LEFT:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_LEFT, SDRVALIGN_NONE);
//STRIP001 						break;
//STRIP001 					case SID_OBJECT_ALIGN_CENTER:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_CENTER, SDRVALIGN_NONE);
//STRIP001 						break;
//STRIP001 					case SID_OBJECT_ALIGN_RIGHT:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_RIGHT, SDRVALIGN_NONE);
//STRIP001 						break;
//STRIP001 					case SID_OBJECT_ALIGN_UP:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_TOP);
//STRIP001 						break;
//STRIP001 					case SID_OBJECT_ALIGN_MIDDLE:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_CENTER);
//STRIP001 						break;
//STRIP001 					case SID_OBJECT_ALIGN_DOWN:
//STRIP001 						pSdrView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_BOTTOM);
//STRIP001 						break;
//STRIP001 				}
//STRIP001 				pSh->EndAction();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_FRAME_UP:
//STRIP001 			bTopParam = FALSE;
//STRIP001 			/* no break */
//STRIP001 		case SID_FRAME_TO_TOP:
//STRIP001 			pSh->SelectionToTop( bTopParam );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_DOWN:
//STRIP001 			bBottomParam = FALSE;
//STRIP001 			/* no break */
//STRIP001 		case SID_FRAME_TO_BOTTOM:
//STRIP001 			pSh->SelectionToBottom( bBottomParam );
//STRIP001 			break;
//STRIP001         case FN_NAME_GROUP:
//STRIP001 		{
//STRIP001             bDone = TRUE;
//STRIP001             const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001             DBG_ASSERT(rMarkList.GetMarkCount() == 1, "Exactly one object has to be selected" )
//STRIP001             SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 			ULONG nMarkCount = rMarkList.GetMarkCount();
//STRIP001             String sName;
//STRIP001             String sDesc(SW_RES( STR_NAME_GROUP_LABEL ) );
//STRIP001             DBG_ASSERT(pObj->ISA(SdrObjGroup),
//STRIP001                 "Object is not a group, graphic or OLE shape")
//STRIP001             sName = pObj->GetName();
//STRIP001             SvxNameDialog* pDlg = new SvxNameDialog( NULL, sName, sDesc );
//STRIP001             pDlg->SetText(SW_RESSTR(STR_NAME_GROUP_DIALOG));
//STRIP001             // #100286# -------------
//STRIP001             pDlg->SetEditHelpId( HID_FORMAT_NAME_OBJECT_NAME );
//STRIP001             pDlg->SetCheckNameHdl(LINK(this, SwDrawBaseShell, CheckGroupShapeNameHdl));
//STRIP001             if( pDlg->Execute() == RET_OK )
//STRIP001             {
//STRIP001                 pDlg->GetName( sName );
//STRIP001                 pObj->SetName(sName);
//STRIP001             }
//STRIP001             delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ASSERT(!this, "falscher Dispatcher");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 	if(!bDone)
//STRIP001 	{
//STRIP001 		if(nSlotId >= SID_OBJECT_ALIGN_LEFT && nSlotId <= SID_OBJECT_ALIGN_DOWN)
//STRIP001 			rBind.Invalidate(SID_ATTR_LONG_LRSPACE);
//STRIP001 		if (pSdrView->GetModel()->IsChanged())
//STRIP001 			pSh->SetModified();
//STRIP001 		else if (bChanged)
//STRIP001 			pSdrView->GetModel()->SetChanged(TRUE);
//STRIP001 		// 40220: Nach dem Loeschen von DrawObjekten ueber die API GPF durch Selbstzerstoerung
//STRIP001 		if(bNotify)
//STRIP001 			GetView().AttrChangedNotify(pSh); // ggf Shellwechsel...
//STRIP001 	}
//STRIP001 }
//STRIP001 /* -----------------------------27.02.2002 15:27------------------------------
//STRIP001     Checks whether a given name is allowed for a group shape
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK( SwDrawBaseShell, CheckGroupShapeNameHdl, SvxNameDialog*, pNameDialog )
//STRIP001 {
//STRIP001     SwWrtShell          &rSh = GetShell();
//STRIP001     SdrView *pSdrView = rSh.GetDrawView();
//STRIP001     const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001     DBG_ASSERT(rMarkList.GetMarkCount() == 1, "wrong draw selection")
//STRIP001     SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001     ULONG nMarkCount = rMarkList.GetMarkCount();
//STRIP001     const String sCurrentName = pObj->GetName();
//STRIP001     String sNewName;
//STRIP001     pNameDialog->GetName(sNewName);
//STRIP001     long nRet = 0;
//STRIP001     if(!sNewName.Len() || sCurrentName == sNewName)
//STRIP001         nRet = 1;
//STRIP001     else
//STRIP001     {
//STRIP001         nRet = 1;
//STRIP001         SdrModel* pModel = rSh.GetDoc()->GetDrawModel();
//STRIP001         SdrPage* pPage = pModel->GetPage(0);
//STRIP001         sal_uInt32 nCount = pPage->GetObjCount();
//STRIP001         for( sal_uInt32 i=0; i< nCount; i++ )
//STRIP001         {
//STRIP001             SdrObject* pTemp = pPage->GetObj(i);
//STRIP001             if(pObj != pTemp && pTemp->ISA(SdrObjGroup) && pTemp->GetName() == sNewName)
//STRIP001             {
//STRIP001                 nRet = 0;
//STRIP001                 break;
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001     return nRet;
//STRIP001 }
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 void SwDrawBaseShell::GetState(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	SdrView* pSdrView = rSh.GetDrawViewWithValidMarkList();
//STRIP001 	SfxWhichIter aIter( rSet );
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	BOOL bProtected = rSh.IsSelObjProtected(FLYPROTECT_CONTENT);
//STRIP001 
//STRIP001 	if (!bProtected)	// Im Parent nachsehen
//STRIP001 		bProtected |= rSh.IsSelObjProtected( (FlyProtectType)(FLYPROTECT_CONTENT|FLYPROTECT_PARENT) ) != 0;
//STRIP001 
//STRIP001 	while( nWhich )
//STRIP001 	{
//STRIP001 		switch( nWhich )
//STRIP001 		{
//STRIP001 			case FN_DRAW_WRAP_DLG:
//STRIP001 			case SID_ATTR_TRANSFORM:
//STRIP001 			case SID_FRAME_TO_TOP:
//STRIP001 			case SID_FRAME_TO_BOTTOM:
//STRIP001 			case FN_FRAME_UP:
//STRIP001 			case FN_FRAME_DOWN:
//STRIP001 			case SID_DELETE:
//STRIP001 			case FN_BACKSPACE:
//STRIP001 				if( bProtected || !rSh.IsObjSelected() )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 			case SID_GROUP:
//STRIP001 				if ( rSh.IsObjSelected() < 2 || bProtected || !rSh.IsGroupAllowed() )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 			case SID_UNGROUP:
//STRIP001 				if ( !rSh.IsGroupSelected() || bProtected )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 			case SID_ENTER_GROUP:
//STRIP001 				if ( !rSh.IsGroupSelected() )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 			case SID_LEAVE_GROUP:
//STRIP001 				if ( !pSdrView->IsGroupEntered() )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 			case SID_OBJECT_ALIGN_LEFT:
//STRIP001 			case SID_OBJECT_ALIGN_CENTER:
//STRIP001 			case SID_OBJECT_ALIGN_RIGHT:
//STRIP001 			case SID_OBJECT_ALIGN_UP:
//STRIP001 			case SID_OBJECT_ALIGN_MIDDLE:
//STRIP001 			case SID_OBJECT_ALIGN_DOWN:
//STRIP001 			case SID_OBJECT_ALIGN:
//STRIP001 				if ( !rSh.IsAlignPossible() || bProtected )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				else
//STRIP001 				{
//STRIP001                     SfxAllEnumItem aEnumItem(nWhich, USHRT_MAX);
//STRIP001                     const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001                     //if only one object is selected it can only be vertically 
//STRIP001                     // aligned because it is character bound
//STRIP001                     if( rMarkList.GetMarkCount() == 1 )
//STRIP001                     {        
//STRIP001                         aEnumItem.DisableValue(SID_OBJECT_ALIGN_LEFT);
//STRIP001                         aEnumItem.DisableValue(SID_OBJECT_ALIGN_CENTER);
//STRIP001                         aEnumItem.DisableValue(SID_OBJECT_ALIGN_RIGHT);
//STRIP001                     }
//STRIP001                     rSet.Put(aEnumItem);
//STRIP001 				}
//STRIP001 				break;
//STRIP001             case FN_NAME_GROUP :
//STRIP001             {
//STRIP001                 BOOL bDisable = TRUE;
//STRIP001                 const SdrMarkList& rMarkList = pSdrView->GetMarkList();
//STRIP001                 if( rMarkList.GetMarkCount() == 1 )
//STRIP001                 {
//STRIP001                     SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001                     if(pObj->ISA(SdrObjGroup))
//STRIP001                         bDisable = FALSE;
//STRIP001                 }
//STRIP001                 if(bDisable)
//STRIP001                     rSet.DisableItem( nWhich );
//STRIP001             }
//STRIP001             break;
//STRIP001         }
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 BOOL SwDrawBaseShell::Disable(SfxItemSet& rSet, USHORT nWhich)
//STRIP001 {
//STRIP001 	BOOL bDisable = GetShell().IsSelObjProtected(FLYPROTECT_CONTENT);
//STRIP001 
//STRIP001 	if (bDisable)
//STRIP001 	{
//STRIP001 		if (nWhich)
//STRIP001 			rSet.DisableItem( nWhich );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SfxWhichIter aIter( rSet );
//STRIP001 			nWhich = aIter.FirstWhich();
//STRIP001 			while (nWhich)
//STRIP001 			{
//STRIP001 				rSet.DisableItem( nWhich );
//STRIP001 				nWhich = aIter.NextWhich();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bDisable;
//STRIP001 }




}
