/*************************************************************************
 *
 *  $RCSfile: sw_frmsh.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:19:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif
#ifndef _UIPARAM_HXX
#include <uiparam.hxx>
#endif

// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif
// auto strip #ifndef _GOODIES_IMAPOBJ_HXX
// auto strip #include <svtools/imapobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SRCHITEM_HXX
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
// auto strip #ifndef _IMAP_HXX //autogen
// auto strip #include <svtools/imap.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SB_SBSTAR_HXX //autogen
// auto strip #include <basic/sbstar.hxx>
// auto strip #endif
// auto strip #ifndef _SFXRECTITEM_HXX //autogen
// auto strip #include <svtools/rectitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXPTITEM_HXX //autogen
// auto strip #include <svtools/ptitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_COLRITEM_HXX //autogen
// auto strip #include <bf_svx/colritem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BOLNITEM_HXX //autogen
// auto strip #include <bf_svx/bolnitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BOXITEM_HXX //autogen
// auto strip #include <bf_svx/boxitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PROTITEM_HXX //autogen
// auto strip #include <bf_svx/protitem.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _SFXOBJFACE_HXX //autogen
#include <bf_sfx2/objface.hxx>
#endif
// auto strip #ifndef _SVX_HLNKITEM_HXX //autogen
// auto strip #include <bf_svx/hlnkitem.hxx>
// auto strip #endif


// auto strip #ifndef _FMTURL_HXX //autogen
// auto strip #include <fmturl.hxx>
// auto strip #endif
// auto strip #ifndef _FMTCLDS_HXX //autogen
// auto strip #include <fmtclds.hxx>
// auto strip #endif
// auto strip #ifndef _FMTCNCT_HXX //autogen
// auto strip #include <fmtcnct.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
// auto strip #ifndef _WVIEW_HXX
// auto strip #include <wview.hxx>
// auto strip #endif
// auto strip #ifndef _FRMATR_HXX
// auto strip #include <frmatr.hxx>
// auto strip #endif
// auto strip #ifndef _UITOOL_HXX
// auto strip #include <uitool.hxx>
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX
// auto strip #include <frmfmt.hxx>
// auto strip #endif
#ifndef _FRMSH_HXX
#include <frmsh.hxx>
#endif
// auto strip #ifndef _FRMMGR_HXX
// auto strip #include <frmmgr.hxx>
// auto strip #endif
// auto strip #ifndef _FRMDLG_HXX
// auto strip #include <frmdlg.hxx>
// auto strip #endif
// auto strip #ifndef _SWEVENT_HXX
// auto strip #include <swevent.hxx>
// auto strip #endif
// auto strip #ifndef _USRPREF_HXX
// auto strip #include <usrpref.hxx>
// auto strip #endif
// auto strip #ifndef _EDTWIN_HXX
// auto strip #include <edtwin.hxx>
// auto strip #endif
// auto strip #ifndef _SWDTFLVR_HXX
// auto strip #include <swdtflvr.hxx>
// auto strip #endif

#ifndef _HELPID_H
#include <helpid.h>
#endif
#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif
#ifndef _POPUP_HRC
#include <popup.hrc>
#endif
#ifndef _SHELLS_HRC
#include <shells.hrc>
#endif
namespace binfilter {//STRIP009
// Prototypen ------------------------------------------------------------

/*M*/ void lcl_FrmGetMaxLineWidth(const SvxBorderLine* pBorderLine, SvxBorderLine& rBorderLine);
//STRIP001 const SwFrmFmt* lcl_GetFrmFmtByName(SwWrtShell& rSh, const String& rName)
//STRIP001 {
//STRIP001     sal_uInt16 nCount = rSh.GetFlyCount(FLYCNTTYPE_FRM);
//STRIP001     for( sal_uInt16 i = 0; i < nCount; i++)
//STRIP001     {
//STRIP001         const SwFrmFmt* pFmt = rSh.GetFlyNum(i, FLYCNTTYPE_FRM);
//STRIP001 		if(pFmt->GetName() == rName)
//STRIP001 			return pFmt;
//STRIP001     }
//STRIP001     return 0;
//STRIP001 }
} //namespace bifilter
#define SwFrameShell
#include "itemdef.hxx"
namespace binfilter {
#include "swslots.hxx"

/*N*/ SFX_IMPL_INTERFACE(SwFrameShell, SwBaseShell, SW_RES(STR_SHELLNAME_FRAME))
/*N*/ {
//STRIP001 /*N*/ 	SFX_POPUPMENU_REGISTRATION(SW_RES(MN_FRM_POPUPMENU));
//STRIP001 /*N*/ 	SFX_OBJECTBAR_REGISTRATION(SFX_OBJECTBAR_OBJECT, SW_RES(RID_FRAME_TOOLBOX));
/*N*/ 	SFX_OBJECTMENU_REGISTRATION(SID_OBJECTMENU0, SW_RES(MN_OBJECTMENU_FRAME));
/*N*/ }



//STRIP001 void SwFrameShell::Execute(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	//Erstmal die, die keinen FrmMgr benoetigen.
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	BOOL bMore = FALSE;
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case FN_FRAME_TO_ANCHOR:
//STRIP001 			if ( rSh.IsFrmSelected() )
//STRIP001 			{
//STRIP001 				rSh.GotoFlyAnchor();
//STRIP001 				rSh.EnterStdMode();
//STRIP001 				rSh.CallChgLnk();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case SID_FRAME_TO_TOP:
//STRIP001 			rSh.SelectionToTop();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_FRAME_TO_BOTTOM:
//STRIP001 			rSh.SelectionToBottom();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_UP:
//STRIP001 			rSh.SelectionToTop( FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_DOWN:
//STRIP001 			rSh.SelectionToBottom( FALSE );
//STRIP001 			break;
//STRIP001 		case FN_INSERT_FRAME:
//STRIP001 			if (!pArgs)
//STRIP001 			{
//STRIP001 				// Rahmen existiert bereits, Rahmendialog zur Bearbeitung oeffnen
//STRIP001 				SfxUInt16Item aDefPage(FN_FORMAT_FRAME_DLG, TP_COLUMN);
//STRIP001 				rSh.GetView().GetViewFrame()->GetDispatcher()->Execute( FN_FORMAT_FRAME_DLG,
//STRIP001 								SFX_CALLMODE_SYNCHRON|SFX_CALLMODE_RECORD,
//STRIP001 								&aDefPage, 0L );
//STRIP001 
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// Rahmen existiert bereits, nur Spaltenanzahl wird geaendert
//STRIP001 				USHORT nCols = 1;
//STRIP001 				if(pArgs->GetItemState(SID_ATTR_COLUMNS, FALSE, &pItem) == SFX_ITEM_SET)
//STRIP001 					nCols = ((SfxUInt16Item *)pItem)->GetValue();
//STRIP001 
//STRIP001 				SfxItemSet aSet(GetPool(),RES_COL,RES_COL);
//STRIP001 				rSh.GetFlyFrmAttr( aSet );
//STRIP001 				SwFmtCol aCol((const SwFmtCol&)aSet.Get(RES_COL));
//STRIP001 				// GutterWidth wird nicht immer uebergeben, daher erst besorgen (siehe view2: Execute auf diesen Slot)
//STRIP001 				USHORT nGutterWidth = aCol.GetGutterWidth();
//STRIP001 				if(!nCols )
//STRIP001 					nCols++;
//STRIP001 				aCol.Init(nCols, nGutterWidth, aCol.GetWishWidth());
//STRIP001 				aSet.Put(aCol);
//STRIP001 				// Vorlagen-AutoUpdate
//STRIP001 				SwFrmFmt* pFmt = rSh.GetCurFrmFmt();
//STRIP001 				if(pFmt && pFmt->IsAutoUpdateFmt())
//STRIP001 				{
//STRIP001 					rSh.AutoUpdateFrame(pFmt, aSet);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					rSh.StartAllAction();
//STRIP001 					rSh.SetFlyFrmAttr( aSet );
//STRIP001 					rSh.SetModified();
//STRIP001 					rSh.EndAllAction();
//STRIP001 				}
//STRIP001 
//STRIP001 			}
//STRIP001 			return;
//STRIP001 
//STRIP001 		case SID_HYPERLINK_SETLINK:
//STRIP001 		{
//STRIP001 			if(pArgs && SFX_ITEM_SET == pArgs->GetItemState(SID_HYPERLINK_SETLINK, FALSE, &pItem))
//STRIP001 			{
//STRIP001 				const SvxHyperlinkItem& rHLinkItem = *(const SvxHyperlinkItem *)pItem;
//STRIP001 				const String& rURL = rHLinkItem.GetURL();
//STRIP001 				const String& rTarget = rHLinkItem.GetTargetFrame();
//STRIP001 
//STRIP001 				SfxItemSet aSet( rSh.GetAttrPool(), RES_URL, RES_URL );
//STRIP001 				rSh.GetFlyFrmAttr( aSet );
//STRIP001 				SwFmtURL aURL( (SwFmtURL&)aSet.Get( RES_URL ) );
//STRIP001 
//STRIP001 				String sOldName(rHLinkItem.GetName());
//STRIP001 				String sFlyName(rSh.GetFlyName());
//STRIP001 				if (sOldName.ToUpperAscii() != sFlyName.ToUpperAscii())
//STRIP001 				{
//STRIP001 					String sName(sOldName);
//STRIP001 					USHORT i = 1;
//STRIP001 					while (rSh.FindFlyByName(sName))
//STRIP001 					{
//STRIP001 						sName = sOldName;
//STRIP001 						sName += '_';
//STRIP001 						sName += String::CreateFromInt32(i++);
//STRIP001 					}
//STRIP001 					rSh.SetFlyName(sName);
//STRIP001 				}
//STRIP001 				aURL.SetURL( rURL, FALSE );
//STRIP001 				aURL.SetTargetFrameName(rTarget);
//STRIP001 
//STRIP001 				aSet.Put( aURL );
//STRIP001 				rSh.SetFlyFrmAttr( aSet );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_FRAME_CHAIN:
//STRIP001 			rSh.GetView().GetEditWin().SetChainMode( !rSh.GetView().GetEditWin().IsChainMode() );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_UNCHAIN:
//STRIP001 			rSh.Unchain( (SwFrmFmt&)*rSh.GetFlyFrmFmt() );
//STRIP001 			GetView().GetViewFrame()->GetBindings().Invalidate(FN_FRAME_CHAIN);
//STRIP001 			break;
//STRIP001 
//STRIP001 		default: bMore = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !bMore )
//STRIP001 	{
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001 	SwFlyFrmAttrMgr aMgr( FALSE, &rSh, FRMMGR_TYPE_NONE );
//STRIP001 	BOOL bUpdateMgr = TRUE;
//STRIP001 	BOOL bCopyToFmt = FALSE;
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case FN_FRAME_ALIGN_VERT_CENTER:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_CENTER );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_BOTTOM:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_BOTTOM );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_TOP:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_TOP );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_CHAR_CENTER:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_CHAR_CENTER );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_CHAR_BOTTOM:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_CHAR_BOTTOM );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_CHAR_TOP:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_CHAR_TOP );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_ROW_CENTER:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_LINE_CENTER );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_ROW_BOTTOM:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_LINE_BOTTOM );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_VERT_ROW_TOP:
//STRIP001 			aMgr.SetVertOrientation( SVX_VERT_LINE_TOP );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_HORZ_CENTER:
//STRIP001 			aMgr.SetHorzOrientation( HORI_CENTER );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_HORZ_RIGHT:
//STRIP001 			aMgr.SetHorzOrientation( HORI_RIGHT );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_FRAME_ALIGN_HORZ_LEFT:
//STRIP001 			aMgr.SetHorzOrientation( HORI_LEFT );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_SET_FRM_POSITION:
//STRIP001 		{
//STRIP001 			aMgr.SetAbsPos(((SfxPointItem &)pArgs->Get
//STRIP001 								(FN_SET_FRM_POSITION)).GetValue());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_ATTR_BRUSH:
//STRIP001 		{
//STRIP001 			if(pArgs)
//STRIP001 			{
//STRIP001 				aMgr.SetAttrSet( *pArgs );
//STRIP001 				bCopyToFmt = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_ATTR_ULSPACE:
//STRIP001 		case SID_ATTR_LRSPACE:
//STRIP001 		{
//STRIP001 			if(pArgs && SFX_ITEM_SET == pArgs->GetItemState(GetPool().GetWhich(nSlot), FALSE, &pItem))
//STRIP001 			{
//STRIP001 				aMgr.SetAttrSet( *pArgs );
//STRIP001 				if(SID_ATTR_ULSPACE == nSlot && SID_ATTR_ULSPACE == nSlot)
//STRIP001 					bCopyToFmt = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_FORMAT_FRAME_DLG:
//STRIP001 		{
//STRIP001 			const int nSel = rSh.GetSelectionType();
//STRIP001 			if (nSel & SwWrtShell::SEL_GRF)
//STRIP001 			{
//STRIP001 				rSh.GetView().GetViewFrame()->GetDispatcher()->Execute(FN_FORMAT_GRAFIC_DLG);
//STRIP001 				bUpdateMgr = FALSE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SfxItemSet aSet(GetPool(), 	RES_FRMATR_BEGIN, 		RES_FRMATR_END-1,
//STRIP001 											SID_ATTR_BORDER_INNER, 	SID_ATTR_BORDER_INNER,
//STRIP001 											FN_GET_PRINT_AREA, 		FN_GET_PRINT_AREA,
//STRIP001 											SID_ATTR_PAGE_SIZE, 	SID_ATTR_PAGE_SIZE,
//STRIP001 											SID_ATTR_BRUSH, 		SID_ATTR_BRUSH,
//STRIP001 											SID_ATTR_LRSPACE,		SID_ATTR_ULSPACE,
//STRIP001 											FN_SURROUND, 			FN_HORI_ORIENT,
//STRIP001 											FN_SET_FRM_NAME, 		FN_SET_FRM_NAME,
//STRIP001 											FN_KEEP_ASPECT_RATIO, 	FN_KEEP_ASPECT_RATIO,
//STRIP001 											SID_DOCFRAME, 			SID_DOCFRAME,
//STRIP001 											SID_HTML_MODE, 			SID_HTML_MODE,
//STRIP001 											FN_SET_FRM_ALT_NAME, 	FN_SET_FRM_ALT_NAME,
//STRIP001                                             FN_PARAM_CHAIN_PREVIOUS, FN_PARAM_CHAIN_NEXT,
//STRIP001                                             0);
//STRIP001 
//STRIP001 				const SwViewOption* pVOpt = rSh.GetViewOptions();
//STRIP001 				if(nSel & SwWrtShell::SEL_OLE)
//STRIP001 				{
//STRIP001 					aSet.Put(SfxBoolItem(FN_KEEP_ASPECT_RATIO,
//STRIP001 						pVOpt->IsKeepRatio()));
//STRIP001 				}
//STRIP001 				aSet.Put(SfxUInt16Item(SID_HTML_MODE, ::binfilter::GetHtmlMode(GetView().GetDocShell())));
//STRIP001 				aSet.Put(SfxStringItem(FN_SET_FRM_NAME, rSh.GetFlyName()));
//STRIP001 				if(nSel & SwWrtShell::SEL_OLE)
//STRIP001 					aSet.Put(SfxStringItem(FN_SET_FRM_ALT_NAME, rSh.GetAlternateText()));
//STRIP001 
//STRIP001 				const SwRect &rPg = rSh.GetAnyCurRect(RECT_PAGE);
//STRIP001 				SwFmtFrmSize aFrmSize(ATT_VAR_SIZE, rPg.Width(), rPg.Height());
//STRIP001 				aFrmSize.SetWhich(GetPool().GetWhich(SID_ATTR_PAGE_SIZE));
//STRIP001 				aSet.Put(aFrmSize);
//STRIP001 
//STRIP001 				const SwRect &rPr = rSh.GetAnyCurRect(RECT_PAGE_PRT);
//STRIP001 				SwFmtFrmSize aPrtSize(ATT_VAR_SIZE, rPr.Width(), rPr.Height());
//STRIP001 				aPrtSize.SetWhich(GetPool().GetWhich(FN_GET_PRINT_AREA));
//STRIP001 				aSet.Put(aPrtSize);
//STRIP001 
//STRIP001 				aSet.Put(aMgr.GetAttrSet());
//STRIP001 				aSet.SetParent( aMgr.GetAttrSet().GetParent() );
//STRIP001 
//STRIP001 				// Bei %-Werten Groesse initialisieren
//STRIP001 				SwFmtFrmSize& rSize = (SwFmtFrmSize&)aSet.Get(RES_FRM_SIZE);
//STRIP001 				if (rSize.GetWidthPercent() && rSize.GetWidthPercent() != 0xff)
//STRIP001 					rSize.SetWidth(rSh.GetAnyCurRect(RECT_FLY_EMBEDDED).Width());
//STRIP001 				if (rSize.GetHeightPercent() && rSize.GetHeightPercent() != 0xff)
//STRIP001 					rSize.SetHeight(rSh.GetAnyCurRect(RECT_FLY_EMBEDDED).Height());
//STRIP001 
//STRIP001 				UINT16 nDefPage = 0;
//STRIP001 				if(pArgs && pArgs->GetItemState(FN_FORMAT_FRAME_DLG, FALSE, &pItem) == SFX_ITEM_SET)
//STRIP001 					nDefPage = ((SfxUInt16Item *)pItem)->GetValue();
//STRIP001 
//STRIP001 				aSet.Put(SfxFrameItem( SID_DOCFRAME, GetView().GetViewFrame()->GetTopFrame()));
//STRIP001                 FieldUnit eMetric = ::GetDfltMetric(0 != PTR_CAST(SwWebView, &GetView()));
//STRIP001 				SW_MOD()->PutItem(SfxUInt16Item(SID_ATTR_METRIC, eMetric));
//STRIP001                 SwFrmDlg *pDlg = new SwFrmDlg( GetView().GetViewFrame(),
//STRIP001 											   GetView().GetWindow(),
//STRIP001 								   aSet, FALSE,
//STRIP001 								   nSel & SwWrtShell::SEL_GRF ? DLG_FRM_GRF :
//STRIP001 								   nSel & SwWrtShell::SEL_OLE ? DLG_FRM_OLE :
//STRIP001 																DLG_FRM_STD,
//STRIP001 								   FALSE,
//STRIP001 								   nDefPage);
//STRIP001 
//STRIP001 				if ( pDlg->Execute() )
//STRIP001 				{
//STRIP001 					const SfxItemSet* pOutSet = pDlg->GetOutputItemSet();
//STRIP001 					if(pOutSet)
//STRIP001 					{
//STRIP001                         rReq.Done(*pOutSet);
//STRIP001                         if(nSel & SwWrtShell::SEL_OLE &&
//STRIP001 						SFX_ITEM_SET == pOutSet->GetItemState(FN_KEEP_ASPECT_RATIO, TRUE, &pItem))
//STRIP001 						{
//STRIP001 							SwViewOption aUsrPref( *pVOpt );
//STRIP001 							aUsrPref.SetKeepRatio(((const SfxBoolItem*)pItem)->GetValue());
//STRIP001 							SW_MOD()->ApplyUsrPref(aUsrPref, &GetView());
//STRIP001 						}
//STRIP001 						if (SFX_ITEM_SET == pOutSet->GetItemState(FN_SET_FRM_ALT_NAME, TRUE, &pItem))
//STRIP001 						{
//STRIP001 							rSh.SetAlternateText(((const SfxStringItem*)pItem)->GetValue());
//STRIP001 						}
//STRIP001 						// Vorlagen-AutoUpdate
//STRIP001 						SwFrmFmt* pFmt = rSh.GetCurFrmFmt();
//STRIP001 						if(pFmt && pFmt->IsAutoUpdateFmt())
//STRIP001 						{
//STRIP001 							rSh.AutoUpdateFrame(pFmt, *pOutSet);
//STRIP001 							const SfxPoolItem* pItem;
//STRIP001 							// alles, dass das Format nicht kann, muss hart
//STRIP001 							// gesetzt werden
//STRIP001 							if(SFX_ITEM_SET == pOutSet->GetItemState(FN_SET_FRM_NAME, FALSE, &pItem))
//STRIP001 								rSh.SetFlyName(((SfxStringItem*)pItem)->GetValue());
//STRIP001 							SfxItemSet aShellSet(GetPool(), RES_FRM_SIZE,	RES_FRM_SIZE,
//STRIP001 															RES_SURROUND, 	RES_SURROUND,
//STRIP001 															RES_ANCHOR,		RES_ANCHOR,
//STRIP001 															RES_VERT_ORIENT,RES_HORI_ORIENT,
//STRIP001 															0);
//STRIP001 							aShellSet.Put(*pOutSet);
//STRIP001 							aMgr.SetAttrSet(aShellSet);
//STRIP001 							if(SFX_ITEM_SET == pOutSet->GetItemState(FN_SET_FRM_NAME, FALSE, &pItem))
//STRIP001 								rSh.SetFlyName(((SfxStringItem*)pItem)->GetValue());
//STRIP001 						}
//STRIP001 						else
//STRIP001 							aMgr.SetAttrSet( *pOutSet );
//STRIP001 
//STRIP001                         const SwFrmFmt* pCurrFlyFmt = rSh.GetFlyFrmFmt();
//STRIP001                         if(SFX_ITEM_SET == 
//STRIP001                            pOutSet->GetItemState(FN_PARAM_CHAIN_PREVIOUS, 
//STRIP001                                                  FALSE, &pItem))
//STRIP001                         {
//STRIP001                             rSh.HideChainMarker();
//STRIP001 
//STRIP001                             String sPrevName = 
//STRIP001                                 ((const SfxStringItem*)pItem)->GetValue();
//STRIP001                             const SwFmtChain &rChain = pCurrFlyFmt->GetChain();
//STRIP001                             //needs cast - no non-const method available
//STRIP001                             SwFlyFrmFmt* pFlyFmt = 
//STRIP001                                 (SwFlyFrmFmt*)rChain.GetPrev();
//STRIP001                             if(pFlyFmt) 
//STRIP001                             {
//STRIP001                                 if (pFlyFmt->GetName() != sPrevName)
//STRIP001                                 {
//STRIP001                                     rSh.Unchain(*pFlyFmt);
//STRIP001                                 }
//STRIP001                                 else
//STRIP001                                     sPrevName.Erase();
//STRIP001                             }
//STRIP001 
//STRIP001                             if(sPrevName.Len())
//STRIP001                             {
//STRIP001                                 //needs cast - no non-const method available
//STRIP001                                 SwFrmFmt* pPrevFmt = (SwFrmFmt*)
//STRIP001                                     lcl_GetFrmFmtByName(rSh, sPrevName);
//STRIP001                                 DBG_ASSERT(pPrevFmt, "No frame found!")
//STRIP001                                 if(pPrevFmt)
//STRIP001                                 {
//STRIP001                                     rSh.Chain(*pPrevFmt, *pCurrFlyFmt);
//STRIP001                                 }
//STRIP001                             }
//STRIP001                             rSh.SetChainMarker();
//STRIP001                         }
//STRIP001                         if(SFX_ITEM_SET == 
//STRIP001                            pOutSet->GetItemState(FN_PARAM_CHAIN_NEXT, FALSE, 
//STRIP001                                                  &pItem))
//STRIP001                         {
//STRIP001                             rSh.HideChainMarker();
//STRIP001                             String sNextName = 
//STRIP001                                 ((const SfxStringItem*)pItem)->GetValue();
//STRIP001                             const SwFmtChain &rChain = pCurrFlyFmt->GetChain();
//STRIP001                             //needs cast - no non-const method available
//STRIP001                             SwFlyFrmFmt* pFlyFmt = 
//STRIP001                                 (SwFlyFrmFmt*)rChain.GetNext();
//STRIP001                             if(pFlyFmt) 
//STRIP001                             {
//STRIP001                                 if (pFlyFmt->GetName() != sNextName)
//STRIP001                                 {
//STRIP001                                     rSh.Unchain(*((SwFlyFrmFmt*) pCurrFlyFmt));
//STRIP001                                 }
//STRIP001                                 else
//STRIP001                                     sNextName.Erase();
//STRIP001                             }
//STRIP001 
//STRIP001                             if(sNextName.Len())
//STRIP001                             {
//STRIP001                                 //needs cast - no non-const method available
//STRIP001                                 SwFrmFmt* pNextFmt = (SwFrmFmt*)
//STRIP001                                     lcl_GetFrmFmtByName(rSh, sNextName);
//STRIP001                                 DBG_ASSERT(pNextFmt, "No frame found!")
//STRIP001                                 if(pNextFmt)
//STRIP001                                 {
//STRIP001                                     rSh.Chain(*(SwFrmFmt*)
//STRIP001                                               pCurrFlyFmt, *pNextFmt);
//STRIP001                                 }
//STRIP001                             }
//STRIP001                             rSh.SetChainMarker();
//STRIP001                         }
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 					bUpdateMgr = FALSE;
//STRIP001 				delete pDlg;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_FRAME_MIRROR_ON_EVEN_PAGES:
//STRIP001 		{
//STRIP001 			SwFmtHoriOrient aHori(aMgr.GetHoriOrient());
//STRIP001 			BOOL bMirror = !aHori.IsPosToggle();
//STRIP001 			aHori.SetPosToggle(bMirror);
//STRIP001 			SfxItemSet aSet(GetPool(), RES_HORI_ORIENT, RES_HORI_ORIENT);
//STRIP001 			aSet.Put(aHori);
//STRIP001 			aMgr.SetAttrSet(aSet);
//STRIP001 			bCopyToFmt = TRUE;
//STRIP001 			rReq.SetReturnValue(SfxBoolItem(nSlot, bMirror));
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		default:
//STRIP001 			ASSERT( !this, "falscher Dispatcher" );
//STRIP001 			return;
//STRIP001 	}
//STRIP001 	// Vorlagen-AutoUpdate
//STRIP001 	SwFrmFmt* pFmt = rSh.GetCurFrmFmt();
//STRIP001 	if ( bUpdateMgr )
//STRIP001 	{
//STRIP001 		if(bCopyToFmt && pFmt && pFmt->IsAutoUpdateFmt())
//STRIP001 		{
//STRIP001 			rSh.AutoUpdateFrame(pFmt, aMgr.GetAttrSet());
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aMgr.UpdateFlyFrm();
//STRIP001 	}
//STRIP001 
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 void SwFrameShell::GetState(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	BOOL bHtmlMode = 0 != ::binfilter::GetHtmlMode(rSh.GetView().GetDocShell());
//STRIP001 	if (rSh.IsFrmSelected())
//STRIP001 	{
//STRIP001 		SfxItemSet aSet( rSh.GetAttrPool(),
//STRIP001 							RES_LR_SPACE, RES_UL_SPACE,
//STRIP001 							RES_PROTECT, RES_HORI_ORIENT,
//STRIP001 							RES_OPAQUE, RES_OPAQUE,
//STRIP001 							RES_PRINT, RES_OPAQUE,
//STRIP001 							0 );
//STRIP001 		rSh.GetFlyFrmAttr( aSet );
//STRIP001 
//STRIP001 		BOOL bProtect = rSh.IsSelObjProtected(FLYPROTECT_POS);
//STRIP001 		BOOL bParentCntProt = rSh.IsSelObjProtected( (FlyProtectType)(FLYPROTECT_CONTENT|FLYPROTECT_PARENT) ) != 0;
//STRIP001 
//STRIP001 		bProtect |= bParentCntProt;
//STRIP001 
//STRIP001 		const USHORT eFrmType = rSh.GetFrmType(0,TRUE);
//STRIP001 		SwFlyFrmAttrMgr aMgr( FALSE, &rSh, FRMMGR_TYPE_NONE );
//STRIP001 
//STRIP001 		SfxWhichIter aIter( rSet );
//STRIP001 		USHORT nWhich = aIter.FirstWhich();
//STRIP001 		while ( nWhich )
//STRIP001 		{
//STRIP001 			switch ( nWhich )
//STRIP001 			{
//STRIP001 				case RES_FRM_SIZE:
//STRIP001 				{
//STRIP001 					SwFmtFrmSize aSz(aMgr.GetFrmSize());
//STRIP001 					rSet.Put(aSz);
//STRIP001 				}
//STRIP001 				break;
//STRIP001 				case RES_VERT_ORIENT:
//STRIP001 				case RES_HORI_ORIENT:
//STRIP001 				case SID_ATTR_ULSPACE:
//STRIP001 				case SID_ATTR_LRSPACE:
//STRIP001 				case RES_LR_SPACE:
//STRIP001 				case RES_UL_SPACE:
//STRIP001 				case RES_PROTECT:
//STRIP001 				case RES_OPAQUE:
//STRIP001 				case RES_PRINT:
//STRIP001 				case RES_SURROUND:
//STRIP001 				{
//STRIP001 					rSet.Put(aSet.Get(GetPool().GetWhich(nWhich), TRUE ));
//STRIP001 				}
//STRIP001 				break;
//STRIP001 				case FN_FRAME_ALIGN_HORZ_CENTER:
//STRIP001 				case FN_FRAME_ALIGN_HORZ_RIGHT:
//STRIP001 				case FN_FRAME_ALIGN_HORZ_LEFT:
//STRIP001 					if ( (eFrmType & FRMTYPE_FLY_INCNT) ||
//STRIP001 							bProtect ||
//STRIP001 							nWhich == FN_FRAME_ALIGN_HORZ_CENTER && bHtmlMode )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 				case FN_FRAME_ALIGN_VERT_ROW_TOP:
//STRIP001 				case FN_FRAME_ALIGN_VERT_ROW_CENTER:
//STRIP001 				case FN_FRAME_ALIGN_VERT_ROW_BOTTOM:
//STRIP001 				case FN_FRAME_ALIGN_VERT_CHAR_TOP:
//STRIP001 				case FN_FRAME_ALIGN_VERT_CHAR_CENTER:
//STRIP001 				case FN_FRAME_ALIGN_VERT_CHAR_BOTTOM:
//STRIP001 					if ( !(eFrmType & FRMTYPE_FLY_INCNT) || bProtect
//STRIP001 							|| bHtmlMode && FN_FRAME_ALIGN_VERT_CHAR_BOTTOM == nWhich )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 				break;
//STRIP001 				case FN_FRAME_ALIGN_VERT_TOP:
//STRIP001 				case FN_FRAME_ALIGN_VERT_CENTER:
//STRIP001 				case FN_FRAME_ALIGN_VERT_BOTTOM:
//STRIP001 					if ( bProtect || bHtmlMode && eFrmType & FRMTYPE_FLY_ATCNT)
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						USHORT nId = 0;
//STRIP001 						if (eFrmType & FRMTYPE_FLY_INCNT)
//STRIP001 						{
//STRIP001 							switch (nWhich)
//STRIP001 							{
//STRIP001 								case FN_FRAME_ALIGN_VERT_TOP:
//STRIP001 									nId = STR_TOP_BASE;	break;
//STRIP001 								case FN_FRAME_ALIGN_VERT_CENTER:
//STRIP001 									nId = STR_CENTER_BASE;	break;
//STRIP001 								case FN_FRAME_ALIGN_VERT_BOTTOM:
//STRIP001 									if(!bHtmlMode)
//STRIP001 										nId = STR_BOTTOM_BASE;
//STRIP001 									else
//STRIP001 										rSet.DisableItem( nWhich );
//STRIP001 								break;
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							if (nWhich == FN_FRAME_ALIGN_VERT_CENTER ||
//STRIP001 								nWhich == FN_FRAME_ALIGN_VERT_BOTTOM)
//STRIP001 							{
//STRIP001 								if (aMgr.GetAnchor() == FLY_AT_FLY)
//STRIP001 								{
//STRIP001 									const SwFrmFmt* pFmt = rSh.IsFlyInFly();
//STRIP001 									if (pFmt)
//STRIP001 									{
//STRIP001 										const SwFmtFrmSize& rFrmSz = pFmt->GetFrmSize();
//STRIP001 										if (rFrmSz.GetSizeType() != ATT_FIX_SIZE)
//STRIP001 										{
//STRIP001 											rSet.DisableItem( nWhich );
//STRIP001 											break;
//STRIP001 										}
//STRIP001 									}
//STRIP001 								}
//STRIP001 							}
//STRIP001 							switch (nWhich)
//STRIP001 							{
//STRIP001 								case FN_FRAME_ALIGN_VERT_TOP:
//STRIP001 									nId = STR_TOP; break;
//STRIP001 								case FN_FRAME_ALIGN_VERT_CENTER:
//STRIP001 									nId = STR_CENTER_VERT; break;
//STRIP001 								case FN_FRAME_ALIGN_VERT_BOTTOM:
//STRIP001 									nId = STR_BOTTOM; break;
//STRIP001 							}
//STRIP001 						}
//STRIP001 						if ( nId )
//STRIP001 							rSet.Put( SfxStringItem( nWhich, SW_RES(nId) ));
//STRIP001 					}
//STRIP001 				break;
//STRIP001 				case SID_HYPERLINK_GETLINK:
//STRIP001 				{
//STRIP001 					String sURL;
//STRIP001 					SvxHyperlinkItem aHLinkItem;
//STRIP001 					const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 					SfxItemSet aSet(GetPool(), RES_URL, RES_URL);
//STRIP001 					rSh.GetFlyFrmAttr( aSet );
//STRIP001 
//STRIP001 					if(SFX_ITEM_SET == aSet.GetItemState(RES_URL, TRUE, &pItem))
//STRIP001 					{
//STRIP001 						const SwFmtURL* pFmtURL = (const SwFmtURL*)pItem;
//STRIP001 						aHLinkItem.SetURL(pFmtURL->GetURL());
//STRIP001 						aHLinkItem.SetTargetFrame(pFmtURL->GetTargetFrameName());
//STRIP001 						aHLinkItem.SetName(rSh.GetFlyName());
//STRIP001 					}
//STRIP001 
//STRIP001 					aHLinkItem.SetInsertMode((SvxLinkInsertMode)(aHLinkItem.GetInsertMode() |
//STRIP001 						(bHtmlMode ? HLINK_HTMLMODE : 0)));
//STRIP001 
//STRIP001 					rSet.Put(aHLinkItem);
//STRIP001 				}
//STRIP001 				break;
//STRIP001 
//STRIP001 				case FN_FRAME_CHAIN:
//STRIP001 				{
//STRIP001 					const int nSel = rSh.GetSelectionType();
//STRIP001 					if (nSel & SwWrtShell::SEL_GRF || nSel & SwWrtShell::SEL_OLE)
//STRIP001 						rSet.DisableItem( FN_FRAME_CHAIN );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						const SwFrmFmt *pFmt = rSh.GetFlyFrmFmt();
//STRIP001 						if ( bParentCntProt || rSh.GetView().GetEditWin().GetApplyTemplate() ||
//STRIP001 						 	!pFmt || pFmt->GetChain().GetNext() )
//STRIP001 						{
//STRIP001 							rSet.DisableItem( FN_FRAME_CHAIN );
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							BOOL bChainMode = rSh.GetView().GetEditWin().IsChainMode();
//STRIP001 							rSet.Put( SfxBoolItem( FN_FRAME_CHAIN, bChainMode ) );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 				case FN_FRAME_UNCHAIN:
//STRIP001 				{
//STRIP001 					const int nSel = rSh.GetSelectionType();
//STRIP001 					if (nSel & SwWrtShell::SEL_GRF || nSel & SwWrtShell::SEL_OLE)
//STRIP001 						rSet.DisableItem( FN_FRAME_UNCHAIN );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						const SwFrmFmt *pFmt = rSh.GetFlyFrmFmt();
//STRIP001 						if ( bParentCntProt || rSh.GetView().GetEditWin().GetApplyTemplate() ||
//STRIP001 						 	!pFmt || !pFmt->GetChain().GetNext() )
//STRIP001 						{
//STRIP001 							rSet.DisableItem( FN_FRAME_UNCHAIN );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 				case SID_FRAME_TO_TOP:
//STRIP001 				case SID_FRAME_TO_BOTTOM:
//STRIP001 				case FN_FRAME_UP:
//STRIP001 				case FN_FRAME_DOWN:
//STRIP001 				case FN_FORMAT_FRAME_DLG:
//STRIP001 					if ( bParentCntProt )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					break;
//STRIP001 
//STRIP001 				default:
//STRIP001 					/* do nothing */;
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			nWhich = aIter.NextWhich();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:	Ctor fuer FrameShell
 --------------------------------------------------------------------*/


//STRIP001 SwFrameShell::SwFrameShell(SwView &rView) :
//STRIP001 	SwBaseShell( rView )
//STRIP001 {
//STRIP001 	SetName(String::CreateFromAscii("Frame"));
//STRIP001 	SetHelpId(SW_FRAMESHELL);
//STRIP001 
//STRIP001 	/* #96392# Use this to announce it is the frame shell who creates the
//STRIP001        selection. */
//STRIP001 	SwTransferable::CreateSelection( rView.GetWrtShell(), (ViewShell *) this );
//STRIP001 }
//STRIP001 
//STRIP001 SwFrameShell::~SwFrameShell()
//STRIP001 {
//STRIP001 	/* #96392# Only clear the selection if it was this frame shell who created
//STRIP001        it. */
//STRIP001 	SwTransferable::ClearSelection( GetShell(), (ViewShell *) this );
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwFrameShell::ExecFrameStyle(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	BOOL bDefault = FALSE;
//STRIP001 	if (!rSh.IsFrmSelected())
//STRIP001 		return;
//STRIP001 
//STRIP001 	// Erst Default-BoxItem aus Pool holen. Wenn ungleich normalem Boxitem,
//STRIP001 	// dann ist es bereits geaendert worden (neues ist kein Default).
//STRIP001 	const SvxBoxItem* pPoolBoxItem = (const SvxBoxItem*)::GetDfltAttr(RES_BOX);
//STRIP001 
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 	SfxItemSet aFrameSet(rSh.GetAttrPool(), RES_BOX, RES_BOX);
//STRIP001 
//STRIP001 	rSh.GetFlyFrmAttr( aFrameSet );
//STRIP001 	const SvxBoxItem& rBoxItem = (const SvxBoxItem&)aFrameSet.Get(RES_BOX);
//STRIP001 
//STRIP001 	if (pPoolBoxItem == &rBoxItem)
//STRIP001 		bDefault = TRUE;
//STRIP001 
//STRIP001 	SvxBoxItem aBoxItem(rBoxItem);
//STRIP001 
//STRIP001 	SvxBorderLine aBorderLine;
//STRIP001 	const SfxPoolItem *pItem = 0;
//STRIP001 
//STRIP001 	if(pArgs)    //irgendein Controller kann auch mal nichts liefern #48169#
//STRIP001 	{
//STRIP001 		switch (rReq.GetSlot())
//STRIP001 		{
//STRIP001 			case SID_ATTR_BORDER:
//STRIP001 			{
//STRIP001 				if (pArgs->GetItemState(RES_BOX, TRUE, &pItem) == SFX_ITEM_SET)
//STRIP001 				{
//STRIP001 					SvxBoxItem aNewBox(*((SvxBoxItem *)pItem));
//STRIP001 					const SvxBorderLine* pBorderLine;
//STRIP001 
//STRIP001 					if ((pBorderLine = aBoxItem.GetTop()) != NULL)
//STRIP001 						lcl_FrmGetMaxLineWidth(pBorderLine, aBorderLine);
//STRIP001 					if ((pBorderLine = aBoxItem.GetBottom()) != NULL)
//STRIP001 						lcl_FrmGetMaxLineWidth(pBorderLine, aBorderLine);
//STRIP001 					if ((pBorderLine = aBoxItem.GetLeft()) != NULL)
//STRIP001 						lcl_FrmGetMaxLineWidth(pBorderLine, aBorderLine);
//STRIP001 					if ((pBorderLine = aBoxItem.GetRight()) != NULL)
//STRIP001 						lcl_FrmGetMaxLineWidth(pBorderLine, aBorderLine);
//STRIP001 
//STRIP001 					if(aBorderLine.GetOutWidth() == 0)
//STRIP001 					{
//STRIP001 						aBorderLine.SetInWidth(0);
//STRIP001 						aBorderLine.SetOutWidth(DEF_LINE_WIDTH_0);
//STRIP001 						aBorderLine.SetDistance(0);
//STRIP001 					}
//STRIP001 					//Distance nur setzen, wenn der Request vom Controller kommt
//STRIP001 
//STRIP001 					if(!StarBASIC::IsRunning())
//STRIP001 					{
//STRIP001 						aNewBox.SetDistance( rBoxItem.GetDistance() );
//STRIP001 					}
//STRIP001 
//STRIP001 					aBoxItem = aNewBox;
//STRIP001 					SvxBorderLine aDestBorderLine;
//STRIP001 
//STRIP001 					if ((pBorderLine = aBoxItem.GetTop()) != NULL)
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_TOP);
//STRIP001 					if ((pBorderLine = aBoxItem.GetBottom()) != NULL)
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_BOTTOM);
//STRIP001 					if ((pBorderLine = aBoxItem.GetLeft()) != NULL)
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_LEFT);
//STRIP001 					if ((pBorderLine = aBoxItem.GetRight()) != NULL)
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_RIGHT);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_FRAME_LINESTYLE:
//STRIP001 			{
//STRIP001 				if (pArgs->GetItemState(SID_FRAME_LINESTYLE, FALSE, &pItem) == SFX_ITEM_SET)
//STRIP001 				{
//STRIP001 					const SvxLineItem* pLineItem =
//STRIP001 							(const SvxLineItem*)pItem;
//STRIP001 
//STRIP001 					if ( pLineItem->GetLine() )
//STRIP001 					{
//STRIP001 						aBorderLine = *(pLineItem->GetLine());
//STRIP001 
//STRIP001 						if (!aBoxItem.GetTop() && !aBoxItem.GetBottom() &&
//STRIP001 							!aBoxItem.GetLeft() && !aBoxItem.GetRight())
//STRIP001 						{
//STRIP001 							aBoxItem.SetLine(&aBorderLine, BOX_LINE_TOP);
//STRIP001 							aBoxItem.SetLine(&aBorderLine, BOX_LINE_BOTTOM);
//STRIP001 							aBoxItem.SetLine(&aBorderLine, BOX_LINE_LEFT);
//STRIP001 							aBoxItem.SetLine(&aBorderLine, BOX_LINE_RIGHT);
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							if( aBoxItem.GetTop() )
//STRIP001 							{
//STRIP001 								aBorderLine.SetColor( aBoxItem.GetTop()->GetColor() );
//STRIP001 								aBoxItem.SetLine(&aBorderLine, BOX_LINE_TOP);
//STRIP001 							}
//STRIP001 							if( aBoxItem.GetBottom() )
//STRIP001 							{
//STRIP001 								aBorderLine.SetColor( aBoxItem.GetBottom()->GetColor());
//STRIP001 								aBoxItem.SetLine(&aBorderLine, BOX_LINE_BOTTOM);
//STRIP001 							}
//STRIP001 							if( aBoxItem.GetLeft() )
//STRIP001 							{
//STRIP001 								aBorderLine.SetColor( aBoxItem.GetLeft()->GetColor());
//STRIP001 								aBoxItem.SetLine(&aBorderLine, BOX_LINE_LEFT);
//STRIP001 							}
//STRIP001 							if( aBoxItem.GetRight() )
//STRIP001 							{
//STRIP001 								aBorderLine.SetColor(aBoxItem.GetRight()->GetColor());
//STRIP001 								aBoxItem.SetLine(&aBorderLine, BOX_LINE_RIGHT);
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						aBoxItem.SetLine(0, BOX_LINE_TOP);
//STRIP001 						aBoxItem.SetLine(0, BOX_LINE_BOTTOM);
//STRIP001 						aBoxItem.SetLine(0, BOX_LINE_LEFT);
//STRIP001 						aBoxItem.SetLine(0, BOX_LINE_RIGHT);
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_FRAME_LINECOLOR:
//STRIP001 			{
//STRIP001 				if (pArgs->GetItemState(SID_FRAME_LINECOLOR, FALSE, &pItem) == SFX_ITEM_SET)
//STRIP001 				{
//STRIP001 					const Color& rNewColor = ((const SvxColorItem*)pItem)->GetValue();
//STRIP001 
//STRIP001 					if (!aBoxItem.GetTop() && !aBoxItem.GetBottom() &&
//STRIP001 						!aBoxItem.GetLeft() && !aBoxItem.GetRight())
//STRIP001 					{
//STRIP001 						aBorderLine.SetColor( rNewColor );
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_TOP);
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_BOTTOM);
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_LEFT);
//STRIP001 						aBoxItem.SetLine(&aBorderLine, BOX_LINE_RIGHT);
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						if ( aBoxItem.GetTop() )
//STRIP001 							((SvxBorderLine*)aBoxItem.GetTop())->SetColor( rNewColor );
//STRIP001 						if ( aBoxItem.GetBottom() )
//STRIP001 							((SvxBorderLine*)aBoxItem.GetBottom())->SetColor( rNewColor );
//STRIP001 						if ( aBoxItem.GetLeft() )
//STRIP001 							((SvxBorderLine*)aBoxItem.GetLeft())->SetColor( rNewColor );
//STRIP001 						if ( aBoxItem.GetRight() )
//STRIP001 							((SvxBorderLine*)aBoxItem.GetRight())->SetColor( rNewColor );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (bDefault && (aBoxItem.GetTop() || aBoxItem.GetBottom() ||
//STRIP001 		aBoxItem.GetLeft() || aBoxItem.GetRight()))
//STRIP001 	{
//STRIP001 		aBoxItem.SetDistance(MIN_BORDER_DIST);
//STRIP001 	}
//STRIP001 	aFrameSet.Put( aBoxItem );
//STRIP001 	// Vorlagen-AutoUpdate
//STRIP001 	SwFrmFmt* pFmt = rSh.GetCurFrmFmt();
//STRIP001 	if(pFmt && pFmt->IsAutoUpdateFmt())
//STRIP001 	{
//STRIP001 		rSh.AutoUpdateFrame(pFmt, aFrameSet);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rSh.SetFlyFrmAttr( aFrameSet );
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void lcl_FrmGetMaxLineWidth(const SvxBorderLine* pBorderLine, SvxBorderLine& rBorderLine)
//STRIP001 {
//STRIP001 	if(pBorderLine->GetInWidth() > rBorderLine.GetInWidth())
//STRIP001 		rBorderLine.SetInWidth(pBorderLine->GetInWidth());
//STRIP001 
//STRIP001 	if(pBorderLine->GetOutWidth() > rBorderLine.GetOutWidth())
//STRIP001 		rBorderLine.SetOutWidth(pBorderLine->GetOutWidth());
//STRIP001 
//STRIP001 	if(pBorderLine->GetDistance() > rBorderLine.GetDistance())
//STRIP001 		rBorderLine.SetDistance(pBorderLine->GetDistance());
//STRIP001 
//STRIP001 	rBorderLine.SetColor(pBorderLine->GetColor());
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwFrameShell::GetLineStyleState(SfxItemSet &rSet)
//STRIP001 {
//STRIP001 	SwWrtShell &rSh = GetShell();
//STRIP001 	BOOL bParentCntProt = rSh.IsSelObjProtected( (FlyProtectType)(FLYPROTECT_CONTENT|FLYPROTECT_PARENT) ) != 0;
//STRIP001 
//STRIP001 	if (bParentCntProt)
//STRIP001 	{
//STRIP001 		if (rSh.IsFrmSelected())
//STRIP001 			rSet.DisableItem( SID_FRAME_LINECOLOR );
//STRIP001 
//STRIP001 		rSet.DisableItem( SID_ATTR_BORDER );
//STRIP001 		rSet.DisableItem( SID_FRAME_LINESTYLE );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if (rSh.IsFrmSelected())
//STRIP001 		{
//STRIP001 			SfxItemSet aFrameSet( rSh.GetAttrPool(), RES_BOX, RES_BOX );
//STRIP001 
//STRIP001 			rSh.GetFlyFrmAttr(aFrameSet);
//STRIP001 
//STRIP001 			const SvxBorderLine* pLine = ((const SvxBoxItem&)aFrameSet.Get(RES_BOX)).GetTop();
//STRIP001 			rSet.Put(SvxColorItem(pLine ? pLine->GetColor() : Color(), SID_FRAME_LINECOLOR));
//STRIP001 		}
//STRIP001 		rSet.Put(SfxUInt16Item(SID_ATTR_BORDER, TRUE));	// Rahmencontroller: letzte Zeile einklappen
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void  SwFrameShell::GetBckColState(SfxItemSet &rSet)
//STRIP001 {
//STRIP001 	SwBaseShell::GetBckColState( rSet );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void  SwFrameShell::ExecBckCol(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	SwBaseShell::ExecBckCol( rReq );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void  SwFrameShell::StateInsert(SfxItemSet &rSet)
//STRIP001 {
//STRIP001 	const int nSel = GetShell().GetSelectionType();
//STRIP001 
//STRIP001 	if ((nSel & SwWrtShell::SEL_GRF) || (nSel & SwWrtShell::SEL_OLE))
//STRIP001 		rSet.DisableItem(FN_INSERT_FRAME);
//STRIP001 }



}
