/*************************************************************************
 *
 *  $RCSfile: sw_gloslst.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#define _SVSTDARR_STRINGSDTOR
#define _SVSTDARR_STRINGSISORTDTOR
#define _SVSTDARR_STRINGS
// auto strip #include <svtools/svstdarr.hxx>

// auto strip #ifndef _URLOBJ_HXX
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SV_DIALOG_HXX //autogen
// auto strip #include <vcl/dialog.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _SV_LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif
// auto strip #ifndef SVTOOLS_FSTATHELPER_HXX
// auto strip #include <svtools/fstathelper.hxx>
// auto strip #endif
// auto strip #ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_TRANSLITERATIONWRAPPER_HXX
// auto strip #include <unotools/transliterationwrapper.hxx>
// auto strip #endif

// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
#ifndef _SHELLIO_HXX
#include <shellio.hxx>
#endif
// auto strip #ifndef _INITUI_HXX
// auto strip #include <initui.hxx>
// auto strip #endif
// auto strip #ifndef _GLOSDOC_HXX
// auto strip #include <glosdoc.hxx>
// auto strip #endif
#ifndef _GLOSLST_HXX
#include <gloslst.hxx>
#endif
// auto strip #ifndef _SWUNOHELPER_HXX
// auto strip #include <swunohelper.hxx>
// auto strip #endif

#ifndef _UTLUI_HRC
#include <utlui.hrc>
#endif
#ifndef _GLOSLST_HRC
#include <gloslst.hrc>
#endif
namespace binfilter {


#define STRING_DELIM (char)0x0A
#define GLOS_TIMEOUT 30000   // alle 30 s updaten
#define FIND_MAX_GLOS 20


//STRIP001 struct TripleString
//STRIP001 {
//STRIP001 	String sGroup;
//STRIP001 	String sBlock;
//STRIP001 	String sShort;
//STRIP001 };

//STRIP001 typedef TripleString* TripleStringPtr;
//STRIP001 SV_DECL_PTRARR_DEL( TripleStrings, TripleStringPtr, 0, 4 )
//STRIP001 SV_IMPL_PTRARR( TripleStrings, TripleStringPtr )

//STRIP001 class SwGlossDecideDlg : public ModalDialog
//STRIP001 {
//STRIP001 	OKButton 		aOk;
//STRIP001 	CancelButton 	aCancel;
//STRIP001 	HelpButton		aHelp;
//STRIP001 	ListBox			aListLB;
//STRIP001     FixedLine       aFL;
//STRIP001 
//STRIP001 	DECL_LINK(DoubleClickHdl, ListBox*);
//STRIP001 	DECL_LINK(SelectHdl, ListBox*);
//STRIP001 
//STRIP001 	public:
//STRIP001 		SwGlossDecideDlg(Window* pParent);
//STRIP001 	ListBox& 	GetListBox() {return aListLB;}
//STRIP001 };

/*-----------------21.01.97 13.25-------------------

--------------------------------------------------*/

//STRIP001 SwGlossDecideDlg::SwGlossDecideDlg(Window* pParent) :
//STRIP001 	ModalDialog(pParent, SW_RES(DLG_GLOSSARY_DECIDE_DLG)),
//STRIP001 	aOk(this, 		ResId(PB_OK)),
//STRIP001 	aCancel(this, 	ResId(PB_CANCEL)),
//STRIP001 	aHelp(this, 	ResId(PB_HELP)),
//STRIP001 	aListLB(this, 	ResId(LB_LIST)),
//STRIP001     aFL(this,    ResId(FL_GLOSS))
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	aListLB.SetDoubleClickHdl(LINK(this, SwGlossDecideDlg, DoubleClickHdl));
//STRIP001 	aListLB.SetSelectHdl(LINK(this, SwGlossDecideDlg, SelectHdl));
//STRIP001 }

/*-----------------21.01.97 13.25-------------------

--------------------------------------------------*/

//STRIP001 IMPL_LINK(SwGlossDecideDlg, DoubleClickHdl, ListBox*, EMPTYARG)
//STRIP001 {
//STRIP001 	EndDialog(RET_OK);
//STRIP001 	return 0;
//STRIP001 }
/*-----------------21.01.97 13.29-------------------

--------------------------------------------------*/

//STRIP001 IMPL_LINK(SwGlossDecideDlg, SelectHdl, ListBox*, EMPTYARG)
//STRIP001 {
//STRIP001 	aOk.Enable(LISTBOX_ENTRY_NOTFOUND != aListLB.GetSelectEntryPos());
//STRIP001 	return 0;
//STRIP001 }

/********************************************************************

********************************************************************/


/*N*/ SwGlossaryList::SwGlossaryList() :
/*N*/ 	bFilled(FALSE)
/*N*/ {
DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	SvtPathOptions aPathOpt;
//STRIP001 	sPath = aPathOpt.GetAutoTextPath();
//STRIP001 	SetTimeout(GLOS_TIMEOUT);
/*N*/ }

/********************************************************************

********************************************************************/


/*N*/ SwGlossaryList::~SwGlossaryList()
/*N*/ {
DBG_BF_ASSERT(0, "STRIP"); //STRIP001  	ClearGroups();
/*N*/ }

/********************************************************************
 * Wenn der GroupName bereits bekannt ist, dann wird nur
 * rShortName gefuellt, sonst wird rGroupName ebenfals gesetzt und
 * bei Bedarf nach der richtigen Gruppe gefragt
********************************************************************/


//STRIP001 BOOL SwGlossaryList::GetShortName(const String& rLongName,
//STRIP001 								String& rShortName, String& rGroupName )
//STRIP001 {
//STRIP001 	if(!bFilled)
//STRIP001 		Update();
//STRIP001 
//STRIP001 	TripleStrings aTripleStrings;
//STRIP001 
//STRIP001 	USHORT nCount = aGroupArr.Count();
//STRIP001 	USHORT nFound = 0;
//STRIP001 	for(USHORT i = 0; i < nCount; i++ )
//STRIP001 	{
//STRIP001 		AutoTextGroup* pGroup = aGroupArr.GetObject(i);
//STRIP001 		if(!rGroupName.Len() || rGroupName == pGroup->sName)
//STRIP001 			for(USHORT j = 0; j < pGroup->nCount; j++)
//STRIP001 			{
//STRIP001 				String sLong = pGroup->sLongNames.GetToken(j, STRING_DELIM);
//STRIP001 				if((rLongName == sLong))
//STRIP001 				{
//STRIP001 					TripleString* pTriple = new TripleString;
//STRIP001 					pTriple->sGroup = pGroup->sName;
//STRIP001 					pTriple->sBlock = sLong;
//STRIP001 					pTriple->sShort = pGroup->sShortNames.GetToken(j, STRING_DELIM);
//STRIP001 					aTripleStrings.Insert(pTriple, nFound++);
//STRIP001 				}
//STRIP001 			}
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	nCount = aTripleStrings.Count();
//STRIP001 	if(1 == nCount )
//STRIP001 	{
//STRIP001 		TripleString* pTriple = aTripleStrings[0];
//STRIP001 		rShortName = pTriple->sShort;
//STRIP001 		rGroupName = pTriple->sGroup;
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001 	else if(1 < nCount)
//STRIP001 	{
//STRIP001 		SwGlossDecideDlg aDlg(0);
//STRIP001 		String sTitle = aDlg.GetText();
//STRIP001 		sTitle += aTripleStrings[0]->sBlock;
//STRIP001 		aDlg.SetText(sTitle);
//STRIP001 
//STRIP001 		ListBox& rLB = aDlg.GetListBox();
//STRIP001 		for(USHORT i = 0; i < nCount; i++ )
//STRIP001 			rLB.InsertEntry(aTripleStrings[i]->sGroup.GetToken(0, GLOS_DELIM));
//STRIP001 
//STRIP001 		rLB.SelectEntryPos(0);
//STRIP001 		if(RET_OK == aDlg.Execute() &&
//STRIP001 			LISTBOX_ENTRY_NOTFOUND != rLB.GetSelectEntryPos())
//STRIP001 		{
//STRIP001 			TripleString* pTriple = aTripleStrings[rLB.GetSelectEntryPos()];
//STRIP001 			rShortName = pTriple->sShort;
//STRIP001 			rGroupName = pTriple->sGroup;
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			bRet = FALSE;
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 USHORT 	SwGlossaryList::GetGroupCount()
//STRIP001 {
//STRIP001 	if(!bFilled)
//STRIP001 		Update();
//STRIP001 	return aGroupArr.Count();
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 String SwGlossaryList::GetGroupName(USHORT nPos, BOOL bNoPath, String* pTitle)
//STRIP001 {
//STRIP001 	DBG_ASSERT(aGroupArr.Count() > nPos, "Gruppe nicht vorhanden")
//STRIP001 	String sRet(aEmptyStr);
//STRIP001 	if(nPos < aGroupArr.Count())
//STRIP001 	{
//STRIP001 		AutoTextGroup* pGroup = aGroupArr.GetObject(nPos);
//STRIP001 		sRet = pGroup->sName;
//STRIP001 		if(bNoPath)
//STRIP001 			sRet = sRet.GetToken(0, GLOS_DELIM);
//STRIP001 		if(pTitle)
//STRIP001 			*pTitle = pGroup->sTitle;
//STRIP001 	}
//STRIP001 	return sRet;
//STRIP001 
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 USHORT 	SwGlossaryList::GetBlockCount(USHORT nGroup)
//STRIP001 {
//STRIP001 	DBG_ASSERT(aGroupArr.Count() > nGroup, "Gruppe nicht vorhanden")
//STRIP001 	if(nGroup < aGroupArr.Count())
//STRIP001 	{
//STRIP001 		AutoTextGroup* pGroup = aGroupArr.GetObject(nGroup);
//STRIP001 		return pGroup->nCount;
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 String	SwGlossaryList::GetBlockName(USHORT nGroup, USHORT nBlock, String& rShortName)
//STRIP001 {
//STRIP001 	DBG_ASSERT(aGroupArr.Count() > nGroup, "Gruppe nicht vorhanden")
//STRIP001 	if(nGroup < aGroupArr.Count())
//STRIP001 	{
//STRIP001 		AutoTextGroup* pGroup = aGroupArr.GetObject(nGroup);
//STRIP001 		rShortName = pGroup->sShortNames.GetToken(nBlock, STRING_DELIM);
//STRIP001 		return pGroup->sLongNames.GetToken(nBlock, STRING_DELIM);
//STRIP001 	}
//STRIP001 	return aEmptyStr;
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 void SwGlossaryList::Update()
//STRIP001 {
//STRIP001 	if(!IsActive())
//STRIP001 		Start();
//STRIP001 
//STRIP001 	SvtPathOptions aPathOpt;
//STRIP001 	String sTemp( aPathOpt.GetAutoTextPath() );
//STRIP001 	if(sTemp != sPath)
//STRIP001 	{
//STRIP001 		sPath = sTemp;
//STRIP001 		bFilled = FALSE;
//STRIP001 		ClearGroups();
//STRIP001 	}
//STRIP001 	SwGlossaries* pGlossaries = ::GetGlossaries();
//STRIP001 	const SvStrings* pPathArr = pGlossaries->GetPathArray();
//STRIP001 	String sExt( SwGlossaries::GetExtension() );
//STRIP001 	if(!bFilled)
//STRIP001 	{
//STRIP001 		USHORT nGroupCount = pGlossaries->GetGroupCnt();
//STRIP001 		for(USHORT i = 0; i < nGroupCount; i++)
//STRIP001 		{
//STRIP001 			String sGrpName = pGlossaries->GetGroupName(i);
//STRIP001 			USHORT nPath = (USHORT)sGrpName.GetToken(1, GLOS_DELIM).ToInt32();
//STRIP001 			if(nPath < pPathArr->Count())
//STRIP001 			{
//STRIP001 				AutoTextGroup* pGroup = new AutoTextGroup;
//STRIP001 				pGroup->sName = sGrpName;
//STRIP001 
//STRIP001 				FillGroup(pGroup, pGlossaries);
//STRIP001 				String sName = *(*pPathArr)[nPath];
//STRIP001 				sName += INET_PATH_TOKEN;
//STRIP001 				sName += pGroup->sName.GetToken(0, GLOS_DELIM);
//STRIP001 				sName += sExt;
//STRIP001 
//STRIP001 				FStatHelper::GetModifiedDateTimeOfFile( sName,
//STRIP001 												&pGroup->aDateModified,
//STRIP001 												&pGroup->aDateModified );
//STRIP001 
//STRIP001 				aGroupArr.Insert( pGroup, i );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		bFilled = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		for(USHORT nPath = 0; nPath < pPathArr->Count(); nPath++)
//STRIP001 		{
//STRIP001 			SvStringsDtor aFoundGroupNames;
//STRIP001 			SvStrings aFiles( 16, 16 );
//STRIP001 			SvPtrarr aDateTimeArr( 16, 16 );
//STRIP001 
//STRIP001 			SWUnoHelper::UCB_GetFileListOfFolder( *(*pPathArr)[nPath], aFiles,
//STRIP001 													&sExt, &aDateTimeArr );
//STRIP001 			for( USHORT nFiles = 0, nFEnd = aFiles.Count();
//STRIP001 					nFiles < nFEnd; ++nFiles )
//STRIP001 			{
//STRIP001 				String* pTitle = aFiles[ nFiles ];
//STRIP001 				::DateTime* pDT = (::DateTime*) aDateTimeArr[ nFiles ];
//STRIP001 
//STRIP001 				String sName( pTitle->Copy( 0, pTitle->Len() - sExt.Len() ));
//STRIP001 
//STRIP001 				aFoundGroupNames.Insert( new String(sName),
//STRIP001 											aFoundGroupNames.Count());
//STRIP001 				sName += GLOS_DELIM;
//STRIP001 				sName += String::CreateFromInt32( nPath );
//STRIP001 				AutoTextGroup* pFound = FindGroup( sName );
//STRIP001 				if( !pFound )
//STRIP001 				{
//STRIP001 					pFound = new AutoTextGroup;
//STRIP001 					pFound->sName = sName;
//STRIP001 					FillGroup( pFound, pGlossaries );
//STRIP001 					pFound->aDateModified = *pDT;
//STRIP001 
//STRIP001 					aGroupArr.Insert(pFound, aGroupArr.Count());
//STRIP001 				}
//STRIP001 				else if( pFound->aDateModified < *pDT )
//STRIP001 				{
//STRIP001 					FillGroup(pFound, pGlossaries);
//STRIP001 					pFound->aDateModified = *pDT;
//STRIP001 				}
//STRIP001 
//STRIP001 				// don't need any more these pointers
//STRIP001 				delete pTitle;
//STRIP001 				delete pDT;
//STRIP001 			}
//STRIP001 
//STRIP001 			USHORT nArrCount = aGroupArr.Count();
//STRIP001 			for( USHORT i = nArrCount; i; --i)
//STRIP001 			{
//STRIP001 				// evtl. geloeschte Gruppen entfernen
//STRIP001 				AutoTextGroup* pGroup = aGroupArr.GetObject(i - 1);
//STRIP001 				USHORT nGroupPath = (USHORT)pGroup->sName.GetToken( 1,
//STRIP001 														GLOS_DELIM).ToInt32();
//STRIP001 				// nur die Gruppen werden geprueft, die fuer den
//STRIP001 				// aktuellen Teilpfad registriert sind
//STRIP001 				if(nGroupPath == nPath)
//STRIP001 				{
//STRIP001 					BOOL bFound = FALSE;
//STRIP001 					String sCompareGroup = pGroup->sName.GetToken(0, GLOS_DELIM);
//STRIP001 					for( USHORT j = 0; j < aFoundGroupNames.Count() && !bFound; ++j)
//STRIP001 					{
//STRIP001 						bFound = sCompareGroup == *aFoundGroupNames[j];
//STRIP001 					}
//STRIP001 					if(!bFound)
//STRIP001 					{
//STRIP001 						aGroupArr.Remove(i - 1);
//STRIP001 						delete pGroup;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 void SwGlossaryList::Timeout()
//STRIP001 {
//STRIP001 	// nur, wenn eine SwView den Fokus hat, wird automatisch upgedated
//STRIP001 	if(::GetActiveView())
//STRIP001 		Update();
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 AutoTextGroup*	SwGlossaryList::FindGroup(const String& rGroupName)
//STRIP001 {
//STRIP001 	for(USHORT i = 0; i < aGroupArr.Count(); i++)
//STRIP001 	{
//STRIP001 		AutoTextGroup* pRet = aGroupArr.GetObject(i);
//STRIP001 		if(pRet->sName == rGroupName)
//STRIP001 			return pRet;
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/********************************************************************

********************************************************************/


//STRIP001 void SwGlossaryList::FillGroup(AutoTextGroup* pGroup, SwGlossaries* pGlossaries)
//STRIP001 {
//STRIP001 	SwTextBlocks*	pBlock = pGlossaries->GetGroupDoc(pGroup->sName);
//STRIP001 	pGroup->nCount = pBlock ? pBlock->GetCount() : 0;
//STRIP001 	pGroup->sLongNames = pGroup->sShortNames = aEmptyStr;
//STRIP001 	if(pBlock)
//STRIP001 		pGroup->sTitle = pBlock->GetName();
//STRIP001 
//STRIP001 	for(USHORT j = 0; j < pGroup->nCount; j++)
//STRIP001 	{
//STRIP001 		pGroup->sLongNames  += pBlock->GetLongName(j);
//STRIP001 		pGroup->sLongNames  += STRING_DELIM;
//STRIP001 		pGroup->sShortNames += pBlock->GetShortName(j);
//STRIP001 		pGroup->sShortNames += STRING_DELIM;
//STRIP001 	}
//STRIP001 	pGlossaries->PutGroupDoc(pBlock);
//STRIP001 }

/********************************************************************
	Alle (nicht mehr als FIND_MAX_GLOS) gefunden Bausteine mit
	passendem Anfang zurueckgeben
********************************************************************/

//STRIP001 BOOL SwGlossaryList::HasLongName(const String& rBegin, SvStringsISortDtor* pLongNames )
//STRIP001 {
//STRIP001 	if(!bFilled)
//STRIP001 		Update();
//STRIP001 	USHORT nFound = 0;
//STRIP001 	USHORT nCount = aGroupArr.Count();
//STRIP001 	USHORT nBeginLen = rBegin.Len();
//STRIP001 	const ::utl::TransliterationWrapper& rSCmp = GetAppCmpStrIgnore();
//STRIP001 
//STRIP001 	for(USHORT i = 0; i < nCount; i++ )
//STRIP001 	{
//STRIP001 		AutoTextGroup* pGroup = aGroupArr.GetObject(i);
//STRIP001 		for(USHORT j = 0; j < pGroup->nCount; j++)
//STRIP001 		{
//STRIP001 			String sBlock = pGroup->sLongNames.GetToken(j, STRING_DELIM);
//STRIP001 			if( rSCmp.isEqual( sBlock.Copy(0, nBeginLen), rBegin ) &&
//STRIP001 				nBeginLen + 1 < sBlock.Len())
//STRIP001 			{
//STRIP001 				String* pBlock = new String(sBlock);
//STRIP001 				pLongNames->Insert(pBlock);
//STRIP001 				nFound++;
//STRIP001 				if(FIND_MAX_GLOS == nFound)
//STRIP001 					break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return nFound > 0;
//STRIP001 }

/********************************************************************

********************************************************************/
/*N*/ void	SwGlossaryList::ClearGroups()
/*N*/ {
/*N*/ 	USHORT nCount = aGroupArr.Count();
/*N*/ 	for( USHORT i = 0; i < nCount; ++i )
/*N*/ 		delete aGroupArr.GetObject( i );
/*N*/ 
/*N*/ 	aGroupArr.Remove( 0, nCount );
/*N*/ 	bFilled = FALSE;
/*N*/ }


}
