/*************************************************************************
 *
 *  $RCSfile: progind.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:01:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_PROGIND_HXX
#define _SFX_PROGIND_HXX

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORFACTORY_HPP_
#include <com/sun/star/task/XStatusIndicatorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORSUPPLIER_HPP_
#include <com/sun/star/task/XStatusIndicatorSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif
#include <vcl/window.hxx>
#include <vcl/fixed.hxx>
#include <svtools/prgsbar.hxx>
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif

// auto strip #include "bf_sfx2/sfxuno.hxx"
namespace binfilter {

//STRIP001 class SfxStatusInd_Impl : public cppu::WeakImplHelper1< ::com::sun::star::task::XStatusIndicator >
//STRIP001 {
//STRIP001 	long						nValue;
//STRIP001 	long 						nRange;
//STRIP001 	sal_uInt16					nProgressCount;
//STRIP001 
//STRIP001 friend class SfxPopupStatusIndicator;
//STRIP001 	SfxPopupStatusIndicator*	pWindow;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SfxStatusInd_Impl();
//STRIP001 
//STRIP001 	// XStatusIndicator
//STRIP001 	virtual void SAL_CALL start(const ::rtl::OUString& aText, sal_Int32 nRange) throw ( ::com::sun::star::uno::RuntimeException );
//STRIP001 	virtual void SAL_CALL end(void) throw ( ::com::sun::star::uno::RuntimeException );
//STRIP001 	virtual void SAL_CALL setText(const ::rtl::OUString& aText) throw ( ::com::sun::star::uno::RuntimeException );
//STRIP001 	virtual void SAL_CALL setValue(sal_Int32 nValue) throw ( ::com::sun::star::uno::RuntimeException );
//STRIP001 	virtual void SAL_CALL reset() throw ( ::com::sun::star::uno::RuntimeException );
//STRIP001 };

//STRIP001 class SfxPopupStatusIndicator : public Window
//STRIP001 {
//STRIP001 friend class SfxStatusInd_Impl;
//STRIP001 	FixedText					aTextBar;
//STRIP001 	ProgressBar					aProgressBar;
//STRIP001 	SfxStatusInd_Impl*			pInterface;
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxPopupStatusIndicator( Window* pParent );
//STRIP001 								~SfxPopupStatusIndicator();
//STRIP001 
//STRIP001 	virtual void				MakeVisible( sal_Bool bVisible );
//STRIP001 	virtual void				Resize();
//STRIP001 	virtual void				Paint( const Rectangle& rRect );
//STRIP001 	Size						CalcWindowSizePixel();
//STRIP001 	::com::sun::star::task::XStatusIndicator*			GetInterface()
//STRIP001 								{ return pInterface; }
//STRIP001 };


}//end of namespace binfilter
#endif

