/*************************************************************************
 *
 *  $RCSfile: imapdlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IMAPDLG_HXX_
#define _IMAPDLG_HXX_

#ifndef _SVTOOLS_INETTBC_HXX
#include <svtools/inettbc.hxx>
#endif

#ifndef _SFX_CHILDWIN_HXX //autogen
#include <bf_sfx2/childwin.hxx>
#endif

#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif

#ifndef _STATUS_HXX //autogen
#include <vcl/status.hxx>
#endif
#ifndef _GOMISC_HXX
class ImageMap;
#endif
namespace binfilter {



/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Float
|*
\************************************************************************/

//STRIP001 class Graphic;
//STRIP001 class TargetList;

class SvxIMapDlgChildWindow : public SfxChildWindow
{
 public:

	SvxIMapDlgChildWindow( Window*, USHORT, SfxBindings*, SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW( SvxIMapDlgChildWindow );

//STRIP001 	static void UpdateIMapDlg( const Graphic& rGraphic, const ImageMap* pImageMap = NULL,
//STRIP001 							   const TargetList* pTargetList = NULL, void* pEditingObj = NULL );
};

#ifndef _REDUCED_IMAPDLG_HXX_
#define _REDUCED_IMAPDLG_HXX_

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 class SvxIMapDlg;

//STRIP001 class SvxIMapDlgItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SvxIMapDlg&	rIMap;
//STRIP001 
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 							   const SfxPoolItem* pState );
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SvxIMapDlgItem( USHORT nId, SvxIMapDlg& rIMapDlg, SfxBindings& rBindings );
//STRIP001 };

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 class IMapOwnData;

//STRIP001 class SvxIMapDlg : public SfxModelessDialog // SfxFloatingWindow
//STRIP001 {
//STRIP001 	friend class IMapOwnData;
//STRIP001 	friend class IMapWindow;
//STRIP001 
//STRIP001 	ToolBox				aTbxIMapDlg1;
//STRIP001 	FixedText			aFtURL;
//STRIP001 	SvtURLBox			maURLBox;
//STRIP001 	FixedText			aFtText;
//STRIP001 	Edit				aEdtText;
//STRIP001 	FixedText			maFtTarget;
//STRIP001 	ComboBox			maCbbTarget;
//STRIP001 	StatusBar			aStbStatus;
//STRIP001 	ImageList			maImageList;
//STRIP001 	ImageList			maImageListH;
//STRIP001 
//STRIP001 	Size				aLastSize;
//STRIP001 	IMapWindow*			pIMapWnd;
//STRIP001 	IMapOwnData*		pOwnData;
//STRIP001 	void*				pCheckObj;
//STRIP001 	SvxIMapDlgItem		aIMapItem;
//STRIP001 
//STRIP001 	virtual	void		Resize();
//STRIP001 	virtual BOOL 		Close();
//STRIP001 
//STRIP001 #ifdef _IMAPDLG_PRIVATE
//STRIP001 
//STRIP001 						DECL_LINK( TbxClickHdl, ToolBox* );
//STRIP001 						DECL_LINK( InfoHdl, IMapWindow* );
//STRIP001 						DECL_LINK( MousePosHdl, IMapWindow* );
//STRIP001 						DECL_LINK( GraphSizeHdl, IMapWindow* );
//STRIP001 						DECL_LINK( URLModifyHdl, void* );
//STRIP001 						DECL_LINK( URLLoseFocusHdl, void* );
//STRIP001 						DECL_LINK( UpdateHdl, Timer* );
//STRIP001 						DECL_LINK( TbxUpdateHdl, Timer* );
//STRIP001 						DECL_LINK( StateHdl, IMapWindow* );
//STRIP001 						DECL_LINK( MiscHdl, void* );
//STRIP001 
//STRIP001 	void				DoOpen();
//STRIP001 	BOOL				DoSave();
//STRIP001 
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						SvxIMapDlg( SfxBindings *pBindings, SfxChildWindow *pCW,
//STRIP001 									Window* pParent, const ResId& rResId );
//STRIP001 						~SvxIMapDlg();
//STRIP001 
//STRIP001 	void				SetExecState( BOOL bEnable );
//STRIP001 
//STRIP001 	void				SetGraphic( const Graphic& rGraphic );
//STRIP001 
//STRIP001 	void				SetEditingObject( void* pObj ) { pCheckObj = pObj; }
//STRIP001 	const void*			GetEditingObject() const { return pCheckObj; }
//STRIP001 
//STRIP001 	void				SetImageMap( const ImageMap& rImageMap );
//STRIP001 	const ImageMap&		GetImageMap() const;
//STRIP001 
//STRIP001 	void				SetTargetList( const TargetList& rTargetList );
//STRIP001 	const TargetList&	GetTargetList() const;
//STRIP001 
//STRIP001 	void				Update( const Graphic& rGraphic, const ImageMap* pImageMap = NULL,
//STRIP001 								const TargetList* pTargetList = NULL, void* pEditingObj = NULL );
//STRIP001 
//STRIP001 	virtual void		KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 	void ApplyImageList();
//STRIP001 };

/*************************************************************************
|*
|* Defines
|*
\************************************************************************/

//STRIP001 #define SVXIMAPDLG() ( (SvxIMapDlg*) ( SfxViewFrame::Current()->GetChildWindow( 		\
//STRIP001 						SvxIMapDlgChildWindow::GetChildWindowId() )-> 	\
//STRIP001 						GetWindow() ) )

#endif // _REDUCED_IMAPDLG_HXX_
}//end of namespace binfilter
#endif // _IMAPDLG_HXX_

