/*************************************************************************
 *
 *  $RCSfile: msocximex.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:19:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _MSOCXIMEX_HXX
#define _MSOCXIMEX_HXX

// auto strip #ifndef _SVSTOR_HXX
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef _TOOLS_DEBUG_HXX
// auto strip #include <tools/debug.hxx>
// auto strip #endif
#ifndef C2U
#define C2U(cChar)	::rtl::OUString::createFromAscii(cChar)
#endif


namespace com{namespace sun{namespace star{
        namespace drawing{
                class XDrawPage;
                class XShape;
                class XShapes;
        }
        namespace form{
                class XFormComponent;
        }
        namespace lang{
                class XMultiServiceFactory;
        }
        namespace container{
                class XIndexContainer;
        }
        namespace beans{
                class XPropertySet;
        }
        namespace text{
                class XText;
        }
        namespace awt{
                struct Size;
				class XControlModel;
        }

}}}
namespace binfilter {
//STRIP001 class OCX_Control;
//STRIP001 class SfxObjectShell;
//STRIP001 class SwPaM;
//STRIP001 
//STRIP001 class SvxMSConvertOCXControls
//STRIP001 {
//STRIP001 public:
//STRIP001     SvxMSConvertOCXControls( SfxObjectShell *pDSh,SwPaM *pP );
//STRIP001 
//STRIP001 	//Reads a control from the given storage, constructed shape in pShapeRef
//STRIP001 	sal_Bool ReadOCXStream( SvStorageRef& rSrc1,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::drawing::XShape > *pShapeRef=0,
//STRIP001 		BOOL bFloatingCtrl=FALSE );
//STRIP001 
//STRIP001 
//STRIP001 	//Excel has a nasty kludged mechanism for this, read
//STRIP001 	//the comments in the source to follow it
//STRIP001 	sal_Bool ReadOCXExcelKludgeStream(SvStorageStreamRef& rSrc1,
//STRIP001 		::com::sun::star::uno::Reference <
//STRIP001 		::com::sun::star::drawing::XShape > *pShapeRef,BOOL bFloatingCtrl);
//STRIP001 
//STRIP001 
//STRIP001 	//Writes the given Uno Control into the given storage
//STRIP001 
//STRIP001 	static sal_Bool WriteOCXStream(SvStorageRef &rSrc1,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::awt::XControlModel > &rControlModel,
//STRIP001 		const ::com::sun::star::awt::Size& rSize,String &rName);
//STRIP001 
//STRIP001 	//Excel has a nasty kludged mechanism for this, read
//STRIP001 	//the comments in the source to follow it
//STRIP001 	static sal_Bool WriteOCXExcelKludgeStream(SvStorageStreamRef& rContents,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::awt::XControlModel > &rControlModel,
//STRIP001 		const ::com::sun::star::awt::Size &rSize, String &rName);
//STRIP001 
//STRIP001 	//Generate an OCX converter based on the OLE2 name
//STRIP001 	static OCX_Control *OCX_Factory(const String &rId);
//STRIP001 
//STRIP001 	//Generate an OCX converter based on the StarOffice UNO id
//STRIP001 	static OCX_Control *OCX_Factory( const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::awt::XControlModel > &rControlModel,
//STRIP001 		String &rId,String &rName);
//STRIP001 
//STRIP001 	virtual sal_Bool InsertControl(
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		const ::com::sun::star::awt::Size& rSize,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::drawing::XShape > *pShape,
//STRIP001 
//STRIP001 		BOOL bFloatingCtrl ) {return sal_False;}
//STRIP001 
//STRIP001 	/*begin: Backwards compatability with office 95 import, modify later*/
//STRIP001 	const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory > & GetServiceFactory();
//STRIP001 
//STRIP001 	sal_uInt16 GetEditNum() { return ++nEdit; }
//STRIP001 	sal_uInt16 GetCheckboxNum() { return ++nCheckbox; }
//STRIP001 	/*end: Backwards compatability*/
//STRIP001 protected:
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShapes > &
//STRIP001 		GetShapes();
//STRIP001 
//STRIP001 	const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::container::XIndexContainer > & 	GetFormComps();
//STRIP001 
//STRIP001 	SfxObjectShell *pDocSh;
//STRIP001 	SwPaM *pPaM;
//STRIP001 
//STRIP001 	// gecachte Interfaces
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPage >
//STRIP001 		xDrawPage;
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShapes >
//STRIP001 		xShapes;
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > 		xServiceFactory;
//STRIP001 
//STRIP001 	// das einzige Formular
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexContainer >
//STRIP001 		xFormComps;
//STRIP001 
//STRIP001 	sal_uInt16 nEdit;
//STRIP001 	sal_uInt16 nCheckbox;
//STRIP001 
//STRIP001 	virtual const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::drawing::XDrawPage > & GetDrawPage();
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_FontData
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_FontData() : nFontNameLen(0), fBold(0), fItalic(0), fUnderline(0),
//STRIP001 		fStrike(0), nFontSize(12), nJustification(1), pFontName(0),
//STRIP001         bHasAlign(FALSE), bHasFont(TRUE) {}
//STRIP001 	~OCX_FontData()  {
//STRIP001 		if (pFontName)
//STRIP001 		delete [] pFontName;
//STRIP001 	}
//STRIP001 	sal_Bool Read(SvStorageStream *pS);
//STRIP001 	void Import(::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet > &rPropSet);
//STRIP001 
//STRIP001 	sal_Bool Export(SvStorageStreamRef &rContent,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet);
//STRIP001 
//STRIP001 	sal_uInt16 nIdentifier;
//STRIP001 	sal_uInt16 nFixedAreaLen;
//STRIP001 	sal_uInt8 pBlockFlags[4];
//STRIP001 
//STRIP001 	sal_uInt32 nFontNameLen;
//STRIP001 
//STRIP001 	sal_uInt8   fBold:1;
//STRIP001 	sal_uInt8   fItalic:1;
//STRIP001 	sal_uInt8   fUnderline:1;
//STRIP001 	sal_uInt8   fStrike:1;
//STRIP001 	sal_uInt8   fUnknown1:4;
//STRIP001 
//STRIP001 	sal_uInt8   nUnknown2;
//STRIP001 	sal_uInt8   nUnknown3;
//STRIP001 	sal_uInt8   nUnknown4;
//STRIP001 
//STRIP001 	sal_uInt32  nFontSize;
//STRIP001 	sal_uInt16 nLanguageID;
//STRIP001 	sal_uInt8   nJustification;
//STRIP001     sal_uInt16  nFontWeight;
//STRIP001 
//STRIP001 	char *pFontName;
//STRIP001 	void SetHasAlign(sal_Bool bIn) {bHasAlign=bIn;}
//STRIP001 	void SetHasFont(sal_Bool bIn) {bHasFont=bIn;}
//STRIP001 protected:
//STRIP001 	static sal_uInt16 nStandardId;
//STRIP001 	sal_uInt8 ExportAlign(sal_Int16 nAlign) const;
//STRIP001 	sal_Int16 ImportAlign(sal_uInt8 nJustification) const;
//STRIP001 private:
//STRIP001 	sal_Bool bHasAlign;
//STRIP001 	sal_Bool bHasFont;
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_Control(UniString sN) : sName(sN) {}
//STRIP001 	sal_Bool FullRead(SvStorageStream *pS)
//STRIP001 	{
//STRIP001 		if (Read(pS))
//STRIP001 			return(aFontData.Read(pS));
//STRIP001 		return(sal_False);
//STRIP001 	};
//STRIP001 	virtual sal_Bool Read(SvStorageStream *pS) {return sal_False;}
//STRIP001 	virtual sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz) {return sal_False;}
//STRIP001 
//STRIP001 	//Export exports a control as an OLE style storage stream tree
//STRIP001 	virtual sal_Bool Export(SvStorageRef &rObj,
//STRIP001 	const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize) {return sal_False;}
//STRIP001 
//STRIP001 	//WriteContents writes the contents of a contents stream, for
//STRIP001 	//the Excel export you cannot use Export, only WriteContents instead
//STRIP001 	virtual sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 	const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize) {return sal_False;}
//STRIP001 
//STRIP001 
//STRIP001 	sal_Bool ReadAndImport(SvStorageStream *pS,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rSF,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz)
//STRIP001 	{
//STRIP001 		if (Read(pS))
//STRIP001 			return Import(rSF,rFComp,rSz);
//STRIP001 		return sal_False;
//STRIP001 	}
//STRIP001 	virtual ~OCX_Control() {}
//STRIP001 
//STRIP001     static void FillSystemColors();
//STRIP001 
//STRIP001 	UniString sName;
//STRIP001 	OCX_FontData aFontData;
//STRIP001 protected:
//STRIP001 	sal_uInt32 ImportColor(sal_uInt32 nColorCode) const;
//STRIP001 	sal_uInt32 ExportColor(sal_uInt32 nColorCode) const;
//STRIP001 	sal_uInt32 SwapColor(sal_uInt32 nColorCode) const;
//STRIP001 	sal_Int16 ImportBorder(sal_uInt16 nSpecialEffect,sal_uInt16 nBorderStyle)
//STRIP001 		const;
//STRIP001 	sal_uInt8 ExportBorder(sal_uInt16 nBorder,sal_uInt8 &rBorderStyle) const;
//STRIP001 	static sal_uInt16 nStandardId;
//STRIP001 	static sal_uInt8 __READONLY_DATA aObjInfo[4];
//STRIP001 private:
//STRIP001 	static sal_uInt32 pColor[25];
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_ModernControl : public OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_ModernControl(UniString sN) : OCX_Control(sN),
//STRIP001 	fEnabled(1), fLocked(0), fBackStyle(1), fColumnHeads(0), fIntegralHeight(1),
//STRIP001 	fMatchRequired(0), fAlignment(1), fDragBehaviour(0), fEnterKeyBehaviour(0),
//STRIP001 	fEnterFieldBehaviour(0), fTabKeyBehaviour(0), fWordWrap(1),
//STRIP001 	fSelectionMargin(1), fAutoWordSelect(1), fAutoSize(0), fHideSelection(1),
//STRIP001 	fAutoTab(0), fMultiLine(1), nMaxLength(0), nBorderStyle(1), nScrollBars(0),
//STRIP001 	nStyle(0), nMousePointer(0), nPasswordChar(0), nListWidth(0),
//STRIP001     nBoundColumn(1), nTextColumn(-1), nColumnCount(1), nListRows(8),
//STRIP001     nMatchEntry(2), nListStyle(0), nShowDropButtonWhen(0), nDropButtonStyle(1),
//STRIP001     nMultiState(0), nValueLen(0), nCaptionLen(0), nVertPos(1), nHorzPos(7),
//STRIP001 	nSpecialEffect(2), nIcon(0), nPicture(0), nAccelerator(0), nGroupNameLen(0),
//STRIP001 	pValue(0), pCaption(0), pGroupName(0), nIconLen(0), pIcon(0),
//STRIP001     nPictureLen(0), pPicture(0) {}
//STRIP001 
//STRIP001 	~OCX_ModernControl() {
//STRIP001 		if (pValue) delete[] pValue;
//STRIP001 		if (pCaption) delete[] pCaption;
//STRIP001 		if (pGroupName) delete[] pGroupName;
//STRIP001 		if (pIcon) delete[] pIcon;
//STRIP001 		if (pPicture) delete[] pPicture;
//STRIP001 	}
//STRIP001 	sal_Bool Read(SvStorageStream *pS);
//STRIP001 
//STRIP001 	/*sal_uInt8 for sal_uInt8 Word Struct*/
//STRIP001 	sal_uInt16  nIdentifier;
//STRIP001 	sal_uInt16 	nFixedAreaLen;
//STRIP001 	sal_uInt8	pBlockFlags[8];
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown1:1;
//STRIP001 	sal_uInt8	fEnabled:1;
//STRIP001 	sal_uInt8	fLocked:1;
//STRIP001 	sal_uInt8	fBackStyle:1;
//STRIP001 	sal_uInt8	fUnknown2:4;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown3:2;
//STRIP001 	sal_uInt8	fColumnHeads:1;
//STRIP001 	sal_uInt8	fIntegralHeight:1;
//STRIP001 	sal_uInt8	fMatchRequired:1;
//STRIP001 	sal_uInt8	fAlignment:1;
//STRIP001 	sal_uInt8	fUnknown4:2;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown5:3;
//STRIP001 	sal_uInt8	fDragBehaviour:1;
//STRIP001 	sal_uInt8	fEnterKeyBehaviour:1;
//STRIP001 	sal_uInt8	fEnterFieldBehaviour:1;
//STRIP001 	sal_uInt8	fTabKeyBehaviour:1;
//STRIP001 	sal_uInt8	fWordWrap:1;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown6:2;
//STRIP001 	sal_uInt8	fSelectionMargin:1;
//STRIP001 	sal_uInt8	fAutoWordSelect:1;
//STRIP001 	sal_uInt8	fAutoSize:1;
//STRIP001 	sal_uInt8	fHideSelection:1;
//STRIP001 	sal_uInt8	fAutoTab:1;
//STRIP001 	sal_uInt8	fMultiLine:1;
//STRIP001 
//STRIP001 	sal_uInt32	nBackColor;
//STRIP001 	sal_uInt32	nForeColor;
//STRIP001 	sal_uInt32 	nMaxLength;
//STRIP001 	sal_uInt8	nBorderStyle;
//STRIP001 	sal_uInt8	nScrollBars;
//STRIP001 	sal_uInt8	nStyle;
//STRIP001 	sal_uInt8	nMousePointer;
//STRIP001 	sal_uInt8	nUnknown7;
//STRIP001 	sal_uInt8	nPasswordChar;
//STRIP001 	sal_uInt32	nListWidth;
//STRIP001 	sal_uInt16	nBoundColumn;
//STRIP001 	sal_Int16	nTextColumn;
//STRIP001 	sal_uInt16	nColumnCount;
//STRIP001 	sal_uInt16	nListRows;
//STRIP001 	sal_uInt16	nUnknown8;
//STRIP001 	sal_uInt8	nMatchEntry;
//STRIP001 	sal_uInt8	nListStyle;
//STRIP001 	sal_uInt8	nShowDropButtonWhen;
//STRIP001 	sal_uInt8	nDropButtonStyle;
//STRIP001 	sal_uInt8	nMultiState;
//STRIP001 	sal_uInt32	nValueLen;
//STRIP001 	sal_uInt32	nCaptionLen;
//STRIP001 
//STRIP001 	sal_uInt16 nVertPos;
//STRIP001 	sal_uInt16 nHorzPos;
//STRIP001 
//STRIP001 	sal_uInt32 nBorderColor;
//STRIP001 	sal_uInt8 nSpecialEffect;
//STRIP001 	sal_uInt16 nIcon;
//STRIP001 	sal_uInt16 nPicture;
//STRIP001 	sal_uInt8 nAccelerator;
//STRIP001 	sal_uInt8 nUnknown9;
//STRIP001 	sal_uInt32 nGroupNameLen;
//STRIP001 	sal_uInt32 nUnknown10;
//STRIP001 
//STRIP001 	sal_uInt32 nWidth;
//STRIP001 	sal_uInt32 nHeight;
//STRIP001 
//STRIP001 	char *pValue;
//STRIP001 	char *pCaption;
//STRIP001 	char *pGroupName;
//STRIP001 
//STRIP001 	sal_uInt8 pIconHeader[20];
//STRIP001 	sal_uInt32 nIconLen;
//STRIP001 	sal_uInt8 *pIcon;
//STRIP001 
//STRIP001 	sal_uInt8 pPictureHeader[20];
//STRIP001 	sal_uInt32 nPictureLen;
//STRIP001 	sal_uInt8 *pPicture;
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_Image : public OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_Image() : OCX_Control(C2U("Image")) {}
//STRIP001 
//STRIP001 	/*sal_uInt8 for sal_uInt8 Word Struct*/
//STRIP001 	sal_uInt16	nIdentifier;
//STRIP001 	sal_uInt16	nFixedAreaLen;
//STRIP001 	sal_uInt8	pBlockFlags[4];
//STRIP001 
//STRIP001 	sal_uInt32	nBackColor;
//STRIP001 	sal_uInt8	nBorderStyle;
//STRIP001 	sal_uInt16	nSpecialEffect;
//STRIP001 
//STRIP001 	sal_uInt32 	nWidth;
//STRIP001 	sal_uInt32 	nHeight;
//STRIP001 
//STRIP001 
//STRIP001 	//sal_uInt8	?
//STRIP001 	sal_uInt8	fEnabled:1;
//STRIP001 	//sal_uInt8	?
//STRIP001 
//STRIP001 
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	static OCX_Control *Create() { return new OCX_Image;}
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 class OCX_CheckBox : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_CheckBox() : OCX_ModernControl(C2U("CheckBox")){
//STRIP001 		nBackColor = 0x00FFFFFF;
//STRIP001 		nForeColor = 0x00000000;
//STRIP001 	}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	static OCX_Control *Create() { return new OCX_CheckBox;}
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_OptionButton : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_OptionButton() : OCX_ModernControl(C2U("OptionButton"))
//STRIP001 	{
//STRIP001 		nBackColor =  0x00FFFFFF;
//STRIP001 		nForeColor =  0x00000000;
//STRIP001 	}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 
//STRIP001 	static OCX_Control *Create() { return new OCX_OptionButton;}
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_TextBox : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_TextBox() : OCX_ModernControl(C2U("TextBox")) {
//STRIP001 		nBackColor = 0x80000005L;
//STRIP001 		nForeColor = 0x80000008L;
//STRIP001 		nBorderColor = 0x80000006L;
//STRIP001 		aFontData.SetHasAlign(TRUE);
//STRIP001 	}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	static OCX_Control *Create() { return new OCX_TextBox;}
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_FieldControl: public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_FieldControl() : OCX_ModernControl(C2U("TextBox")) {
//STRIP001 		nBackColor = 0x80000005L;
//STRIP001 		nForeColor = 0x80000008L;
//STRIP001 		nBorderColor = 0x80000006L;
//STRIP001 	}
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	static OCX_Control *Create() { return new OCX_FieldControl;}
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 class OCX_ToggleButton : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_ToggleButton() : OCX_ModernControl(C2U("ToggleButton")) {
//STRIP001 		nBackColor = 0x8000000F;
//STRIP001 		nForeColor = 0x80000012;
//STRIP001 	}
//STRIP001 	static OCX_Control *Create() { return new OCX_ToggleButton;}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_ComboBox : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_ComboBox() : OCX_ModernControl(C2U("ComboBox")){
//STRIP001 		nBackColor = 0x80000005;
//STRIP001 		nForeColor = 0x80000008;
//STRIP001 		nBorderColor = 0x80000006;
//STRIP001 	}
//STRIP001 	static OCX_Control *Create() { return new OCX_ComboBox;}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_ListBox : public OCX_ModernControl
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_ListBox() : OCX_ModernControl(C2U("ListBox")){
//STRIP001 		nBackColor = 0x80000005;
//STRIP001 		nForeColor = 0x80000008;
//STRIP001 		nBorderColor = 0x80000006;
//STRIP001 	}
//STRIP001 	static OCX_Control *Create() { return new OCX_ListBox;}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_CommandButton : public OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_CommandButton() : OCX_Control(String::CreateFromAscii("CommandButton")),
//STRIP001 	nForeColor(0x80000012L), nBackColor(0x8000000FL), fEnabled(1), fLocked(0),
//STRIP001 	fBackStyle(1), fWordWrap(1), fAutoSize(0), nCaptionLen(0), nVertPos(1),
//STRIP001     nHorzPos(7), nMousePointer(0), nPicture(0), nAccelerator(0), nIcon(0),
//STRIP001     pCaption(0), nIconLen(0), pIcon(0), nPictureLen(0), pPicture(0)
//STRIP001 	{}
//STRIP001 
//STRIP001 	~OCX_CommandButton() {
//STRIP001 		if (pCaption) delete[] pCaption;
//STRIP001 		if (pIcon) delete[] pIcon;
//STRIP001 		if (pPicture) delete[] pPicture;
//STRIP001 	}
//STRIP001 	sal_Bool Read(SvStorageStream *pS);
//STRIP001 
//STRIP001 	/*sal_uInt8 for sal_uInt8 Word Struct*/
//STRIP001 	sal_uInt16	nIdentifier;
//STRIP001 	sal_uInt16	nFixedAreaLen;
//STRIP001 	sal_uInt8	pBlockFlags[4];
//STRIP001 
//STRIP001 	sal_uInt32	nForeColor;
//STRIP001 	sal_uInt32	nBackColor;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown1:1;
//STRIP001 	sal_uInt8	fEnabled:1;
//STRIP001 	sal_uInt8	fLocked:1;
//STRIP001 	sal_uInt8	fBackStyle:1;
//STRIP001 	sal_uInt8	fUnknown2:4;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown3:8;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown4:7;
//STRIP001 	sal_uInt8	fWordWrap:1;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown5:4;
//STRIP001 	sal_uInt8	fAutoSize:1;
//STRIP001 	sal_uInt8	fUnknown6:3;
//STRIP001 
//STRIP001 	sal_uInt32	nCaptionLen;
//STRIP001 
//STRIP001 	sal_uInt16  nVertPos;
//STRIP001 	sal_uInt16  nHorzPos;
//STRIP001 
//STRIP001 	sal_uInt16 	nMousePointer;
//STRIP001 	sal_uInt16	nPicture;
//STRIP001 	sal_uInt16	nAccelerator;
//STRIP001 	sal_uInt16	nIcon;
//STRIP001 
//STRIP001 	char *pCaption;
//STRIP001 
//STRIP001 	sal_uInt32 	nWidth;
//STRIP001 	sal_uInt32 	nHeight;
//STRIP001 
//STRIP001 	sal_uInt8 pIconHeader[20];
//STRIP001 	sal_uInt32  nIconLen;
//STRIP001 	sal_uInt8 *pIcon;
//STRIP001 
//STRIP001 	sal_uInt8 pPictureHeader[20];
//STRIP001 	sal_uInt32  nPictureLen;
//STRIP001 	sal_uInt8 *pPicture;
//STRIP001 
//STRIP001 	static OCX_Control *Create() { return new OCX_CommandButton;}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_ImageButton: public OCX_CommandButton
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_ImageButton() {
//STRIP001 		aFontData.SetHasAlign(FALSE);
//STRIP001 		aFontData.SetHasFont(FALSE);
//STRIP001 	}
//STRIP001 	static OCX_Control *Create() { return new OCX_ImageButton;}
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_GroupBox: public OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_GroupBox() : OCX_Control(String::CreateFromAscii("GroupBox")) {}
//STRIP001 	static OCX_Control *Create() { return new OCX_GroupBox;}
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 class OCX_Label : public OCX_Control
//STRIP001 {
//STRIP001 public:
//STRIP001 	OCX_Label() : OCX_Control(C2U("Label")),nForeColor(0),
//STRIP001 	nBackColor(0xFFFFFF),fEnabled(1),fLocked(0),fBackStyle(1),fWordWrap(1),
//STRIP001 	fAutoSize(0),nCaptionLen(0),nVertPos(1),nHorzPos(7),nMousePointer(0),
//STRIP001 	nBorderColor(0x80000006),nBorderStyle(0),nSpecialEffect(0),
//STRIP001 	nPicture(0),nAccelerator(0),nIcon(0),pCaption(0),nIconLen(0),pIcon(0),
//STRIP001 	nPictureLen(0),pPicture(0) {aFontData.SetHasAlign(TRUE);}
//STRIP001 
//STRIP001 	~OCX_Label() {
//STRIP001 		if (pCaption) delete[] pCaption;
//STRIP001 		if (pIcon) delete[] pIcon;
//STRIP001 		if (pPicture) delete[] pPicture;
//STRIP001 	}
//STRIP001 	sal_Bool Read(SvStorageStream *pS);
//STRIP001 
//STRIP001 	/*sal_uInt8 for sal_uInt8 Word Struct*/
//STRIP001 	sal_uInt16 nIdentifier;
//STRIP001 	sal_uInt16 nFixedAreaLen;
//STRIP001 	sal_uInt8	pBlockFlags[4];
//STRIP001 
//STRIP001 	sal_uInt32	nForeColor;
//STRIP001 	sal_uInt32	nBackColor;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown1:1;
//STRIP001 	sal_uInt8	fEnabled:1;
//STRIP001 	sal_uInt8	fLocked:1;
//STRIP001 	sal_uInt8	fBackStyle:1;
//STRIP001 	sal_uInt8	fUnknown2:4;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown3:8;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown4:7;
//STRIP001 	sal_uInt8	fWordWrap:1;
//STRIP001 
//STRIP001 	sal_uInt8	fUnknown5:4;
//STRIP001 	sal_uInt8	fAutoSize:1;
//STRIP001 	sal_uInt8	fUnknown6:3;
//STRIP001 
//STRIP001 	sal_uInt32	nCaptionLen;
//STRIP001 	sal_uInt16  nVertPos;
//STRIP001 	sal_uInt16  nHorzPos;
//STRIP001 	sal_uInt8 	nMousePointer;
//STRIP001 	sal_uInt32	nBorderColor;
//STRIP001 	sal_uInt16	nBorderStyle;
//STRIP001 	sal_uInt16	nSpecialEffect;
//STRIP001 	sal_uInt16	nPicture;
//STRIP001 	sal_uInt16	nAccelerator;
//STRIP001 	sal_uInt16	nIcon;
//STRIP001 
//STRIP001 	char *pCaption;
//STRIP001 
//STRIP001 	sal_uInt32 	nWidth;
//STRIP001 	sal_uInt32 	nHeight;
//STRIP001 
//STRIP001 	sal_uInt8 pIconHeader[20];
//STRIP001 	sal_uInt32  nIconLen;
//STRIP001 	sal_uInt8 *pIcon;
//STRIP001 
//STRIP001 	sal_uInt8 pPictureHeader[20];
//STRIP001 	sal_uInt32  nPictureLen;
//STRIP001 	sal_uInt8 *pPicture;
//STRIP001 
//STRIP001 	static OCX_Control *Create() { return new OCX_Label;}
//STRIP001 	sal_Bool Import(const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 		::com::sun::star::awt::Size &rSz);
//STRIP001 	sal_Bool Export(SvStorageRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 	sal_Bool WriteContents(SvStorageStreamRef &rObj,
//STRIP001 		const ::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::beans::XPropertySet> &rPropSet,
//STRIP001 		const ::com::sun::star::awt::Size& rSize);
//STRIP001 
//STRIP001 };
}//end of namespace binfilter
#endif
