/*************************************************************************
 *
 *  $RCSfile: page.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:28:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_PAGE_HXX
#define _SVX_PAGE_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#ifndef _SVX_PAGECTRL_HXX //autogen
#include <bf_svx/pagectrl.hxx>
#endif
#ifndef _SVX_FRMDIRLBOX_HXX
#include <bf_svx/frmdirlbox.hxx>
#endif

#include <bf_svx/svxenum.hxx>
namespace binfilter {

// enum ------------------------------------------------------------------

//STRIP001 enum SvxModeType
//STRIP001 {
//STRIP001 	SVX_PAGE_MODE_STANDARD,
//STRIP001 	SVX_PAGE_MODE_CENTER,
//STRIP001 	SVX_PAGE_MODE_PRESENTATION
//STRIP001 };
//STRIP001 
//STRIP001 // class SvxPageDescPage -------------------------------------------------
//STRIP001 
//STRIP001 /*  {k:\svx\prototyp\dialog\page.bmp}
//STRIP001 
//STRIP001 	[Beschreibung]
//STRIP001 	TabPage zur Einstellung einer Seite (Groesse, Raender, ...)
//STRIP001 
//STRIP001 	[Items]
//STRIP001 	<SvxPageItem>:          <SID_ATTR_PAGE>
//STRIP001 	<SvxSizeItem>:          <SID_ATTR_SIZE>
//STRIP001 	<SvxSizeItem>:          <SID_ATTR_MAXSIZE>
//STRIP001 	<SvxULSpaceItem>:       <SID_ATTR_LRSPACE>
//STRIP001 	<SvxLRSpaceItem>:       <SID_ATTR_ULSPACE>
//STRIP001 	<SfxAllEnumItem>:       <SID_ATTR_PAPERTRAY>
//STRIP001 	<SvxPaperBinItem>:      <SID_ATTR_PAPERBIN>
//STRIP001 	<SvxBoolItem>:          <SID_ATTR_EXT1>
//STRIP001 	<SvxBoolItem>:          <SID_ATTR_EXT2>
//STRIP001 
//STRIP001 	<SfxSetItem>:           <SID_ATTR_HEADERSET>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_ON>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_DYNAMIC>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_SHARED>
//STRIP001 		<SvxSizeItem>:          <SID_ATTR_SIZE>
//STRIP001 		<SvxULSpaceItem>:       <SID_ATTR_ULSPACE>
//STRIP001 		<SvxLRSpaceItem>:       <SID_ATTR_LRSPACE>
//STRIP001 
//STRIP001 	<SfxSetItem>:           <SID_ATTR_FOOTERSET>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_ON>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_DYNAMIC>
//STRIP001 		<SfxBoolItem>:          <SID_ATTR_SHARED>
//STRIP001 		<SvxSizeItem>:          <SID_ATTR_SIZE>
//STRIP001 		<SvxULSpaceItem>:       <SID_ATTR_ULSPACE>
//STRIP001 		<SvxLRSpaceItem>:       <SID_ATTR_LRSPACE>
//STRIP001 */
//STRIP001 
//STRIP001 struct	SvxPage_Impl;
//STRIP001 typedef	USHORT MarginPosition;
//STRIP001 
//STRIP001 class SvxPageDescPage : public SfxTabPage
//STRIP001 {
//STRIP001     // paper format
//STRIP001     FixedLine           aPaperSizeFl;
//STRIP001     FixedText           aPaperFormatText;
//STRIP001 	ListBox             aPaperSizeBox;
//STRIP001 
//STRIP001     FixedText           aPaperWidthText;
//STRIP001 	MetricField         aPaperWidthEdit;
//STRIP001 	FixedText           aPaperHeightText;
//STRIP001 	MetricField         aPaperHeightEdit;
//STRIP001 
//STRIP001     FixedText           aOrientationFT;
//STRIP001     RadioButton         aPortraitBtn;
//STRIP001 	RadioButton         aLandscapeBtn;
//STRIP001 
//STRIP001     SvxPageWindow       aBspWin;
//STRIP001 
//STRIP001     FixedText           		aTextFlowLbl;
//STRIP001     svx::FrameDirectionListBox	aTextFlowBox;
//STRIP001 
//STRIP001     FixedText           aPaperTrayLbl;
//STRIP001 	ListBox             aPaperTrayBox;
//STRIP001 
//STRIP001     // Margins
//STRIP001     FixedLine           aMarginFl;
//STRIP001     FixedText           aLeftMarginLbl;
//STRIP001 	MetricField         aLeftMarginEdit;
//STRIP001 	FixedText           aRightMarginLbl;
//STRIP001 	MetricField         aRightMarginEdit;
//STRIP001 	FixedText           aTopMarginLbl;
//STRIP001 	MetricField         aTopMarginEdit;
//STRIP001 	FixedText           aBottomMarginLbl;
//STRIP001 	MetricField         aBottomMarginEdit;
//STRIP001 
//STRIP001     // layout settings
//STRIP001     FixedLine           aLayoutFL;
//STRIP001     ListBox             aLayoutBox;
//STRIP001 	FixedText           aPageText;
//STRIP001     ListBox             aNumberFormatBox;
//STRIP001 	FixedText			aNumberFormatText;
//STRIP001 
//STRIP001     FixedLine           aBottomSeparatorFl;
//STRIP001 
//STRIP001     //Extras Calc
//STRIP001     FixedText           aTblAlignFT;
//STRIP001     CheckBox            aHorzBox;
//STRIP001 	CheckBox            aVertBox;
//STRIP001 
//STRIP001     // Impress and Draw
//STRIP001 	CheckBox            aAdaptBox;
//STRIP001 
//STRIP001 	//Register Writer
//STRIP001 	CheckBox			aRegisterCB;
//STRIP001 	FixedText			aRegisterFT;
//STRIP001 	ListBox				aRegisterLB;
//STRIP001 
//STRIP001 	String				sStandardRegister;
//STRIP001 
//STRIP001 	String              aInsideText;
//STRIP001 	String              aOutsideText;
//STRIP001 	String              aLeftText;
//STRIP001 	String              aRightText;
//STRIP001 	String				aPrintRangeQueryText;
//STRIP001 
//STRIP001 	long				nFirstLeftMargin;
//STRIP001 	long				nFirstRightMargin;
//STRIP001 	long				nFirstTopMargin;
//STRIP001 	long				nFirstBottomMargin;
//STRIP001 	long				nLastLeftMargin;
//STRIP001 	long				nLastRightMargin;
//STRIP001 	long				nLastTopMargin;
//STRIP001 	long				nLastBottomMargin;
//STRIP001 
//STRIP001 	Size                aMaxSize;
//STRIP001 	BOOL                bLandscape;
//STRIP001 	FASTBOOL            bBorderModified;
//STRIP001 	SvxModeType         eMode;
//STRIP001 	SvxPaper            ePaperStart;
//STRIP001 	SvxPaper            ePaperEnd;
//STRIP001 
//STRIP001 	SvxPage_Impl*		pImpl;
//STRIP001 
//STRIP001 #ifdef _SVX_PAGE_CXX
//STRIP001 	void                Init_Impl();
//STRIP001 	DECL_LINK( 			LayoutHdl_Impl, ListBox* );
//STRIP001 	DECL_LINK( 			PaperBinHdl_Impl, ListBox* );
//STRIP001 	DECL_LINK( 			SwapOrientation_Impl, RadioButton* );
//STRIP001 	void                SwapFirstValues_Impl( FASTBOOL bSet );
//STRIP001 	DECL_LINK( 			BorderModify_Impl, MetricField* );
//STRIP001 	void                InitHeadFoot_Impl( const SfxItemSet& rSet );
//STRIP001 	DECL_LINK( 			CenterHdl_Impl, CheckBox* );
//STRIP001 	void                UpdateExample_Impl();
//STRIP001 
//STRIP001 	// Papiergroesse
//STRIP001 	DECL_LINK(			PaperSizeSelect_Impl, ListBox* );
//STRIP001 	DECL_LINK(			PaperSizeModify_Impl, Edit* );
//STRIP001 
//STRIP001     DECL_LINK(			FrameDirectionModify_Impl, ListBox* );
//STRIP001 
//STRIP001     // Hintergrund
//STRIP001 	void                ResetBackground_Impl( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	// Grenzwerte
//STRIP001 	DECL_LINK(			RangeHdl_Impl, Edit* );
//STRIP001 	void                CalcMargin_Impl();
//STRIP001 
//STRIP001 	// Registerhaltigkeit
//STRIP001 	DECL_LINK(			RegisterModify, CheckBox * );
//STRIP001 
//STRIP001     // page direction
//STRIP001     /** Disables vertical page direction entries in the text flow listbox. */
//STRIP001     void                DisableVerticalPageDir();
//STRIP001 
//STRIP001 	bool				IsPrinterRangeOverflow( MetricField& rField, long nFirstMargin,
//STRIP001 												long nLastMargin, MarginPosition nPos );
//STRIP001 	void				CheckMarginEdits( bool _bClear );
//STRIP001 	bool				IsMarginOutOfRange();
//STRIP001 #endif
//STRIP001 
//STRIP001 	SvxPageDescPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void        ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*  Create( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*      GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL        FillItemSet( SfxItemSet& rOutSet );
//STRIP001 	virtual void        Reset( const SfxItemSet& rSet );
//STRIP001 	virtual void        FillUserData();
//STRIP001 
//STRIP001 	virtual ~SvxPageDescPage();
//STRIP001 
//STRIP001 	void                SetMode( SvxModeType eMType ) { eMode = eMType; }
//STRIP001 	void                SetPaperFormatRanges( SvxPaper eStart, SvxPaper eEnd )
//STRIP001 							{ ePaperStart = eStart, ePaperEnd = eEnd; }
//STRIP001 
//STRIP001 	void				SetCollectionList(const List* pList);
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_PAGE_HXX

