/*************************************************************************
 *
 *  $RCSfile: svxbox.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:31:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_BOX_HXX
#define _SVX_BOX_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _SVARRAY_HXX //autogen
// auto strip #include <svtools/svarray.hxx>
// auto strip #endif

// auto strip #ifndef _STRING_HXX //autogen
// auto strip #include <tools/string.hxx>
// auto strip #endif

// auto strip #ifndef _LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif

// auto strip #ifndef _COMBOBOX_HXX //autogen
// auto strip #include <vcl/combobox.hxx>
// auto strip #endif
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP001 class SvxBoxEntry;
//STRIP001 class SvxListBase;

#if _SOLAR__PRIVATE
//STRIP001 SV_DECL_PTRARR( SvxEntryLst, SvxBoxEntry*, 10, 10 )
#else
//STRIP001 typedef SvPtrarr SvxEntryLst;
#endif

// class SvxBoxEntry -----------------------------------------------------

//STRIP001 class SvxBoxEntry
//STRIP001 {
//STRIP001 	friend class SvxListBox;
//STRIP001 	friend class SvxComboBox;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxBoxEntry( const String& aName, USHORT nId=0 );
//STRIP001 	SvxBoxEntry( const SvxBoxEntry& rOrg );
//STRIP001 	SvxBoxEntry();
//STRIP001 
//STRIP001 	String 				aName;
//STRIP001 	USHORT 				nId;
//STRIP001 
//STRIP001 private:
//STRIP001 	BOOL   				bModified;
//STRIP001 	BOOL   				bNew;
//STRIP001 };

// class SvxListBox ------------------------------------------------------

//STRIP001 class SvxListBox : public ListBox
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxListBox( Window* pParent, WinBits nBits = WB_BORDER );
//STRIP001 	SvxListBox( Window* pParent, const ResId& rId );
//STRIP001 	~SvxListBox();
//STRIP001 
//STRIP001 	void				InsertNewEntry( const SvxBoxEntry& rEntry );
//STRIP001 	void				InsertEntry( const SvxBoxEntry& rEntry,
//STRIP001 									 USHORT nId = LISTBOX_ENTRY_NOTFOUND );
//STRIP001 
//STRIP001 	void				RemoveEntry( USHORT nPos );
//STRIP001 	void				RemoveEntry( const SvxBoxEntry& rEntry );
//STRIP001 
//STRIP001 	void				Clear();
//STRIP001 
//STRIP001 	USHORT 				GetEntryPos( const SvxBoxEntry& rEntry ) const;
//STRIP001 	const SvxBoxEntry&  GetEntry( USHORT nIdx ) const;
//STRIP001 
//STRIP001 	inline BOOL			IsEntrySelected( const SvxBoxEntry& rEntry ) const;
//STRIP001 	const SvxBoxEntry&  GetSelectEntry( USHORT nIdx = 0 ) const;
//STRIP001 	inline void			SelectEntry( const SvxBoxEntry& rEntry,
//STRIP001 									 BOOL bSelect = TRUE );
//STRIP001 
//STRIP001 	void				ModifyEntry( USHORT nPos, const String& aName );
//STRIP001 	USHORT				GetModifiedCount() const;
//STRIP001 	const SvxBoxEntry&	GetModifiedEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 	USHORT				GetRemovedCount() const;
//STRIP001 	const SvxBoxEntry&	GetRemovedEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 	USHORT				GetNewCount() const;
//STRIP001 	const SvxBoxEntry&	GetNewEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxEntryLst			aEntryLst;
//STRIP001 	SvxEntryLst			aDelEntryLst;
//STRIP001 	SvxBoxEntry 		aDefault;
//STRIP001 
//STRIP001 	void				InitListBox();
//STRIP001 	void				InsertSorted( SvxBoxEntry* pEntry );
//STRIP001 };

// inlines ---------------------------------------------------------------

//STRIP001 inline BOOL	SvxListBox::IsEntrySelected( const SvxBoxEntry& aEntry ) const
//STRIP001 	{ return ListBox::IsEntrySelected( aEntry.aName ); }

//STRIP001 inline void SvxListBox::SelectEntry( const SvxBoxEntry& aEntry, BOOL bSelect )
//STRIP001 	{ ListBox::SelectEntry( aEntry.aName, bSelect ); }

// enum SvxComboBoxStyle -------------------------------------------------

//STRIP001 enum SvxComboBoxStyle
//STRIP001 {
//STRIP001 	SVX_CBS_UPPER 	 	= 0x01,
//STRIP001 	SVX_CBS_LOWER	 	= 0x02,
//STRIP001 	SVX_CBS_ALL	  	 	= 0x04,
//STRIP001 	SVX_CBS_FILENAME 	= 0x08,
//STRIP001 #ifdef WIN
//STRIP001 	SVX_CBS_SW_FILENAME = SVX_CBS_FILENAME | SVX_CBS_LOWER
//STRIP001 #else
//STRIP001 	SVX_CBS_SW_FILENAME = SVX_CBS_FILENAME
//STRIP001 #endif
//STRIP001 };

// class SvxComboBox -----------------------------------------------------

//STRIP001 class SvxComboBox : public ComboBox
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxComboBox( Window* pParent,
//STRIP001 				 WinBits nBits = WB_BORDER, USHORT nStyleBits = SVX_CBS_ALL );
//STRIP001 	SvxComboBox( Window* pParent, const ResId& rId, USHORT nStyleBits = SVX_CBS_ALL );
//STRIP001 	~SvxComboBox();
//STRIP001 
//STRIP001 	void				InsertNewEntry( const SvxBoxEntry& );
//STRIP001 	void				InsertEntry( const SvxBoxEntry& );
//STRIP001 
//STRIP001 	void				RemoveEntry( USHORT nPos );
//STRIP001 	void				RemoveEntry( const SvxBoxEntry& rEntry );
//STRIP001 
//STRIP001 	void				Clear();
//STRIP001 
//STRIP001 	USHORT 				GetEntryPos( const SvxBoxEntry& rEntry ) const;
//STRIP001 	const SvxBoxEntry&  GetEntry( USHORT nIdx ) const;
//STRIP001 
//STRIP001 	void				ModifyEntry( USHORT nPos, const String& aName );
//STRIP001 	USHORT				GetModifiedCount() const;
//STRIP001 	const SvxBoxEntry&	GetModifiedEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 	USHORT				GetRemovedCount() const;
//STRIP001 	const SvxBoxEntry&	GetRemovedEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 	USHORT				GetNewCount() const;
//STRIP001 	const SvxBoxEntry&	GetNewEntry( USHORT nPos ) const;
//STRIP001 
//STRIP001 	USHORT 				GetStyle() const 			 { return nStyle; }
//STRIP001 	void				SetStyle( const USHORT nSt ) { nStyle = nSt; }
//STRIP001 
//STRIP001 	String				GetText() const;
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxEntryLst			aEntryLst;
//STRIP001 	SvxEntryLst			aDelEntryLst;
//STRIP001 	SvxBoxEntry 		aDefault;
//STRIP001 	USHORT 				nStyle;
//STRIP001 
//STRIP001 	virtual void 		KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 	void				InitComboBox();
//STRIP001 	void				InsertSorted( SvxBoxEntry* pEntry );
//STRIP001 };

}//end of namespace binfilter
#endif

