/*************************************************************************
 *
 *  $RCSfile: textanim.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:29:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_TEXTANIM_HXX
#define _SVX_TEXTANIM_HXX

// include ---------------------------------------------------------------

#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif

#ifndef _SFXTABDLG_HXX
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _SVDATTR_HXX
#include <bf_svx/svdattr.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
namespace binfilter {

//STRIP001 class SdrView;

/*************************************************************************
|*
|* Page zum "Andern von TextAnimationen (Lauftext etc.)
|*
\************************************************************************/

//STRIP001 class SvxTextAnimationPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine			aFlEffect;
//STRIP001 	FixedText			aFtEffects;
//STRIP001 	ListBox				aLbEffect;
//STRIP001 	//ValueSet			aCtlEffect;
//STRIP001 	FixedText			aFtDirection;	
//STRIP001 	ImageButton			aBtnUp;
//STRIP001 	ImageButton			aBtnLeft;
//STRIP001 	ImageButton			aBtnRight;
//STRIP001 	ImageButton			aBtnDown;
//STRIP001 
//STRIP001 	FixedLine			aFlProperties;	
//STRIP001 	TriStateBox			aTsbStartInside;
//STRIP001 	TriStateBox			aTsbStopInside;
//STRIP001 
//STRIP001 	FixedText			aFtCount;
//STRIP001 	TriStateBox			aTsbEndless;
//STRIP001 	NumericField		aNumFldCount;
//STRIP001 
//STRIP001 	FixedText			aFtAmount;
//STRIP001 	TriStateBox			aTsbPixel;
//STRIP001 	MetricField			aMtrFldAmount;
//STRIP001 
//STRIP001 	FixedText			aFtDelay;
//STRIP001 	TriStateBox			aTsbAuto;
//STRIP001 	MetricField			aMtrFldDelay;
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	SdrTextAniKind		eAniKind;
//STRIP001 	FieldUnit			eFUnit;
//STRIP001 	SfxMapUnit			eUnit;
//STRIP001 
//STRIP001 #ifdef _SVX_TEXTANIM_CXX
//STRIP001 	DECL_LINK( SelectEffectHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickEndlessHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickAutoHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickPixelHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickDirectionHdl_Impl, ImageButton * );
//STRIP001 
//STRIP001 	void				SelectDirection( USHORT nValue );
//STRIP001 	USHORT				GetSelectedDirection();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SvxTextAnimationPage( Window* pWindow, const SfxItemSet& rInAttrs );
//STRIP001 	~SvxTextAnimationPage();
//STRIP001 
//STRIP001 	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
//STRIP001 	static  USHORT*	    GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL 		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void 		Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 };

/*************************************************************************
|*
|* Text-Tab-Dialog
|*
\************************************************************************/
//STRIP001 class SvxTextTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	const SdrView*		pView;
//STRIP001 
//STRIP001 	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 			SvxTextTabDialog( Window* pParent, const SfxItemSet* pAttr,
//STRIP001 								const SdrView* pView );
//STRIP001 			~SvxTextTabDialog() {};
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_TEXTANIM_HXX

