/*************************************************************************
 *
 *  $RCSfile: offmgr_optfltr.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

// include ---------------------------------------------------------------

//STRIP001 #ifdef PRECOMPILED
//STRIP001 #include "ofapch.hxx"
//STRIP001 #endif
//STRIP001 
//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include "app.hxx"
//STRIP001 #include "fltrcfg.hxx"
//STRIP001 #include "resid.hxx"
//STRIP001 #include "optfltr.hxx"
//STRIP001 
//STRIP001 #include "app.hrc"
//STRIP001 #include "optfltr.hrc"
//STRIP001 
//STRIP001 enum MSFltrPg2_CheckBoxEntries {
//STRIP001 	Math,
//STRIP001 	Writer,
//STRIP001 	Calc,
//STRIP001 	Impress,
//STRIP001 	InvalidCBEntry
//STRIP001 };
//STRIP001 
//STRIP001 #define CBCOL_FIRST		0
//STRIP001 #define CBCOL_SECOND 	1
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 OfaMSFilterTabPage::OfaMSFilterTabPage(Window* pParent, const SfxItemSet& rSet)
//STRIP001 	: SfxTabPage( pParent, OffResId( RID_OFAPAGE_MSFILTEROPT ), rSet ),
//STRIP001 	aMSWordGB		( this, ResId( GB_WORD	    ) ),
//STRIP001 	aWBasicCodeCB	( this, ResId( CB_WBAS_CODE ) ),
//STRIP001 	aWBasicStgCB	( this, ResId( CB_WBAS_STG  ) ),
//STRIP001 	aMSExcelGB      ( this, ResId( GB_EXCEL     ) ),
//STRIP001 	aEBasicCodeCB   ( this, ResId( CB_EBAS_CODE ) ),
//STRIP001 	aEBasicStgCB    ( this, ResId( CB_EBAS_STG  ) ),
//STRIP001 	aMSPPointGB     ( this, ResId( GB_PPOINT    ) ),
//STRIP001 	aPBasicCodeCB   ( this, ResId( CB_PBAS_CODE ) ),
//STRIP001 	aPBasicStgCB    ( this, ResId( CB_PBAS_STG  ) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 }
//STRIP001 
//STRIP001 OfaMSFilterTabPage::~OfaMSFilterTabPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SfxTabPage*	OfaMSFilterTabPage::Create( Window* pParent,
//STRIP001 										const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new OfaMSFilterTabPage( pParent, rAttrSet );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL OfaMSFilterTabPage::FillItemSet( SfxItemSet& )
//STRIP001 {
//STRIP001 	OfaFilterOptions* pOpt = OFF_APP()->GetFilterOptions();
//STRIP001 
//STRIP001 	BOOL bFlag;
//STRIP001 	if( aWBasicCodeCB.GetSavedValue() != (bFlag = aWBasicCodeCB.IsChecked()))
//STRIP001 		pOpt->SetLoadWordBasicCode( bFlag );
//STRIP001 	if( aWBasicStgCB.GetSavedValue() != (bFlag = aWBasicStgCB.IsChecked()))
//STRIP001 		pOpt->SetLoadWordBasicStorage( bFlag );
//STRIP001 
//STRIP001 	if( aEBasicCodeCB.GetSavedValue() != (bFlag = aEBasicCodeCB.IsChecked()))
//STRIP001 		pOpt->SetLoadExcelBasicCode( bFlag );
//STRIP001 	if( aEBasicStgCB.GetSavedValue() != (bFlag = aEBasicStgCB.IsChecked()))
//STRIP001 		pOpt->SetLoadExcelBasicStorage( bFlag );
//STRIP001 
//STRIP001 	if( aPBasicCodeCB.GetSavedValue() != (bFlag = aPBasicCodeCB.IsChecked()))
//STRIP001 		pOpt->SetLoadPPointBasicCode( bFlag );
//STRIP001 	if( aPBasicStgCB.GetSavedValue() != (bFlag = aPBasicStgCB.IsChecked()))
//STRIP001 		pOpt->SetLoadPPointBasicStorage( bFlag );
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------02.09.96 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void OfaMSFilterTabPage::Reset( const SfxItemSet& )
//STRIP001 {
//STRIP001 	const OfaFilterOptions* pOpt = OFF_APP()->GetFilterOptions();
//STRIP001 
//STRIP001 	aWBasicCodeCB.Check( pOpt->IsLoadWordBasicCode() );
//STRIP001 	aWBasicCodeCB.SaveValue();
//STRIP001 	aWBasicStgCB.Check( pOpt->IsLoadWordBasicStorage() );
//STRIP001 	aWBasicStgCB.SaveValue();
//STRIP001 
//STRIP001 	aEBasicCodeCB.Check( pOpt->IsLoadExcelBasicCode() );
//STRIP001 	aEBasicCodeCB.SaveValue();
//STRIP001 	aEBasicStgCB.Check( pOpt->IsLoadExcelBasicStorage() );
//STRIP001 	aEBasicStgCB.SaveValue();
//STRIP001 
//STRIP001 	aPBasicCodeCB.Check( pOpt->IsLoadPPointBasicCode() );
//STRIP001 	aPBasicCodeCB.SaveValue();
//STRIP001 	aPBasicStgCB.Check( pOpt->IsLoadPPointBasicStorage() );
//STRIP001 	aPBasicStgCB.SaveValue();
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------29.06.00 13:22-------------------
//STRIP001  *
//STRIP001  * --------------------------------------------------*/
//STRIP001 OfaMSFilterTabPage2::OfaMSFilterTabPage2( Window* pParent,
//STRIP001 										const SfxItemSet& rSet )
//STRIP001 	: SfxTabPage( pParent, OffResId( RID_OFAPAGE_MSFILTEROPT2 ), rSet ),
//STRIP001 	aCheckLB			( this, ResId( CLB_SETTINGS	)),
//STRIP001 	aHeader1FT			( this, ResId( FT_HEADER1_EXPLANATION )),
//STRIP001 	aHeader2FT          ( this, ResId( FT_HEADER2_EXPLANATION )),
//STRIP001 	sHeader1            ( ResId( ST_HEADER1 )),
//STRIP001 	sHeader2            ( ResId( ST_HEADER2 )),
//STRIP001 	sChgToFromMath		( ResId( ST_CHG_MATH	)),
//STRIP001 	sChgToFromWriter	( ResId( ST_CHG_WRITER )),
//STRIP001 	sChgToFromCalc		( ResId( ST_CHG_CALC )),
//STRIP001 	sChgToFromImpress	( ResId( ST_CHG_IMPRESS )),
//STRIP001 	aChkunBmp			( ResId( CHKBUT_UNCHECKED )),
//STRIP001 	aChkchBmp			( ResId( CHKBUT_CHECKED	)),
//STRIP001 	aChkchhiBmp			( ResId( CHKBUT_HICHECKED )),
//STRIP001 	aChkunhiBmp			( ResId( CHKBUT_HIUNCHECKED )),
//STRIP001 	aChktriBmp			( ResId( CHKBUT_TRISTATE	)),
//STRIP001 	aChktrihiBmp		( ResId( CHKBUT_HITRISTATE )),
//STRIP001 	pCheckButtonData(0)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	static long aStaticTabs[] = { 3, 0, 20, 40 };
//STRIP001 	aCheckLB.SvxSimpleTable::SetTabs( aStaticTabs );
//STRIP001 
//STRIP001 	String sHeader( sHeader1 );
//STRIP001 	(( sHeader += '\t' ) += sHeader2 ) += '\t';
//STRIP001 	aCheckLB.InsertHeaderEntry( sHeader, HEADERBAR_APPEND,
//STRIP001 					HIB_CENTER | HIB_VCENTER | HIB_FIXEDPOS | HIB_FIXED );
//STRIP001 
//STRIP001 	aCheckLB.SetHelpId( HID_OFAPAGE_MSFLTR2_CLB );
//STRIP001 	aCheckLB.SetWindowBits( WB_HSCROLL| WB_VSCROLL );
//STRIP001 }
//STRIP001 
//STRIP001 OfaMSFilterTabPage2::~OfaMSFilterTabPage2()
//STRIP001 {
//STRIP001 	delete pCheckButtonData;
//STRIP001 }
//STRIP001 
//STRIP001 SfxTabPage*	OfaMSFilterTabPage2::Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new OfaMSFilterTabPage2( pParent, rAttrSet );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL OfaMSFilterTabPage2::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	BOOL bModified = FALSE;
//STRIP001 	OfaFilterOptions* pOpt = OFF_APP()->GetFilterOptions();
//STRIP001 
//STRIP001 	static struct ChkCBoxEntries{
//STRIP001 		MSFltrPg2_CheckBoxEntries eType;
//STRIP001 		BOOL (OfaFilterOptions:: *FnIs)() const;
//STRIP001 		void (OfaFilterOptions:: *FnSet)( BOOL bFlag );
//STRIP001 	} aChkArr[] = {
//STRIP001 		{ Math, 	&OfaFilterOptions::IsMathType2Math,
//STRIP001 						&OfaFilterOptions::SetMathType2Math	},
//STRIP001 		{ Math, 	&OfaFilterOptions::IsMath2MathType,
//STRIP001 						&OfaFilterOptions::SetMath2MathType },
//STRIP001 		{ Writer,	&OfaFilterOptions::IsWinWord2Writer,
//STRIP001 						&OfaFilterOptions::SetWinWord2Writer },
//STRIP001 		{ Writer, 	&OfaFilterOptions::IsWriter2WinWord,
//STRIP001 						&OfaFilterOptions::SetWriter2WinWord },
//STRIP001 		{ Calc, 	&OfaFilterOptions::IsExcel2Calc,
//STRIP001 						&OfaFilterOptions::SetExcel2Calc },
//STRIP001 		{ Calc, 	&OfaFilterOptions::IsCalc2Excel,
//STRIP001 						&OfaFilterOptions::SetCalc2Excel },
//STRIP001 		{ Impress, 	&OfaFilterOptions::IsPowerPoint2Impress,
//STRIP001 						&OfaFilterOptions::SetPowerPoint2Impress },
//STRIP001 		{ Impress, 	&OfaFilterOptions::IsImpress2PowerPoint,
//STRIP001 						&OfaFilterOptions::SetImpress2PowerPoint },
//STRIP001 		{ InvalidCBEntry, 0, 0 }
//STRIP001 	};
//STRIP001 
//STRIP001 	BOOL bCheck, bFirst = TRUE;
//STRIP001 	for( const ChkCBoxEntries* pArr = aChkArr;
//STRIP001 			InvalidCBEntry != pArr->eType; ++pArr, bFirst = !bFirst )
//STRIP001 	{
//STRIP001 		USHORT nCol = bFirst ? 1 : 2;
//STRIP001 		SvLBoxEntry* pEntry = aCheckLB.GetEntry( pArr->eType );
//STRIP001 		if( pEntry )
//STRIP001 		{
//STRIP001 			SvLBoxButton* pItem = (SvLBoxButton*)(pEntry->GetItem( nCol ));
//STRIP001 			if( pItem && ((SvLBoxItem*)pItem)->IsA() == SV_ITEM_ID_LBOXBUTTON )
//STRIP001 			{
//STRIP001 				USHORT nButtonFlags = pItem->GetButtonFlags();
//STRIP001 				bCheck = SV_BUTTON_CHECKED ==
//STRIP001 						pCheckButtonData->ConvertToButtonState( nButtonFlags );
//STRIP001 
//STRIP001 				if( bCheck != (pOpt->*pArr->FnIs)() )
//STRIP001 				{
//STRIP001 					bModified = TRUE;
//STRIP001 					(pOpt->*pArr->FnSet)( bCheck );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 void OfaMSFilterTabPage2::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const OfaFilterOptions* pOpt = OFF_APP()->GetFilterOptions();
//STRIP001 
//STRIP001 	aCheckLB.SetUpdateMode(FALSE);
//STRIP001 	aCheckLB.Clear();
//STRIP001 
//STRIP001 	// int the same sequence as the enums of MSFltrPg2_CheckBoxEntries
//STRIP001 	InsertEntry( sChgToFromMath	);
//STRIP001 	InsertEntry( sChgToFromWriter );
//STRIP001 	InsertEntry( sChgToFromCalc	);
//STRIP001 	InsertEntry( sChgToFromImpress	);
//STRIP001 
//STRIP001 	static struct ChkCBoxEntries{
//STRIP001 		MSFltrPg2_CheckBoxEntries eType;
//STRIP001 		BOOL (OfaFilterOptions:: *FnIs)() const;
//STRIP001 	} aChkArr[] = {
//STRIP001 		{ Math, 	&OfaFilterOptions::IsMathType2Math	},
//STRIP001 		{ Math, 	&OfaFilterOptions::IsMath2MathType },
//STRIP001 		{ Writer,	&OfaFilterOptions::IsWinWord2Writer },
//STRIP001 		{ Writer, 	&OfaFilterOptions::IsWriter2WinWord },
//STRIP001 		{ Calc, 	&OfaFilterOptions::IsExcel2Calc },
//STRIP001 		{ Calc, 	&OfaFilterOptions::IsCalc2Excel },
//STRIP001 		{ Impress, 	&OfaFilterOptions::IsPowerPoint2Impress },
//STRIP001 		{ Impress, 	&OfaFilterOptions::IsImpress2PowerPoint },
//STRIP001 		{ InvalidCBEntry, 0 }
//STRIP001 	};
//STRIP001 
//STRIP001 	BOOL bFirst = TRUE;
//STRIP001 	for( const ChkCBoxEntries* pArr = aChkArr;
//STRIP001 			InvalidCBEntry != pArr->eType; ++pArr, bFirst = !bFirst )
//STRIP001 	{
//STRIP001 		USHORT nCol = bFirst ? 1 : 2;
//STRIP001 		SvLBoxEntry* pEntry = aCheckLB.GetEntry( pArr->eType );
//STRIP001 		if( pEntry )
//STRIP001 		{
//STRIP001 			SvLBoxButton* pItem = (SvLBoxButton*)(pEntry->GetItem( nCol ));
//STRIP001 			if( pItem && ((SvLBoxItem*)pItem)->IsA() == SV_ITEM_ID_LBOXBUTTON )
//STRIP001 			{
//STRIP001 				if( (pOpt->*pArr->FnIs)() )
//STRIP001 					pItem->SetStateChecked();
//STRIP001 				else
//STRIP001 					pItem->SetStateUnchecked();
//STRIP001 				aCheckLB.InvalidateEntry( pEntry );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	aCheckLB.SetUpdateMode( TRUE );
//STRIP001 }
//STRIP001 
//STRIP001 void OfaMSFilterTabPage2::InsertEntry( const String& rTxt )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = new SvLBoxEntry;
//STRIP001 
//STRIP001 	if( !pCheckButtonData )
//STRIP001 		pCheckButtonData = new SvLBoxButtonData( &aCheckLB );
//STRIP001 
//STRIP001 	pEntry->AddItem( new SvLBoxContextBmp( pEntry, 0, Image(), Image(), 0));
//STRIP001 	pEntry->AddItem( new SvLBoxButton( pEntry, 0, pCheckButtonData ) );
//STRIP001 	pEntry->AddItem( new SvLBoxButton( pEntry, 0, pCheckButtonData ) );
//STRIP001 	pEntry->AddItem( new SvLBoxString( pEntry, 0, rTxt ) );
//STRIP001 
//STRIP001 	aCheckLB.GetModel()->Insert( pEntry );
//STRIP001 }
//STRIP001 
//STRIP001 void OfaMSFilterTabPage2::MSFltrSimpleTable::SetTabs()
//STRIP001 {
//STRIP001 	SvxSimpleTable::SetTabs();
//STRIP001 	USHORT nAdjust = SV_LBOXTAB_ADJUST_RIGHT|SV_LBOXTAB_ADJUST_LEFT|SV_LBOXTAB_ADJUST_CENTER|SV_LBOXTAB_ADJUST_NUMERIC|SV_LBOXTAB_FORCE;
//STRIP001 
//STRIP001 	if( aTabs.Count() > 1 )
//STRIP001 	{
//STRIP001 		SvLBoxTab* pTab = (SvLBoxTab*)aTabs.GetObject(1);
//STRIP001 		pTab->nFlags &= ~nAdjust;
//STRIP001 		pTab->nFlags |= SV_LBOXTAB_PUSHABLE|SV_LBOXTAB_ADJUST_CENTER|SV_LBOXTAB_FORCE;
//STRIP001 	}
//STRIP001 	if( aTabs.Count() > 2 )
//STRIP001 	{
//STRIP001 		SvLBoxTab* pTab = (SvLBoxTab*)aTabs.GetObject(2);
//STRIP001 		pTab->nFlags &= ~nAdjust;
//STRIP001 		pTab->nFlags |= SV_LBOXTAB_PUSHABLE|SV_LBOXTAB_ADJUST_CENTER|SV_LBOXTAB_FORCE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void OfaMSFilterTabPage2::MSFltrSimpleTable::HBarClick()
//STRIP001 {
//STRIP001 	// Sortierung durch diese Ueberladung abgeklemmt
//STRIP001 }
//STRIP001 /* -----------------------------2002/06/20 11:51------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void OfaMSFilterTabPage2::MSFltrSimpleTable::SetCheckButtonState(
//STRIP001                             SvLBoxEntry* pEntry, USHORT nCol, SvButtonState eState)
//STRIP001 {
//STRIP001 	SvLBoxButton* pItem = (SvLBoxButton*)(pEntry->GetItem(nCol + 1));
//STRIP001 
//STRIP001 	DBG_ASSERT(pItem,"SetCheckButton:Item not found")
//STRIP001 	if (((SvLBoxItem*)pItem)->IsA() == SV_ITEM_ID_LBOXBUTTON)
//STRIP001 	{
//STRIP001 		switch( eState )
//STRIP001 		{
//STRIP001 			case SV_BUTTON_CHECKED:
//STRIP001 				pItem->SetStateChecked();
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SV_BUTTON_UNCHECKED:
//STRIP001 				pItem->SetStateUnchecked();
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SV_BUTTON_TRISTATE:
//STRIP001 				pItem->SetStateTristate();
//STRIP001 				break;
//STRIP001 		}
//STRIP001 		InvalidateEntry( pEntry );
//STRIP001 	}
//STRIP001 }
//STRIP001 /* -----------------------------2002/06/20 11:56------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 SvButtonState OfaMSFilterTabPage2::MSFltrSimpleTable::GetCheckButtonState(
//STRIP001                                     SvLBoxEntry* pEntry, USHORT nCol ) const
//STRIP001 {
//STRIP001 	SvButtonState eState = SV_BUTTON_UNCHECKED;
//STRIP001 	SvLBoxButton* pItem = (SvLBoxButton*)(pEntry->GetItem(nCol + 1));
//STRIP001 	DBG_ASSERT(pItem,"GetChButnState:Item not found")
//STRIP001 
//STRIP001 	if (((SvLBoxItem*)pItem)->IsA() == SV_ITEM_ID_LBOXBUTTON)
//STRIP001 	{
//STRIP001 		USHORT nButtonFlags = pItem->GetButtonFlags();
//STRIP001 		eState = pCheckButtonData->ConvertToButtonState( nButtonFlags );
//STRIP001 	}
//STRIP001 
//STRIP001 	return eState;
//STRIP001 }
//STRIP001 /* -----------------------------2002/06/20 11:57------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void OfaMSFilterTabPage2::MSFltrSimpleTable::CheckEntryPos(ULONG nPos, USHORT nCol, BOOL bChecked)
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		SetCheckButtonState(
//STRIP001 			GetEntry(nPos),
//STRIP001 			nCol,
//STRIP001 			bChecked ? SvButtonState( SV_BUTTON_CHECKED ) :
//STRIP001 									   SvButtonState( SV_BUTTON_UNCHECKED ) );
//STRIP001 }
//STRIP001 /* -----------------------------2002/06/20 11:51------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void OfaMSFilterTabPage2::MSFltrSimpleTable::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001     if(!rKEvt.GetKeyCode().GetModifier() &&
//STRIP001         KEY_SPACE == rKEvt.GetKeyCode().GetCode())
//STRIP001     {
//STRIP001         ULONG nSelPos = GetModel()->GetAbsPos(GetCurEntry());
//STRIP001         USHORT nCheck = GetCheckButtonState( GetEntry(nSelPos), 1 ) == SV_BUTTON_CHECKED ? 1 : 0;
//STRIP001         if(GetCheckButtonState( GetEntry(nSelPos), 0 ))
//STRIP001             nCheck += 2;
//STRIP001         nCheck--;
//STRIP001         nCheck &= 3;
//STRIP001         CheckEntryPos(nSelPos, 1, 0 != (nCheck & 1));
//STRIP001         CheckEntryPos(nSelPos, 0, 0 != (nCheck & 2));
//STRIP001     }
//STRIP001     else
//STRIP001         SvxSimpleTable::KeyInput(rKEvt);
//STRIP001 }

}
