/*************************************************************************
 *
 *  $RCSfile: sctictac.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:26:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_SCTICTAC_HXX
#define SC_SCTICTAC_HXX
namespace binfilter {

//STRIP001 //#define TICTACTOE_MAIN
//STRIP001 #ifdef TICTACTOE_MAIN
//STRIP001 #define TICTACTOE_STDOUT
//STRIP001 #else
//STRIP001 //#define TICTACTOE_STDOUT
//STRIP001 #endif
//STRIP001 #ifndef TICTACTOE_STDOUT
//STRIP001 #define TICTACTOE_SC
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifdef TICTACTOE_SC
//STRIP001 class ScDocument;
//STRIP001 #include "global.hxx"
//STRIP001 #else
//STRIP001 #include <tools/string.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 static const int ScTicTacToe_Squares = 9;
//STRIP001 static const int ScTicTacToe_Possible_Wins = 8;
//STRIP001 typedef sal_Unicode Square_Type;
//STRIP001 typedef Square_Type Board_Type[ScTicTacToe_Squares];
//STRIP001 
//STRIP001 class ScTicTacToe
//STRIP001 {
//STRIP001 private:
//STRIP001 	/* Structure to hold a move and its heuristic */
//STRIP001 	typedef struct {
//STRIP001 		int Square;
//STRIP001 		int Heuristic;
//STRIP001 	} Move_Heuristic_Type;
//STRIP001 
//STRIP001 	static	const Square_Type	Empty;
//STRIP001 	static	const Square_Type	Human;
//STRIP001 	static	const Square_Type	Compi;
//STRIP001 	static	const int		Infinity;		/* Higher value than any score */
//STRIP001 	static	const int		Maximum_Moves;	/* Maximum moves in a game */
//STRIP001 
//STRIP001 			Board_Type		Board;
//STRIP001 #ifdef TICTACTOE_SC
//STRIP001 			ScAddress		aPos;			// linke obere Ecke des Boards
//STRIP001 			ScDocument*		pDoc;
//STRIP001 #endif
//STRIP001 			ByteString		aStdOut;
//STRIP001 			int				Total_Nodes;	/* Nodes searched with minimax */
//STRIP001 			int				nMove;
//STRIP001 			Square_Type		aPlayer;
//STRIP001 			BOOL			bInitialized;
//STRIP001 
//STRIP001 	/* Array describing the eight combinations of three squares in a row */
//STRIP001 	static	const int		Three_in_a_Row[ScTicTacToe_Possible_Wins][3];
//STRIP001 
//STRIP001 	/* Array used in heuristic formula for each move. */
//STRIP001 	static	const int		Heuristic_Array[4][4];
//STRIP001 
//STRIP001 
//STRIP001 			Square_Type		Winner();
//STRIP001 	inline	Square_Type		Other( Square_Type Player );
//STRIP001 	inline	void			Play( int Square, Square_Type Player );
//STRIP001 			int				Evaluate( Square_Type Player );
//STRIP001 			int				BestMove( Square_Type Player, int *Square,
//STRIP001 									int Move_Nbr, int Alpha, int Beta );
//STRIP001 			void			Describe( int Score );
//STRIP001 			void			Move( int& Square );
//STRIP001 			Square_Type 	TryMove( int& Square );		// return Winner()
//STRIP001 			void			PromptHuman();
//STRIP001 #ifdef TICTACTOE_SC
//STRIP001 			// -1 == Fehler/Redraw, 0 == keine Aenderung, >0 == UserMoveSquare+1
//STRIP001 			int				GetStatus();
//STRIP001 			void			DrawBoard();
//STRIP001 			void			DrawPos( int nSquare, const String& rStr );
//STRIP001 #endif
//STRIP001 #ifdef TICTACTOE_STDOUT
//STRIP001 			void			Print();
//STRIP001 #endif
//STRIP001 
//STRIP001 							ScTicTacToe( const ScTicTacToe& );
//STRIP001 			ScTicTacToe&	operator=( const ScTicTacToe& );
//STRIP001 
//STRIP001 public:
//STRIP001 #ifdef TICTACTOE_SC
//STRIP001 							ScTicTacToe( ScDocument* pDoc, const ScAddress& );
//STRIP001 #else
//STRIP001 							ScTicTacToe();
//STRIP001 #endif
//STRIP001 							~ScTicTacToe() {}
//STRIP001 			void			Initialize( BOOL bHumanFirst );
//STRIP001 			Square_Type		GetEmpty() { return Empty; }
//STRIP001 #ifdef TICTACTOE_SC
//STRIP001 			Square_Type		CalcMove();		// return Winner()
//STRIP001 #endif
//STRIP001 #ifdef TICTACTOE_STDOUT
//STRIP001 			void			Game();
//STRIP001 			void			GetOutput( ByteString& rStr );
//STRIP001 #else
//STRIP001 			void			GetOutput( String& rStr );
//STRIP001 #endif
//STRIP001 };

} //namespace binfilter
#endif

