/*************************************************************************
 *
 *  $RCSfile: sc_csvsplits.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:40:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif
#pragma hdrstop

// ============================================================================

// auto strip #ifndef _SC_CSVSPLITS_HXX
// auto strip #include "csvsplits.hxx"
// auto strip #endif

// auto strip #ifndef _TOOLS_DEBUG_HXX
// auto strip #include <tools/debug.hxx>
// auto strip #endif

#include <algorithm>
namespace binfilter {


// ============================================================================

//STRIP001 bool ScCsvSplits::Insert( sal_Int32 nPos )
//STRIP001 {
//STRIP001     bool bValid = (nPos >= 0);
//STRIP001     if( bValid )
//STRIP001     {
//STRIP001         iterator aIter = ::std::lower_bound( maVec.begin(), maVec.end(), nPos );
//STRIP001         bValid = (aIter == maVec.end()) || (*aIter != nPos);
//STRIP001         if( bValid )
//STRIP001             aIter = maVec.insert( aIter, nPos );
//STRIP001     }
//STRIP001     return bValid;
//STRIP001 }

//STRIP001 bool ScCsvSplits::Remove( sal_Int32 nPos )
//STRIP001 {
//STRIP001     sal_uInt32 nIndex = GetIndex( nPos );
//STRIP001     bool bValid = (nIndex != CSV_VEC_NOTFOUND);
//STRIP001     if( bValid )
//STRIP001         maVec.erase( maVec.begin() + nIndex );
//STRIP001     return bValid;
//STRIP001 }

//STRIP001 void ScCsvSplits::RemoveRange( sal_Int32 nPosStart, sal_Int32 nPosEnd )
//STRIP001 {
//STRIP001     sal_uInt32 nStartIx = LowerBound( nPosStart );
//STRIP001     sal_uInt32 nEndIx = UpperBound( nPosEnd );
//STRIP001     if( (nStartIx != CSV_VEC_NOTFOUND) && (nEndIx != CSV_VEC_NOTFOUND) && (nStartIx <= nEndIx) )
//STRIP001         maVec.erase( maVec.begin() + nStartIx, maVec.begin() + nEndIx + 1 );
//STRIP001 }

//STRIP001 void ScCsvSplits::Clear()
//STRIP001 {
//STRIP001     maVec.clear();
//STRIP001 }

//STRIP001 bool ScCsvSplits::HasSplit( sal_Int32 nPos ) const
//STRIP001 {
//STRIP001     return GetIndex( nPos ) != CSV_VEC_NOTFOUND;
//STRIP001 }


// ----------------------------------------------------------------------------

//STRIP001 sal_uInt32 ScCsvSplits::GetIndex( sal_Int32 nPos ) const
//STRIP001 {
//STRIP001     const_iterator aIter = ::std::lower_bound( maVec.begin(), maVec.end(), nPos );
//STRIP001     return GetIterIndex( ((aIter != maVec.end()) && (*aIter == nPos)) ? aIter : maVec.end() );
//STRIP001 }

//STRIP001 sal_uInt32 ScCsvSplits::LowerBound( sal_Int32 nPos ) const
//STRIP001 {
//STRIP001     return GetIterIndex( ::std::lower_bound( maVec.begin(), maVec.end(), nPos ) );
//STRIP001 }

//STRIP001 sal_uInt32 ScCsvSplits::UpperBound( sal_Int32 nPos ) const
//STRIP001 {
//STRIP001     sal_uInt32 nIndex = LowerBound( nPos );
//STRIP001     if( nIndex == CSV_VEC_NOTFOUND )
//STRIP001         return Count() ? (Count() - 1) : CSV_VEC_NOTFOUND;
//STRIP001     if( GetPos( nIndex ) == nPos )
//STRIP001         return nIndex;
//STRIP001     return nIndex ? (nIndex - 1) : CSV_VEC_NOTFOUND;
//STRIP001 }

//STRIP001 sal_Int32 ScCsvSplits::GetPos( sal_uInt32 nIndex ) const
//STRIP001 {
//STRIP001     return (nIndex < Count()) ? maVec[ nIndex ] : CSV_POS_INVALID;
//STRIP001 }


// ----------------------------------------------------------------------------

//STRIP001 sal_uInt32 ScCsvSplits::GetIterIndex( const_iterator aIter ) const
//STRIP001 {
//STRIP001     return (aIter == maVec.end()) ? CSV_VEC_NOTFOUND : (aIter - maVec.begin());
//STRIP001 }


// ============================================================================

}
