/*************************************************************************
 *
 *  $RCSfile: sc_drawsh.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:50:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif


#pragma hdrstop

//------------------------------------------------------------------

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX

//SV
//#define _CLIP_HXX ***
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX ***
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX ***
//#define _TOOLBOX_HXX
//#define _STATUS_HXX ***
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
//#define _FILDLG_HXX ***
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX ***
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX

#if defined  WIN
#define _MENUBTN_HXX
#endif

//svtools
#define _SCRWIN_HXX
#define _RULER_HXX
//#define _TABBAR_HXX
//#define _VALUESET_HXX
#define _STDMENU_HXX
//#define _STDCTRL_HXX
//#define _CTRLBOX_HXX
#define _CTRLTOOL_HXX
#define _EXTATTR_HXX
#define _FRM3D_HXX
#define _EXTATTR_HXX

//SVTOOLS
//#define _SVTREELIST_HXX
#define _FILTER_HXX
//#define _SVLBOXITM_HXX
//#define _SVTREEBOX_HXX
#define _SVICNVW_HXX
#define _SVTABBX_HXX

//sfxcore.hxx
//#define _SFXINIMGR_HXX
//#define _SFXCFGITEM_HXX
//#define _SFX_PRINTER_HXX
#define _SFXGENLINK_HXX
#define _SFXHINTPOST_HXX
#define _SFXDOCINF_HXX
#define _SFXLINKHDL_HXX
//#define _SFX_PROGRESS_HXX

//sfxsh.hxx
//#define _SFX_SHELL_HXX
//#define _SFXAPP_HXX
//#define _SFXDISPATCH_HXX
//#define _SFXMSG_HXX
//#define _SFXOBJFACE_HXX
//#define _SFXREQUEST_HXX
#define _SFXMACRO_HXX

// SFX
//#define _SFXAPPWIN_HXX
#define _SFX_SAVEOPT_HXX
//#define _SFX_CHILDWIN_HXX
//#define _SFXCTRLITEM_HXX
#define _SFXPRNMON_HXX
#define _INTRO_HXX
#define _SFXMSGDESCR_HXX
#define _SFXMSGPOOL_HXX
#define _SFXFILEDLG_HXX
#define _PASSWD_HXX
//#define _SFXTBXCTRL_HXX ***
#define _SFXSTBITEM_HXX
#define _SFXMNUITEM_HXX
#define _SFXIMGMGR_HXX
#define _SFXTBXMGR_HXX
#define _SFXSTBMGR_HXX
#define _SFX_MINFITEM_HXX
#define _SFXEVENT_HXX

//sfxdoc.hxx
//#define _SFX_OBJSH_HXX
//#define _SFX_CLIENTSH_HXX
//#define _SFXDOCINF_HXX
//#define _SFX_OBJFAC_HXX
#define _SFX_DOCFILT_HXX
//#define _SFXDOCFILE_HXX
//define _VIEWFAC_HXX
//#define _SFXVIEWFRM_HXX
//#define _SFXVIEWSH_HXX
//#define _MDIFRM_HXX
#define _SFX_IPFRM_HXX
//#define _SFX_INTERNO_HXX

//sfxdlg.hxx
//#define _SFXTABDLG_HXX
//#define _BASEDLGS_HXX
#define _SFX_DINFDLG_HXX
#define _SFXDINFEDT_HXX
#define _SFX_MGETEMPL_HXX
#define _SFX_TPLPITEM_HXX
//#define _SFX_STYLEDLG_HXX
#define _NEWSTYLE_HXX
//#define _SFXDOCTEMPL_HXX
//#define _SFXDOCTDLG_HXX
//#define _SFX_TEMPLDLG_HXX
//#define _SFXNEW_HXX
#define _SFXDOCMAN_HXX
//#define _SFXDOCKWIN_HXX ***

//sfxitems.hxx
#define _SFX_WHMAP_HXX
#define _ARGS_HXX
//#define _SFXPOOLITEM_HXX
//#define _SFXINTITEM_HXX
//#define _SFXENUMITEM_HXX
#define _SFXFLAGITEM_HXX
//#define _SFXSTRITEM_HXX
#define _SFXPTITEM_HXX
#define _SFXRECTITEM_HXX
//#define _SFXITEMPOOL_HXX
//#define _SFXITEMSET_HXX
#define _SFXITEMITER_HXX
//#define _SFX_WHITER_HXX ***
#define _SFXPOOLCACH_HXX
//#define _AEITEM_HXX
#define _SFXRNGITEM_HXX
//#define _SFXSLSTITM_HXX
//#define _SFXSTYLE_HXX

//xout.hxx
//#define _XENUM_HXX
//#define _XPOLY_HXX
//#define _XATTR_HXX
//#define _XOUTX_HXX
//#define _XPOOL_HXX
//#define _XTABLE_HXX

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS

//#define SI_NOITEMS
//#define SI_NODRW
#define _SI_NOSBXCONTROLS
//#define _VCATTR_HXX
#define _VCONT_HXX
//#define _VCSBX_HXX
#define _SI_NOOTHERFORMS
#define _VCTRLS_HXX
//#define _VCDRWOBJ_HXX
#define _SI_NOCONTROL
#define _SETBRW_HXX
#define _VCBRW_HXX
#define _SI_NOSBXCONTROLS
//#define _SIDLL_HXX

//------------------------------------------------------------------

// auto strip #include <bf_svx/eeitem.hxx>
#include <bf_svx/fontwork.hxx>
// auto strip #include <bf_svx/labdlg.hxx>
// auto strip #include <bf_svx/srchitem.hxx>
#include <bf_svx/tabarea.hxx>
// auto strip #include <bf_svx/tabline.hxx>
// auto strip #include <bf_svx/textanim.hxx>
// auto strip #include <bf_svx/transfrm.hxx>
#include <bf_sfx2/app.hxx>
#include <bf_sfx2/objface.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <svtools/whiter.hxx>
// auto strip #include <vcl/msgbox.hxx>

#include "drawsh.hxx"
// auto strip #include "drwlayer.hxx"
#include "bf_sc.hrc"
// auto strip #include "viewdata.hxx"
// auto strip #include "document.hxx"
// auto strip #include "docpool.hxx"
// auto strip #include "drawview.hxx"
#include "scresid.hxx"

// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
namespace binfilter {
#define ScDrawShell
#include "scslots.hxx"

//------------------------------------------------------------------

TYPEINIT1( ScDrawShell, SfxShell );

/*N*/ SFX_IMPL_INTERFACE(ScDrawShell, SfxShell, ScResId(SCSTR_DRAWSHELL) )
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT|SFX_VISIBILITY_STANDARD|SFX_VISIBILITY_SERVER,
/*N*/ 								ScResId(RID_DRAW_OBJECTBAR) );
/*N*/ 	SFX_POPUPMENU_REGISTRATION( ScResId(RID_POPUP_DRAW) );
/*N*/ 	SFX_OBJECTMENU_REGISTRATION( SID_OBJECTMENU0, ScResId(RID_OBJECTMENU_DRAW) );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxFontWorkChildWindow::GetChildWindowId() );
/*N*/ }


// abschalten der nicht erwuenschten Acceleratoren:

//STRIP001 void ScDrawShell::StateDisableItems( SfxItemSet &rSet )
//STRIP001 {
//STRIP001 	SfxWhichIter aIter(rSet);
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 
//STRIP001 	while (nWhich)
//STRIP001 	{
//STRIP001 		rSet.DisableItem( nWhich );
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }


//STRIP001 void ScDrawShell::ExecDrawAttr( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	USHORT				nSlot		= rReq.GetSlot();
//STRIP001 	Window* 			pWin		= pViewData->GetActiveWin();
//STRIP001 	Window* 			pDlgParent	= pViewData->GetDialogParent();
//STRIP001 //	SfxViewFrame*		pViewFrame	= SfxViewShell::Current()->GetViewFrame(); //!!! koennte knallen
//STRIP001 	ScDrawView* 		pView		= pViewData->GetScDrawView();
//STRIP001 	SdrModel*			pDoc		= pViewData->GetDocument()->GetDrawLayer();
//STRIP001 
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case SID_TEXT_STANDARD:	// Harte Textattributierung loeschen
//STRIP001 			{
//STRIP001 				SfxItemSet aEmptyAttr(GetPool(), EE_ITEMS_START, EE_ITEMS_END);
//STRIP001 				pView->SetAttributes(aEmptyAttr, TRUE);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ATTR_LINE_STYLE:
//STRIP001 		case SID_ATTR_LINEEND_STYLE:
//STRIP001 		case SID_ATTR_LINE_DASH:
//STRIP001 		case SID_ATTR_LINE_WIDTH:
//STRIP001 		case SID_ATTR_LINE_COLOR:
//STRIP001 		case SID_ATTR_FILL_STYLE:
//STRIP001 		case SID_ATTR_FILL_COLOR:
//STRIP001 		case SID_ATTR_FILL_GRADIENT:
//STRIP001 		case SID_ATTR_FILL_HATCH:
//STRIP001 		case SID_ATTR_FILL_BITMAP:
//STRIP001 			{
//STRIP001 				// Wenn ToolBar vertikal :
//STRIP001 				if ( !rReq.GetArgs() )
//STRIP001 				{
//STRIP001 					switch ( nSlot )
//STRIP001 					{
//STRIP001 						case SID_ATTR_LINE_STYLE:
//STRIP001 						case SID_ATTR_LINE_DASH:
//STRIP001 						case SID_ATTR_LINE_WIDTH:
//STRIP001 						case SID_ATTR_LINE_COLOR:
//STRIP001 							ExecuteLineDlg( rReq );
//STRIP001 							break;
//STRIP001 
//STRIP001 						case SID_ATTR_FILL_STYLE:
//STRIP001 						case SID_ATTR_FILL_COLOR:
//STRIP001 						case SID_ATTR_FILL_GRADIENT:
//STRIP001 						case SID_ATTR_FILL_HATCH:
//STRIP001 						case SID_ATTR_FILL_BITMAP:
//STRIP001 							ExecuteAreaDlg( rReq );
//STRIP001 							break;
//STRIP001 
//STRIP001 						default:
//STRIP001 							break;
//STRIP001 					}
//STRIP001 
//STRIP001 					//=====
//STRIP001 					return;
//STRIP001 					//=====
//STRIP001 				}
//STRIP001 
//STRIP001 				if( pView->HasMarkedObj() )
//STRIP001 					pView->SetAttrToMarked( *rReq.GetArgs(), FALSE );
//STRIP001 				else
//STRIP001 					pView->SetDefaultAttr( *rReq.GetArgs(), FALSE);
//STRIP001 				pView->InvalidateAttribs();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ATTRIBUTES_LINE:
//STRIP001 			ExecuteLineDlg( rReq );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ATTRIBUTES_AREA:
//STRIP001 			ExecuteAreaDlg( rReq );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DRAWTEXT_ATTR_DLG:
//STRIP001 			ExecuteTextAttrDlg( rReq );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ATTR_TRANSFORM:
//STRIP001 			{
//STRIP001 				if ( pView->HasMarkedObj() )
//STRIP001 				{
//STRIP001 					const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 					if( !pArgs )
//STRIP001 					{
//STRIP001 						const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 						if( rMarkList.GetMark(0) != 0 )
//STRIP001 						{
//STRIP001 							SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 							if( pObj->GetObjIdentifier() == OBJ_CAPTION )
//STRIP001 							{
//STRIP001 								// --------- Itemset fuer Caption --------
//STRIP001 								SfxItemSet aNewAttr(pDoc->GetItemPool());
//STRIP001 								pView->GetAttributes(aNewAttr);
//STRIP001 								// --------- Itemset fuer Groesse und Position --------
//STRIP001 								SfxItemSet aNewGeoAttr(pView->GetGeoAttrFromMarked());
//STRIP001 
//STRIP001 								SvxCaptionTabDialog* pDlg = new SvxCaptionTabDialog(pWin, pView);
//STRIP001 
//STRIP001 								const USHORT* pRange = pDlg->GetInputRanges( *aNewAttr.GetPool() );
//STRIP001 								SfxItemSet aCombSet( *aNewAttr.GetPool(), pRange );
//STRIP001 								aCombSet.Put( aNewAttr );
//STRIP001 								aCombSet.Put( aNewGeoAttr );
//STRIP001 								pDlg->SetInputSet( &aCombSet );
//STRIP001 
//STRIP001 								if (pDlg->Execute() == RET_OK)
//STRIP001 								{
//STRIP001 									rReq.Done(*(pDlg->GetOutputItemSet()));
//STRIP001 									pView->SetAttributes(*pDlg->GetOutputItemSet());
//STRIP001 									pView->SetGeoAttrToMarked(*pDlg->GetOutputItemSet());
//STRIP001 								}
//STRIP001 
//STRIP001 								delete pDlg;
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								SfxItemSet aNewAttr(pView->GetGeoAttrFromMarked());
//STRIP001 								SvxTransformTabDialog* pDlg = new SvxTransformTabDialog(pWin, &aNewAttr, pView);
//STRIP001 
//STRIP001 								if (pDlg->Execute() == RET_OK)
//STRIP001 								{
//STRIP001 									rReq.Done(*(pDlg->GetOutputItemSet()));
//STRIP001 									pView->SetGeoAttrToMarked(*pDlg->GetOutputItemSet());
//STRIP001 								}
//STRIP001 								delete pDlg;
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 
//STRIP001 					}
//STRIP001 					else
//STRIP001 						pView->SetGeoAttrToMarked( *pArgs );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScDrawShell::ExecuteLineDlg( SfxRequest& rReq, USHORT nTabPage )
//STRIP001 {
//STRIP001 	ScDrawView*			pView		= pViewData->GetScDrawView();
//STRIP001 	BOOL 				bHasMarked	= pView->HasMarkedObj();
//STRIP001 	const SdrObject* 	pObj		= NULL;
//STRIP001 	const SdrMarkList&	rMarkList	= pView->GetMarkList();
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 		pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 
//STRIP001 	SfxItemSet	aNewAttr( pView->GetDefaultAttr() );
//STRIP001 	if( bHasMarked )
//STRIP001 		pView->MergeAttrFromMarked( aNewAttr, FALSE );
//STRIP001 
//STRIP001 	SvxLineTabDialog* pDlg
//STRIP001 		= new SvxLineTabDialog( pViewData->GetDialogParent(),
//STRIP001 								&aNewAttr,
//STRIP001 								pViewData->GetDocument()->GetDrawLayer(),
//STRIP001 								pObj,
//STRIP001 								bHasMarked );
//STRIP001 
//STRIP001 	if ( nTabPage != 0xffff )
//STRIP001 		pDlg->SetCurPageId( nTabPage );
//STRIP001 
//STRIP001 	if ( pDlg->Execute() == RET_OK )
//STRIP001 	{
//STRIP001 		if( bHasMarked )
//STRIP001 			pView->SetAttrToMarked( *pDlg->GetOutputItemSet(), FALSE );
//STRIP001 		else
//STRIP001 			pView->SetDefaultAttr( *pDlg->GetOutputItemSet(), FALSE );
//STRIP001 
//STRIP001 		pView->InvalidateAttribs();
//STRIP001 		rReq.Done();
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pDlg;
//STRIP001 }

//STRIP001 void ScDrawShell::ExecuteAreaDlg( SfxRequest& rReq, USHORT nTabPage )
//STRIP001 {
//STRIP001 	ScDrawView*	pView		= pViewData->GetScDrawView();
//STRIP001 	BOOL		bHasMarked	= pView->HasMarkedObj();
//STRIP001 
//STRIP001 	SfxItemSet	aNewAttr( pView->GetDefaultAttr() );
//STRIP001 	if( bHasMarked )
//STRIP001 		pView->MergeAttrFromMarked( aNewAttr, FALSE );
//STRIP001 
//STRIP001 	SvxAreaTabDialog* pDlg
//STRIP001 		= new SvxAreaTabDialog( pViewData->GetDialogParent(),
//STRIP001 								&aNewAttr,
//STRIP001 								pViewData->GetDocument()->GetDrawLayer(),
//STRIP001 								pView );
//STRIP001 
//STRIP001 	if ( nTabPage != 0xffff )
//STRIP001 		pDlg->SetCurPageId( nTabPage );
//STRIP001 
//STRIP001 	if ( pDlg->Execute() == RET_OK )
//STRIP001 	{
//STRIP001 		if( bHasMarked )
//STRIP001 			pView->SetAttrToMarked( *pDlg->GetOutputItemSet(), FALSE );
//STRIP001 		else
//STRIP001 			pView->SetDefaultAttr( *pDlg->GetOutputItemSet(), FALSE );
//STRIP001 
//STRIP001 		pView->InvalidateAttribs();
//STRIP001 		rReq.Done();
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pDlg;
//STRIP001 }

//STRIP001 void ScDrawShell::ExecuteTextAttrDlg( SfxRequest& rReq, USHORT nTabPage )
//STRIP001 {
//STRIP001 	ScDrawView*	pView		= pViewData->GetScDrawView();
//STRIP001 	BOOL		bHasMarked	= pView->HasMarkedObj();
//STRIP001 	SfxItemSet	aNewAttr	( pView->GetDefaultAttr() );
//STRIP001 
//STRIP001 	if( bHasMarked )
//STRIP001 		pView->MergeAttrFromMarked( aNewAttr, FALSE );
//STRIP001 
//STRIP001 	SvxTextTabDialog* pDlg =
//STRIP001 		new SvxTextTabDialog( pViewData->GetDialogParent(), &aNewAttr , pView);
//STRIP001 
//STRIP001 	USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 	if ( RET_OK == nResult )
//STRIP001 	{
//STRIP001 		if ( bHasMarked )
//STRIP001 			pView->SetAttributes( *pDlg->GetOutputItemSet() );
//STRIP001 		else
//STRIP001 			pView->SetDefaultAttr( *pDlg->GetOutputItemSet(), FALSE );
//STRIP001 
//STRIP001 		rReq.Done();
//STRIP001 	}
//STRIP001 	delete( pDlg );
//STRIP001 }


}
