/*************************************************************************
 *
 *  $RCSfile: sc_fusel2.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:54:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/svditer.hxx>
// auto strip #include <bf_svx/svdocapt.hxx>
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #include <bf_svx/outliner.hxx>

// auto strip #include "fusel.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "document.hxx"
// auto strip #include "detfunc.hxx"
// auto strip #include "futext.hxx"
#include "bf_sc.hrc"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 inline long Diff( const Point& rP1, const Point& rP2 )
//STRIP001 {
//STRIP001 	long nX = rP1.X() - rP2.X();
//STRIP001 	if (nX<0) nX = -nX;
//STRIP001 	long nY = rP1.Y() - rP2.Y();
//STRIP001 	if (nY<0) nY = -nY;
//STRIP001 	return nX+nY;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL FuSelection::TestDetective( SdrPageView* pPV, const Point& rPos )
//STRIP001 {
//STRIP001 	if (!pPV)
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 	SdrObjListIter aIter( *pPV->GetObjList(), IM_FLAT );
//STRIP001 	SdrObject* pObject = aIter.Next();
//STRIP001 	while (pObject && !bFound)
//STRIP001 	{
//STRIP001 		if (ScDetectiveFunc::IsNonAlienArrow( pObject ))
//STRIP001 		{
//STRIP001 			USHORT nHitLog = (USHORT) pWindow->PixelToLogic(
//STRIP001 								Size(pView->GetHitTolerancePixel(),0)).Width();
//STRIP001 			if ( pObject->IsHit( rPos, nHitLog ) )
//STRIP001 			{
//STRIP001 				ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001 				ScSplitPos ePos = pViewShell->FindWindow( pWindow );
//STRIP001 				Point aLineStart = pObject->GetPoint(0);
//STRIP001 				Point aLineEnd   = pObject->GetPoint(1);
//STRIP001 				Point aPixel = pWindow->LogicToPixel( aLineStart );
//STRIP001 				short nStartCol;
//STRIP001 				short nStartRow;
//STRIP001 				pViewData->GetPosFromPixel( aPixel.X(), aPixel.Y(), ePos, nStartCol, nStartRow );
//STRIP001 				aPixel = pWindow->LogicToPixel( aLineEnd );
//STRIP001 				short nEndCol;
//STRIP001 				short nEndRow;
//STRIP001 				pViewData->GetPosFromPixel( aPixel.X(), aPixel.Y(), ePos, nEndCol, nEndRow );
//STRIP001 				short nCurX = (short) pViewData->GetCurX();
//STRIP001 				short nCurY = (short) pViewData->GetCurY();
//STRIP001 				BOOL bStart = ( Diff( rPos,aLineStart ) > Diff( rPos,aLineEnd ) );
//STRIP001 				if ( nCurX == nStartCol && nCurY == nStartRow )
//STRIP001 					bStart = FALSE;
//STRIP001 				else if ( nCurX == nEndCol && nCurY == nEndRow )
//STRIP001 					bStart = TRUE;
//STRIP001 
//STRIP001 				short nDifX;
//STRIP001 				short nDifY;
//STRIP001 				if ( bStart )
//STRIP001 				{
//STRIP001 					nDifX = nStartCol - nCurX;
//STRIP001 					nDifY = nStartRow - nCurY;
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					nDifX = nEndCol - nCurX;
//STRIP001 					nDifY = nEndRow - nCurY;
//STRIP001 				}
//STRIP001 				pViewShell->MoveCursorRel( nDifX, nDifY, SC_FOLLOW_JUMP, FALSE );
//STRIP001 
//STRIP001 				bFound = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		pObject = aIter.Next();
//STRIP001 	}
//STRIP001 	return bFound;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL FuSelection::TestComment( SdrPageView* pPV, const Point& rPos )
//STRIP001 {
//STRIP001 	if (!pPV)
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SdrObject* pFoundObj = NULL;
//STRIP001 
//STRIP001 	SdrObjListIter aIter( *pPV->GetObjList(), IM_FLAT );
//STRIP001 	SdrObject* pObject = aIter.Next();
//STRIP001 	while (pObject)
//STRIP001 	{
//STRIP001 		if ( pObject->GetLayer()==SC_LAYER_INTERN && pObject->ISA(SdrCaptionObj)
//STRIP001 			&& pObject->GetLogicRect().IsInside( rPos ) )
//STRIP001 		{
//STRIP001 			pFoundObj = pObject;
//STRIP001 			// keep searching - use the last matching object (on top)
//STRIP001 		}
//STRIP001 		pObject = aIter.Next();
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pFoundObj )
//STRIP001 	{
//STRIP001 		pViewShell->GetViewData()->GetDispatcher().
//STRIP001 			Execute(SID_DRAW_NOTEEDIT, SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 		// now get the created FuText and put in EditMode
//STRIP001 		FuPoor* pPoor = pViewShell->GetViewData()->GetView()->GetDrawFuncPtr();
//STRIP001 		if ( pPoor && pPoor->GetSlotID() == SID_DRAW_NOTEEDIT )	 //	no RTTI
//STRIP001 		{
//STRIP001 			FuText* pText = (FuText*)pPoor;
//STRIP001 			Point aPixel = pWindow->LogicToPixel( rPos );
//STRIP001 			pText->SetInEditMode( pFoundObj, &aPixel );
//STRIP001 		}
//STRIP001 
//STRIP001 		//	repaint outliner view with background now
//STRIP001 
//STRIP001 		OutlinerView* pOlView = pView->GetTextEditOutlinerView();
//STRIP001 		if ( pOlView && pOlView->GetWindow() == pWindow )
//STRIP001 		{
//STRIP001 			Rectangle aEditRect = pOlView->GetOutputArea();
//STRIP001 			pWindow->SetFillColor( pOlView->GetBackgroundColor() );
//STRIP001 			pWindow->SetLineColor();
//STRIP001 			pWindow->DrawRect( aEditRect );
//STRIP001 			pOlView->Paint( aEditRect );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return (pFoundObj != NULL);
//STRIP001 }

//==================================================================




}
