/*************************************************************************
 *
 *  $RCSfile: sc_privsplt.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:57:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// auto strip #include "privsplt.hxx"
namespace binfilter {

/*************************************************************************
#*	Member:		ScPrivatSplit								Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		MD_Test
#*
#*  Funktion:	Konstruktor der Klasse ScPrivatSplit
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 ScPrivatSplit::ScPrivatSplit( Window* pParent, const ResId& rResId,
//STRIP001 							 SC_SPLIT_DIRECTION eSplit):
//STRIP001 						Control( pParent, rResId )
//STRIP001 {
//STRIP001 	Point aPos=GetPosPixel();
//STRIP001 	nOldX=(short)aPos.X();
//STRIP001 	nOldY=(short)aPos.Y();
//STRIP001 	nNewX=(short)aPos.X();
//STRIP001 	nNewY=(short)aPos.Y();
//STRIP001 	eScSplit=eSplit;
//STRIP001 	aXMovingRange.Min()=nNewX;
//STRIP001 	aXMovingRange.Max()=nNewX;
//STRIP001 	aYMovingRange.Min()=nNewY;
//STRIP001 	aYMovingRange.Max()=nNewY;
//STRIP001 
//STRIP001 	aWinPointer=GetPointer();
//STRIP001 
//STRIP001 	aMovingFlag=FALSE;
//STRIP001 	if(eScSplit==SC_SPLIT_HORZ)
//STRIP001 	{
//STRIP001 		aWinPointer=Pointer(POINTER_HSPLIT);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aWinPointer=Pointer(POINTER_VSPLIT);
//STRIP001 	}
//STRIP001 	SetPointer(aWinPointer);
//STRIP001 }


/*************************************************************************
#*	Member:		MouseButtonDown							Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Reagiert auf einen einzelnen Mouse-Event. Nach Aufruf
#*				werden alle Mauseingaben an dieses Control weitergeleitet.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void ScPrivatSplit::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	Point aPos=LogicToPixel(rMEvt.GetPosPixel());
//STRIP001 
//STRIP001 	nOldX=(short)aPos.X();
//STRIP001 	nOldY=(short)aPos.Y();
//STRIP001 
//STRIP001 	CaptureMouse();
//STRIP001 }

/*************************************************************************
#*	Member:		MouseButtonUp							Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Ende einer Benutzeraktion mit der Maus. Es werden
#*				die aktuelle Maus- Koordinaten ermittelt und fuer
#*				die Verschiebung des Fensters verwendet.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void ScPrivatSplit::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	ReleaseMouse();
//STRIP001 
//STRIP001 	Point aPos=LogicToPixel(rMEvt.GetPosPixel());
//STRIP001 	Point a2Pos=GetPosPixel();
//STRIP001 	Point a3Pos=a2Pos;
//STRIP001 
//STRIP001 	if(eScSplit==SC_SPLIT_HORZ)
//STRIP001 	{
//STRIP001 		nNewX=(short)aPos.X();
//STRIP001 		nDeltaX=nNewX-nOldX;
//STRIP001 		a2Pos.X()+=nDeltaX;
//STRIP001 		if(a2Pos.X()<aXMovingRange.Min())
//STRIP001 		{
//STRIP001 			nDeltaX=(short)(aXMovingRange.Min()-a3Pos.X());
//STRIP001 			a2Pos.X()=aXMovingRange.Min();
//STRIP001 		}
//STRIP001 		else if(a2Pos.X()>aXMovingRange.Max())
//STRIP001 		{
//STRIP001 			nDeltaX=(short)(aXMovingRange.Max()-a3Pos.X());
//STRIP001 			a2Pos.X()=aXMovingRange.Max();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nNewY=(short)aPos.Y();
//STRIP001 		nDeltaY=nNewY-nOldY;
//STRIP001 		a2Pos.Y()+=nDeltaY;
//STRIP001 		if(a2Pos.Y()<aYMovingRange.Min())
//STRIP001 		{
//STRIP001 			nDeltaY=(short)(aYMovingRange.Min()-a3Pos.Y());
//STRIP001 			a2Pos.Y()=aYMovingRange.Min();
//STRIP001 		}
//STRIP001 		else if(a2Pos.Y()>aYMovingRange.Max())
//STRIP001 		{
//STRIP001 			nDeltaY=(short)(aYMovingRange.Max()-a3Pos.Y());
//STRIP001 			a2Pos.Y()=aYMovingRange.Max();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SetPosPixel(a2Pos);
//STRIP001 	Invalidate();
//STRIP001 	Update();
//STRIP001 	CtrModified();
//STRIP001 }

/*************************************************************************
#*	Member:		MouseMove									Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Reagiert kontinuierlich auf Mausbewegungen. Es werden
#*				die aktuelle Maus- Koordinaten ermittelt und fuer
#*				die Verschiebung des Fensters verwendet.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void ScPrivatSplit::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	Point aPos=LogicToPixel(rMEvt.GetPosPixel());
//STRIP001 	Point a2Pos=GetPosPixel();
//STRIP001 	Point a3Pos=a2Pos;
//STRIP001 	if(rMEvt.IsLeft())
//STRIP001 	{
//STRIP001 		if(eScSplit==SC_SPLIT_HORZ)
//STRIP001 		{
//STRIP001 			nNewX=(short)aPos.X();
//STRIP001 			nDeltaX=nNewX-nOldX;
//STRIP001 			a2Pos.X()+=nDeltaX;
//STRIP001 
//STRIP001 			if(a2Pos.X()<aXMovingRange.Min())
//STRIP001 			{
//STRIP001 				nDeltaX=(short)(aXMovingRange.Min()-a3Pos.X());
//STRIP001 				a2Pos.X()=aXMovingRange.Min();
//STRIP001 			}
//STRIP001 			else if(a2Pos.X()>aXMovingRange.Max())
//STRIP001 			{
//STRIP001 				nDeltaX=(short)(aXMovingRange.Max()-a3Pos.X());
//STRIP001 				a2Pos.X()=aXMovingRange.Max();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			nNewY=(short)aPos.Y();
//STRIP001 			nDeltaY=nNewY-nOldY;
//STRIP001 			a2Pos.Y()+=nDeltaY;
//STRIP001 			if(a2Pos.Y()<aYMovingRange.Min())
//STRIP001 			{
//STRIP001 				nDeltaY=(short)(aYMovingRange.Min()-a3Pos.Y());
//STRIP001 				a2Pos.Y()=aYMovingRange.Min();
//STRIP001 			}
//STRIP001 			else if(a2Pos.Y()>aYMovingRange.Max())
//STRIP001 			{
//STRIP001 				nDeltaY=(short)(aYMovingRange.Max()-a3Pos.Y());
//STRIP001 				a2Pos.Y()=aYMovingRange.Max();
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		SetPosPixel(a2Pos);
//STRIP001 
//STRIP001 		CtrModified();
//STRIP001 		Invalidate();
//STRIP001 		Update();
//STRIP001 	}
//STRIP001 }

/*************************************************************************
#*	Member:		SetXRange									Datum:14.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Setzt den Range fuer die X- Verschiebung
#*
#*  Input:		neuer Bereich
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 void ScPrivatSplit::SetXRange(Range cRgeX)
//STRIP001 {
//STRIP001 	aXMovingRange=cRgeX;
//STRIP001 }

/*************************************************************************
#*	Member:		SetYRange									Datum:14.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Setzt den Range fuer die Y- Verschiebung
#*
#*  Input:		neuer Bereich
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 void ScPrivatSplit::SetYRange(Range cRgeY)
//STRIP001 {
//STRIP001 	aYMovingRange=cRgeY;
//STRIP001 }



/*************************************************************************
#*	Member:		GetDeltaY									Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Liefert die relative x-Verschiebung zurueck
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 short ScPrivatSplit::GetDeltaX()
//STRIP001 {
//STRIP001 	return nDeltaX;
//STRIP001 }

/*************************************************************************
#*	Member:		GetDeltaY									Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Liefert die relative y-Verschiebung zurueck
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 short ScPrivatSplit::GetDeltaY()
//STRIP001 {
//STRIP001 	return nDeltaY;
//STRIP001 }

/*************************************************************************
#*	Member:		CtrModified									Datum:13.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		ScPrivatSplit
#*
#*  Funktion:	Teilt einem installierten Handler mit, dass
#*				eine Veraenderung eingetreten ist.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 void ScPrivatSplit::CtrModified()
//STRIP001 {
//STRIP001 	aCtrModifiedLink.Call( this );
//STRIP001 }

//STRIP001 void ScPrivatSplit::MoveSplitTo(Point aPos)
//STRIP001 {
//STRIP001 	Point a2Pos=GetPosPixel();
//STRIP001 	nOldX=(short)a2Pos.X();
//STRIP001 	nOldY=(short)a2Pos.Y();
//STRIP001 	Point a3Pos=a2Pos;
//STRIP001 
//STRIP001 	if(eScSplit==SC_SPLIT_HORZ)
//STRIP001 	{
//STRIP001 		nNewX=(short)aPos.X();
//STRIP001 		nDeltaX=nNewX-nOldX;
//STRIP001 		a2Pos.X()+=nDeltaX;
//STRIP001 		if(a2Pos.X()<aXMovingRange.Min())
//STRIP001 		{
//STRIP001 			nDeltaX=(short)(aXMovingRange.Min()-a3Pos.X());
//STRIP001 			a2Pos.X()=aXMovingRange.Min();
//STRIP001 		}
//STRIP001 		else if(a2Pos.X()>aXMovingRange.Max())
//STRIP001 		{
//STRIP001 			nDeltaX=(short)(aXMovingRange.Max()-a3Pos.X());
//STRIP001 			a2Pos.X()=aXMovingRange.Max();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nNewY=(short)aPos.Y();
//STRIP001 		nDeltaY=nNewY-nOldY;
//STRIP001 		a2Pos.Y()+=nDeltaY;
//STRIP001 		if(a2Pos.Y()<aYMovingRange.Min())
//STRIP001 		{
//STRIP001 			nDeltaY=(short)(aYMovingRange.Min()-a3Pos.Y());
//STRIP001 			a2Pos.Y()=aYMovingRange.Min();
//STRIP001 		}
//STRIP001 		else if(a2Pos.Y()>aYMovingRange.Max())
//STRIP001 		{
//STRIP001 			nDeltaY=(short)(aYMovingRange.Max()-a3Pos.Y());
//STRIP001 			a2Pos.Y()=aYMovingRange.Max();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SetPosPixel(a2Pos);
//STRIP001 	Invalidate();
//STRIP001 	Update();
//STRIP001 	CtrModified();
//STRIP001 }


//STRIP001 void ScPrivatSplit::ImplInitSettings( BOOL bFont, BOOL bForeground, BOOL bBackground )
//STRIP001 {
//STRIP001 	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();
//STRIP001 
//STRIP001 	if ( bFont )
//STRIP001 	{
//STRIP001 		Font aFont = rStyleSettings.GetAppFont();
//STRIP001 		if ( IsControlFont() )
//STRIP001 			aFont.Merge( GetControlFont() );
//STRIP001 		SetFont( aFont );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bFont || bForeground )
//STRIP001 	{
//STRIP001 		Color aTextColor = rStyleSettings.GetButtonTextColor();
//STRIP001 		if ( IsControlForeground() )
//STRIP001 			aTextColor = GetControlForeground();
//STRIP001 		SetTextColor( aTextColor );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bBackground )
//STRIP001 	{
//STRIP001 		SetBackground( rStyleSettings.GetFaceColor());
//STRIP001 	}
//STRIP001 	if ( IsBackground() )
//STRIP001 	{
//STRIP001 		SetFillColor( GetBackground().GetColor() );
//STRIP001 		SetBackground();
//STRIP001 	}
//STRIP001 	Invalidate();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScPrivatSplit::StateChanged( StateChangedType nType )
//STRIP001 {
//STRIP001 	if ( (nType == STATE_CHANGE_ZOOM) ||
//STRIP001 		 (nType == STATE_CHANGE_CONTROLFONT) )
//STRIP001 	{
//STRIP001 		ImplInitSettings( TRUE, FALSE, FALSE );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 	if ( nType == STATE_CHANGE_CONTROLFOREGROUND )
//STRIP001 	{
//STRIP001 		ImplInitSettings( FALSE, TRUE, FALSE );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 	else if ( nType == STATE_CHANGE_CONTROLBACKGROUND )
//STRIP001 	{
//STRIP001 		ImplInitSettings( FALSE, FALSE, TRUE );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 
//STRIP001 	Control::StateChanged( nType );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScPrivatSplit::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001 	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
//STRIP001 		 (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001 	{
//STRIP001 		ImplInitSettings( TRUE, TRUE, TRUE );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		Window::DataChanged( rDCEvt );
//STRIP001 }


}
