/*************************************************************************
 *
 *  $RCSfile: pfiltdlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:30:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_PFILTDLG_HXX
#define SC_PFILTDLG_HXX

#ifndef _SV_HXX
#endif

#ifndef _MOREBTN_HXX //autogen
#include <vcl/morebtn.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#include "global.hxx" // -> ScQueryParam
namespace binfilter {

//------------------------------------------------------------------

class ScViewData;
class ScDocument;
class ScQueryItem;
class TypedStrCollection;

//==================================================================

//STRIP001 class ScPivotFilterDlg : public ModalDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 					ScPivotFilterDlg( Window* pParent,
//STRIP001 									  const SfxItemSet&	rArgSet, USHORT nSourceTab );
//STRIP001 					~ScPivotFilterDlg();
//STRIP001 
//STRIP001 	const ScQueryItem&	GetOutputItem();
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine       aFlCriteria;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbField1;
//STRIP001 	ListBox			aLbCond1;
//STRIP001 	ComboBox		aEdVal1;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbConnect1;
//STRIP001 	ListBox			aLbField2;
//STRIP001 	ListBox			aLbCond2;
//STRIP001 	ComboBox		aEdVal2;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbConnect2;
//STRIP001 	ListBox			aLbField3;
//STRIP001 	ListBox			aLbCond3;
//STRIP001 	ComboBox		aEdVal3;
//STRIP001 	//----------------------------
//STRIP001 	FixedText		aFtConnect;
//STRIP001 	FixedText		aFtField;
//STRIP001 	FixedText		aFtCond;
//STRIP001 	FixedText		aFtVal;
//STRIP001 
//STRIP001     FixedLine       aFlOptions;
//STRIP001 	CheckBox		aBtnCase;
//STRIP001 	CheckBox		aBtnRegExp;
//STRIP001 	CheckBox		aBtnUnique;
//STRIP001 	FixedText		aFtDbAreaLabel;
//STRIP001 	FixedInfo		aFtDbArea;
//STRIP001 	OKButton		aBtnOk;
//STRIP001 	CancelButton	aBtnCancel;
//STRIP001 	HelpButton		aBtnHelp;
//STRIP001 	MoreButton		aBtnMore;
//STRIP001 	const String	aStrUndefined;
//STRIP001 	const String	aStrNoName;
//STRIP001 	const String	aStrNone;
//STRIP001 	const String	aStrEmpty;
//STRIP001 	const String	aStrNotEmpty;
//STRIP001 	const String	aStrRow;
//STRIP001 	const String	aStrColumn;
//STRIP001 
//STRIP001 	const USHORT		nWhichQuery;
//STRIP001 	const ScQueryParam	theQueryData;
//STRIP001 	ScQueryItem*		pOutItem;
//STRIP001 	ScViewData*			pViewData;
//STRIP001 	ScDocument*			pDoc;
//STRIP001 	USHORT				nSrcTab;
//STRIP001 
//STRIP001 	USHORT				nFieldCount;
//STRIP001 	ComboBox*			aValueEdArr[3];
//STRIP001 	ListBox*			aFieldLbArr[3];
//STRIP001 	ListBox*			aCondLbArr[3];
//STRIP001 
//STRIP001 	TypedStrCollection*	pEntryLists[MAXCOL+1];
//STRIP001 
//STRIP001 #ifdef _PFILTDLG_CXX
//STRIP001 private:
//STRIP001 	void	Init			( const SfxItemSet&	rArgSet );
//STRIP001 	void	FillFieldLists	();
//STRIP001 	void	UpdateValueList	( USHORT nList );
//STRIP001 	void	ClearValueList	( USHORT nList );
//STRIP001 	USHORT	GetFieldSelPos	( USHORT nField );
//STRIP001 
//STRIP001 	// Handler:
//STRIP001 	DECL_LINK( LbSelectHdl, ListBox* );
//STRIP001 	DECL_LINK( ValModifyHdl, ComboBox* );
//STRIP001 	DECL_LINK( CheckBoxHdl,	 CheckBox* );
//STRIP001 #endif
//STRIP001 };


} //namespace binfilter
#endif // SC_PFILTDLG_HXX

