/*************************************************************************
 *
 *  $RCSfile: sc_auditsh.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:25:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include "scitems.hxx"
// auto strip #include <bf_svx/srchitem.hxx>
#include <bf_sfx2/bindings.hxx>
#include <bf_sfx2/objface.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <bf_sfx2/request.hxx>

#include "auditsh.hxx"
#include "tabvwsh.hxx"
#include "scresid.hxx"
#include "bf_sc.hrc"

//------------------------------------------------------------------------
namespace binfilter {

#define ScAuditingShell
#include "scslots.hxx"

//------------------------------------------------------------------------

//STRIP001 TYPEINIT1( ScAuditingShell, SfxShell );

/*N*/ SFX_IMPL_INTERFACE(ScAuditingShell, SfxShell, ScResId(SCSTR_AUDITSHELL))
/*N*/ {
/*N*/ 	SFX_POPUPMENU_REGISTRATION( ScResId(RID_POPUP_AUDIT) );
/*N*/ }


//------------------------------------------------------------------------

ScAuditingShell::ScAuditingShell(ScViewData* pData) :
	SfxShell(pData->GetViewShell()) //STRIP001 ,
//STRIP001 	pViewData( pData ),
//STRIP001 	nFunction( SID_FILL_ADD_PRED )
{DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	SetPool( &pViewData->GetViewShell()->GetPool() );
//STRIP001 	SetUndoManager( pViewData->GetSfxDocShell()->GetUndoManager() );
//STRIP001 	SetHelpId( HID_SCSHELL_AUDIT );
//STRIP001 	SetName(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("Auditing")));
}

//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 ScAuditingShell::~ScAuditingShell()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void ScAuditingShell::Execute( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	SfxBindings& rBindings = pViewData->GetBindings();
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case SID_FILL_ADD_PRED:
//STRIP001 		case SID_FILL_DEL_PRED:
//STRIP001 		case SID_FILL_ADD_SUCC:
//STRIP001 		case SID_FILL_DEL_SUCC:
//STRIP001 			nFunction = nSlot;
//STRIP001 			rBindings.Invalidate( SID_FILL_ADD_PRED );
//STRIP001 			rBindings.Invalidate( SID_FILL_DEL_PRED );
//STRIP001 			rBindings.Invalidate( SID_FILL_ADD_SUCC );
//STRIP001 			rBindings.Invalidate( SID_FILL_DEL_SUCC );
//STRIP001 			break;
//STRIP001 		case SID_CANCEL:		// Escape
//STRIP001 		case SID_FILL_NONE:
//STRIP001 			pViewData->GetViewShell()->SetAuditShell( FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_FILL_SELECT:
//STRIP001 			{
//STRIP001 				const SfxItemSet* pReqArgs = rReq.GetArgs();
//STRIP001 				if ( pReqArgs )
//STRIP001 				{
//STRIP001 					const SfxPoolItem* pXItem;
//STRIP001 					const SfxPoolItem* pYItem;
//STRIP001 					if ( pReqArgs->GetItemState( SID_RANGE_COL, TRUE, &pXItem ) == SFX_ITEM_SET
//STRIP001 					  && pReqArgs->GetItemState( SID_RANGE_ROW, TRUE, &pYItem ) == SFX_ITEM_SET )
//STRIP001 					{
//STRIP001 						DBG_ASSERT( pXItem->ISA(SfxInt16Item) && pYItem->ISA(SfxInt16Item),
//STRIP001 										"falsche Items" );
//STRIP001 						short nCol = ((const SfxInt16Item*) pXItem)->GetValue();
//STRIP001 						short nRow = ((const SfxInt16Item*) pYItem)->GetValue();
//STRIP001 						ScViewFunc* pView = pViewData->GetView();
//STRIP001 						pView->MoveCursorAbs( nCol, nRow, SC_FOLLOW_LINE, FALSE, FALSE );
//STRIP001 						switch ( nFunction )
//STRIP001 						{
//STRIP001 							case SID_FILL_ADD_PRED:
//STRIP001 								pView->DetectiveAddPred();
//STRIP001 								break;
//STRIP001 							case SID_FILL_DEL_PRED:
//STRIP001 								pView->DetectiveDelPred();
//STRIP001 								break;
//STRIP001 							case SID_FILL_ADD_SUCC:
//STRIP001 								pView->DetectiveAddSucc();
//STRIP001 								break;
//STRIP001 							case SID_FILL_DEL_SUCC:
//STRIP001 								pView->DetectiveDelSucc();
//STRIP001 								break;
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void ScAuditingShell::GetState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	rSet.Put( SfxBoolItem( nFunction, TRUE ) );			// aktive Funktion markieren
//STRIP001 }


}
