#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:22:57 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..$/..
BFPRJ=..$/..$/..

PROJECTPCH=sch
PROJECTPCHSOURCE=$(BFPRJ)$/util$/sch_sch

PRJNAME=binfilter
TARGET=sch_func

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

AUTOSEG=true

# --- Settings -----------------------------------------------------
.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk
INC+= -I$(PRJ)$/inc$/bf_sch
# --- Files --------------------------------------------------------

SLOFILES = \
		$(SLO)$/sch_fupoor.obj		\
        $(SLO)$/sch_fu3d.obj               \
		$(SLO)$/sch_fuchrmap.obj    \
        $(SLO)$/sch_fudgrlin.obj               \
		$(SLO)$/sch_fudraw.obj		\
		$(SLO)$/sch_fusel.obj		\
		$(SLO)$/sch_futext.obj		\
		$(SLO)$/sch_fuinstit.obj		\
        $(SLO)$/sch_fuinssts.obj             \
		$(SLO)$/sch_fuinsleg.obj		\
		$(SLO)$/sch_fuinsdes.obj		\
		$(SLO)$/sch_fuinsaxi.obj		\
		$(SLO)$/sch_fudgraut.obj		\
		$(SLO)$/sch_fudgrtyp.obj		\
		$(SLO)$/sch_futitle.obj		\
		$(SLO)$/sch_fulegend.obj		\
		$(SLO)$/sch_fudatrow.obj		\
		$(SLO)$/sch_fudgraxi.obj		\
		$(SLO)$/sch_fudgrgri.obj		\
		$(SLO)$/sch_fudgrare.obj		\
		$(SLO)$/sch_fudgrwal.obj		\
		$(SLO)$/sch_fufloor.obj		\
		$(SLO)$/sch_schundo.obj		\
		$(SLO)$/sch_undgrdat.obj		\
		$(SLO)$/sch_unedtit.obj		\
        $(SLO)$/sch_unscale.obj              \
		$(SLO)$/sch_uninstit.obj		\
		$(SLO)$/sch_uninsleg.obj		\
		$(SLO)$/sch_uninsdes.obj		\
        $(SLO)$/sch_undgrlin.obj             \
		$(SLO)$/sch_uninsaxi.obj		\
		$(SLO)$/sch_undgraut.obj		\
		$(SLO)$/sch_undgrtyp.obj		\
		$(SLO)$/sch_undoattr.obj		\
		$(SLO)$/sch_undstat.obj             \
		$(SLO)$/sch_untitle.obj		\
		$(SLO)$/sch_unlegend.obj		\
		$(SLO)$/sch_undatrow.obj		\
		$(SLO)$/sch_undatpnt.obj		\
		$(SLO)$/sch_undgraxi.obj		\
		$(SLO)$/sch_undgrgri.obj		\
		$(SLO)$/sch_undgrare.obj		\
		$(SLO)$/sch_undgrwal.obj		\
		$(SLO)$/sch_unfloor.obj		\
		$(SLO)$/sch_un3dview.obj		\
        $(SLO)$/sch_unlight.obj              \
        $(SLO)$/sch_unswitch.obj \
        $(SLO)$/sch_unmultdp.obj \
		$(SLO)$/sch_undswap.obj\
		$(SLO)$/sch_unbyid.obj\
		$(SLO)$/sch_fubyid.obj \
		$(SLO)$/sch_futransform.obj \
		$(SLO)$/sch_undmovsize.obj \
		$(SLO)$/sch_undmovpieseg.obj

# --- Tagets -------------------------------------------------------

.INCLUDE :  target.mk

