/*************************************************************************
 *
 *  $RCSfile: sd_copydlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:35:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SVX_DLGUTIL_HXX //autogen
// auto strip #include <bf_svx/dlgutil.hxx>
// auto strip #endif
// auto strip #ifndef _SFXMODULE_HXX //autogen
// auto strip #include <bf_sfx2/module.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_XCOLORITEM_HXX //autogen
// auto strip #include <bf_svx/xcolit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLCLIT_HXX //autogen
// auto strip #include <bf_svx/xflclit.hxx>
// auto strip #endif
// auto strip #ifndef _XDEF_HXX //autogen
// auto strip #include <bf_svx/xdef.hxx>
// auto strip #endif
// auto strip #ifndef SVX_XFILLIT0_HXX //autogen
// auto strip #include <bf_svx/xfillit0.hxx>
// auto strip #endif
// auto strip #ifndef _XENUM_HXX //autogen
// auto strip #include <bf_svx/xenum.hxx>
// auto strip #endif

// auto strip #include <bf_sfx2/app.hxx>

#pragma hdrstop


// auto strip #include "sdattr.hxx"

// auto strip #include "copydlg.hxx"
#include "copydlg.hrc"
// auto strip #include "sdview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
#include "res_bmp.hrc"
namespace binfilter {

//STRIP001 #define TOKEN (sal_Unicode(';'))

/*************************************************************************
|*
|* Dialog zum Kopieren von Objekten
|*
\************************************************************************/

//STRIP001 SdCopyDlg::SdCopyDlg( Window* pWindow, const SfxItemSet& rInAttrs,
//STRIP001 					  XColorTable* pColTab, SdView* pInView ) :
//STRIP001 				SfxModalDialog     ( pWindow, SdResId( DLG_COPY ) ),
//STRIP001 				aFtCopies           ( this, SdResId( FT_COPIES ) ),
//STRIP001 				aNumFldCopies       ( this, SdResId( NUM_FLD_COPIES ) ),
//STRIP001 				aFtMoveX            ( this, SdResId( FT_MOVE_X ) ),
//STRIP001 				aMtrFldMoveX        ( this, SdResId( MTR_FLD_MOVE_X ) ),
//STRIP001 				aFtMoveY            ( this, SdResId( FT_MOVE_Y ) ),
//STRIP001 				aMtrFldMoveY        ( this, SdResId( MTR_FLD_MOVE_Y ) ),
//STRIP001 				aFtAngle            ( this, SdResId( FT_ANGLE ) ),
//STRIP001 				aMtrFldAngle        ( this, SdResId( MTR_FLD_ANGLE ) ),
//STRIP001 				aGrpMovement        ( this, SdResId( GRP_MOVEMENT ) ),
//STRIP001 				aFtWidth            ( this, SdResId( FT_WIDTH ) ),
//STRIP001 				aMtrFldWidth        ( this, SdResId( MTR_FLD_WIDTH ) ),
//STRIP001 				aFtHeight           ( this, SdResId( FT_HEIGHT ) ),
//STRIP001 				aMtrFldHeight       ( this, SdResId( MTR_FLD_HEIGHT ) ),
//STRIP001 				aGrpEnlargement     ( this, SdResId( GRP_ENLARGEMENT ) ),
//STRIP001 				aFtStartColor       ( this, SdResId( FT_START_COLOR ) ),
//STRIP001 				aLbStartColor       ( this, SdResId( LB_START_COLOR ) ),
//STRIP001 				aFtEndColor         ( this, SdResId( FT_END_COLOR ) ),
//STRIP001 				aLbEndColor         ( this, SdResId( LB_END_COLOR ) ),
//STRIP001 				aGrpColor           ( this, SdResId( GRP_COLOR ) ),
//STRIP001 				aBtnOK              ( this, SdResId( BTN_OK ) ),
//STRIP001 				aBtnCancel          ( this, SdResId( BTN_CANCEL ) ),
//STRIP001 				aBtnHelp            ( this, SdResId( BTN_HELP ) ),
//STRIP001 				aBtnSetViewData     ( this, SdResId( BTN_SET_VIEWDATA ) ),
//STRIP001 				aBtnSetDefault      ( this, SdResId( BTN_SET_DEFAULT ) ),
//STRIP001 				rOutAttrs			( rInAttrs ),
//STRIP001 				pColorTab			( pColTab ),
//STRIP001 				pView				( pInView ),
//STRIP001 				eUIUnit(pInView->GetDoc()->GetUIUnit()),
//STRIP001 				aUIScale(pInView->GetDoc()->GetUIScale())
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001     // Set up the view data button (image and accessible name).
//STRIP001 	aBtnSetViewData.SetModeImage( Image( SdResId( IMG_PIPETTE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001     aBtnSetViewData.SetAccessibleName (aBtnSetViewData.GetQuickHelpText());
//STRIP001 
//STRIP001 	// Farbtabellen
//STRIP001 	DBG_ASSERT( pColorTab, "Keine gueltige ColorTable uebergeben!" );
//STRIP001 	aLbStartColor.Fill( pColorTab );
//STRIP001 	aLbEndColor.CopyEntries( aLbStartColor );
//STRIP001 
//STRIP001 	aLbStartColor.SetSelectHdl( LINK( this, SdCopyDlg, SelectColorHdl ) );
//STRIP001 	aBtnSetViewData.SetClickHdl( LINK( this, SdCopyDlg, SetViewData ) );
//STRIP001 	aBtnSetDefault.SetClickHdl( LINK( this, SdCopyDlg, SetDefault ) );
//STRIP001 
//STRIP001 
//STRIP001 	FieldUnit eFUnit( GetModuleFieldUnit() );
//STRIP001 
//STRIP001 	SetFieldUnit( aMtrFldMoveX, eFUnit, TRUE );
//STRIP001 	SetFieldUnit( aMtrFldMoveY, eFUnit, TRUE );
//STRIP001 	SetFieldUnit( aMtrFldWidth, eFUnit, TRUE );
//STRIP001 	SetFieldUnit( aMtrFldHeight, eFUnit, TRUE );
//STRIP001 
//STRIP001 	Reset(0L);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Dtor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdCopyDlg::~SdCopyDlg()
//STRIP001 {
//STRIP001 	String& rStr = GetExtraData();
//STRIP001 
//STRIP001 	rStr = UniString::CreateFromInt32( aNumFldCopies.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( aMtrFldMoveX.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( aMtrFldMoveY.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( aMtrFldAngle.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( aMtrFldWidth.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( aMtrFldHeight.GetValue() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( (long)aLbStartColor.GetSelectEntryColor().GetColor() );
//STRIP001 	rStr.Append( TOKEN );
//STRIP001 
//STRIP001 	rStr += UniString::CreateFromInt32( (long)aLbEndColor.GetSelectEntryColor().GetColor() );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Liest uebergebenen Item-Set oder wertet den INI-String aus
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdCopyDlg, Reset, void*, p )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pPoolItem = NULL;
//STRIP001 	String aStr( GetExtraData() );
//STRIP001 
//STRIP001 	if( aStr.GetTokenCount( TOKEN ) < 8 )
//STRIP001 	{
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_NUMBER, TRUE, &pPoolItem ) )
//STRIP001 			aNumFldCopies.SetValue( ( ( const SfxUInt16Item* ) pPoolItem )->GetValue() );
//STRIP001 		else
//STRIP001 			aNumFldCopies.SetValue( 1L );
//STRIP001 
//STRIP001 		long nMoveX = 500L;
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_MOVE_X, TRUE, &pPoolItem ) )
//STRIP001 			nMoveX = ( ( ( const SfxInt32Item* ) pPoolItem )->GetValue() );
//STRIP001 		SetMetricValue( aMtrFldMoveX, Fraction(nMoveX) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 		long nMoveY = 500L;
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_MOVE_Y, TRUE, &pPoolItem ) )
//STRIP001 			nMoveY = ( ( ( const SfxInt32Item* ) pPoolItem )->GetValue() );
//STRIP001 		SetMetricValue( aMtrFldMoveY, Fraction(nMoveY) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_ANGLE, TRUE, &pPoolItem ) )
//STRIP001 			aMtrFldAngle.SetValue( ( ( const SfxInt32Item* ) pPoolItem )->GetValue() );
//STRIP001 		else
//STRIP001 			aMtrFldAngle.SetValue( 0L );
//STRIP001 
//STRIP001 		long nWidth = 0L;
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_WIDTH, TRUE, &pPoolItem ) )
//STRIP001 			nWidth = ( ( ( const SfxInt32Item* ) pPoolItem )->GetValue() );
//STRIP001 		SetMetricValue( aMtrFldWidth, Fraction(nWidth) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 		long nHeight = 0L;
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_HEIGHT, TRUE, &pPoolItem ) )
//STRIP001 			nHeight = ( ( ( const SfxInt32Item* ) pPoolItem )->GetValue() );
//STRIP001 		SetMetricValue( aMtrFldHeight, Fraction(nHeight) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 		if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_START_COLOR, TRUE, &pPoolItem ) )
//STRIP001 		{
//STRIP001 			Color aColor = ( ( const XColorItem* ) pPoolItem )->GetValue();
//STRIP001 			aLbStartColor.SelectEntry( aColor );
//STRIP001 			aLbEndColor.SelectEntry( aColor );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aLbStartColor.SetNoSelection();
//STRIP001 			aLbEndColor.SetNoSelection();
//STRIP001 			aLbEndColor.Disable();
//STRIP001 			aFtEndColor.Disable();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		long nTmp;
//STRIP001 		nTmp = (long)aStr.GetToken( 0, TOKEN ).ToInt32();
//STRIP001 		aNumFldCopies.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 1, TOKEN ).ToInt32();
//STRIP001 		aMtrFldMoveX.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 2, TOKEN ).ToInt32();
//STRIP001 		aMtrFldMoveY.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 3, TOKEN ).ToInt32();
//STRIP001 		aMtrFldAngle.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 4, TOKEN ).ToInt32();
//STRIP001 		aMtrFldWidth.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 5, TOKEN ).ToInt32();
//STRIP001 		aMtrFldHeight.SetValue( nTmp );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 6, TOKEN ).ToInt32();
//STRIP001 		aLbStartColor.SelectEntry( Color( nTmp ) );
//STRIP001 
//STRIP001 		nTmp = (long)aStr.GetToken( 7, TOKEN ).ToInt32();
//STRIP001 		aLbEndColor.SelectEntry( Color( nTmp ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdCopyDlg::GetAttr( SfxItemSet& rOutAttrs )
//STRIP001 {
//STRIP001 	long nMoveX = Fraction( GetCoreValue( aMtrFldMoveX, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 	long nMoveY = Fraction( GetCoreValue( aMtrFldMoveY, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 	long nHeight = Fraction( GetCoreValue( aMtrFldHeight, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 	long nWidth  = Fraction( GetCoreValue( aMtrFldWidth, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 
//STRIP001 	rOutAttrs.Put( SfxUInt16Item( ATTR_COPY_NUMBER, (UINT16) aNumFldCopies.GetValue() ) );
//STRIP001 	rOutAttrs.Put( SfxInt32Item( ATTR_COPY_MOVE_X, nMoveX ) );
//STRIP001 	rOutAttrs.Put( SfxInt32Item( ATTR_COPY_MOVE_Y, nMoveY ) );
//STRIP001 	rOutAttrs.Put( SfxInt32Item( ATTR_COPY_ANGLE, aMtrFldAngle.GetValue() ) );
//STRIP001 	rOutAttrs.Put( SfxInt32Item( ATTR_COPY_WIDTH, nWidth ) );
//STRIP001 	rOutAttrs.Put( SfxInt32Item( ATTR_COPY_HEIGHT, nHeight ) );
//STRIP001 
//STRIP001 	if( aLbStartColor.GetSelectEntryPos() != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001 		XColorItem aXColorItem( ATTR_COPY_START_COLOR, aLbStartColor.GetSelectEntry(),
//STRIP001 									aLbStartColor.GetSelectEntryColor() );
//STRIP001 		rOutAttrs.Put( aXColorItem );
//STRIP001 	}
//STRIP001 	if( aLbEndColor.GetSelectEntryPos() != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001 		XColorItem aXColorItem( ATTR_COPY_END_COLOR, aLbEndColor.GetSelectEntry(),
//STRIP001 									aLbEndColor.GetSelectEntryColor() );
//STRIP001 		rOutAttrs.Put( aXColorItem );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Enabled und selektiert Endfarben-LB
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdCopyDlg, SelectColorHdl, void *, p )
//STRIP001 {
//STRIP001 	USHORT nPos = aLbStartColor.GetSelectEntryPos();
//STRIP001 
//STRIP001 	if( nPos != LISTBOX_ENTRY_NOTFOUND &&
//STRIP001 		!aLbEndColor.IsEnabled() )
//STRIP001 	{
//STRIP001 		aLbEndColor.SelectEntryPos( nPos );
//STRIP001 		aLbEndColor.Enable();
//STRIP001 		aFtEndColor.Enable();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |* Setzt Werte der Selektion
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdCopyDlg, SetViewData, void*, EMPTYARG )
//STRIP001 {
//STRIP001 	Rectangle aRect = pView->GetAllMarkedRect();
//STRIP001 
//STRIP001 	SetMetricValue( aMtrFldMoveX, Fraction( aRect.GetWidth() ) /
//STRIP001 									aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 	SetMetricValue( aMtrFldMoveY, Fraction( aRect.GetHeight() ) /
//STRIP001 									aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 	// Farb-Attribut setzen
//STRIP001 	const SfxPoolItem*	pPoolItem = NULL;
//STRIP001 	if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_START_COLOR, TRUE, &pPoolItem ) )
//STRIP001 	{
//STRIP001 		Color aColor = ( ( const XColorItem* ) pPoolItem )->GetValue();
//STRIP001 		aLbStartColor.SelectEntry( aColor );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |* Setzt Werte auf Standard
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdCopyDlg, SetDefault, void*, EMPTYARG )
//STRIP001 {
//STRIP001 	aNumFldCopies.SetValue( 1L );
//STRIP001 
//STRIP001 	long nValue = 500L;
//STRIP001 	SetMetricValue( aMtrFldMoveX, Fraction(nValue) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 	SetMetricValue( aMtrFldMoveY, Fraction(nValue) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 	nValue = 0L;
//STRIP001 	aMtrFldAngle.SetValue( nValue );
//STRIP001 	SetMetricValue( aMtrFldWidth, Fraction(nValue) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 	SetMetricValue( aMtrFldHeight, Fraction(nValue) / aUIScale, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 	// Farb-Attribut setzen
//STRIP001 	const SfxPoolItem*	pPoolItem = NULL;
//STRIP001 	if( SFX_ITEM_SET == rOutAttrs.GetItemState( ATTR_COPY_START_COLOR, TRUE, &pPoolItem ) )
//STRIP001 	{
//STRIP001 		Color aColor = ( ( const XColorItem* ) pPoolItem )->GetValue();
//STRIP001 		aLbStartColor.SelectEntry( aColor );
//STRIP001 		aLbEndColor.SelectEntry( aColor );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }


}
