/*************************************************************************
 *
 *  $RCSfile: sd_dlgfield.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:36:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #include <bf_svx/editeng.hxx>

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #ifndef _PSTM_HXX
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#ifndef _SVX_ITEMDATA_HXX
#include <bf_svx/itemdata.hxx>
#endif

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif

#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif

#define ITEMID_FIELD	EE_FEATURE_FIELD
// auto strip #include <bf_svx/flditem.hxx>
// auto strip #ifndef _ZFORLIST_HXX
// auto strip #include <svtools/zforlist.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ADRITEM_HXX
// auto strip #include <bf_svx/adritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_OBJSH_HXX
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMSET_HXX 
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
#define ITEMID_LANGUAGE EE_CHAR_LANGUAGE
// auto strip #ifndef _SVX_LANGITEM_HXX 
// auto strip #include <bf_svx/langitem.hxx>
// auto strip #endif

#include "strings.hrc"
#include "dlgfield.hrc"
// auto strip #include "sdattr.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "sdmod.hxx"
// auto strip #include "dlgfield.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Dialog zum Bearbeiten von Feldbefehlen
|*
\************************************************************************/

//STRIP001 SdModifyFieldDlg::SdModifyFieldDlg( Window* pWindow, const SvxFieldData* pInField, const SfxItemSet& rSet ) :
//STRIP001 	ModalDialog ( pWindow, SdResId( DLG_FIELD_MODIFY ) ),
//STRIP001 	aRbtFix		( this, SdResId( RBT_FIX ) ),
//STRIP001 	aRbtVar		( this, SdResId( RBT_VAR ) ),
//STRIP001 	aGrpType	( this, SdResId( GRP_TYPE ) ),
//STRIP001 	maFtLanguage( this, SdResId( FT_LANGUAGE ) ),
//STRIP001 	maLbLanguage( this, SdResId( LB_LANGUAGE ) ),
//STRIP001 	aFtFormat	( this, SdResId( FT_FORMAT ) ),
//STRIP001 	aLbFormat	( this, SdResId( LB_FORMAT ) ),
//STRIP001 	aBtnOK      ( this, SdResId( BTN_OK ) ),
//STRIP001 	aBtnCancel  ( this, SdResId( BTN_CANCEL ) ),
//STRIP001 	aBtnHelp    ( this, SdResId( BTN_HELP ) ),
//STRIP001 	pField		( pInField ),
//STRIP001 	maInputSet	( rSet )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	maLbLanguage.SetLanguageList( LANG_LIST_ALL|LANG_LIST_ONLY_KNOWN, false );
//STRIP001 	maLbLanguage.SetSelectHdl( LINK( this, SdModifyFieldDlg, LanguageChangeHdl ) );
//STRIP001 	FillControls();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Gibt das neue Feld zurueck, gehoert dem Caller.
//STRIP001 |* Liefert NULL, wenn sich nichts geaendert hat.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SvxFieldData* SdModifyFieldDlg::GetField()
//STRIP001 {
//STRIP001 	SvxFieldData* pNewField = NULL;
//STRIP001 
//STRIP001 	if( aRbtFix.IsChecked() != aRbtFix.GetSavedValue() ||
//STRIP001 		aRbtVar.IsChecked() != aRbtVar.GetSavedValue() ||
//STRIP001 		aLbFormat.GetSelectEntryPos() != aLbFormat.GetSavedValue() )
//STRIP001 	{
//STRIP001 		if( pField->ISA( SvxDateField ) )
//STRIP001 		{
//STRIP001 			const SvxDateField* pDateField = (const SvxDateField*) pField;
//STRIP001 			SvxDateType	  eType;
//STRIP001 			SvxDateFormat eFormat;
//STRIP001 
//STRIP001 			if( aRbtFix.IsChecked() )
//STRIP001 				eType = SVXDATETYPE_FIX;
//STRIP001 			else
//STRIP001 				eType = SVXDATETYPE_VAR;
//STRIP001 
//STRIP001 			eFormat = (SvxDateFormat) ( aLbFormat.GetSelectEntryPos() + 2 );
//STRIP001 
//STRIP001 			pNewField = new SvxDateField( *pDateField );
//STRIP001 			( (SvxDateField*) pNewField )->SetType( eType );
//STRIP001 			( (SvxDateField*) pNewField )->SetFormat( eFormat );
//STRIP001 		}
//STRIP001 		else if( pField->ISA( SvxExtTimeField ) )
//STRIP001 		{
//STRIP001 			const SvxExtTimeField* pTimeField = (const SvxExtTimeField*) pField;
//STRIP001 			SvxTimeType	  eType;
//STRIP001 			SvxTimeFormat eFormat;
//STRIP001 
//STRIP001 			if( aRbtFix.IsChecked() )
//STRIP001 				eType = SVXTIMETYPE_FIX;
//STRIP001 			else
//STRIP001 				eType = SVXTIMETYPE_VAR;
//STRIP001 
//STRIP001 			eFormat = (SvxTimeFormat) ( aLbFormat.GetSelectEntryPos() + 2 );
//STRIP001 
//STRIP001 			pNewField = new SvxExtTimeField( *pTimeField );
//STRIP001 			( (SvxExtTimeField*) pNewField )->SetType( eType );
//STRIP001 			( (SvxExtTimeField*) pNewField )->SetFormat( eFormat );
//STRIP001 		}
//STRIP001 		else if( pField->ISA( SvxExtFileField ) )
//STRIP001 		{
//STRIP001 			const SvxExtFileField* pFileField = (const SvxExtFileField*) pField;
//STRIP001 			SvxFileType	  eType;
//STRIP001 			SvxFileFormat eFormat;
//STRIP001 
//STRIP001 			if( aRbtFix.IsChecked() )
//STRIP001 				eType = SVXFILETYPE_FIX;
//STRIP001 			else
//STRIP001 				eType = SVXFILETYPE_VAR;
//STRIP001 
//STRIP001 			eFormat = (SvxFileFormat) ( aLbFormat.GetSelectEntryPos() );
//STRIP001 
//STRIP001 			SdDrawDocShell* pDocSh = PTR_CAST( SdDrawDocShell,
//STRIP001 											   SfxObjectShell::Current() );
//STRIP001 
//STRIP001 			if( pDocSh )
//STRIP001 			{
//STRIP001 				SvxExtFileField aFileField( *pFileField );
//STRIP001 				
//STRIP001 				String aName;
//STRIP001 				if( pDocSh->HasName() )
//STRIP001 					aName = pDocSh->GetMedium()->GetName();
//STRIP001 
//STRIP001 				// #91225# Get current filename, not the one stored in the old field
//STRIP001 				pNewField = new SvxExtFileField( aName );
//STRIP001 				( (SvxExtFileField*) pNewField )->SetType( eType );
//STRIP001 				( (SvxExtFileField*) pNewField )->SetFormat( eFormat );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( pField->ISA( SvxAuthorField ) )
//STRIP001 		{
//STRIP001 			const SvxAuthorField* pAuthorField = (const SvxAuthorField*) pField;
//STRIP001 			SvxAuthorType	eType;
//STRIP001 			SvxAuthorFormat eFormat;
//STRIP001 
//STRIP001 			if( aRbtFix.IsChecked() )
//STRIP001 				eType = SVXAUTHORTYPE_FIX;
//STRIP001 			else
//STRIP001 				eType = SVXAUTHORTYPE_VAR;
//STRIP001 
//STRIP001 			eFormat = (SvxAuthorFormat) ( aLbFormat.GetSelectEntryPos() );
//STRIP001 
//STRIP001 			// #91225# Get current state of address, not the old one
//STRIP001 			pNewField = new SvxAuthorField( SvxAddressItem() );
//STRIP001 			( (SvxAuthorField*) pNewField )->SetType( eType );
//STRIP001 			( (SvxAuthorField*) pNewField )->SetFormat( eFormat );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( pNewField );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdModifyFieldDlg::FillFormatList()
//STRIP001 {
//STRIP001 	LanguageType eLangType = maLbLanguage.GetSelectLanguage();
//STRIP001 
//STRIP001 	aLbFormat.Clear();
//STRIP001 
//STRIP001 	if( pField->ISA( SvxDateField ) )
//STRIP001 	{
//STRIP001 		const SvxDateField* pDateField = (const SvxDateField*) pField;
//STRIP001 		SvxDateField aDateField( *pDateField );
//STRIP001 
//STRIP001 		//SVXDATEFORMAT_APPDEFAULT, 	// Wird nicht benutzt
//STRIP001 		//SVXDATEFORMAT_SYSTEM, 		// Wird nicht benutzt
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_STANDARD_SMALL ) ) );
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_STANDARD_BIG ) ) );
//STRIP001 
//STRIP001 		SvNumberFormatter* pNumberFormatter = SD_MOD()->GetNumberFormatter();
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_A );	// 13.02.96
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_B );	// 13.02.1996
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_C );	// 13.Feb 1996
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_D );	// 13.Februar 1996
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_E );	// Die, 13.Februar 1996
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aDateField.SetFormat( SVXDATEFORMAT_F );	// Dienstag, 13.Februar 1996
//STRIP001 		aLbFormat.InsertEntry( aDateField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 
//STRIP001 		aLbFormat.SelectEntryPos( (USHORT) ( pDateField->GetFormat() - 2 ) );
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxExtTimeField ) )
//STRIP001 	{
//STRIP001 		const SvxExtTimeField* pTimeField = (const SvxExtTimeField*) pField;
//STRIP001 		SvxExtTimeField aTimeField( *pTimeField );
//STRIP001 
//STRIP001 		//SVXTIMEFORMAT_APPDEFAULT, 	// Wird nicht benutzt
//STRIP001 		//SVXTIMEFORMAT_SYSTEM, 		// Wird nicht benutzt
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_STANDARD_NORMAL ) ) );
//STRIP001 
//STRIP001 		SvNumberFormatter* pNumberFormatter = SD_MOD()->GetNumberFormatter();
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_24_HM );	// 13:49
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_24_HMS );	// 13:49:38
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_24_HMSH );	// 13:49:38.78
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_12_HM );	// 01:49
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_12_HMS );	// 01:49:38
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		aTimeField.SetFormat( SVXTIMEFORMAT_12_HMSH );	// 01:49:38.78
//STRIP001 		aLbFormat.InsertEntry( aTimeField.GetFormatted( *pNumberFormatter, eLangType ) );
//STRIP001 		//SVXTIMEFORMAT_AM_HM,	// 01:49 PM
//STRIP001 		//SVXTIMEFORMAT_AM_HMS,	// 01:49:38 PM
//STRIP001 		//SVXTIMEFORMAT_AM_HMSH	// 01:49:38.78 PM
//STRIP001 
//STRIP001 		aLbFormat.SelectEntryPos( (USHORT) ( pTimeField->GetFormat() - 2 ) );
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxExtFileField ) )
//STRIP001 	{
//STRIP001 		const SvxExtFileField* pFileField = (const SvxExtFileField*) pField;
//STRIP001 		SvxExtFileField aFileField( *pFileField );
//STRIP001 
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_FILEFORMAT_NAME_EXT ) ) );
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_FILEFORMAT_FULLPATH ) ) );
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_FILEFORMAT_PATH ) ) );
//STRIP001 		aLbFormat.InsertEntry( String( SdResId( STR_FILEFORMAT_NAME ) ) );
//STRIP001 
//STRIP001 		aLbFormat.SelectEntryPos( (USHORT) ( pFileField->GetFormat() ) );
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxAuthorField ) )
//STRIP001 	{
//STRIP001 		const SvxAuthorField* pAuthorField = (const SvxAuthorField*) pField;
//STRIP001 		SvxAuthorField aAuthorField( *pAuthorField );
//STRIP001 
//STRIP001 		for( USHORT i = 0; i < 4; i++ )
//STRIP001 		{
//STRIP001 			aAuthorField.SetFormat( (SvxAuthorFormat) i );
//STRIP001 			aLbFormat.InsertEntry( aAuthorField.GetFormatted() );
//STRIP001 		}
//STRIP001 
//STRIP001 		aLbFormat.SelectEntryPos( (USHORT) ( pAuthorField->GetFormat() ) );
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 }

//STRIP001 void SdModifyFieldDlg::FillControls()
//STRIP001 {
//STRIP001 	aLbFormat.Clear();
//STRIP001 
//STRIP001 	if( pField->ISA( SvxDateField ) )
//STRIP001 	{
//STRIP001 		const SvxDateField* pDateField = (const SvxDateField*) pField;
//STRIP001 		SvxDateField aDateField( *pDateField );
//STRIP001 
//STRIP001 		if( pDateField->GetType() == SVXDATETYPE_FIX )
//STRIP001 			aRbtFix.Check();
//STRIP001 		else
//STRIP001 			aRbtVar.Check();
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxExtTimeField ) )
//STRIP001 	{
//STRIP001 		const SvxExtTimeField* pTimeField = (const SvxExtTimeField*) pField;
//STRIP001 		SvxExtTimeField aTimeField( *pTimeField );
//STRIP001 
//STRIP001 		if( pTimeField->GetType() == SVXTIMETYPE_FIX )
//STRIP001 			aRbtFix.Check();
//STRIP001 		else
//STRIP001 			aRbtVar.Check();
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxExtFileField ) )
//STRIP001 	{
//STRIP001 		const SvxExtFileField* pFileField = (const SvxExtFileField*) pField;
//STRIP001 		SvxExtFileField aFileField( *pFileField );
//STRIP001 
//STRIP001 		if( pFileField->GetType() == SVXFILETYPE_FIX )
//STRIP001 			aRbtFix.Check();
//STRIP001 		else
//STRIP001 			aRbtVar.Check();
//STRIP001 	}
//STRIP001 	else if( pField->ISA( SvxAuthorField ) )
//STRIP001 	{
//STRIP001 		const SvxAuthorField* pAuthorField = (const SvxAuthorField*) pField;
//STRIP001 		SvxAuthorField aAuthorField( *pAuthorField );
//STRIP001 
//STRIP001 		if( pAuthorField->GetType() == SVXAUTHORTYPE_FIX )
//STRIP001 			aRbtFix.Check();
//STRIP001 		else
//STRIP001 			aRbtVar.Check();
//STRIP001 	}
//STRIP001 	aRbtFix.SaveValue();
//STRIP001 	aRbtVar.SaveValue();
//STRIP001 
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 	if( SFX_ITEM_SET == maInputSet.GetItemState(EE_CHAR_LANGUAGE, TRUE, &pItem ) )
//STRIP001 		maLbLanguage.SelectLanguage( static_cast<const SvxLanguageItem*>(pItem)->GetLanguage() );
//STRIP001 
//STRIP001 	maLbLanguage.SaveValue();
//STRIP001 
//STRIP001 	FillFormatList();
//STRIP001 	aLbFormat.SaveValue();
//STRIP001 }


//STRIP001 IMPL_LINK( SdModifyFieldDlg, LanguageChangeHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	FillFormatList();
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }

//STRIP001 SfxItemSet SdModifyFieldDlg::GetItemSet()
//STRIP001 {
//STRIP001 	SfxItemSet aOutput( *maInputSet.GetPool(), EE_CHAR_LANGUAGE, EE_CHAR_LANGUAGE_CTL );
//STRIP001 
//STRIP001 	if( maLbLanguage.GetSelectEntryPos() != maLbLanguage.GetSavedValue() )
//STRIP001 	{
//STRIP001 		LanguageType eLangType = maLbLanguage.GetSelectLanguage();
//STRIP001 		SvxLanguageItem aItem( eLangType, EE_CHAR_LANGUAGE );
//STRIP001 		aOutput.Put( aItem );
//STRIP001 
//STRIP001 		SvxLanguageItem aItemCJK( eLangType, EE_CHAR_LANGUAGE_CJK );
//STRIP001 		aOutput.Put( aItemCJK );
//STRIP001 
//STRIP001 		SvxLanguageItem aItemCTL( eLangType, EE_CHAR_LANGUAGE_CTL );
//STRIP001 		aOutput.Put( aItemCTL );
//STRIP001 	}
//STRIP001 
//STRIP001 	return aOutput;
//STRIP001 }

}
