/*************************************************************************
 *
 *  $RCSfile: sd_dlgsnap.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:37:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <bf_svx/svxids.hrc>
// auto strip #include <bf_svx/dlgutil.hxx>
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif

#include "dlgsnap.hrc"
// auto strip #include "sdattr.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "dlgsnap.hxx"
namespace binfilter {


/*************************************************************************
|*
|* Dialog zum Einstellen des Rasters (wohl kaum ESO!)
|*
\************************************************************************/

//STRIP001 SdSnapLineDlg::SdSnapLineDlg(Window* pWindow, const SfxItemSet& rInAttrs,
//STRIP001 							 SdView* pView) :
//STRIP001 	ModalDialog (pWindow, SdResId(DLG_SNAPLINE)),
//STRIP001 	aFtX        (this, SdResId(FT_X)),
//STRIP001 	aFtY        (this, SdResId(FT_Y)),
//STRIP001 	aMtrFldX    (this, SdResId(MTR_FLD_X)),
//STRIP001 	aMtrFldY    (this, SdResId(MTR_FLD_Y)),
//STRIP001 	aFlPos      (this, SdResId(FL_POSITION)),
//STRIP001 	aFlDir      (this, SdResId(FL_DIRECTION)),
//STRIP001 	aRbHorz     (this, SdResId(RB_HORIZONTAL)),
//STRIP001 	aRbVert     (this, SdResId(RB_VERTICAL)),
//STRIP001 	aRbPoint    (this, SdResId(RB_POINT)),
//STRIP001 	aBtnOK      (this, SdResId(BTN_OK)),
//STRIP001 	aBtnCancel  (this, SdResId(BTN_CANCEL)),
//STRIP001 	aBtnHelp    (this, SdResId(BTN_HELP)),
//STRIP001 	aBtnDelete  (this, SdResId(BTN_DELETE)),
//STRIP001 	eUIUnit(pView->GetDoc()->GetUIUnit()),
//STRIP001 	aUIScale(pView->GetDoc()->GetUIScale())
//STRIP001 {
//STRIP001 	aRbPoint.SetModeImage( Image( SdResId( BMP_POINT_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aRbVert.SetModeImage( Image( SdResId( BMP_VERTICAL_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aRbHorz.SetModeImage( Image( SdResId( BMP_HORIZONTAL_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aRbHorz.SetClickHdl(LINK(this, SdSnapLineDlg, ClickHdl));
//STRIP001 	aRbVert.SetClickHdl(LINK(this, SdSnapLineDlg, ClickHdl));
//STRIP001 	aRbPoint.SetClickHdl(LINK(this, SdSnapLineDlg, ClickHdl));
//STRIP001 
//STRIP001 	aBtnDelete.SetClickHdl(LINK(this, SdSnapLineDlg, ClickHdl));
//STRIP001 
//STRIP001 	SetFieldUnit( aMtrFldX, eUIUnit, TRUE );
//STRIP001 	SetFieldUnit( aMtrFldY, eUIUnit, TRUE );
//STRIP001 
//STRIP001 	// WorkArea holen
//STRIP001 	Rectangle aWorkArea = pView->GetWorkArea();
//STRIP001 
//STRIP001 	// PoolUnit ermitteln
//STRIP001 	SfxItemPool* pPool = rInAttrs.GetPool();
//STRIP001 	DBG_ASSERT( pPool, "Wo ist der Pool?" );
//STRIP001 	SfxMapUnit ePoolUnit = pPool->GetMetric( SID_ATTR_FILL_HATCH );
//STRIP001 
//STRIP001 	// Hier werden die Max- und MinWerte in Ahaengigkeit von der
//STRIP001 	// WorkArea, PoolUnit und der FieldUnit:
//STRIP001 	SetMetricValue( aMtrFldX, aWorkArea.Left(), ePoolUnit );
//STRIP001 	long nValue = aMtrFldX.GetValue();
//STRIP001 	nValue = Fraction( nValue ) / aUIScale;
//STRIP001 	aMtrFldX.SetMin( nValue );
//STRIP001 	aMtrFldX.SetFirst( nValue );
//STRIP001 
//STRIP001 	SetMetricValue( aMtrFldX, aWorkArea.Right()+1, ePoolUnit );
//STRIP001 	nValue = aMtrFldX.GetValue();
//STRIP001 	nValue = Fraction( nValue ) / aUIScale;
//STRIP001 	aMtrFldX.SetMax( nValue );
//STRIP001 	aMtrFldX.SetLast( nValue );
//STRIP001 
//STRIP001 	SetMetricValue( aMtrFldY, aWorkArea.Top(), ePoolUnit );
//STRIP001 	nValue = aMtrFldY.GetValue();
//STRIP001 	nValue = Fraction( nValue ) / aUIScale;
//STRIP001 	aMtrFldY.SetMin( nValue );
//STRIP001 	aMtrFldY.SetFirst( nValue );
//STRIP001 
//STRIP001 	SetMetricValue( aMtrFldY, aWorkArea.Bottom()+1, ePoolUnit );
//STRIP001 	nValue = aMtrFldY.GetValue();
//STRIP001 	nValue = Fraction( nValue ) / aUIScale;
//STRIP001 	aMtrFldY.SetMax( nValue );
//STRIP001 	aMtrFldY.SetLast( nValue );
//STRIP001 
//STRIP001 	// Setzen der Werte
//STRIP001 	nXValue = ((const SfxUInt32Item&) rInAttrs.Get(ATTR_SNAPLINE_X)).GetValue();
//STRIP001 	nYValue = ((const SfxUInt32Item&) rInAttrs.Get(ATTR_SNAPLINE_Y)).GetValue();
//STRIP001 	nXValue = Fraction(nXValue) / aUIScale;
//STRIP001 	nYValue = Fraction(nYValue) / aUIScale;
//STRIP001 	SetMetricValue( aMtrFldX, nXValue, SFX_MAPUNIT_100TH_MM);
//STRIP001 	SetMetricValue( aMtrFldY, nYValue, SFX_MAPUNIT_100TH_MM);
//STRIP001 
//STRIP001 	aRbPoint.Check();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fuellt uebergebenes Item-Set mit Dialogbox-Attributen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdSnapLineDlg, ClickHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 	if ( pBtn == &aRbPoint )		SetInputFields(TRUE, TRUE);
//STRIP001 	else if ( pBtn == &aRbHorz )	SetInputFields(FALSE, TRUE);
//STRIP001 	else if ( pBtn == &aRbVert )	SetInputFields(TRUE, FALSE);
//STRIP001 	else if ( pBtn == &aBtnDelete ) EndDialog(RET_SNAP_DELETE);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fuellt uebergebenes Item-Set mit Dialogbox-Attributen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdSnapLineDlg::GetAttr(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	SnapKind eKind;
//STRIP001 
//STRIP001 	if ( aRbHorz.IsChecked() )		eKind = SK_HORIZONTAL;
//STRIP001 	else if ( aRbVert.IsChecked() ) eKind = SK_VERTICAL;
//STRIP001 	else							eKind = SK_POINT;
//STRIP001 
//STRIP001 	nXValue = Fraction( GetCoreValue( aMtrFldX, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 	nYValue = Fraction( GetCoreValue( aMtrFldY, SFX_MAPUNIT_100TH_MM) ) * aUIScale;
//STRIP001 
//STRIP001 	rOutAttrs.Put(SfxAllEnumItem(ATTR_SNAPLINE_KIND, eKind));
//STRIP001 	rOutAttrs.Put(SfxUInt32Item(ATTR_SNAPLINE_X, nXValue));
//STRIP001 	rOutAttrs.Put(SfxUInt32Item(ATTR_SNAPLINE_Y, nYValue));
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Gruppe mit Radiobutton verstecken
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdSnapLineDlg::HideRadioGroup()
//STRIP001 {
//STRIP001 	aFlDir.Hide();
//STRIP001 	aRbHorz.Hide();
//STRIP001 	aRbVert.Hide();
//STRIP001 	aRbPoint.Hide();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* X- bzw. Y-Inputfeld disablen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdSnapLineDlg::SetInputFields(BOOL bEnableX, BOOL bEnableY)
//STRIP001 {
//STRIP001 	if ( bEnableX )
//STRIP001 	{
//STRIP001 		if ( !aMtrFldX.IsEnabled() )
//STRIP001 			aMtrFldX.SetValue(nXValue);
//STRIP001 		aMtrFldX.Enable();
//STRIP001 		aFtX.Enable();
//STRIP001 	}
//STRIP001 	else if ( aMtrFldX.IsEnabled() )
//STRIP001 	{
//STRIP001 		nXValue = aMtrFldX.GetValue();
//STRIP001 		aMtrFldX.SetText(String());
//STRIP001 		aMtrFldX.Disable();
//STRIP001 		aFtX.Disable();
//STRIP001 	}
//STRIP001 	if ( bEnableY )
//STRIP001 	{
//STRIP001 		if ( !aMtrFldY.IsEnabled() )
//STRIP001 			aMtrFldY.SetValue(nYValue);
//STRIP001 		aMtrFldY.Enable();
//STRIP001 		aFtY.Enable();
//STRIP001 	}
//STRIP001 	else if ( aMtrFldY.IsEnabled() )
//STRIP001 	{
//STRIP001 		nYValue = aMtrFldY.GetValue();
//STRIP001 		aMtrFldY.SetText(String());
//STRIP001 		aMtrFldY.Disable();
//STRIP001 		aFtY.Disable();
//STRIP001 	}
//STRIP001 }



}
