/*************************************************************************
 *
 *  $RCSfile: showview.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//STRIP001 #ifndef _SD_SHOWVIEW_HXX
//STRIP001 #define _SD_SHOWVIEW_HXX
//STRIP001 
//STRIP001 #ifndef _SVX_FMVIEW_HXX
//STRIP001 #include <bf_svx/fmview.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 class SdDrawDocument;
//STRIP001 class SdViewShell;
//STRIP001 
/*************************************************************************
|*
|*	  Beschreibung		ShowView ist die View fuer die Diashow
|*
\************************************************************************/
//STRIP001 
//STRIP001 class ShowView : public FmFormView
//STRIP001 {
//STRIP001 	SdDrawDocument* pDrDoc;
//STRIP001 	SdViewShell*	pViewSh;
//STRIP001 	Window*         pWindowForPlugIns;
//STRIP001 	USHORT			nAllowInvalidateSmph;
//STRIP001 	BOOL			bAllowMasterPageCaching;
//STRIP001 
//STRIP001  public:
//STRIP001 					// wenn waehrend des Zeichnens Plugins 'connected'
//STRIP001 					// werden sollen, muss pWWin ein Zeiger auf das Fenster
//STRIP001 					// sein, das das Plugin benutzen soll
//STRIP001 					ShowView(SdDrawDocument* pDoc, OutputDevice* pOut,
//STRIP001 							 SdViewShell* pViewShell, Window* pWin = NULL);
//STRIP001 					~ShowView();
//STRIP001 
//STRIP001 	SdDrawDocument& GetDoc() const			{ return *pDrDoc; }
//STRIP001 
//STRIP001 			void	SetAllowInvalidate(BOOL bFlag);
//STRIP001 			BOOL	IsInvalidateAllowed() const;
//STRIP001 
//STRIP001 			void	SetAllowMasterPageCaching(BOOL bAllow)
//STRIP001 					{ bAllowMasterPageCaching = bAllow; }
//STRIP001 			BOOL	IsMasterPageCachingAllowed() const
//STRIP001 					{ return(bAllowMasterPageCaching); }
//STRIP001 
//STRIP001 	virtual void	InitRedraw(OutputDevice* pOutDev, const Region& rReg);
//STRIP001 	virtual void	InvalidateOneWin(Window& rWin);
//STRIP001 	virtual void	InvalidateOneWin(Window& rWin, const Rectangle& rRect);
//STRIP001 
//STRIP001 	virtual void	DoConnect(SdrOle2Obj* pOleObj);
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 #endif		// _SD_SHOWVIEW_HXX


