/*************************************************************************
 *
 *  $RCSfile: sprite.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//STRIP001 #ifndef _SPRITE_HXX
//STRIP001 #define _SPRITE_HXX
//STRIP001 
//STRIP001 #ifndef _SV_VIRDEV_HXX //autogen
//STRIP001 #include <vcl/virdev.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_REGION_HXX //autogen
//STRIP001 #include <vcl/region.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_MAPMOD_HXX //autogen
//STRIP001 #include <vcl/mapmod.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_IMAGE_HXX //autogen
//STRIP001 #include <vcl/image.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_BITMAPEX_HXX //autogen
//STRIP001 #include <vcl/bitmapex.hxx>
//STRIP001 #endif

// ----------
// - Sprite -
// ----------

//STRIP001 class SdMetaFile;
//STRIP001 class Marker;
//STRIP001 
//STRIP001 class Sprite
//STRIP001 {
//STRIP001 protected:
//STRIP001 
//STRIP001 	MapMode			aOldMap;
//STRIP001 	Region			aOldClip;
//STRIP001 	Rectangle		aPaintRect;
//STRIP001 	Point			aPt;
//STRIP001 	Size			aSz;
//STRIP001 	Point			aLayerOffsetPix;
//STRIP001 	VirtualDevice*	pPaintDev;
//STRIP001 	VirtualDevice*	pBottomLayer;
//STRIP001 	BitmapEx*		pActBmpEx;
//STRIP001 	BitmapEx*		pTopLayer;
//STRIP001 	SdMetaFile**	ppTopMtf;
//STRIP001 	Marker*			pObjStartMarker;
//STRIP001 	Marker*			pObjEndMarker;
//STRIP001 	List*			pListOfBmpEx;
//STRIP001 	ULONG			nLastTime;
//STRIP001 	BOOL			bClipRegion;
//STRIP001 
//STRIP001 	BOOL			ImplPrepareMoveTo();
//STRIP001 	void			ImplDrawSprite( OutputDevice* pOut, const Point& rPt, const Size& rSz );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 					Sprite( List* pListOfBmpEx );
//STRIP001 					~Sprite();
//STRIP001 
//STRIP001 	BOOL			StartMoving( OutputDevice* pOut,
//STRIP001 								 OutputDevice* pBottomLayer = NULL,
//STRIP001 								 BitmapEx* pTopLayer = NULL,
//STRIP001 								 SdMetaFile** ppTopMtf = NULL, 
//STRIP001 								 Marker* pObjStartMarker = NULL,
//STRIP001 								 Marker* pObjEndMarker = NULL );
//STRIP001 	void			MoveTo( OutputDevice* pOut, const Point& rPt, const Size* pSz = NULL );
//STRIP001 	void			MoveTo( OutputDevice* pOut, const Point& rPt, const double& rScaleX, const double& rScaleY );
//STRIP001 	void			EndMoving( OutputDevice* pOut );
//STRIP001 };

//STRIP001 #endif // _SPRITE_HXX
