/*************************************************************************
 *
 *  $RCSfile: sd_outlview.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:17:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _FORBIDDENCHARACTERSTABLE_HXX
// auto strip #include <bf_svx/forbiddencharacterstable.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PROGRESS_HXX
// auto strip #include <bf_sfx2/progress.hxx>
// auto strip #endif
// auto strip #ifndef _SV_WRKWIN_HXX
// auto strip #include <vcl/wrkwin.hxx>
// auto strip #endif
#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
#include "eetext.hxx"       // definiert ITEMID_... fuer frmitems und textitem
#ifndef _EEITEM_HXX
#include <bf_svx/eeitem.hxx>
#endif
// auto strip #ifndef _EDITSTAT_HXX
// auto strip #include <bf_svx/editstat.hxx>
// auto strip #endif
// auto strip #ifndef _LRSPITEM_HXX
// auto strip #include <bf_svx/lrspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX //autogen
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTBMGR_HXX //autogen
// auto strip #include <bf_sfx2/stbmgr.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _SVDORECT_HXX //autogen
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _SFXBRDCST_HXX //autogen
// auto strip #include <svtools/brdcst.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ADJITEM_HXX
// auto strip #include <bf_svx/adjitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_TSPTITEM_HXX
// auto strip #include <bf_svx/tstpitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_LSPCITEM_HXX
// auto strip #include <bf_svx/lspcitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_NUMITEM_HXX
// auto strip #include <bf_svx/numitem.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLOBJ_HXX //autogen
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_NUMITEM_HXX
// auto strip #include <bf_svx/numitem.hxx>
// auto strip #endif

// #97766#
// auto strip #ifndef _EDITOBJ_HXX
// auto strip #include <bf_svx/editobj.hxx>
// auto strip #endif

#pragma hdrstop

// auto strip #include "docshell.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "outlview.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "pres.hxx"
// auto strip #include "outlnvsh.hxx"
#include "app.hrc"
#include "glob.hrc"
// auto strip #include "sdresid.hxx"
#include "sdoutl.hxx"
#include "strings.hrc"
namespace binfilter {

#pragma code_seg("STATICS")
static USHORT SidArray[] = {
				SID_OUTLINE_UP,
				SID_OUTLINE_DOWN,
				SID_OUTLINE_LEFT,
				SID_OUTLINE_RIGHT,
				SID_OUTLINE_COLLAPSE_ALL,
				SID_OUTLINE_COLLAPSE,
				SID_OUTLINE_EXPAND_ALL,
				SID_OUTLINE_EXPAND,
				0 };
#pragma code_seg()


// Breite: DIN A 4,  zwei Raender zu je 1 cm
#define OUTLINE_PAPERWIDTH 19000

// beim Seitenmanipulation Fortschrittsanzeige, wenn mehr Seiten betroffen
// sind als:
#define PROCESS_WITH_PROGRESS_THRESHOLD  5

//STRIP001 struct SdParaAndPos
//STRIP001 {
//STRIP001 	Paragraph* pPara;
//STRIP001 	USHORT	   nPos;
//STRIP001 };
//STRIP001 
//STRIP001 TYPEINIT1( SdOutlineView, SdView );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdOutlineView::SdOutlineView(SdDrawDocShell* pDocSh, Window* pWindow,
//STRIP001 							 SdOutlineViewShell* pOutlineViewSh)
//STRIP001 	: SdView(pDocSh->GetDoc(), pWindow, pOutlineViewSh),
//STRIP001 	  pOutlineViewShell(pOutlineViewSh),
//STRIP001 	  pOutliner( pDoc->GetOutliner(TRUE) ),
//STRIP001 	  pOldParaOrder(NULL),
//STRIP001 	  pSelectedParas(NULL),
//STRIP001 	  bFirstPaint(TRUE),
//STRIP001 	  nPagesToProcess(0),
//STRIP001 	  nPagesProcessed(0),
//STRIP001 	  mbHighContrastMode( false ),
//STRIP001 	  maDocColor( COL_WHITE ),
//STRIP001 	  mpProgress(NULL)
//STRIP001 {
//STRIP001 	BOOL bInitOutliner = FALSE;
//STRIP001 
//STRIP001 	if (pOutliner->GetViewCount() == 0)
//STRIP001 	{
//STRIP001 		// Outliner initialisieren: Referenz-Device setzen
//STRIP001 		bInitOutliner = TRUE;
//STRIP001 		pOutliner->Init( OUTLINERMODE_OUTLINEVIEW );
//STRIP001 
//STRIP001 		SfxStyleSheet* pTitleSheet = pDoc->GetSdPage( 0, PK_STANDARD )->GetStyleSheetForPresObj( PRESOBJ_TITLE );
//STRIP001 
//STRIP001 		if ( pTitleSheet )
//STRIP001 		{
//STRIP001 			// set title symbol (level 0)
//STRIP001 			SvxNumBulletItem aNumBulletItem( (const SvxNumBulletItem&) pTitleSheet->GetItemSet().Get(EE_PARA_NUMBULLET) );
//STRIP001 			SvxNumRule aNumRule(* aNumBulletItem.GetNumRule());
//STRIP001 			SvxNumberFormat aFormat( aNumRule.GetLevel(0));
//STRIP001             Font    aBulletFont;
//STRIP001             const Font* pFont = aFormat.GetBulletFont();
//STRIP001             if ( pFont )                                        // if available take font size and color from style
//STRIP001                 aBulletFont = *pFont;
//STRIP001             else
//STRIP001             {
//STRIP001                 aBulletFont.SetColor( COL_AUTO );
//STRIP001                 aBulletFont.SetHeight( 1552 );
//STRIP001             }
//STRIP001             aBulletFont.SetCharSet(RTL_TEXTENCODING_MS_1252);   // and replacing other values by standard
//STRIP001             aBulletFont.SetName( String( RTL_CONSTASCII_USTRINGPARAM( "StarSymbol" )) );
//STRIP001 	        aBulletFont.SetWeight(WEIGHT_NORMAL);
//STRIP001 	        aBulletFont.SetUnderline(UNDERLINE_NONE);
//STRIP001 	        aBulletFont.SetStrikeout(STRIKEOUT_NONE);
//STRIP001 	        aBulletFont.SetItalic(ITALIC_NONE);
//STRIP001 	        aBulletFont.SetOutline(FALSE);
//STRIP001 	        aBulletFont.SetShadow(FALSE);
//STRIP001             aFormat.SetBulletFont( &aBulletFont );
//STRIP001 			aFormat.SetBulletChar( 0xE011 );  // StarBats: 0xF000 + 114
//STRIP001 			pOutliner->OverwriteLevel0Bullet( aFormat );
//STRIP001 		}
//STRIP001 
//STRIP001 		pOutliner->SetRefDevice( SD_MOD()->GetRefDevice( *pDocSh ) );
//STRIP001 		ULONG nWidth = OUTLINE_PAPERWIDTH;
//STRIP001 		pOutliner->SetPaperSize(Size(nWidth, 4000000000));
//STRIP001 	}
//STRIP001 
//STRIP001 	// View in Outliner einfuegen
//STRIP001 	for (USHORT nView = 0; nView < MAX_OUTLINERVIEWS; nView++)
//STRIP001 	{
//STRIP001 		pOutlinerView[nView] = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	pOutlinerView[0] = new OutlinerView(pOutliner, pWindow);
//STRIP001 	Rectangle aNullRect;
//STRIP001 	pOutlinerView[0]->SetOutputArea(aNullRect);
//STRIP001 	pOutliner->SetUpdateMode(FALSE);
//STRIP001 	pOutliner->InsertView(pOutlinerView[0], LIST_APPEND);
//STRIP001 
//STRIP001 	onUpdateStyleSettings( true );
//STRIP001 
//STRIP001 	if (bInitOutliner)
//STRIP001 	{
//STRIP001 		// Outliner mit Inhalt fuellen
//STRIP001 		FillOutliner();
//STRIP001 	}
//STRIP001 
//STRIP001 	pWindow->GrabFocus();
//STRIP001 
//STRIP001 	Application::AddEventListener( LINK( this, SdOutlineView, AppEventListenerHdl ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor, Links restaurieren, Outliner leeren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdOutlineView::~SdOutlineView()
//STRIP001 {
//STRIP001 	Application::RemoveEventListener( LINK( this, SdOutlineView, AppEventListenerHdl ) );
//STRIP001 
//STRIP001 	if( mpProgress )
//STRIP001 		delete mpProgress;
//STRIP001 
//STRIP001 	// OutlinerViews abmelden und zerstoeren
//STRIP001 	for (USHORT nView = 0; nView < MAX_OUTLINERVIEWS; nView++)
//STRIP001 	{
//STRIP001 		if (pOutlinerView[nView] != NULL)
//STRIP001 		{
//STRIP001 			pOutliner->RemoveView( pOutlinerView[nView] );
//STRIP001 			delete pOutlinerView[nView];
//STRIP001 			pOutlinerView[nView] = NULL;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pOutliner->GetViewCount() == 0)
//STRIP001 	{
//STRIP001 		// Outliner deinitialisieren: Farbdarstellung einschalten
//STRIP001 		ResetLinks();
//STRIP001 		ULONG nCntrl = pOutliner->GetControlWord();
//STRIP001 		pOutliner->SetUpdateMode(FALSE); // sonst wird bei SetControlWord gezeichnet
//STRIP001 		pOutliner->SetControlWord(nCntrl & ~EE_CNTRL_NOCOLORS);
//STRIP001 		SvtAccessibilityOptions aOptions;
//STRIP001 		pOutliner->ForceAutoColor( aOptions.GetIsAutomaticFontColor() );
//STRIP001 		pOutliner->Clear();
//STRIP001 	}
//STRIP001 
//STRIP001 	DBG_ASSERT(!pSelectedParas, "Absatzliste nicht geloescht");
//STRIP001 	DBG_ASSERT(!pOldParaOrder, "Absatzliste nicht geloescht");
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Paint-Methode
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::Paint(const Rectangle& rRect, SdWindow* pWin)
//STRIP001 {
//STRIP001 	OutlinerView* pOlView = GetViewByWindow(pWin);
//STRIP001 
//STRIP001 	if (pOlView)
//STRIP001 	{
//STRIP001 		pOlView->HideCursor();
//STRIP001 		pOlView->Paint(rRect);
//STRIP001 		pOlView->ShowCursor(bFirstPaint);
//STRIP001 		bFirstPaint = FALSE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fenster-Groesse hat sich geaendert
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::AdjustPosSizePixel(const Point &rNewPos,
//STRIP001 									   const Size &rNewSize, SdWindow* pWindow)
//STRIP001 {
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ein Fenster hinzufuegen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::AddWin(SdWindow* pWin)
//STRIP001 {
//STRIP001 	BOOL bAdded = FALSE;
//STRIP001 	BOOL bValidArea = FALSE;
//STRIP001 	Rectangle aOutputArea;
//STRIP001 	const Color aWhiteColor( COL_WHITE );
//STRIP001 	USHORT nView = 0;
//STRIP001 
//STRIP001 	while (nView < MAX_OUTLINERVIEWS && !bAdded)
//STRIP001 	{
//STRIP001 		if (pOutlinerView[nView] == NULL)
//STRIP001 		{
//STRIP001 			pOutlinerView[nView] = new OutlinerView(pOutliner, pWin);
//STRIP001 			pOutlinerView[nView]->SetBackgroundColor( aWhiteColor );
//STRIP001 			pOutliner->InsertView(pOutlinerView[nView], LIST_APPEND);
//STRIP001 			bAdded = TRUE;
//STRIP001 
//STRIP001 			if (bValidArea)
//STRIP001 			{
//STRIP001 				pOutlinerView[nView]->SetOutputArea(aOutputArea);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if (!bValidArea)
//STRIP001 		{
//STRIP001 			aOutputArea = pOutlinerView[nView]->GetOutputArea();
//STRIP001 			bValidArea = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		nView++;
//STRIP001 	}
//STRIP001 
//STRIP001 	// weisser Hintergrund im Outliner
//STRIP001 	pWin->SetBackground( Wallpaper( aWhiteColor ) );
//STRIP001 
//STRIP001 	SdView::AddWin(pWin);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ein Fenster entfernen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::DelWin(SdWindow* pWin)
//STRIP001 {
//STRIP001 	BOOL bRemoved = FALSE;
//STRIP001 	USHORT nView = 0;
//STRIP001 	Window* pWindow;
//STRIP001 
//STRIP001 	while (nView < MAX_OUTLINERVIEWS && !bRemoved)
//STRIP001 	{
//STRIP001 		if (pOutlinerView[nView] != NULL)
//STRIP001 		{
//STRIP001 			pWindow = pOutlinerView[nView]->GetWindow();
//STRIP001 
//STRIP001 			if (pWindow == pWin)
//STRIP001 			{
//STRIP001 				pOutliner->RemoveView( pOutlinerView[nView] );
//STRIP001 				delete pOutlinerView[nView];
//STRIP001 				pOutlinerView[nView] = NULL;
//STRIP001 				bRemoved = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		nView++;
//STRIP001 	}
//STRIP001 
//STRIP001 	SdView::DelWin(pWin);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Zeiger der dem Fenster entsprechenden OutlinerView zurueckgeben.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 OutlinerView* SdOutlineView::GetViewByWindow(Window* pWin) const
//STRIP001 {
//STRIP001 	OutlinerView* pOlView = NULL;
//STRIP001 	for (USHORT nView = 0; nView < MAX_OUTLINERVIEWS; nView++)
//STRIP001 	{
//STRIP001 		if (pOutlinerView[nView] != NULL)
//STRIP001 		{
//STRIP001 			if ( pWin == pOutlinerView[nView]->GetWindow() )
//STRIP001 			{
//STRIP001 				pOlView = pOutlinerView[nView];
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return (pOlView);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ermittelt den Titel vor einem beliebigen Absatz.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 Paragraph* SdOutlineView::GetPrevTitle(const Paragraph* pPara)
//STRIP001 {
//STRIP001 	Paragraph* pResult = NULL;
//STRIP001 	ULONG	   nPos    = pOutliner->GetAbsPos((Paragraph*)pPara);
//STRIP001 
//STRIP001 	if (nPos > 0)
//STRIP001 	{
//STRIP001 		while (nPos && !pResult)
//STRIP001 		{
//STRIP001 			pPara = pOutliner->GetParagraph(--nPos);
//STRIP001 			if ( pOutliner->GetDepth( (USHORT) nPos ) == 0 )
//STRIP001 			{
//STRIP001 				pResult = (Paragraph*)pPara;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 	}
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ermittelt den Titel nach einem beliebigen Absatz.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 Paragraph* SdOutlineView::GetNextTitle(const Paragraph* pPara)
//STRIP001 {
//STRIP001 	ULONG nPos = pOutliner->GetAbsPos((Paragraph*)pPara);
//STRIP001 
//STRIP001 	Paragraph* pResult = (Paragraph*)pPara;
//STRIP001 	do
//STRIP001 	{
//STRIP001 		pResult = pOutliner->GetParagraph(++nPos);
//STRIP001 	}
//STRIP001 	while (pResult && pOutliner->GetDepth( (USHORT) nPos ) != 0);
//STRIP001 
//STRIP001 	if (pResult && pOutliner->GetDepth( (USHORT) nPos ) != 0)
//STRIP001 	{
//STRIP001 		pResult = NULL;
//STRIP001 	}
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Einfuegen von Seiten (Absaetzen)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, ParagraphInsertedHdl, Outliner *, pOutliner )
//STRIP001 {
//STRIP001 	Paragraph* pPara = pOutliner->GetHdlParagraph();
//STRIP001 
//STRIP001 	if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) == 0 )
//STRIP001 	{
//STRIP001 		// wieviele Titel sind vor dem neuen Titelabsatz?
//STRIP001 		ULONG nExample = 0L;			// Position der "Vorbild"seite
//STRIP001 		ULONG nTarget  = 0L;			// Einfuegeposition
//STRIP001 		while(pPara)
//STRIP001 		{
//STRIP001 			pPara = GetPrevTitle(pPara);
//STRIP001 			if (pPara)
//STRIP001 				nTarget++;
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 		// was der Outliner nicht kann, muss hier wieder wettgemacht werden:
//STRIP001 		// wenn VOR dem ersten Absatz ein neuer Absatz mit RETURN erzeugt wird,
//STRIP001 		// meldet der Outliner den bereits bestehenden (jetzt nach unten
//STRIP001 		// gerutschten) Absatz als neuen Absatz; nicht darauf reinfallen!
//STRIP001 		if (nTarget == 1)
//STRIP001 		{
//STRIP001 			String aTest(pOutliner->GetText( pOutliner->GetParagraph( 0 ) ));
//STRIP001 			if (aTest.Len() == 0)
//STRIP001 			{
//STRIP001 				nTarget = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 		// "Vorbild"seite ist - wenn vorhanden - die Vorgaengerseite
//STRIP001 		if (nTarget > 0)
//STRIP001 		{
//STRIP001 			nExample = nTarget - 1;
//STRIP001 		}
//STRIP001 
//STRIP001 		// #96090# added string to create no empty UNDO actions (in ListBox)
//STRIP001 		BegUndo( String( SdResId(STR_INSERTPAGE) ) );
//STRIP001 
//STRIP001 		/**********************************************************************
//STRIP001 		* Es wird stets zuerst eine Standardseite und dann eine
//STRIP001 		* Notizseite erzeugt. Es ist sichergestellt, dass auf eine
//STRIP001 		* Standardseite stets die zugehoerige Notizseite folgt.
//STRIP001 		* Vorangestellt ist genau eine Handzettelseite
//STRIP001 		**********************************************************************/
//STRIP001 
//STRIP001 		// diese Seite hat Vorbildfunktion
//STRIP001 		SdPage* pExample = (SdPage*)pDoc->GetSdPage((USHORT)nExample, PK_STANDARD);
//STRIP001 		SdPage*    pPage = (SdPage*)pDoc->AllocPage(FALSE);
//STRIP001 
//STRIP001 		pPage->SetLayoutName(pExample->GetLayoutName());
//STRIP001 
//STRIP001 		// einfuegen (Seite)
//STRIP001 		pDoc->InsertPage(pPage, (USHORT)(nTarget) * 2 + 1);
//STRIP001 		AddUndo(new SdrUndoNewPage(*pPage));
//STRIP001 
//STRIP001 		// der Standardseite eine Masterpage zuweisen
//STRIP001 		USHORT nPgNum = pExample->GetMasterPageNum(0);
//STRIP001 		pPage->InsertMasterPage(nPgNum);
//STRIP001 
//STRIP001 		// Seitengroesse setzen
//STRIP001 		pPage->SetSize(pExample->GetSize());
//STRIP001 		pPage->SetBorder( pExample->GetLftBorder(),
//STRIP001 						  pExample->GetUppBorder(),
//STRIP001 						  pExample->GetRgtBorder(),
//STRIP001 						  pExample->GetLwrBorder() );
//STRIP001 
//STRIP001 		// neue Praesentationsobjekte anlegen (auf <Titel> oder
//STRIP001 		// <Titel mit Untertitel> folgt <Titel mit Gliederung>, ansonsten
//STRIP001 		// wird das Layout von der Vorgaengerseite uebernommen)
//STRIP001 		AutoLayout eAutoLayout = pExample->GetAutoLayout();
//STRIP001 		if (eAutoLayout == AUTOLAYOUT_TITLE ||
//STRIP001 			eAutoLayout == AUTOLAYOUT_ONLY_TITLE)
//STRIP001 		{
//STRIP001 			pPage->SetAutoLayout(AUTOLAYOUT_ENUM, TRUE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pPage->SetAutoLayout(pExample->GetAutoLayout(), TRUE);
//STRIP001 		}
//STRIP001 
//STRIP001 		/**********************************************************************
//STRIP001 		|* jetzt die Notizseite
//STRIP001 		\*********************************************************************/
//STRIP001 		pExample = (SdPage*)pDoc->GetSdPage((USHORT)nExample, PK_NOTES);
//STRIP001 		SdPage* pNotesPage = (SdPage*)pDoc->AllocPage(FALSE);
//STRIP001 
//STRIP001 		pNotesPage->SetLayoutName(pExample->GetLayoutName());
//STRIP001 
//STRIP001 		pNotesPage->SetPageKind(PK_NOTES);
//STRIP001 
//STRIP001 		// einfuegen (Notizseite)
//STRIP001 		pDoc->InsertPage(pNotesPage, (USHORT)(nTarget) * 2 + 2);
//STRIP001 		AddUndo(new SdrUndoNewPage(*pNotesPage));
//STRIP001 
//STRIP001 		// der Notizseite eine Masterpage zuweisen
//STRIP001 		nPgNum = pExample->GetMasterPageNum(0);
//STRIP001 		pNotesPage->InsertMasterPage(nPgNum);
//STRIP001 
//STRIP001 		// Seitengroesse setzen, es muss bereits eine Seite vorhanden sein
//STRIP001 		pNotesPage->SetSize(pExample->GetSize());
//STRIP001 		pNotesPage->SetBorder( pExample->GetLftBorder(),
//STRIP001 							   pExample->GetUppBorder(),
//STRIP001 							   pExample->GetRgtBorder(),
//STRIP001 							   pExample->GetLwrBorder() );
//STRIP001 
//STRIP001 		// neue Praesentationsobjekte anlegen
//STRIP001 		pNotesPage->SetAutoLayout(pExample->GetAutoLayout(), TRUE);
//STRIP001 
//STRIP001 		EndUndo();
//STRIP001 
//STRIP001 		SfxUndoManager* pDocUndoMgr = pDocSh->GetUndoManager();
//STRIP001 		SfxLinkUndoAction* pLink = new SfxLinkUndoAction(pDocUndoMgr);
//STRIP001 		pOutliner->GetUndoManager().AddUndoAction(pLink);
//STRIP001 
//STRIP001 		pOutliner->UpdateFields();
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Loeschen von Seiten (Absaetzen)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, ParagraphRemovingHdl, Outliner *, pOutliner )
//STRIP001 {
//STRIP001 	Paragraph* pPara = pOutliner->GetHdlParagraph();
//STRIP001 	if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) == 0 )
//STRIP001 	{
//STRIP001 		// wieviele Titel sind vor dem fraglichen Titelabsatz?
//STRIP001 		ULONG nPos = 0L;
//STRIP001 		while(pPara)
//STRIP001 		{
//STRIP001 			pPara = GetPrevTitle(pPara);
//STRIP001 			if (pPara) nPos++;
//STRIP001 		}
//STRIP001 
//STRIP001 		// Seite und Notizseite loeschen
//STRIP001 		BegUndo();
//STRIP001 
//STRIP001 		USHORT nAbsPos = (USHORT)nPos * 2 + 1;
//STRIP001 		SdrPage* pPage = pDoc->GetPage(nAbsPos);
//STRIP001 		AddUndo(new SdrUndoDelPage(*pPage));
//STRIP001 		pDoc->RemovePage(nAbsPos);
//STRIP001 
//STRIP001 		nAbsPos = (USHORT)nPos * 2 + 1;
//STRIP001 		pPage = pDoc->GetPage(nAbsPos);
//STRIP001 		AddUndo(new SdrUndoDelPage(*pPage));
//STRIP001 		pDoc->RemovePage(nAbsPos);
//STRIP001 
//STRIP001 		EndUndo();
//STRIP001 
//STRIP001 		SfxUndoManager* pDocUndoMgr = pDocSh->GetUndoManager();
//STRIP001 		SfxLinkUndoAction* pLink = new SfxLinkUndoAction(pDocUndoMgr);
//STRIP001 		pOutliner->GetUndoManager().AddUndoAction(pLink);
//STRIP001 
//STRIP001 		// ggfs. Fortschrittsanzeige
//STRIP001 		if (nPagesToProcess)
//STRIP001 		{
//STRIP001 			nPagesProcessed++;
//STRIP001 
//STRIP001 			if(mpProgress)
//STRIP001 				mpProgress->SetState(nPagesProcessed);
//STRIP001 
//STRIP001 			if (nPagesProcessed == nPagesToProcess)
//STRIP001 			{
//STRIP001 				if(mpProgress)
//STRIP001 				{
//STRIP001 					delete mpProgress;
//STRIP001 					mpProgress = NULL;
//STRIP001 				}
//STRIP001 				nPagesToProcess = 0;
//STRIP001 				nPagesProcessed = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pOutliner->UpdateFields();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Aendern der Einruecktiefe von Absaetzen (macht ggfs.
//STRIP001 |* das Einfuegen oder Loeschen von Seiten notwendig)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, DepthChangedHdl, Outliner *, pOutliner )
//STRIP001 {
//STRIP001 	Paragraph* pPara = pOutliner->GetHdlParagraph();
//STRIP001 	if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) == 0 )
//STRIP001 	{
//STRIP001 		// werden da etwa mehrere Level-1-Absaetze auf Level 0 gebracht und
//STRIP001 		// wir sollten eine Fortschrittsanzeige oder Eieruhr aufsetzen und
//STRIP001 		// haben es noch nicht getan?
//STRIP001 		if (nPagesToProcess == 0)
//STRIP001 		{
//STRIP001 			Window* 	  pActWin = pOutlineViewShell->GetActiveWindow();
//STRIP001 			OutlinerView* pOlView = GetViewByWindow(pActWin);
//STRIP001 			List*		  pList   = pOlView->CreateSelectionList();
//STRIP001 
//STRIP001 			Paragraph*	  pParagraph   = (Paragraph*)pList->First();
//STRIP001 			while (pParagraph)
//STRIP001 			{
//STRIP001 				if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pParagraph ) ) == 1 )
//STRIP001 					nPagesToProcess++;
//STRIP001 				pParagraph = (Paragraph*)pList->Next();
//STRIP001 			}
//STRIP001 
//STRIP001 			nPagesToProcess++;	// der Absatz, der jetzt schon auf Level 0
//STRIP001 								// steht, gehoert auch dazu
//STRIP001 			nPagesProcessed = 0;
//STRIP001 
//STRIP001 			if (nPagesToProcess > PROCESS_WITH_PROGRESS_THRESHOLD)
//STRIP001 			{
//STRIP001 				if( mpProgress )
//STRIP001 					delete mpProgress;
//STRIP001 
//STRIP001 				const String aStr(SdResId(STR_CREATE_PAGES));
//STRIP001 				mpProgress = new SfxProgress( GetDocSh(), aStr, nPagesToProcess );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pDocSh->SetWaitCursor( TRUE );
//STRIP001 			}
//STRIP001 			delete pList;
//STRIP001 		}
//STRIP001 
//STRIP001 		ParagraphInsertedHdl(pOutliner);
//STRIP001 
//STRIP001 		nPagesProcessed++;
//STRIP001 
//STRIP001 		// muss eine Fortschrittsanzeige gepflegt werden?
//STRIP001 		if (nPagesToProcess > PROCESS_WITH_PROGRESS_THRESHOLD)
//STRIP001 		{
//STRIP001 			if (mpProgress)
//STRIP001 				mpProgress->SetState(nPagesProcessed);
//STRIP001 		}
//STRIP001 
//STRIP001 		// war das die letzte Seite?
//STRIP001 		if (nPagesProcessed == nPagesToProcess)
//STRIP001 		{
//STRIP001 			if (nPagesToProcess > PROCESS_WITH_PROGRESS_THRESHOLD && mpProgress)
//STRIP001 			{
//STRIP001 				delete mpProgress;
//STRIP001 				mpProgress = NULL;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pDocSh->SetWaitCursor( FALSE );
//STRIP001 
//STRIP001 			nPagesToProcess = 0;
//STRIP001 			nPagesProcessed = 0;
//STRIP001 		}
//STRIP001 		pOutliner->UpdateFields();
//STRIP001 	}
//STRIP001 	else if (pOutliner->GetPrevDepth() == 0)
//STRIP001 	{
//STRIP001 		// wieviele Titel sind vor dem fraglichen Titelabsatz?
//STRIP001 		ULONG nPos = 0L;
//STRIP001 		Paragraph* pParagraph = pPara;
//STRIP001 		while(pParagraph)
//STRIP001 		{
//STRIP001 			pParagraph = GetPrevTitle(pParagraph);
//STRIP001 			if (pParagraph)
//STRIP001 				nPos++;
//STRIP001 		}
//STRIP001 		// Seite und Notizseite loeschen
//STRIP001 		BegUndo();
//STRIP001 
//STRIP001 		USHORT nAbsPos = (USHORT)nPos * 2 + 1;
//STRIP001 		SdrPage* pPage = pDoc->GetPage(nAbsPos);
//STRIP001 		AddUndo(new SdrUndoDelPage(*pPage));
//STRIP001 		pDoc->RemovePage(nAbsPos);
//STRIP001 
//STRIP001 		nAbsPos = (USHORT)nPos * 2 + 1;
//STRIP001 		pPage = pDoc->GetPage(nAbsPos);
//STRIP001 		AddUndo(new SdrUndoDelPage(*pPage));
//STRIP001 		pDoc->RemovePage(nAbsPos);
//STRIP001 
//STRIP001 		EndUndo();
//STRIP001 
//STRIP001 		SfxUndoManager* pDocUndoMgr = pDocSh->GetUndoManager();
//STRIP001 		SfxLinkUndoAction* pLink = new SfxLinkUndoAction(pDocUndoMgr);
//STRIP001 		pOutliner->GetUndoManager().AddUndoAction(pLink);
//STRIP001 
//STRIP001 		// ggfs. Fortschrittsanzeige
//STRIP001 		if (nPagesToProcess)
//STRIP001 		{
//STRIP001 			nPagesProcessed++;
//STRIP001 			if (mpProgress)
//STRIP001 				mpProgress->SetState(nPagesProcessed);
//STRIP001 
//STRIP001 			if (nPagesProcessed == nPagesToProcess)
//STRIP001 			{
//STRIP001 				if(mpProgress)
//STRIP001 				{
//STRIP001 					delete mpProgress;
//STRIP001 					mpProgress = NULL;
//STRIP001 				}
//STRIP001 				nPagesToProcess = 0;
//STRIP001 				nPagesProcessed = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pOutliner->UpdateFields();
//STRIP001 	}
//STRIP001 	else if ( (pOutliner->GetPrevDepth() == 1) && ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) == 2 ) )
//STRIP001 	{
//STRIP001 		// wieviele Titel sind vor dem fraglichen Titelabsatz?
//STRIP001 		ULONG nPos = -1L;
//STRIP001 
//STRIP001 		Paragraph* pParagraph = pPara;
//STRIP001 		while(pParagraph)
//STRIP001 		{
//STRIP001 			pParagraph = GetPrevTitle(pParagraph);
//STRIP001 			if (pParagraph)
//STRIP001 				nPos++;
//STRIP001 		}
//STRIP001 
//STRIP001 		if(0 <= nPos)
//STRIP001 		{
//STRIP001 			SdPage*pPage = (SdPage*)pDoc->GetSdPage( (USHORT) nPos, PK_STANDARD);
//STRIP001 
//STRIP001 			if(pPage && pPage->GetPresObj(PRESOBJ_TEXT))
//STRIP001 				pOutliner->SetDepth( pPara, 1 );
//STRIP001 		}
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	// wieviele Titel sind vor dem fraglichen Titelabsatz?
//STRIP001 	ULONG nPos = -1L;
//STRIP001 
//STRIP001 	Paragraph* pTempPara = pPara;
//STRIP001 	while(pTempPara)
//STRIP001 	{
//STRIP001 		pTempPara = GetPrevTitle(pTempPara);
//STRIP001 		if (pTempPara)
//STRIP001 			nPos++;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( 0 <= nPos)
//STRIP001 	{
//STRIP001 		SdPage* pPage = (SdPage*) pDoc->GetSdPage( (USHORT) nPos, PK_STANDARD );
//STRIP001 
//STRIP001 		if( pPage )
//STRIP001 		{
//STRIP001 			SfxStyleSheet* pStyleSheet = NULL;
//STRIP001 			ULONG nPara = pOutliner->GetAbsPos( pPara );
//STRIP001 			ULONG nDepth = pOutliner->GetDepth( (USHORT) nPara );
//STRIP001 			BOOL bSubTitle = pPage->GetPresObj(PRESOBJ_TEXT) != NULL;
//STRIP001 
//STRIP001 			if( nDepth == 0 )
//STRIP001 			{
//STRIP001 				pStyleSheet = pPage->GetStyleSheetForPresObj( PRESOBJ_TITLE );
//STRIP001 			}
//STRIP001 			else if( bSubTitle )
//STRIP001 			{
//STRIP001 				pStyleSheet = pPage->GetStyleSheetForPresObj( PRESOBJ_TEXT );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pStyleSheet = pPage->GetStyleSheetForPresObj( PRESOBJ_OUTLINE );
//STRIP001 
//STRIP001 				if( nDepth > 1 )
//STRIP001 				{
//STRIP001 					String aNewStyleSheetName( pStyleSheet->GetName() );
//STRIP001 					aNewStyleSheetName.Erase( aNewStyleSheetName.Len()-1, 1 );
//STRIP001 					aNewStyleSheetName += String::CreateFromInt32( nDepth );
//STRIP001 					SfxStyleSheetBasePool* pStylePool = pDoc->GetStyleSheetPool();
//STRIP001 					pStyleSheet = (SfxStyleSheet*) pStylePool->Find( aNewStyleSheetName, pStyleSheet->GetFamily() );
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			// before we set the style sheet we need to preserve the bullet item
//STRIP001 			// since all items will be deleted while setting a new style sheet
//STRIP001  			SfxItemSet aOldAttrs( pOutliner->GetParaAttribs( nPara ) );
//STRIP001 
//STRIP001 			pOutliner->SetStyleSheet( nPara, pStyleSheet );
//STRIP001 
//STRIP001 			// restore the old bullet item but not if the style changed
//STRIP001 			if ( pOutliner->GetPrevDepth() != 0 &&
//STRIP001 				 nDepth != 0 &&
//STRIP001 				 aOldAttrs.GetItemState( EE_PARA_NUMBULLET ) == SFX_ITEM_ON )
//STRIP001 			{
//STRIP001 				SfxItemSet aAttrs( pOutliner->GetParaAttribs( nPara ) );
//STRIP001 				aAttrs.Put( *aOldAttrs.GetItem( EE_PARA_NUMBULLET ) );
//STRIP001 				pOutliner->SetParaAttribs( nPara, aAttrs );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer StatusEvents
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, StatusEventHdl, EditStatus *, pEditStatus )
//STRIP001 {
//STRIP001 	SdWindow*	  pWin			= pOutlineViewShell->GetActiveWindow();
//STRIP001 	OutlinerView* pOutlinerView = GetViewByWindow(pWin);
//STRIP001 	Rectangle	  aVis			= pOutlinerView->GetVisArea();
//STRIP001 
//STRIP001 //	  ULONG nWidth = ((SdPage*)pDoc->GetSdPage(0, PK_STANDARD))->GetSize().Width();
//STRIP001 	ULONG nWidth = OUTLINE_PAPERWIDTH;
//STRIP001 	Rectangle aText = Rectangle(Point(0,0),
//STRIP001 								   Size(nWidth,
//STRIP001 										pOutliner->GetTextHeight()));
//STRIP001 	Rectangle aWin(Point(0,0), pWin->GetOutputSizePixel());
//STRIP001 	aWin = pWin->PixelToLogic(aWin);
//STRIP001 
//STRIP001 	if (!aVis.IsEmpty())		// nicht beim Oeffnen
//STRIP001 	{
//STRIP001 		aText.Bottom() += aWin.GetHeight();
//STRIP001 
//STRIP001 		pOutlineViewShell->InitWindows(Point(0,0), aText.GetSize(),
//STRIP001 									   Point(aVis.TopLeft()));
//STRIP001 		pOutlineViewShell->UpdateScrollBars();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer den Beginn einer Absatzverschiebung
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, BeginMovingHdl, Outliner *, pOutliner )
//STRIP001 {
//STRIP001 	DBG_ASSERT(!pSelectedParas, "Absatzliste nicht geloescht");
//STRIP001 	DBG_ASSERT(!pOldParaOrder, "Absatzliste nicht geloescht");
//STRIP001 	pOldParaOrder = new List;
//STRIP001 
//STRIP001 	// Liste der selektierten Titelabsaetze
//STRIP001 	pSelectedParas = pOutlinerView[0]->CreateSelectionList();
//STRIP001 	Paragraph* pPara = (Paragraph*)pSelectedParas->First();
//STRIP001 	while (pPara)
//STRIP001 	{
//STRIP001 		if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) > 0 )
//STRIP001 		{
//STRIP001 			pSelectedParas->Remove();
//STRIP001 			pPara = (Paragraph*)pSelectedParas->GetCurObject();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pPara = (Paragraph*)pSelectedParas->Next();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Die zu den selektierten Absaetzen auf Ebene 0 gehoerenden Seiten
//STRIP001 	// selektieren
//STRIP001 	USHORT nPos = 0;
//STRIP001 	ULONG nParaPos = 0;
//STRIP001 	pPara = pOutliner->GetParagraph( 0 );
//STRIP001 
//STRIP001 	while (pPara)
//STRIP001 	{
//STRIP001 		if ( pOutliner->GetDepth( (USHORT) nParaPos ) == 0 )                     // eine Seite?
//STRIP001 		{
//STRIP001 			pOldParaOrder->Insert(pPara, LIST_APPEND);
//STRIP001 			SdPage* pPage = pDoc->GetSdPage(nPos, PK_STANDARD);
//STRIP001 			pPage->SetSelected(FALSE);
//STRIP001 			if (pSelectedParas->Seek(pPara))            // selektiert?
//STRIP001 			{
//STRIP001 				pPage->SetSelected(TRUE);
//STRIP001 			}
//STRIP001 			nPos++;
//STRIP001 		}
//STRIP001 		pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Ende einer Absatzverschiebung
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, EndMovingHdl, Outliner *, pOutliner )
//STRIP001 {
//STRIP001 	DBG_ASSERT(pSelectedParas, "keine Absatzliste");
//STRIP001 	DBG_ASSERT(pOldParaOrder, "keine Absatzliste");
//STRIP001 
//STRIP001 	// Einfuegeposition anhand des ersten Absatzes suchen
//STRIP001 	Paragraph* pSearchIt = (Paragraph*)pSelectedParas->First();
//STRIP001 
//STRIP001 	// den ersten der selektierten Paragraphen in der neuen Ordnung suchen
//STRIP001 	USHORT nPosNewOrder = 0;
//STRIP001 	ULONG nParaPos = 0;
//STRIP001 	Paragraph*	pPara = pOutliner->GetParagraph( 0 );
//STRIP001 	Paragraph*	pPrev = NULL;
//STRIP001 	while (pPara && pPara != pSearchIt)
//STRIP001 	{
//STRIP001 		if (pOutliner->GetDepth( (USHORT) nParaPos ) == 0)
//STRIP001 		{
//STRIP001 			nPosNewOrder++;
//STRIP001 			pPrev = pPara;
//STRIP001 		}
//STRIP001 		pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nPos = nPosNewOrder; 	// nPosNewOrder nicht veraendern
//STRIP001 	if (nPos == 0)
//STRIP001 	{
//STRIP001 		nPos = (USHORT)-1;			// vor der ersten Seite einfuegen
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// den Vorgaenger in der alten Ordnung suchen
//STRIP001 		nPos = (USHORT)pOldParaOrder->GetPos(pPrev);
//STRIP001 		DBG_ASSERT(nPos != LIST_ENTRY_NOTFOUND, "Absatz nicht gefunden");
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bTest = pDoc->MovePages(nPos);
//STRIP001 
//STRIP001 	// die Seiten wieder deselektieren
//STRIP001 	USHORT nPageCount = (USHORT)pSelectedParas->Count();
//STRIP001 	while (nPageCount)
//STRIP001 	{
//STRIP001 		SdPage* pPage = pDoc->GetSdPage(nPosNewOrder, PK_STANDARD);
//STRIP001 		pPage->SetSelected(FALSE);
//STRIP001 		nPosNewOrder++;
//STRIP001 		nPageCount--;
//STRIP001 	}
//STRIP001 
//STRIP001 	pOutliner->UpdateFields();
//STRIP001 
//STRIP001 	delete pSelectedParas;
//STRIP001 	pSelectedParas = NULL;
//STRIP001 	delete pOldParaOrder;
//STRIP001 	pOldParaOrder = NULL;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Eine Seite des Models nach dem Titeltextobjekt durchsuchen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdrTextObj* SdOutlineView::GetTitleTextObject(SdrPage* pPage)
//STRIP001 {
//STRIP001 	ULONG			nObjectCount = pPage->GetObjCount();
//STRIP001 	SdrObject*		pObject 	 = NULL;
//STRIP001 	SdrTextObj* 	pResult 	 = NULL;
//STRIP001 
//STRIP001 	for (ULONG nObject = 0; nObject < nObjectCount; nObject++)
//STRIP001 	{
//STRIP001 		pObject = pPage->GetObj(nObject);
//STRIP001 		if (pObject->GetObjInventor() == SdrInventor &&
//STRIP001 			pObject->GetObjIdentifier() == OBJ_TITLETEXT)
//STRIP001 		{
//STRIP001 			pResult = (SdrTextObj*)pObject;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Eine Seite des Models nach dem Gliederungstextobjekt durchsuchen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdrTextObj* SdOutlineView::GetLayoutTextObject(SdrPage* pPage)
//STRIP001 {
//STRIP001 	ULONG			nObjectCount = pPage->GetObjCount();
//STRIP001 	SdrObject*		pObject 	 = NULL;
//STRIP001 	SdrTextObj* 	pResult 	 = NULL;
//STRIP001 
//STRIP001 	for (ULONG nObject = 0; nObject < nObjectCount; nObject++)
//STRIP001 	{
//STRIP001 		pObject = pPage->GetObj(nObject);
//STRIP001 		if (pObject->GetObjInventor() == SdrInventor &&
//STRIP001 			pObject->GetObjIdentifier() == OBJ_OUTLINETEXT)
//STRIP001 		{
//STRIP001 			pResult = (SdrTextObj*)pObject;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* PrepareClose(), Daten und Selektion ins Model uebertragen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdOutlineView::PrepareClose(BOOL bUI)
//STRIP001 {
//STRIP001 	if( pOutliner->IsModified() )
//STRIP001 	{
//STRIP001 		// die Seiten des Models mit den Inhalten des Outliners fuellen
//STRIP001 		USHORT				nPageCount	= pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 		Paragraph*			pPara		= NULL;
//STRIP001 		SdrTextObj* 		pTO 		= NULL;
//STRIP001 		OutlinerParaObject* pOPO		= NULL;
//STRIP001 		SfxItemPool* pPool = pDoc->GetDrawOutliner().GetEmptyItemSet().GetPool();
//STRIP001 
//STRIP001 		// den Outliner in den OutlinerStyle setzen; dann wird ein von ihm
//STRIP001 		// erzeugter Titeltext bei der Anzeige durch einen Outliner im
//STRIP001 		// EditEngine-Modus mit der Titelvorlage formatiert
//STRIP001 		SdrOutliner* pTempLiner	= new SdrOutliner( pPool, OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 		pTempLiner->SetStyleSheetPool((SfxStyleSheetPool*)pDoc->GetStyleSheetPool());
//STRIP001 		pTempLiner->SetEditTextObjectPool(pPool);
//STRIP001 		pTempLiner->SetForbiddenCharsTable( pDoc->GetForbiddenCharsTable() );
//STRIP001 
//STRIP001 		// Referenz-Device setzen
//STRIP001 		pTempLiner->SetRefDevice( SD_MOD()->GetRefDevice( *pDocSh ) );
//STRIP001 		SfxStyleSheetBasePool* pSPool	= pDoc->GetStyleSheetPool();
//STRIP001 		pTempLiner->SetMinDepth(0);
//STRIP001 
//STRIP001 		BOOL bBegUndoDone = FALSE;		// wurde schon BegUndo() gerufen?
//STRIP001 		String aUndoStr;
//STRIP001 		aUndoStr = String(SdResId(STR_UNDO_CHANGE_TITLE_AND_LAYOUT));
//STRIP001 
//STRIP001 
//STRIP001 		/**************************************************************************
//STRIP001 		|* jetzt die Seiten fuellen
//STRIP001 		\*************************************************************************/
//STRIP001 		pPara = pOutliner->GetParagraph( 0 );
//STRIP001 		for (USHORT nPage = 0; nPage < nPageCount; nPage++)
//STRIP001 		{
//STRIP001 			SdPage* pPage = pDoc->GetSdPage(nPage, PK_STANDARD);
//STRIP001 			SdPage* pMasterPage = (SdPage*) pPage->GetMasterPage(0);
//STRIP001 
//STRIP001 			Point aPos;
//STRIP001 			Rectangle aTitleRect ( aPos, pPage->GetSize() );
//STRIP001 			Rectangle aLayoutRect ( aTitleRect );
//STRIP001 
//STRIP001 			SdrObject* pTitleObj = pMasterPage->GetPresObj(PRESOBJ_TITLE);
//STRIP001 			SdrObject* pLayoutObj = pMasterPage->GetPresObj(PRESOBJ_OUTLINE);
//STRIP001 
//STRIP001 			if (pTitleObj)
//STRIP001 			{
//STRIP001 				aTitleRect = pTitleObj->GetLogicRect();
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pLayoutObj)
//STRIP001 			{
//STRIP001 				aLayoutRect = pLayoutObj->GetLogicRect();
//STRIP001 			}
//STRIP001 
//STRIP001 			pDoc->SetSelected(pPage, FALSE);		  // deselektieren
//STRIP001 
//STRIP001 			// Liste der Gliederungsvorlagen fuer Anmeldung als Listener
//STRIP001 			String aName = pPage->GetLayoutName();
//STRIP001 
//STRIP001 			// erst fuer die Gliederungsebenen
//STRIP001 			List* pOutlineStyleList = new List; // StyleSheet-Liste zum Anmelden
//STRIP001 			pOutlineStyleList->Insert(NULL, LIST_APPEND);
//STRIP001 			String aFullName;
//STRIP001 			SfxStyleSheetBase* pSheet = NULL;
//STRIP001 			for (USHORT i = 1; i < 10; i++)
//STRIP001 			{
//STRIP001 				aFullName  = aName;
//STRIP001 				aFullName += sal_Unicode(' ');
//STRIP001 				aFullName += String::CreateFromInt32( (sal_Int32)i );;
//STRIP001 				pSheet = pSPool->Find(aFullName, SD_LT_FAMILY);
//STRIP001 				pOutlineStyleList->Insert(pSheet, LIST_APPEND);
//STRIP001 			}
//STRIP001 
//STRIP001 			// Titelvorlage
//STRIP001 			aFullName = aName;
//STRIP001 			String aSep( RTL_CONSTASCII_USTRINGPARAM( SD_LT_SEPARATOR ));
//STRIP001 			USHORT n = aFullName.Search(aSep);
//STRIP001 			n += aSep.Len();
//STRIP001 			aFullName.Erase(n);
//STRIP001 			aFullName += String (SdResId(STR_LAYOUT_TITLE));
//STRIP001 			SfxStyleSheet* pTitleSheet = (SfxStyleSheet*)pSPool->
//STRIP001 				Find(aFullName, SD_LT_FAMILY);
//STRIP001 			DBG_ASSERT(pTitleSheet, "Titelvorlage nicht gefunden");
//STRIP001 
//STRIP001 			/*********************************************************************
//STRIP001 			|* Titeltextobjekt
//STRIP001 			\********************************************************************/
//STRIP001 			pTO = GetTitleTextObject(pPage);
//STRIP001 			String aTest(pOutliner->GetText(pPara));
//STRIP001 			BOOL bText = aTest.Len() > 0;
//STRIP001 
//STRIP001 			if (!pTO && bText)
//STRIP001 			{
//STRIP001 				// Kein Seitenobjekt, Text im Outliner:
//STRIP001 				// Entspr. Seitenobjekt erzeugen und einfuegen
//STRIP001 				if (!bBegUndoDone)
//STRIP001 				{
//STRIP001 					BegUndo(aUndoStr);
//STRIP001 					bBegUndoDone = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				pTO  = new SdrRectObj(OBJ_TITLETEXT);
//STRIP001 				pOPO = pOutliner->CreateParaObject( (USHORT) pOutliner->GetAbsPos( pPara ), 1 );
//STRIP001 				pOPO->SetOutlinerMode( OUTLINERMODE_TITLEOBJECT );
//STRIP001 				pTO->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 				// als Praesentationsobjekt anmelden
//STRIP001 				pTO->SetUserCall(pPage);
//STRIP001 				List* pPresObjList = pPage->GetPresObjList();
//STRIP001 				pPresObjList->Insert(pTO, LIST_APPEND);
//STRIP001 
//STRIP001 				pPage->InsertObject(pTO);
//STRIP001 				pTO->SetOutlinerParaObject(pOPO);
//STRIP001 							// TRUE: DontRemoveHardAttr
//STRIP001 				pTO->SetStyleSheet(pTitleSheet, TRUE);
//STRIP001 				AutoLayout eLayout = pPage->GetAutoLayout();
//STRIP001 				if( eLayout == AUTOLAYOUT_VERTICAL_TITLE_TEXT_CHART       ||
//STRIP001 		    		eLayout == AUTOLAYOUT_VERTICAL_TITLE_VERTICAL_OUTLINE )
//STRIP001 					pTO->SetVerticalWriting( TRUE );
//STRIP001 
//STRIP001 				AddUndo(new SdrUndoNewObj(*pTO));
//STRIP001 			}
//STRIP001 			else if (pTO && bText)
//STRIP001 			{
//STRIP001 				// Seitenobjekt, Text im Outliner:
//STRIP001 				// Titeltext uebernehmen
//STRIP001 
//STRIP001 				if (!bBegUndoDone)
//STRIP001 				{
//STRIP001 					BegUndo(aUndoStr);
//STRIP001 					bBegUndoDone = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				pOPO = pOutliner->CreateParaObject( (USHORT) pOutliner->GetAbsPos( pPara ), 1 );
//STRIP001 				pOPO->SetOutlinerMode( OUTLINERMODE_TITLEOBJECT );
//STRIP001 				pOPO->SetVertical( pTO->IsVerticalWriting() );
//STRIP001 				// loescht altes OutlinerParaObject
//STRIP001 				AddUndo(new SdrUndoObjSetText(*pTO));
//STRIP001 				pTO->SetOutlinerParaObject(pOPO);
//STRIP001 				pTO->SetEmptyPresObj(FALSE);
//STRIP001 			}
//STRIP001 			else if (!pTO && !bText)
//STRIP001 			{
//STRIP001 				// Kein Seitenobjekt, kein Text im Outliner: nix tun
//STRIP001 			}
//STRIP001 			else if(pTO && !bText)
//STRIP001 			{
//STRIP001 				// Seitenobjekt, kein Text im Outliner:
//STRIP001 				// wenn Objekt in Praesentationsliste der Seite ist -> Defaulttext,
//STRIP001 				// sonst Objekt loeschen
//STRIP001 				List* pPresObjList = pPage->GetPresObjList();
//STRIP001 				if (pPresObjList->GetPos(pTO) != LIST_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					if( !pTO->IsEmptyPresObj() )
//STRIP001 					{
//STRIP001 						if (!bBegUndoDone)
//STRIP001 						{
//STRIP001 							BegUndo(aUndoStr);
//STRIP001 							bBegUndoDone = TRUE;
//STRIP001 						}
//STRIP001 
//STRIP001 						BOOL bVertical = pTO->IsVerticalWriting();
//STRIP001 						AddUndo(new SdrUndoObjSetText(*pTO));
//STRIP001 
//STRIP001 						String aString( pPage->GetPresObjText(PRESOBJ_TITLE) );
//STRIP001 						pPage->SetObjText( pTO, pTempLiner, PRESOBJ_TITLE, aString );
//STRIP001 						pTO->SetVerticalWriting(bVertical);
//STRIP001 						pTO->NbcSetStyleSheet( pPage->GetStyleSheetForPresObj(PRESOBJ_TITLE), TRUE );
//STRIP001 
//STRIP001 /*						pTempLiner->Init( OUTLINERMODE_TITLEOBJECT );
//STRIP001 						pTempLiner->SetMinDepth(0);
//STRIP001 						String aString (SdResId(STR_PRESOBJ_TITLE));
//STRIP001 						pTempLiner->Insert(aString, LIST_APPEND, 0);
//STRIP001 						pOPO = pTempLiner->CreateParaObject( 0, 1 );
//STRIP001 						pOPO->SetOutlinerMode( OUTLINERMODE_TITLEOBJECT );
//STRIP001 						pTO->SetOutlinerParaObject(pOPO);
//STRIP001  * */
//STRIP001 						pTO->SetEmptyPresObj(TRUE);
//STRIP001 						pTempLiner->SetMinDepth(0);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					// Grafik: Seitenobjekt loeschen
//STRIP001 					if (!bBegUndoDone)
//STRIP001 					{
//STRIP001 						BegUndo(aUndoStr);
//STRIP001 						bBegUndoDone = TRUE;
//STRIP001 					}
//STRIP001 
//STRIP001 					AddUndo(new SdrUndoRemoveObj(*pTO));
//STRIP001 					pPage->RemoveObject(pTO->GetOrdNum());
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			/*********************************************************************
//STRIP001 			|* Gliederungstextobjekt
//STRIP001 			\********************************************************************/
//STRIP001 			BOOL bSubTitle = FALSE;
//STRIP001 			pTO = (SdrTextObj*) pPage->GetPresObj(PRESOBJ_TEXT);
//STRIP001 
//STRIP001 			if (pTO)
//STRIP001 			{
//STRIP001 				bSubTitle = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pTO = GetLayoutTextObject(pPage);
//STRIP001 			}
//STRIP001 
//STRIP001 			pOPO = NULL;
//STRIP001 
//STRIP001 			// Wenn moeglich, OutlinerParaObject fuer Gliederung erzeugen
//STRIP001 			if ( pPara && pOutliner->HasChilds(pPara) )
//STRIP001 			{
//STRIP001 				// wieviele Absaetze in der Gliederung?
//STRIP001 				ULONG nTitlePara = pOutliner->GetAbsPos(pPara);
//STRIP001 				ULONG nParaPos = nTitlePara;
//STRIP001 				ULONG nParasInLayout = 0L;
//STRIP001 				pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 				while (pPara && pOutliner->GetDepth( (USHORT) nParaPos ) != 0)
//STRIP001 				{
//STRIP001 					nParasInLayout++;
//STRIP001 					pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 				}
//STRIP001 
//STRIP001 				// ein OutlinerParaObject erzeugen
//STRIP001 				pPara = pOutliner->GetParagraph(nTitlePara + 1);
//STRIP001 				pOPO  = pOutliner->CreateParaObject( (USHORT) nTitlePara + 1, (USHORT) nParasInLayout );
//STRIP001 				pOPO->SetOutlinerMode( OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 			}
//STRIP001 
//STRIP001 			if (!pTO && pOPO)
//STRIP001 			{
//STRIP001 				// Kein Seitenobjekt, Gliederungstext im Outliner
//STRIP001 				if (!bBegUndoDone)
//STRIP001 				{
//STRIP001 					BegUndo(aUndoStr);
//STRIP001 					bBegUndoDone = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				pTO = new SdrRectObj(OBJ_OUTLINETEXT);
//STRIP001 				pTO->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 				// als Praesentationsobjekt anmelden
//STRIP001 				pTO->SetUserCall(pPage);
//STRIP001 				List* pPresObjList = pPage->GetPresObjList();
//STRIP001 				pPresObjList->Insert(pTO, LIST_APPEND);
//STRIP001 
//STRIP001 				pPage->InsertObject(pTO);
//STRIP001 				pTO->SetOutlinerParaObject(pOPO);
//STRIP001 
//STRIP001 				AutoLayout eLayout = pPage->GetAutoLayout();
//STRIP001 				if( eLayout == AUTOLAYOUT_TITLE_VERTICAL_OUTLINE       ||
//STRIP001 		    		eLayout == AUTOLAYOUT_VERTICAL_TITLE_VERTICAL_OUTLINE ||
//STRIP001 					eLayout == AUTOLAYOUT_TITLE_VERTICAL_OUTLINE_CLIPART )
//STRIP001 					pTO->SetVerticalWriting( TRUE );
//STRIP001 
//STRIP001 				// Linien- und Fuellattribute der Standardvorlage hart
//STRIP001 				// ueberschreiben
//STRIP001 				SfxItemSet aTempAttr(pDoc->GetPool());
//STRIP001 				aTempAttr.Put(XLineStyleItem(XLINE_NONE));
//STRIP001 				aTempAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 
//STRIP001 //-/				pTO->SetAttributes(aTempAttr, FALSE);
//STRIP001 //-/				SdrBroadcastItemChange aItemChange(*pTO);
//STRIP001 				pTO->SetItemSetAndBroadcast(aTempAttr);
//STRIP001 //-/				pTO->BroadcastItemChange(aItemChange);
//STRIP001 
//STRIP001 				// als Listener anmelden
//STRIP001 				for (USHORT i = 1; i < 10; i++)
//STRIP001 				{
//STRIP001 					SfxStyleSheet* pS = (SfxStyleSheet*)pOutlineStyleList->GetObject(i);
//STRIP001 					if (pS)
//STRIP001 					{
//STRIP001 						pTO->StartListening(*pS);
//STRIP001 
//STRIP001 						if( i == 1 )
//STRIP001 							pTO->SetStyleSheet( pS, TRUE );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				AddUndo(new SdrUndoNewObj(*pTO));
//STRIP001 			}
//STRIP001 			else if (pTO && pOPO)
//STRIP001 			{
//STRIP001 				// Seitenobjekt, Gliederungstext im Outliner:
//STRIP001 				// Text uebernehmen
//STRIP001 				if (!bBegUndoDone)
//STRIP001 				{
//STRIP001 					BegUndo(aUndoStr);
//STRIP001 					bBegUndoDone = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				// loescht auch altes OutlinerParaObject
//STRIP001 				AddUndo(new SdrUndoObjSetText(*pTO));
//STRIP001 
//STRIP001 				if (bSubTitle)
//STRIP001 				{
//STRIP001 					// Fuer alle Absaetze im TextObjekt schauen ob eine Ausrichtung
//STRIP001 					// gesetzt ist, wenn nicht => zentrieren
//STRIP001 					Outliner* pOutl = pDoc->GetInternalOutliner();
//STRIP001 					pOutl->Clear();
//STRIP001 					pOutl->SetText( *pOPO );
//STRIP001 
//STRIP001 					ULONG nCount = pOutl->GetParagraphCount();
//STRIP001 					for( ULONG nPara = 0; nPara < nCount; nPara++ )
//STRIP001 					{
//STRIP001 						SfxItemSet aSet( pOutl->GetParaAttribs( nPara ) );
//STRIP001 						if (aSet.GetItemState(EE_PARA_JUST) != SFX_ITEM_SET)
//STRIP001 						{
//STRIP001 							aSet.Put(SvxAdjustItem( SVX_ADJUST_CENTER ));
//STRIP001 							pOutl->SetParaAttribs(nPara, aSet);
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					delete pOPO;
//STRIP001 					pOPO = pOutl->CreateParaObject( 0, (USHORT) nCount );
//STRIP001 					pOPO->SetOutlinerMode( OUTLINERMODE_TEXTOBJECT );
//STRIP001 					pOutl->Clear();
//STRIP001 				}
//STRIP001 
//STRIP001 				pOPO->SetVertical( pTO->IsVerticalWriting() );
//STRIP001 				pTO->SetOutlinerParaObject(pOPO);
//STRIP001 				pTO->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 				if (bSubTitle)
//STRIP001 				{
//STRIP001 					// Subtitle-Vorlage setzen
//STRIP001 					SfxStyleSheet* pSheet = pPage->GetStyleSheetForPresObj(PRESOBJ_TEXT);
//STRIP001 
//STRIP001 					if( pTO->GetStyleSheet() != pSheet )
//STRIP001 						pTO->SetStyleSheet(pSheet, TRUE);
//STRIP001 
//STRIP001 					// Untertitel-Objekt statt Gliederung -> Linken Einzug zuruecksetzen
//STRIP001 					SfxItemSet aSet(pDoc->GetPool(), EE_PARA_LRSPACE, EE_PARA_LRSPACE);
//STRIP001 
//STRIP001 //-/					pTO->TakeAttributes(aSet, TRUE, FALSE);
//STRIP001 					aSet.Put(pTO->GetItemSet());
//STRIP001 
//STRIP001 					if (aSet.GetItemState(EE_PARA_LRSPACE) != SFX_ITEM_SET)
//STRIP001 					{
//STRIP001 						const SvxLRSpaceItem& rLRItem = (const SvxLRSpaceItem&) aSet.Get(EE_PARA_LRSPACE);
//STRIP001 						SvxLRSpaceItem aNewLRItem(rLRItem);
//STRIP001 						aNewLRItem.SetTxtLeft(0);
//STRIP001 						aSet.Put(aNewLRItem);
//STRIP001 
//STRIP001 //-/						pTO->NbcSetAttributes(aSet, FALSE);
//STRIP001 						pTO->SetItemSet(aSet);
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else if (!pTO && !pOPO)
//STRIP001 			{
//STRIP001 				// kein Seitenobjekt, kein Gliederungstext: nix tun
//STRIP001 			}
//STRIP001 			else if (pTO && !pOPO)
//STRIP001 			{
//STRIP001 				// Seitenobjekt, aber kein Gliederungstext:
//STRIP001 				// wenn Objekt in Praesentationsliste der Seite ist -> Defaulttext,
//STRIP001 				// sonst Objekt loeschen
//STRIP001 				List* pPresObjList = pPage->GetPresObjList();
//STRIP001 				if (pPresObjList->GetPos(pTO) != LIST_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					if( !pTO->IsEmptyPresObj() )
//STRIP001 					{
//STRIP001 						if (!bBegUndoDone)
//STRIP001 						{
//STRIP001 							BegUndo(aUndoStr);
//STRIP001 							bBegUndoDone = TRUE;
//STRIP001 						}
//STRIP001 
//STRIP001 						// loescht auch altes OutlinerParaObject
//STRIP001 						AddUndo(new SdrUndoObjSetText(*pTO));
//STRIP001 
//STRIP001 						pTempLiner->Init( OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 						pTempLiner->SetMinDepth(0);
//STRIP001 
//STRIP001 						String aEmptyStr;
//STRIP001 						PresObjKind ePresObjKind = pPage->GetPresObjKind(pTO);
//STRIP001 						String aString = pPage->GetPresObjText(ePresObjKind);
//STRIP001 						pPage->SetObjText( pTO, pTempLiner, ePresObjKind, aString );
//STRIP001 						pTO->NbcSetStyleSheet( pPage->GetStyleSheetForPresObj( ePresObjKind ), TRUE );
//STRIP001 						pTO->GetOutlinerParaObject()->SetVertical( pTO->IsVerticalWriting() );
//STRIP001 
//STRIP001 						if (ePresObjKind == PRESOBJ_TEXT)
//STRIP001 						{
//STRIP001 							pTempLiner->Init( OUTLINERMODE_SUBTITLE );
//STRIP001 
//STRIP001 							// Vorlage setzen
//STRIP001 							pTO->SetStyleSheet(pPage->GetStyleSheetForPresObj(ePresObjKind), TRUE);
//STRIP001 
//STRIP001 							// Linken Einzug zuruecksetzen
//STRIP001 							SfxItemSet aSet(pDoc->GetPool(), EE_PARA_LRSPACE, EE_PARA_LRSPACE);
//STRIP001 
//STRIP001 //-/							pTO->TakeAttributes(aSet, TRUE, FALSE);
//STRIP001 							aSet.Put(pTO->GetItemSet());
//STRIP001 
//STRIP001 							const SvxLRSpaceItem& rLRItem = (const SvxLRSpaceItem&) aSet.Get(EE_PARA_LRSPACE);
//STRIP001 							SvxLRSpaceItem aNewLRItem(rLRItem);
//STRIP001 							aNewLRItem.SetTxtLeft(0);
//STRIP001 							aSet.Put(aNewLRItem);
//STRIP001 
//STRIP001 //-/							pTO->NbcSetAttributes(aSet, FALSE);
//STRIP001 							pTO->SetItemSet(aSet);
//STRIP001 						}
//STRIP001 
//STRIP001 						pTO->SetEmptyPresObj(TRUE);
//STRIP001 						pTempLiner->SetMinDepth(0);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					if (!bBegUndoDone)
//STRIP001 					{
//STRIP001 						BegUndo(aUndoStr);
//STRIP001 						bBegUndoDone = TRUE;
//STRIP001 					}
//STRIP001 
//STRIP001 					AddUndo(new SdrUndoRemoveObj(*pTO));
//STRIP001 					pPage->RemoveObject(pTO->GetOrdNum());
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			delete pOutlineStyleList;
//STRIP001 
//STRIP001 			// das AutoLayout nochmal anwenden, damit neu eingefuegte Textobjekte
//STRIP001 			// die richtige Position/Groesse bekommen
//STRIP001 			pPage->SetAutoLayout(pPage->GetAutoLayout());
//STRIP001 
//STRIP001 			// zum naechsten Absatz der 0-ten Ebene
//STRIP001 			if( pPara )
//STRIP001 				pPara = GetNextTitle(pPara);
//STRIP001 		}
//STRIP001 
//STRIP001 		if (bBegUndoDone)
//STRIP001 		{
//STRIP001 			// Actions im Redo-Anteil des Outliner-UndoManagers loeschen, denn die
//STRIP001 			// referenzieren Actions im Redo-Anteil des Doc-UndoManagers (und die
//STRIP001 			// werden bei EndUndo() geloescht --> Referenzen ins Leere --> Absturz)
//STRIP001 			pOutliner->GetUndoManager().ClearRedo();
//STRIP001 
//STRIP001 			EndUndo();
//STRIP001 			SfxUndoManager* pDocUndoMgr = pDocSh->GetUndoManager();
//STRIP001 			SfxLinkUndoAction* pLink = new SfxLinkUndoAction(pDocUndoMgr);
//STRIP001 			pOutliner->GetUndoManager().AddUndoAction(pLink);
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 		// die Seite selektieren
//STRIP001 		SdPage* pPage = GetActualPage();
//STRIP001 		pDoc->SetSelected(pPage, TRUE);
//STRIP001 
//STRIP001 		// temporaeren Outliner loeschen
//STRIP001 		delete pTempLiner;
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;	// einverstanden mit der eigenen Zerstoerung
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Attribute des selektierten Textes setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdOutlineView::SetAttributes(const SfxItemSet& rSet, BOOL bReplaceAll)
//STRIP001 {
//STRIP001 	FASTBOOL bOk = FALSE;
//STRIP001 
//STRIP001 	OutlinerView* pOlView = GetViewByWindow(pOutlineViewShell->GetActiveWindow());
//STRIP001 
//STRIP001 	if (pOlView)
//STRIP001 	{
//STRIP001 		pOlView->SetAttribs(rSet);
//STRIP001 		bOk = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001     pOutlineViewShell->Invalidate (SID_PREVIEW_STATE);
//STRIP001 
//STRIP001 	return (bOk);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Attribute des selektierten Textes erfragen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdOutlineView::GetAttributes( SfxItemSet& rTargetSet, BOOL bOnlyHardAttr ) const
//STRIP001 {
//STRIP001 	OutlinerView* pOlView = GetViewByWindow(
//STRIP001 								pOutlineViewShell->GetActiveWindow());
//STRIP001 	DBG_ASSERT(pOlView, "keine OutlinerView gefunden");
//STRIP001 
//STRIP001 	rTargetSet.Put( pOlView->GetAttribs(), FALSE );
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* gibt's selektierten Text ?
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdOutlineView::HasMarkedObj() const
//STRIP001 {
//STRIP001 	BOOL bResult = FALSE;
//STRIP001 	OutlinerView* pOlView = GetViewByWindow(
//STRIP001 								pOutlineViewShell->GetActiveWindow());
//STRIP001 	DBG_ASSERT(pOlView, "keine OutlinerView gefunden");
//STRIP001 	List* pSelList = (List*)pOlView->CreateSelectionList();
//STRIP001 	if (pSelList->Count() > 0)
//STRIP001 		bResult = TRUE;
//STRIP001 
//STRIP001 	delete pSelList;
//STRIP001 	return bResult;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Outliner mit Daten aus dem SdDrawDocument fuellen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::FillOutliner()
//STRIP001 {
//STRIP001 	ResetLinks();
//STRIP001 	pOutliner->SetMinDepth(0);
//STRIP001 
//STRIP001 	Paragraph* pTitleToSelect = NULL;
//STRIP001 	ULONG nPageCount = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 
//STRIP001 	// Outliner mit Text versorgen
//STRIP001 	for (USHORT nPage = 0; nPage < nPageCount; nPage++)
//STRIP001 	{
//STRIP001 		SdPage* 	pPage = (SdPage*)pDoc->GetSdPage(nPage, PK_STANDARD);
//STRIP001 		Paragraph * pPara = NULL;
//STRIP001 
//STRIP001 		// Titeltext uebernehmen
//STRIP001 		SdrTextObj* 	pTO   = GetTitleTextObject(pPage);
//STRIP001 		if (pTO)
//STRIP001 		{
//STRIP001 			if (!(pTO->IsEmptyPresObj()))	// gesetzten Titeltext gefunden
//STRIP001 			{
//STRIP001 				OutlinerParaObject* pOPO = pTO->GetOutlinerParaObject();
//STRIP001 				if (pOPO)
//STRIP001 				{
//STRIP001 					BOOL bVertical = pOPO->IsVertical();
//STRIP001 					pOPO->SetVertical( FALSE );
//STRIP001 					pOutliner->AddText(*pOPO);
//STRIP001 					pOPO->SetVertical( bVertical );
//STRIP001 					pPara = pOutliner->GetParagraph( pOutliner->GetParagraphCount() - 1 );
//STRIP001 					// Man sollte meinen, dass folgendes Statement unnoetig sei,
//STRIP001 					// aber ueber das #39788#-Bugdoc ist eine Inkonsistenz im
//STRIP001 					// Doc aufgefallen, wo Titel die Ebene 1 (nicht 0) hat.
//STRIP001 					// Die Ursache ist bisher ungeklaert.
//STRIP001 					pOutliner->SetDepth( pPara, 0 );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					pPara = pOutliner->Insert(String());
//STRIP001 
//STRIP001 					// Keine harten Attribute vom vorherigen Absatz uebernehmen
//STRIP001 					pOutliner->SetParaAttribs( pOutliner->GetAbsPos(pPara),
//STRIP001 											   pOutliner->GetEmptyItemSet() );
//STRIP001 					pPara = pOutliner->GetParagraph( pOutliner->GetParagraphCount() - 1 );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else							// leerer Praesentationstitel
//STRIP001 			{
//STRIP001 				pPara = pOutliner->Insert(String());
//STRIP001 
//STRIP001 				// Keine harten Attribute vom vorherigen Absatz uebernehmen
//STRIP001 				pOutliner->SetParaAttribs( pOutliner->GetAbsPos(pPara),
//STRIP001 										   pOutliner->GetEmptyItemSet() );
//STRIP001 
//STRIP001 				pOutliner->SetStyleSheet( pOutliner->GetAbsPos( pPara ), pPage->GetStyleSheetForPresObj( PRESOBJ_TITLE ) );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else				// kein Titeltext, also leerer Titel
//STRIP001 		{
//STRIP001 			pPara = pOutliner->Insert(String());
//STRIP001 
//STRIP001 			// Keine harten Attribute vom vorherigen Absatz uebernehmen
//STRIP001 			pOutliner->SetParaAttribs( pOutliner->GetAbsPos(pPara),
//STRIP001 									   pOutliner->GetEmptyItemSet() );
//STRIP001 
//STRIP001 			pOutliner->SetStyleSheet( pOutliner->GetAbsPos( pPara ), pPage->GetStyleSheetForPresObj( PRESOBJ_TITLE ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		// selektierte Seite merken
//STRIP001 		if (pPage->IsSelected())
//STRIP001 		{
//STRIP001 			pTitleToSelect = pPara;
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 		// Gliederungstext uebernehmen
//STRIP001 		pTO = (SdrTextObj*)pPage->GetPresObj(PRESOBJ_TEXT);
//STRIP001 		BOOL   bSubTitle = pTO != NULL;
//STRIP001 		if (!pTO)
//STRIP001 		{
//STRIP001 			pTO = GetLayoutTextObject(pPage);
//STRIP001 		}
//STRIP001 		if (pTO)
//STRIP001 		{
//STRIP001 			if(!(pTO->IsEmptyPresObj())) // gesetzten Gl.text gefunden
//STRIP001 			{
//STRIP001 				OutlinerParaObject* pOPO = pTO->GetOutlinerParaObject();
//STRIP001 				if (pOPO)
//STRIP001 				{
//STRIP001 					ULONG nParaCount1 = pOutliner->GetParagraphCount();
//STRIP001 					BOOL bVertical = pOPO->IsVertical();
//STRIP001 					pOPO->SetVertical( FALSE );
//STRIP001 					pOutliner->AddText(*pOPO);
//STRIP001 					pOPO->SetVertical( bVertical );
//STRIP001 					if (bSubTitle)
//STRIP001 					{
//STRIP001 						ULONG nParaCount2 = pOutliner->GetParagraphCount();
//STRIP001 						Paragraph* pPara = NULL;
//STRIP001 						for (ULONG nPara = nParaCount1; nPara < nParaCount2; nPara++)
//STRIP001 						{
//STRIP001 							pPara = pOutliner->GetParagraph(nPara);
//STRIP001 							if(pPara && pOutliner->GetDepth( (USHORT) nPara ) != 1 )
//STRIP001 								pOutliner->SetDepth(pPara, 1);
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else				// kein Gliederungstext, also nichts einfuegen
//STRIP001 		{
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Cursor an den Anfang stellen
//STRIP001 	Paragraph* pFirstPara = pOutliner->GetParagraph( 0 );
//STRIP001 	pOutlinerView[0]->Select( pFirstPara, TRUE, FALSE );
//STRIP001 	pOutlinerView[0]->Select( pFirstPara, FALSE, FALSE );
//STRIP001 
//STRIP001 	// Titel der selektierten Seite des Models im Outliner selektieren
//STRIP001 	if (pTitleToSelect)
//STRIP001 	{
//STRIP001 		pOutlinerView[0]->Select(pTitleToSelect, TRUE, FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	SetLinks();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Loeschen von Level-0-Absaetzen (Seiten): Warnung
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, RemovingPagesHdl, OutlinerView *, pOutlinerView )
//STRIP001 {
//STRIP001 	long nResult = 0;
//STRIP001 	USHORT nNumOfPages = 0;
//STRIP001 	Paragraph* pTitlePara = NULL;  // der Titel (falls nur eine Seite betroffen)
//STRIP001 	Paragraph* pPara	  = NULL;
//STRIP001 
//STRIP001 	/*************************************************************************
//STRIP001 	|* Befinden sich Objekte auf der/den Seite(n), die der Benutzer nicht
//STRIP001 	|* so einfach neu erzeugen kann?
//STRIP001 	|* Kriterium: <mehr Objekte als Praesentationsobjekte>	 oder
//STRIP001 	|*			  <wenigstens ein nicht-leeres Praesentationsobjekt>
//STRIP001 	\**********************************************************************/
//STRIP001 	BOOL bValuableObjectsFound = FALSE;
//STRIP001 	List* pList = pOutlinerView->CreateSelectionList();
//STRIP001 	pPara = (Paragraph*)pList->First();
//STRIP001 	while (pPara)
//STRIP001 	{
//STRIP001 		if ( pOutliner->GetDepth( (USHORT) pOutlinerView->GetOutliner()->GetAbsPos( pPara ) ) == 0 )
//STRIP001 		{
//STRIP001 			// welche Seite?
//STRIP001 			USHORT nPage = 0;
//STRIP001 			Paragraph* pScan = pPara;
//STRIP001 			while (pScan)
//STRIP001 			{
//STRIP001 				pScan = GetPrevTitle(pScan);
//STRIP001 				if (pScan)
//STRIP001 					nPage++;
//STRIP001 			}
//STRIP001 
//STRIP001 			SdPage* pPage = pDoc->GetSdPage(nPage, PK_STANDARD);
//STRIP001 			List* pPresObjs = pPage->GetPresObjList();
//STRIP001 			if (pPage->GetObjCount() > pPresObjs->Count())
//STRIP001 			{
//STRIP001 				bValuableObjectsFound = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SdrObject* pObject = (SdrObject*)pPresObjs->First();
//STRIP001 				while (pObject && !bValuableObjectsFound)
//STRIP001 				{
//STRIP001 					bValuableObjectsFound = !pObject->IsEmptyPresObj();
//STRIP001 					pObject = (SdrObject*)pPresObjs->Next();
//STRIP001 
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pPara = (Paragraph*)pList->Next();
//STRIP001 	}
//STRIP001 	delete pList;
//STRIP001 
//STRIP001 	/*************************************************************************
//STRIP001 	|* nichts "wertvolles" gefunden: es darf ohne Rueckfrage geloescht werden
//STRIP001 	\************************************************************************/
//STRIP001 	if (!bValuableObjectsFound)
//STRIP001 	{
//STRIP001 		nResult = 1;
//STRIP001 	}
//STRIP001 	/*************************************************************************
//STRIP001 	|* lieber vorher nachfragen
//STRIP001 	\************************************************************************/
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nNumOfPages = pOutliner->GetSelPageCount();
//STRIP001 		DBG_ASSERT(nNumOfPages > 0, "0 Seiten werden geloescht ???");
//STRIP001 
//STRIP001 		String aWarnStr;
//STRIP001 		if (nNumOfPages == 1)
//STRIP001 		{
//STRIP001 			// wie heisst die betroffene Seite?
//STRIP001 			USHORT nPage = 0;
//STRIP001 			ULONG nPara = pOutliner->GetFirstSelPage();
//STRIP001 			pPara = pOutliner->GetParagraph(nPara);
//STRIP001 			while (pPara)
//STRIP001 			{
//STRIP001 				pPara = GetPrevTitle(pPara);
//STRIP001 				if (pPara)
//STRIP001 					nPage++;
//STRIP001 			}
//STRIP001 
//STRIP001 			String aPageName = ((SdPage*)pDoc->GetSdPage(nPage, PK_STANDARD))->
//STRIP001 												 GetName();
//STRIP001 
//STRIP001 			// dynamische Seitentitel beachten
//STRIP001 			if (aPageName.Len() == 0)
//STRIP001 			{
//STRIP001 				aPageName += String(SdResId(STR_PAGE));
//STRIP001 				aPageName += String::CreateFromInt32( nPage + 1 ); 		// an der UI beginnen Seiten bei 1
//STRIP001 			}
//STRIP001 
//STRIP001 			aWarnStr = String(SdResId(STR_WARN_DEL_PAGE));
//STRIP001 
//STRIP001 			// Platzhalter durch Seitennamen ersetzen
//STRIP001 			xub_StrLen nPos = aWarnStr.Search(sal_Unicode('$'));
//STRIP001 			aWarnStr.Erase(nPos, 1);
//STRIP001 			aWarnStr.Insert(aPageName, nPos);
//STRIP001 		}
//STRIP001 		else if (nNumOfPages > 1)
//STRIP001 		{
//STRIP001 			aWarnStr = String(SdResId(STR_WARN_DEL_SEL_PAGES));
//STRIP001 
//STRIP001 		}
//STRIP001 
//STRIP001 		// Warnung ausgeben
//STRIP001 		WarningBox aWarningBox( pOutlineViewShell->GetActiveWindow(),
//STRIP001 							   (WinBits)WB_OK_CANCEL | WB_DEF_CANCEL, aWarnStr);
//STRIP001 		short nDlgResult = aWarningBox.Execute();
//STRIP001 		if (nDlgResult == RET_OK)
//STRIP001 		{
//STRIP001 			nResult = 1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	/*************************************************************************
//STRIP001 	|* Es soll geloescht werden: ggfs. Fortschrittsanzeige vorbereiten
//STRIP001 	\************************************************************************/
//STRIP001 	if (nResult == 1)
//STRIP001 	{
//STRIP001 		if (nNumOfPages > PROCESS_WITH_PROGRESS_THRESHOLD)
//STRIP001 		{
//STRIP001 			nPagesToProcess = nNumOfPages;
//STRIP001 			nPagesProcessed  = 0;
//STRIP001 		}
//STRIP001 
//STRIP001 		if (nPagesToProcess)
//STRIP001 		{
//STRIP001 			if( mpProgress )
//STRIP001 				delete mpProgress;
//STRIP001 
//STRIP001 			String aStr(SdResId(STR_DELETE_PAGES));
//STRIP001 			mpProgress = new SfxProgress( GetDocSh(), aStr, nPagesToProcess );
//STRIP001 		}
//STRIP001 		pOutliner->UpdateFields();
//STRIP001 	}
//STRIP001 
//STRIP001 	return nResult;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Handler fuer das Einruecken von Level-0-Absaetzen (Seiten): Warnung
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SdOutlineView, IndentingPagesHdl, OutlinerView *, pOutlinerView )
//STRIP001 {
//STRIP001 	return RemovingPagesHdl(pOutlinerView);
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SdOutlineView, IndentingPagesHdl, OutlinerView *, pOutlinerView )
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Liefert die aktuellen Seite
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPage* SdOutlineView::GetActualPage()
//STRIP001 {
//STRIP001 	/**************************************************************************
//STRIP001 	|* Die Seite, in deren Titel oder Gliederung der Cursor (bzw. der
//STRIP001 	|* Selektionsbeginn) steht, soll selektiert werden.
//STRIP001 	\*************************************************************************/
//STRIP001 	SdWindow*	   pWin 			= pOutlineViewShell->GetActiveWindow();
//STRIP001 	OutlinerView*  pActiveView		= GetViewByWindow(pWin);
//STRIP001 	Outliner*      pOutl            = pActiveView->GetOutliner();
//STRIP001 	List*		   pSelList 		= (List*)pActiveView->CreateSelectionList();
//STRIP001 	Paragraph*	   pPara			= (Paragraph*)pSelList->First();
//STRIP001 	if ( pOutl->GetDepth( (USHORT) pOutl->GetAbsPos( pPara ) ) > 0 )
//STRIP001 	{
//STRIP001 		pPara = GetPrevTitle(pPara);
//STRIP001 	}
//STRIP001 	USHORT nPageToSelect = 0;
//STRIP001 	while(pPara)
//STRIP001 	{
//STRIP001 		pPara = GetPrevTitle(pPara);
//STRIP001 		if (pPara) nPageToSelect++;
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pSelList;				// die wurde extra fuer uns erzeugt
//STRIP001 
//STRIP001 	SdPage* pPage = (SdPage*)pDoc->GetSdPage(nPageToSelect, PK_STANDARD);
//STRIP001 
//STRIP001 	return(pPage);
//STRIP001 }
//STRIP001 
//STRIP001 /** selects the paragraph for the given page at the outliner view*/
//STRIP001 void SdOutlineView::SetActualPage( SdPage* pActual )
//STRIP001 {
//STRIP001 	if( pActual )
//STRIP001 	{
//STRIP001 		// get the number of paragraphs with ident 0 we need to skip before
//STRIP001 		// we finde the actual page
//STRIP001 		USHORT nPagesToSkip = (pActual->GetPageNum() - 1) / 2; // Sdr --> Sd
//STRIP001 
//STRIP001 		ULONG nParaPos = 0;
//STRIP001 		Paragraph* pPara = pOutliner->GetParagraph( 0 );
//STRIP001 
//STRIP001 		while( pPara )
//STRIP001 		{
//STRIP001 			// if this paragraph is a page ...
//STRIP001 			if ( pOutliner->GetDepth( (USHORT) nParaPos ) == 0 )
//STRIP001 			{
//STRIP001 				// see if we already skiped enough pages
//STRIP001 				if( 0 == nPagesToSkip )
//STRIP001 					break;	// and if so, end the loop
//STRIP001 
//STRIP001 				// we skiped another page
//STRIP001 				nPagesToSkip--;
//STRIP001 			}
//STRIP001 
//STRIP001 			// get next paragraph
//STRIP001 			pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 		}
//STRIP001 
//STRIP001 		// if we found a paragraph, select its text at the outliner view
//STRIP001 		if( pPara )
//STRIP001 			pOutlinerView[0]->Select( pPara, TRUE, FALSE );
//STRIP001 	}
//STRIP001 }

//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* StyleSheet aus der Selektion besorgen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SfxStyleSheet* SdOutlineView::GetStyleSheet() const
//STRIP001 {
//STRIP001 	SdWindow*     pActWin = pOutlineViewShell->GetActiveWindow();
//STRIP001 	OutlinerView* pOlView = GetViewByWindow(pActWin);
//STRIP001 	SfxStyleSheet* pResult = pOlView->GetStyleSheet();
//STRIP001 	return pResult;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Seiten als selektiert / nicht selektiert setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::SetSelectedPages()
//STRIP001 {
//STRIP001 	// Liste der selektierten Titelabsaetze
//STRIP001 	List* pSelParas = pOutlinerView[0]->CreateSelectionList();
//STRIP001 	Paragraph* pPara = (Paragraph*) pSelParas->First();
//STRIP001 
//STRIP001 	while (pPara)
//STRIP001 	{
//STRIP001 		if ( pOutliner->GetDepth( (USHORT) pOutliner->GetAbsPos( pPara ) ) > 0 )
//STRIP001 		{
//STRIP001 			pSelParas->Remove();
//STRIP001 			pPara = (Paragraph*) pSelParas->GetCurObject();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pPara = (Paragraph*) pSelParas->Next();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Die zu den selektierten Absaetzen auf Ebene 0 gehoerenden Seiten
//STRIP001 	// selektieren
//STRIP001 	USHORT nPos = 0;
//STRIP001 	ULONG nParaPos = 0;
//STRIP001 	pPara = pOutliner->GetParagraph( 0 );
//STRIP001 
//STRIP001 	while (pPara)
//STRIP001 	{
//STRIP001 		if ( pOutliner->GetDepth( (USHORT) nParaPos ) == 0 )                     // eine Seite?
//STRIP001 		{
//STRIP001 			SdPage* pPage = pDoc->GetSdPage(nPos, PK_STANDARD);
//STRIP001 			pPage->SetSelected(FALSE);
//STRIP001 
//STRIP001 			if (pSelParas->Seek(pPara))            // selektiert?
//STRIP001 			{
//STRIP001 				pPage->SetSelected(TRUE);
//STRIP001 			}
//STRIP001 
//STRIP001 			nPos++;
//STRIP001 		}
//STRIP001 
//STRIP001 		pPara = pOutliner->GetParagraph( ++nParaPos );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Neue Links setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::SetLinks()
//STRIP001 {
//STRIP001 	// Benachrichtigungs-Links setzen
//STRIP001 	pOutliner->SetParaInsertedHdl(LINK(this, SdOutlineView, ParagraphInsertedHdl));
//STRIP001 	pOutliner->SetParaRemovingHdl(LINK(this, SdOutlineView, ParagraphRemovingHdl));
//STRIP001 	pOutliner->SetDepthChangedHdl(LINK(this, SdOutlineView, DepthChangedHdl));
//STRIP001 	pOutliner->SetBeginMovingHdl(LINK(this, SdOutlineView, BeginMovingHdl));
//STRIP001 	pOutliner->SetEndMovingHdl(LINK(this, SdOutlineView, EndMovingHdl));
//STRIP001 	pOutliner->SetRemovingPagesHdl(LINK(this, SdOutlineView, RemovingPagesHdl));
//STRIP001 	pOutliner->SetIndentingPagesHdl(LINK(this, SdOutlineView, IndentingPagesHdl));
//STRIP001 	pOutliner->SetMinDepth(0);
//STRIP001 	pOutliner->SetStatusEventHdl(LINK(this, SdOutlineView, StatusEventHdl));
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Alte Links restaurieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdOutlineView::ResetLinks() const
//STRIP001 {
//STRIP001 	// alte Links restaurieren
//STRIP001 	Link aEmptyLink;
//STRIP001 	pOutliner->SetParaInsertedHdl(aEmptyLink);
//STRIP001 	pOutliner->SetParaRemovingHdl(aEmptyLink);
//STRIP001 	pOutliner->SetDepthChangedHdl(aEmptyLink);
//STRIP001 	pOutliner->SetBeginMovingHdl(aEmptyLink);
//STRIP001 	pOutliner->SetEndMovingHdl(aEmptyLink);
//STRIP001 	pOutliner->SetStatusEventHdl(aEmptyLink);
//STRIP001 	pOutliner->SetRemovingPagesHdl(aEmptyLink);
//STRIP001 	pOutliner->SetIndentingPagesHdl(aEmptyLink);
//STRIP001 	pOutliner->SetMinDepth(0);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* AcceptDrop
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 sal_Int8 SdOutlineView::AcceptDrop( const AcceptDropEvent& rEvt, DropTargetHelper& rTargetHelper,
//STRIP001                                     SdWindow* pTargetWindow, USHORT nPage, USHORT nLayer )
//STRIP001 {
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ExecuteDrop
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 sal_Int8 SdOutlineView::ExecuteDrop( const ExecuteDropEvent& rEvt, DropTargetHelper& rTargetHelper,
//STRIP001                                      SdWindow* pTargetWindow, USHORT nPage, USHORT nLayer )
//STRIP001 {
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }
//STRIP001 
//STRIP001 // #97766# Re-implement GetScriptType for this view to get correct results
//STRIP001 sal_uInt16 SdOutlineView::GetScriptType() const
//STRIP001 {
//STRIP001 	sal_uInt16 nScriptType = SdView::GetScriptType();
//STRIP001 	
//STRIP001 	if(pOutliner)
//STRIP001 	{
//STRIP001 		OutlinerParaObject* pTempOPObj = pOutliner->CreateParaObject();
//STRIP001 
//STRIP001 		if(pTempOPObj)
//STRIP001 		{
//STRIP001 			nScriptType = pTempOPObj->GetTextObject().GetScriptType();
//STRIP001 			delete pTempOPObj;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nScriptType;
//STRIP001 }
//STRIP001 
//STRIP001 void SdOutlineView::onUpdateStyleSettings( bool bForceUpdate /* = false */ )
//STRIP001 {
//STRIP001 	const bool bHighContrastMode = Application::GetSettings().GetStyleSettings().GetHighContrastMode() != 0;
//STRIP001 	if( bForceUpdate || (mbHighContrastMode != bHighContrastMode) )
//STRIP001 	{
//STRIP001 		if( pOutliner )
//STRIP001 		{
//STRIP001 			pOutliner->ForceAutoColor( bHighContrastMode );
//STRIP001 		}
//STRIP001 		mbHighContrastMode = bHighContrastMode;
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001     const Color aDocColor( aColorConfig.GetColorValue( svtools::DOCCOLOR ).nColor );
//STRIP001 	if( bForceUpdate || (maDocColor != aDocColor) )
//STRIP001 	{
//STRIP001 		sal_uInt16 nView;
//STRIP001 		for( nView = 0; nView < MAX_OUTLINERVIEWS; nView++ )
//STRIP001 		{
//STRIP001 			if (pOutlinerView[nView] != NULL)
//STRIP001 			{
//STRIP001 				pOutlinerView[nView]->SetBackgroundColor( aDocColor );
//STRIP001 
//STRIP001 				Window* pWindow = pOutlinerView[nView]->GetWindow();
//STRIP001 
//STRIP001 				if( pWindow )
//STRIP001 					pWindow->SetBackground( Wallpaper( aDocColor ) );
//STRIP001 
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if( pOutliner )
//STRIP001 			pOutliner->SetBackgroundColor( aDocColor );
//STRIP001 
//STRIP001 		maDocColor = aDocColor;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SdOutlineView, AppEventListenerHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	onUpdateStyleSettings();
//STRIP001 	return 0;
//STRIP001 }

// eof
}
