/*************************************************************************
 *
 *  $RCSfile: sfx2_fltdlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:31:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// INCLUDE ---------------------------------------------------------------

// auto strip #ifndef _LIST_HXX //autogen
// auto strip #include <tools/list.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _SFXPOOLITEM_HXX //autogen
// auto strip #include <svtools/poolitem.hxx>
// auto strip #endif
#pragma hdrstop

// auto strip #include "fltfnc.hxx"
// auto strip #include "nfltdlg.hxx"
// auto strip #include "docfilt.hxx"
// auto strip #include "sfxresid.hxx"
// auto strip #include "app.hxx"
// auto strip #include "docfile.hxx"

#include "bastyp.hrc"
#include "fltdlg.hrc"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 SfxFilterDialog::SfxFilterDialog
//STRIP001 (
//STRIP001 	Window* pParent,
//STRIP001 	SfxMedium* pMed,
//STRIP001 	const SfxFilterMatcher& rMatcherP,
//STRIP001 	const String* pDefFilter,
//STRIP001 	BOOL bShowConvert
//STRIP001 ) :
//STRIP001 
//STRIP001 	ModalDialog( pParent, SfxResId( DLG_FILTER_SELECT ) ),
//STRIP001 
//STRIP001 	aMimeTypeFL	( this, ResId( FL_MIMETYPE ) ),
//STRIP001 	aMIMEType	( this, ResId( FT_DLG_MIMETYPE ) ),
//STRIP001 	aExtension	( this, ResId( FT_DLG_EXTENSTION ) ),
//STRIP001 	aFilterFL	( this, ResId( FL_FILTER ) ),
//STRIP001 	aListbox	( this, ResId( LB_DLG_LISTBOX ) ),
//STRIP001 	aOkBtn		( this, ResId( LB_DLG_OKBTN ) ),
//STRIP001 	aCancelBtn	( this, ResId( LB_DLG_CANCELBTN ) ),
//STRIP001 	aHelpBtn	( this, ResId( BTN_HELP ) ),
//STRIP001     rMatcher    ( rMatcherP )
//STRIP001 {
//STRIP001 	const short nExtra = *(short*)GetClassRes();
//STRIP001 	IncrementRes(sizeof(short));
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	String aMimeText( aMIMEType.GetText() );
//STRIP001 	String aMime;
//STRIP001 	pMed->GetMIMEAndRedirect( aMime );
//STRIP001 	aMimeText += aMime;
//STRIP001 	aMIMEType.SetText( aMimeText );
//STRIP001 	String aExtensionText( aExtension.GetText() );
//STRIP001 	aExtensionText += pMed->GetURLObject().GetExtension();
//STRIP001 	aExtension.SetText( aExtensionText );
//STRIP001 
//STRIP001 	aListbox.SetDoubleClickHdl(LINK(this, SfxFilterDialog, OkHdl));
//STRIP001 	SfxFilterMatcherIter aIter(
//STRIP001 		&rMatcher, SFX_FILTER_IMPORT,
//STRIP001 		SFX_FILTER_INTERNAL|SFX_FILTER_NOTINCHOOSER );
//STRIP001 	for( const SfxFilter* pFilter = aIter.First(); pFilter;
//STRIP001 		 pFilter = aIter.Next() )
//STRIP001 		aListbox.InsertEntry( pFilter->GetUIName() );
//STRIP001 	if ( pDefFilter )
//STRIP001 		aListbox.SelectEntry(*pDefFilter);
//STRIP001 	else
//STRIP001 		aListbox.SelectEntryPos( aListbox.GetEntryCount()-1 );
//STRIP001 }
//STRIP001 
//STRIP001 //-------------------------------------------------------------------------
//STRIP001 
//STRIP001 String SfxFilterDialog::GetSelectEntry()  const
//STRIP001 {
//STRIP001 	return aListbox.GetSelectEntry();
//STRIP001 }
//STRIP001 
//STRIP001 //-------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SfxFilterDialog, OkHdl, Control *, pControl )
//STRIP001 {
//STRIP001 	EndDialog(RET_OK);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SfxFilterDialog, OkHdl, Control *, pControl )
//STRIP001 
}
