/*************************************************************************
 *
 *  $RCSfile: sfx2_clientsh.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:49:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SOERR_HXX //autogen
// auto strip #include <so3/soerr.hxx>
// auto strip #endif
// auto strip #ifndef _SV_WRKWIN_HXX //autogen
// auto strip #include <vcl/wrkwin.hxx>
// auto strip #endif
// auto strip #include <so3/applet.hxx>
#pragma hdrstop

#define _SFX_CLIENTSH_CXX

// auto strip #include "clientsh.hxx"
#include "docfile.hxx"
// auto strip #include "virtmenu.hxx"
// auto strip #include "app.hxx"
// auto strip #include "mnumgr.hxx"
// auto strip #include "stbmgr.hxx"
// auto strip #include "viewfrm.hxx"
#include "viewsh.hxx"
// auto strip #include "dispatch.hxx"
#include "contenv.hxx"
// auto strip #include "objsh.hxx"
#include "interno.hxx"
#if SUPD<613//MUSTINI
// auto strip #include "inimgr.hxx"
#endif

//! wg. HACK
// auto strip #include "plugobj.hxx"
// auto strip #include "frameobj.hxx"
namespace binfilter {

#define SFX_CLIENTACTIVATE_TIMEOUT 100

//--------------------------------------------------------------------

/*N*/ struct SfxInPlaceClient_Impl
/*N*/ {
/*N*/ 	Timer	aTimer;
/*N*/ 	//SvInPlaceMenuBar*	pMenuBar;
/*N*/ };

//--------------------------------------------------------------------

/*N*/ SfxInPlaceClient::SfxInPlaceClient( SfxViewShell * pViewShell, Window * pDraw ) :
/*N*/ 	pImp( new SfxInPlaceClient_Impl ),
/*N*/ 	pViewSh( pViewShell )
/*N*/ {
/*N*/ 	WorkWindow* pTop;
/*!!! (pb) needs new implementation
	if ( Application::IsPresentationMode() )
	{
		// Wg. Mega-Hack im Impress mu\s die Presentation leider wieder mal
		// spezialbehandelt werden; das ViewFrameWindow oder TaskWindow liegen
		// leider au\serhalb des PresentaionWindow !
		pTop = (WorkWindow*) SFX_APP()->GetTopWindow();
	}
	else
*/
/*N*/ 	{
/*N*/         pTop = (WorkWindow*) &pViewSh->GetViewFrame()->GetFrame()->GetWindow();
/*N*/ 	}

	// Bis zur 314 erstmal gleich erzeugen
/*N*/ 	SetViewData( new SfxContainerEnv_Impl( this, pViewShell->GetViewFrame(), pTop, pDraw ) );
/*N*/ 
/*N*/ 	pImp->aTimer.SetTimeout( SFX_CLIENTACTIVATE_TIMEOUT );
/*N*/ 	pImp->aTimer.SetTimeoutHdl( LINK( this, SfxInPlaceClient, TimerHdl_Impl ) );
/*N*/ }

//--------------------------------------------------------------------

/*N*/ SfxInPlaceClient::SfxInPlaceClient( SfxViewShell * pViewShell,
/*N*/ 									SvInPlaceClient * pPar )
/*N*/ :	SvInPlaceClient( /*
		new SfxContainerEnv_Impl( pViewShell->GetViewFrame(), pPar )*/ ),
/*N*/ 	pImp( NULL ),
/*N*/  	pViewSh( pViewShell )
/*N*/ {
/*N*/ }

//--------------------------------------------------------------------

/*N*/ SfxInPlaceClient::~SfxInPlaceClient()
/*N*/ {
/*N*/ 	SvClientData *pData = GetClientData();
/*N*/ 	SetViewData( NULL );
/*N*/ 	delete pData;
/*N*/ 	pImp->aTimer.Stop();
/*N*/ 	delete pImp;
/*N*/ }

//--------------------------------------------------------------------

/*?*/ void SfxInPlaceClient::Opened( BOOL bOpen )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// SO2 l"a\st das Zerst"oren der Objeckte leider jederzeit zu
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 	SvInPlaceClient::Opened(bOpen);
//STRIP001 	if ( bOpen )
//STRIP001 	{
//STRIP001 		if ( GetIPObj()->GetMiscStatus() & SVOBJ_MISCSTATUS_ALWAYSACTIVATE )
//STRIP001 		{
//STRIP001 #if SUPD<613//MUSTINI
//STRIP001 			BOOL bApplets = SFX_INIMANAGER()->IsAppletsEnabled();
//STRIP001 #else
//STRIP001 			BOOL bApplets = sal_False;
//STRIP001 #endif
//STRIP001 			SvAppletObjectRef aAppRef = GetIPObj();
//STRIP001 			if ( !pViewSh->PlugInsActive() || aAppRef.Is() && !bApplets )
//STRIP001 				GetProtocol().Reset2Open();
//STRIP001 		}
//STRIP001 	}
/*?*/ }

//--------------------------------------------------------------------

/*?*/ void SfxInPlaceClient::Connected( BOOL bConnect )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// SO2 l"a\st das Zerst"oren der Objeckte leider jederzeit zu
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 
//STRIP001 	SvInPlaceClient::Connected(bConnect);
//STRIP001 	if ( bConnect )
//STRIP001 	{
//STRIP001 		pViewSh->NewIPClient_Impl(this);
//STRIP001 		if ( pViewSh->PlugInsActive() )
//STRIP001 			pImp->aTimer.Start();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pImp->aTimer.Stop();
//STRIP001 		pViewSh->IPClientGone_Impl(this);
//STRIP001 	}
/*?*/ }

//--------------------------------------------------------------------

/*?*/ void SfxInPlaceClient::UIActivate( BOOL bActivate )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// SO2 l"a\st das Zerst"oren der Objeckte leider jederzeit zu
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 
//STRIP001 	if (bActivate)
//STRIP001 	{
//STRIP001 		pViewSh->DisconnectClients_Impl(this);
//STRIP001 		pViewSh->GetViewFrame()->GetBindings().InvalidateAll(TRUE);
//STRIP001         pViewSh->GetViewFrame()->GetDispatcher()->Flush();
//STRIP001 
//STRIP001 		pViewSh->UIActivate( GetIPObj() );
//STRIP001 	}
//STRIP001 
//STRIP001 	SvInPlaceClient::UIActivate( bActivate );
//STRIP001 
//STRIP001 	if (!bActivate)
//STRIP001 	{
//STRIP001 		pViewSh->UIDeactivate( GetIPObj() );
//STRIP001 //		pViewSh->GetWindow()->GrabFocus();
//STRIP001 		pViewSh->GetViewFrame()->GetBindings().InvalidateAll(TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 /* InPlace in InPlace ...
//STRIP001 	if( !GetParent() )
//STRIP001 	{ // Root-Client
//STRIP001 		if( bActivate )
//STRIP001 			aPaintApp.GetToolBox()->Hide();
//STRIP001 		else if( !GetUIActiveClient() )
//STRIP001 			// letzter Client im MDI-Win wird deaktiviert
//STRIP001 			aPaintApp.GetToolBox()->Show();
//STRIP001 	}
//STRIP001 	else if( !GetUIActiveClient() && GetParent()->IsInPlaceActive() )
//STRIP001 		// Kein andere aktiviert, also Parent aktivieren
//STRIP001 		GetParent()->GetIPObj()->DoUIActivate( TRUE );
//STRIP001 */
/*?*/ }

//--------------------------------------------------------------------

/*?*/ void SfxInPlaceClient::RequestObjAreaPixel( const Rectangle & rObjRect )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	GetEnv()->SvContainerEnvironment::RequestObjAreaPixel( rObjRect );
/*?*/ }

//--------------------------------------------------------------------

/*?*/ void SfxInPlaceClient::Embedded( BOOL bEmbedding )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// SO2 l"a\st das Zerst"oren der Objeckte leider jederzeit zu
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 
//STRIP001 	SvInPlaceClient::Embedded( bEmbedding );
//STRIP001 	if (bEmbedding)
//STRIP001         GetEmbedObj()->SetDocumentName( pViewSh->GetViewFrame()->GetObjectShell()->GetTitle() );
//STRIP001 	else
//STRIP001         pViewSh->GetViewFrame()->GetFrame()->GrabFocusOnComponent_Impl();
/*?*/ }


/*?*/ IMPL_LINK( SfxInPlaceClient, TimerHdl_Impl, Timer*, pTimer )

/*	[Beschreibung]

	Ein Client wurde connected, weil das Objekt ACTIVATE_WHENVISIBLE hat.
	Dann soll es nach kurzer Zeit automatisch aktiviert werden.

*/

/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// Diesen Client referenzieren, da er evtl. im DoVerb abfliegen k"onnte,
//STRIP001 	// wenn das PlugIn fehlschl"agt
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 	SfxInPlaceObject *pObj = pViewSh->GetFrame()->GetObjectShell()->GetInPlaceObject();
//STRIP001 	Rectangle aVisArea = pObj->GetVisArea();
//STRIP001 	GetViewShell()->CheckIPClient_Impl( this, aVisArea );
/*?*/ 	return 0;
/*?*/ }

/*?*/ void SfxInPlaceClient::InPlaceActivate( BOOL bActivate )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// SO2 l"a\st das Zerst"oren der Objeckte leider jederzeit zu
//STRIP001 	SvInPlaceClientRef aIPClient( this );
//STRIP001 
//STRIP001 	if ( bActivate )
//STRIP001 	{
//STRIP001 		// Falls der Activate-Timer noch l"auft.
//STRIP001 		pImp->aTimer.Stop();
//STRIP001 
//STRIP001 		// FullPlugs, die als Objekte eingef"ugt wurden, m"ussen noch auf volle
//STRIP001 		// Fenstergr"o\se gebracht werden
//STRIP001 		SvPlugInObjectRef aRef = GetIPObj();
//STRIP001 		if ( aRef.Is() )
//STRIP001 		{
//STRIP001 			//! HACK
//STRIP001 			TimerHdl_Impl(0);
//STRIP001 //			pImp->aTimer.Start();
//STRIP001 
//STRIP001 			if ( aRef->GetPlugInMode() == PLUGIN_FULL )
//STRIP001 			{
//STRIP001 				pViewSh->SetBorderPixel(SvBorder());
//STRIP001 				Window *pWin = pViewSh->GetWindow();
//STRIP001 				Size aSize = pWin->GetOutputSizePixel();
//STRIP001 				aSize = pWin->PixelToLogic(aSize);
//STRIP001 				Rectangle aRect = Rectangle ( pWin->PixelToLogic(Point()), aSize);
//STRIP001 				GetClientData()->SetObjArea(aRect);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
/*?*/ }

// F"urs Update erstmal schnell rein damit ...

/*?*/ void SfxInPlaceClient::MakeViewData()
/*?*/ {
/*?*/ }

/*?*/ void SfxInPlaceClient::FreeViewData()
/*?*/ {
/*?*/ }

/*?*/ void SfxInPlaceClient::MakeVisible()
/*?*/ {
/*?*/ }

//========================================================================
/*?*/ ErrCode	SfxInPlaceClient::GetContURL
/*?*/ (
/*?*/ 	INetURLObject & rURL
/*?*/ )
/*	[Beschreibung]

	[Querverweise]

	<SvEmbeddedClient::GetContURL>
*/
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); return 0;//STRIP001 
//STRIP001 	SfxMedium * pMed = pViewSh->GetViewFrame()->GetObjectShell()->GetMedium();
//STRIP001 	if( rURL.SetSmartURL( pMed->GetName() ) )
//STRIP001 		return ERRCODE_NONE;
//STRIP001 	else
//STRIP001 	{
//STRIP001 		rURL = INetURLObject();
//STRIP001 		return ERRCODE_SO_GENERALERROR;
//STRIP001 	}
/*?*/ }


}
