/*************************************************************************
 *
 *  $RCSfile: mailmodel.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:39:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef INCLUDED_SFX_MAILMODEL_HXX
#define INCLUDED_SFX_MAILMODEL_HXX

#include "objsh.hxx"
namespace binfilter {

// class SfxMailModel_Impl -----------------------------------------------

class AddressList_Impl;
class SfxBindings;

//STRIP001 class SfxMailModel_Impl
//STRIP001 {
//STRIP001 public:
//STRIP001 	enum MailPriority
//STRIP001 	{
//STRIP001 		PRIO_HIGHEST,
//STRIP001 		PRIO_HIGH,
//STRIP001 		PRIO_NORMAL,
//STRIP001 		PRIO_LOW,
//STRIP001 		PRIO_LOWEST
//STRIP001 	};
//STRIP001 
//STRIP001 	enum AddressRole
//STRIP001 	{
//STRIP001 		ROLE_TO,
//STRIP001 		ROLE_CC,
//STRIP001 		ROLE_BCC
//STRIP001 	};
//STRIP001 
//STRIP001 	enum MailDocType
//STRIP001 	{
//STRIP001 		TYPE_SELF,
//STRIP001 		TYPE_ASPDF
//STRIP001 	};
//STRIP001 
//STRIP001 private:
//STRIP001 	enum SaveResult
//STRIP001 	{
//STRIP001 		SAVE_SUCCESSFULL,
//STRIP001 		SAVE_CANCELLED,
//STRIP001 		SAVE_ERROR
//STRIP001 	};
//STRIP001 
//STRIP001 	AddressList_Impl*	mpToList;
//STRIP001 	AddressList_Impl*	mpCcList;
//STRIP001 	AddressList_Impl*	mpBccList;
//STRIP001 	SfxBindings*		mpBindings;
//STRIP001 	String				maFromAddress;
//STRIP001 	String				maSubject;
//STRIP001 	MailPriority		mePriority;
//STRIP001 
//STRIP001 	sal_Bool			mbLoadDone;
//STRIP001 
//STRIP001 	void				ClearList( AddressList_Impl* pList );
//STRIP001 	void				MakeValueList( AddressList_Impl* pList, String& rValueList );
//STRIP001 	SaveResult			SaveDocument( String& rFileName, String& rType );
//STRIP001 	SaveResult			SaveDocAsPDF( String& rFileName, String& rType );
//STRIP001 
//STRIP001 	DECL_LINK( DoneHdl, void* );
//STRIP001 
//STRIP001 public:
//STRIP001 	enum SendMailResult
//STRIP001 	{
//STRIP001 		SEND_MAIL_OK,
//STRIP001 		SEND_MAIL_CANCELLED,
//STRIP001 		SEND_MAIL_ERROR
//STRIP001 	};
//STRIP001 	
//STRIP001 	SfxMailModel_Impl( SfxBindings* pBinds );
//STRIP001 	~SfxMailModel_Impl();
//STRIP001 
//STRIP001 	void				AddAddress( const String& rAddress, AddressRole eRole );
//STRIP001 	void				SetFromAddress( const String& rAddress )	{ maFromAddress = rAddress; }
//STRIP001 	void				SetSubject( const String& rSubject )		{ maSubject = rSubject; }
//STRIP001 	void				SetPriority( MailPriority ePrio )			{ mePriority = ePrio; }
//STRIP001 
//STRIP001 	SendMailResult		Send( MailDocType );
//STRIP001 };

BOOL CreateFromAddress_Impl( String& rFrom );

}//end of namespace binfilter
#endif // INCLUDED_SFX_MAILMODEL_HXX


