/*************************************************************************
 *
 *  $RCSfile: svx_contwnd.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _XOUTX_HXX //autogen
#include <xoutx.hxx>
#endif
#include <xoutbmp.hxx>
#include <dialogs.hrc>
#include <svxids.hrc>
#include <contdlg.hrc>
#include <contwnd.hxx>
#include "svdpage.hxx"
#include "svdopath.hxx"
#include "xfltrit.hxx"

#ifndef _SVX_FILLITEM_HXX //autogen
#include <xfillit.hxx>
#endif
namespace binfilter {

//STRIP001 #ifdef MAC
//STRIP001 #define TRANSCOL Color( COL_LIGHTGRAY )
//STRIP001 #else
//STRIP001 #define TRANSCOL Color( COL_WHITE )
//STRIP001 #endif

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 ContourWindow::ContourWindow( Window* pParent, const ResId& rResId ) :
//STRIP001 			GraphCtrl		( pParent, rResId ),
//STRIP001 			aWorkRect		( 0, 0, 0, 0 ),
//STRIP001 			bPipetteMode	( FALSE ),
//STRIP001 			bWorkplaceMode	( FALSE ),
//STRIP001 			bClickValid		( FALSE )
//STRIP001 {
//STRIP001 	SetWinStyle( WB_SDRMODE );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 ContourWindow::~ContourWindow()
//STRIP001 {
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::SetPolyPolygon( const PolyPolygon& rPolyPoly )
//STRIP001 {
//STRIP001 	SdrPage*		pPage = (SdrPage*) pModel->GetPage( 0 );
//STRIP001 	const USHORT	nPolyCount = rPolyPoly.Count();
//STRIP001 
//STRIP001 	// zuerst alle Zeichenobjekte loeschen
//STRIP001 	aPolyPoly = rPolyPoly;
//STRIP001 	pPage->Clear();
//STRIP001 
//STRIP001 	for ( USHORT i = 0; i < nPolyCount; i++ )
//STRIP001 	{
//STRIP001 		SdrPathObj* pPathObj = new SdrPathObj( OBJ_PATHFILL, XPolygon( aPolyPoly[ i ] ) );
//STRIP001 
//STRIP001 		if ( pPathObj )
//STRIP001 		{
//STRIP001 			SfxItemSet aSet( pModel->GetItemPool() );
//STRIP001 
//STRIP001 			aSet.Put( XFillStyleItem( XFILL_SOLID ) );
//STRIP001 			aSet.Put( XFillColorItem( String(), TRANSCOL ) );
//STRIP001 			aSet.Put( XFillTransparenceItem( 50 ) );
//STRIP001 
//STRIP001 //-/			pPathObj->SetAttributes( aSet, FALSE );
//STRIP001 //-/			SdrBroadcastItemChange aItemChange(*pPathObj);
//STRIP001 			pPathObj->SetItemSetAndBroadcast(aSet);
//STRIP001 //-/			pPathObj->BroadcastItemChange(aItemChange);
//STRIP001 
//STRIP001 			pPage->InsertObject( pPathObj );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( nPolyCount )
//STRIP001 	{
//STRIP001 		pView->MarkAll();
//STRIP001 		pView->CombineMarkedObjects( FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	pModel->SetChanged( TRUE );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 const PolyPolygon& ContourWindow::GetPolyPolygon()
//STRIP001 {
//STRIP001 	if ( pModel->IsChanged() )
//STRIP001 	{
//STRIP001 		SdrPage* pPage = (SdrPage*) pModel->GetPage( 0 );
//STRIP001 
//STRIP001 		aPolyPoly = PolyPolygon();
//STRIP001 
//STRIP001 		if ( pPage && pPage->GetObjCount() )
//STRIP001 		{
//STRIP001 			SdrPathObj*			pPathObj = (SdrPathObj*) pPage->GetObj( 0 );
//STRIP001 			const XPolyPolygon&	rXPolyPoly = pPathObj->GetPathPoly();
//STRIP001 
//STRIP001 			for ( USHORT i = 0, nPolyCount = rXPolyPoly.Count(); i < nPolyCount; i++ )
//STRIP001 				aPolyPoly.Insert( XOutCreatePolygon( rXPolyPoly.GetObject( i ), NULL ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		pModel->SetChanged( FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	return aPolyPoly;
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::InitSdrModel()
//STRIP001 {
//STRIP001 	GraphCtrl::InitSdrModel();
//STRIP001 
//STRIP001 	SfxItemSet aSet( pModel->GetItemPool() );
//STRIP001 
//STRIP001 	aSet.Put( XFillColorItem( String(), TRANSCOL ) );
//STRIP001 	aSet.Put( XFillTransparenceItem( 50 ) );
//STRIP001 	pView->SetAttributes( aSet );
//STRIP001 	pView->SetFrameDragSingles( TRUE );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::SdrObjCreated( const SdrObject& rObj )
//STRIP001 {
//STRIP001 	pView->MarkAll();
//STRIP001 	pView->CombineMarkedObjects( FALSE );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 BOOL ContourWindow::IsContourChanged() const
//STRIP001 {
//STRIP001 	SdrPage*	pPage = (SdrPage*) pModel->GetPage( 0 );
//STRIP001 	BOOL		bRet = FALSE;
//STRIP001 
//STRIP001 	if ( pPage && pPage->GetObjCount() )
//STRIP001 		bRet = ( (SdrPathObj*) pPage->GetObj( 0 ) )->GetPathPoly().Count() && pModel->IsChanged();
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	if ( bWorkplaceMode )
//STRIP001 	{
//STRIP001 		const Point aLogPt( PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 		SetPolyPolygon( PolyPolygon() );
//STRIP001 		aWorkRect = Rectangle( aLogPt, aLogPt );
//STRIP001 		Paint( Rectangle( Point(), GetGraphicSize() ) );
//STRIP001 		SetEditMode( TRUE );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !bPipetteMode )
//STRIP001 		GraphCtrl::MouseButtonDown( rMEvt );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	bClickValid = FALSE;
//STRIP001 
//STRIP001 	if ( bPipetteMode )
//STRIP001 	{
//STRIP001 		const Point aLogPt( PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 		const Link&	rLink = GetMousePosLink();
//STRIP001 
//STRIP001 		aPipetteColor = GetPixel( aLogPt );
//STRIP001 		Control::MouseMove( rMEvt );
//STRIP001 
//STRIP001 		if ( aPipetteLink.IsSet() && Rectangle( Point(), GetGraphicSize() ).IsInside( aLogPt ) )
//STRIP001 		{
//STRIP001 			SetPointer( POINTER_REFHAND );
//STRIP001 			aPipetteLink.Call( this );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		GraphCtrl::MouseMove( rMEvt );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	Point aTmpPoint;
//STRIP001 	const Rectangle	aGraphRect( aTmpPoint, GetGraphicSize() );
//STRIP001 	const Point		aLogPt( PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 	bClickValid = aGraphRect.IsInside( aLogPt );
//STRIP001 	ReleaseMouse();
//STRIP001 
//STRIP001 	if ( bPipetteMode )
//STRIP001 	{
//STRIP001 		Control::MouseButtonUp( rMEvt );
//STRIP001 
//STRIP001 		if ( aPipetteClickLink.IsSet() )
//STRIP001 			aPipetteClickLink.Call( this );
//STRIP001 	}
//STRIP001 	else if ( bWorkplaceMode )
//STRIP001 	{
//STRIP001 		GraphCtrl::MouseButtonUp( rMEvt );
//STRIP001 
//STRIP001 		aWorkRect.Right() = aLogPt.X();
//STRIP001 		aWorkRect.Bottom() = aLogPt.Y();
//STRIP001 		aWorkRect.Intersection( aGraphRect );
//STRIP001 		aWorkRect.Justify();
//STRIP001 
//STRIP001 		if ( aWorkRect.Left() != aWorkRect.Right() && aWorkRect.Top() != aWorkRect.Bottom() )
//STRIP001 		{
//STRIP001 			PolyPolygon aPolyPoly( GetPolyPolygon() );
//STRIP001 
//STRIP001 			aPolyPoly.Clip( aWorkRect );
//STRIP001 			SetPolyPolygon( aPolyPoly );
//STRIP001 			pView->SetWorkArea( aWorkRect );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pView->SetWorkArea( aGraphRect );
//STRIP001 
//STRIP001 		Invalidate( aGraphRect );
//STRIP001 
//STRIP001 		if ( aWorkplaceClickLink.IsSet() )
//STRIP001 			aWorkplaceClickLink.Call( this );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		GraphCtrl::MouseButtonUp( rMEvt );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void ContourWindow::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	const Graphic& rGraphic = GetGraphic();
//STRIP001 
//STRIP001 	const Color& rOldLineColor = GetLineColor();
//STRIP001 	const Color& rOldFillColor = GetFillColor();
//STRIP001 	
//STRIP001 	SetLineColor( Color( COL_BLACK ) );
//STRIP001 	SetFillColor( Color( COL_WHITE ) );
//STRIP001 
//STRIP001 	DrawRect( Rectangle( Point(), GetGraphicSize() ) );
//STRIP001 
//STRIP001 	SetLineColor( rOldLineColor );
//STRIP001 	SetFillColor( rOldFillColor );
//STRIP001 
//STRIP001 	if ( rGraphic.GetType() != GRAPHIC_NONE )
//STRIP001 		rGraphic.Draw( this, Point(), GetGraphicSize() );
//STRIP001 
//STRIP001 	if ( aWorkRect.Left() != aWorkRect.Right() && aWorkRect.Top() != aWorkRect.Bottom() )
//STRIP001 	{
//STRIP001 		PolyPolygon	aPolyPoly( 2, 2 );
//STRIP001 		const Color	aOldFillColor( GetFillColor() );
//STRIP001 
//STRIP001 		aPolyPoly.Insert( Rectangle( Point(), GetGraphicSize() ) );
//STRIP001 		aPolyPoly.Insert( aWorkRect );
//STRIP001 
//STRIP001 		SetFillColor( COL_LIGHTRED );
//STRIP001 		DrawTransparent( aPolyPoly, 50 );
//STRIP001 		SetFillColor( aOldFillColor );
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->InitRedraw( this , rRect );
//STRIP001 }


}
