/*************************************************************************
 *
 *  $RCSfile: svx_measctrl.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#pragma hdrstop

#include "xoutx.hxx"
#include "svdomeas.hxx"
#include "svdmodel.hxx"

//#include "svdrwobj.hxx" // SdrPaintInfoRec

#include "measctrl.hxx"
#include "dialmgr.hxx"
#include "dlgutil.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Ctor SvxXMeasurePreview
|*
*************************************************************************/

//STRIP001 SvxXMeasurePreview::SvxXMeasurePreview
//STRIP001 (
//STRIP001 	Window* pParent,
//STRIP001 	const ResId& rResId,
//STRIP001 	const SfxItemSet& rInAttrs
//STRIP001 ) :
//STRIP001 
//STRIP001 	Control	( pParent, rResId ),
//STRIP001 	rAttrs	( rInAttrs )
//STRIP001 
//STRIP001 {
//STRIP001 	pExtOutDev = new ExtOutputDevice( this );
//STRIP001 
//STRIP001 	SetMapMode( MAP_100TH_MM );
//STRIP001 
//STRIP001 	Size aSize = GetOutputSize();
//STRIP001 
//STRIP001 	// Massstab: 1:2
//STRIP001 	MapMode aMapMode = GetMapMode();
//STRIP001 	aMapMode.SetScaleX( Fraction( 1, 2 ) );
//STRIP001 	aMapMode.SetScaleY( Fraction( 1, 2 ) );
//STRIP001 	SetMapMode( aMapMode );
//STRIP001 
//STRIP001 	aSize = GetOutputSize();
//STRIP001 	Rectangle aRect = Rectangle( Point(), aSize );
//STRIP001 	Point aPt1 = Point( aSize.Width() / 5, (long) ( aSize.Height() / 2 ) );
//STRIP001 	Point aPt2 = Point( aSize.Width() * 4 / 5, (long) ( aSize.Height() / 2 ) );
//STRIP001 
//STRIP001 	pMeasureObj = new SdrMeasureObj( aPt1, aPt2 );
//STRIP001 
//STRIP001 	pModel = new SdrModel();
//STRIP001 	pMeasureObj->SetModel( pModel );
//STRIP001 
//STRIP001 //-/	pMeasureObj->SetAttributes( rInAttrs, FALSE );
//STRIP001 //-/	SdrBroadcastItemChange aItemChange(*pMeasureObj);
//STRIP001 	pMeasureObj->SetItemSetAndBroadcast(rInAttrs);
//STRIP001 //-/	pMeasureObj->BroadcastItemChange(aItemChange);
//STRIP001 
//STRIP001 	SetDrawMode( GetDisplayBackground().GetColor().IsDark() ? OUTPUT_DRAWMODE_CONTRAST : OUTPUT_DRAWMODE_COLOR );
//STRIP001 
//STRIP001 	Invalidate();
//STRIP001 }

/*************************************************************************
|*
|* Dtor SvxXMeasurePreview
|*
*************************************************************************/

//STRIP001 SvxXMeasurePreview::~SvxXMeasurePreview()
//STRIP001 {
//STRIP001 	delete pExtOutDev;
//STRIP001 	delete pModel;
//STRIP001 }

/*************************************************************************
|*
|* SvxXMeasurePreview: Paint()
|*
*************************************************************************/

//STRIP001 void SvxXMeasurePreview::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	SdrPaintInfoRec aInfoRec;
//STRIP001 
//STRIP001 	pMeasureObj->Paint( *pExtOutDev, aInfoRec );
//STRIP001 }

/*************************************************************************
|*
|* SvxXMeasurePreview: SetAttributes()
|*
*************************************************************************/

//STRIP001 void SvxXMeasurePreview::SetAttributes( const SfxItemSet& rInAttrs )
//STRIP001 {
//STRIP001 //-/	pMeasureObj->SetAttributes( rInAttrs, FALSE );
//STRIP001 //-/	SdrBroadcastItemChange aItemChange(*pMeasureObj);
//STRIP001 	pMeasureObj->SetItemSetAndBroadcast(rInAttrs);
//STRIP001 //-/	pMeasureObj->BroadcastItemChange(aItemChange);
//STRIP001 
//STRIP001 	Invalidate();
//STRIP001 }

/*************************************************************************
|*
|* SvxXMeasurePreview: SetAttributes()
|*
*************************************************************************/

//STRIP001 void SvxXMeasurePreview::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	BOOL bZoomIn  = rMEvt.IsLeft() && !rMEvt.IsShift();
//STRIP001 	BOOL bZoomOut = rMEvt.IsRight() || rMEvt.IsShift();
//STRIP001 	BOOL bCtrl	  = rMEvt.IsMod1();
//STRIP001 
//STRIP001 	if( bZoomIn || bZoomOut )
//STRIP001 	{
//STRIP001 		MapMode aMapMode = GetMapMode();
//STRIP001 		Fraction aXFrac = aMapMode.GetScaleX();
//STRIP001 		Fraction aYFrac = aMapMode.GetScaleY();
//STRIP001 		Fraction* pMultFrac;
//STRIP001 
//STRIP001 		if( bZoomIn )
//STRIP001 		{
//STRIP001 			if( bCtrl )
//STRIP001 				pMultFrac = new Fraction( 3, 2 );
//STRIP001 			else
//STRIP001 				pMultFrac = new Fraction( 11, 10 );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( bCtrl )
//STRIP001 				pMultFrac = new Fraction( 2, 3 );
//STRIP001 			else
//STRIP001 				pMultFrac = new Fraction( 10, 11 );
//STRIP001 		}
//STRIP001 
//STRIP001 		aXFrac *= *pMultFrac;
//STRIP001 		aYFrac *= *pMultFrac;
//STRIP001 		if( (double)aXFrac > 0.001 && (double)aXFrac < 1000.0 &&
//STRIP001 			(double)aYFrac > 0.001 && (double)aYFrac < 1000.0 )
//STRIP001 		{
//STRIP001 			aMapMode.SetScaleX( aXFrac );
//STRIP001 			aMapMode.SetScaleY( aYFrac );
//STRIP001 			SetMapMode( aMapMode );
//STRIP001 
//STRIP001 			Size aOutSize( GetOutputSize() );
//STRIP001 
//STRIP001 			Point aPt( aMapMode.GetOrigin() );
//STRIP001 			long nX = (long)( ( (double)aOutSize.Width() - ( (double)aOutSize.Width() * (double)*pMultFrac  ) ) / 2.0 + 0.5 );
//STRIP001 			long nY = (long)( ( (double)aOutSize.Height() - ( (double)aOutSize.Height() * (double)*pMultFrac  ) ) / 2.0 + 0.5 );
//STRIP001 			aPt.X() +=  nX;
//STRIP001 			aPt.Y() +=  nY;
//STRIP001 
//STRIP001 			aMapMode.SetOrigin( aPt );
//STRIP001 			SetMapMode( aMapMode );
//STRIP001 
//STRIP001 			Invalidate();
//STRIP001 		}
//STRIP001 		delete pMultFrac;
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxXMeasurePreview::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001 	Control::DataChanged( rDCEvt );
//STRIP001 
//STRIP001 	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) && (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001 	{
//STRIP001 		SetDrawMode( GetDisplayBackground().GetColor().IsDark() ? OUTPUT_DRAWMODE_CONTRAST : OUTPUT_DRAWMODE_COLOR );
//STRIP001 	}
//STRIP001 }

}
