/*************************************************************************
 *
 *  $RCSfile: svx_passwd.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#pragma hdrstop

#define _SVX_PASSWD_CXX

#include "passwd.hxx"
#include "dialmgr.hxx"
#include "dialogs.hrc"
#include "passwd.hrc"
namespace binfilter {

// class SvxPasswordDialog -----------------------------------------------

//STRIP001 IMPL_LINK( SvxPasswordDialog, ButtonHdl, OKButton *, EMPTYARG )
//STRIP001 {
//STRIP001     BOOL bOK = TRUE;
//STRIP001 	short nRet = RET_OK;
//STRIP001 	String aEmpty;
//STRIP001 
//STRIP001 	if ( aNewPasswdED.GetText() != aRepeatPasswdED.GetText() )
//STRIP001 	{
//STRIP001 		ErrorBox( this, WB_OK, aRepeatPasswdErrStr ).Execute();
//STRIP001         aNewPasswdED.SetText( aEmpty );
//STRIP001 		aRepeatPasswdED.SetText( aEmpty );
//STRIP001 		aNewPasswdED.GrabFocus();
//STRIP001 		bOK = FALSE;
//STRIP001     }
//STRIP001 
//STRIP001     if ( bOK && aCheckPasswordHdl.IsSet() && !aCheckPasswordHdl.Call( this ) )
//STRIP001     {
//STRIP001         ErrorBox( this, WB_OK, aOldPasswdErrStr ).Execute();
//STRIP001         aOldPasswdED.SetText( aEmpty );
//STRIP001 		aOldPasswdED.GrabFocus();
//STRIP001 		bOK = FALSE;
//STRIP001     }
//STRIP001         
//STRIP001 	if ( bOK )
//STRIP001 		EndDialog( nRet );
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( SvxPasswordDialog, EditModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	if ( !bEmpty )
//STRIP001 	{
//STRIP001         String aPasswd = aRepeatPasswdED.GetText();
//STRIP001 		aPasswd.EraseLeadingChars().EraseTrailingChars();
//STRIP001 
//STRIP001 		if ( !aPasswd.Len() && aOKBtn.IsEnabled() )
//STRIP001 			aOKBtn.Disable();
//STRIP001         else if ( aPasswd.Len() && !aOKBtn.IsEnabled() )
//STRIP001 			aOKBtn.Enable();
//STRIP001 	}
//STRIP001 	else if ( !aOKBtn.IsEnabled() )
//STRIP001 		aOKBtn.Enable();
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxPasswordDialog::SvxPasswordDialog( Window* pParent, BOOL bAllowEmptyPasswords, BOOL bDisableOldPassword ) :
//STRIP001 	SfxModalDialog( pParent, SVX_RES( RID_SVXDLG_PASSWORD ) ),
//STRIP001 	aOldPasswdFT	( this, ResId( FT_OLD_PASSWD ) ),
//STRIP001 	aOldPasswdED	( this, ResId( ED_OLD_PASSWD ) ),
//STRIP001     aOldFL          ( this, ResId( FL_OLD_PASSWD ) ),
//STRIP001 	aNewPasswdFT	( this, ResId( FT_NEW_PASSWD ) ),
//STRIP001 	aNewPasswdED	( this, ResId( ED_NEW_PASSWD ) ),
//STRIP001 	aRepeatPasswdFT	( this, ResId( FT_REPEAT_PASSWD ) ),
//STRIP001 	aRepeatPasswdED	( this, ResId( ED_REPEAT_PASSWD ) ),
//STRIP001     aNewFL          ( this, ResId( FL_NEW_PASSWD ) ),
//STRIP001 	aOKBtn			( this, ResId( BTN_PASSWD_OK ) ),
//STRIP001 	aEscBtn			( this, ResId( BTN_PASSWD_ESC ) ),
//STRIP001 	aHelpBtn		( this, ResId( BTN_PASSWD_HELP ) ),
//STRIP001 	aOldPasswdErrStr	( ResId( STR_ERR_OLD_PASSWD ) ),
//STRIP001 	aRepeatPasswdErrStr	( ResId( STR_ERR_REPEAT_PASSWD ) ),
//STRIP001     bEmpty  ( bAllowEmptyPasswords )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aOKBtn.SetClickHdl( LINK( this, SvxPasswordDialog, ButtonHdl ) );
//STRIP001     aRepeatPasswdED.SetModifyHdl( LINK( this, SvxPasswordDialog, EditModifyHdl ) );
//STRIP001 	EditModifyHdl( 0 );
//STRIP001 
//STRIP001     if ( bDisableOldPassword )
//STRIP001     {
//STRIP001         aOldFL.Disable();
//STRIP001      	aOldPasswdFT.Disable();
//STRIP001 		aOldPasswdED.Disable();
//STRIP001 		aNewPasswdED.GrabFocus();
//STRIP001     }
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxPasswordDialog::~SvxPasswordDialog()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------


}
