/*************************************************************************
 *
 *  $RCSfile: eertfpar.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:32:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _EERTFPAR_HXX
#define _EERTFPAR_HXX

#include <svxrtf.hxx>

#include <editdoc.hxx>

#ifndef _SV_OUTDEV_HXX
#include <vcl/outdev.hxx>
#endif

#ifndef _VCL_POINTR_HXX
#include <vcl/pointr.hxx>
#endif

#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif

#include <impedit.hxx>
namespace binfilter {

#ifndef SVX_LIGHT

//STRIP001 class EditNodeIdx : public SvxNodeIdx
//STRIP001 {
//STRIP001 private:
//STRIP001 	ContentNode* 		pNode;
//STRIP001 	ImpEditEngine*		pImpEditEngine;
//STRIP001 
//STRIP001 public:
//STRIP001 						EditNodeIdx( ImpEditEngine* pIEE, ContentNode* pNd = 0)
//STRIP001 							{ pImpEditEngine = pIEE; pNode = pNd; }
//STRIP001 	virtual ULONG		GetIdx() const;
//STRIP001 	virtual SvxNodeIdx* Clone() const;
//STRIP001 	ContentNode*		GetNode() { return pNode; }
//STRIP001 };

//STRIP001 class EditPosition : public SvxPosition
//STRIP001 {
//STRIP001 private:
//STRIP001 	EditSelection* 	pCurSel;
//STRIP001 	ImpEditEngine*	pImpEditEngine;
//STRIP001 
//STRIP001 public:
//STRIP001 					EditPosition( ImpEditEngine* pIEE, EditSelection* pSel )
//STRIP001 							{ pImpEditEngine = pIEE; pCurSel = pSel; }
//STRIP001 
//STRIP001 	virtual ULONG	GetNodeIdx() const;
//STRIP001 	virtual USHORT	GetCntIdx() const;
//STRIP001 
//STRIP001 	// erzeuge von sich selbst eine Kopie
//STRIP001 	virtual SvxPosition* Clone() const;
//STRIP001 
//STRIP001 	// erzeuge vom NodeIndex eine Kopie
//STRIP001 	virtual SvxNodeIdx* MakeNodeIdx() const;
//STRIP001 };

//STRIP001 #define ACTION_INSERTTEXT		1
//STRIP001 #define ACTION_INSERTPARABRK	2

//STRIP001 class EditRTFParser : public SvxRTFParser
//STRIP001 {
//STRIP001 private:
//STRIP001 	EditSelection		aCurSel;
//STRIP001 	ImpEditEngine*		pImpEditEngine;
//STRIP001 	CharSet				eDestCharSet;
//STRIP001 	MapMode				aRTFMapMode;
//STRIP001 	MapMode				aEditMapMode;
//STRIP001 
//STRIP001 	USHORT				nDefFont;
//STRIP001 	USHORT				nDefTab;
//STRIP001 	USHORT				nDefFontHeight;
//STRIP001 	BYTE				nLastAction;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 		InsertPara();
//STRIP001 	virtual void 		InsertText();
//STRIP001 	virtual void		MovePos( int bForward = TRUE );
//STRIP001 	virtual void		SetEndPrevPara( SvxNodeIdx*& rpNodePos,
//STRIP001 											USHORT& rCntPos );
//STRIP001 
//STRIP001 	virtual void 		UnknownAttrToken( int nToken, SfxItemSet* pSet );
//STRIP001 	virtual void 		NextToken( int nToken );
//STRIP001 	virtual	void 		SetAttrInDoc( SvxRTFItemStackType &rSet );
//STRIP001 	inline long			TwipsToLogic( long n );
//STRIP001 	virtual int 		IsEndPara( SvxNodeIdx* pNd, USHORT nCnt ) const;
//STRIP001 	virtual void 		CalcValue();
//STRIP001 	void				CreateStyleSheets();
//STRIP001 	SfxStyleSheet*		CreateStyleSheet( SvxRTFStyleType* pRTFStyle );
//STRIP001 	SvxRTFStyleType*	FindStyleSheet( const String& rName );
//STRIP001 	void				AddRTFDefaultValues( const EditPaM& rStart, const EditPaM& rEnd );
//STRIP001 	void				ReadField();
//STRIP001 	void				SkipGroup();
//STRIP001 
//STRIP001 public:
//STRIP001 				EditRTFParser( SvStream& rIn, EditSelection aCurSel, SfxItemPool& rAttrPool, ImpEditEngine* pImpEditEngine );
//STRIP001 				~EditRTFParser();
//STRIP001 
//STRIP001 	virtual SvParserState	CallParser();
//STRIP001 
//STRIP001 
//STRIP001 	void		SetDestCharSet( CharSet eCharSet )	{ eDestCharSet = eCharSet; }
//STRIP001 	CharSet		GetDestCharSet() const				{ return eDestCharSet; }
//STRIP001 
//STRIP001 	USHORT		GetDefTab()	const					{ return nDefTab; }
//STRIP001 	Font		GetDefFont() 						{ return GetFont( nDefFont ); }
//STRIP001 
//STRIP001 	EditPaM		GetCurPaM() const					{ return aCurSel.Max(); }
//STRIP001 };

//STRIP001 SV_DECL_REF( EditRTFParser )//STRIP008 ;
//STRIP001 SV_IMPL_REF( EditRTFParser );

//STRIP001 inline long EditRTFParser::TwipsToLogic( long nTwps )
//STRIP001 {
//STRIP001 	Size aSz( nTwps, 0 );
//STRIP001 	aSz = pImpEditEngine->GetRefDevice()->LogicToLogic( aSz, &aRTFMapMode, &aEditMapMode );
//STRIP001 	return aSz.Width();
//STRIP001 }

#endif  // !SVX_LIGH
}//end of namespace binfilter
#endif	//_EERTFPAR_HXX
