/*************************************************************************
 *
 *  $RCSfile: svx_tabwin.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:50:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif

#ifndef _BASEDLGS_HXX
#include <bf_sfx2/basedlgs.hxx>
#endif

// auto strip #ifndef _SVX_FMTOOLS_HXX
// auto strip #include "fmtools.hxx"
// auto strip #endif
#ifndef _SVX_SVXIDS_HRC
#include "svxids.hrc"
#endif
// auto strip #ifndef _SVX_FMSERVS_HXX
// auto strip #include "fmservs.hxx"
// auto strip #endif
// auto strip #ifndef _SVX_DBAEXCHANGE_HXX_
// auto strip #include "dbaexchange.hxx"
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_SDB_COMMANDTYPE_HPP_
// auto strip #include <com/sun/star/sdb/CommandType.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_SDBCX_XTABLESSUPPLIER_HPP_
// auto strip #include <com/sun/star/sdbcx/XTablesSupplier.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_SDB_XQUERIESSUPPLIER_HPP_
// auto strip #include <com/sun/star/sdb/XQueriesSupplier.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_SDBC_XPREPAREDSTATEMENT_HPP_
// auto strip #include <com/sun/star/sdbc/XPreparedStatement.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_AWT_XCONTROLCONTAINER_HPP_
// auto strip #include <com/sun/star/awt/XControlContainer.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
// auto strip #include <com/sun/star/util/XLocalizedAliases.hpp>
// auto strip #endif

// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif

// auto strip #ifndef _COMPHELPER_STLTYPES_HXX_
// auto strip #include <comphelper/stl_types.hxx>
// auto strip #endif

#ifndef _SVX_FMHELP_HRC
#include "fmhelp.hrc"
#endif

// auto strip #ifndef _SVX_FMSHELL_HXX
// auto strip #include "fmshell.hxx"
// auto strip #endif

#ifndef SVX_DBTOOLSCLIENT_HXX
#include "dbtoolsclient.hxx"
#endif

// auto strip #ifndef _SVX_FMPAGE_HXX
// auto strip #include "fmpage.hxx"
// auto strip #endif

// auto strip #ifndef _SVX_FMPGEIMP_HXX
// auto strip #include "fmpgeimp.hxx"
// auto strip #endif

// auto strip #ifndef _SVX_FMPROP_HXX
// auto strip #include "fmprop.hxx"
// auto strip #endif

#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif

// auto strip #ifndef _SVX_DIALMGR_HXX
// auto strip #include "dialmgr.hxx"
// auto strip #endif

// auto strip #ifndef _SHL_HXX
// auto strip #include <tools/shl.hxx>
// auto strip #endif

// auto strip #ifndef _SVDPAGV_HXX
// auto strip #include <svdpagv.hxx>
// auto strip #endif

// auto strip #ifndef _SFX_OBJITEM_HXX //autogen
// auto strip #include <bf_sfx2/objitem.hxx>
// auto strip #endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif

// auto strip #ifndef _ISOLANG_HXX
// auto strip #include <tools/isolang.hxx>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_PROPERTY_HXX_
// auto strip #include <comphelper/property.hxx>
// auto strip #endif
// auto strip #ifndef _SFXFRAME_HXX
// auto strip #include <bf_sfx2/frame.hxx>
// auto strip #endif
#ifndef _SVX_DATACCESSDESCRIPTOR_HXX_
#include <dataaccessdescriptor.hxx>
#endif
// auto strip #ifndef _LEGACYBINFILTERMGR_HXX
// auto strip #include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
// auto strip #endif
namespace binfilter {

const long STD_WIN_POS_X = 50;
const long STD_WIN_POS_Y = 50;

const long STD_WIN_SIZE_X = 120;
const long STD_WIN_SIZE_Y = 150;

const long MIN_WIN_SIZE_X = 50;
const long MIN_WIN_SIZE_Y = 50;

const long LISTBOX_BORDER = 2;

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::datatransfer;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::container;
using namespace ::binfilter::svxform;//STRIP008 using namespace ::svxform;
using namespace ::binfilter ::svx;

//==================================================================
// class FmFieldWinListBox
//==================================================================
//STRIP001 DBG_NAME(FmFieldWinListBox)
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 FmFieldWinListBox::FmFieldWinListBox( FmFieldWin* pParent )
//STRIP001 	:SvTreeListBox( pParent, WB_HASBUTTONS|WB_BORDER )
//STRIP001 	,pTabWin( pParent )
//STRIP001 {
//STRIP001 	DBG_CTOR(FmFieldWinListBox,NULL);
//STRIP001 	SetHelpId( HID_FIELD_SEL );
//STRIP001 
//STRIP001 	SetHighlightRange( );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 FmFieldWinListBox::~FmFieldWinListBox()
//STRIP001 {
//STRIP001 	DBG_DTOR(FmFieldWinListBox,NULL);
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 sal_Int8 FmFieldWinListBox::AcceptDrop( const AcceptDropEvent& rEvt )
//STRIP001 {
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 sal_Int8 FmFieldWinListBox::ExecuteDrop( const ExecuteDropEvent& rEvt )
//STRIP001 {
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 BOOL FmFieldWinListBox::DoubleClickHdl()
//STRIP001 {
//STRIP001 	if ( pTabWin->createSelectionControls() )
//STRIP001 		return sal_True;
//STRIP001 
//STRIP001 	return SvTreeListBox::DoubleClickHdl();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void FmFieldWinListBox::StartDrag( sal_Int8 _nAction, const Point& _rPosPixel )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pSelected = FirstSelected();
//STRIP001 	if (!pSelected)
//STRIP001 		// no drag without a field
//STRIP001 		return;
//STRIP001 
//STRIP001 	TransferableHelper* pTransferColumn = new OColumnTransferable(
//STRIP001 		pTabWin->GetDatabaseName(),
//STRIP001 		pTabWin->GetObjectType(),
//STRIP001 		pTabWin->GetObjectName(),
//STRIP001 		GetEntryText( pSelected),
//STRIP001 		CTF_FIELD_DESCRIPTOR | CTF_CONTROL_EXCHANGE
//STRIP001 	);
//STRIP001 	Reference< XTransferable> xEnsureDelete = pTransferColumn;
//STRIP001 	if (pTransferColumn)
//STRIP001 	{
//STRIP001 		EndSelection();
//STRIP001 		pTransferColumn->StartDrag( this, DND_ACTION_COPY );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // class FmFieldWinData
//STRIP001 //========================================================================
//STRIP001 DBG_NAME(FmFieldWinData)
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 FmFieldWinData::FmFieldWinData()
//STRIP001 {
//STRIP001 	DBG_CTOR(FmFieldWinData,NULL);
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 FmFieldWinData::~FmFieldWinData()
//STRIP001 {
//STRIP001 	DBG_DTOR(FmFieldWinData,NULL);
//STRIP001 }
//STRIP001 
//STRIP001 //========================================================================
//STRIP001 // class FmFieldWin
//STRIP001 //========================================================================
//STRIP001 DBG_NAME(FmFieldWin)
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 FmFieldWin::FmFieldWin(SfxBindings *pBindings, SfxChildWindow *pMgr, Window* pParent)
//STRIP001 			:SfxFloatingWindow(pBindings, pMgr, pParent, WinBits(WB_STDMODELESS|WB_SIZEABLE))
//STRIP001 			,SfxControllerItem(SID_FM_FIELDS_CONTROL, *pBindings)
//STRIP001 			,::comphelper::OPropertyChangeListener(m_aMutex)
//STRIP001 			,pData(new FmFieldWinData)
//STRIP001 			,m_nObjectType(0)
//STRIP001 			,m_pChangeListener(NULL)
//STRIP001 {
//STRIP001 	DBG_CTOR(FmFieldWin,NULL);
//STRIP001 	SetHelpId( HID_FIELD_SEL_WIN );
//STRIP001 
//STRIP001 	SetBackground( Wallpaper( Application::GetSettings().GetStyleSettings().GetFaceColor()) );
//STRIP001 	pListBox = new FmFieldWinListBox( this );
//STRIP001 	pListBox->Show();
//STRIP001 	Update(NULL);
//STRIP001 	SetSizePixel(Size(STD_WIN_SIZE_X,STD_WIN_SIZE_Y));
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 FmFieldWin::~FmFieldWin()
//STRIP001 {
//STRIP001 	if (m_pChangeListener)
//STRIP001 	{
//STRIP001 		m_pChangeListener->dispose();
//STRIP001 		m_pChangeListener->release();
//STRIP001 		//	delete m_pChangeListener;
//STRIP001 	}
//STRIP001 	delete pListBox;
//STRIP001 	delete pData;
//STRIP001 	DBG_DTOR(FmFieldWin,NULL);
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 void FmFieldWin::GetFocus()
//STRIP001 {
//STRIP001 	if ( pListBox )
//STRIP001 		pListBox->GrabFocus();
//STRIP001 	else
//STRIP001 		SfxFloatingWindow::GetFocus();
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 sal_Bool FmFieldWin::createSelectionControls( )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pSelected = pListBox->FirstSelected();
//STRIP001 	if ( pSelected )
//STRIP001 	{
//STRIP001 		// build a descriptor for the currently selected field
//STRIP001 		ODataAccessDescriptor aDescr;
//STRIP001 		aDescr[ daDataSource ]	<<= GetDatabaseName();
//STRIP001 		aDescr[ daCommand ]		<<= GetObjectName();
//STRIP001 		aDescr[ daCommandType ]	<<= GetObjectType();
//STRIP001 		aDescr[ daColumnName ]	<<= ::rtl::OUString( pListBox->GetEntryText( pSelected) );
//STRIP001 
//STRIP001 		// transfer this to the SFX world
//STRIP001 		SfxUnoAnyItem aDescriptorItem( SID_FM_DATACCESS_DESCRIPTOR, makeAny( aDescr.createPropertyValueSequence() ) );
//STRIP001 		const SfxPoolItem* pArgs[] =
//STRIP001 		{
//STRIP001 			&aDescriptorItem, NULL
//STRIP001 		};
//STRIP001 
//STRIP001 		// execute the create slot
//STRIP001 		GetBindings().Execute( SID_FM_CREATE_FIELDCONTROL, pArgs );
//STRIP001 	}
//STRIP001 
//STRIP001 	return NULL != pSelected;
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 long FmFieldWin::PreNotify( NotifyEvent& _rNEvt )
//STRIP001 {
//STRIP001 	if ( EVENT_KEYINPUT == _rNEvt.GetType() )
//STRIP001 	{
//STRIP001 		const KeyCode& rKeyCode = _rNEvt.GetKeyEvent()->GetKeyCode();
//STRIP001 		if ( ( 0 == rKeyCode.GetModifier() ) && ( KEY_RETURN == rKeyCode.GetCode() ) )
//STRIP001 		{
//STRIP001 			if ( createSelectionControls() )
//STRIP001 				return 1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return SfxFloatingWindow::PreNotify( _rNEvt );
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 sal_Bool FmFieldWin::Close()
//STRIP001 {
//STRIP001 	return SfxFloatingWindow::Close();
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 void FmFieldWin::_propertyChanged(const ::com::sun::star::beans::PropertyChangeEvent& evt) throw( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  xForm(evt.Source, ::com::sun::star::uno::UNO_QUERY);
//STRIP001 	Update(xForm);
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 void FmFieldWin::StateChanged(sal_uInt16 nSID, SfxItemState eState, const SfxPoolItem* pState)
//STRIP001 {
//STRIP001 	if (!pState  || SID_FM_FIELDS_CONTROL != nSID)
//STRIP001 		return;
//STRIP001 
//STRIP001 	if (eState >= SFX_ITEM_AVAILABLE)
//STRIP001 	{
//STRIP001 		FmFormShell* pShell = PTR_CAST(FmFormShell,((SfxObjectItem*)pState)->GetShell());
//STRIP001 		Update(pShell);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		Update(NULL);
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 sal_Bool FmFieldWin::Update(FmFormShell* pShell)
//STRIP001 {
//STRIP001 	// ::com::sun::star::form::ListBox loeschen
//STRIP001 	pListBox->Clear();
//STRIP001 	::rtl::OUString aTitle(SVX_RES(RID_STR_FIELDSELECTION));
//STRIP001 	SetText(aTitle);
//STRIP001 
//STRIP001 	if (!pShell || !pShell->GetFormView())
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	SdrPageView* pPageView = pShell->GetFormView()->GetPageViewPvNum(0);
//STRIP001 	if( !pPageView )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	FmFormPage* pPage = PTR_CAST( FmFormPage, pPageView->GetPage() );
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  xForm	  = pPage->GetImpl()->getCurForm();
//STRIP001 	if (!xForm.is())
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	return Update(xForm);
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 sal_Bool FmFieldWin::Update(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm > & xForm)
//STRIP001 {
//STRIP001 	// ListBox loeschen
//STRIP001 	pListBox->Clear();
//STRIP001 	UniString aTitle(SVX_RES(RID_STR_FIELDSELECTION));
//STRIP001 	SetText(aTitle);
//STRIP001 
//STRIP001 	if (!xForm.is())
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	Reference< XPreparedStatement >  xStatement;
//STRIP001 	Reference< XPropertySet >  xSet(xForm, UNO_QUERY);
//STRIP001 
//STRIP001 	m_aObjectName	= ::comphelper::getString(xSet->getPropertyValue(FM_PROP_COMMAND));
//STRIP001 	m_aDatabaseName	= ::comphelper::getString(xSet->getPropertyValue(FM_PROP_DATASOURCE));
//STRIP001 	m_nObjectType 	= ::comphelper::getINT32(xSet->getPropertyValue(FM_PROP_COMMANDTYPE));
//STRIP001 
//STRIP001 	// get the connection of the form
//STRIP001 	Reference< XConnection > xConnection = OStaticDataAccessTools().calcConnection(Reference< XRowSet >(xForm, UNO_QUERY), ::legacy_binfilters::getLegacyProcessServiceFactory());
//STRIP001 	Sequence< ::rtl::OUString> aFieldNames;
//STRIP001 	// get the fields of the object
//STRIP001 	if ( xConnection.is() && m_aObjectName.getLength() )
//STRIP001 		aFieldNames = getFieldNamesByCommandDescriptor( xConnection, m_nObjectType, m_aObjectName );
//STRIP001 
//STRIP001 	// put them into the list
//STRIP001 	const ::rtl::OUString* pFieldNames = aFieldNames.getConstArray();
//STRIP001 	sal_Int32 nFieldsCount = aFieldNames.getLength();
//STRIP001 	for ( sal_Int32 i = 0; i < nFieldsCount; ++i, ++pFieldNames)
//STRIP001 		pListBox->InsertEntry( * pFieldNames);
//STRIP001 
//STRIP001 	// Prefix setzen
//STRIP001 	UniString  aPrefix;
//STRIP001 	UniString  aPrefixes( SVX_RES(RID_STR_TABWIN_PREFIX) );
//STRIP001 
//STRIP001 	switch (m_nObjectType)
//STRIP001 	{
//STRIP001 		case CommandType::TABLE:
//STRIP001 			aPrefix = aPrefixes.GetToken(0);
//STRIP001 			break;
//STRIP001 		case CommandType::QUERY:
//STRIP001 			aPrefix = aPrefixes.GetToken(1);
//STRIP001 			break;
//STRIP001 		default:
//STRIP001 			aPrefix = aPrefixes.GetToken(2);
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	// an dem PropertySet nach Aenderungen der ControlSource lauschen
//STRIP001 	if (m_pChangeListener)
//STRIP001 	{
//STRIP001 		m_pChangeListener->dispose();
//STRIP001 		m_pChangeListener->release();
//STRIP001 	}
//STRIP001 	m_pChangeListener = new ::comphelper::OPropertyChangeMultiplexer(this, xSet);
//STRIP001 	m_pChangeListener->acquire();
//STRIP001 	m_pChangeListener->addProperty(FM_PROP_DATASOURCE);
//STRIP001 	m_pChangeListener->addProperty(FM_PROP_COMMAND);
//STRIP001 	m_pChangeListener->addProperty(FM_PROP_COMMANDTYPE);
//STRIP001 
//STRIP001 	// Titel setzen
//STRIP001 	aTitle.AppendAscii(" ");
//STRIP001 	aTitle += aPrefix;
//STRIP001 	aTitle.AppendAscii(" ");
//STRIP001 	aTitle += m_aObjectName.getStr();
//STRIP001 	SetText( aTitle );
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 void FmFieldWin::Resize()
//STRIP001 {
//STRIP001 	SfxFloatingWindow::Resize();
//STRIP001 
//STRIP001 	Point aPos(GetPosPixel());
//STRIP001 	Size aSize( GetOutputSizePixel() );
//STRIP001 
//STRIP001 	//////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 	// Groesse der ::com::sun::star::form::ListBox anpassen
//STRIP001 	Point aLBPos( LISTBOX_BORDER, LISTBOX_BORDER );
//STRIP001 	Size aLBSize( aSize );
//STRIP001 	aLBSize.Width() -= (2*LISTBOX_BORDER);
//STRIP001 	aLBSize.Height() -= (2*LISTBOX_BORDER);
//STRIP001 
//STRIP001 	pListBox->SetPosSizePixel( aLBPos, aLBSize );
//STRIP001 }
//STRIP001 
//STRIP001 //-----------------------------------------------------------------------
//STRIP001 void FmFieldWin::FillInfo( SfxChildWinInfo& rInfo ) const
//STRIP001 {
//STRIP001 	rInfo.bVisible = sal_False;
//STRIP001 }

//-----------------------------------------------------------------------
SFX_IMPL_FLOATINGWINDOW(FmFieldWinMgr, SID_FM_ADD_FIELD)

/*?*/ //-----------------------------------------------------------------------
/*?*/ FmFieldWinMgr::FmFieldWinMgr(Window *pParent, sal_uInt16 nId,
/*?*/ 			   SfxBindings *pBindings, SfxChildWinInfo* pInfo)
/*?*/ 			  :SfxChildWindow(pParent, nId)
/*?*/ {DBG_BF_ASSERT(0, "STRIP");//STRIP001 
//STRIP001 	pWindow = new FmFieldWin(pBindings, this, pParent);
//STRIP001 	SetHideNotDelete(sal_True);
//STRIP001 	eChildAlignment = SFX_ALIGN_NOALIGNMENT;
//STRIP001 	((SfxFloatingWindow*)pWindow)->Initialize( pInfo );
/*?*/ }


}
