#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:24:20 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..
BFPRJ=..$/..$/..

PRJNAME=binfilter
TARGET=sw_access

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

AUTOSEG=true

# --- Settings -----------------------------------------------------
#ENABLE_EXCEPTIONS=TRUE

#.INCLUDE :	$(PRJ)$/inc$/swpre.mk
.INCLUDE :	$(PRJ)$/inc$/bf_sw$/swpre.mk
.INCLUDE :	settings.mk
#.INCLUDE :	$(PRJ)$/inc$/sw.mk
.INCLUDE :	$(PRJ)$/inc$/bf_sw$/sw.mk
INC+= -I$(PRJ)$/inc$/bf_sw

.IF "$(GUI)$(COM)" == "WINMSC"
LIBFLAGS=/NOI /NOE /PAGE:512
.ENDIF



# --- Files --------------------------------------------------------

SLOFILES =	\
		$(SLO)$/sw_acccell.obj \
		$(SLO)$/sw_acccontext.obj \
		$(SLO)$/sw_accdoc.obj \
		$(SLO)$/sw_accembedded.obj \
		$(SLO)$/sw_accfootnote.obj \
		$(SLO)$/sw_accframe.obj \
		$(SLO)$/sw_accframebase.obj \
		$(SLO)$/sw_accfrmobj.obj \
		$(SLO)$/sw_accfrmobjmap.obj \
		$(SLO)$/sw_accfrmobjslist.obj \
		$(SLO)$/sw_accgraphic.obj \
		$(SLO)$/sw_accheaderfooter.obj \
		$(SLO)$/sw_acchyperlink.obj \
		$(SLO)$/sw_acchypertextdata.obj \
		$(SLO)$/sw_accmap.obj \
		$(SLO)$/sw_accnotextframe.obj \
		$(SLO)$/sw_accpage.obj \
		$(SLO)$/sw_accpara.obj \
		$(SLO)$/sw_accportions.obj \
		$(SLO)$/sw_accpreview.obj \
		$(SLO)$/sw_accselectionhelper.obj \
		$(SLO)$/sw_acctable.obj \
		$(SLO)$/sw_acctextframe.obj

EXCEPTIONSFILES=	\
		$(SLO)$/sw_acccell.obj \
		$(SLO)$/sw_acccontext.obj \
		$(SLO)$/sw_accdoc.obj \
		$(SLO)$/sw_accembedded.obj \
		$(SLO)$/sw_accfootnote.obj \
		$(SLO)$/sw_accframe.obj \
		$(SLO)$/sw_accframebase.obj \
		$(SLO)$/sw_accfrmobj.obj \
		$(SLO)$/sw_accfrmobjmap.obj \
		$(SLO)$/sw_accfrmobjslist.obj \
		$(SLO)$/sw_accgraphic.obj \
		$(SLO)$/sw_accheaderfooter.obj \
		$(SLO)$/sw_acchyperlink.obj \
		$(SLO)$/sw_acchypertextdata.obj \
		$(SLO)$/sw_accmap.obj \
		$(SLO)$/sw_accnotextframe.obj \
		$(SLO)$/sw_accpage.obj \
		$(SLO)$/sw_accpara.obj \
		$(SLO)$/sw_accportions.obj \
		$(SLO)$/sw_accpreview.obj \
		$(SLO)$/sw_accselectionhelper.obj \
		$(SLO)$/sw_acctable.obj \
		$(SLO)$/sw_acctextframe.obj

# --- Targets -------------------------------------------------------


.INCLUDE :	target.mk

