/*************************************************************************
 *
 *  $RCSfile: sw_edglss.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:43:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif

// auto strip #ifndef SVTOOLS_URIHELPER_HXX
// auto strip #include <svtools/urihelper.hxx>
// auto strip #endif
// auto strip #ifndef _CACHESTR_HXX //autogen
// auto strip #include <tools/cachestr.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif

#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif

// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _EDITSH_HXX
// auto strip #include <editsh.hxx>
// auto strip #endif
// auto strip #ifndef _EDIMP_HXX
// auto strip #include <edimp.hxx>
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX //autogen
// auto strip #include <frmfmt.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>		// fuer die UndoIds
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _TBLSEL_HXX
// auto strip #include <tblsel.hxx> 		// fuers kopieren von Tabellen
// auto strip #endif
// auto strip #ifndef _SWTABLE_HXX
// auto strip #include <swtable.hxx> 		// fuers kopieren von Tabellen
// auto strip #endif
#ifndef _SHELLIO_HXX
#include <shellio.hxx> 		// SwTextBlocks
#endif
// auto strip #ifndef _ACORRECT_HXX
// auto strip #include <acorrect.hxx>
// auto strip #endif
#ifndef _SWSWERROR_H
#include <swerror.h> 		// SwTextBlocks
#endif
#ifndef _OSL_ENDIAN_H_
#include <osl/endian.h>
#endif
#include "so3/staticbaseurl.hxx"
namespace binfilter {


/******************************************************************************
 *				jetzt mit einem verkappten Reader/Writer/Dokument
 ******************************************************************************/



//STRIP001 void SwEditShell::InsertGlossary( SwTextBlocks& rGlossary, const String& rStr )
//STRIP001 {
//STRIP001 	StartAllAction();
//STRIP001 	GetDoc()->InsertGlossary( rGlossary, rStr, *GetCrsr(), this );
//STRIP001 	EndAllAction();
//STRIP001 }


/******************************************************************************
 *				aktuelle Selektion zum Textbaustein machen und ins
 *			Textbausteindokument einfuegen, einschliesslich Vorlagen
 ******************************************************************************/


//STRIP001 USHORT SwEditShell::MakeGlossary( SwTextBlocks& rBlks, const String& rName, const String& rShortName,
//STRIP001 									BOOL bSaveRelFile, BOOL bSaveRelNet,
//STRIP001 									const String* pOnlyTxt )
//STRIP001 {
//STRIP001 	SwDoc* pGDoc = rBlks.GetDoc();
//STRIP001 
//STRIP001 	// Bis es eine Option dafuer gibt, base URL loeschen
//STRIP001 	const String aOldURL( so3::StaticBaseUrl::GetBaseURL() );
//STRIP001 
//STRIP001 	if(bSaveRelFile)
//STRIP001 	{
//STRIP001 		so3::StaticBaseUrl::SetBaseURL( StaticBaseUrl::SmartRelToAbs(rBlks.GetFileName()));
//STRIP001 	}
//STRIP001 	else
//STRIP001 		so3::StaticBaseUrl::SetBaseURL( aEmptyStr );
//STRIP001 
//STRIP001 	USHORT nRet;
//STRIP001 
//STRIP001 	if( pOnlyTxt )
//STRIP001 		nRet = rBlks.PutText( rShortName, rName, *pOnlyTxt );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		rBlks.ClearDoc();
//STRIP001 		if( rBlks.BeginPutDoc( rShortName, rName ) )
//STRIP001 		{
//STRIP001 			rBlks.GetDoc()->SetRedlineMode_intern( REDLINE_DELETE_REDLINES );
//STRIP001 			_CopySelToDoc( pGDoc );
//STRIP001 			rBlks.GetDoc()->SetRedlineMode_intern( 0 );
//STRIP001 			nRet = rBlks.PutDoc();
//STRIP001 		}
//STRIP001 		else
//STRIP001 			nRet = (USHORT) -1;
//STRIP001 	}
//STRIP001 
//STRIP001 	so3::StaticBaseUrl::SetBaseURL( aOldURL );
//STRIP001 	return nRet;
//STRIP001 }

//STRIP001 USHORT SwEditShell::SaveGlossaryDoc( SwTextBlocks& rBlock,
//STRIP001 									const String& rName,
//STRIP001 									const String& rShortName,
//STRIP001 									BOOL bSaveRelFile, BOOL bSaveRelNet,
//STRIP001 									BOOL bOnlyTxt )
//STRIP001 {
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwDoc* pGDoc = rBlock.GetDoc();
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 
//STRIP001 	// Bis es eine Option dafuer gibt, base URL loeschen
//STRIP001 	const String aOldURL( so3::StaticBaseUrl::GetBaseURL() );
//STRIP001 
//STRIP001 	if(bSaveRelFile)
//STRIP001 	{
//STRIP001 		so3::StaticBaseUrl::SetBaseURL( StaticBaseUrl::SmartRelToAbs(rBlock.GetFileName()));
//STRIP001 	}
//STRIP001 	else
//STRIP001 		so3::StaticBaseUrl::SetBaseURL( aEmptyStr );
//STRIP001 
//STRIP001 	USHORT nRet = USHRT_MAX;
//STRIP001 
//STRIP001 	if( bOnlyTxt )
//STRIP001 	{
//STRIP001 		KillPams();
//STRIP001 
//STRIP001 		SwPaM* pCrsr = GetCrsr();
//STRIP001 
//STRIP001 		SwNodeIndex aStt( pDoc->GetNodes().GetEndOfExtras(), 1 );
//STRIP001 		SwCntntNode* pCntntNd = pDoc->GetNodes().GoNext( &aStt );
//STRIP001 		const SwNode* pNd = pCntntNd->FindTableNode();
//STRIP001 		if( !pNd )
//STRIP001 			pNd = pCntntNd;
//STRIP001 
//STRIP001 		pCrsr->GetPoint()->nNode = *pNd;
//STRIP001 		if( pNd == pCntntNd )
//STRIP001 			pCrsr->GetPoint()->nContent.Assign( pCntntNd, 0 );
//STRIP001 		pCrsr->SetMark();
//STRIP001 
//STRIP001 		// dann bis zum Ende vom Nodes Array
//STRIP001 		pCrsr->GetPoint()->nNode = pDoc->GetNodes().GetEndOfContent().GetIndex()-1;
//STRIP001 		pCntntNd = pCrsr->GetCntntNode();
//STRIP001 		if( pCntntNd )
//STRIP001 			pCrsr->GetPoint()->nContent.Assign( pCntntNd, pCntntNd->Len() );
//STRIP001 
//STRIP001 		String sBuf;
//STRIP001 		if( GetSelectedText( sBuf, GETSELTXT_PARABRK_TO_ONLYCR ) && sBuf.Len() )
//STRIP001 			nRet = rBlock.PutText( rShortName, rName, sBuf );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		rBlock.ClearDoc();
//STRIP001 		if( rBlock.BeginPutDoc( rShortName, rName ) )
//STRIP001 		{
//STRIP001 			SwNodeIndex aStt( pDoc->GetNodes().GetEndOfExtras(), 1 );
//STRIP001 			SwCntntNode* pCntntNd = pDoc->GetNodes().GoNext( &aStt );
//STRIP001 			const SwNode* pNd = pCntntNd->FindTableNode();
//STRIP001 			if( !pNd ) pNd = pCntntNd;
//STRIP001 			SwPaM aCpyPam( *pNd );
//STRIP001 			aCpyPam.SetMark();
//STRIP001 
//STRIP001 			// dann bis zum Ende vom Nodes Array
//STRIP001 			aCpyPam.GetPoint()->nNode = pDoc->GetNodes().GetEndOfContent().GetIndex()-1;
//STRIP001 			pCntntNd = aCpyPam.GetCntntNode();
//STRIP001 			aCpyPam.GetPoint()->nContent.Assign( pCntntNd, pCntntNd->Len() );
//STRIP001 
//STRIP001 			aStt = pGDoc->GetNodes().GetEndOfExtras();
//STRIP001 			pCntntNd = pGDoc->GetNodes().GoNext( &aStt );
//STRIP001 			SwPosition aInsPos( aStt, SwIndex( pCntntNd ));
//STRIP001 			pDoc->Copy( aCpyPam, aInsPos );
//STRIP001 
//STRIP001 			nRet = rBlock.PutDoc();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	so3::StaticBaseUrl::SetBaseURL( aOldURL );
//STRIP001 	EndAllAction();
//STRIP001 	return nRet;
//STRIP001 }

/******************************************************************************
 *					kopiere alle Selectionen und das Doc
 ******************************************************************************/


//STRIP001 BOOL SwEditShell::_CopySelToDoc( SwDoc* pInsDoc, SwNodeIndex* pSttNd )
//STRIP001 {
//STRIP001 	ASSERT( pInsDoc, "kein Ins.Dokument"  );
//STRIP001 
//STRIP001 	SwNodes& rNds = pInsDoc->GetNodes();
//STRIP001 
//STRIP001 	SwNodeIndex aIdx( rNds.GetEndOfContent(), -1 );
//STRIP001 	SwCntntNode * pNd = aIdx.GetNode().GetCntntNode();
//STRIP001 	SwPosition aPos( aIdx, SwIndex( pNd, pNd->Len() ));
//STRIP001 
//STRIP001 	// soll der Index auf Anfang returnt werden ?
//STRIP001 	if( pSttNd )
//STRIP001 	{
//STRIP001 		*pSttNd = aPos.nNode;
//STRIP001 		(*pSttNd)--;
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 
//STRIP001 	pInsDoc->LockExpFlds();
//STRIP001 
//STRIP001 	if( IsTableMode() )
//STRIP001 	{
//STRIP001 		// kopiere Teile aus einer Tabelle: lege eine Tabelle mit der Breite
//STRIP001 		// von der Originalen an und kopiere die selectierten Boxen.
//STRIP001 		// Die Groessen werden prozentual korrigiert.
//STRIP001 
//STRIP001 		// lasse ueber das Layout die Boxen suchen
//STRIP001 		SwTableNode* pTblNd;
//STRIP001 		SwSelBoxes aBoxes;
//STRIP001 		GetTblSel( *this, aBoxes );
//STRIP001 		if( aBoxes.Count() && 0 != (pTblNd = (SwTableNode*)aBoxes[0]
//STRIP001 			->GetSttNd()->FindTableNode() ))
//STRIP001 		{
//STRIP001 			// teste ob der TabellenName kopiert werden kann
//STRIP001 			BOOL bCpyTblNm = aBoxes.Count() == pTblNd->GetTable().GetTabSortBoxes().Count();
//STRIP001 			if( bCpyTblNm )
//STRIP001 			{
//STRIP001 				const String& rTblName = pTblNd->GetTable().GetFrmFmt()->GetName();
//STRIP001 				const SwFrmFmts& rTblFmts = *pInsDoc->GetTblFrmFmts();
//STRIP001 				for( USHORT n = rTblFmts.Count(); n; )
//STRIP001 					if( rTblFmts[ --n ]->GetName() == rTblName )
//STRIP001 					{
//STRIP001 						bCpyTblNm = FALSE;
//STRIP001 						break;
//STRIP001 					}
//STRIP001 			}
//STRIP001 			bRet = pInsDoc->InsCopyOfTbl( aPos, aBoxes, 0, bCpyTblNm, FALSE );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			bRet = FALSE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		FOREACHPAM_START(this)
//STRIP001 
//STRIP001 			if( !PCURCRSR->HasMark() )
//STRIP001 			{
//STRIP001 				if( 0 != (pNd = PCURCRSR->GetCntntNode()) && !pNd->GetTxtNode() )
//STRIP001 				{
//STRIP001 					PCURCRSR->SetMark();
//STRIP001 					PCURCRSR->Move( fnMoveForward, fnGoCntnt );
//STRIP001 					bRet |= GetDoc()->Copy( *PCURCRSR, aPos );
//STRIP001 					PCURCRSR->Exchange();
//STRIP001 					PCURCRSR->DeleteMark();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 				bRet |= GetDoc()->Copy( *PCURCRSR, aPos );
//STRIP001 
//STRIP001 		FOREACHPAM_END()
//STRIP001 	}
//STRIP001 
//STRIP001 	pInsDoc->UnlockExpFlds();
//STRIP001 	if( !pInsDoc->IsExpFldsLocked() )
//STRIP001 		pInsDoc->UpdateExpFlds();
//STRIP001 
//STRIP001 	// die gemerkte Node-Position wieder auf den richtigen Node
//STRIP001 	if( bRet && pSttNd )
//STRIP001 		(*pSttNd)++;
//STRIP001 
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Text innerhalb der Selektion erfragen
 Returnwert:	liefert FALSE, wenn der selektierte Bereich
				zu gross ist, um in den Stringpuffer kopiert zu werden.
------------------------------------------------------------------------*/

//STRIP001 BOOL SwEditShell::GetSelectedText( String &rBuf, int nHndlParaBrk )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	GetCrsr();	// ggfs. alle Cursor erzeugen lassen
//STRIP001 	if( IsSelOnePara() )
//STRIP001 	{
//STRIP001 		rBuf = GetSelTxt();
//STRIP001 		if( GETSELTXT_PARABRK_TO_BLANK == nHndlParaBrk )
//STRIP001 		{
//STRIP001 			xub_StrLen nPos = 0;
//STRIP001 			while( STRING_NOTFOUND !=
//STRIP001 				( nPos = rBuf.SearchAndReplace( 0x0a, ' ', nPos )) )
//STRIP001 				;
//STRIP001 		}
//STRIP001 		else if( IsSelFullPara() &&
//STRIP001 			GETSELTXT_PARABRK_TO_ONLYCR != nHndlParaBrk )
//STRIP001 		{
//STRIP001 #if defined(MAC)
//STRIP001 				rBuf += '\015';
//STRIP001 #elif defined(UNX)
//STRIP001 				rBuf += '\012';
//STRIP001 #else
//STRIP001 				rBuf += String::CreateFromAscii(
//STRIP001 							RTL_CONSTASCII_STRINGPARAM( "\015\012" ));
//STRIP001 #endif
//STRIP001 		}
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001 	else if( IsSelection() )
//STRIP001 	{
//STRIP001 		SvCacheStream aStream(20480);
//STRIP001 #ifdef OSL_BIGENDIAN
//STRIP001         aStream.SetNumberFormatInt( NUMBERFORMAT_INT_BIGENDIAN );
//STRIP001 #else
//STRIP001         aStream.SetNumberFormatInt( NUMBERFORMAT_INT_LITTLEENDIAN );
//STRIP001 #endif
//STRIP001 		WriterRef xWrt;
//STRIP001 		SwIoSystem::GetWriter( String::CreateFromAscii( FILTER_TEXT ), xWrt );
//STRIP001 		if( xWrt.Is() )
//STRIP001 		{
//STRIP001 				// Selektierte Bereiche in ein ASCII Dokument schreiben
//STRIP001 			SwWriter aWriter( aStream, *this);
//STRIP001 			xWrt->SetShowProgress( FALSE );
//STRIP001 
//STRIP001 			switch( nHndlParaBrk )
//STRIP001 			{
//STRIP001 			case GETSELTXT_PARABRK_TO_BLANK:
//STRIP001 				xWrt->bASCII_ParaAsBlanc = TRUE;
//STRIP001 				xWrt->bASCII_NoLastLineEnd = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case GETSELTXT_PARABRK_TO_ONLYCR:
//STRIP001 				xWrt->bASCII_ParaAsCR = TRUE;
//STRIP001 				xWrt->bASCII_NoLastLineEnd = TRUE;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 			//JP 09.05.00: write as UNICODE ! (and not as ANSI)
//STRIP001 			SwAsciiOptions aAsciiOpt( xWrt->GetAsciiOptions() );
//STRIP001 			aAsciiOpt.SetCharSet( RTL_TEXTENCODING_UCS2 );
//STRIP001 			xWrt->SetAsciiOptions( aAsciiOpt );
//STRIP001 			xWrt->bUCS2_WithStartChar = FALSE;
//STRIP001 
//STRIP001 			long lLen;
//STRIP001 			if( !IsError( aWriter.Write( xWrt ) ) &&
//STRIP001 				STRING_MAXLEN > (( lLen  = aStream.GetSize() )
//STRIP001 										/ sizeof( sal_Unicode )) + 1 )
//STRIP001 			{
//STRIP001 				aStream << (sal_Unicode)'\0';
//STRIP001 
//STRIP001 				const sal_Unicode *p = (sal_Unicode*)aStream.GetBuffer();
//STRIP001 				if( p )
//STRIP001 					rBuf = p;
//STRIP001 				else
//STRIP001 				{
//STRIP001 					sal_Unicode* pStrBuf = rBuf.AllocBuffer( xub_StrLen(
//STRIP001 									( lLen / sizeof( sal_Unicode )) + 1 ) );
//STRIP001 					aStream.Seek( 0 );
//STRIP001 					aStream.ResetError();
//STRIP001 					aStream.Read( pStrBuf, lLen );
//STRIP001 					pStrBuf[ lLen / sizeof( sal_Unicode ) ] = '\0';
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }





}
