/*************************************************************************
 *
 *  $RCSfile: labfmt.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:43:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _LABFMT_HXX
#define _LABFMT_HXX

// auto strip #include "labimp.hxx"
// auto strip #include "labimg.hxx"

// auto strip #ifndef _SV_MSGBOX_HXX
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
namespace binfilter {
class SwLabFmtPage;

// class SwLabPreview -------------------------------------------------------

//STRIP001 class SwLabPreview : public Window
//STRIP001 {
//STRIP001 	long lOutWPix;
//STRIP001 	long lOutHPix;
//STRIP001 	long lOutWPix23;
//STRIP001 	long lOutHPix23;
//STRIP001 
//STRIP001     Color aGrayColor;
//STRIP001 
//STRIP001 	String aHDistStr;
//STRIP001 	String aVDistStr;
//STRIP001 	String aWidthStr;
//STRIP001 	String aHeightStr;
//STRIP001 	String aLeftStr;
//STRIP001 	String aUpperStr;
//STRIP001 	String aColsStr;
//STRIP001 	String aRowsStr;
//STRIP001 
//STRIP001 	long lHDistWidth;
//STRIP001 	long lVDistWidth;
//STRIP001 	long lHeightWidth;
//STRIP001 	long lLeftWidth;
//STRIP001 	long lUpperWidth;
//STRIP001 	long lColsWidth;
//STRIP001 
//STRIP001 	long lXWidth;
//STRIP001 	long lXHeight;
//STRIP001 
//STRIP001 	SwLabItem aItem;
//STRIP001 
//STRIP001 	void Paint(const Rectangle&);
//STRIP001 
//STRIP001 	void DrawArrow(const Point& rP1, const Point& rP2, BOOL bArrow);
//STRIP001 	SwLabFmtPage* GetParent() {return (SwLabFmtPage*) Window::GetParent();}
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	 SwLabPreview(const SwLabFmtPage* pParent, const ResId& rResID);
//STRIP001 	~SwLabPreview();
//STRIP001 
//STRIP001 	void Update(const SwLabItem& rItem);
//STRIP001 };

// class SwLabFmtPage -------------------------------------------------------

//STRIP001 class SwLabFmtPage : public SfxTabPage
//STRIP001 {
//STRIP001 	FixedInfo		aMakeFI;
//STRIP001 	FixedInfo		aTypeFI;
//STRIP001 	SwLabPreview aPreview;
//STRIP001 	FixedText	 aHDistText;
//STRIP001 	MetricField	 aHDistField;
//STRIP001 	FixedText	 aVDistText;
//STRIP001 	MetricField	 aVDistField;
//STRIP001 	FixedText	 aWidthText;
//STRIP001 	MetricField	 aWidthField;
//STRIP001 	FixedText	 aHeightText;
//STRIP001 	MetricField	 aHeightField;
//STRIP001 	FixedText	 aLeftText;
//STRIP001 	MetricField	 aLeftField;
//STRIP001 	FixedText	 aUpperText;
//STRIP001 	MetricField	 aUpperField;
//STRIP001 	FixedText	 aColsText;
//STRIP001 	NumericField aColsField;
//STRIP001 	FixedText	 aRowsText;
//STRIP001 	NumericField aRowsField;
//STRIP001 	PushButton 	 aSavePB;
//STRIP001 
//STRIP001 	Timer aPreviewTimer;
//STRIP001 	BOOL  bModified;
//STRIP001 
//STRIP001 	SwLabItem	 aItem;
//STRIP001 
//STRIP001 	 SwLabFmtPage(Window* pParent, const SfxItemSet& rSet);
//STRIP001 	~SwLabFmtPage();
//STRIP001 
//STRIP001 	DECL_LINK( ModifyHdl, Edit * );
//STRIP001 	DECL_LINK( PreviewHdl, Timer * );
//STRIP001 	DECL_LINK( LoseFocusHdl, Control * );
//STRIP001 	DECL_LINK( SaveHdl, PushButton* );
//STRIP001 
//STRIP001 	void ChangeMinMax();
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	static SfxTabPage* Create(Window* pParent, const SfxItemSet& rSet);
//STRIP001 
//STRIP001 	virtual void ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int  DeactivatePage(SfxItemSet* pSet = 0);
//STRIP001 			void FillItem(SwLabItem& rItem);
//STRIP001 	virtual BOOL FillItemSet(SfxItemSet& rSet);
//STRIP001 	virtual void Reset(const SfxItemSet& rSet);
//STRIP001 
//STRIP001 	SwLabDlg* GetParent() {return (SwLabDlg*) SfxTabPage::GetParent()->GetParent();}
//STRIP001 };
/* -----------------------------23.01.01 10:26--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 class SwSaveLabelDlg : public ModalDialog
//STRIP001 {
//STRIP001     FixedLine       aOptionsFL;
//STRIP001 	FixedText		aMakeFT;
//STRIP001 	ComboBox		aMakeCB;
//STRIP001 	FixedText		aTypeFT;
//STRIP001 	Edit			aTypeED;
//STRIP001 
//STRIP001 	OKButton		aOKPB;
//STRIP001 	CancelButton	aCancelPB;
//STRIP001 	HelpButton		aHelpPB;
//STRIP001 
//STRIP001 	QueryBox		aQueryMB;
//STRIP001 
//STRIP001 	sal_Bool 		bSuccess;
//STRIP001 	SwLabFmtPage* 	pLabPage;
//STRIP001 	SwLabRec&		rLabRec;
//STRIP001 
//STRIP001 	DECL_LINK(OkHdl, OKButton*);
//STRIP001 	DECL_LINK(ModifyHdl, Edit*);
//STRIP001 
//STRIP001 public:
//STRIP001 	SwSaveLabelDlg(SwLabFmtPage* pParent, SwLabRec& rRec);
//STRIP001 
//STRIP001 	void	SetLabel(const ::rtl::OUString& rMake, const ::rtl::OUString& rType)
//STRIP001 		{
//STRIP001 			aMakeCB.SetText(String(rMake));
//STRIP001 			aTypeED.SetText(String(rType));
//STRIP001 		}
//STRIP001 	sal_Bool GetLabel(SwLabItem& rItem);
//STRIP001 };
} //namespace binfilter
#endif

