/*************************************************************************
 *
 *  $RCSfile: sw_xfldui.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:51:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XDATASOURCE_HPP_
#include <com/sun/star/sdbc/XDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XTABLESSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XTablesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XCOLUMNSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XQUERIESSUPPLIER_HPP_
#include <com/sun/star/sdb/XQueriesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#ifndef _FLDMGR_HXX
#include <fldmgr.hxx>
#endif
#ifndef _DBMGR_HXX
#include <dbmgr.hxx>
#endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>		// Actives Fenster
#endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
#ifndef _SWMODULE_HXX
#include <swmodule.hxx>
#endif
namespace binfilter {


using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::beans;


// ---------------------------------------------------------------------------
// This file contains all routines of the fldui directory, which must compile
// with exceptions. So we can reduce the code of the other files, which don't
// need any exception handling.
// ---------------------------------------------------------------------------

/*--------------------------------------------------------------------
	 Beschreibung: Ist das Datenbankfeld numerisch?
	 Anm: Im Fehlerfall wird TRUE returnt.
 --------------------------------------------------------------------*/

//STRIP001 BOOL SwFldMgr::IsDBNumeric( const String& rDBName, const String& rTblQryName,
//STRIP001 							BOOL bIsTable, const String& rFldName)
//STRIP001 {
//STRIP001 	BOOL bNumeric = TRUE;
//STRIP001 
//STRIP001     SwNewDBMgr* pDBMgr = pWrtShell ? pWrtShell->GetNewDBMgr() :
//STRIP001                             ::GetActiveView()->GetWrtShell().GetNewDBMgr();
//STRIP001 
//STRIP001     ::rtl::OUString sSource(rDBName);
//STRIP001     Reference< XConnection> xConnection =
//STRIP001                     pDBMgr->RegisterConnection(sSource);
//STRIP001 
//STRIP001     if( !xConnection.is() )
//STRIP001 		return bNumeric;
//STRIP001 
//STRIP001 	Reference<XColumnsSupplier> xColsSupplier;
//STRIP001 	if(bIsTable)
//STRIP001 	{
//STRIP001 		Reference<XTablesSupplier> xTSupplier = Reference<XTablesSupplier>(xConnection, UNO_QUERY);
//STRIP001 		if(xTSupplier.is())
//STRIP001 		{
//STRIP001 			Reference<XNameAccess> xTbls = xTSupplier->getTables();
//STRIP001 			DBG_ASSERT(xTbls->hasByName(rTblQryName), "table not available anymore?")
//STRIP001 			try
//STRIP001 			{
//STRIP001 				Any aTable = xTbls->getByName(rTblQryName);
//STRIP001                 Reference<XPropertySet> xPropSet;
//STRIP001                 aTable >>= xPropSet;
//STRIP001 				xColsSupplier = Reference<XColumnsSupplier>(xPropSet, UNO_QUERY);
//STRIP001 			}
//STRIP001             catch(Exception&){}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		Reference<XQueriesSupplier> xQSupplier = Reference<XQueriesSupplier>(xConnection, UNO_QUERY);
//STRIP001 		if(xQSupplier.is())
//STRIP001 		{
//STRIP001 			Reference<XNameAccess> xQueries = xQSupplier->getQueries();
//STRIP001 			DBG_ASSERT(xQueries->hasByName(rTblQryName), "table not available anymore?")
//STRIP001 			try
//STRIP001 			{
//STRIP001 				Any aQuery = xQueries->getByName(rTblQryName);
//STRIP001                 Reference<XPropertySet> xPropSet;
//STRIP001                 aQuery >>= xPropSet;
//STRIP001 				xColsSupplier = Reference<XColumnsSupplier>(xPropSet, UNO_QUERY);
//STRIP001 			}
//STRIP001             catch(Exception&){}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if(xColsSupplier.is())
//STRIP001 	{
//STRIP001 		Reference <XNameAccess> xCols;
//STRIP001         try
//STRIP001         {
//STRIP001             xCols = xColsSupplier->getColumns();
//STRIP001         }
//STRIP001         catch(Exception& )
//STRIP001         {
//STRIP001             DBG_ERROR("Exception in getColumns()")
//STRIP001         }
//STRIP001 		if(xCols.is() && xCols->hasByName(rFldName))
//STRIP001 		{
//STRIP001 			Any aCol = xCols->getByName(rFldName);
//STRIP001             Reference <XPropertySet> xCol;
//STRIP001             aCol >>= xCol;
//STRIP001 			Any aType = xCol->getPropertyValue( UniString::CreateFromAscii("Type"));
//STRIP001 			sal_Int32 eDataType;
//STRIP001 			aType >>= eDataType;
//STRIP001 			switch(eDataType)
//STRIP001 			{
//STRIP001 				case DataType::BIT:
//STRIP001 				case DataType::TINYINT:
//STRIP001 				case DataType::SMALLINT:
//STRIP001 				case DataType::INTEGER:
//STRIP001 				case DataType::BIGINT:
//STRIP001 				case DataType::FLOAT:
//STRIP001 				case DataType::REAL:
//STRIP001 				case DataType::DOUBLE:
//STRIP001 				case DataType::NUMERIC:
//STRIP001 				case DataType::DECIMAL:
//STRIP001 				case DataType::DATE:
//STRIP001 				case DataType::TIME:
//STRIP001 				case DataType::TIMESTAMP:
//STRIP001 					break;
//STRIP001 
//STRIP001 				case DataType::BINARY:
//STRIP001 				case DataType::VARBINARY:
//STRIP001 				case DataType::LONGVARBINARY:
//STRIP001 				case DataType::SQLNULL:
//STRIP001 				case DataType::OTHER:
//STRIP001 				case DataType::OBJECT:
//STRIP001 				case DataType::DISTINCT:
//STRIP001 				case DataType::STRUCT:
//STRIP001 				case DataType::ARRAY:
//STRIP001 				case DataType::BLOB:
//STRIP001 				case DataType::CLOB:
//STRIP001 				case DataType::REF:
//STRIP001 				case DataType::CHAR:
//STRIP001 				case DataType::VARCHAR:
//STRIP001 				case DataType::LONGVARCHAR:
//STRIP001 				default:
//STRIP001 					bNumeric = FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bNumeric;
//STRIP001 }


}
