/*************************************************************************
 *
 *  $RCSfile: cnttab.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CNTTAB_HXX
#define _CNTTAB_HXX

#ifndef _SVX_STDDLG_HXX //autogen
#include <bf_svx/stddlg.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#include "tox.hxx"
#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _TOXMGR_HXX
#include <toxmgr.hxx>
#endif
#ifndef _SVX_CHECKLBX_HXX //autogen wg. SvxCheckListBox
#include <bf_svx/checklbx.hxx>
#endif
#ifndef _TOOLS_RESARY_HXX
#include <tools/resary.hxx>
#endif
#ifndef _SVTREEBOX_HXX
#include <svtools/svtreebx.hxx>
#endif
#ifndef _SV_MENUBTN_HXX
#include <vcl/menubtn.hxx>
#endif
#ifndef _SVX_LANGBOX_HXX
#include <bf_svx/langbox.hxx>
#endif
namespace com{namespace sun{namespace star{
    namespace text{
        class XTextSection;
        class XDocumentIndex;
    }
}}}
namespace binfilter {

class SwWrtShell;
class SwTOXMgr;
//STRIP008 namespace com{namespace sun{namespace star{
//STRIP008     namespace text{
//STRIP008         class XTextSection;
//STRIP008         class XDocumentIndex;
//STRIP008     }
//STRIP008 }}}

#define TOX_PAGE_SELECT 1
#define TOX_PAGE_ENTRY  2
#define TOX_PAGE_STYLES 3


/* -----------------14.06.99 12:12-------------------

 --------------------------------------------------*/
struct CurTOXType
{
	TOXTypes 	eType;
	USHORT 		nIndex; //for TOX_USER only

	BOOL operator==(const CurTOXType aCmp)
   	{
		return eType == aCmp.eType && nIndex == aCmp.nIndex;
   	}
	USHORT GetFlatIndex() const;

};
//-----------------------------------------------------------------------------
struct SwIndexSections_Impl
{
    ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextSection >    xContainerSection;
    ::com::sun::star::uno::Reference< ::com::sun::star::text::XDocumentIndex >    xDocumentIndex;
};

//-----------------------------------------------------------------------------
class SwOneExampleFrame;
struct SwIndexSections_Impl;

//STRIP001 class SwMultiTOXTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 	Window					aExampleContainerWIN;
//STRIP001     Window                  aExampleWIN;
//STRIP001 	CheckBox				aShowExampleCB;
//STRIP001 	SwTOXMgr*				pMgr;
//STRIP001 	SwWrtShell& 			rSh;
//STRIP001 
//STRIP001 	SwOneExampleFrame*		pExampleFrame;
//STRIP001 
//STRIP001 	SwTOXDescription** 		pDescArr; //
//STRIP001 	SwForm**				pFormArr; //
//STRIP001 	SwIndexSections_Impl**	pxIndexSectionsArr;
//STRIP001 
//STRIP001 	SwTOXBase* 				pParamTOXBase;
//STRIP001 
//STRIP001 	CurTOXType				eCurrentTOXType;
//STRIP001 
//STRIP001 	String					sUserDefinedIndex;
//STRIP001 	USHORT 					nTypeCount;
//STRIP001 	USHORT					nInitialTOXType;
//STRIP001 
//STRIP001 	BOOL					bEditTOX;
//STRIP001 	BOOL					bExampleCreated;
//STRIP001 	BOOL					bGlobalFlag;
//STRIP001 
//STRIP001 	virtual short		Ok();
//STRIP001 	SwTOXDescription* 	CreateTOXDescFromTOXBase(const SwTOXBase*pCurTOX);

//STRIP001 	DECL_LINK(CreateExample_Hdl, void* );
//STRIP001 	DECL_LINK(ShowPreviewHdl, CheckBox*);

//STRIP001 public:
//STRIP001 	SwMultiTOXTabDialog(Window* pParent, const SfxItemSet& rSet,
//STRIP001 						SwWrtShell &rShell,
//STRIP001 						SwTOXBase* pCurTOX, USHORT nToxType = USHRT_MAX,
//STRIP001 						BOOL bGlobal = FALSE);
//STRIP001 	~SwMultiTOXTabDialog();

//STRIP001 	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );

//STRIP001 	SwForm*				GetForm(CurTOXType eType);

//STRIP001 	CurTOXType			GetCurrentTOXType() const { return eCurrentTOXType;}
//STRIP001 	void				SetCurrentTOXType(CurTOXType	eSet)
//STRIP001 								{
//STRIP001 									eCurrentTOXType = eSet;
//STRIP001 								}
//STRIP001 
//STRIP001 	void				UpdateExample();
//STRIP001 	BOOL				IsTOXEditMode() const { return bEditTOX;}
//STRIP001 
//STRIP001 	SwWrtShell& 		GetWrtShell() {return rSh;}
//STRIP001 
//STRIP001 	SwTOXDescription&	GetTOXDescription(CurTOXType eTOXTypes);
//STRIP001 	void				CreateOrUpdateExample(
//STRIP001 							USHORT nTOXIndex, USHORT nPage = 0, USHORT nCurLevel = USHRT_MAX);

//STRIP001 	static BOOL	IsNoNum(SwWrtShell& rSh, const String& rName);
//STRIP001 };

/* -----------------14.06.99 12:17-------------------

 --------------------------------------------------*/
class SwOLENames : public Resource
{
	ResStringArray		aNamesAry;
public:
	SwOLENames(const ResId& rResId) :
		Resource(rResId),
		aNamesAry(ResId(1)){FreeResource();}

	ResStringArray& 	GetNames() { return aNamesAry;}

};
/* -----------------14.07.99 12:17-------------------

 --------------------------------------------------*/
class IndexEntryRessource;
class IndexEntrySupplierWrapper;

//STRIP001 class SwTOXSelectTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aTypeTitleFL;
//STRIP001 	FixedText		aTitleFT;
//STRIP001 	Edit			aTitleED;
//STRIP001 	FixedText		aTypeFT;
//STRIP001 	ListBox			aTypeLB;
//STRIP001 	CheckBox		aReadOnlyCB;
//STRIP001 
//STRIP001     FixedLine       aAreaFL;
//STRIP001     FixedText       aAreaFT;
//STRIP001     ListBox         aAreaLB;
//STRIP001 	FixedText		aLevelFT;	//content, user
//STRIP001 	NumericField	aLevelNF;   //content, user
//STRIP001 
//STRIP001 	//content
//STRIP001     FixedLine       aCreateFromFL;  // content, user, illustration
//STRIP001 	CheckBox		aFromHeadingsCB;
//STRIP001 	PushButton		aChapterDlgPB;
//STRIP001 	CheckBox		aAddStylesCB;
//STRIP001 	PushButton		aAddStylesPB;
//STRIP001 	//user
//STRIP001 	CheckBox		aFromTablesCB;
//STRIP001 	CheckBox		aFromFramesCB;
//STRIP001 	CheckBox		aFromGraphicsCB;
//STRIP001 	CheckBox		aFromOLECB;
//STRIP001 	CheckBox		aLevelFromChapterCB;
//STRIP001 
//STRIP001 	//illustration + table
//STRIP001 	RadioButton		aFromCaptionsRB;
//STRIP001 	RadioButton     aFromObjectNamesRB;
//STRIP001 
//STRIP001 	//illustration and tables
//STRIP001 	FixedText		aCaptionSequenceFT;
//STRIP001 	ListBox			aCaptionSequenceLB;
//STRIP001 	FixedText		aDisplayTypeFT;
//STRIP001 	ListBox			aDisplayTypeLB;
//STRIP001 
//STRIP001 	//all but illustration and table
//STRIP001 	CheckBox		aTOXMarksCB;
//STRIP001 
//STRIP001 	//
//STRIP001 
//STRIP001 	//index only
//STRIP001 	CheckBox		aCollectSameCB;
//STRIP001 	CheckBox		aUseFFCB;
//STRIP001 	CheckBox		aUseDashCB;
//STRIP001 	CheckBox		aCaseSensitiveCB;
//STRIP001 	CheckBox		aInitialCapsCB;
//STRIP001 	CheckBox		aKeyAsEntryCB;
//STRIP001 	CheckBox		aFromFileCB;
//STRIP001 	MenuButton		aAutoMarkPB;
//STRIP001     FixedLine       aIdxOptionsFL; // index only
//STRIP001 
//STRIP001 	// object only
//STRIP001 	SwOLENames		aFromNames;
//STRIP001 	SvxCheckListBox	aFromObjCLB;
//STRIP001     FixedLine       aFromObjFL;
//STRIP001 
//STRIP001 	CheckBox		aSequenceCB;
//STRIP001 	FixedText		aBracketFT;
//STRIP001 	ListBox			aBracketLB;
//STRIP001     FixedLine       aAuthorityFormatFL;
//STRIP001 
//STRIP001     //all
//STRIP001     FixedLine       aSortOptionsFL;
//STRIP001     FixedText       aLanguageFT;
//STRIP001     SvxLanguageBox  aLanguageLB;
//STRIP001     FixedText       aSortAlgorithmFT;
//STRIP001     ListBox         aSortAlgorithmLB;
//STRIP001 
//STRIP001     IndexEntryRessource* pIndexRes;
//STRIP001 
//STRIP001     Point           aCBLeftPos1;
//STRIP001 	Point 			aCBLeftPos2;
//STRIP001 	Point 			aCBLeftPos3;
//STRIP001 
//STRIP001 	String			aStyleArr[MAXLEVEL];
//STRIP001 	String 			sAutoMarkURL;
//STRIP001 	String 			sAutoMarkType;
//STRIP001 	String 			sAddStyleUser;
//STRIP001 	String 			sAddStyleContent;
//STRIP001 
//STRIP001     const IndexEntrySupplierWrapper* pIndexEntryWrapper;
//STRIP001 
//STRIP001 	BOOL 			bFirstCall;
//STRIP001 
//STRIP001 	DECL_LINK(TOXTypeHdl, 	ListBox* );
//STRIP001 	DECL_LINK(TOXAreaHdl, 	ListBox* );
//STRIP001 	DECL_LINK(ChapterHdl, 	PushButton* );
//STRIP001 	DECL_LINK(AddStylesHdl, PushButton* );
//STRIP001 	DECL_LINK(MenuEnableHdl, Menu*);
//STRIP001 	DECL_LINK(MenuExecuteHdl, Menu*);
//STRIP001     DECL_LINK(LanguageHdl, ListBox*);
//STRIP001 
//STRIP001 	DECL_LINK(CheckBoxHdl, 	CheckBox*	);
//STRIP001 	DECL_LINK(RadioButtonHdl, RadioButton* );
//STRIP001 	DECL_LINK(ModifyHdl, void*);
//STRIP001 
//STRIP001   	void	ApplyTOXDescription();
//STRIP001 	void 	FillTOXDescription();
//STRIP001 public:
//STRIP001 	SwTOXSelectTabPage(Window* pParent, const SfxItemSet& rAttrSet);
//STRIP001 	~SwTOXSelectTabPage();
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void		Reset( const SfxItemSet& );
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	void				SelectType(TOXTypes eSet); 	//preset TOXType, GlobalDoc
//STRIP001 	void				SetWrtShell(SwWrtShell& rSh);
//STRIP001 };
/* -----------------16.06.99 08:33-------------------

 --------------------------------------------------*/

DECLARE_LIST(TOXControlList, Control*)//STRIP008 DECLARE_LIST(TOXControlList, Control*);
class SwTOXEdit;
class SwTOXButton;
class SwTOXEntryTabPage;
//STRIP001 class SwTokenWindow : public Window
//STRIP001 {
//STRIP001 	ImageButton 	aLeftScrollWin;
//STRIP001 	Window			aCtrlParentWin;
//STRIP001 	ImageButton 	aRightScrollWin;
//STRIP001 	TOXControlList 	aControlList;
//STRIP001 	SwForm* 		pForm;
//STRIP001 	USHORT 			nLevel;
//STRIP001 	BOOL			bValid;
//STRIP001 	String 			aButtonTexts[TOKEN_END]; // Text of the buttons
//STRIP001 	String 			aButtonHelpTexts[TOKEN_END]; // QuickHelpText of the buttons
//STRIP001 	String 			sCharStyle;
//STRIP001 	Link			aButtonSelectedHdl;
//STRIP001 	Control*		pActiveCtrl;
//STRIP001 	Link			aModifyHdl;
//STRIP001 
//STRIP001 	SwTOXEntryTabPage*	m_pParent;
//STRIP001 
//STRIP001 	DECL_LINK(EditResize, Edit*);
//STRIP001 	DECL_LINK(NextItemHdl, SwTOXEdit* );
//STRIP001 	DECL_LINK(TbxFocusHdl, SwTOXEdit* );
//STRIP001 	DECL_LINK(NextItemBtnHdl, SwTOXButton* );
//STRIP001 	DECL_LINK(TbxFocusBtnHdl, SwTOXButton* );
//STRIP001 	DECL_LINK(ScrollHdl, ImageButton* );
//STRIP001 
//STRIP001 	void	SetActiveControl(Control* pSet);
//STRIP001 
//STRIP001 	Control*	InsertItem(const String& rText, const SwFormToken& aToken);
//STRIP001 	void		AdjustPositions();
//STRIP001 	void 		AdjustScrolling();
//STRIP001 	void 		MoveControls(long nOffset);
//STRIP001 
//STRIP001 public:
//STRIP001 	SwTokenWindow(SwTOXEntryTabPage* pParent, const ResId& rResId);
//STRIP001 	~SwTokenWindow();
//STRIP001 
//STRIP001 	void		SetForm(SwForm& rForm, USHORT nLevel);
//STRIP001 	USHORT 		GetLastLevel()const {return nLevel;};
//STRIP001 
//STRIP001 	BOOL		IsValid() const {return bValid;}
//STRIP001 	void		Invalidate() {bValid = FALSE;}
//STRIP001 
//STRIP001 	String		GetPattern() const;
//STRIP001 
//STRIP001 	void		SetButtonSelectedHdl(const Link& rLink)
//STRIP001 				{ aButtonSelectedHdl = rLink;}
//STRIP001 
//STRIP001 	void		SetModifyHdl(const Link& rLink){aModifyHdl = rLink;}
//STRIP001 
//STRIP001 	Control*	GetActiveControl()
//STRIP001 					{ return pActiveCtrl;}
//STRIP001 
//STRIP001 	void		InsertAtSelection(const String& rText, const SwFormToken& aToken);
//STRIP001 	void		RemoveControl(SwTOXButton* pDel, BOOL bInternalCall = FALSE);
//STRIP001 
//STRIP001 	BOOL 		Contains(FormTokenType) const;
//STRIP001 
//STRIP001 	BOOL		DetermineLinkStart();
//STRIP001 
//STRIP001 	//helper for pattern buttons and edits
//STRIP001 	BOOL 		CreateQuickHelp(Control* pCtrl,
//STRIP001 					const SwFormToken& rToken, const HelpEvent& );
//STRIP001 
//STRIP001 	virtual void		Resize();
//STRIP001     virtual void        GetFocus();
//STRIP001 };
/* -----------------------------23.12.99 14:16--------------------------------

 ---------------------------------------------------------------------------*/
class SwTOXEntryTabPage;
//STRIP001 class SwIdxTreeListBox : public SvTreeListBox
//STRIP001 {
//STRIP001 	SwTOXEntryTabPage* pParent;
//STRIP001 
//STRIP001 	virtual void    RequestHelp( const HelpEvent& rHEvt );
//STRIP001 public:
//STRIP001 	SwIdxTreeListBox(SwTOXEntryTabPage* pPar, const ResId& rResId);
//STRIP001 };

/* -----------------16.06.99 12:49-------------------

 --------------------------------------------------*/
//STRIP001 class SwTOXEntryTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedText           aLevelFT;
//STRIP001     SwIdxTreeListBox    aLevelLB;
//STRIP001 
//STRIP001     FixedText       aTokenFT;
//STRIP001     SwTokenWindow   aTokenWIN;
//STRIP001 	PushButton		aAllLevelsPB;
//STRIP001 
//STRIP001 	PushButton		aEntryNoPB;
//STRIP001 	PushButton		aEntryPB;
//STRIP001 	PushButton 		aTabPB;
//STRIP001 	PushButton		aChapterInfoPB;
//STRIP001 	PushButton		aPageNoPB;
//STRIP001 	PushButton		aHyperLinkPB;
//STRIP001 
//STRIP001 	ListBox			aAuthFieldsLB;
//STRIP001 	PushButton 		aAuthInsertPB;
//STRIP001 	PushButton 		aAuthRemovePB;
//STRIP001 
//STRIP001 	FixedText		aCharStyleFT;
//STRIP001 	ListBox			aCharStyleLB;		// character style of the current token
//STRIP001 	PushButton		aEditStylePB;
//STRIP001 
//STRIP001 	FixedText		aChapterEntryFT;
//STRIP001 	ListBox			aChapterEntryLB;	// type of chapter info
//STRIP001 
//STRIP001 	FixedText		aFillCharFT;
//STRIP001 	ComboBox		aFillCharCB;		// fill char for tab stop
//STRIP001 	FixedText		aTabPosFT;
//STRIP001 	MetricField		aTabPosMF;			// tab stop position
//STRIP001 	CheckBox		aAutoRightCB;
//STRIP001     FixedLine       aEntryFL;
//STRIP001 
//STRIP001 	CheckBox		aRelToStyleCB;		// position relative to the right margin of the para style
//STRIP001 	FixedText		aMainEntryStyleFT;
//STRIP001 	ListBox 		aMainEntryStyleLB;	// character style of main entries in indexes
//STRIP001 	CheckBox		aAlphaDelimCB;
//STRIP001 	CheckBox		aCommaSeparatedCB;
//STRIP001     FixedLine       aFormatFL;
//STRIP001 
//STRIP001 	RadioButton		aSortDocPosRB;
//STRIP001 	RadioButton		aSortContentRB;
//STRIP001     FixedLine       aSortingFL;
//STRIP001 
//STRIP001 	FixedText			aFirstKeyFT;
//STRIP001 	ListBox				aFirstKeyLB;
//STRIP001 	ImageRadioButton    aFirstSortUpRB;
//STRIP001 	ImageRadioButton    aFirstSortDownRB;
//STRIP001 
//STRIP001 	FixedText			aSecondKeyFT;
//STRIP001 	ListBox				aSecondKeyLB;
//STRIP001 	ImageRadioButton    aSecondSortUpRB;
//STRIP001 	ImageRadioButton    aSecondSortDownRB;
//STRIP001 
//STRIP001 	FixedText 			aThirdKeyFT;
//STRIP001 	ListBox 			aThirdKeyLB;
//STRIP001 	ImageRadioButton    aThirdSortUpRB;
//STRIP001 	ImageRadioButton    aThirdSortDownRB;
//STRIP001 
//STRIP001     FixedLine       aSortKeyFL;
//STRIP001 
//STRIP001 	String 			sDelimStr;
//STRIP001 	String 			sLevelStr;
//STRIP001 	String			sAuthTypeStr;
//STRIP001 
//STRIP001 	String 			sNoCharStyle;
//STRIP001 	String 			sNoCharSortKey;
//STRIP001 	Point 			aButtonPositions[5];
//STRIP001 	SwForm*			pCurrentForm;
//STRIP001 
//STRIP001 	Point 			aRelToStylePos;
//STRIP001 	Point 			aRelToStyleIdxPos;
//STRIP001     Size            aLevelFLSize;
//STRIP001 
//STRIP001 	CurTOXType  	aLastTOXType;
//STRIP001 	BOOL 			bInLevelHdl;
//STRIP001 
//STRIP001 	DECL_LINK(StyleSelectHdl, ListBox*);
//STRIP001 	DECL_LINK(EditStyleHdl, PushButton*);
//STRIP001 	DECL_LINK(InsertTokenHdl, PushButton*);
//STRIP001 	DECL_LINK(LevelHdl, SvTreeListBox*);
//STRIP001 	DECL_LINK(AutoRightHdl, CheckBox*);
//STRIP001 	DECL_LINK(TokenSelectedHdl, SwFormToken*);
//STRIP001 	DECL_LINK(TabPosHdl, MetricField*);
//STRIP001 	DECL_LINK(FillCharHdl, ComboBox*);
//STRIP001 	DECL_LINK(RemoveInsertAuthHdl, PushButton*);
//STRIP001 	DECL_LINK(SortKeyHdl, RadioButton*);
//STRIP001 	DECL_LINK(ChapterInfoHdl, ListBox*);
//STRIP001 	DECL_LINK(AllLevelsHdl, PushButton*);
//STRIP001 
//STRIP001 	void 			EnableButtons();
//STRIP001 	void			WriteBackLevel();
//STRIP001 	void			UpdateDescriptor();
//STRIP001 	DECL_LINK(ModifyHdl, void*);
//STRIP001 
//STRIP001 public:
//STRIP001 	SwTOXEntryTabPage(Window* pParent, const SfxItemSet& rAttrSet);
//STRIP001 	~SwTOXEntryTabPage();
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void		Reset( const SfxItemSet& );
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 	void				SetWrtShell(SwWrtShell& rSh);
//STRIP001 
//STRIP001 	String 				GetLevelHelp(USHORT nLevel) const;
//STRIP001 
//STRIP001 	void 				PreTokenButtonRemoved(const SwFormToken& rToken);
//STRIP001 };
/* -----------------05.07.99 13:00-------------------

 --------------------------------------------------*/
//STRIP001 class SwTOXStylesTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 	FixedText		aLevelFT2;
//STRIP001 	ListBox 		aLevelLB;
//STRIP001 	FixedText		aTemplateFT;
//STRIP001 	ListBox 		aParaLayLB;
//STRIP001 	PushButton		aStdBT;
//STRIP001     ImageButton     aAssignBT;
//STRIP001 	PushButton 		aEditStyleBT;
//STRIP001     FixedLine       aFormatFL;
//STRIP001 
//STRIP001 	SwForm*			pCurrentForm;
//STRIP001 //	void			UpdatePattern();
//STRIP001 
//STRIP001 	DECL_LINK( EditStyleHdl, Button *);
//STRIP001 	DECL_LINK( StdHdl, Button * );
//STRIP001 	DECL_LINK( EnableSelectHdl, ListBox * );
//STRIP001 	DECL_LINK( DoubleClickHdl, Button * );
//STRIP001 	DECL_LINK( AssignHdl, Button * );
//STRIP001 	DECL_LINK( ModifyHdl, void*);
//STRIP001 
//STRIP001 	SwForm&		GetForm()
//STRIP001 		{
//STRIP001 			SwMultiTOXTabDialog* pDlg = (SwMultiTOXTabDialog*)GetTabDialog();
//STRIP001 			return *pDlg->GetForm(pDlg->GetCurrentTOXType());
//STRIP001 		}
//STRIP001 public:
//STRIP001 	SwTOXStylesTabPage(Window* pParent, const SfxItemSet& rAttrSet);
//STRIP001 	~SwTOXStylesTabPage();
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void		Reset( const SfxItemSet& );
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 };

} //namespace binfilter
#endif // _CNTTAB_HXX

