/*************************************************************************
 *
 *  $RCSfile: sw_linenum.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:56:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SFXVIEWFRM_HXX //autogen
//STRIP001 #include <bf_sfx2/viewfrm.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SFXSTYLE_HXX //autogen
//STRIP001 #include <svtools/style.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SV_MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SWVIEW_HXX //autogen
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _WRTSH_HXX //autogen
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SWDOCSH_HXX //autogen
//STRIP001 #include <docsh.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _CHARFMT_HXX //autogen
//STRIP001 #include <charfmt.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 //#ifndef _FLDMGR_HXX //autogen
//STRIP001 //#include <fldmgr.hxx>
//STRIP001 //#endif
//STRIP001 
//STRIP001 #ifndef _DOC_HXX //autogen
//STRIP001 #include <doc.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _DOCSTYLE_HXX //autogen
//STRIP001 #include <docstyle.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "fldbas.hxx"
//STRIP001 #include "lineinfo.hxx"
//STRIP001 #include "globals.hrc"
//STRIP001 #include "linenum.hrc"
//STRIP001 #include "linenum.hxx"
//STRIP001 #include "uitool.hxx"
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwLineNumberingDlg::SwLineNumberingDlg(SwView *pVw) :
//STRIP001 	SfxSingleTabDialog(&pVw->GetViewFrame()->GetWindow(), 0, 0),
//STRIP001 	pSh(pVw->GetWrtShellPtr())
//STRIP001 {
//STRIP001 	// TabPage erzeugen
//STRIP001 	SfxTabPage* pPage = SwLineNumberingPage::Create(this, *(SfxItemSet*)0);
//STRIP001 	SetTabPage(pPage);
//STRIP001 
//STRIP001 	GetOKButton()->SetClickHdl(LINK(this, SwLineNumberingDlg, OKHdl));
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 __EXPORT SwLineNumberingDlg::~SwLineNumberingDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	 Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwLineNumberingDlg, OKHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 	if (GetOKButton()->IsEnabled())
//STRIP001 	{
//STRIP001 		SfxTabPage*	pPage = GetTabPage();
//STRIP001 		if (pPage)
//STRIP001 			pPage->FillItemSet(*(SfxItemSet*)0);
//STRIP001 
//STRIP001 		EndDialog( RET_OK );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  -----------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwLineNumberingPage::SwLineNumberingPage( Window* pParent,
//STRIP001 													const SfxItemSet& rSet )
//STRIP001 	: SfxTabPage(pParent, SW_RES(TP_LINENUMBERING), rSet),
//STRIP001 	aNumberingOnCB		( this, SW_RES( CB_NUMBERING_ON )),
//STRIP001 	aCharStyleFT		( this, SW_RES( FT_CHAR_STYLE )),
//STRIP001 	aCharStyleLB		( this, SW_RES( LB_CHAR_STYLE )),
//STRIP001 	aFormatFT			( this, SW_RES( FT_FORMAT )),
//STRIP001 	aFormatLB			( this, SW_RES( LB_FORMAT ), INSERT_NUM_EXTENDED_TYPES),
//STRIP001 	aPosFT				( this, SW_RES( FT_POS )),
//STRIP001 	aPosLB				( this, SW_RES( LB_POS )),
//STRIP001 	aOffsetFT   		( this, SW_RES( FT_OFFSET )),
//STRIP001 	aOffsetMF   		( this, SW_RES( MF_OFFSET )),
//STRIP001 	aNumIntervalFT		( this, SW_RES( FT_NUM_INVERVAL )),
//STRIP001 	aNumIntervalNF		( this, SW_RES( NF_NUM_INVERVAL )),
//STRIP001 	aNumRowsFT			( this, SW_RES( FT_NUM_ROWS )),
//STRIP001     aDisplayFL          ( this, SW_RES( FL_DISPLAY )),
//STRIP001 	aDivisorFT			( this, SW_RES( FT_DIVISOR )),
//STRIP001 	aDivisorED			( this, SW_RES( ED_DIVISOR )),
//STRIP001 	aDivIntervalFT		( this, SW_RES( FT_DIV_INTERVAL )),
//STRIP001 	aDivIntervalNF		( this, SW_RES( NF_DIV_INTERVAL )),
//STRIP001 	aDivRowsFT			( this, SW_RES( FT_DIV_ROWS )),
//STRIP001     aDivisorFL          ( this, SW_RES( FL_DIVISOR )),
//STRIP001 	aCountEmptyLinesCB	( this, SW_RES( CB_COUNT_EMPTYLINES )),
//STRIP001 	aCountFrameLinesCB	( this, SW_RES( CB_COUNT_FRAMELINES )),
//STRIP001 	aRestartEachPageCB	( this, SW_RES( CB_RESTART_PAGE )),
//STRIP001     aCountFL            ( this, SW_RES( FL_COUNT ))
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	SwLineNumberingDlg *pDlg = (SwLineNumberingDlg *)GetParent();
//STRIP001 	pSh = pDlg->GetWrtShell();
//STRIP001 	// Zeichenvorlagen
//STRIP001 	::FillCharStyleListBox(aCharStyleLB, pSh->GetView().GetDocShell());
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  -----------------------------------------------------------------------*/
//STRIP001 
//STRIP001 __EXPORT SwLineNumberingPage::~SwLineNumberingPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  -----------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage*	__EXPORT SwLineNumberingPage::Create( Window* pParent, const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	return new SwLineNumberingPage( pParent, rSet );
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  -----------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void __EXPORT SwLineNumberingPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const SwLineNumberInfo &rInf = pSh->GetLineNumberInfo();
//STRIP001 
//STRIP001 	String sStyleName(rInf.GetCharFmt(*pSh->GetDoc())->GetName());
//STRIP001 	const USHORT nPos = aCharStyleLB.GetEntryPos(sStyleName);
//STRIP001 
//STRIP001 	if (nPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		aCharStyleLB.SelectEntryPos(nPos);
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if (sStyleName.Len())
//STRIP001 		{
//STRIP001 			aCharStyleLB.InsertEntry(sStyleName);
//STRIP001 			aCharStyleLB.SelectEntry(sStyleName);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Format
//STRIP001 //	SwFldMgr aMgr( pSh );
//STRIP001 	USHORT nSelFmt = rInf.GetNumType().GetNumberingType();
//STRIP001 //	USHORT nCnt = aMgr.GetFormatCount( TYP_SEQFLD, FALSE );
//STRIP001 
//STRIP001 //	for( USHORT i = 0; i < nCnt; i++)
//STRIP001 //	{
//STRIP001 //		aFormatLB.InsertEntry(aMgr.GetFormatStr( TYP_SEQFLD, i));
//STRIP001 //		USHORT nFmtId = aMgr.GetFormatId( TYP_SEQFLD, i );
//STRIP001 //		aFormatLB.SetEntryData( i, (void*)nFmtId );
//STRIP001 //		if( nFmtId == nSelFmt )
//STRIP001 //			aFormatLB.SelectEntryPos( i );
//STRIP001 //	}
//STRIP001 	aFormatLB.SelectNumberingType(nSelFmt);
//STRIP001 
//STRIP001 //	if ( !aFormatLB.GetSelectEntryCount() )
//STRIP001 //		aFormatLB.SelectEntryPos(aFormatLB.GetEntryCount() - 1);
//STRIP001 
//STRIP001 	// Position
//STRIP001 	aPosLB.SelectEntryPos((USHORT)rInf.GetPos());
//STRIP001 
//STRIP001 	// Offset
//STRIP001 	USHORT nOffset = rInf.GetPosFromLeft();
//STRIP001 	if (nOffset == USHRT_MAX)
//STRIP001 		nOffset = 0;
//STRIP001 
//STRIP001 	aOffsetMF.SetValue(aOffsetMF.Normalize(nOffset), FUNIT_TWIP);
//STRIP001 
//STRIP001 	// Numerierungsoffset
//STRIP001 	aNumIntervalNF.SetValue(rInf.GetCountBy());
//STRIP001 
//STRIP001 	// Teiler
//STRIP001 	aDivisorED.SetText(rInf.GetDivider());
//STRIP001 
//STRIP001 	// Teileroffset
//STRIP001 	aDivIntervalNF.SetValue(rInf.GetDividerCountBy());
//STRIP001 
//STRIP001 	// Zaehlen
//STRIP001 	aCountEmptyLinesCB.Check(rInf.IsCountBlankLines());
//STRIP001 	aCountFrameLinesCB.Check(rInf.IsCountInFlys());
//STRIP001 	aRestartEachPageCB.Check(rInf.IsRestartEachPage());
//STRIP001 
//STRIP001 	aNumberingOnCB.Check(rInf.IsPaintLineNumbers());
//STRIP001 
//STRIP001 	aNumberingOnCB.SetClickHdl(LINK(this, SwLineNumberingPage, LineOnOffHdl));
//STRIP001 	aDivisorED.SetModifyHdl(LINK(this, SwLineNumberingPage, ModifyHdl));
//STRIP001 	ModifyHdl();
//STRIP001 	LineOnOffHdl();
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Modify
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwLineNumberingPage, ModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	BOOL bHasValue = aDivisorED.GetText().Len() != 0;
//STRIP001 
//STRIP001 	aDivIntervalFT.Enable(bHasValue);
//STRIP001 	aDivIntervalNF.Enable(bHasValue);
//STRIP001 	aDivRowsFT.Enable(bHasValue);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: On/Off
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwLineNumberingPage, LineOnOffHdl, CheckBox *, EMPTYARG )
//STRIP001 {
//STRIP001 	BOOL bEnable = aNumberingOnCB.IsChecked();
//STRIP001 
//STRIP001 	aCharStyleFT.Enable(bEnable);
//STRIP001 	aCharStyleLB.Enable(bEnable);
//STRIP001 	aFormatFT.Enable(bEnable);
//STRIP001 	aFormatLB.Enable(bEnable);
//STRIP001 	aPosFT.Enable(bEnable);
//STRIP001 	aPosLB.Enable(bEnable);
//STRIP001 	aOffsetFT.Enable(bEnable);
//STRIP001 	aOffsetMF.Enable(bEnable);
//STRIP001 	aNumIntervalFT.Enable(bEnable);
//STRIP001 	aNumIntervalNF.Enable(bEnable);
//STRIP001 	aNumRowsFT.Enable(bEnable);
//STRIP001     aDisplayFL.Enable(bEnable);
//STRIP001 	aDivisorFT.Enable(bEnable);
//STRIP001 	aDivisorED.Enable(bEnable);
//STRIP001 	aDivIntervalFT.Enable(bEnable);
//STRIP001 	aDivIntervalNF.Enable(bEnable);
//STRIP001 	aDivRowsFT.Enable(bEnable);
//STRIP001     aDivisorFL.Enable(bEnable);
//STRIP001 	aCountEmptyLinesCB.Enable(bEnable);
//STRIP001 	aCountFrameLinesCB.Enable(bEnable);
//STRIP001 	aRestartEachPageCB.Enable(bEnable);
//STRIP001     aCountFL.Enable(bEnable);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  -----------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL __EXPORT SwLineNumberingPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	SwLineNumberInfo aInf(pSh->GetLineNumberInfo());
//STRIP001 
//STRIP001 	// Zeichenvorlagen
//STRIP001 	String sCharFmtName(aCharStyleLB.GetSelectEntry());
//STRIP001 	SwCharFmt *pCharFmt = pSh->FindCharFmtByName(sCharFmtName);
//STRIP001 
//STRIP001 	if (!pCharFmt)
//STRIP001 	{
//STRIP001 		SfxStyleSheetBasePool* pPool = pSh->GetView().GetDocShell()->GetStyleSheetPool();
//STRIP001 		SfxStyleSheetBase* pBase;
//STRIP001 		pBase = pPool->Find(sCharFmtName, SFX_STYLE_FAMILY_CHAR);
//STRIP001 		if(!pBase)
//STRIP001 			pBase = &pPool->Make(sCharFmtName, SFX_STYLE_FAMILY_CHAR);
//STRIP001 		pCharFmt = ((SwDocStyleSheet*)pBase)->GetCharFmt();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCharFmt)
//STRIP001 		aInf.SetCharFmt(pCharFmt);
//STRIP001 
//STRIP001 	// Format
//STRIP001 	SvxNumberType aType;
//STRIP001 	aType.SetNumberingType(aFormatLB.GetSelectedNumberingType());
//STRIP001 	aInf.SetNumType(aType);
//STRIP001 
//STRIP001 	// Position
//STRIP001 	aInf.SetPos((LineNumberPosition)aPosLB.GetSelectEntryPos());
//STRIP001 
//STRIP001 	// Offset
//STRIP001 	aInf.SetPosFromLeft((USHORT)aOffsetMF.Denormalize(aOffsetMF.GetValue(FUNIT_TWIP)));
//STRIP001 
//STRIP001 	// Numerierungsoffset
//STRIP001 	aInf.SetCountBy((USHORT)aNumIntervalNF.GetValue());
//STRIP001 
//STRIP001 	// Teiler
//STRIP001 	aInf.SetDivider(aDivisorED.GetText());
//STRIP001 
//STRIP001 	// Teileroffset
//STRIP001 	aInf.SetDividerCountBy((USHORT)aDivIntervalNF.GetValue());
//STRIP001 
//STRIP001 	// Zaehlen
//STRIP001 	aInf.SetCountBlankLines(aCountEmptyLinesCB.IsChecked());
//STRIP001 	aInf.SetCountInFlys(aCountFrameLinesCB.IsChecked());
//STRIP001 	aInf.SetRestartEachPage(aRestartEachPageCB.IsChecked());
//STRIP001 
//STRIP001 	aInf.SetPaintLineNumbers(aNumberingOnCB.IsChecked());
//STRIP001 
//STRIP001 	pSh->SetLineNumberInfo(aInf);
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }


}
