/*************************************************************************
 *
 *  $RCSfile: sw_wrtundo.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:42:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#define _SVSTDARR_STRINGSDTOR

// auto strip #ifndef _TOOLS_RESID_HXX
// auto strip #include <tools/resid.hxx>
// auto strip #endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
// auto strip #ifndef _SFXSLSTITM_HXX
// auto strip #include <svtools/slstitm.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _SWUNDO_HXX
#include <swundo.hxx>               	// fuer Undo-Ids
#endif
// auto strip #ifndef _SWDTFLVR_HXX
// auto strip #include <swdtflvr.hxx>
// auto strip #endif

#ifndef _WRTSH_HRC
#include <wrtsh.hrc>
#endif
#include <bf_sfx2/sfx.hrc>
namespace binfilter {


// Undo beendet alle Modi. Falls eine Selektion durch das Undo entstanden
// ist, muss die fuer die weiteren Aktionen beruecksichtigt werden.


//STRIP001 void SwWrtShell::Do( DoType eDoType, USHORT nCnt )
//STRIP001 {
//STRIP001     // #105332# save current state of DoesUndo() and disable undo.
//STRIP001     sal_Bool bSaveDoesUndo = DoesUndo();
//STRIP001 
//STRIP001     DoUndo(sal_False);
//STRIP001 	StartAllAction();
//STRIP001 	switch( eDoType )
//STRIP001 	{
//STRIP001 		case UNDO:
//STRIP001 			// Modi zuruecksetzen
//STRIP001 			EnterStdMode();
//STRIP001 			SwEditShell::Undo(0, nCnt );
//STRIP001 			break;
//STRIP001 		case REDO:
//STRIP001 			// Modi zuruecksetzen
//STRIP001 			EnterStdMode();
//STRIP001 			SwEditShell::Redo( nCnt );
//STRIP001 			break;
//STRIP001 		case REPEAT:
//STRIP001 			SwEditShell::Repeat( nCnt );
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	EndAllAction();
//STRIP001     // #105332# restore undo state
//STRIP001     DoUndo(bSaveDoesUndo);
//STRIP001 
//STRIP001 	BOOL bCreateXSelection = FALSE;
//STRIP001 	const FASTBOOL bFrmSelected = IsFrmSelected() || IsObjSelected();
//STRIP001 	if ( IsSelection() )
//STRIP001 	{
//STRIP001 		if ( bFrmSelected )
//STRIP001 			UnSelectFrm();
//STRIP001 
//STRIP001 		// Funktionspointer fuer das Aufheben der Selektion setzen
//STRIP001 		// bei Cursor setzen
//STRIP001 		fnKillSel = &SwWrtShell::ResetSelect;
//STRIP001 		fnSetCrsr = &SwWrtShell::SetCrsrKillSel;
//STRIP001 		bCreateXSelection = TRUE;
//STRIP001 	}
//STRIP001 	else if ( bFrmSelected )
//STRIP001 	{
//STRIP001 		EnterSelFrmMode();
//STRIP001 		bCreateXSelection = TRUE;
//STRIP001 	}
//STRIP001 	else if( (CNT_GRF | CNT_OLE ) & GetCntType() )
//STRIP001 	{
//STRIP001 		SelectObj( GetCharRect().Pos() );
//STRIP001 		EnterSelFrmMode();
//STRIP001 		bCreateXSelection = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bCreateXSelection )
//STRIP001 		SwTransferable::CreateSelection( *this );
//STRIP001 
//STRIP001 	// Bug 32918: nach loeschen der Numerierung bleibt die Obj. Leiste stehen
//STRIP001 	//			Warum wird hier nicht immer ein CallChgLink gerufen?
//STRIP001 	CallChgLnk();
//STRIP001 }


/*N*/ String SwWrtShell::GetDoString( DoType eDoType ) const
/*N*/ {
/*N*/ 	String aStr;
/*N*/ 	USHORT nId = 0, nResStr;
/*N*/ 	switch( eDoType )
/*N*/ 	{
/*N*/ 	case UNDO:
/*N*/ 		nResStr = STR_UNDO;
/*N*/ 		nId = GetUndoIds( &aStr );
/*N*/ 		break;
/*N*/ 	case REDO:
/*N*/ 		nResStr = STR_REDO;
/*N*/ 		nId = GetRedoIds( &aStr );
/*N*/ 		break;
/*N*/ 	}
/*N*/ 
/*N*/ 	if( UNDO_END < nId )
/*N*/ 	{
/*N*/ 		aStr.Insert( String(ResId( nResStr, SFX_APP()->GetSfxResManager() )), 0 );
/*N*/ 		if( UNDO_DRAWUNDO != nId )
/*N*/ 			aStr += SW_RESSTR( UNDO_BASE + nId );
/*N*/ 	}
/*N*/ 	return aStr;
/*N*/ }

//STRIP001 USHORT SwWrtShell::GetDoStrings( DoType eDoType, SfxStringListItem& rStrs ) const
//STRIP001 {
//STRIP001 	SwUndoIds aIds;
//STRIP001 	switch( eDoType )
//STRIP001 	{
//STRIP001 	case UNDO:
//STRIP001 		GetUndoIds( 0, &aIds );
//STRIP001 		break;
//STRIP001 	case REDO:
//STRIP001 		GetRedoIds( 0, &aIds );
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	String sList;
//STRIP001 	for( USHORT n = 0, nEnd = aIds.Count(); n < nEnd; ++n )
//STRIP001 	{
//STRIP001 		const SwUndoIdAndName& rIdNm = *aIds[ n ];
//STRIP001 		if( UNDO_DRAWUNDO != rIdNm.GetUndoId() )
//STRIP001 			sList += String( ResId( UNDO_BASE + rIdNm.GetUndoId(), pSwResMgr ));
//STRIP001 		else if( rIdNm.GetUndoStr() )
//STRIP001 			sList += *rIdNm.GetUndoStr();
//STRIP001 		else
//STRIP001 		{
//STRIP001 			ASSERT( !this, "no Undo/Redo Test set" );
//STRIP001 		}
//STRIP001 		sList += '\n';
//STRIP001 	}
//STRIP001 	rStrs.SetString( sList );
//STRIP001 	return aIds.Count();
//STRIP001 }


//STRIP001 String SwWrtShell::GetRepeatString() const
//STRIP001 {
//STRIP001 	String aStr;
//STRIP001 	USHORT nId = GetRepeatIds( &aStr );
//STRIP001 	if( UNDO_END < nId )
//STRIP001 	{
//STRIP001 		aStr.Insert( ResId( STR_REPEAT, SFX_APP()->GetSfxResManager()), 0 );
//STRIP001 		if( UNDO_DRAWUNDO != nId )
//STRIP001 			aStr += SW_RESSTR( UNDO_BASE + nId );
//STRIP001 	}
//STRIP001 	return aStr;
//STRIP001 }


}
