/*************************************************************************
 *
 *  $RCSfile: prnmon.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:26:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_PRNMON_HXX
#define _SFX_PRNMON_HXX

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#include <bf_sfx2/printer.hxx>
#include <bf_sfx2/progress.hxx>
namespace binfilter {

//STRIP001 class SfxViewShell;
//STRIP001 class SfxProgress;
//STRIP001 struct SfxPrintProgress_Impl;

// ------------------------------------------------------------------------

#define PAGE_MAX    9999        //max. Anzahl der Seiten die gedruckt werden

//--------------------------------------------------------------------

//STRIP001 class SfxPrintProgress: public SfxProgress
//STRIP001 {
//STRIP001 	SfxPrintProgress_Impl*  pImp;
//STRIP001 
//STRIP001 private:
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( PrintErrorNotify, void * );
//STRIP001 	DECL_LINK( EndPrintNotify, void * );
//STRIP001 #endif
//STRIP001 public:
//STRIP001 							SfxPrintProgress( SfxViewShell* pViewSh,
//STRIP001 											  FASTBOOL bShow = TRUE );
//STRIP001 	virtual                 ~SfxPrintProgress();
//STRIP001 
//STRIP001 	virtual void            SetText( const String &rText );
//STRIP001 			BOOL            SetStateText( ULONG nVal, const String &rVal, ULONG nNewRange = 0 );
//STRIP001 	virtual BOOL            SetState( ULONG nVal, ULONG nNewRange = 0 );
//STRIP001 
//STRIP001 	void                    RestoreOnEndPrint( SfxPrinter *pOldPrinter );
//STRIP001 	void                    RestoreOnEndPrint( SfxPrinter *pOldPrinter,
//STRIP001 											   BOOL bOldEnablePrintFile );
//STRIP001 	void                    DeleteOnEndPrint();
//STRIP001 	void					SetCancelHdl( const Link& aCancelHdl );
//STRIP001 	BOOL					IsAborted() const;
//STRIP001 };

// ------------------------------------------------------------------------

//STRIP001 struct SfxPrintOptDlg_Impl;
//STRIP001 class SfxPrintOptionsDialog : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	OKButton                aOkBtn;
//STRIP001 	CancelButton            aCancelBtn;
//STRIP001 #if SUPD > 640
//STRIP001 	HelpButton				aHelpBtn;
//STRIP001 #endif
//STRIP001 	SfxPrintOptDlg_Impl*	pDlgImpl;
//STRIP001 	SfxViewShell*           pViewSh;
//STRIP001 	SfxItemSet*             pOptions;
//STRIP001 	SfxTabPage*             pPage;
//STRIP001 
//STRIP001 public:
//STRIP001 							SfxPrintOptionsDialog( Window *pParent,
//STRIP001 												   SfxViewShell *pViewShell,
//STRIP001 												   const SfxItemSet *rOptions );
//STRIP001 	virtual                 ~SfxPrintOptionsDialog();
//STRIP001 
//STRIP001 	BOOL                    Construct();
//STRIP001 	virtual short           Execute();
//STRIP001 	virtual long			Notify( NotifyEvent& rNEvt );
//STRIP001 
//STRIP001 	SfxTabPage*             GetTabPage() const { return pPage; }
//STRIP001 	const SfxItemSet&       GetOptions() const { return *pOptions; }
//STRIP001 	void					DisableHelp();
//STRIP001 };

}//end of namespace binfilter
#endif
