/*************************************************************************
 *
 *  $RCSfile: connect.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_CONNECT_HXX
#define _SVX_CONNECT_HXX

// include ---------------------------------------------------------------

#ifndef _SVX_CONNCTRL_HXX
#include <bf_svx/connctrl.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
namespace binfilter {

//STRIP001 class SdrView;

/*************************************************************************
|*
|* Dialog zum Aendern von Konnektoren (Connectors)
|*
\************************************************************************/

//STRIP001 class SvxConnectionPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText   		aFtType;
//STRIP001 	ListBox 			aLbType;
//STRIP001 
//STRIP001 	FixedLine			aFlDelta;
//STRIP001 	FixedText			aFtLine1;
//STRIP001 	MetricField			aMtrFldLine1;
//STRIP001 	FixedText			aFtLine2;
//STRIP001 	MetricField			aMtrFldLine2;
//STRIP001 	FixedText			aFtLine3;
//STRIP001 	MetricField			aMtrFldLine3;
//STRIP001 
//STRIP001 	FixedLine			aFlDistance;
//STRIP001 	FixedText			aFtHorz1;
//STRIP001 	MetricField			aMtrFldHorz1;
//STRIP001 	FixedText			aFtVert1;
//STRIP001 	MetricField			aMtrFldVert1;
//STRIP001 	FixedText			aFtHorz2;
//STRIP001 	MetricField			aMtrFldHorz2;
//STRIP001 	FixedText			aFtVert2;
//STRIP001 	MetricField			aMtrFldVert2;
//STRIP001 
//STRIP001 	SvxXConnectionPreview	aCtlPreview;
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	SfxItemSet			aAttrSet;
//STRIP001 	const SdrView*		pView;
//STRIP001 	SfxMapUnit			eUnit;
//STRIP001 
//STRIP001 #ifdef _SVX_CONNECT_CXX
//STRIP001 	void 				FillTypeLB();
//STRIP001 
//STRIP001 						DECL_LINK( ChangeAttrHdl_Impl, void * );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SvxConnectionPage( Window* pWindow, const SfxItemSet& rInAttrs );
//STRIP001 	~SvxConnectionPage();
//STRIP001 
//STRIP001 	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
//STRIP001 	static  USHORT*	    GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL 		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void 		Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
//STRIP001 };

/*************************************************************************
|*
|* Von SfxSingleTabDialog abgeleitet, um vom Control "uber virtuelle Methode
|* benachrichtigt werden zu k"onnen.
|*
\************************************************************************/

//STRIP001 class SvxConnectionDialog : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxConnectionDialog( Window* pParent, const SfxItemSet& rAttr,
//STRIP001 					   const SdrView* pView );
//STRIP001 	~SvxConnectionDialog();
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_CONNECT_HXX

