/*************************************************************************
 *
 *  $RCSfile: edtspell.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:29:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EDTSPELL_HXX
#define _EDTSPELL_HXX

#include <bf_svx/svxbox.hxx>
#include <bf_svx/svxenum.hxx>
#include <splwrap.hxx>
#include <bf_svx/svxacorr.hxx>

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
namespace binfilter {
//STRIP008 namespace com { namespace sun { namespace star { namespace linguistic2 {
//STRIP001 	class XSpellChecker1;
//STRIP008 }}}}


//STRIP001 class EditView;
//STRIP001 class ImpEditEngine;
//STRIP001 class ContentNode;

//STRIP001 class EditSpellWrapper : public SvxSpellWrapper
//STRIP001 {
//STRIP001 private:
//STRIP001 	EditView*				pEditView;
//STRIP001 	void					CheckSpellTo();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual	void			SpellStart( SvxSpellArea eArea );
//STRIP001 	virtual	BOOL 			SpellContinue();	// Bereich pruefen
//STRIP001 	virtual void 			ReplaceAll( const String &rNewText, INT16 nLanguage );
//STRIP001 	virtual void			SpellEnd();
//STRIP001 //  virtual BOOL            ();
//STRIP001 	virtual BOOL			SpellMore();
//STRIP001 	virtual	BOOL			HasOtherCnt();
//STRIP001 	virtual void			ScrollArea();
//STRIP001     virtual void            ChangeWord( const String& rNewWord, const USHORT nLang );
//STRIP001     virtual void            ChangeThesWord( const String& rNewWord );
//STRIP001 //  virtual void            ChangeAll( const String& rNewWord );
//STRIP001     virtual void            AutoCorrect( const String& rOldWord, const String& rNewWord );
//STRIP001 
//STRIP001 //  virtual String          GetCurrentWord() const;
//STRIP001 
//STRIP001 public:
//STRIP001 	EditSpellWrapper( Window* pWin,
//STRIP001 			::com::sun::star::uno::Reference<
//STRIP001 				::com::sun::star::linguistic2::XSpellChecker1 > &xChecker,
//STRIP001 			BOOL bIsStart,
//STRIP001 			BOOL bIsAllRight, EditView* pView );
//STRIP001 
//STRIP001 	static BOOL 			IsSpellReverse();
//STRIP001 };


struct WrongRange
{
	USHORT nStart;
	USHORT nEnd;

	WrongRange( USHORT nS, USHORT nE ) { nStart = nS; nEnd = nE; }
};

SV_DECL_VARARR( WrongRanges, WrongRange, 4, 4 )//STRIP008 ;
#define NOT_INVALID	0xFFFF

class WrongList : private WrongRanges
{
private:
//STRIP001 	USHORT 	nInvalidStart;
//STRIP001 	USHORT 	nInvalidEnd;

//STRIP001 	BOOL	DbgIsBuggy() const;

public:
			WrongList();
			~WrongList();

//STRIP001 	BOOL	IsInvalid() const 		{ return nInvalidStart != NOT_INVALID; }
//STRIP001 	void 	SetValid() 				{ nInvalidStart = NOT_INVALID; nInvalidEnd = 0; }
//STRIP001 	void	MarkInvalid( USHORT nS, USHORT nE )
//STRIP001 			{
//STRIP001 				if ( ( nInvalidStart == NOT_INVALID ) || ( nInvalidStart > nS ) )
//STRIP001 					nInvalidStart = nS;
//STRIP001 				if ( nInvalidEnd < nE )
//STRIP001 					nInvalidEnd = nE;
//STRIP001 			}
//STRIP001 
			USHORT			Count() const 				{ DBG_BF_ASSERT(0, "STRIP"); return 0; } //STRIP001 return WrongRanges::Count(); }
//STRIP001 
//STRIP001 	// Wenn man weiss was man tut:
//STRIP001 	WrongRange&		GetObject( USHORT n ) const	{ return WrongRanges::GetObject( n ); }
//STRIP001 	void			InsertWrong( const WrongRange& rWrong, USHORT nPos );
//STRIP001 
//STRIP001 	USHORT	GetInvalidStart() const	{ return nInvalidStart; }
//STRIP001 	USHORT&	GetInvalidStart() 		{ return nInvalidStart; }
//STRIP001 
//STRIP001 	USHORT	GetInvalidEnd() const 	{ return nInvalidEnd; }
//STRIP001 	USHORT&	GetInvalidEnd() 		{ return nInvalidEnd; }
//STRIP001 
//STRIP001 	void	TextInserted( USHORT nPos, USHORT nChars, BOOL bPosIsSep );
//STRIP001 	void	TextDeleted( USHORT nPos, USHORT nChars );
//STRIP001 
//STRIP001 	void	ResetRanges() 			{ Remove( 0, Count() ); }
			BOOL	HasWrongs() const 		{ DBG_BF_ASSERT(0, "STRIP"); return FALSE; }//STRIP001 return Count() != 0; }
//STRIP001 	void	InsertWrong( USHORT nStart, USHORT nEnd, BOOL bClearRange );
//STRIP001 	BOOL	NextWrong( USHORT& rnStart, USHORT& rnEnd ) const;
//STRIP001 	BOOL	HasWrong( USHORT nStart, USHORT nEnd ) const;
//STRIP001 	BOOL	HasAnyWrong( USHORT nStart, USHORT nEnd ) const;
//STRIP001 	void	ClearWrongs( USHORT nStart, USHORT nEnd, const ContentNode* pNode );
//STRIP001 	void	MarkWrongsInvalid();
//STRIP001 
//STRIP001 	WrongList*	Clone() const;
};

//STRIP001 inline void WrongList::InsertWrong( const WrongRange& rWrong, USHORT nPos )
//STRIP001 {
//STRIP001 	WrongRanges::Insert( rWrong, nPos );
//STRIP001 #ifdef DBG_UTIL
//STRIP001 	DBG_ASSERT( !DbgIsBuggy(), "Insert: WrongList kaputt!" );
//STRIP001 #endif
//STRIP001 }



//STRIP001 class EdtAutoCorrDoc : public SvxAutoCorrDoc
//STRIP001 {
//STRIP001 	ImpEditEngine* 	pImpEE;
//STRIP001 	ContentNode*	pCurNode;
//STRIP001 	USHORT			nCursor;
//STRIP001 
//STRIP001 	BOOL			bAllowUndoAction;
//STRIP001 	BOOL			bUndoAction;
//STRIP001 
//STRIP001 protected:
//STRIP001 	void			ImplStartUndoAction();
//STRIP001 
//STRIP001 public:
//STRIP001 					EdtAutoCorrDoc( ImpEditEngine* pImpEE, ContentNode* pCurNode, USHORT nCrsr, xub_Unicode cIns );
//STRIP001 					~EdtAutoCorrDoc();
//STRIP001 
//STRIP001 	virtual BOOL 	Delete( USHORT nStt, USHORT nEnd );
//STRIP001 	virtual BOOL 	Insert( USHORT nPos, const String& rTxt );
//STRIP001 	virtual BOOL 	Replace( USHORT nPos, const String& rTxt );
//STRIP001 
//STRIP001 	virtual BOOL 	SetAttr( USHORT nStt, USHORT nEnd, USHORT nSlotId, SfxPoolItem& );
//STRIP001 	virtual BOOL 	SetINetAttr( USHORT nStt, USHORT nEnd, const String& rURL );
//STRIP001 
//STRIP001 	virtual BOOL 	HasSymbolChars( USHORT nStt, USHORT nEnd );
//STRIP001 
//STRIP001 	virtual const String* GetPrevPara( BOOL bAtNormalPos );
//STRIP001 
//STRIP001 	virtual BOOL 	ChgAutoCorrWord( USHORT& rSttPos, USHORT nEndPos,
//STRIP001 								  SvxAutoCorrect& rACorrect, const String** ppPara );
//STRIP001 
//STRIP001 	virtual LanguageType GetLanguage( USHORT nPos, BOOL bPrevPara = FALSE ) const;
//STRIP001 
//STRIP001 	USHORT			GetCursor() const { return nCursor; }
//STRIP001 
//STRIP001 };

}//end of namespace binfilter
#endif	// EDTSPELL

