/*************************************************************************
 *
 *  $RCSfile: pagectrl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:24:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_PAGECTRL_HXX
#define _SVX_PAGECTRL_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _WINDOW_HXX //autogen
// auto strip #include <vcl/window.hxx>
// auto strip #endif
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP001 class SvxBoxItem;
//STRIP001 struct PageWindow_Impl;

// class SvxPageWindow ---------------------------------------------------

//STRIP001 class SvxPageWindow : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 	Size		aWinSize;
//STRIP001 	Size 		aSize;
//STRIP001 
//STRIP001 	long		nTop;
//STRIP001 	long		nBottom;
//STRIP001 	long 		nLeft;
//STRIP001 	long		nRight;
//STRIP001 	Color		aColor;
//STRIP001 
//STRIP001 	PageWindow_Impl* pImpl;
//STRIP001 
//STRIP001 	long 		nHdLeft;
//STRIP001 	long		nHdRight;
//STRIP001 	long		nHdDist;
//STRIP001 	long		nHdHeight;
//STRIP001 	Color		aHdColor;
//STRIP001 	SvxBoxItem*	pHdBorder;
//STRIP001 
//STRIP001 	long		nFtLeft;
//STRIP001 	long		nFtRight;
//STRIP001 	long		nFtDist;
//STRIP001 	long		nFtHeight;
//STRIP001 	Color		aFtColor;
//STRIP001 	SvxBoxItem*	pFtBorder;
//STRIP001 
//STRIP001 	BOOL		bFooter	:1;
//STRIP001 	BOOL		bHeader	:1;
//STRIP001 	BOOL		bTable	:1;
//STRIP001 	BOOL		bHorz	:1;
//STRIP001 	BOOL		bVert	:1;
//STRIP001 
//STRIP001 	USHORT		eUsage;
//STRIP001 
//STRIP001 	String		aLeftText;
//STRIP001 	String		aRightText;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 	virtual void DrawPage( const Point& rPoint,
//STRIP001 						   const BOOL bSecond,
//STRIP001 						   const BOOL bEnabled );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPageWindow( Window* pParent, const ResId& rId );
//STRIP001 	~SvxPageWindow();
//STRIP001 
//STRIP001 	void 		SetWidth( long nW )						{ aSize.Width()  = nW; }
//STRIP001 	void    	SetHeight( long nH )					{ aSize.Height() = nH; }
//STRIP001 
//STRIP001 	void		SetSize( const Size& rSz )				{ aSize = rSz; }
//STRIP001 	const Size&	GetSize() const 						{ return aSize; }
//STRIP001 
//STRIP001 	void		SetTop( long nNew )						{ nTop = nNew; }
//STRIP001 	void		SetBottom( long nNew ) 					{ nBottom = nNew; }
//STRIP001 	void		SetLeft( long nNew )					{ nLeft = nNew; }
//STRIP001 	void   		SetRight( long nNew )					{ nRight = nNew; }
//STRIP001 	void		SetColor( const Color& rNew )			{ aColor = rNew; }
//STRIP001 	void		SetBorder( const SvxBoxItem& rNew );
//STRIP001 	void		SetBitmap( Bitmap* pBmp );
//STRIP001 
//STRIP001 	long		GetTop() const							{ return nTop;   }
//STRIP001 	long		GetBottom() const						{ return nBottom;}
//STRIP001 	long		GetLeft() const							{ return nLeft;  }
//STRIP001 	long		GetRight() const						{ return nRight; }
//STRIP001 
//STRIP001 	const Color&		GetColor() const				{ return aColor; }
//STRIP001 	const SvxBoxItem& 	GetBorder() const;
//STRIP001 
//STRIP001 	void    	SetHdLeft( long nNew )					{ nHdLeft = nNew; }
//STRIP001 	void    	SetHdRight( long nNew )					{ nHdRight = nNew; }
//STRIP001 	void    	SetHdDist( long nNew )					{ nHdDist = nNew; }
//STRIP001 	void    	SetHdHeight( long nNew )				{ nHdHeight = nNew; }
//STRIP001 	void		SetHdColor( const Color& aNew )			{ aHdColor = aNew; }
//STRIP001 	void		SetHdBorder( const SvxBoxItem& rNew );
//STRIP001 
//STRIP001 	long		GetHdLeft() const 						{ return nHdLeft;  }
//STRIP001 	long		GetHdRight() const 						{ return nHdRight; }
//STRIP001 	long		GetHdDist()	const 						{ return nHdDist;  }
//STRIP001 	long		GetHdHeight() const 					{ return nHdHeight;}
//STRIP001 
//STRIP001 	const Color&		GetHdColor() const				{ return aHdColor; }
//STRIP001 	const SvxBoxItem& 	GetHdBorder() const				{ return *pHdBorder; }
//STRIP001 
//STRIP001 	void		SetFtLeft( long nNew )					{ nFtLeft = nNew; }
//STRIP001 	void		SetFtRight( long nNew )					{ nFtRight = nNew; }
//STRIP001 	void		SetFtDist( long nNew )					{ nFtDist = nNew; }
//STRIP001 	void		SetFtHeight( long nNew )				{ nFtHeight = nNew; }
//STRIP001 	void		SetFtColor( const Color& aNew )			{ aFtColor = aNew; }
//STRIP001 	void		SetFtBorder( const SvxBoxItem& rNew );
//STRIP001 
//STRIP001 	long		GetFtLeft() const 						{ return nFtLeft;  }
//STRIP001 	long		GetFtRight() const 						{ return nFtRight; }
//STRIP001 	long		GetFtDist()	const 						{ return nFtDist;  }
//STRIP001 	long		GetFtHeight() const 					{ return nFtHeight;}
//STRIP001 
//STRIP001 	const Color& 		GetFtColor() const				{ return aFtColor; }
//STRIP001 	const SvxBoxItem& 	GetFtBorder() const				{ return *pFtBorder; }
//STRIP001 
//STRIP001 	void		SetUsage( USHORT eU )					{ eUsage = eU;  }
//STRIP001 	USHORT		GetUsage() const						{ return eUsage;}
//STRIP001 
//STRIP001 	void 		SetHeader( BOOL bNew )  				{ bHeader = bNew; }
//STRIP001 	BOOL		GetHeader() const						{ return bHeader;}
//STRIP001 	void		SetFooter( BOOL bNew )					{ bFooter = bNew; }
//STRIP001 	BOOL		GetFooter() const						{ return bFooter;}
//STRIP001 
//STRIP001 	void 		SetTable( BOOL bNew )					{ bTable = bNew; }
//STRIP001 	BOOL		GetTable() const						{ return bTable;}
//STRIP001 	void		SetHorz( BOOL bNew )					{ bHorz = bNew; }
//STRIP001 	BOOL		GetHorz() const							{ return bHorz;}
//STRIP001 	void 		SetVert( BOOL bNew )		   			{ bVert = bNew; }
//STRIP001 	BOOL		GetVert() const				   			{ return bVert;}
//STRIP001 
//STRIP001     void        EnableFrameDirection(sal_Bool bEnable);
//STRIP001     //uses enum SvxFrameDirection
//STRIP001     void        SetFrameDirection(sal_Int32 nFrameDirection);
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_PAGECTRL_HXX

