/*************************************************************************
 *
 *  $RCSfile: textattr.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:29:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_TEXTATTR_HXX
#define _SVX_TEXTATTR_HXX

// include ---------------------------------------------------------------

#ifndef _SVX_DLG_CTRL_HXX
#include <bf_svx/dlgctrl.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
namespace binfilter {

//STRIP001 class SdrView;

/*************************************************************************
|*
|* Dialog zum "Andern von TextAttributen
|*
\************************************************************************/

//STRIP001 class SvxTextAttrPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine			aFlText;
//STRIP001 	TriStateBox         aTsbAutoGrowWidth;
//STRIP001 	TriStateBox         aTsbAutoGrowHeight;
//STRIP001 	TriStateBox			aTsbFitToSize;
//STRIP001 	TriStateBox			aTsbContour;
//STRIP001 
//STRIP001 	FixedLine			aFlDistance;
//STRIP001 	FixedText			aFtLeft;
//STRIP001 	MetricField			aMtrFldLeft;
//STRIP001 	FixedText			aFtRight;
//STRIP001 	MetricField			aMtrFldRight;
//STRIP001 	FixedText			aFtTop;
//STRIP001 	MetricField			aMtrFldTop;
//STRIP001 	FixedText			aFtBottom;
//STRIP001 	MetricField			aMtrFldBottom;
//STRIP001 
//STRIP001 	FixedLine			aFlSeparator;
//STRIP001 
//STRIP001 	FixedLine			aFlPosition;
//STRIP001 	SvxRectCtl			aCtlPosition;
//STRIP001 	TriStateBox			aTsbFullWidth;
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	const SdrView*		pView;
//STRIP001 
//STRIP001 	BOOL				bAutoGrowSizeEnabled;
//STRIP001 	BOOL				bContourEnabled;
//STRIP001 
//STRIP001 #ifdef _SVX_TEXTATTR_CXX
//STRIP001 	DECL_LINK( ClickFullWidthHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickHdl_Impl, void * );
//STRIP001 #endif
//STRIP001 
//STRIP001     /** Return whether the text direction is from left to right (</TRUE>) or
//STRIP001         top to bottom (</FALSE>).
//STRIP001     */
//STRIP001     bool IsTextDirectionLeftToRight (void) const;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SvxTextAttrPage( Window* pWindow, const SfxItemSet& rInAttrs );
//STRIP001 	~SvxTextAttrPage();
//STRIP001 
//STRIP001 	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
//STRIP001 	static  USHORT*	    GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL 		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void 		Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void 		PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
//STRIP001 };

/*************************************************************************
|*
|* Von SfxSingleTabDialog abgeleitet, um vom Control "uber virtuelle Methode
|* benachrichtigt werden zu k"onnen.
|*
\************************************************************************/

//STRIP001 class SvxTextAttrDialog : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxTextAttrDialog( Window* pParent, const SfxItemSet& rAttr,
//STRIP001 					   const SdrView* pView );
//STRIP001 	~SvxTextAttrDialog();
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_TEXTATTR_HXX

